/* party-g.c - Party group */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/* 
 * $Header$
 *
 *
 * $Log$
 */

/*
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <stdio.h>
#include "mib.h"
#include "party.h"

/*  */

extern	int	tooBig;

/*  */

struct snmp_party *get_party_entry ();


static int  o_party (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register unsigned int *ip,
			  *jp;
    register struct snmp_party *party;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    static int	lastq = -1;
    static long now;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((party = get_party_entry (oid -> oid_elements
				              + ot -> ot_name -> oid_nelem,
					  oid -> oid_nelem
				              - ot -> ot_name -> oid_nelem,
					  0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem < ot -> ot_name -> oid_nelem)
		return NOTOK;
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((party = partyHead) == NULLPARTY)
		    return NOTOK;

		jp = party -> party_Identity -> oid_elements;
		i = party -> party_Identity -> oid_nelem;

		if ((new = oid_extend (oid, i)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - i;
		for (; i > 0; i--)
		    *ip++ = *jp++;
		
		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;

#ifdef	MAGIC
		oid = new;
#endif
	    }
	    else {
		int	j;

		if ((party = get_party_entry (oid -> oid_elements
					          + ot -> ot_name -> oid_nelem,
					      j = oid -> oid_nelem
					          - ot -> ot_name -> oid_nelem,
					      1)) == NULL)
		    return NOTOK;
		i = party -> party_Identity -> oid_nelem;

		if ((i = j - i) < 0) {
		    OID	    new;

		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		jp = party -> party_Identity -> oid_elements;
		i = party -> party_Identity -> oid_nelem;
		for (; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case partyIndex:
	    return o_integer (oi, v, party -> party_index);

	case partyTDomain:
	    return o_specific (oi, v, (caddr_t) party -> party_TDomain);

	case partyTAddress:
	    return o_string (oi, v, (char *) party -> party_TAddress,
			     party -> party_TAddress_len);
	  
	case partyMaxMessageSize:
	    return o_integer (oi, v, party -> party_MaxMessageSize);

	case partyLocal:
	    return o_integer (oi, v, party -> party_location);

	case partyAuthProtocol:
	    return o_specific (oi, v, (caddr_t) party -> party_AuthProtocol);
	    
	case partyAuthClock:
	    if (party -> party_authProt != MD5AUTHPROT)
		return o_integer (oi, v, 0);
	    if (quantum != lastq) {
		lastq = quantum;

		now = party_time_now ();
	    }
	    return o_integer (oi, v, now - party -> party_AuthStart);
	    
	case partyAuthPublic:
	    return o_string (oi, v, (char *) party -> party_AuthPublic,
			     party -> party_AuthPublic_len);

	case partyAuthLifetime:
	    return o_integer (oi, v, party -> party_AuthLifetime);

	case partyPrivProtocol:
	    return o_specific (oi, v, (caddr_t) party -> party_PrivProtocol);

	case partyPrivPublic:
	    return o_string (oi, v, (char *) party -> party_PrivPublic,
			     party -> party_PrivPublic_len);

	case partyAuthPrivate:
	case partyPrivPrivate:
	    return o_string (oi, v, "", 0);

	case partyCloneFrom:
	    return o_specific (oi, v, (caddr_t) nullSpecific);
	    
	case partyStorageType:
	    return o_integer (oi, v, party -> party_storage);

	case partyStatus:
	    return o_integer (oi, v, party -> party_status);

	case snmpTrapNumbers:
	    return o_integer (oi, v, party -> party_traps);

#ifdef	MAGIC
	case partyTestMode:
	    return o_integer (oi, v, party -> party_testmode);
#endif

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static int  c_clone (ck)
register struct checklist *ck;
{
    register struct snmp_party *party = (struct snmp_party *) ck -> ck_info;
    register struct snmp_party *q;
    OID	    new;

    if (!(q = party -> party_template))
	return OK;
    party -> party_template = NULL;

    if (!(party -> party_clone & PARTY_AUTHPROT)) {
	if ((new = oid_cpy (q -> party_AuthProtocol)) == NULL) {
losing_big: ;
	    advise (LLOG_EXCEPTIONS, NULLCP, "out of memory");
	    return int_SNMP_error__status_genErr;
	}
	oid_free (party -> party_AuthProtocol);
	party -> party_authProt = q -> party_authProt;
	party -> party_AuthProtocol = new;
    }
    if (party -> party_authProt == NOAUTH)
	goto no_auth;

    if (!(party -> party_clone & PARTY_AUTHPUB)) {
	if (party -> party_AuthPublic)
	    free ((char *) party -> party_AuthPublic);
	if (q -> party_AuthPublic) {
	    if ((party -> party_AuthPublic = (unsigned char *)
			    malloc ((unsigned int) q -> party_AuthPublic_len))
		    == NULL)
		goto losing_big;
	    bcopy ((char *) q -> party_AuthPublic,
		   (char *) party -> party_AuthPublic,
		   party -> party_AuthPublic_len = q -> party_AuthPublic_len);
	}
	else
	    party -> party_AuthPublic = NULL;
    }

    if (!(party -> party_clone & PARTY_AUTHLIFE))
	party -> party_AuthLifetime = q -> party_AuthLifetime;
no_auth: ;

    if (!(party -> party_clone & PARTY_PRIVPROT)) {
	if ((new = oid_cpy (q -> party_PrivProtocol)) == NULL)
	    goto losing_big;
	oid_free (party -> party_PrivProtocol);
	party -> party_privProt = q -> party_privProt;
	party -> party_PrivProtocol = new;
    }
    if (party -> party_privProt == NOPRIV)
	goto no_priv;

    if (!(party -> party_clone & PARTY_PRIVPUB)) {
	if (party -> party_PrivPublic)
	    free ((char *) party -> party_PrivPublic);
	if (q -> party_PrivPublic) {
	    if ((party -> party_PrivPublic = (unsigned char *)
			    malloc ((unsigned int) q -> party_PrivPublic_len))
		    == NULL)
		goto losing_big;
	    bcopy ((char *) q -> party_PrivPublic,
		   (char *) party -> party_PrivPublic,
		   party -> party_PrivPublic_len = q -> party_PrivPublic_len);
	}
	else
	    party -> party_PrivPublic = NULL;
    }
no_priv: ;

    if (party -> party_authProt == NOAUTH)
	return OK;
    if (q -> party_authProt == NOAUTH)
	return int_SNMP_error__status_inconsistentValue;
    if (party -> party_clone & PARTY_AUTHPRIV) {
	int	len;
	unsigned char *dp;

	if (dp = party -> party_new_AuthPrivate)
	    len = party -> party_new_AuthPrivate_len;
	else {
	    dp =  party -> party_AuthPrivate;
	    len = party -> party_AuthPrivate_len;
	}
	exor (dp, len, q -> party_AuthPrivate, q -> party_AuthPrivate_len);
	if (checkey (dp, len) == NOTOK)
	    return int_SNMP_error__status_inconsistentValue;
    }
    else {
	if (party -> party_AuthPrivate)
	    free ((char *) party -> party_AuthPrivate);
	if (q -> party_AuthPrivate) {
	    if ((party -> party_AuthPrivate = (unsigned char *)
			    malloc ((unsigned int) q -> party_AuthPrivate_len))
		    == NULL)
		goto losing_big;
	    bcopy ((char *) q -> party_AuthPrivate,
		   (char *) party -> party_AuthPrivate,
		   party -> party_AuthPrivate_len
		       = q -> party_AuthPrivate_len);
	}
	else
	    party -> party_AuthPrivate = NULL;
    }

    if (party -> party_privProt == NOPRIV)
	return OK;
    if (q -> party_privProt == NOPRIV)
	return int_SNMP_error__status_inconsistentValue;
    if (party -> party_clone & PARTY_PRIVPRIV) {
	int	len;
	unsigned char *dp;

	if (dp = party -> party_new_PrivPrivate)
	    len = party -> party_new_PrivPrivate_len;
	else {
	    dp =  party -> party_PrivPrivate;
	    len = party -> party_PrivPrivate_len;
	}
	exor (dp, len, q -> party_PrivPrivate, q -> party_PrivPrivate_len);
	if (checkey (dp, len) == NOTOK)
	    return int_SNMP_error__status_inconsistentValue;
    }
    else {
	if (party -> party_PrivPrivate)
	    free ((char *) party -> party_PrivPrivate);
	if (q -> party_PrivPrivate) {
	    if ((party -> party_PrivPrivate = (unsigned char *)
			    malloc ((unsigned int) q -> party_PrivPrivate_len))
		    == NULL)
		goto losing_big;
	    bcopy ((char *) q -> party_PrivPrivate,
		   (char *) party -> party_PrivPrivate,
		   party -> party_PrivPrivate_len
		       = q -> party_PrivPrivate_len);
	}
	else
	    party -> party_PrivPrivate = NULL;
    }

    return OK;
}


static int  c_party (ck)
register struct checklist *ck;
{
    int	    result;
    register struct snmp_party *party = (struct snmp_party *) ck -> ck_info;

    if (party -> party_template && (result = c_clone (ck)) != OK)
	return result;
    if (party -> party_fresh
	    && party -> party_status == ROW_CREATEGO
	    && party_ready (party, "c_party") == NOTOK)
	return int_SNMP_error__status_inconsistentValue;

    if (party -> party_AuthStart < party -> party_new_AuthStart
	    && !party -> party_new_AuthPrivate)
	return int_SNMP_error__status_inconsistentValue;

    return OK;
}


static int  party_ready (party, where)
register struct snmp_party *party;
char   *where;
{
    if (debug)
	advise (LLOG_DEBUG, NULLCP, "party_ready %s %s %d %d (from %s)",
		sprintoid (party -> party_Identity),
		sprintb (party -> party_clone,
			 "\020\01cloning\02cloned\03authprot\04authpub\05authlife\06privprot\07privpub\010authpriv\011privpriv"),
		party -> party_authProt, party -> party_privProt, where);

    if (party -> party_clone & PARTY_CLONING) {
	party -> party_clone |= PARTY_CLONED;
	party -> party_clone &= ~PARTY_CLONING;
    }

    if (!(party -> party_clone & PARTY_CLONED)
	    || (party -> party_authProt != NOAUTH
		    && !(party -> party_clone & PARTY_AUTHPRIV))
	    || (party -> party_privProt != NOPRIV
		    && !(party -> party_clone & PARTY_PRIVPRIV)))
	return NOTOK;
	    
    return OK;
}

/*  */

static int  s_party (oi, v, offset, idx)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset,
	idx;
{
    register int    i;
    int	    ifvar;
    register struct snmp_party *party;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    register OS	    os = ot -> ot_syntax;
    u_long  big;
    caddr_t value;
    OID	    new;
    struct qbuf *qb;
    static int	lastq = -1;
    static u_long now;

    if (quantum != lastq) {
	lastq = quantum;

	now = party_time_now ();
    }

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_set__request:
	case type_SNMP_PDUs_commit:
	case type_SNMP_PDUs_rollback:
	    if ((i = oid -> oid_nelem - ot -> ot_name -> oid_nelem) <= 0)
		return int_SNMP_error__status_noSuchName;
	    if (party = get_party_entry (oid -> oid_elements
					     + ot -> ot_name -> oid_nelem,
					 i, 0))
		break;
	    if (offset != type_SNMP_PDUs_set__request)
		return int_SNMP_error__status_noError;
	    if (i < 2)
		return int_SNMP_error__status_noSuchName;

	    if ((party = (struct snmp_party *) calloc (1, sizeof *party))
		    == NULL) {
no_mem: ;
		advise (LLOG_EXCEPTIONS, NULLCP,
			"out of memory creating new party entry");

losing: ;
		if (party)
		    free_party_aux (party, 0);
		return int_SNMP_error__status_genErr;
	    }
	    if ((party -> party_Identity =
			    (OID) calloc (1, sizeof *party -> party_Identity))
		    == NULL)
		goto no_mem;
	    if (make_oid (oid, party -> party_Identity,
			  ot -> ot_name -> oid_nelem, i) == NOTOK)
		goto losing;
	    {
		register struct snmp_party *p;
		static int max_party = 0;

		i = max_party + 1;
		for (p = partyHead; p; p = p -> party_next)
		    if (p -> party_index >= i)
			i = p -> party_index + 1;
		party -> party_index = max_party = i;
	    }
	    if ((party -> party_TDomain = oid_cpy (snmpUDPDomain)) == NULL)
		goto no_mem;
	    party -> party_tDomain = SNMPUDPDOMAIN;
	    if ((party -> party_TAddress =
		 (u_char *) calloc ((unsigned) (party -> party_TAddress_len = 6),
				    sizeof *party -> party_TAddress)) == NULL)
		goto no_mem;
	    party -> party_MaxMessageSize = MAXSNMP;
	    party -> party_location = MANAGER;
	    if ((party -> party_AuthProtocol = oid_cpy (md5Auth)) == NULL)
		goto no_mem;
	    party -> party_authProt = MD5AUTHPROT;
	    party -> party_AuthStart = now;
	    party -> party_AuthLifetime = 300;
	    if ((party -> party_PrivProtocol = oid_cpy (noPriv)) == NULL)
		goto no_mem;
	    party -> party_privProt = NOPRIV;
	    party -> party_status = ROW_CREATEWAIT;
	    party -> party_storage = STORAGE_NONVOLATILE;
	    party -> party_fresh = 1;
	    {
		register struct snmp_party  *pp,
					   **ppp;

		for (ppp = &partyHead; pp = *ppp; ppp = &pp -> party_next)
		    if (oid_cmp (pp -> party_Identity,
				 party -> party_Identity) > 0)
			break;
		party -> party_next = pp;
		*ppp = party;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if (os == NULLOS) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"no syntax defined for object \"%s\"", ot -> ot_text);
	return int_SNMP_error__status_genErr;
    }

    switch (offset) {
	case type_SNMP_PDUs_set__request:
	    switch (ifvar) {
		case partyTDomain:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (party -> party_fresh) {
			/* test will work, given our only two domains... */
			if (party -> party_TAddress_len != 6) {
bad_tdomain: ;
bad_authprotocol: ;
bad_privprotocol: ;
			    (*os -> os_free) ((caddr_t) new);
			    return int_SNMP_error__status_wrongLength;
			}
			if (oid_cmp (new, snmpUDPDomain) == 0) {
			    party -> party_tDomain = SNMPUDPDOMAIN;
			    goto set_tdomain;
			}
			if (oid_cmp (new, rfc1157Domain) == 0) {
			    if (party -> party_privProt != NOPRIV) {
				(*os -> os_free) ((caddr_t) new);
				return int_SNMP_error__status_inconsistentValue;
			    }
			    party -> party_tDomain = RFC1157DOMAIN;
			    if (party -> party_authProt != RFC1157NOAUTH) {
				OID	foo;

				if ((foo = oid_cpy (rfc1157noAuth)) == NULL) {
				    (*os -> os_free) ((caddr_t) new);
losing_big: ;
				    advise (LLOG_EXCEPTIONS, NULLCP,
					    "out of memory");
				    return int_SNMP_error__status_genErr;
				}
				oid_free (party -> party_AuthProtocol);
				party -> party_AuthProtocol = foo;
				party -> party_authProt = RFC1157NOAUTH;
				party -> party_AuthLifetime = 0;
				party -> party_clone |= PARTY_AUTHPROT;
			    }
			    party -> party_MaxMessageSize = MAXSNMP;
			    party -> party_location = MANAGER;
			    goto set_tdomain;
			}
			goto bad_tdomain;
set_tdomain: ;
			oid_free (party -> party_TDomain);
			party -> party_TDomain = new;
			break;
		    }
		    i = oid_cmp (party -> party_TDomain, new);
		    (*os -> os_free) ((caddr_t) new);
		    if (i)
			return int_SNMP_error__status_inconsistentValue;
		    break;

		case partyTAddress:
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (party -> party_fresh) {
			/* test will work, given our only two domains... */
			if (qb -> qb_forw -> qb_forw != qb
			        || party -> party_TAddress_len
			    		!= qb -> qb_len) {
wrong_length: ;
			    (*os -> os_free) ((caddr_t) qb);
			    return int_SNMP_error__status_wrongLength;
			}
			bcopy (qb -> qb_forw -> qb_data,
			       (char *) party -> party_TAddress,
			       party -> party_TAddress_len);
			(*os -> os_free) ((caddr_t) qb);
			if (party -> party_tDomain == SNMPUDPDOMAIN) {
			    register struct snmp_party *p;

			    for (p = partyHead; p; p = p -> party_next)
				if (p -> party_status == ROW_ACTIVE
					&& p -> party_location == AGENT
				        && p -> party_TAddress_len
				    		== party -> party_TAddress_len
				        && bcmp ((char *) p -> party_TAddress,
						 (char *) party
							    -> party_TAddress,
						 p -> party_TAddress_len)
				    	    == 0) {
				    party -> party_MaxMessageSize = tooBig;
				    party -> party_location = AGENT;
				    break;
				}
			}
			break;
		    }
		    if (qb -> qb_forw -> qb_forw != qb
			    || party -> party_TAddress_len != qb -> qb_len
			    || bcmp ((char *) party -> party_TAddress,
				     qb -> qb_forw -> qb_data,
				     party -> party_TAddress_len)) {
inconsistent_value: ;
			    (*os -> os_free) ((caddr_t) qb);
			    return int_SNMP_error__status_inconsistentValue;
		     }
		    (*os -> os_free) ((caddr_t) qb);
		    break;
	  
		case partyMaxMessageSize:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    if (i < MAXSNMP || i > BIGSNMP)
			return int_SNMP_error__status_wrongValue;
		    if (party -> party_location == AGENT
			    && i > party -> party_MaxMessageSize)
			return int_SNMP_error__status_inconsistentValue;
		    if (party -> party_fresh)
			party -> party_MaxMessageSize = i;
		    else
			party -> party_new_MaxMessageSize = i;
		    break;

		case partyLocal:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    if (i < AGENT || i > MANAGER)
			return int_SNMP_error__status_wrongValue;
		    if (i == AGENT) {
			register struct snmp_party *p;

			if (party -> party_tDomain != SNMPUDPDOMAIN)
			    return int_SNMP_error__status_inconsistentValue;

			if (party -> party_TAddress_len != 6
			        || party -> party_TAddress[0]
			        || party -> party_TAddress[1]
			        || party -> party_TAddress[2]
			        || party -> party_TAddress[3]
			        || party -> party_TAddress[4]
			        || party -> party_TAddress[5]) {
			    for (p = partyHead; p; p = p -> party_next)
				if (p -> party_status == ROW_ACTIVE
				        && p -> party_location == AGENT
				        && p -> party_TAddress_len
						== party -> party_TAddress_len
				        && bcmp ((char *) p -> party_TAddress,
						 (char *) party
							    -> party_TAddress,
						 p -> party_TAddress_len) == 0)
				    break;
			    /* perhaps too strict... */
			    if (!p)
				return int_SNMP_error__status_resourceUnavailable;
			}
			else
			    for (p = partyHead; p; p = p -> party_next)
				if (p -> party_status == ROW_ACTIVE
				        && p -> party_location == AGENT
				        && p -> party_TAddress_len
						== party
						    -> party_TAddress_len) {
				    bcopy ((char *) p -> party_TAddress,
					   (char *) party -> party_TAddress,
					   p -> party_TAddress_len);
				    break;
				}
		    }
		    if (party -> party_fresh)
			party -> party_location = i;
		    else
			party -> party_new_Local = i;
		    break;
		    
		case partyAuthProtocol:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (party -> party_fresh) {
			if (oid_cmp (new, noAuth) == 0) {
			    if (party -> party_AuthPublic
				    || party -> party_AuthPrivate)
				goto bad_authprotocol;
			    party -> party_authProt = NOAUTH;
			    party -> party_AuthLifetime = 0;
			    goto set_authProtocol;
			}
			if (oid_cmp (new, md5Auth) == 0) {
			    if (party -> party_tDomain != SNMPUDPDOMAIN
				    || (party -> party_AuthPublic
					    && party -> party_AuthPublic_len
						    > AUTH_KEY_LENGTH)
				    || (party -> party_AuthPrivate
					    && party
						-> party_AuthPrivate_len
						    != AUTH_KEY_LENGTH))
				goto bad_authprotocol;
			    party -> party_authProt = MD5AUTHPROT;
			    if (party -> party_AuthLifetime <= 0)
				party -> party_AuthLifetime = 300;
			    goto set_authProtocol;
			}
			if (oid_cmp (new, rfc1157noAuth) == 0) {
			    if (party -> party_tDomain != RFC1157DOMAIN)
				goto bad_authprotocol;
			    party -> party_authProt = RFC1157NOAUTH;
			    party -> party_AuthLifetime = 0;
			    goto set_authProtocol;
			}
			goto bad_authprotocol;
set_authProtocol: ;
			oid_free (party -> party_AuthProtocol);
			party -> party_AuthProtocol = new;
			party -> party_clone |= PARTY_AUTHPROT;
			break;
		    }
		    i = oid_cmp (party -> party_AuthProtocol, new);
		    (*os -> os_free) ((caddr_t) new);
		    if (i)
			return int_SNMP_error__status_inconsistentValue;
		    break;
	    
		case partyAuthClock:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    big = *((u_long *) value);
		    (*os -> os_free) (value);
		    if (big > now)
			return int_SNMP_error__status_inconsistentValue;
		    big = now - big;
		    if (party -> party_fresh)
			party -> party_AuthStart = big;
		    else {
			if (party -> party_AuthStart < big
			        && !party -> party_new_AuthPrivate) {
			    register struct checklist *ck;

			    if (ck = (struct checklist *)
						    calloc (1, sizeof *ck)) {
				ck -> ck_next = ckHead, ckHead = ck;

				ck -> ck_fnx = c_party;
				ck -> ck_info = (caddr_t) party;
				ck -> ck_idx = idx;
			    }
			    else {
				advise (LLOG_EXCEPTIONS, NULLCP,
					"out of memory creating checklist");
				return int_SNMP_error__status_genErr;
			    }
			}
			party -> party_new_AuthStart = big;
		    }
		    break;

		case partyAuthPrivate:
		    if (party -> party_fresh) {
			if (party -> party_authProt == NOAUTH
			        || (party -> party_clone & PARTY_AUTHPRIV))
			    return int_SNMP_error__status_inconsistentValue;
			if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			        == NOTOK)
			    return v -> value -> pe_errno;
			if (qb -> qb_forw -> qb_forw != qb
			        || (party -> party_authProt == MD5AUTHPROT
				        && qb -> qb_len != AUTH_KEY_LENGTH))
			    goto wrong_length;
			if ((party -> party_AuthPrivate =
					    (u_char *) qb2str (qb)) == NULL) {
losing_qb_big: ;
				(*os -> os_free) ((caddr_t) qb);
				goto losing_big;
			}
			party -> party_AuthPrivate_len = qb -> qb_len;
			(*os -> os_free) ((caddr_t) qb);
			party -> party_clone |= PARTY_AUTHPRIV;
			break;
		    }
		    if (party -> party_new_AuthPrivate)
			return int_SNMP_error__status_inconsistentValue;
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb
			    || (party -> party_authProt == MD5AUTHPROT
				    && qb -> qb_len != AUTH_KEY_LENGTH))
			goto wrong_length;
		    exor ((u_char *) qb -> qb_forw -> qb_data,
			  qb -> qb_len,
			  party -> party_AuthPrivate,
			  party -> party_AuthPrivate_len);
		    if (checkey ((u_char *) qb -> qb_forw -> qb_data,
				 qb -> qb_len) == NOTOK)
			goto inconsistent_value;
		    if ((party -> party_new_AuthPrivate = 
					    (u_char *) qb2str (qb)) == NULL)
			goto losing_qb_big;
		    party -> party_new_AuthPrivate_len = qb -> qb_len;
		    (*os -> os_free) ((caddr_t) qb);
		    party -> party_clone |= PARTY_AUTHPRIV;
		    break;

		case partyAuthPublic:
		    if (party -> party_fresh) {
			if (party -> party_authProt == NOAUTH
			        || (party -> party_clone & PARTY_AUTHPUB))
			    return int_SNMP_error__status_inconsistentValue;
			if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			        == NOTOK)
			    return v -> value -> pe_errno;
			if (qb -> qb_forw -> qb_forw != qb
			        || (party -> party_authProt == MD5AUTHPROT
				        && qb -> qb_len > AUTH_KEY_LENGTH))
			    goto wrong_length;
			if ((party -> party_AuthPublic =
					    (u_char *) qb2str (qb)) == NULL)
			    goto losing_qb_big;
			party -> party_AuthPublic_len = qb -> qb_len;
			(*os -> os_free) ((caddr_t) qb);
			party -> party_clone |= PARTY_AUTHPUB;
			break;
		    }
		    if (party -> party_new_AuthPublic)
			return int_SNMP_error__status_inconsistentValue;
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb
			    || (party -> party_authProt == MD5AUTHPROT
				    && qb -> qb_len > AUTH_KEY_LENGTH))
			goto wrong_length;
		    if ((party -> party_new_AuthPublic = 
					    (u_char *) qb2str (qb)) == NULL)
			goto losing_qb_big;
		    party -> party_new_AuthPublic_len = qb -> qb_len;
		    (*os -> os_free) ((caddr_t) qb);
		    break;

		case partyAuthLifetime:
		    if (party -> party_authProt != MD5AUTHPROT)
			return int_SNMP_error__status_inconsistentValue;
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    if (i < 0 || i > 2147483647)
			return int_SNMP_error__status_wrongValue;
		    if (party -> party_fresh) {
			party -> party_AuthLifetime = i;
			party -> party_clone |= PARTY_AUTHLIFE;
		    }
		    else
			if (party -> party_AuthLifetime != i)
			    return int_SNMP_error__status_wrongValue;
		    break;

		case partyPrivProtocol:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (party -> party_fresh) {
			if (oid_cmp (new, noPriv) == 0) {
			    if (party -> party_PrivPublic
				    || party -> party_PrivPrivate)
				goto bad_privprotocol;
			    party -> party_privProt = NOPRIV;
			    goto set_privProtocol;
			}
			if (oid_cmp (new, desPriv) == 0) {
			    if (party -> party_tDomain != SNMPUDPDOMAIN
				    || (party -> party_PrivPublic
					    && party -> party_PrivPublic_len
					    	     > PRIV_KEY_LENGTH * 2)
			    	    || (party -> party_PrivPrivate
					    && party
					        -> party_PrivPrivate_len
						     != PRIV_KEY_LENGTH * 2))
				goto bad_privprotocol;
			    party -> party_privProt = DESPRIVPROT;
			    goto set_privProtocol;
			}
set_privProtocol: ;
			oid_free (party -> party_PrivProtocol);
			party -> party_PrivProtocol = new;
			party -> party_clone |= PARTY_PRIVPROT;
			break;
		    }
		    i = oid_cmp (party -> party_PrivProtocol, new);
		    (*os -> os_free) ((caddr_t) new);
		    if (i)
			return int_SNMP_error__status_wrongValue;
		    break;

		case partyPrivPrivate:
		    if (party -> party_fresh) {
			if (party -> party_tDomain != SNMPUDPDOMAIN)
			    return int_SNMP_error__status_inconsistentValue;
			if (!(party -> party_clone & PARTY_PRIVPROT)) {
			    if ((new = oid_cpy (desPriv)) == NULL)
				goto losing_big;
			    oid_free (party -> party_PrivProtocol);
			    party -> party_PrivProtocol = new;
			    party -> party_privProt = DESPRIVPROT;
			    party -> party_clone |= PARTY_PRIVPROT;
			}
			else
			    if (party -> party_privProt == NOPRIV
			            || (party -> party_clone & PARTY_PRIVPROT))
			       return int_SNMP_error__status_inconsistentValue;
			if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			        == NOTOK)
			    return v -> value -> pe_errno;
			if (qb -> qb_forw -> qb_forw != qb
			        || (party -> party_privProt == DESPRIVPROT
				        && qb -> qb_len != PRIV_KEY_LENGTH *2))
			    goto wrong_length;
			if ((party -> party_PrivPrivate =
					    (u_char *) qb2str (qb)) == NULL)
			    goto losing_qb_big;
			party -> party_PrivPrivate_len = qb -> qb_len;
			(*os -> os_free) ((caddr_t) qb);
			party -> party_clone |= PARTY_PRIVPRIV;
			break;
		    }
		    if (party -> party_new_PrivPrivate)
			return int_SNMP_error__status_inconsistentValue;
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb
			    || (party -> party_privProt == DESPRIVPROT
				    && qb -> qb_len != PRIV_KEY_LENGTH * 2))
			goto wrong_length;
		    exor ((u_char *) qb -> qb_forw -> qb_data,
			  qb -> qb_len,
			  party -> party_PrivPrivate,
			  party -> party_PrivPrivate_len);
		    if (checkey ((u_char *) qb -> qb_forw -> qb_data,
				 qb -> qb_len) == NOTOK)
			goto inconsistent_value;
		    if ((party -> party_new_PrivPrivate = 
					    (u_char *) qb2str (qb)) == NULL)
			goto losing_qb_big;
		    party -> party_new_PrivPrivate_len = qb -> qb_len;
		    (*os -> os_free) ((caddr_t) qb);
		    party -> party_clone |= PARTY_PRIVPRIV;
		    break;

		case partyPrivPublic:
		    if (party -> party_fresh) {
			if (party -> party_tDomain != SNMPUDPDOMAIN)
			    return int_SNMP_error__status_inconsistentValue;
			if (party -> party_privProt == NOPRIV) {
			    if ((new = oid_cpy (desPriv)) == NULL)
				goto losing_big;
			    oid_free (party -> party_PrivProtocol);
			    party -> party_PrivProtocol = new;
			    party -> party_privProt = DESPRIVPROT;
			    party -> party_clone |= PARTY_PRIVPROT;
			}
			else
			    if (party -> party_privProt == NOPRIV
			            || (party -> party_clone
					    & (PARTY_PRIVPROT |PARTY_PRIVPUB)))
			       return int_SNMP_error__status_inconsistentValue;
			if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			        == NOTOK)
			    return v -> value -> pe_errno;
			if (qb -> qb_forw -> qb_forw != qb
			        || qb -> qb_len > PRIV_KEY_LENGTH * 2)
			    goto wrong_length;
			if ((party -> party_PrivPublic =
					    (u_char *) qb2str (qb)) == NULL)
			    goto losing_qb_big;
			party -> party_PrivPublic_len = qb -> qb_len;
			(*os -> os_free) ((caddr_t) qb);
			party -> party_clone |= PARTY_PRIVPUB;
			break;
		    }
		    if (party -> party_new_PrivPublic)
			return int_SNMP_error__status_inconsistentValue;
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb
			    || qb -> qb_len > PRIV_KEY_LENGTH * 2)
			goto wrong_length;
		    if ((party -> party_new_PrivPublic = 
					    (u_char *) qb2str (qb)) == NULL)
			goto losing_qb_big;
		    party -> party_new_PrivPublic_len = qb -> qb_len;
		    (*os -> os_free) ((caddr_t) qb);
		    break;

		case partyCloneFrom:
		    {
			struct snmp_party *q;
			register struct checklist *ck;

			if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			        == NOTOK)
			    return v -> value -> pe_errno;
			q = lookup_party (new, EITHER);
			(*os -> os_free) ((caddr_t) new);
			if (party -> party_status == ROW_ACTIVE
			        || party -> party_status == ROW_NOTINSVC
			        || (party -> party_clone &
						(PARTY_CLONED | PARTY_CLONED))
				|| q == NULL)
			    return int_SNMP_error__status_inconsistentValue;
			party -> party_clone |= PARTY_CLONING;

			if (ck = (struct checklist *) calloc (1, sizeof *ck)) {
			    ck -> ck_next = ckHead, ckHead = ck;

			    ck -> ck_fnx = c_clone;
			    ck -> ck_info = (caddr_t) party;
			    ck -> ck_idx = idx;

			    party -> party_template = q;
			}
			else {
			    advise (LLOG_EXCEPTIONS, NULLCP,
				    "out of memory creating checklist");
			    return int_SNMP_error__status_genErr;
			}
		    }
		    break;

		case partyStorageType:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case STORAGE_VOLATILE:
			case STORAGE_NONVOLATILE:
			    if (party -> party_fresh)
				party -> party_storage = i;
			    else
				party -> party_new_storage = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		case partyStatus:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case ROW_CREATEGO:
			case ROW_CREATEWAIT:
			    if (!party -> party_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    if (i == ROW_CREATEGO) {
				register struct checklist *ck;

				if (ck = (struct checklist *)
						    calloc (1, sizeof *ck)) {
				    ck -> ck_next = ckHead, ckHead = ck;

				    ck -> ck_fnx = c_party;
				    ck -> ck_info = (caddr_t) party;
				    ck -> ck_idx = idx;
				}
				else {
				    advise (LLOG_EXCEPTIONS, NULLCP,
					    "out of memory creating checklist");
				    return int_SNMP_error__status_genErr;
				}
			    }
			    party -> party_status = i;
			    break;

			case ROW_ACTIVE:
			case ROW_NOTINSVC:
			    if (party -> party_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    party -> party_new_status = i;
			    break;

			case ROW_DESTROY:
			    if (party -> party_fresh)
				party -> party_status = i;
			    else
				party -> party_new_status = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

#ifdef	MAGIC
		case partyTestMode:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    {
			register struct enum_syntax *es;

			for (es = os -> os_enum; es; es = es -> es_next)
			    if (es -> es_value == i)
				break;
			if (!es)
			    return int_SNMP_error__status_wrongValue;

			if (party -> party_fresh)
			    party -> party_testmode = i;
			else
			    party -> party_new_testmode = i;
		    }
		    break;
#endif

		default:
		    return int_SNMP_error__status_noSuchName;
	    }
	    break;

	case type_SNMP_PDUs_commit:
	    if (party -> party_fresh) {
		switch (party -> party_status) {
		    case ROW_CREATEGO:
		        party -> party_status = ROW_ACTIVE;
			break;

		    case ROW_CREATEWAIT:
			party -> party_status = party_ready (party, "commit1")
							== NOTOK
			    			    ? ROW_NOTREADY
						    : ROW_NOTINSVC;
			break;

		    case ROW_DESTROY:
			break;
		}
		party -> party_old_clone = party -> party_clone;

		party -> party_fresh = 0;
		party_changed = 1;
		break;
	    }
	    
	    if (party -> party_new_MaxMessageSize) {
		party -> party_MaxMessageSize =
					    party -> party_new_MaxMessageSize;
		party -> party_new_MaxMessageSize = 0;

		party_changed = 1;
	    }
	    if (party -> party_new_Local) {
		party -> party_location = party -> party_new_Local;
		party -> party_new_Local = 0;

		party_changed = 1;
	    }
	    if (party -> party_new_AuthStart) {
		party -> party_AuthStart = party -> party_new_AuthStart;
		party -> party_new_AuthStart = 0;

		party_changed = 1;
	    }
	    if (party -> party_new_AuthPrivate) {
		if (party -> party_AuthPrivate)
		    free ((char *) party -> party_AuthPrivate);
		party -> party_AuthPrivate =
				    party -> party_new_AuthPrivate;
		party -> party_AuthPrivate_len =
				    party -> party_new_AuthPrivate_len;
		party -> party_new_AuthPrivate = NULL;

		party_changed = 1;
	    }
	    if (party -> party_new_AuthPublic) {
		if (party -> party_AuthPublic)
		    free ((char *) party -> party_AuthPublic);
		party -> party_AuthPublic = party -> party_new_AuthPublic;
		party -> party_AuthPublic_len =
					    party -> party_new_AuthPublic_len;
		party -> party_new_AuthPublic = NULL;

		party_changed = 1;
	    }
	    if (party -> party_new_PrivPrivate) {
		if (party -> party_PrivPrivate)
		    free ((char *) party -> party_PrivPrivate);
		party -> party_PrivPrivate =
				    party -> party_new_PrivPrivate;
		party -> party_PrivPrivate_len =
				    party -> party_new_PrivPrivate_len;
		party -> party_new_PrivPrivate = NULL;

		party_changed = 1;
	    }
	    if (party -> party_new_PrivPublic) {
		if (party -> party_PrivPublic)
		    free ((char *) party -> party_PrivPublic);
		party -> party_PrivPublic = party -> party_new_PrivPublic;
		party -> party_PrivPublic_len =
					    party -> party_new_PrivPublic_len;
		party -> party_new_PrivPublic = NULL;

		party_changed = 1;
	    }
	    if (party -> party_new_status) {
		party -> party_status = party -> party_new_status;
		party -> party_new_status = 0;

		party_changed = 1;
	    }
	    if (party_ready (party, "commit2") == NOTOK) {
		if (party -> party_status != ROW_DESTROY)
		    party -> party_status = ROW_NOTREADY;
	    }
	    else
		if (party -> party_status == ROW_NOTREADY) {
		    party -> party_status = ROW_NOTINSVC;

		    party_changed = 1;
		}
	    if (party -> party_new_storage) {
		party -> party_storage = party -> party_new_storage;
		party -> party_new_storage = 0;

		party_changed = 1;
	    }
#ifdef	MAGIC
	    party -> party_testmode = party -> party_new_testmode;
#endif
	    party -> party_old_clone = party -> party_clone;
	    break;

	case type_SNMP_PDUs_rollback:
	    if (party -> party_fresh) {
		free_party (party);
		break;
	    }
	    party -> party_new_MaxMessageSize = 0;
	    party -> party_new_Local = 0;
	    party -> party_new_AuthStart = 0;
	    if (party -> party_new_AuthPrivate) {
		free ((char *) party -> party_new_AuthPrivate);
	        party -> party_new_AuthPrivate = NULL;
	    }
	    if (party -> party_new_AuthPublic) {
		free ((char *) party -> party_new_AuthPublic);
	        party -> party_new_AuthPublic = NULL;
	    }
	    if (party -> party_new_PrivPrivate) {
		free ((char *) party -> party_new_PrivPrivate);
	        party -> party_new_PrivPrivate = NULL;
	    }
	    if (party -> party_new_PrivPublic) {
		free ((char *) party -> party_new_PrivPublic);
	        party -> party_new_PrivPublic = NULL;
	    }
	    party -> party_new_status = party -> party_new_storage = 0;
#ifdef	MAGIC
	    party -> party_new_testmode = party -> party_testmode;
#endif
	    party -> party_clone = party -> party_old_clone;
	    party -> party_template = NULL;
	    break;
    }

    return int_SNMP_error__status_noError;
}

/*  */

static struct snmp_party *get_party_entry (ip, len, isnext)
register unsigned int *ip;
int	len,
	isnext;
{
    register struct snmp_party *p;

    for (p = partyHead; p; p = p -> party_next)
	switch (elem_cmp (p -> party_Identity -> oid_elements,
			  p -> party_Identity -> oid_nelem, ip, len)) {
	    case 0:
	        if (!isnext)
		    return p;
		if ((p = p -> party_next) == NULL)
		    return NULL;
		/* else fall... */

	    case 1:
		return (isnext ? p : NULL);
	}

    return NULL;
}

/*  */

static int  checkey (bp, n)
register u_char *bp;
int	n;
{
    int	    len = n,
	    oC = 0,
    	    zC = 0;

    while (len-- > 0) {
	int	c = *bp++ & 0xff;

	if (c == 0x00)
	    zC++;
	else
	    if (c == 0xff)
		oC++;
    }
    
    return (zC == n || oC == n ? NOTOK : OK );
}

/*  */

#ifdef	MAGIC
#define	testIndex	1
#define	testInteger	2
#define	testString	3


static int  o_test (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem != ot -> ot_name -> oid_nelem + 1
		    || oid -> oid_elements[oid -> oid_nelem - 1] != 0)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if (magicommand == MAGIC_LONGROW) {
		    if ((i = 128 - oid -> oid_nelem) <= 0)
			return NOTOK;
		}
		else 
		    i = 1;
		if ((new = oid_extend (oid, i)) == NULLOID)
		    return NOTOK;
		new -> oid_elements[oid -> oid_nelem + 1] = i - 1;

		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else
		return NOTOK;
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case testIndex:
	    switch (magicommand) {
		case MAGIC_LONGROW:
		    if (offset == type_SNMP_PDUs_get__next__request && i > 0) {
			char	buffer[128 + 1];

			bzero (buffer, sizeof buffer);
			buffer[0] = i;
			return o_string (oi, v, buffer, i + 1);
		    }
		    /* else fall... */
		default:
		    return o_string (oi, v, "", 0);
	    }
	
	case testInteger:
	    switch (magicommand) {
		case MAGIC_TOOSMALLINT:
		    return o_integer (oi, v, -1);

		case MAGIC_TOOBIGINT:
		    return o_integer (oi, v, 2);

		case MAGIC_LONGROW:
		default:
		    return o_integer (oi, v, 0);
	    }

	case testString:
	    switch (magicommand) {
		case MAGIC_TOOSMALLSTR:
		    return o_string (oi, v, "", 0);

		case MAGIC_TOOBIGSTR:
		    return o_string (oi, v, "123", 3);
		
		case MAGIC_LONGROW:
		default:
		    return o_string (oi, v, " ", 1);
	    }

	default:
	    return int_SNMP_error__status_genErr;
    }
}
#endif

/*  */

struct snmp_context *get_context_entry ();


static int  o_context (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register unsigned int *ip,
			  *jp;
    register struct snmp_context *sc;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((sc = get_context_entry (oid -> oid_elements
				             + ot -> ot_name -> oid_nelem,
					 oid -> oid_nelem
				             - ot -> ot_name -> oid_nelem,
					 0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem < ot -> ot_name -> oid_nelem)
		return NOTOK;
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((sc = contextHead) == NULL)
		    return NOTOK;

		jp = sc -> sc_identity -> oid_elements;
		i = sc -> sc_identity -> oid_nelem;

		if ((new = oid_extend (oid, i)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - i;
		for (; i > 0; i--)
		    *ip++ = *jp++;
		
		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else {
		int	j;

		if ((sc = get_context_entry (oid -> oid_elements
					         + ot -> ot_name -> oid_nelem,
					     j = oid -> oid_nelem
					         - ot -> ot_name -> oid_nelem,
					     1)) == NULL)
		    return NOTOK;
		i = sc -> sc_identity -> oid_nelem;

		if ((i = j - i) < 0) {
		    OID	    new;

		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		jp = sc -> sc_identity -> oid_elements;
		i = sc -> sc_identity -> oid_nelem;
		for (; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case contextName:
	    return o_string (oi, v, (char *) sc -> sc_name,
			     sc -> sc_name_len);

	case contextIndex:
	    return o_integer (oi, v, sc -> sc_index);

	case contextLocal:
	    return o_integer (oi, v, sc -> sc_location);

	case contextViewIndex:
	    return o_integer (oi, v, sc -> sc_view);

	case contextLocalEntity:
	    return o_string (oi, v, (char *) sc -> sc_entity,
			     sc -> sc_entity_len);

	case contextLocalTime:
	    return o_specific (oi, v, (caddr_t) sc -> sc_time);

	case contextProxyDstParty:
	    return o_specific (oi, v, (caddr_t) sc -> sc_dst_oid);

	case contextProxySrcParty:
	    return o_specific (oi, v, (caddr_t) sc -> sc_src_oid);

	case contextProxyContext:
	    return o_specific (oi, v, (caddr_t) sc -> sc_ctx);

	case contextStorageType:
	    return o_integer (oi, v, sc -> sc_storage);

	case contextStatus:
	    return o_integer (oi, v, sc -> sc_status);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static int  c_context (ck)
register struct checklist *ck;
{
    register struct snmp_context *sc = (struct snmp_context *) ck -> ck_info;

    if (sc -> sc_fresh && sc -> sc_status == ROW_CREATEGO)
	if (sc -> sc_view > 0) {
	    register struct snmp_view *vu;

	    for (vu = viewHead; vu; vu = vu -> vu_next)
		if (vu -> vu_status == ROW_ACTIVE
		        && vu -> vu_index == sc -> sc_view)
		    break;
	    if (!vu)
		return int_SNMP_error__status_inconsistentValue;
	}
	else {
	    if (!(sc -> sc_dst = lookup_party (sc -> sc_dst_oid, MANAGER)))
		return int_SNMP_error__status_inconsistentValue;
	    sc -> sc_src = lookup_party (sc -> sc_src_oid, AGENT);
	    if ((sc -> sc_dst -> party_tDomain == SNMPUDPDOMAIN)
		    && (!sc -> sc_src || !sc -> sc_ctx))
		return int_SNMP_error__status_inconsistentValue;
	}

    return OK;
}

/*  */

static int  s_context (oi, v, offset, idx)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset,
	idx;
{
    register int    i;
    int	    ifvar;
    register struct snmp_context *sc;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    register OS	    os = ot -> ot_syntax;
    caddr_t value;
    OID	    new;
    struct qbuf *qb;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_set__request:
	case type_SNMP_PDUs_commit:
	case type_SNMP_PDUs_rollback:
	    if ((i = oid -> oid_nelem - ot -> ot_name -> oid_nelem) <= 0)
		return int_SNMP_error__status_noSuchName;
	    if (sc = get_context_entry (oid -> oid_elements
					     + ot -> ot_name -> oid_nelem,
					 i, 0))
		break;
	    if (offset != type_SNMP_PDUs_set__request)
		return int_SNMP_error__status_noError;
	    if (i < 2)
		return int_SNMP_error__status_noSuchName;

	    if ((sc = (struct snmp_context *) calloc (1, sizeof *sc)) == NULL){
no_mem: ;
		advise (LLOG_EXCEPTIONS, NULLCP,
			"out of memory creating new context entry");

losing: ;
		if (sc)
		    free_context_aux (sc, 0);
		return int_SNMP_error__status_genErr;
	    }
	    if ((sc -> sc_identity =
			    (OID) calloc (1, sizeof *sc -> sc_identity))
		    == NULL)
		goto no_mem;
	    if (make_oid (oid, sc -> sc_identity, ot -> ot_name -> oid_nelem,
			  i) == NOTOK)
		goto losing;
	    sc -> sc_location = AGENT;
	    if ((sc -> sc_name = (u_char *)
				strdup (sprintoid (sc -> sc_identity))) == NULL
		    || (sc -> sc_entity = (u_char *) calloc (1,
					    sizeof *sc -> sc_entity)) == NULL
		    || (sc -> sc_time = oid_cpy (currentTime)) == NULL
		    || (sc -> sc_dst_oid = oid_cpy (nullSpecific)) == NULL
		    || (sc -> sc_src_oid = oid_cpy (nullSpecific)) == NULL
		    || (sc -> sc_ctx = oid_cpy (nullSpecific)) == NULL)
		goto no_mem;
	    sc -> sc_name_len = strlen ((char *) sc -> sc_name);
	    {
		register struct snmp_context *qc;
		static int max_context = 0;

		i = max_context + 1;
		for (qc = contextHead; qc; qc = qc -> sc_next)
		    if (qc -> sc_index >= i)
			i = qc -> sc_index + 1;
		sc -> sc_index = max_context = i;
	    }
	    sc -> sc_status = ROW_CREATEWAIT;
	    sc -> sc_storage = STORAGE_NONVOLATILE;
	    sc -> sc_fresh = 1;
	    {
		register struct snmp_context  *pc,
					     **ppc;

		for (ppc = &contextHead; pc = *ppc; ppc = &pc -> sc_next)
		    if (oid_cmp (pc -> sc_identity, sc -> sc_identity) > 0)
			break;
		sc -> sc_next = pc;
		*ppc = sc;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if (os == NULLOS) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"no syntax defined for object \"%s\"", ot -> ot_text);
	return int_SNMP_error__status_genErr;
    }

    switch (offset) {
	case type_SNMP_PDUs_set__request:
	    switch (ifvar) {
		case contextName:
		    if (sc -> sc_new_name)
			return int_SNMP_error__status_inconsistentValue;
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb
			    || qb -> qb_len < 1
			    || qb -> qb_len > 255) {
			(*os -> os_free) ((caddr_t) qb);
			return int_SNMP_error__status_wrongLength;
		    }
		    if ((sc -> sc_new_name = (u_char *) qb2str (qb)) == NULL) {
			(*os -> os_free) ((caddr_t) qb);
			advise (LLOG_EXCEPTIONS, NULLCP, "out of memory");
			return int_SNMP_error__status_genErr;
		    }
		    sc -> sc_new_name_len = qb -> qb_len;
		    (*os -> os_free) ((caddr_t) qb);
		    break;

		case contextLocal:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    if (i < AGENT || i > MANAGER)
			return int_SNMP_error__status_wrongValue;
		    if (sc -> sc_fresh)
			sc -> sc_location = i;
		    else
			sc -> sc_new_location = i;
		    break;

		case contextViewIndex:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    if (i < 0)
			return int_SNMP_error__status_wrongValue;
		    if (sc -> sc_fresh)
			sc -> sc_view = i;
		    else
			sc -> sc_new_view = i;
		    break;

		case contextLocalEntity:
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb) {
			(*os -> os_free) ((caddr_t) qb);
			return int_SNMP_error__status_wrongLength;
		    }
		    if (qb -> qb_len != 0) {
			(*os -> os_free) ((caddr_t) qb);
			return int_SNMP_error__status_wrongValue;
		    }
		    (*os -> os_free) ((caddr_t) qb);
		    break;

		case contextLocalTime:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    i = oid_cmp (currentTime, new);
		    (*os -> os_free) ((caddr_t) new);
		    if (i)
			return int_SNMP_error__status_wrongValue;
		    break;

		case contextProxyDstParty:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (sc -> sc_fresh) {
			if (sc -> sc_dst_oid)
			    oid_free (sc -> sc_dst_oid);
			sc -> sc_dst_oid = new;
		    }
		    else {
			if (sc -> sc_new_dst_oid)
			    oid_free (sc -> sc_new_dst_oid);
			sc -> sc_new_dst_oid = new;
		    }
		    break;

		case contextProxySrcParty:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (sc -> sc_fresh) {
			if (sc -> sc_src_oid)
			    oid_free (sc -> sc_src_oid);
			sc -> sc_src_oid = new;
		    }
		    else {
			if (sc -> sc_new_src_oid)
			    oid_free (sc -> sc_new_src_oid);
			sc -> sc_new_src_oid = new;
		    }
		    break;

		case contextProxyContext:
		    if ((*os -> os_decode) ((caddr_t) &new, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (sc -> sc_fresh) {
			if (sc -> sc_ctx)
			    oid_free (sc -> sc_ctx);
			sc -> sc_ctx = new;
		    }
		    else {
			if (sc -> sc_new_ctx)
			    oid_free (sc -> sc_new_ctx);
			sc -> sc_new_ctx = new;
		    }
		    break;

		case contextStorageType:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case STORAGE_VOLATILE:
			case STORAGE_NONVOLATILE:
			    if (sc -> sc_fresh)
				sc -> sc_storage = i;
			    else
				sc -> sc_new_storage = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		case contextStatus:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case ROW_CREATEGO:
			case ROW_CREATEWAIT:
			    if (!sc -> sc_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    if (i == ROW_CREATEGO) {
				register struct checklist *ck;

				if (ck = (struct checklist *)
						    calloc (1, sizeof *ck)) {
				    ck -> ck_next = ckHead, ckHead = ck;

				    ck -> ck_fnx = c_context;
				    ck -> ck_info = (caddr_t) sc;
				    ck -> ck_idx = idx;
				}
				else {
				    advise (LLOG_EXCEPTIONS, NULLCP,
					    "out of memory creating checklist");
				    return int_SNMP_error__status_genErr;
				}
			    }
			    sc -> sc_status = i;
			    break;

			case ROW_ACTIVE:
			case ROW_NOTINSVC:
			    if (sc -> sc_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    sc -> sc_new_status = i;
			    break;

			case ROW_DESTROY:
			    if (sc -> sc_fresh)
				sc -> sc_status = i;
			    else
				sc -> sc_new_status = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		default:
		    return int_SNMP_error__status_noSuchName;
	    }
	    break;

	case type_SNMP_PDUs_commit:
	    if (sc -> sc_fresh) {
		switch (sc -> sc_status) {
		    case ROW_CREATEGO:
		        sc -> sc_status = ROW_ACTIVE;
			break;

		    case ROW_CREATEWAIT:
			sc -> sc_status = ROW_NOTINSVC;
			break;

		    case ROW_DESTROY:
			break;
		}

		sc -> sc_fresh = 0;
		context_changed = 1;
		break;
	    }
	    
	    if (sc -> sc_new_name) {
		if (sc -> sc_name)
		    free ((char *) sc -> sc_name);
		sc -> sc_name = sc -> sc_new_name;
		sc -> sc_name_len = sc -> sc_new_name_len;
		sc -> sc_new_name = NULL;

		context_changed = 1;
	    }
	    if (sc -> sc_new_location) {
		sc -> sc_location = sc -> sc_location;
		sc -> sc_new_location = 0;

		context_changed = 1;
	    }
	    if (sc -> sc_new_view) {
		sc -> sc_view = sc -> sc_view;
		sc -> sc_new_view = 0;

		context_changed = 1;
	    }
	    if (sc -> sc_new_entity) {
		if (sc -> sc_entity)
		    free ((char *) sc -> sc_entity);
		sc -> sc_entity = sc -> sc_new_entity;
		sc -> sc_entity_len = sc -> sc_new_entity_len;
		sc -> sc_new_entity = NULL;

		context_changed = 1;
	    }
	    if (sc -> sc_new_time) {
		if (sc -> sc_time)
		    oid_free (sc -> sc_time);
		sc -> sc_time = sc -> sc_new_time;
		sc -> sc_new_time = NULL;

		context_changed = 1;
	    }
	    if (sc -> sc_new_dst_oid) {
		if (sc -> sc_dst_oid)
		    oid_free (sc -> sc_dst_oid);
		sc -> sc_dst_oid = sc -> sc_new_dst_oid;
		sc -> sc_new_dst_oid = NULL;

		context_changed = 1;
	    }
	    if (sc -> sc_new_src_oid) {
		if (sc -> sc_src_oid)
		    oid_free (sc -> sc_src_oid);
		sc -> sc_src_oid = sc -> sc_new_src_oid;
		sc -> sc_new_src_oid = NULL;

		context_changed = 1;
	    }
	    if (sc -> sc_new_ctx) {
		sc -> sc_ctx = sc -> sc_new_ctx;
		sc -> sc_new_ctx = NULL;

		context_changed = 1;
	    }
	    if (sc -> sc_new_status) {
		sc -> sc_status = sc -> sc_new_status;
		sc -> sc_new_status = 0;

		context_changed = 1;
	    }
	    if (sc -> sc_new_storage) {
		sc -> sc_storage = sc -> sc_new_storage;
		sc -> sc_new_storage = 0;

		context_changed = 1;
	    }
	    break;

	case type_SNMP_PDUs_rollback:
	    if (sc -> sc_fresh) {
		free_context (sc);
		break;
	    }
	    if (sc -> sc_new_name) {
		free ((char *) sc -> sc_new_name);
	        sc -> sc_new_name = NULL;
	    }
	    sc -> sc_new_location = sc -> sc_new_view = 0;
	    if (sc -> sc_new_entity) {
		free ((char *) sc -> sc_new_entity);
	        sc -> sc_new_entity = NULL;
	    }
	    if (sc -> sc_new_time) {
		oid_free (sc -> sc_new_time);
	        sc -> sc_new_time = NULL;
	    }
	    if (sc -> sc_new_dst_oid) {
		oid_free (sc -> sc_new_dst_oid);
		sc -> sc_new_dst_oid = NULL;
	    }
	    if (sc -> sc_new_src_oid) {
		oid_free (sc -> sc_new_src_oid);
		sc -> sc_new_src_oid = NULL;
	    }
	    if (sc -> sc_new_ctx) {
		oid_free (sc -> sc_new_ctx);
	        sc -> sc_new_ctx = NULL;
	    }
	    sc -> sc_new_status = sc -> sc_new_storage = 0;
	    break;
    }

    return int_SNMP_error__status_noError;
}

/*  */

static struct snmp_context *get_context_entry (ip, len, isnext)
register unsigned int *ip;
int	len,
	isnext;
{
    register struct snmp_context *sc;

    for (sc = contextHead; sc; sc = sc -> sc_next)
	switch (elem_cmp (sc -> sc_identity -> oid_elements,
			  sc -> sc_identity -> oid_nelem, ip, len)) {
	    case 0:
	        if (!isnext)
		    return sc;
		if ((sc = sc -> sc_next) == NULL)
		    return NULL;
		/* else fall... */

	    case 1:
		return (isnext ? sc : NULL);
	}

    return NULL;
}

/*  */

struct snmp_access *get_access_entry ();


static int  o_access (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register unsigned int *ip,
			  *jp;
    register struct snmp_access *sa;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((sa = get_access_entry (oid -> oid_elements
					    + ot -> ot_name -> oid_nelem,
					oid -> oid_nelem
					    - ot -> ot_name -> oid_nelem,
					0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem < ot -> ot_name -> oid_nelem)
		return NOTOK;
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((sa = accessHead) == NULL)
		    return NOTOK;

		jp = sa -> sa_instance.oid_elements;
		i = sa -> sa_instance.oid_nelem;

		if ((new = oid_extend (oid, i)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - i;
		for (; i > 0; i--)
		    *ip++ = *jp++;
		
		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else {
		int	j;

		if ((sa = get_access_entry (oid -> oid_elements
					        + ot -> ot_name -> oid_nelem,
					    j = oid -> oid_nelem
					        - ot -> ot_name -> oid_nelem,
					    1)) == NULL)
		    return NOTOK;
		i = sa -> sa_instance.oid_nelem;

		if ((i = j - i) < 0) {
		    OID	    new;

		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		jp = sa -> sa_instance.oid_elements;
		i = sa -> sa_instance.oid_nelem;
		for (; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case aclPrivileges:
	    return o_integer (oi, v, sa -> sa_privileges);

	case aclStorageType:
	    return o_integer (oi, v, sa -> sa_storage);

	case aclStatus:
	    return o_integer (oi, v, sa -> sa_status);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

/* ARGSUSED */

static int  s_access (oi, v, offset, idx)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset,
	idx;
{
    register int    i;
    int	    ifvar,
	    result;
    register struct snmp_access *sa;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    register OS	    os = ot -> ot_syntax;
    caddr_t value;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_set__request:
	case type_SNMP_PDUs_commit:
	case type_SNMP_PDUs_rollback:
	    if ((i = oid -> oid_nelem - ot -> ot_name -> oid_nelem) <= 0)
		return int_SNMP_error__status_noSuchName;
	    if (sa = get_access_entry (oid -> oid_elements
				           + ot -> ot_name -> oid_nelem, i, 0))
		break;
	    if (offset != type_SNMP_PDUs_set__request)
		return int_SNMP_error__status_noError;

	    if (i != 3)
		return int_SNMP_error__status_noSuchName;

	    if ((sa = (struct snmp_access *) calloc (1, sizeof *sa)) == NULL) {
no_mem: ;
		result = int_SNMP_error__status_genErr;
		advise (LLOG_EXCEPTIONS, NULLCP,
			"out of memory creating new access entry");

losing: ;
		if (sa)
		    free_access_aux (sa, 0);
		return result;
	    }
	    if (make_oid (oid, &sa -> sa_instance, ot -> ot_name -> oid_nelem,
			  i) == NOTOK)
		goto no_mem;
	    {
		register unsigned int *ip;

		result = int_SNMP_error__status_inconsistentName;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		if (!(sa -> sa_target =
		          index_party_aux (sa -> sa_target_index = *ip++,
						EITHER, 0)))
		    goto losing;

		if (!(sa -> sa_subject =
		          index_party_aux (sa -> sa_subject_index = *ip++,
					   EITHER, 0)))
		    goto losing;

		if (!(sa -> sa_resources =
		          index_context_aux (sa -> sa_resources_index = *ip,
					     0)))
		    goto losing;

		if (sa -> sa_target -> party_authProt
		        != sa -> sa_subject -> party_authProt)
		    goto losing;
	    }
	    sa -> sa_privileges = sa -> sa_new_privileges = PARTY_PRIV_GET
							  | PARTY_PRIV_NEXT
							  | PARTY_PRIV_BULK;
	    sa -> sa_status = ROW_ACTIVE;
	    sa -> sa_storage = STORAGE_NONVOLATILE;
	    sa -> sa_fresh = 1;
	    {
		register struct snmp_access  *ap,
					    **app;

		for (app = &accessHead; ap = *app; app = &ap -> sa_next)
		    if (oid_cmp (&ap -> sa_instance, &sa -> sa_instance) > 0)
			break;
		sa -> sa_next = ap;
		*app = sa;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if (os == NULLOS) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"no syntax defined for object \"%s\"", ot -> ot_text);
	return int_SNMP_error__status_genErr;
    }

    switch (offset) {
	case type_SNMP_PDUs_set__request:
	    switch (ifvar) {
		case aclPrivileges:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    if (i < 0 || i > 255)
			return int_SNMP_error__status_wrongValue;
		    if (sa -> sa_fresh)
			sa -> sa_privileges = i;
		    sa -> sa_new_privileges = i; /* regardless of sa_fresh */
		    break;

		case aclStorageType:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case STORAGE_VOLATILE:
			case STORAGE_NONVOLATILE:
			    if (sa -> sa_fresh)
				sa -> sa_storage = i;
			    else
				sa -> sa_new_storage = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		case aclStatus:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case ROW_CREATEGO:
			    if (!sa -> sa_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    sa -> sa_status = ROW_ACTIVE;
			    break;

			case ROW_CREATEWAIT:
			    if (!sa -> sa_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    sa -> sa_status = ROW_NOTINSVC;
			    break;

			case ROW_ACTIVE:
			case ROW_NOTINSVC:
			    if (sa -> sa_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    sa -> sa_new_status = i;
			    break;

			case ROW_DESTROY:
			    if (sa -> sa_fresh)
				sa -> sa_status = i;
			    else
				sa -> sa_new_status = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		default:
		    return int_SNMP_error__status_noSuchName;
	    }
	    break;

	case type_SNMP_PDUs_commit:
	    if (sa -> sa_fresh) {
		sa -> sa_fresh = 0;

		access_changed = 1;
		break;
	    }
	    if (sa -> sa_new_privileges != sa -> sa_privileges) {
		sa -> sa_privileges = sa -> sa_new_privileges;

		access_changed = 1;
	    }
	    if (sa -> sa_new_status) {
		sa -> sa_status = sa -> sa_new_status;
		sa -> sa_new_status = 0;

		access_changed = 1;
	    }
	    if (sa -> sa_new_storage) {
		sa -> sa_storage = sa -> sa_new_storage;
		sa -> sa_new_storage = 0;

		access_changed = 1;
	    }
	    break;

	case type_SNMP_PDUs_rollback:
	    if (sa -> sa_fresh) {
		free_access (sa);
		break;
	    }
	    sa -> sa_new_privileges = sa -> sa_privileges;
	    sa -> sa_new_status = sa -> sa_new_storage = 0;
	    break;
    }

    return int_SNMP_error__status_noError;
}

/*  */

static struct snmp_access *get_access_entry (ip, len, isnext)
register unsigned int *ip;
int	len,
	isnext;
{
    register struct snmp_access *sa;

    for (sa = accessHead; sa; sa = sa -> sa_next)
	switch (elem_cmp (sa -> sa_instance.oid_elements,
			  sa -> sa_instance.oid_nelem, ip, len)) {
	    case 0:
	        if (!isnext)
		    return sa;
		if ((sa = sa -> sa_next) == NULL)
		    return NULL;
		/* else fall... */

	    case 1:
		return (isnext ? sa : NULL);
	}

    return NULL;
}

/*  */

#define	viewIndex	0
#define	viewSubtree	1
#define	viewMask	2
#define	viewType	3
#define	viewStorageType	4
#define	viewStatus	5


struct snmp_view *get_view_entry ();


static int  o_view (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register unsigned int *ip,
			  *jp;
    register struct snmp_view *vu;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    if (oid -> oid_nelem <= ot -> ot_name -> oid_nelem)
		return int_SNMP_error__status_noSuchName;
	    if ((vu = get_view_entry (oid -> oid_elements
				          + ot -> ot_name -> oid_nelem,
				      oid -> oid_nelem
				          - ot -> ot_name -> oid_nelem,
				      0)) == NULL)
		return int_SNMP_error__status_noSuchName;
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (oid -> oid_nelem < ot -> ot_name -> oid_nelem)
		return NOTOK;
	    if (oid -> oid_nelem == ot -> ot_name -> oid_nelem) {
		OID	new;

		if ((vu = viewHead) == NULL)
		    return NOTOK;

		jp = vu -> vu_instance.oid_elements;
		i = vu -> vu_instance.oid_nelem;

		if ((new = oid_extend (oid, i)) == NULLOID)
		    return NOTOK;
		ip = new -> oid_elements + new -> oid_nelem - i;
		for (; i > 0; i--)
		    *ip++ = *jp++;
		
		if (v -> name)
		    free_SNMP_ObjectName (v -> name);
		v -> name = new;
	    }
	    else {
		int	j;

		if ((vu = get_view_entry (oid -> oid_elements
					      + ot -> ot_name -> oid_nelem,
					  j = oid -> oid_nelem
					      - ot -> ot_name -> oid_nelem,
					  1)) == NULL)
		    return NOTOK;
		i = vu -> vu_instance.oid_nelem;

		if ((i = j - i) < 0) {
		    OID	    new;

		    if ((new = oid_extend (oid, -i)) == NULLOID)
			return NOTOK;
		    if (v -> name)
			free_SNMP_ObjectName (v -> name);
		    v -> name = new;

		    oid = new;
		}
		else
		    if (i > 0)
			oid -> oid_nelem -= i;

		ip = oid -> oid_elements + ot -> ot_name -> oid_nelem;
		jp = vu -> vu_instance.oid_elements;
		i = vu -> vu_instance.oid_nelem;
		for (; i > 0; i--)
		    *ip++ = *jp++;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    switch (ifvar) {
	case viewMask:
	    if (vu -> vu_mask)
		return o_string (oi, v, vu -> vu_mask -> qb_forw -> qb_data,
				 vu -> vu_mask -> qb_len);
	    else
		return o_string (oi, v, "", 0);

	case viewType:
	    return o_integer (oi, v, vu -> vu_type);

	case viewStorageType:
	    return o_integer (oi, v, vu -> vu_storage);

	case viewStatus:
	    return o_integer (oi, v, vu -> vu_status);

	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static int  s_view (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    register int    i;
    int	    ifvar;
    register struct snmp_view *vu;
    register OID    oid = oi -> oi_name;
    register OT	    ot = oi -> oi_type;
    register OS	    os = ot -> ot_syntax;
    caddr_t value;
    struct qbuf *qb;

    ifvar = (int) ot -> ot_info;
    switch (offset) {
	case type_SNMP_PDUs_set__request:
	case type_SNMP_PDUs_commit:
	case type_SNMP_PDUs_rollback:
	    if ((i = oid -> oid_nelem - ot -> ot_name -> oid_nelem) <= 0)
		return int_SNMP_error__status_noSuchName;
	    if (vu = get_view_entry (oid -> oid_elements
				         + ot -> ot_name -> oid_nelem, i, 0))
		break;
	    if (offset != type_SNMP_PDUs_set__request)
		return int_SNMP_error__status_noError;

	    if (i < 3)
		return int_SNMP_error__status_noSuchName;

	    if ((vu = (struct snmp_view *) calloc (1, sizeof *vu)) == NULL
		    || (vu -> vu_subtree =
			        (OID) calloc (1, sizeof *vu -> vu_subtree))
			    == NULL) {
		advise (LLOG_EXCEPTIONS, NULLCP,
			"out of memory creating new view entry");

losing: ;
		if (vu)
		    free_view_aux (vu, 0);
		return int_SNMP_error__status_genErr;
	    }
	    if (make_oid (oid, &vu -> vu_instance, ot -> ot_name -> oid_nelem,
			  i) == NOTOK
		    || make_oid (oid, vu -> vu_subtree,
				 ot -> ot_name -> oid_nelem + 1, i - 1)
				== NOTOK)
		goto losing;
	    vu -> vu_index = oid -> oid_elements[ot -> ot_name -> oid_nelem];
	    vu -> vu_type = VIEW_INCLUDED;
	    vu -> vu_status = ROW_ACTIVE;
	    vu -> vu_storage = STORAGE_NONVOLATILE;
	    vu -> vu_fresh = 1;
	    {
		register struct snmp_view  *vp,
					  **vpp;

		for (vpp = &viewHead; vp = *vpp; vpp = &vp -> vu_next)
		    if (oid_cmp (&vp -> vu_instance, &vu -> vu_instance) > 0)
			break;
		vu -> vu_next = vp;
		*vpp = vu;
	    }
	    break;

	default:
	    return int_SNMP_error__status_genErr;
    }

    if (os == NULLOS) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"no syntax defined for object \"%s\"", ot -> ot_text);
	return int_SNMP_error__status_genErr;
    }

    switch (offset) {
	case type_SNMP_PDUs_set__request:
	    switch (ifvar) {
		case viewMask:
		    if ((*os -> os_decode) ((caddr_t) &qb, v -> value)
			    == NOTOK)
			return v -> value -> pe_errno;
		    if (qb -> qb_forw -> qb_forw != qb
			    || qb -> qb_len > 16) {
			(*os -> os_free) ((caddr_t) qb);
			return int_SNMP_error__status_wrongLength;
		    }
		    if (vu -> vu_fresh) {
			if (vu -> vu_mask)
			    qb_free (vu -> vu_mask);
			vu -> vu_mask = qb;
		    }
		    else {
			if (vu -> vu_new_mask)
			    qb_free (vu -> vu_new_mask);
			vu -> vu_new_mask = qb;
		    }
		    break;

		case viewType:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case VIEW_INCLUDED:
			case VIEW_EXCLUDED:
			    if (vu -> vu_fresh)
				vu -> vu_type = i;
			    else
				vu -> vu_new_type = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		case viewStorageType:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case STORAGE_VOLATILE:
			case STORAGE_NONVOLATILE:
			    if (vu -> vu_fresh)
				vu -> vu_storage = i;
			    else
				vu -> vu_new_storage = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		case viewStatus:
		    if ((*os -> os_decode) (&value, v -> value) == NOTOK)
			return v -> value -> pe_errno;
		    i = *((integer *) value);
		    (*os -> os_free) (value);
		    switch (i) {
			case ROW_CREATEGO:
			    if (!vu -> vu_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    vu -> vu_status = ROW_ACTIVE;
			    break;

			case ROW_CREATEWAIT:
			    if (!vu -> vu_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    vu -> vu_status = ROW_NOTINSVC;
			    break;

			case ROW_ACTIVE:
			case ROW_NOTINSVC:
			    if (vu -> vu_fresh)
				return int_SNMP_error__status_inconsistentValue;
			    vu -> vu_new_status = i;
			    break;

			case ROW_DESTROY:
			    if (vu -> vu_fresh)
				vu -> vu_status = i;
			    else
				vu -> vu_new_status = i;
			    break;

			default:
			    return int_SNMP_error__status_wrongValue;
		    }
		    break;

		default:
		    return int_SNMP_error__status_noSuchName;
	    }
	    break;

	case type_SNMP_PDUs_commit:
	    if (vu -> vu_fresh) {
		vu -> vu_fresh = 0;

		view_changed = 1;
		break;
	    }

	    if (vu -> vu_new_mask) {
		if (vu -> vu_mask)
		    qb_free (vu -> vu_mask);
		vu -> vu_mask = vu -> vu_new_mask;
		vu -> vu_new_mask = NULL;

		view_changed = 1;
	    }
	    if (vu -> vu_new_type) {
		vu -> vu_type = vu -> vu_new_type;
		vu -> vu_new_type = 0;

		view_changed = 1;
	    }
	    if (vu -> vu_new_status) {
		vu -> vu_status = vu -> vu_new_status;
		vu -> vu_new_status = 0;

		view_changed = 1;
	    }
	    if (vu -> vu_new_storage) {
		vu -> vu_storage = vu -> vu_new_storage;
		vu -> vu_new_storage = 0;

		view_changed = 1;
	    }
	    break;

	case type_SNMP_PDUs_rollback:
	    if (vu -> vu_fresh) {
		free_view (vu);
		break;
	    }
	    if (vu -> vu_new_mask)
		qb_free (vu -> vu_new_mask), vu -> vu_new_mask = NULL;
	    vu -> vu_new_type = 0;
	    vu -> vu_new_status = vu -> vu_new_storage = 0;
	    break;
    }

    return int_SNMP_error__status_noError;
}

/*  */

static struct snmp_view *get_view_entry (ip, len, isnext)
register unsigned int *ip;
int	len,
	isnext;
{
    register struct snmp_view *vu;

    for (vu = viewHead; vu; vu = vu -> vu_next)
	switch (elem_cmp (vu -> vu_instance.oid_elements,
			  vu -> vu_instance.oid_nelem, ip, len)) {
	    case 0:
	        if (!isnext)
		    return vu;
		if ((vu = vu -> vu_next) == NULL)
		    return NULL;
		/* else fall... */

	    case 1:
		return (isnext ? vu : NULL);
	}

    return NULL;
}

/*  */

static int  make_oid (oid, new, offset, len)
OID	oid,
	new;
int	offset,
	len;
{
    new -> oid_nelem = len;
    if ((new -> oid_elements = (unsigned int *)
					calloc ((unsigned int) len,
						sizeof *new -> oid_elements))
	    == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"out of memory creating new instance");
	return NOTOK;
    }

    bcopy ((char *) (oid -> oid_elements + offset),
	   (char *) new -> oid_elements,
	   len * sizeof *oid -> oid_elements);

    return OK;
}

/*  */

static struct objreg party_objects[] = {
    "partyIndex",		(caddr_t) partyIndex,
    "partyTDomain",		(caddr_t) partyTDomain,
    "partyTAddress",		(caddr_t) partyTAddress,
    "partyMaxMessageSize",	(caddr_t) partyMaxMessageSize,
    "partyLocal",		(caddr_t) partyLocal,
    "partyAuthProtocol",	(caddr_t) partyAuthProtocol,
    "partyAuthClock",		(caddr_t) partyAuthClock,
    "partyAuthPrivate",		(caddr_t) partyAuthPrivate,
    "partyAuthPublic",		(caddr_t) partyAuthPublic,
    "partyAuthLifetime",	(caddr_t) partyAuthLifetime,
    "partyPrivProtocol",	(caddr_t) partyPrivProtocol,
    "partyPrivPrivate",		(caddr_t) partyPrivPrivate,
    "partyPrivPublic",		(caddr_t) partyPrivPublic,
    "partyCloneFrom",		(caddr_t) partyCloneFrom,
    "partyStorageType",		(caddr_t) partyStorageType,
    "partyStatus",		(caddr_t) partyStatus,
    "snmpTrapNumbers",		(caddr_t) snmpTrapNumbers,
#ifdef	MAGIC
    "iSODEPartyTestMode",       (caddr_t) partyTestMode,
#endif

    NULL
};

#ifdef	MAGIC
static struct objreg test_objects[] = {
    "iSODETestIndex",    	(caddr_t) testIndex,
    "iSODETestInteger",    	(caddr_t) testInteger,
    "iSODETestString",     	(caddr_t) testString,

    NULL
};
#endif

static struct objreg context_objects[] = {
    "iSODEContextName",		(caddr_t) contextName,
    "contextIndex",		(caddr_t) contextIndex,
    "contextLocal",		(caddr_t) contextLocal,
    "contextViewIndex",		(caddr_t) contextViewIndex,
    "contextLocalEntity",	(caddr_t) contextLocalEntity,
    "contextLocalTime",		(caddr_t) contextLocalTime,
    "contextProxyDstParty",	(caddr_t) contextProxyDstParty,
    "contextProxySrcParty",	(caddr_t) contextProxySrcParty,
    "contextProxyContext",	(caddr_t) contextProxyContext,
    "contextStorageType",	(caddr_t) contextStorageType,
    "contextStatus",		(caddr_t) contextStatus,
    "contextLocalEntity",	(caddr_t) contextLocalEntity,

    NULL
};

static struct objreg access_objects[] = {
    "aclPrivileges",		(caddr_t) aclPrivileges,
    "aclStorageType",		(caddr_t) aclStorageType,
    "aclStatus",		(caddr_t) aclStatus,

    NULL
};

static struct objreg view_objects[] = {
    "viewMask",			(caddr_t) viewMask,
    "viewType",			(caddr_t) viewType,
    "viewStorageType",		(caddr_t) viewStorageType,
    "viewStatus",		(caddr_t) viewStatus,

    NULL
};


init_partymib () {
    register OT	    ot;

    register_objects (party_objects, o_party, s_party);
    if (ot = text2obj ("partyIndex"))
	ot -> ot_setfnx = NULLIFP;
    if (ot = text2obj ("snmpTrapNumbers"))
	ot -> ot_setfnx = NULLIFP;
    
#ifdef	MAGIC
    register_objects (test_objects, o_test, NULLIFP);
#endif

    register_objects (context_objects, o_context, s_context);
    if (ot = text2obj ("contextIndex"))
	ot -> ot_setfnx = NULLIFP;

    register_objects (access_objects, o_access, s_access);

    register_objects (view_objects, o_view, s_view);
}
