/* snmpd.c - 4BSD/ISODE SNMPv2 agent */

/* Someday add sets for these objects...
	tcpConnState
	clnp route table
	clnp es-is table
 */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/*
 * $Header$
 *
 * Originally contributed by NYSERNet Inc.  This work was partially supported
 * by the U.S. Defense Advanced Research Projects Agency and the Rome Air
 * Development Center of the U.S. Air Force Systems Command under contract
 * number F30602-88-C-0016.
 *
 *
 * $Log$
 */

/*
 *			  ISODE 8.0 NOTICE
 *
 *   Acquisition, use, and distribution of this module and related
 *   materials are subject to the restrictions of a license agreement.
 *   Consult the Preface in the User's Manual for the full terms of
 *   this agreement.
 *
 *
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <varargs.h>
#include "mib.h"
#include "party.h"
#include "snmp-g.h"
#include "sys.file.h"
#include <sys/stat.h>
#include "tailor.h"

#include "dgram.h"
#ifdef	TCP
#include "internet.h"
#endif


#define	EQUIV
#undef	SIGDEBUG

/*    DATA */

static	int	cflag = 0;
	int	debug = 0;
static	int	ddebug = 0;
#ifdef	MAGIC
	int	mmagic = 0;
#endif
	int	tooBig = MAXDGRAM;
static	int	nbits = FD_SETSIZE;
static	int	rflag = 0;

static	char	sfile[BUFSIZ];
static	char   *spath;
static	char  **sargv;


#define	LLOG_XXX	(LLOG_PDUS | LLOG_DEBUG)

static LLog _pgm_log = {
    "snmpd.log",
    NULLCP, NULLCP, LLOG_FATAL | LLOG_EXCEPTIONS | LLOG_NOTICE,
    LLOG_FATAL, -1, LLOGCLS | LLOGCRT | LLOGZER, NOTOK
};
static LLog *pgm_log = &_pgm_log;

static char *myname = "snmpd";


#ifdef	SIGDEBUG
static	int	didhup = OK;

SFD	hupser ();
#endif

void	adios (), advise ();


/* COMMUNICATIONS */

int	nd = NOTOK;

#ifdef	TCP
static	int	udp = NOTOK;
#endif

static char	source[BUFSIZ];


/* PARTIES */

#define	UDPaddress_OK(p) \
    ((p) -> party_TAddress_len == 6 \
         && ((p) -> party_TAddress[0] != 0 \
	         || (p) -> party_TAddress[1] != 0 \
	         || (p) -> party_TAddress[2] != 0 \
	         || (p) -> party_TAddress[3] != 0) \
         && ((p) -> party_TAddress[4] != 0 \
	         || (p) -> party_TAddress[5] != 0))

#define	snmpUDPDomain_OK(p) \
    ((p) -> party_tDomain == SNMPUDPDOMAIN && UDPaddress_OK (p))

#define	rfc1157Domain_OK(p) \
    ((p) -> party_tDomain == RFC1157DOMAIN && UDPaddress_OK (p))


static	char   *aParty = NULL;
static	char   *pParty = "party";
static	struct snmp_party *myParty = NULL;

struct sockaddr *party2sa ();


/* OPERATIONS */

struct checklist *ckHead  = NULL;


	PE	unSpecified = NULLPE;
static	PE	noSuchObject = NULLPE;
static	PE	noSuchInstance = NULLPE;
static	PE	endOfMibView = NULLPE;

/* PROXY */

#define	NPQ	10

static struct proxyque {
    integer pq_quantum;
    int	    pq_age;

    struct sockaddr_in pq_isock;
    int	    pq_fd;
    int	    pq_maxsize;
    IFP	    pq_readfnx;
    IFP	    pq_writefnx;
    IFP	    pq_checkfnx;

    struct snmp_party *pq_proxyParty;
    struct snmp_party *pq_srcParty;
    struct snmp_party *pq_dstParty;
    struct snmp_context *pq_proxyContext;

    integer pq_request;
}	pips[NPQ];

static	int	pqs = 0;

static struct proxyque *pqr = NULL;


#ifdef	EQUIV
struct equiv {
    struct equiv *eq_next;

    char	 *eq_community;
    int		  eq_commlen;

    OID		  eq_target;
    OID		  eq_subject;
    OID		  eq_resources;
};

static struct equiv *eqHead = NULL;
#endif

/* TRAPS */

static	OID	snmpTrapOID = NULLOID;
static	OID	sysUpTime = NULLOID;
static	OID	snmpTrapEnterprise = NULLOID;
static	OID	coldStart = NULLOID;
static	OID	warmStart = NULLOID;
static	OID	linkDown = NULLOID;
static	OID	linkUp = NULLOID;
static	OID	authenticationFailure = NULLOID;
static	OID	egpNeighborLoss = NULLOID;

static struct trapname {
    char   *trap;
    OID	   *value;
}	trapnames[] = {
    "coldStart",	     &coldStart,
    "warmStart",	     &warmStart,
    "linkDown",		     &linkDown,
    "linkUp",		     &linkUp,
    "authenticationFailure", &authenticationFailure,
    "egpNeighborLoss",	     &egpNeighborLoss,
    "snmpTrapOID.0",	     &snmpTrapOID,
    "sysUpTime.0",	     &sysUpTime,
    "snmpTrapEnterprise.0",  &snmpTrapEnterprise,

    NULL
};


static	PS	audit = NULLPS;


extern int  errno;

/*    MAIN */

/* ARGSUSED */

main (argc, argv, envp)
int	argc;
char  **argv,
      **envp;
{
    int	    failed,
	    fd,
	    listening,
	    nfds;
    fd_set  ifds,
	    ufds;
    register struct snmp_party *p;
    struct sockaddr *sas;

    arginit (argv);
    envinit ();

    failed = listening = 0;
    nfds = 0;
    FD_ZERO (&ifds);
    FD_ZERO (&ufds);

    if (!myParty) {
	int	i;

	i = 0;
	for (p = partyHead; p; p = p -> party_next) {
	    if (p -> party_status != ROW_ACTIVE
		    || p -> party_location != AGENT)
		continue;

	    i++;
	}

	if ((sas = (struct sockaddr *) calloc ((unsigned) (i + 1),
					       sizeof *sas)) == NULL)
	    adios (NULLCP, "out of memory");
    }

    for (p = partyHead; p; p = p -> party_next) {
	register struct sockaddr *sa,
				 *pa;

	if (p -> party_status != ROW_ACTIVE
	        || p -> party_location != AGENT)
	    continue;
	if (myParty && myParty != p)
	    continue;

	pa = party2sa (p);
	if (!myParty) {
	    for (sa = sas; sa -> sa_family; sa++)
		if (bcmp ((char *) sa, (char *) pa, sizeof *pa) == 0)
		    break;
	    if (sa -> sa_family) {
		advise (LLOG_NOTICE, NULLCP,
			"listening for party %s (already)",
			oid2ode (p -> party_Identity));
		p -> party_MaxMessageSize = tooBig;
		continue;
	    }
	}

#ifdef	TCP
	if (!snmpUDPDomain_OK (p))
	    continue;

	if ((fd = start_udp_server ((struct sockaddr_in *) pa, 0, 0, 0))
	        == NOTOK) {
	    advise (LLOG_EXCEPTIONS, party_address (p), "party %s at",
		    oid2ode (p -> party_Identity));
	    failed++;
	    continue;
	}
	(void) ioctl (fd, FIOCLEX, NULLCP);
	if (fd >= nfds)
	    nfds = fd + 1;
	FD_SET (fd, &ifds);
	FD_SET (fd, &ufds);
	if (udp == NOTOK)
	    udp = fd;
	if (nd == NOTOK)
	    nd = udp;

	advise (LLOG_NOTICE, NULLCP, "listening for party %s at %s",
		oid2ode (p -> party_Identity), party_address (p));
	listening++;
	p -> party_MaxMessageSize = tooBig;
	if (!myParty)
	    *sa = *pa;	/* struct copy */
#endif
    }
    if (!listening)
	adios (NULLCP, failed ? "no successful listens"
			      : "no parties selected");

    send_traps (coldStart, (struct type_SNMP_VarBindList *) 0);

    for (;;) {
	int	action,
		secs;
	fd_set  rfds;

	secs = party_changed ? (5 * 60) : NOTOK;

	rfds = ifds;	/* struct copy */
	switch (xselect (nfds, &rfds, NULLFD, NULLFD, secs)) {
	    case NOTOK:
	        advise (LLOG_EXCEPTIONS, "failed", "xselect");
		continue;

	    case OK:
		if (party_changed && sync_party (pParty, AGENT, 0) == NOTOK)
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "stable storage suspect: %s", PY_pepy);
		continue;

	    default:
	        break;
	}

#ifdef	TCP
	for (fd = 0; fd < nfds; fd++)
	    if (FD_ISSET (fd, &ufds) && FD_ISSET (fd, &rfds))
		doit_udp (fd);
#endif

	switch (action = *((integer *) *agentAction)) {
	    case AGENT_OTHER:
	        break;

	    case AGENT_COLDSTART:
	    case AGENT_TERMINATE:
coldStart_trap: ;
		advise (LLOG_FATAL, NULLCP, "%s...",
			action == AGENT_COLDSTART ? "initiating coldStart"
						  : "I'll be back");
		if (sync_party (pParty, AGENT, action == AGENT_TERMINATE)
		        == NOTOK)
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "stable storage suspect: %s", PY_pepy);

#ifdef	TCP
		for (fd = 0; fd < nfds; fd++)
		    if (FD_ISSET (fd, &ufds)) {
			(void) close_udp_socket (fd);
			FD_CLR (fd, &ifds);
			FD_CLR (fd, &ufds);
		    }
#endif
		if (action == AGENT_TERMINATE)
		    exit (0);
		(void) execv (spath, sargv);
		adios (spath, "unable to execv");
		/* NOTREACHED */

	    case AGENT_DUMPARTYDB:
		if (sync_party (pParty, AGENT, 1) == NOTOK)
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "stable storage suspect: %s", PY_pepy);
		goto reset_action;

	    case AGENT_WARMSTART:
		if (gettimeofday (&my_boottime, (struct timezone *) 0)
		        == NOTOK) {
		    advise (LLOG_EXCEPTIONS, "failed", "gettimeofday");
		    bzero ((char *) &my_boottime, sizeof my_boottime);
		}
		send_traps (warmStart, (struct type_SNMP_VarBindList *) 0);
		goto reset_action;

	    case AGENT_DEBUGON:
		debug = 1;
		pgm_log -> ll_events |= LLOG_ALL;
		pgm_log -> ll_stat |= LLOGTTY;
		goto reset_action;

	    case AGENT_DEBUGOFF:
		debug = 0;
		pgm_log -> ll_events = LLOG_FATAL | LLOG_EXCEPTIONS
					    | LLOG_NOTICE;
		pgm_log -> ll_stat = LLOGCLS | LLOGCRT | LLOGZER | LLOGHDR;
		goto reset_action;

	    default:
		advise (LLOG_NOTICE, NULLCP, "agentAction reset from %d",
			*((integer *) *agentAction));
reset_action: ;
		*((integer *) *agentAction) = AGENT_OTHER;
		break;
	}

	if (party_changed && !myParty)
	    for (p = partyHead; p; p = p -> party_next)
		if (p -> party_status == ROW_ACTIVE
		        && p -> party_location == AGENT) {
		    register struct sockaddr *sa,
				             *pa;

		    pa = party2sa (p);
		    for (sa = sas; sa -> sa_family; sa++)
			if (bcmp ((char *) sa, (char *) pa, sizeof *pa) == 0)
			    break;
		    if (!sa -> sa_family) {
			action = AGENT_COLDSTART;
			goto coldStart_trap;
		    }
		}
    }
}

/*  */

static struct sockaddr *party2sa (p)
struct snmp_party *p;
{
    static struct sockaddr sas;
    register struct sockaddr_in *sin = (struct sockaddr_in *) &sas;

    bzero ((char *) sin, sizeof *sin);
    if (p -> party_tDomain == SNMPUDPDOMAIN
	    || p -> party_tDomain == RFC1157DOMAIN) {
	sin -> sin_family = AF_INET;
	bcopy ((char *) p -> party_TAddress, (char *) &sin -> sin_addr,
	       sizeof sin -> sin_addr);
	bcopy ((char *) (p -> party_TAddress + sizeof sin -> sin_addr),
	       (char *) &sin -> sin_port, sizeof sin -> sin_port);
    }

    return &sas;
}

/*    DOIT */

#ifdef	TCP
static	doit_udp (pd)
int	pd;
{
    int	    fd;
    struct sockaddr_in in_socket;
    register struct sockaddr_in *isock = &in_socket;

    if ((fd = join_udp_client (pd, isock)) == NOTOK) {
	if (errno == EWOULDBLOCK)
	    return;
	adios ("failed", "join_udp_client");
    }

    (void) sprintf (source, "%s/%d", inet_ntoa (isock -> sin_addr),
		    (int) ntohs (isock -> sin_port));

    pqr = NULL;
    doit_aux (fd, read_udp_socket, write_udp_socket, check_udp_socket);
    if (pqr) {
	pqr -> pq_isock = *isock;	/* struct copy */
	pqr -> pq_fd = udp;
	pqr -> pq_readfnx = read_udp_socket;
	pqr -> pq_writefnx = write_udp_socket;
	pqr -> pq_checkfnx = check_udp_socket;
    }

    (void) close_udp_socket (fd);
}
#endif

/*  */

static	doit_aux (fd, rfx, wfx, cfx)
int	fd;
IFP	rfx,
	wfx,
	cfx;
{
    int	    reason,
    	    size = 0;
    char   *cp = source + strlen (source);
    PE	    pe = NULL;
    PS	    ps = NULL;
    PS      qbufPS = NULL;
    struct snmp_party *dstParty,
		      *srcParty;
    struct snmp_context *context;
    struct type_SNMP_SnmpPrivMsg *privmsg = NULL;
    struct type_SNMP_SnmpAuthMsg *authmsg = NULL;
    struct qbuf *qb = NULL;

#ifdef	SIGDEBUG
    didhup = NOTOK;
#endif

    if ((ps = ps_alloc (dg_open)) == NULLPS
	    || dg_setup (ps, fd, tooBig, rfx, wfx, cfx) == NOTOK) {
	if (ps == NULLPS)
	    advise (LLOG_EXCEPTIONS, NULLCP, "ps_alloc(dg_open): failed (%s)",
		    source);
	else
	    advise (LLOG_EXCEPTIONS, NULLCP, "dg_setup: %s (%s)",
		    ps_error (ps -> ps_errno), source);

	goto out;
    }
    snmpstat.s_packets++;

    size = ps -> ps_byteno;
    if ((pe = ps2pe (ps)) == NULLPE) {
bad_parse: ;
	advise (LLOG_EXCEPTIONS, NULLCP, "ps2pe: %s (%s)",
		ps_error (ps -> ps_errno), source);
	snmpstat.s_encodingerrs++;
	goto out;
    }
    size = ps -> ps_byteno - size;
    advise (LLOG_XXX, NULLCP, "packet from %s", source);

    if (pe -> pe_class == PE_CLASS_UNIV && pe -> pe_id == PE_CONS_SEQ) {
#ifdef	TCP
	(void) proxy4 (pe, size, ps);
#else
	advise (LLOG_EXCEPTIONS, NULLCP, "30something message (%s)", source);
	snmpstat.s_30something++;
#endif
	goto out;
    }

    if (decode_SNMP_SnmpPrivMsg (pe, 1, NULLIP, NULLVP, &privmsg) == NOTOK) {
	advise (LLOG_EXCEPTIONS, NULLCP, "decode_SNMP_SnmpPrivMsg: %s (%s)",
		PY_pepy, source);
	snmpstat.s_encodingerrs++;
	goto out;
    }

    PLOGP (pgm_log,SNMP_SnmpPrivMsg, pe, "SnmpPrivMsg", 1);

    if ((dstParty = lookup_party (privmsg -> privDst, AGENT)) == NULLPARTY) {
	advise (LLOG_EXCEPTIONS, NULLCP, "bad dstParty: %s (%s)",
		oid2ode (privmsg -> privDst), source);
	snmpstat.s_unknowndstparties++;

bad_community: ;
	if (*((integer *) snmpstat.s_enableauthentraps) == TRAPS_ENABLED)
	    send_traps (authenticationFailure,
			(struct type_SNMP_VarBindList *) 0);
	goto out;
    }

    (void) sprintf (cp, " dst=%s", oid2ode (dstParty -> party_Identity));
    cp += strlen (cp);

    if ((qb = do_decryption (privmsg, dstParty)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, "error decrypting: %s (%s)",
		PY_pepy, source);
	goto out;
    }

    if ((qbufPS = ps_alloc (qbuf_open)) == NULLPS
	    || qbuf_setup (qbufPS, qb) == NOTOK) {
	if (qbufPS == NULLPS)
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "ps_alloc(qbuf_open): failed (%s)", source);
	else
	    advise (LLOG_EXCEPTIONS, NULLCP, "qbuf_setup: %s (%s)",
		    ps_error (ps -> ps_errno), source);

	goto out;
    }

    if (pe)
	pe_free (pe), pe = NULLPE;

    if ((pe = ps2pe (qbufPS)) == NULLPE)
	goto bad_parse;
    do_decryption_fixup (privmsg, qb);

    if (decode_SNMP_SnmpAuthMsg (pe, 1, NULLIP, NULLVP, &authmsg) == NOTOK) {
	advise (LLOG_EXCEPTIONS, NULLCP, "decode_SNMP_SnmpAuthMsg: %s (%s)",
		PY_pepy, source);
	if (authmsg)
	    free_SNMP_SnmpAuthMsg (authmsg), authmsg = NULL;
        goto out;
    }
    
    PLOGP (pgm_log,SNMP_SnmpAuthMsg, pe, "SnmpAuthMsg", 1);

    if ((srcParty = lookup_party (authmsg -> authData -> srcParty, MANAGER))
	    == NULLPARTY) {
	advise (LLOG_EXCEPTIONS, NULLCP, "bad srcParty: %s (%s)",
		oid2ode (authmsg -> authData -> srcParty), source);
	snmpstat.s_unknownsrcparties++;
	goto bad_community;
    }

    if (authenticate_incoming (privmsg, authmsg, srcParty, dstParty, &reason)
	    == NOTOK) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"authentication failure: %s for party %s (%s)",
		PY_pepy, oid2ode (srcParty -> party_Identity), source);
	switch (reason) {
	    case AUTH_MISMATCH:
	        snmpstat.s_dstpartymismatches++;
	        break;

	    case AUTH_WRONGAUTH:
	        snmpstat.s_badauths++;
	        break;

	    case AUTH_LIFETIME:
	        snmpstat.s_notinlifetimes++;
		break;

	    case AUTH_DIGEST:
	        snmpstat.s_wrongdigestvalues++;
		break;

	    default:
		break;
	}
	goto bad_community;
    }

    (void) sprintf (cp, " src=%s", oid2ode (srcParty -> party_Identity));
    cp += strlen (cp);

    if ((context = lookup_context (authmsg -> authData -> context)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, "bad context: %s (%s)",
		oid2ode (authmsg -> authData -> context), source);
	snmpstat.s_unknowncontexts++;
	goto bad_community;
    }

    (void) sprintf (cp, " ctx=%s", oid2ode (context -> sc_identity));
    cp += strlen (cp);

    if (debug) {
	advise (LLOG_DEBUG, NULLCP, "srcParty:  %s",
		oid2ode (srcParty -> party_Identity));
	advise (LLOG_DEBUG, NULLCP, "dstParty:  %s",
		oid2ode (dstParty -> party_Identity));
	advise (LLOG_DEBUG, NULLCP, "context:   %s",
		oid2ode (context -> sc_identity));
    }

#ifdef	MAGIC
    magicommand = dstParty -> party_testmode;
#endif
    if (do_operation (authmsg, size, srcParty, dstParty, context, 0) == DONE) {
	(void) send_message (ps, authmsg, dstParty, srcParty,
			     context -> sc_identity);
#ifdef	MAGIC
	switch (magicommand) {
	    case MAGIC_SENDGET:
	        authmsg -> authData -> pdu -> offset =
						type_SNMP_PDUs_get__request;
		goto unexpected_pdu;

	    case MAGIC_SENDNEXT:
		authmsg -> authData -> pdu -> offset =
					    type_SNMP_PDUs_get__next__request;
		goto unexpected_pdu;

	    case MAGIC_SENDSET:
		authmsg -> authData -> pdu -> offset =
						type_SNMP_PDUs_set__request;
		goto unexpected_pdu;

	    case MAGIC_SENDXXX:
		authmsg -> authData -> pdu -> offset =
						type_SNMP_PDUs_xxx;
unexpected_pdu: ;
		(void) send_message (ps, authmsg, dstParty, srcParty,
				     context -> sc_identity);
		break;

	    default:
		break;
	}
#endif
    }
#ifdef	MAGIC
    magicommand = MAGIC_NONE;
#endif

out: ;
    if (ps)
	ps_free (ps);
    if (pe)
	pe_free (pe);
    if (qbufPS)
	ps_free (qbufPS);
    if (qb)
	qb_free (qb);
    if (privmsg)
	free_SNMP_SnmpPrivMsg (privmsg);
    if (authmsg) {
	if (authmsg -> authData -> pdu -> offset != type_SNMP_PDUs_trap) {
/* BEGIN MOBY PEPSY HACK... */
	    register struct type_SNMP_VarBindList *vp =
			authmsg -> authData -> pdu -> un.get__request
						   -> variable__bindings;

	    free_SNMP_VarBindList (vp);
	    authmsg -> authData -> pdu -> un.get__request -> variable__bindings
									= NULL;
/* END MOBY PEPSY HACK... */
	}

	free_SNMP_SnmpAuthMsg (authmsg);
    }

#ifdef	SIGDEBUG
    hupser (SIGHUP);
#endif
}

/*  */

static int  send_message (ps, msg, srcParty, dstParty, ctx)
PS	ps;
register struct type_SNMP_SnmpAuthMsg *msg;
register struct snmp_party *srcParty,
			   *dstParty;
OID	ctx;
{
    int	    result = NOTOK;
    struct qbuf *qb;
    struct type_SNMP_SnmpPrivMsg *privmsg = NULL;
    PE	    pe = NULLPE;

    if (msg -> authData -> srcParty)
	oid_free (msg -> authData -> srcParty);
    if ((msg -> authData -> srcParty = oid_cpy (srcParty -> party_Identity))
	    == NULL) {
no_mem: ;
	advise (LLOG_EXCEPTIONS, NULLCP, "out of memory");
	goto out;
    }
    if (msg -> authData -> dstParty)
	oid_free (msg -> authData -> dstParty);
    if ((msg -> authData -> dstParty = oid_cpy (dstParty -> party_Identity))
	    == NULL)
	goto no_mem;
    if (msg -> authData -> context)
	oid_free (msg -> authData -> context);
    if ((msg -> authData -> context = oid_cpy (ctx)) == NULL)
	goto no_mem;

    if ((qb = generate_outgoing_auth (msg, srcParty, dstParty,
				      (caddr_t) pgm_log)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, 
		"error generating outgoing authentication: %s (%s)", PY_pepy,
		source);
	goto out;
    }
    if (ps == NULLPS) {
	qb_free (qb);
	return DONE;
    }

    if ((privmsg = (struct type_SNMP_SnmpPrivMsg *) calloc (1,
							    sizeof *privmsg))
		== NULL
	    || (privmsg -> privDst = oid_cpy (dstParty -> party_Identity))
		    == NULLOID) {
	qb_free (qb);
	goto no_mem;
    }	
    privmsg -> privData = qb;

    if (do_encryption (privmsg, dstParty) == NOTOK) {
	advise (LLOG_EXCEPTIONS, NULLCP, "error encrypting: %s (%s)", PY_pepy,
		source);
	goto out;
    }

    if (encode_SNMP_SnmpPrivMsg (&pe, 1, 0, NULLCP, privmsg) != NOTOK) {
	PLOGP (pgm_log,SNMP_SnmpPrivMsg, pe, "SnmpPrivMsg", 0);

       if (pe2ps (ps, pe) == NOTOK)
	   advise (LLOG_EXCEPTIONS, NULLCP, "pe2ps: %s (%s)",
		   ps_error (ps -> ps_errno), source);
       else
	   result = OK;
    }
    else
	advise (LLOG_EXCEPTIONS, NULLCP, "encode_SNMP_SnmpPrivMsg: %s (%s)",
		PY_pepy, source);

out: ;
    if (pe)
	pe_free (pe);

    if (privmsg)
	free_SNMP_SnmpPrivMsg (privmsg);

    return result;
}

/*    OPERATION */

#ifndef	EQUIV
/* ARGSUSED */
#endif

static int  do_operation (msg, size, srcParty, dstParty, context, equivP)
struct type_SNMP_SnmpAuthMsg *msg;
int	size;
struct snmp_party *srcParty,
		  *dstParty;
struct snmp_context *context;
int	equivP;
{
    int	    idx,
	    maxsize,
	    offset;
    register struct snmp_access *sa;
    register struct type_SNMP_PDUs *pdu = msg -> authData -> pdu;
    register struct type_SNMP_VarBindList *vp;
    struct type_SNMP_VarBindList *op = NULL;
    register struct type_SNMP_Response__PDU *parm = pdu -> un.response;

    idx = 0;
    for (sa = dstParty -> party_access; sa; ) {
	if (sa -> sa_status == ROW_ACTIVE
	        && sa -> sa_subject == srcParty
	        && sa -> sa_resources == context)
	    break;
	if ((sa = sa -> sa_next) && sa -> sa_target != dstParty)
	    goto access_denied;
    }
    if (!sa)
	goto access_denied;

    switch (pdu -> offset) {
	case type_SNMP_PDUs_get__request:
	    if (!(sa -> sa_privileges & PARTY_PRIV_GET)) {
access_denied: ;
		advise (LLOG_EXCEPTIONS, NULLCP,
			"authorizationError: %d (%s)", pdu -> offset, source);
/* no trap for this... */
		offset = pdu -> offset;
		pdu -> offset = type_SNMP_PDUs_response;
		parm -> error__status =
				    int_SNMP_error__status_authorizationError;
		goto out;
	    }
	    break;

	case type_SNMP_PDUs_get__next__request:
	    if (!(sa -> sa_privileges & PARTY_PRIV_NEXT))
		goto access_denied;
	    break;

	case type_SNMP_PDUs_get__bulk__request:
	    if (!(sa -> sa_privileges & PARTY_PRIV_BULK))
		goto access_denied;
	    break;

	case type_SNMP_PDUs_set__request:
	    if (!(sa -> sa_privileges & PARTY_PRIV_SET))
		goto access_denied;
	    break;

	case type_SNMP_PDUs_response:
	    if (!(sa -> sa_privileges & PARTY_PRIV_RESP)) {
access_silently_denied: ;
		advise (LLOG_EXCEPTIONS, NULLCP,
			"authorizationError: %d (%s)", pdu -> offset, source);
/* no trap for this... */
		snmpstat.s_badoperations++;
		return OK;
	    }
	    break;

	case type_SNMP_PDUs_inform__request:
	    if (!(sa -> sa_privileges & PARTY_PRIV_INFO))
		goto access_denied;
	    break;

	case type_SNMP_PDUs_snmpV2__trap:
	    if (!(sa -> sa_privileges & PARTY_PRIV_NTFY))
		goto access_silently_denied;
	    break;

	case type_SNMP_PDUs_trap:
	    if (!(sa -> sa_privileges & PARTY_PRIV_TRAP))
		goto access_silently_denied;
	    break;

	default:
bad_operation: ;
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "badOperation: %d (%s)", pdu -> offset, source);
	    snmpstat.s_badoperations++;
	    return NOTOK;
    }

    quantum++;

    if (context -> sc_view > 0)
	switch (pdu -> offset) {
	    case type_SNMP_PDUs_get__request:
	    case type_SNMP_PDUs_get__next__request:
	    case type_SNMP_PDUs_get__bulk__request:
	    case type_SNMP_PDUs_set__request:
	        if (context -> sc_location != AGENT) {
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "non-local context: %s (%s)",
			    oid2ode (context -> sc_identity), source);
		    snmpstat.s_unknowncontexts++;
		    if (*((integer *) snmpstat.s_enableauthentraps)
			    == TRAPS_ENABLED)
			send_traps (authenticationFailure,
				    (struct type_SNMP_VarBindList *) 0);
		    return NOTOK;
		}
	        break;

	    default:
	        goto bad_operation;
	}
    else
	switch (pdu -> offset) {
	    case type_SNMP_PDUs_get__request:
	    case type_SNMP_PDUs_get__next__request:
	    case type_SNMP_PDUs_get__bulk__request:
	    case type_SNMP_PDUs_set__request:
	    case type_SNMP_PDUs_inform__request:
	        return proxy1 (msg, srcParty, dstParty, context);

	    case type_SNMP_PDUs_response:
	        return proxy2 (msg);

	    case type_SNMP_PDUs_snmpV2__trap:
		return proxy3 (msg, srcParty, dstParty, context);

	    default:
	        goto bad_operation;
	}

    offset = pdu -> offset;
    pdu -> offset = type_SNMP_PDUs_response;

    maxsize = size;
    for (vp = parm -> variable__bindings; vp; vp = vp -> next)
	maxsize -= ps_get_abs_oid (vp -> VarBind -> name)
		        + ps_get_abs (vp -> VarBind -> value)
			+ 2;
    if (maxsize > srcParty -> party_MaxMessageSize || maxsize > tooBig) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"dropOperation: %d (%s) actual=%d minimal=%d remote=%d local=%d",
		pdu -> offset, source, size, maxsize,
		srcParty -> party_MaxMessageSize, tooBig);
	snmpstat.s_silentdrops++;
	return NOTOK;
    }
    if (size > srcParty -> party_MaxMessageSize || size > tooBig) {
	parm -> error__status = int_SNMP_error__status_tooBig;
	goto out;
    }

    {
	register struct type_SNMP_VarBindList **opp;

	opp = &op;
	for (vp = parm -> variable__bindings; vp; vp = vp -> next) {
	    register struct type_SNMP_VarBindList *bind;
	    register struct type_SNMP_VarBind *v;

	    if ((bind = (struct type_SNMP_VarBindList *)
					calloc (1, sizeof *bind)) == NULL) {
no_mem: ;
		free_SNMP_VarBindList (op);
		op = NULL;
		advise (LLOG_EXCEPTIONS, NULLCP, "out of memory");

		parm -> error__status = int_SNMP_error__status_genErr;
		goto out;
	    }
	    *opp = bind, opp = &bind -> next;

	    if ((v = (struct type_SNMP_VarBind *) calloc (1, sizeof *v))
		    == NULL)
		goto no_mem;
	    bind -> VarBind = v;

	    if ((v -> name = oid_cpy (vp -> VarBind -> name)) == NULLOID)
		goto no_mem;
	    (v -> value = vp -> VarBind -> value) -> pe_refcnt++;
	}
    }

    maxsize = tooBig <= srcParty -> party_MaxMessageSize
		    ? tooBig : srcParty -> party_MaxMessageSize;
    maxsize -= 8;

    switch (offset) {
	case type_SNMP_PDUs_get__request:
	case type_SNMP_PDUs_get__next__request:
	    parm -> error__status = int_SNMP_error__status_noError;
	    idx = do_pass (msg, offset, context);
	    break;

	case type_SNMP_PDUs_get__bulk__request:
	    {
		int	br,
			cnt,
			dr,
			mr,
			nr;
		register struct type_SNMP_VarBindList **vpp;
		struct type_SNMP_VarBindList *vb;

		if (parm -> error__index < 0)
		    parm -> error__index = 0;
		if (parm -> error__status < 0)
		    parm -> error__status = 0;

		mr = parm -> error__index - 1,
		br = (nr = parm -> error__status) + 1;
		if (idx = do_pass (msg, type_SNMP_PDUs_get__next__request,
				   context))
		    break;
		parm -> error__status = int_SNMP_error__status_noError;

		for (vp = op; vp; vp = vp -> next)
		    size -= ps_get_abs_oid (vp -> VarBind -> name)
				+ ps_get_abs (vp -> VarBind -> value);
		dr = 0;
		for (vpp = &parm -> variable__bindings;
		         vp = *vpp;
		         vpp = &vp -> next) {
		    if ((size += ps_get_abs_oid (vp -> VarBind -> name)
				    + ps_get_abs (vp -> VarBind -> value))
			    >= maxsize) {
			*vpp = NULL;
			free_SNMP_VarBindList (vp);
			break;
		    }
		    if (!dr
			    && vp -> VarBind -> value -> pe_class
				    != PE_CLASS_CONT)
			dr = 1;
		}
		if (!dr) {
		    if (debug)
			advise (LLOG_DEBUG, NULLCP,
				"all variable-bindings got exceptions");
		    break;
		}
		for (vpp = &parm -> variable__bindings;
		         (vp = *vpp) && nr-- > 0;
		         vpp = &vp -> next)
		    continue;
		if (!vp)
		    break;
		for (nr = 1;; nr++)
		    if (*(vpp = &((*vpp) -> next)) == NULL)
			break;
		mr *= nr;

		vb = parm -> variable__bindings, cnt = dr = 0;
		while (mr-- > 0) {
		    register struct type_SNMP_VarBindList *bind;
		    register struct type_SNMP_VarBind *v;

		    if ((bind = (struct type_SNMP_VarBindList *)
					calloc (1, sizeof *bind)) == NULL) {
			advise (LLOG_EXCEPTIONS, NULLCP,
				"out of memory in do_operation(1) (%s)",
				source);
			goto done_bulk;
		    }
		    if ((v = (struct type_SNMP_VarBind *)
					    calloc (1, sizeof *v)) == NULL) {
			advise (LLOG_EXCEPTIONS, NULLCP,
				"out of memory in do_operation(2) (%s)",
				source);
			free ((char *) bind);
			goto done_bulk;
		    }
		    bind -> VarBind = v;
		    if ((v -> name = oid_cpy (vp -> VarBind -> name))
			    == NULLOID) {
			advise (LLOG_EXCEPTIONS, NULLCP,
				"out of memory in do_operation(3) (%s)",
				source);
			free ((char *) v);
			free ((char *) bind);
			goto done_bulk;
		    }
		    (v -> value = vp -> VarBind -> value) -> pe_refcnt++;

		    *vpp = bind;

		    parm -> variable__bindings = bind;
		    if (idx = do_pass (msg, type_SNMP_PDUs_get__next__request,
				       context)) {
			idx = br + (nr > 1 ? cnt % nr : 0);
			goto done_bulk;
		    }
		    cnt++;

		    if ((size += ps_get_abs_oid (bind -> VarBind -> name)
			 	    + ps_get_abs (bind -> VarBind -> value)
				    + 2) >= maxsize) {
			if (debug)
			    advise (LLOG_DEBUG, NULLCP,
				    "reached size=%d (maxsize %d) on loop %d",
				    size, maxsize, cnt + 1);
			*vpp = NULL;
			free_SNMP_VarBindList (bind);
			goto done_bulk;
		    }

		    if (bind -> VarBind -> value -> pe_class == PE_CLASS_CONT){
			dr++;
			if (dr == nr) {
			    if (debug)
				advise (LLOG_DEBUG, NULLCP,
					"%d consecutive exceptions", dr);
			    goto done_bulk;
			}
		    }
		    else
			dr = 0;
		    vpp = &bind -> next, vp = vp -> next;
		}

done_bulk: ;
		parm -> variable__bindings = vb;
	    }
	    break;

	case type_SNMP_PDUs_set__request:
	    parm -> error__status = int_SNMP_error__status_noError;
	    if (idx = do_pass (msg, offset, context)) {
		int	status;

rollback: ;
		status = parm -> error__status;
/* someday check to see if rollback failed... */
		(void) do_pass (msg, type_SNMP_PDUs_rollback, context);
		parm -> error__status = status;
	    }
	    else {
		if (ckHead) {
		    int	    status = int_SNMP_error__status_noError;
		    register struct checklist *ck;

		    for (ck = ckHead; ck; ck = ck -> ck_next)
			if  (ck -> ck_fnx
			         && (status = (*ck -> ck_fnx) (ck))
					    != int_SNMP_error__status_noError)
			    break;
		    if  (status != int_SNMP_error__status_noError) {
			if ((parm -> error__status = status)
			        != int_SNMP_error__status_genErr)
			    idx = ck -> ck_idx;
			goto rollback;
		    }
		}

/* someday check to see if commit failed... */
		(void) do_pass (msg, type_SNMP_PDUs_commit, context);
		parm -> error__status = int_SNMP_error__status_noError;
	    }
	    (void) chekmem ((struct nlist *) 0);
	    if ((party_changed > 0
		 	|| context_changed
		 	|| access_changed
		 	|| view_changed)
		     && sync_party (pParty, AGENT, 0) == NOTOK)
		advise (LLOG_EXCEPTIONS, NULLCP,
			"stable storage suspect: %s", PY_pepy);
	    break;
    }
    if (ckHead) {
	register struct checklist *ck;
	struct checklist *ckp;

	for (ck = ckHead; ck; ck = ckp) {
	    ckp = ck -> ck_next;

	    free ((char *) ck);
	}
	ckHead = NULL;
    }

out: ;
#ifdef	MAGIC
    if (magicommand == MAGIC_SENDRESPONSE)
	parm -> request__id ^= 0xffffffff;
    else
	if (magicommand == MAGIC_TOOBIG)
	    maxsize = MAXSNMP / 2;
#endif
    parm -> error__index = idx;
    switch (parm -> error__status) {
	case int_SNMP_error__status_noError:
	    if (offset != type_SNMP_PDUs_get__bulk__request) {
#ifdef	MAGIC
		OID	new;
#endif

		if (equivP) {
		    for (vp = parm -> variable__bindings, idx = 1;
			    vp;
			    vp = vp -> next, idx++)
			if (vp -> VarBind -> value == noSuchObject
				|| vp -> VarBind -> value == noSuchInstance
				|| vp -> VarBind -> value == endOfMibView) {
			    parm -> error__status = int_SNMP_error__status_noSuchName;
			    goto out;
			}
		    idx = 0;
	        }
		if (offset == type_SNMP_PDUs_get__next__request) {
		    for (vp = op; vp; vp = vp -> next)
			size -= ps_get_abs_oid (vp -> VarBind -> name);
		    for (vp = parm -> variable__bindings; vp; vp = vp -> next)
			size += ps_get_abs_oid (vp -> VarBind -> name);
		}
		for (vp = op; vp; vp = vp -> next)
		    size -= ps_get_abs (vp -> VarBind -> value);
		for (vp = parm -> variable__bindings; vp; vp = vp -> next)
		    size += ps_get_abs (vp -> VarBind -> value);
		if (size >= maxsize) {
		    parm -> error__status = int_SNMP_error__status_tooBig;
		    goto out;
		}
#ifdef	MAGIC
		if ((vp = parm -> variable__bindings)
		        && magicommand == MAGIC_VARVARBINDS) {
		    vp = vp -> next;
		    parm -> variable__bindings -> next = NULL;
		    free_SNMP_VarBindList (parm -> variable__bindings);
		    parm -> variable__bindings = vp;
		}
		else
		    if (offset != type_SNMP_PDUs_get__next__request
			    && (vp = parm -> variable__bindings)
			    && magicommand == MAGIC_VARNAMEBINDS
			    && (new = oid_extend (vp -> VarBind -> name, 1))) {
			new -> oid_elements[new -> oid_nelem - 1] = 1;
			free_SNMP_ObjectName (vp -> VarBind -> name);
			vp -> VarBind -> name = new;
		    }
		else
		    if (offset == type_SNMP_PDUs_set__request
			    && (vp = parm -> variable__bindings)
			    && magicommand == MAGIC_VARVALUEBINDS) {
			free_SNMP_ObjectSyntax (vp -> VarBind -> value);
			(vp -> VarBind -> value = unSpecified) -> pe_refcnt++;
		    }
#endif
	    }
#ifdef	MAGIC
	    if (magicommand == MAGIC_READONLY)
		parm -> error__status = int_SNMP_error__status_readOnly;
#endif
	    free_SNMP_VarBindList (op);
	    break;

	case int_SNMP_error__status_tooBig:
#ifdef	EQUIV
	    if (equivP)
		goto oops;
#endif
	    free_SNMP_VarBindList (op);
	    free_SNMP_VarBindList (parm -> variable__bindings);
	    parm -> variable__bindings = NULL;
	    break;
	    
	default:	/* readOnly, ..., inconsistentName */
#ifdef	EQUIV
oops: ;
#endif
	    if (op) {
		free_SNMP_VarBindList (parm -> variable__bindings);
		parm -> variable__bindings = op;
	    }
	    break;
    }

    return DONE;
}

/*  */

static int  do_pass (msg, offset, context)
struct type_SNMP_SnmpAuthMsg *msg;
int	offset;
struct snmp_context *context;
{
    int	    heins,
	    idx,
	    status;
    object_instance ois;
    register struct type_SNMP_PDUs *pdu = msg -> authData -> pdu;
    register struct type_SNMP_VarBindList *vp;
    register struct type_SNMP_Response__PDU *parm = pdu -> un.response;
    IFP	    method;
    static int lastq = -1;

    heins = idx = 0;
    for (vp = msg -> authData -> pdu -> un.get__request -> variable__bindings;
	     vp;
	     vp = vp -> next) {
	OID	save;
	register OI	oi;
	register OT	ot;
	register struct type_SNMP_VarBind *v = vp -> VarBind;

	idx++;
	
	if (offset == type_SNMP_PDUs_get__next__request) {
	    if ((oi = name2inst (v -> name)) == NULLOI
		    && (oi = next2inst (v -> name)) == NULLOI) {
no_next: ;
		if (v -> value)
		    pe_free (v -> value);
		(v -> value = endOfMibView) -> pe_refcnt++;
		continue;
	    }

	    if ((ot = oi -> oi_type) -> ot_getfnx == NULLIFP)
		goto get_next;
	}
	else {
	    if ((oi = name2inst (v -> name)) == NULLOI) {
		if (offset == type_SNMP_PDUs_set__request) {
no_creation: ;
		    parm -> error__status = int_SNMP_error__status_noCreation;
		    return idx;
		}

no_object: ;
		if (v -> value)
		    pe_free (v -> value);
		(v -> value = noSuchObject) -> pe_refcnt++;
		continue;
	    }
	    ot = oi -> oi_type;
	    if ((offset == type_SNMP_PDUs_get__request
		 	    ? ot -> ot_getfnx : ot -> ot_setfnx) == NULLIFP) {
		if (offset == type_SNMP_PDUs_set__request) {
		    if (!ot -> ot_getfnx)
			goto no_creation;
		    parm -> error__status = int_SNMP_error__status_notWritable;
		    return idx;
		}

		goto no_object;
	    }
	}

try_again: ;
	switch (offset) {
	    case type_SNMP_PDUs_get__request:
	        if (!check_view (context, oi -> oi_name))
		    goto no_instance;
		method = ot -> ot_getfnx;
		break;

	    case type_SNMP_PDUs_get__next__request:
		method = ot -> ot_getfnx;
		break;

	    case type_SNMP_PDUs_set__request:
	        if (!check_view (context, oi -> oi_name)) {
		    parm -> error__status = int_SNMP_error__status_noAccess;
		    return idx;
		}
		/* and fall... */
	    case type_SNMP_PDUs_commit:
	    case type_SNMP_PDUs_rollback:
		method = ot -> ot_setfnx;
		break;
	}

	if (offset == type_SNMP_PDUs_get__next__request)
	    save = oid_cpy (v -> name);
heinous: ;
	status = (*method) (oi, v, offset, idx);

	if (offset == type_SNMP_PDUs_get__next__request
	        && status == int_SNMP_error__status_noError
	        && !check_view (context, v -> name)) {	/* XXX: heinous! */
	    if (!view_granular) {
		oid_free (v -> name), v -> name = save;
		if (v -> value)
		    pe_free (v -> value);
		(v -> value = unSpecified) -> pe_refcnt++;

		goto get_next;
	    }

	    if (quantum != lastq) {
		lastq = quantum;

		if (debug)
		    advise (LLOG_DEBUG, NULLCP, "heinous %s %s (%s)",
			    ot -> ot_text, sprintoid (v -> name),  source);
	    }
	    heins++;

	    if (v -> value)
		pe_free (v -> value);
	    (v -> value = unSpecified) -> pe_refcnt++;

	    oi = &ois;
	    oi -> oi_name = v -> name;
	    oi -> oi_type = ot;
	    goto heinous;
	}
	else
	    if (heins && debug) {
		advise (LLOG_DEBUG, NULLCP, "heinous %d times...", heins);

		heins = 0, lastq = quantum - 1;
	    }

	if (offset == type_SNMP_PDUs_get__next__request && status != NOTOK)
	    oid_free (save);
	switch (status) {
	    case NOTOK:	    /* get-next wants a bump */
		oid_free (v -> name), v -> name = save;
get_next: ;
		oi = &ois;
		for (;;) {
		    if ((ot = ot -> ot_next) == NULLOT)
			goto no_next;
		    oi -> oi_name = (oi -> oi_type = ot) -> ot_name;
		    if (ot -> ot_getfnx)
			goto try_again;
		}

	    case int_SNMP_error__status_noError:
		break;

	    case int_SNMP_error__status_noSuchName:
		if (offset == type_SNMP_PDUs_set__request) {
		    parm -> error__status =
				    int_SNMP_error__status_noCreation;
		    return idx;
		}
		
no_instance: ;
		if (v -> value)
		    pe_free (v -> value);
		(v -> value = noSuchInstance) -> pe_refcnt++;
		break;


	    default:
		parm -> error__status = status;
		return idx;
	}
    }

    return 0;
}

/*  */

int	check_view (sc, oid)
struct snmp_context *sc;
OID	oid;
{
    register struct snmp_view *vu;

    for (vu = sc -> sc_vu; vu;) {
	register int	 i;
	int	bits;
	register unsigned int *ip,
			      *jp;
	register u_char *mp,
		        *np;
	u_char	mask[16];

	if (vu -> vu_status != ROW_ACTIVE
	        || (i = vu -> vu_subtree -> oid_nelem) > oid -> oid_nelem)
	    goto next;

	for (np = (mp = mask) + sizeof mask; mp < np; mp++)
	    *mp = 0xff;
	if (vu -> vu_mask)
	    bcopy (vu -> vu_mask -> qb_forw -> qb_data, (char *) mask,
		   vu -> vu_mask -> qb_len);

	mp = mask, bits = 0x80;
	for (ip = vu -> vu_subtree -> oid_elements, jp = oid -> oid_elements;
	         i > 0;
	         ip++, jp++, i--) {
	    if ((*mp & bits) && *ip != *jp)
		break;
	    if ((bits >>= 1) == 0)
		mp++, bits = 0x80;
	}
	if (i == 0) {
	    if (debug)
		advise (LLOG_DEBUG, NULLCP, "check_view %s -> %d",
			sprintoid (oid),
			vu -> vu_type == VIEW_INCLUDED ? 1 : 0);

	    return (vu -> vu_type == VIEW_INCLUDED ? 1 : 0);
	}

next: ;
	if ((vu = vu -> vu_prev) && vu -> vu_index != sc -> sc_view)
	    break;
    }

    if (debug)
	advise (LLOG_DEBUG, NULLCP, "check_view %s -> miss", sprintoid (oid));

    return 0;
}

/*    PROXY */

static int  proxy1 (msg, srcParty, dstParty, context)
struct type_SNMP_SnmpAuthMsg *msg;
struct snmp_party *srcParty,
		  *dstParty;
struct snmp_context *context;
{
    register struct snmp_party *proxyParty;

    if ((proxyParty = context -> sc_dst) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, "badProxy: no proxy dst (%s)",
		source);
	return NOTOK;
    }

#ifdef	TCP
    if (UDPaddress_OK (proxyParty)) {
	if (proxyParty -> party_tDomain == SNMPUDPDOMAIN)
	    return snmpUDPproxy (msg, srcParty, dstParty, context);
	if (proxyParty -> party_tDomain == RFC1157DOMAIN)
	    return rfc1157proxy (msg, srcParty, dstParty, context);
    }
#endif

    advise (LLOG_EXCEPTIONS, NULLCP,
	    "proxy party %s is not reachable via any supported domain (%s)",
	    oid2ode (proxyParty -> party_Identity), source);
    return NOTOK;
}

/*  */

struct proxyque *pq_slot (msg, proxyParty, srcParty, dstParty, proxyContext)
struct type_SNMP_SnmpAuthMsg *msg;
struct snmp_party *proxyParty,
		  *srcParty,
		  *dstParty;
struct snmp_context *proxyContext;
{
    register struct proxyque *pq;

    if (pqs >= NPQ) {
	register struct proxyque *qp;

	for (qp = (pq = pips) + NPQ; pq < qp; pq++)
	    if (pq -> pq_age < quantum) {
		advise (LLOG_NOTICE, NULLCP, "proxy flush");
		break;
	    }
	if (pq >= qp)
	    return NULL;
    }
    else
	pq = pips + pqs++;

    pq -> pq_quantum = quantum;
    pq -> pq_age = quantum + NPQ - 1;	/* who knows what a good value is?!? */
    pq -> pq_maxsize = srcParty -> party_MaxMessageSize;
    pq -> pq_proxyParty = proxyParty;
    pq -> pq_srcParty = srcParty;
    pq -> pq_dstParty = dstParty;
    pq -> pq_proxyContext = proxyContext;
    pq -> pq_request = msg -> authData -> pdu -> un.get__request
					      -> request__id;

    msg -> authData -> pdu -> un.get__request -> request__id =
							    pq -> pq_quantum;

    return pq;
}

/*  */

#ifdef	TCP
static int  snmpUDPproxy (msg, srcParty, dstParty, context)
struct type_SNMP_SnmpAuthMsg *msg;
struct snmp_party *srcParty,
		  *dstParty;
struct snmp_context *context;
{
    int	    result;
    register struct proxyque *pq;
    struct snmp_party  *srcProxy,
		       *dstProxy;
    PS	    ps = NULL;

    if ((srcProxy = context -> sc_src) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, "badProxy: no proxy src (%s)",
		source);
	return NOTOK;
    }
    if (context -> sc_ctx == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, "badProxy: no proxy ctx (%s)",
		source);
	return NOTOK;
    }
    if ((pq = pq_slot (msg, dstProxy = context -> sc_dst, srcParty, dstParty,
		       context)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"no proxyque slots available (%s)",
		oid2ode (dstParty -> party_Identity), source);
	return NOTOK;
    }

    result = NOTOK;
    if ((ps = ps_alloc (dg_open)) == NULLPS
	    || dg_setup (ps, udp, dstProxy -> party_MaxMessageSize,
			 read_udp_socket, write_udp_socket, check_udp_socket)
	    == NOTOK) {
	if (ps == NULLPS)
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "ps_alloc(dg_open): failed for snmpUDPproxy (%s)",
		    source);
	else
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "dg_setup: %s for snmpUDPproxy (%s)",
		    ps_error (ps -> ps_errno), source);
	goto out;
    }
    if (hack_dgram_socket (udp, party2sa (dstProxy)) == NOTOK) {
	advise (LLOG_EXCEPTIONS, "failed",
		"hack_dgram_socket(1) for snmpUDPproxy (%s)", source);
	goto out;
    }

    result = send_message (ps, msg, srcProxy, dstProxy, context -> sc_ctx);

    if (hack_dgram_socket (udp, (struct sockaddr *) NULL) == NOTOK)
	advise (LLOG_EXCEPTIONS, "failed",
		"hack_dgram_socket(2) for snmpUDPproxy (%s)", source);

out: ;
    if (ps)
	ps_free (ps);

    if (result == NOTOK) {
	register struct proxyque *qp = pips + --pqs;

	if (pq != qp)
	    *pq = *qp;		/* struct copy */
    }
    else
	pqr = pq;

    return result;
}

/*  */

static int  rfc1157proxy (msg, srcParty, dstParty, context)
struct type_SNMP_SnmpAuthMsg *msg;
struct snmp_party *srcParty,
		  *dstParty;
struct snmp_context *context;
{
    int	    result;
    register struct proxyque *pq;
    struct snmp_party  *dstProxy;
    struct type_SNMP_Snmp1157Msg proxymsgs;
    register struct type_SNMP_Snmp1157Msg *proxymsg = &proxymsgs;
    PE	    pe = NULL;
    PS	    ps = NULL;

    if ((result = down_message (msg)) != OK)
	return result;
    if ((pq = pq_slot (msg, dstProxy = context -> sc_dst, srcParty, dstParty,
		       context)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP, "no proxyque slots available (%s)",
		source);
	return NOTOK;
    }

    bzero ((char *) proxymsg, sizeof *proxymsg);
    proxymsg -> version = int_SNMP_version_version__1;
    if ((proxymsg -> community = str2qb ((char *) dstProxy ->party_AuthPrivate,
					 dstProxy -> party_AuthPrivate_len, 1))
	    == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"out of memory generating community for proxy for %s (%s)",
		oid2ode (dstProxy -> party_Identity), source);
	return NOTOK;
    }
    proxymsg -> data = msg -> authData -> pdu;

    result = NOTOK;
    if ((ps = ps_alloc (dg_open)) == NULLPS
	    || dg_setup (ps, udp, dstProxy -> party_MaxMessageSize,
			 read_udp_socket, write_udp_socket, check_udp_socket)
	    == NOTOK) {
	if (ps == NULLPS)
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "ps_alloc(dg_open): failed for rfc1157proxy (%s)", source);
	else
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "dg_setup: %s for rfc1157proxy (%s)",
		    ps_error (ps -> ps_errno), source);
	goto out;
    }

    if (encode_SNMP_Snmp1157Msg (&pe, 1, 0, NULLCP, proxymsg) != NOTOK) {
	PLOGP (pgm_log,SNMP_Snmp1157Msg, pe, "Snmp1157Msg", 0);

	if (hack_dgram_socket (udp, party2sa (dstProxy)) == NOTOK) {
	    advise (LLOG_EXCEPTIONS, "failed",
		    "hack_dgram_socket(1) for rfc1157proxy (%s)", source);
	    goto out;
	}

	if (pe2ps (ps, pe) == NOTOK)
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "pe2ps: %s for rfc1157proxy (%s)",
		    ps_error (ps -> ps_errno), source);
	else
	    result = OK;

	if (hack_dgram_socket (udp, (struct sockaddr *) NULL) == NOTOK)
	    advise (LLOG_EXCEPTIONS, "failed",
		    "hack_dgram_socket(2) for rfc1157proxy (%s)", source);
    }
    else
	advise (LLOG_EXCEPTIONS, NULLCP,
		"encode_SNMP_Snmp1157Msg: %s for rfc1157proxy (%s)", PY_pepy,
		source);

out: ;
    if (ps)
	ps_free (ps);
    if (pe)
	pe_free (pe);
    if (proxymsg -> community)
	qb_free (proxymsg -> community);

    if (result == NOTOK) {
	register struct proxyque *qp = pips + --pqs;

	if (pq != qp)
	    *pq = *qp;		/* struct copy */
    }
    else
	pqr = pq;

    return result;
}

/*  */

static int  down_message (msg)
struct type_SNMP_SnmpAuthMsg *msg;
{
    register struct type_SNMP_PDUs *pdu = msg -> authData -> pdu;

    switch (pdu -> offset) {
	case type_SNMP_PDUs_get__bulk__request:
	    pdu -> offset = type_SNMP_PDUs_get__next__request;
	    pdu -> un.response -> error__status =
						int_SNMP_error__status_noError;
	    pdu -> un.response -> error__index = 0;
	    break;

	case type_SNMP_PDUs_inform__request:
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "unable to downgrade inform-request for rfc1157proxy (%s)",
		    source);
	    pdu -> offset = type_SNMP_PDUs_response;
	    pdu -> un.response -> error__index = 0;
	    pdu -> un.response -> error__status =
				    int_SNMP_error__status_authorizationError;
	    return DONE;

	default:
	    break;
    }

    return OK;
}
#endif

/*  */

static int  proxy2 (msg)
struct type_SNMP_SnmpAuthMsg *msg;
{
    integer request;
    register struct proxyque *pq,
			     *qp;
    PS	    ps = NULL;

    request = msg -> authData -> pdu -> un.get__request -> request__id;
    for (qp = (pq = pips) + pqs; pq < qp; pq++)
	if (pq -> pq_quantum == request)
	    break;
    if (pq >= qp) {
	advise (LLOG_EXCEPTIONS, NULLCP, "spurious proxy response from %s",
		source);
	return NOTOK;
    }
    msg -> authData -> pdu -> un.get__request -> request__id =
							    pq -> pq_request;

    if ((ps = ps_alloc (dg_open)) == NULLPS
	    || dg_setup (ps, pq -> pq_fd, pq -> pq_maxsize, pq -> pq_readfnx,
			 pq -> pq_writefnx, pq -> pq_checkfnx) == NOTOK) {
	if (ps == NULLPS)
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "ps_alloc(dg_open): failed (for proxy response from %s)", 
		    source);
	else
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "dg_setup: %s (for proxy from %s)",
		    ps_error (ps -> ps_errno), source);
	goto out;
    }
    if (hack_dgram_socket (pq -> pq_fd, (struct sockaddr *) &pq -> pq_isock)
	    == NOTOK) {
	advise (LLOG_EXCEPTIONS, "failed",
		"hack_dgram_socket(1) (for proxy response from %s)", source);
	goto out;
    }

    (void) send_message (ps, msg, pq -> pq_dstParty, pq -> pq_srcParty,
			 pq -> pq_proxyContext -> sc_identity);

    if (hack_dgram_socket (pq -> pq_fd, (struct sockaddr *) NULL) == NOTOK)
	advise (LLOG_EXCEPTIONS, "failed",
		"hack_dgram_socket(2) (for proxy response from %s)", source);

out: ;
    if (ps)
	ps_free (ps);

    qp = pips + --pqs;
    if (pq != qp)
	*pq = *qp;	/* struct copy */

    return OK;
}

/*  */

/* ARGSUSED */

static int  proxy3 (msg, srcParty, dstParty, context)
struct type_SNMP_SnmpAuthMsg *msg;
struct snmp_party *srcParty,
		  *dstParty;
struct snmp_context *context;
{
    register struct snmp_context *sc;

    for (sc = contextHead; sc; sc = sc -> sc_next)
	if (sc -> sc_status == ROW_ACTIVE
	        && sc -> sc_view == 0
		&& sc -> sc_dst == srcParty
	        && sc -> sc_ctx
	        && oid_cmp (sc -> sc_ctx, context -> sc_identity) == 0) {
	    register struct snmp_access *sa;

	    for (sa = accessHead; sa; sa = sa -> sa_next)
		if (sa -> sa_status == ROW_ACTIVE
		        && sa -> sa_resources == sc
			&& sa -> sa_subject -> party_location == AGENT
		        && (sa -> sa_privileges & PARTY_PRIV_NTFY))
		    send_trap (msg, sa -> sa_subject, sa -> sa_target,
			       sa -> sa_resources);
	}

    return OK;
}

/*  */

#ifdef	TCP
#ifndef	EQUIV
/* ARGSUSED */
#endif

static int  proxy4 (pe, size, px)
PE	pe;
int	size;
PS	px;
{
    int	    result = NOTOK;
    integer  request;
    register struct proxyque *pq,
			     *qp;
    PS	    ps = NULL;
    struct type_SNMP_SnmpAuthMsg authmsgs;
    struct type_SNMP_SnmpAuthMsg *authmsg = &authmsgs;
    struct type_SNMP_SnmpMgmtCom mgmtcoms;
    struct type_SNMP_Snmp1157Msg *msg = NULL;

    if (decode_SNMP_Snmp1157Msg (pe, 1, NULLIP, NULLVP, &msg) == NOTOK) {
	advise (LLOG_EXCEPTIONS, NULLCP, "decode_SNMP_Message: %s (%s)",
		PY_pepy, source);
	snmpstat.s_encodingerrs++;
	goto out;
    }

    PLOGP (pgm_log,SNMP_Snmp1157Msg, pe, "Snmp1157Msg", 1);

    if (msg -> version != int_SNMP_version_version__1) {
	advise (LLOG_EXCEPTIONS, NULLCP, "bad version number %d (%s)",
		msg -> version, source);
	snmpstat.s_badversions++;
	goto out;
    }
    
    bzero ((char *) authmsg, sizeof *authmsg);
    authmsg -> authData = &mgmtcoms;

    bzero ((char *) &mgmtcoms, sizeof mgmtcoms);
    mgmtcoms.pdu = msg -> data;

    switch (msg -> data -> offset) {
        case type_SNMP_PDUs_get__request:
	case type_SNMP_PDUs_get__next__request:
	case type_SNMP_PDUs_set__request:
#ifdef	EQUIV
	{
	    register struct equiv *eq;
	    struct qbuf *qb = msg -> community;
	    struct snmp_party *dstParty,
			      *srcParty;
	    struct snmp_context *context;

	    if (qb -> qb_forw -> qb_forw != qb)
		goto losing_30;
	    for (eq = eqHead; eq; eq = eq -> eq_next)
		if (eq -> eq_commlen == qb -> qb_len
		        && bcmp (eq -> eq_community,
				 qb -> qb_forw -> qb_data, qb -> qb_len) == 0)
		    break;
	    if (!eq)
		goto losing_30;

	    if (debug) {
		advise (LLOG_DEBUG, NULLCP, "srcParty:  %s",
			oid2ode (eq -> eq_subject));
		advise (LLOG_DEBUG, NULLCP, "dstParty:  %s",
			oid2ode (eq -> eq_target));
		advise (LLOG_DEBUG, NULLCP, "context:   %s",
			oid2ode (eq -> eq_resources));
	    }

	    if ((dstParty = lookup_party (eq -> eq_target, AGENT)) == NULL) {
		advise (LLOG_EXCEPTIONS, NULLCP,
			"bad equivalence dstParty: %s (%s)",
			oid2ode (eq -> eq_target), source);
		goto losing_30;
	    }
	    if ((srcParty = lookup_party (eq -> eq_subject, MANAGER)) == NULL){
		advise (LLOG_EXCEPTIONS, NULLCP,
			"bad equivalence srcParty: %s (%s)",
			oid2ode (eq -> eq_subject), source);
		goto losing_30;
	    }
	    if ((context = lookup_context (eq -> eq_resources)) == NULL
		    || context -> sc_view <= 0
		    || context -> sc_location != AGENT) {
		advise (LLOG_EXCEPTIONS, NULLCP,
			"bad equivalence context: %s (%s)",
			oid2ode (eq -> eq_resources), source);
		goto losing_30;
	    }

#ifdef	MAGIC
	    magicommand = dstParty -> party_testmode;
#endif
	    if (do_operation (authmsg, size, srcParty, dstParty, context, 1)
		    == DONE) {
#ifdef	MAGIC
		int	magic = 0;
#endif
		PE	py;
		struct type_SNMP_PDU *parm;

#ifdef	MAGIC
again: ;
#endif
		py = NULLPE;
		parm = msg -> data -> un.response;

		switch (parm -> error__status) {
		    case int_SNMP_error__status_authorizationError:
		        if (!parm -> variable__bindings) {
			    parm -> error__status =
						int_SNMP_error__status_noError;
			    break;
			}
			parm -> error__index = 1;
			/* and fall... */
		    case int_SNMP_error__status_noAccess:
		    case int_SNMP_error__status_noCreation:
		    case int_SNMP_error__status_notWritable:
		    case int_SNMP_error__status_inconsistentName:
			parm -> error__status =
					    int_SNMP_error__status_noSuchName;
			break;

		    case int_SNMP_error__status_wrongType:
		    case int_SNMP_error__status_wrongLength:
		    case int_SNMP_error__status_wrongEncoding:
		    case int_SNMP_error__status_wrongValue:
		    case int_SNMP_error__status_inconsistentValue:
		    case int_SNMP_error__status_resourceUnavailable:
		        parm -> error__status =
					    int_SNMP_error__status_badValue;
			break;

		    case int_SNMP_error__status_commitFailed:
		    case int_SNMP_error__status_undoFailed:
		        parm -> error__status = int_SNMP_error__status_genErr;
			break;

		    default:
			break;
		}

		if (encode_SNMP_Snmp1157Msg (&py, 1, 0, NULLCP, msg) != NOTOK){
		    PLOGP (pgm_log,SNMP_Snmp1157Msg, py, "Snmp1157Msg", 0);

		    if (pe2ps (px, py) == NOTOK)
			advise (LLOG_EXCEPTIONS, NULLCP,
				"pe2ps: %s (%s)",
				ps_error (ps -> ps_errno), source);
		    else
			result = OK;
		}
		else
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "encode_SNMP_Snmp1157Msg: %s (%s)", PY_pepy,
			    source);
		if (py)
		    pe_free (py);

#ifdef	MAGIC
		if (!magic)
		    switch (magicommand) {
		        case MAGIC_SENDGET:
			    msg -> data -> offset =
						type_SNMP_PDUs_get__request;
			    magic = 1;
			    goto again;

		        case MAGIC_SENDNEXT:
			    msg -> data -> offset =
					    type_SNMP_PDUs_get__next__request;
			    magic = 1;
			    goto again;

		        case MAGIC_SENDSET:
			    msg -> data -> offset =
						type_SNMP_PDUs_set__request;
			    magic = 1;
			    goto again;

		        case MAGIC_SENDXXX:
			    msg -> data -> offset = type_SNMP_PDUs_xxx;
			    magic = 1;
			    goto again;

		        default:
		            break;
		    }
#endif
	    }
#ifdef	MAGIC
	    magicommand = MAGIC_NONE;
#endif
	    break;
	}
losing_30: ;
#endif
	default:
	    advise (LLOG_EXCEPTIONS, NULLCP, "30something message (%s)",
		    source);
	    snmpstat.s_30something++;
	    break;

	case type_SNMP_PDUs_response:
	    if (msg -> data -> un.response -> error__status
			== int_SNMP_error__status_tooBig) {
		register struct type_SNMP_Response__PDU *parm =
					    msg -> data -> un.response;

		if (parm -> variable__bindings) {
		    free_SNMP_VarBindList (parm -> variable__bindings);
		    parm -> variable__bindings = NULL;
		}
	    }
	    request = msg -> data -> un.get__request -> request__id;
	    for (qp = (pq = pips) + pqs; pq < qp; pq++)
		if (pq -> pq_quantum == request)
		    break;
	    if (pq >= qp) {
		advise (LLOG_EXCEPTIONS, NULLCP,
			"spurious rfc1157 proxy response from %s", source);
		break;
	    }
	    msg -> data -> un.get__request -> request__id = pq -> pq_request;

	    if ((ps = ps_alloc (dg_open)) == NULLPS
		    || dg_setup (ps, pq -> pq_fd, pq -> pq_maxsize,
				 pq -> pq_readfnx, pq -> pq_writefnx,
				 pq -> pq_checkfnx) == NOTOK) {
		if (ps == NULLPS)
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "ps_alloc(dg_open): failed for proxy response (%s)",
			    source);
		else
		    advise (LLOG_EXCEPTIONS, NULLCP, "dg_setup: %s (%s)",
			    ps_error (ps -> ps_errno), source);
		goto drop;
	    }
	    if (hack_dgram_socket (pq -> pq_fd,
				   (struct sockaddr *) &pq -> pq_isock)
		    == NOTOK) {
		advise (LLOG_EXCEPTIONS, "failed",
			"hack_dgram_socket(1) for proxy response (%s)",
			source);
		goto drop;
	    }

	    (void) send_message (ps, authmsg, pq -> pq_dstParty,
				 pq -> pq_srcParty,
				 pq -> pq_proxyContext -> sc_identity);

	    if (hack_dgram_socket (pq -> pq_fd, (struct sockaddr *) NULL)
		    == NOTOK)
		advise (LLOG_EXCEPTIONS, "failed",
			"hack_dgram_socket(2) for proxy response (%s)",
			source);

	    if (authmsg -> authInfo)
		free_SNMP_AuthInformation (authmsg -> authInfo);
	    if (authmsg -> authData -> srcParty)
		oid_free (authmsg -> authData -> srcParty);
	    if (authmsg -> authData -> dstParty)
		oid_free (authmsg -> authData -> dstParty);
	    if (authmsg -> authData -> context)
		oid_free (authmsg -> authData -> context);

drop: ;
	    if (ps)
		ps_free (ps);

	    qp = pips + --pqs;
	    if (pq != qp)
		*pq = *qp;	/* struct copy */

	    result = OK;
	    break;

	case type_SNMP_PDUs_trap:
	    {
		int	i;
		OID	name;
		register struct snmp_context *sc;
		struct type_SNMP_Trap__PDU *trap = msg -> data -> un.trap;
		register struct type_SNMP_VarBindList **vpp;
		struct type_SNMP_VarBindList list;
		struct type_SNMP_VarBind     bind;

		switch (trap -> generic__trap) {
		    case int_SNMP_generic__trap_coldStart:
		    case int_SNMP_generic__trap_warmStart:
		    case int_SNMP_generic__trap_linkDown:
		    case int_SNMP_generic__trap_linkUp:
		    case int_SNMP_generic__trap_authenticationFailure:
		    case int_SNMP_generic__trap_egpNeighborLoss:
		        name = *(trapnames[trap -> generic__trap].value);
			break;

		    case int_SNMP_generic__trap_enterpriseSpecific:
		    default:
			name = oid_extend (trap -> enterprise, 2);
			i = trap -> enterprise -> oid_nelem;
			name -> oid_elements[i++] = 0;
			name -> oid_elements[i] = trap -> specific__trap;
			break;
		}

		list.VarBind = &bind;
		list.next = NULL;
		bind.name = snmpTrapEnterprise;
		if ((bind.value = oid2prim (trap -> enterprise)) == NULL)
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "out of memory in proxy4 (%s)", source);
		else {
		    for (vpp = &trap -> variable__bindings;
		             *vpp;
		             vpp = &((*vpp) -> next))
			continue;
		    *vpp = &list;
		}

		for (sc = contextHead; sc; sc = sc -> sc_next) {
		    char    addr[BUFSIZ];
		    register struct snmp_party *p;
		    register struct sockaddr_in *pa;

		    if (sc -> sc_status != ROW_ACTIVE
			    || sc -> sc_view > 0
			    || (p = sc -> sc_dst) == NULLPARTY
			    || p -> party_status != ROW_ACTIVE
			    || p -> party_tDomain != RFC1157DOMAIN
			    || p -> party_AuthPrivate_len
				    != msg -> community -> qb_len
			    || bcmp ((char *) p -> party_AuthPrivate,
				     msg -> community -> qb_forw -> qb_data,
				     msg -> community -> qb_len))
			continue;

		    pa = (struct sockaddr_in *) party2sa (p);
		    (void) sprintf (addr, "%s/%d", inet_ntoa (pa -> sin_addr),
				    (int) ntohs (pa -> sin_port));
		    if (strcmp (source, addr))
			continue;

		    send_traps_aux (name, trap -> variable__bindings,
				    (u_long) trap -> time__stamp -> parm, sc);
		}

		if (bind.value) {
		    *vpp = NULL;
		    pe_free (bind.value);
		}

		switch (trap -> generic__trap) {
		    case int_SNMP_generic__trap_coldStart:
		    case int_SNMP_generic__trap_warmStart:
		    case int_SNMP_generic__trap_linkDown:
		    case int_SNMP_generic__trap_linkUp:
		    case int_SNMP_generic__trap_authenticationFailure:
		    case int_SNMP_generic__trap_egpNeighborLoss:
			break;

		    case int_SNMP_generic__trap_enterpriseSpecific:
		    default:
			oid_free (name);
			break;
		}
	    }
	    break;
    }
    
out: ;
    if (msg)
	free_SNMP_Snmp1157Msg (msg);

    return result;
}
#endif

/*    TRAPS */

static	send_traps (name, bindings)
OID	name;
struct type_SNMP_VarBindList *bindings;
{
    u_long	timestamp;
    struct timeval now;

    if (gettimeofday (&now, (struct timezone *) 0) == NOTOK) {
	advise (LLOG_EXCEPTIONS, "failed", "gettimeofday");
	return;
    }
    timestamp = (now.tv_sec - my_boottime.tv_sec) * 100
			    + ((now.tv_usec - my_boottime.tv_usec) / 10000);
    send_traps_aux (name, bindings, timestamp, (struct snmp_context *) 0);
}

/*  */

static	send_traps_aux (name, bindings, timestamp, sc)
OID	name;
struct type_SNMP_VarBindList *bindings;
u_long	timestamp;
struct snmp_context *sc;
{
    register struct snmp_access *sa;
    struct type_SNMP_SnmpAuthMsg authmsgs;
    struct type_SNMP_SnmpAuthMsg *authmsg = &authmsgs;
    struct type_SNMP_SnmpMgmtCom mgmtcoms;
    struct type_SNMP_PDUs pdus;
    struct type_SNMP_SNMPv2__Trap__PDU traps;
    struct type_SNMP_SNMPv2__Trap__PDU *trap = &traps;
    struct type_SNMP_VarBindList *vp,
				  list[2];
    struct type_SNMP_VarBind     *bp,
				  bind[2];

    bzero ((char *) authmsg, sizeof *authmsg);
    authmsg -> authData = &mgmtcoms;

    bzero ((char *) &mgmtcoms, sizeof mgmtcoms);
    mgmtcoms.pdu = &pdus;

    bzero ((char *) &pdus, sizeof pdus);
    pdus.offset = type_SNMP_PDUs_snmpV2__trap;
    pdus.un.snmpV2__trap = trap;

    vp = list, bp = bind;
    bzero ((char *) trap, sizeof *trap);
    trap -> variable__bindings = vp;

    vp -> VarBind = bp;
    vp -> next = vp + 1;
    bp -> name = sysUpTime;
    if ((bp -> value = ulong2prim (timestamp, PE_CLASS_APPL, 3)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"out of memory in send_traps_aux(1) (%s)", source);
	return;
    }
    vp++, bp++;

    vp -> VarBind = bp;
    vp -> next = bindings;
    bp -> name = snmpTrapOID;
    if ((bp -> value = oid2prim (name)) == NULL) {
	advise (LLOG_EXCEPTIONS, NULLCP,
		"out of memory in send_traps_aux(2) (%s)", source);
	pe_free (bind[0].value);
	return;
    }

    for (sa = accessHead; sa; sa = sa -> sa_next) {
	if (sa -> sa_status != ROW_ACTIVE
		|| sa -> sa_subject -> party_location != AGENT
	        || !(sa -> sa_privileges & PARTY_PRIV_NTFY))
	    continue;
	if (sc) {
	    if (sa -> sa_resources != sc)
		continue;
	}
	else {
	    if (sa -> sa_resources -> sc_view == 0
		    || !check_view (sa -> sa_resources, name))
		continue;

	    for (; bindings; bindings = bindings -> next)
		if (!check_view (sa -> sa_resources,
				 bindings -> VarBind -> name))
		    break;
	    if (bindings)
		continue;
	}

	trap -> request__id = ++sa -> sa_target -> party_traps;
	send_trap (authmsg, sa -> sa_subject, sa -> sa_target,
		   sa -> sa_resources);
    }

    pe_free (bind[0].value);
    pe_free (bind[1].value);
}

/*  */

static	send_trap (msg, srcParty, dstParty, context)
register struct type_SNMP_SnmpAuthMsg *msg;
struct snmp_party *srcParty,
    		  *dstParty;
struct snmp_context *context;
{
#ifdef	TCP
    PS	    ps;
#endif

    if (dstParty -> party_location == AGENT) {	/* it's to me... */
	(void) send_message (NULLPS, msg, srcParty, dstParty,
			     context -> sc_identity);
	(void) audit_trap (msg, party_address (srcParty));
	return;
    }

#ifdef	TCP
    if ((ps = ps_alloc (dg_open)) == NULLPS
	    || dg_setup (ps, udp, dstParty -> party_MaxMessageSize,
			 read_udp_socket, write_udp_socket, check_udp_socket)
	    == NOTOK) {
	if (ps == NULLPS)
	    advise (LLOG_EXCEPTIONS, NULLCP,
		    "ps_alloc(dg_open): failed (trap)");
	else
	    advise (LLOG_EXCEPTIONS, NULLCP, "dg_setup: %s (trap)",
		    ps_error (ps -> ps_errno));
	goto out;
    }
    if (hack_dgram_socket (udp, party2sa (dstParty)) == NOTOK) {
	advise (LLOG_EXCEPTIONS, "failed", "hack_dgram_socket(1) (trap)");
	goto out;
    }

    (void) send_message (ps, msg, srcParty, dstParty, context -> sc_identity);

    if (hack_dgram_socket (udp, (struct sockaddr *) NULL) == NOTOK)
	advise (LLOG_EXCEPTIONS, "failed", "hack_dgram_socket(2) (trap)");

out: ;
    if (ps)
	ps_free (ps);
#endif
}

/*  */

static int  audit_trap (msg, src)
register struct type_SNMP_SnmpAuthMsg *msg;
char   *src;
{
    char   *cp;
    long    now;
    PE	    pe1,
	    pe2;
    register struct tm *tm;
    struct UTCtime uts;
    register struct UTCtime *ut = &uts;
    register struct type_SNMP_Audit *au;

    pe1 = pe2 = NULLPE;
    au = NULL;

    if (encode_SNMP_SnmpAuthMsg (&pe2, 1, 0, NULLCP, msg) == NOTOK) {
	advise (LLOG_EXCEPTIONS, NULLCP, "encode_SNMP_SnmpAuthMsg: %s (%s)",
		PY_pepy, source);
	goto out;
    }

    if ((au = (struct type_SNMP_Audit *) calloc (1, sizeof *au)) == NULL)
	goto no_mem;
    au -> sizeOfEncodingWhichFollows = ps_get_abs (pe2);

    if ((au -> source = str2qb (src, strlen (src), 1)) == NULL) {
no_mem: ;
        advise (LLOG_EXCEPTIONS, NULLCP, "out of memory in audit_trap (%s)",
		source);
	goto out;
    }
    (void) time (&now);

    if (tm = gmtime (&now))
	tm2ut (tm, ut);
    else {
	advise (LLOG_EXCEPTIONS, NULLCP, "gmtime failed");

	bzero ((char *) ut, sizeof *ut);
    }

    if ((cp = gent2str (ut)) == NULL
	    || (au -> dateAndTime = str2qb (cp, strlen (cp), 1)) == NULL)
	goto no_mem;

    if (encode_SNMP_Audit (&pe1, 1, 0, NULLCP, au) != NOTOK) {
	PLOGP (pgm_log,SNMP_Audit, pe1, "Audit", 0);
	PLOGP (pgm_log,SNMP_SnmpAuthMsg, pe2, "SnmpAuthMsg", 0);

	if (pe2ps (audit, pe1) == NOTOK || pe2ps (audit, pe2) == NOTOK)
	    advise (LLOG_EXCEPTIONS, NULLCP, "pe2ps: %s (%s)",
		    ps_error (audit -> ps_errno), source);

	(void) ps_flush (audit);
    }
    else
	advise (LLOG_EXCEPTIONS, NULLCP, "encode_SNMP_Audit: %s (%s)",
		PY_pepy, source);

out: ;
    if (au)
	free_SNMP_Audit (au);
    if (pe1)
	pe_free (pe1);
    if (pe2)
	pe_free (pe2);

    return DONE;
}

/*    MISCELLANY */

static	arginit (vec)
char	**vec;
{
    register char  *ap;
    char   *file = "snmpd.traps";
    FILE   *fp;

    if (myname = rindex (*vec, '/'))
	myname++;
    if (myname == NULL || *myname == NULL)
	myname = *vec;

    _tailor_logging_only = 1;
    isodetailor (myname, 0);
    ll_hdinit (pgm_log, myname);

    sargv = vec;
    if (*sargv[0] == '/')
	spath = sargv[0];
    else {
	int	i = strlen (sargv[0]);
	
	if (getcwd (sfile, sizeof sfile - (i + 1))) {
	    ap = sfile + strlen (sfile);
	    (void) sprintf (ap, "%s%s", ap > sfile + 1 ? "/" : "", sargv[0]);
	}
	else
	    (void) strcpy (sfile, _isodefile (isodesbinpath, myname));

	spath = sfile;
    }	

    for (vec++; ap = *vec; vec++) {
	if (*ap == '-')
	    switch (*++ap) {
                case 'a':
                    if ((aParty = *++vec) == NULL || *aParty == '-')
                        adios (NULLCP, "usage: %s -a party", myname);
                    continue;

		case 'b':
		    if ((ap = *++vec) == NULL
			    || *ap == '-'
			    || (tooBig = atoi (ap)) <= 128 /* MAXSNMP */
			    || tooBig > MAXDGRAM)	   /* BIGSNMP */
			adios (NULLCP, "usage: %s -b size", myname);
		    continue;

		case 'c':
		    cflag++;
		    continue;

		case 'd':
		    debug++;
		    /* and fall... */
		case 'D':
		    ddebug++;
		    continue;

		case 'f':
		    if ((file = *++vec) == NULL || *file == '-')
			adios (NULLCP, "usage: %s -f audit-file", myname);
		    continue;

#ifdef	MAGIC
		case 'm':
		    mmagic++;
		    continue;
#endif

		case 'p':
                    if ((pParty = *++vec) == NULL || *pParty == '-')
                        adios (NULLCP, "usage: %s -p party-file-prefix",
			       myname);
		    continue;

		case 'r':
		    rflag = 1;
		    continue;

		default:
		    adios (NULLCP, "-%s: unknown switch", ap);
	    }

	adios (NULLCP, "usage: %s [switches]", myname);
    }

    ps_len_strategy = PS_LEN_LONG;

    file = _isodefile (isodelogpath, file);
    if ((fp = fopen (file, "a")) == NULL)
	adios (file, "unable to append to");
    if ((audit = ps_alloc (std_open)) == NULLPS)
	adios (NULLCP, "ps_alloc(std_open): failed");
    if (std_setup (audit, fp) == NOTOK)
	adios (NULLCP, "std_setup: %s", ps_error (audit -> ps_errno));
}

/*  */

static  envinit () {
    int     i,
            sd;
    char    file[BUFSIZ];
    FILE   *fp;

    nbits = getdtablesize ();

    if (debug == 0 && !(debug = isatty (2))) {
	for (i = 0; i < 5; i++) {
	    switch (fork ()) {
		case NOTOK:
		    sleep (5);
		    continue;

		case OK:
		    break;

		default:
		    _exit (0);
	    }
	    break;
	}

	if (!ddebug)
	    (void) chdir ("/");

	if ((sd = open ("/dev/null", O_RDWR)) == NOTOK)
	    adios ("/dev/null", "unable to read");
	if (sd != 0)
	    (void) dup2 (sd, 0), (void) close (sd);
	(void) dup2 (0, 1);
	(void) dup2 (0, 2);

#ifdef	SETSID
	if (setsid () == NOTOK)
	    advise (LLOG_EXCEPTIONS, "failed", "setsid");
#endif
#ifdef	TIOCNOTTY
	if ((sd = open ("/dev/tty", O_RDWR)) != NOTOK) {
	    (void) ioctl (sd, TIOCNOTTY, NULLCP);
	    (void) close (sd);
	}
#else
#ifdef	SYS5
	(void) setpgrp ();
	(void) signal (SIGINT, SIG_IGN);
	(void) signal (SIGQUIT, SIG_IGN);
#endif
#endif
    }
    else
	ll_dbinit (pgm_log, myname);

#ifndef	sun		/* damn YP... */
    for (sd = 3; sd < nbits; sd++)
	if (pgm_log -> ll_fd != sd)
	    (void) close (sd);
#endif

    (void) signal (SIGPIPE, SIG_IGN);

    ll_hdinit (pgm_log, myname);

    o_advise = (IFP) advise;

    if (readobjects ("snmpd.defs") == NOTOK)
	adios (NULLCP, "readobjects: %s", PY_pepy);

    init_mib (cflag);
    init_system (sysDescr, sysObjectID, "72");
    if (!cflag) {		/* Internet-standard MIB */
	init_interfaces ();
	init_ip ();
	init_icmp ();
	init_tcp ();
	init_udp ();
	init_clns ();		/* experimental CLNS group */
    }
    if (init_snmp (1, 1) == NOTOK)
	adios (NULLCP, "%s", PY_pepy);
    init_partymib ();

    if (init_party (pParty, AGENT, rflag, &pParty) == NOTOK)
	adios (NULLCP, "%s", PY_pepy);
    if (sync_party (pParty, AGENT, 0) == NOTOK)
	advise (LLOG_EXCEPTIONS, NULLCP, "stable storage suspect: %s",
		PY_pepy);

    readconfig ();

    fin_mib ();

    if (aParty) {
	OID	oid;

	if ((oid = text2oid (aParty)) == NULLOID)
	    adios (NULLCP, "no such object as %s", aParty);
	if ((myParty = lookup_party (oid, AGENT)) == NULLPARTY)
	    adios (NULLCP, "no such party as %s", aParty);
	oid_free (oid);
    }

    if ((unSpecified = pe_alloc (PE_CLASS_UNIV, PE_FORM_PRIM, PE_PRIM_NULL))
		    == NULL
	    || (noSuchObject = pe_alloc (PE_CLASS_CONT, PE_FORM_PRIM, 0))
		    == NULL
	    || (noSuchInstance = pe_alloc (PE_CLASS_CONT, PE_FORM_PRIM, 1))
		    == NULL
	    || (endOfMibView = pe_alloc (PE_CLASS_CONT, PE_FORM_PRIM, 2))
		    == NULL)
	adios (NULLCP, "out of memory");

    {
	register struct trapname *t;

	for (t = trapnames; t -> trap; t++)
	    if ((*t -> value = text2oid (t -> trap)) == NULL)
		adios (NULLCP, "no such object as %s", t -> trap);
    }

    (void) sprintf (file, "/etc/%s.pid", myname);
    if (fp = fopen (file, "w")) {
	(void) fprintf (fp, "%d\n", getpid ());
	(void) fclose (fp);
    }

    advise (LLOG_NOTICE, NULLCP, "starting");
#ifdef	SIGDEBUG
    (void) signal (SIGHUP, hupser);
#endif
}

/*  */

#ifdef	SIGDEBUG
/* ARGSUSED */

static SFD  hupser (sig)
int	sig;
{
    char    buffer[BUFSIZ];
    PE	    p;

#ifndef	BSDSIGS
    (void) signal (SIGHUP, hupser);
#endif

    if (didhup == NOTOK) {
	didhup = OK;
	return;
    }

    advise (LLOG_EXCEPTIONS, NULLCP,
	    "sbrk=0x%x allocs=%d frees=%d most=%d",
	    sbrk (0), pe_allocs, pe_frees, pe_most);

    for (p = pe_active; p; p = p -> pe_link) {
	(void) sprintf (buffer, "active PE 0x%x (refcnt %d)", (caddr_t) p,
			p -> pe_refcnt);

	_vpdu (pgm_log, vunknown, p, buffer, -1);
    }
}
#endif

/*    CONFIG */

int	f_logging (), f_variable ();
#ifdef	EQUIV
int	f_equiv ();
#endif

static struct pair {
    char   *p_name;		/* runcom directive */
    IFP	    p_handler;		/* dispatch */
}	pairs[] = {
    "logging",	    f_logging,
    "variable",	    f_variable,
#ifdef	EQUIV
    "equivalence",  f_equiv,
#endif

    NULL
};

/*  */

static	readconfig () {
    register char *cp;
    char    buffer[BUFSIZ],
	    line[BUFSIZ],
	   *vec[NVEC + NSLACK + 1];
    register struct pair *p;
    struct stat st;
    FILE   *fp;

    cp = "snmpd.rc";
    if ((fp = fopen (cp, "r")) == NULL
	    && (fp = fopen (cp = isodefile (cp, 0), "r")) == NULL)
	adios (cp, "unable to read");

    if (!rflag
	    && getuid () == 0
	    && fstat (fileno (fp), &st) != NOTOK
	    && st.st_uid != 0)
	adios (NULLCP, "%s not owned by root", cp);

    while (fgets (buffer, sizeof buffer, fp)) {
	if (*buffer == '#')
	    continue;
	if (cp = index (buffer, '\n'))
	    *cp = NULL;
	(void) strcpy (line, buffer);

	bzero ((char *) vec, sizeof vec);
	if (str2vec (buffer, vec) < 1)
	    continue;
	for (p = pairs; p -> p_name; p++)
	    if (lexequ (p -> p_name, vec[0]) == 0) {
		if ((*p -> p_handler) (vec) == NOTOK)
		    advise (LLOG_EXCEPTIONS, NULLCP,
			    "malformed directive: \"%s\"", line);
		break;
	    }
	if (!p -> p_name)
	    advise (LLOG_EXCEPTIONS, NULLCP, "unknown directive: \"%s\"",
		    line);
    }

    (void) fclose (fp);
}

/*  */

static int  f_logging (vec)
char  **vec;
{
    register char  **vp;

    for (vp = ++vec; *vp; vp++)
	continue;

    log_tai (pgm_log, vec, vp - vec);

    return OK;
}

/*  */

static int  f_variable (vec)
char  **vec;
{
    if (*++vec == NULL)
	return NOTOK;

    if (lexequ (*vec, "interface") == 0) {
	char   *name;

	if (cflag)
	    return OK;
	    	
	if ((name = *++vec) == NULL)
	    return NOTOK;
	for (vec++; *vec; vec++)
	    if (index (*vec, '='))
		set_interface (name, *vec);
	    else
		return NOTOK;

	return OK;	
    }

    if (lexequ (*vec, "snmpEnableAuthenTraps") == 0) {
	++vec;

	if (lexequ (*vec, "enabled") == 0)
	    *((integer *) snmpstat.s_enableauthentraps) = TRAPS_ENABLED;
	else
	    if (lexequ (*vec, "disabled") == 0)
		*((integer *) snmpstat.s_enableauthentraps) = TRAPS_DISABLED;

	return OK;
    }

    if (!vec[0] || !vec[1] || vec[2])
	return NOTOK;

    set_variable (vec[0], vec[1]);

    return OK;
}

/*  */

#ifdef	EQUIV
static int  f_equiv (vec)
char  **vec;
{
    register struct equiv *eq;
    struct snmp_context   *r;
    OID	    oid1 = NULL,
	    oid2 = NULL,
	    oid3 = NULL;

    if (vec[1] == NULL
	    || (oid1 = text2oid (vec[1])) == NULL
	    || vec[2] == NULL
	    || (oid2 = text2oid (vec[2])) == NULL
	    || vec[3] == NULL
	    || (oid3 = text2oid (vec[3])) == NULL
	    || vec[4] == NULL) {
losing: ;
	if (oid1)
	    oid_free (oid1);
	if (oid2)
	    oid_free (oid2);
	if (oid3)
	    oid_free (oid3);
	return NOTOK;
    }
    if (lookup_party (oid1, AGENT) == NULL
	    || lookup_party (oid2, MANAGER) == NULL)
	goto losing;
    if ((r = lookup_context (oid3)) == NULL
	    || r -> sc_view <= 0
	    || r -> sc_location != AGENT)
	goto losing;

    if ((eq = (struct equiv *) calloc (1, sizeof *eq)) == NULL)
	adios (NULLCP, "out of memory");
    eq -> eq_next = eqHead, eqHead = eq;
    eq -> eq_commlen = strlen (eq -> eq_community = strdup (vec[4]));
    eq -> eq_target = oid1;
    eq -> eq_subject = oid2;
    eq -> eq_resources = oid3;

    return OK;
}
#endif

/*    ERRORS */

#ifndef	lint
void	adios (va_alist)
va_dcl
{
    va_list ap;

    va_start (ap);

    _ll_log (pgm_log, LLOG_FATAL, ap);

    va_end (ap);

    _exit (1);
}
#else
/* VARARGS */

void	adios (what, fmt)
char   *what,
       *fmt;
{
    adios (what, fmt);
}
#endif


#ifndef	lint
void	advise (va_alist)
va_dcl
{
    int	    code;
    va_list ap;

    va_start (ap);

    code = va_arg (ap, int);

    _ll_log (pgm_log, code, ap);

    va_end (ap);
}
#else
/* VARARGS */

void	advise (code, what, fmt)
char   *what,
       *fmt;
int	code;
{
    advise (code, what, fmt);
}
#endif

/*  */

#ifdef	MAGIC
/* taken from psap/pe2ps.c */


static PElement pe_eoc = { PE_CLASS_UNIV, PE_FORM_PRIM, PE_UNIV_EOC, 0 };
static int  pe2ps_aux2 ();
static int  ps_write_id ();
static int  ps_write_len ();

/*  */

static int  pe2ps_aux (ps, pe, eval)
register PS	ps;
register PE	pe;
int	eval;
{
    int     result;

    if (magicommand == MAGIC_INDFLEN)
	ps_len_strategy = PS_LEN_INDF;

    if (eval > 0)
	switch (pe -> pe_form) {
	    case PE_FORM_PRIM: 
	    case PE_FORM_ICONS: 
		break;

	    case PE_FORM_CONS: 
		(void) ps_get_abs (pe);
		break;
	}

    if (magicommand == MAGIC_INDFLEN)
	ps_len_strategy = PS_LEN_LONG;

    if (magicommand == MAGIC_UDPLESBER)
	pe -> pe_len++;
    if ((result = pe2ps_aux2 (ps, pe, eval)) != NOTOK) {
	if (magicommand == MAGIC_BERLESUDP)
	    (void) ps_write_aux (ps, (PElementData) "surprise!",
				 (PElementLen) strlen ("surprise!"), 1);

	result = ps_flush (ps);
    }

    return result;
}


static int  pe2ps_aux2 (ps, pe, eval)
register PS	ps;
register PE	pe;
int	eval;
{
    register PE	    p;

    if (pe -> pe_form == PE_FORM_ICONS) {
	if (ps_write_aux (ps, pe -> pe_prim, pe -> pe_len, 1) == NOTOK)
	    return NOTOK;

	return OK;
    }
    
    if (ps_write_id (ps, pe) == NOTOK || ps_write_len (ps, pe) == NOTOK)
	return NOTOK;

    switch (pe -> pe_form) {
	case PE_FORM_PRIM: 
	    if (ps_write_aux (ps, pe -> pe_prim, pe -> pe_len, 1) == NOTOK)
		return NOTOK;
	    break;

	case PE_FORM_CONS: 
	    if (eval < 0)
		    return OK;
	    if (pe -> pe_len) {
		for (p = pe -> pe_cons; p; p = p -> pe_next)
		    if (pe2ps_aux2 (ps, p, 0) == NOTOK)
			return NOTOK;

		if (pe -> pe_len == PE_LEN_INDF
			&& pe2ps_aux2 (ps, &pe_eoc, 0) == NOTOK)
		    return NOTOK;
	    }
	    break;
    }

    return OK;
}

/*  */

static int  ps_write_id (ps, pe)
register PS	ps;
register PE	pe;
{
    byte    buffer[1 + sizeof (PElementID)];
    register byte  *bp = buffer;
    PElementForm    form;
    register PElementID id;

    if ((form = pe -> pe_form) == PE_FORM_ICONS)
	form = PE_FORM_CONS;
    *bp = ((pe -> pe_class << PE_CLASS_SHIFT) & PE_CLASS_MASK)
		| ((form << PE_FORM_SHIFT) & PE_FORM_MASK);

    if ((id = pe -> pe_id) < PE_ID_XTND)
	*bp++ |= id;
    else {
	register byte *ep;
	register PElementID jd;

	*bp |= PE_ID_XTND;

	ep = buffer;
	for (jd = id; jd != 0; jd >>= PE_ID_SHIFT)
	    ep++;

	for (bp = ep; id != 0; id >>= PE_ID_SHIFT)
	    *bp-- = id & PE_ID_MASK;
	for (bp = buffer + 1; bp < ep; bp++)
	    *bp |= PE_ID_MORE;

	bp = ++ep;
    }

    if (ps_write (ps, buffer, bp - buffer) == NOTOK)
	return NOTOK;

    return OK;
}

/*  */

/* probably should integrate the non-PE_LEN_SMAX case with the algorithm in
   num2prim() for a single, unified routine */

static int  ps_write_len (ps, pe)
register PS	ps;
register PE	pe;
{
    byte    buffer[1 + sizeof (PElementLen)];
    register byte  *bp = buffer,
		   *ep;
    register PElementLen len;

    if ((len = pe -> pe_len) == PE_LEN_INDF)
	*bp++ = PE_LEN_XTND;
    else
	if (len <= PE_LEN_SMAX && magicommand != MAGIC_NOTMINLEN)
	    *bp++ = len & 0xff;
	else {
	    ep = buffer + sizeof buffer - 1;
	    for (bp = ep; len != 0 && buffer < bp; len >>= 8)
		*bp-- = len & 0xff;
	    if (magicommand == MAGIC_NOTMINLEN) {
		if (pe -> pe_len == 0)
		    *bp-- = 0;
		if ((ep - bp) < sizeof (PElementLen))
		    *bp-- = 0;
	    }
	    *bp = PE_LEN_XTND | ((ep - bp) & 0xff);
	    if (ps_write (ps, bp, ep - bp + 1) == NOTOK)
		return NOTOK;

	    return OK;
	}

    if (ps_write (ps, buffer, bp - buffer) == NOTOK)
	return NOTOK;

    return OK;
}

/*  */

/* taken from psap/ps_get_abs.c */

static  int	ps_get_abs (pe)
register PE	pe;
{
    register    PElementLen len;
    register    PE p;

    switch (pe -> pe_form) {
	case PE_FORM_PRIM: 
	    len = pe -> pe_len;
	    break;

	case PE_FORM_CONS: 
	    len = 0;
	    for (p = pe -> pe_cons; p; p = p -> pe_next)
		len += ps_get_abs (p);

	    switch (ps_len_strategy) {
		case PS_LEN_SPAG: 
		default: 
		    if (len <= PE_LEN_SMAX) {
			pe -> pe_len = len;
			break;
		    }		/* else fall */

		case PS_LEN_INDF: 
		    pe -> pe_len = PE_LEN_INDF;
		    len += 2;	/* for EOC */
		    break;

		case PS_LEN_LONG: 
		    pe -> pe_len = len;
		    break;
	    }
	    break;

	case PE_FORM_ICONS:
	    return pe -> pe_len;
    }

    return (ps_get_id (pe) + ps_get_len (pe) + len);
}

/*  */

static int  ps_get_id (pe)
register PE	pe;
{
    register int    i;
    register PElementID id;

    if ((id = pe -> pe_id) < PE_ID_XTND)
	return 1;

    for (i = 1; id != 0; id >>= PE_ID_SHIFT)
	i++;
    return i;
}

/*  */

static int  ps_get_len (pe)
register PE	pe;
{
    register int    i;
    register PElementLen len;

    if ((len = pe -> pe_len) == PE_LEN_INDF || len <= PE_LEN_SMAX)
	return ((magicommand == MAGIC_NOTMINLEN) ? 3 : 1);

    for (i = 1; len > 0; len >>= 8)
	i++;
    if ((magicommand == MAGIC_NOTMINLEN) && (i <= sizeof (PElementLen)))
	i++;
    return i;
}
#endif
