#!/usr/local/bin/snmptcl -f

if {![info exists snmptcl_loaded(browsing.tcl)]} {
    if {[file readable browsing.tcl]} {
	source			browsing.tcl
    } else {
	source			$snmptcl_library/browsing.tcl
    }
}

if {[info exists snmptcl_loaded(bsdunix-browse.tcl)]} {
    return
}
set	snmptcl_loaded(bsdunix-browse.tcl)	1


#
# turn on "Applications" menu
#

.title.apps	configure	-state normal
.title.apps.menu \
		add cascade	-label "BSDUNIX MIB browse" \
				-menu [set menu .title.apps.menu.bsdunix]
menu		$menu


#
# Printer queue
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Printer queue for $snmptcl_context" pqueue {
{ printQStatus			Status			}
{ printQDisplay			Display			}
{ printQEntries			Entries			}
} 60 {snmptcl_browsetable_command Queue {}}} \
				-label "Printer queue"

set	snmptcl_print_object(printQStatus)	snmptcl_print_printQStatus

proc	snmptcl_print_printQStatus	{var data}	{
    upvar	$data	info

    set		value		[lindex $info 4]
    set	    	privs		""
    foreach	priv		{ {queuingOk 1} {printingOk 2} {daemonOk 4}} {
	if {[lindex $priv 1] & $value} {
	    lappend	privs	[lindex $priv 0]
	}
    }

    return	"[join $privs {, }] ($value)"
}


#
# Printer jobs
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Printer jobs for $snmptcl_context" pjobs {
{ printJName			Name			}
{ printJOwner			Owner			}
{ printJDescription		Description		}
{ printJSize			Size			}
} 60 {snmptcl_browsetable_command "Q Name/Rank" {}}} \
				-label "Printer jobs"

$menu		add separator


#
# Users
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Users for $snmptcl_context" users {
{ userID			ID			}
{ userGroup			Group			}
{ userQuota			Quota			}
{ userComment			Comment			}
{ userFullName			"Full Name"		}
{ userHome			Home			}
{ userShell			Shell			}
} 300 {snmptcl_browsetable_command Name {}}} \
				-label Users


#
# Groups
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Groups for $snmptcl_context" groups {
{ groupID			ID			}
} 300 {snmptcl_browsetable_command Name {}}} \
				-label "Groups"


#
# Group users
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Group users for $snmptcl_context" grusers {
{ grNewUserStatus		Status			}
} 300 {snmptcl_browsetable_command "Group           User" snmptcl_print_gruser}} \
				-label "Group users"

proc	snmptcl_print_gruser	{inst}	{
    if {[llength $inst] != 2} {
	return		$inst
    }

    return	[format "%-8s %s" [lindex $inst 0] [lindex $inst 1]]
}

$menu		add separator


#
# Filesystems
#

$menu		add command	-command {snmptcl_proc_browsetable $snmptcl_agent 1 "Filesystems for $snmptcl_context" filesys {
{ fsName			Name			}
{ fsMountPoint			Mount			}
{ fsMountType			Type			}
{ fsMountOptions		Options			}
{ fsBlockSize			BSize			}
{ fsBlockCount			BCount			}
{ fsBlocksFree			BFree			}
{ fsBlocksAvailable		BAvail			}
{ fsInodeCount			Inodes			}
{ fsInodesAvailable		IAvail			}
} 120 {snmptcl_browsetable_command "fs #" {}}} \
				-label "Filesystems"