if {[info exists snmptcl_loaded(APPLICATION-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(APPLICATION-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(RFC1213-MIB.tcl)]} {
    if {[file readable RFC1213-MIB.tcl]} {
	source RFC1213-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/RFC1213-MIB.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {[catch { snmpinfo mibprop application value }]} {
    if {[file readable APPLICATION-MIB.defs]} {
	snmpmisc mibload APPLICATION-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/APPLICATION-MIB.defs
    }
}

snmpmisc mibgroup APPLICATION-MIB applGroup \
    applName \
    applVersion \
    applUptime \
    applOperStatus \
    applLastChange \
    applInboundAssociations \
    applOutboundAssociations \
    applAccumulatedInboundAssociations \
    applAccumulatedOutboundAssociations \
    applLastInboundActivity \
    applLastOutboundActivity \
    applRejectedInboundAssociations \
    applFailedOutboundAssociations

snmpmisc mibgroup APPLICATION-MIB assocGroup \
    assocRemoteApplication \
    assocApplicationProtocol \
    assocApplicationType \
    assocDuration
