if {[info exists snmptcl_loaded(DSA-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(DSA-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {![info exists snmptcl_loaded(RFC1213-MIB.tcl)]} {
    if {[file readable RFC1213-MIB.tcl]} {
	source RFC1213-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/RFC1213-MIB.tcl }
    }
}

if {![info exists snmptcl_loaded(APPLICATION-MIB.tcl)]} {
    if {[file readable APPLICATION-MIB.tcl]} {
	source APPLICATION-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/APPLICATION-MIB.tcl }
    }
}

if {[catch { snmpinfo mibprop dsaMIB value }]} {
    if {[file readable DSA-MIB.defs]} {
	snmpmisc mibload DSA-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/DSA-MIB.defs
    }
}

snmpmisc mibgroup DSA-MIB dsaOpsGroup \
    dsaAnonymousBinds \
    dsaUnauthBinds \
    dsaSimpleAuthBinds \
    dsaStrongAuthBinds \
    dsaBindSecurityErrors \
    dsaInOps \
    dsaReadOps \
    dsaCompareOps \
    dsaAddEntryOps \
    dsaRemoveEntryOps \
    dsaModifyEntryOps \
    dsaModifyRDNOps \
    dsaListOps \
    dsaSearchOps \
    dsaOneLevelSearchOps \
    dsaWholeTreeSearchOps \
    dsaReferrals \
    dsaChainings \
    dsaSecurityErrors \
    dsaErrors

snmpmisc mibgroup DSA-MIB dsaEntryGroup \
    dsaMasterEntries \
    dsaCopyEntries \
    dsaCacheEntries \
    dsaCacheHits \
    dsaSlaveHits

snmpmisc mibgroup DSA-MIB dsaIntGroup \
    dsaName \
    dsaTimeOfCreation \
    dsaTimeOfLastAttempt \
    dsaTimeOfLastSuccess \
    dsaFailuresSinceLastSuccess \
    dsaFailures \
    dsaSuccesses
