if {[info exists snmptcl_loaded(MTA-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(MTA-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {![info exists snmptcl_loaded(RFC1213-MIB.tcl)]} {
    if {[file readable RFC1213-MIB.tcl]} {
	source RFC1213-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/RFC1213-MIB.tcl }
    }
}

if {![info exists snmptcl_loaded(APPLICATION-MIB.tcl)]} {
    if {[file readable APPLICATION-MIB.tcl]} {
	source APPLICATION-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/APPLICATION-MIB.tcl }
    }
}

if {[catch { snmpinfo mibprop mta value }]} {
    if {[file readable MTA-MIB.defs]} {
	snmpmisc mibload MTA-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/MTA-MIB.defs
    }
}

snmpmisc mibgroup MTA-MIB mtaGroup \
    mtaReceivedMessages \
    mtaStoredMessages \
    mtaTransmittedMessages \
    mtaReceivedVolume \
    mtaStoredVolume \
    mtaTransmittedVolume \
    mtaReceivedRecipients \
    mtaStoredRecipients \
    mtaTransmittedRecipients \
    mtaGroupReceivedMessages \
    mtaGroupRejectedMessages \
    mtaGroupStoredMessages \
    mtaGroupTransmittedMessages \
    mtaGroupReceivedVolume \
    mtaGroupStoredVolume \
    mtaGroupTransmittedVolume \
    mtaGroupReceivedRecipients \
    mtaGroupStoredRecipients \
    mtaGroupTransmittedRecipients \
    mtaGroupOldestMessageStored \
    mtaGroupInboundAssociations \
    mtaGroupOutboundAssociations \
    mtaGroupAccumulatedInboundAssociations \
    mtaGroupAccumulatedOutboundAssociations \
    mtaGroupLastInboundActivity \
    mtaGroupLastOutboundActivity \
    mtaGroupRejectedInboundAssociations \
    mtaGroupFailedOutboundAssociations \
    mtaGroupInboundRejectionReason \
    mtaGroupOutboundConnectFailureReason \
    mtaGroupScheduledRetry \
    mtaGroupMailProtocol \
    mtaGroupName

snmpmisc mibgroup MTA-MIB mtaAssocGroup \
    mtaGroupAssociationIndex
