if {[info exists snmptcl_loaded(SNMPv2-M2M-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(SNMPv2-M2M-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-CONF.tcl)]} {
    if {[file readable SNMPv2-CONF.tcl]} {
	source SNMPv2-CONF.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-CONF.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-PARTY-MIB.tcl)]} {
    if {[file readable SNMPv2-PARTY-MIB.tcl]} {
	source SNMPv2-PARTY-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-PARTY-MIB.tcl }
    }
}

if {[catch { snmpinfo mibprop snmpM2M value }]} {
    if {[file readable SNMPv2-M2M-MIB.defs]} {
	snmpmisc mibload SNMPv2-M2M-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/SNMPv2-M2M-MIB.defs
    }
}

snmpmisc mibgroup SNMPv2-M2M-MIB snmpAlarmGroup \
    snmpAlarmNextIndex \
    snmpAlarmVariable \
    snmpAlarmInterval \
    snmpAlarmSampleType \
    snmpAlarmValue \
    snmpAlarmStartupAlarm \
    snmpAlarmRisingThreshold \
    snmpAlarmFallingThreshold \
    snmpAlarmRisingEventIndex \
    snmpAlarmFallingEventIndex \
    snmpAlarmUnavailableEventIndex \
    snmpAlarmStatus

snmpmisc mibgroup SNMPv2-M2M-MIB snmpEventGroup \
    snmpEventNextIndex \
    snmpEventID \
    snmpEventDescription \
    snmpEventEvents \
    snmpEventLastTimeSent \
    snmpEventStatus \
    snmpEventNotifyMinInterval \
    snmpEventNotifyMaxRetransmissions \
    snmpEventNotifyIntervalRequested \
    snmpEventNotifyRetransmissionsRequested \
    snmpEventNotifyLifetime \
    snmpEventNotifyStatus
