if {[info exists snmptcl_loaded(SNMPv2-MIB.tcl)]} {
    return
}
set	snmptcl_loaded(SNMPv2-MIB.tcl)	1

if {![info exists snmptcl_loaded(SNMPv2-SMI.tcl)]} {
    if {[file readable SNMPv2-SMI.tcl]} {
	source SNMPv2-SMI.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-SMI.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-TC.tcl)]} {
    if {[file readable SNMPv2-TC.tcl]} {
	source SNMPv2-TC.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-TC.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-CONF.tcl)]} {
    if {[file readable SNMPv2-CONF.tcl]} {
	source SNMPv2-CONF.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-CONF.tcl }
    }
}

if {![info exists snmptcl_loaded(RFC1213-MIB.tcl)]} {
    if {[file readable RFC1213-MIB.tcl]} {
	source RFC1213-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/RFC1213-MIB.tcl }
    }
}

if {![info exists snmptcl_loaded(SNMPv2-PARTY-MIB.tcl)]} {
    if {[file readable SNMPv2-PARTY-MIB.tcl]} {
	source SNMPv2-PARTY-MIB.tcl
    } else {
	catch { source $snmptcl_library/mibs/SNMPv2-PARTY-MIB.tcl }
    }
}

if {[catch { snmpinfo mibprop snmpMIB value }]} {
    if {[file readable SNMPv2-MIB.defs]} {
	snmpmisc mibload SNMPv2-MIB.defs
    } else {
	snmpmisc mibload /usr/include/isode/snmp/SNMPv2-MIB.defs
    }
}

snmpmisc mibgroup SNMPv2-MIB snmpStatsGroup \
    snmpStatsPackets \
    snmpStats30Something \
    snmpStatsEncodingErrors \
    snmpStatsUnknownDstParties \
    snmpStatsDstPartyMismatches \
    snmpStatsUnknownSrcParties \
    snmpStatsBadAuths \
    snmpStatsNotInLifetimes \
    snmpStatsWrongDigestValues \
    snmpStatsUnknownContexts \
    snmpStatsBadOperations \
    snmpStatsSilentDrops

snmpmisc mibgroup SNMPv2-MIB snmpV1Group \
    snmpV1BadCommunityNames \
    snmpV1BadCommunityUses

snmpmisc mibgroup SNMPv2-MIB snmpORGroup \
    snmpORLastChange \
    snmpORID \
    snmpORDescr

snmpmisc mibgroup SNMPv2-MIB snmpTrapGroup \
    snmpTrapNumbers \
    snmpV2EnableAuthenTraps

snmpmisc mibgroup SNMPv2-MIB snmpSetGroup \
    snmpSetSerialNo
