: run this script through /bin/sh

if [ "$#" != 2 ]; then
    echo "usage: test-manager.sh test key"		1>&2
    exit 1
fi

T="interfaces table"
case $1 in
    none)	S=none T=
		;;
    2.1.1)	S=lexiBroken
		;;
    2.1.2.1)	S=none L="ifLastChange"
		;;
    2.1.2.2)	S=cellMissing L="ifDescr"
		;;
    2.1.2.3)	S=newRow
		;;
    2.1.3)	S=longRow T="iSODETestTable"
		;;
    2.1.4)	S=tooBig
		;;
    2.1.5.1)	S=wrongTag L="ifDescr"
		;;
    2.1.5.2)	S=notMinLen
		;;
    2.1.5.3)	S=tooSmallInt T="iSODETestTable" L="iSODETestInteger"
		;;
    2.1.5.4)	S=tooBigInt T="iSODETestTable" L="iSODETestInteger"
		;;
    2.1.5.5)	S=notAnEnum L="ifType"
		;;
    2.1.5.6)	S=nonAscii L="ifDescr"
		;;
    2.1.5.7)	S=notCrNullOrLf L="ifDescr"
		;;
    2.1.5.8)	S=conString L="ifDescr"
		;;
    2.1.5.9)	S=tooSmallStr T="iSODETestTable" L="iSODETestString"
		;;
    2.1.5.10)	S=tooBigStr T="iSODETestTable" L="iSODETestString"
		;;
    2.1.6.1)	S=indfLen
		;;
    2.1.6.2)	S=sendResponse
		;;
    2.1.6.3)	S=readOnly
		;;
    2.1.6.4)	S=varVarBinds
		;;
    2.1.6.5)	S=varNameBinds
		;;
    2.1.6.6)	S=varValueBinds T=
		;;
    2.1.6.7)	S=berLesUdp
		;;
    2.1.6.8)	S=udpLesBer
		;;
    2.1.7.1)	S=sendGet
		;;
    2.1.7.2)	S=sendNext
		;;
    2.1.7.3)	S=sendSet
		;;
    2.1.7.4)	S=sendXxx
		;;
    2.1.8.1)	S=bigCounter L="ifInUcastPkts"
		;;
    2.1.8.2)	S=rollCounter L="ifInUcastPkts"
		;;
    2.1.9)	S=bigGauge L="ifSpeed"
		;;

   *)		echo "unknown test $1"			1>&2
		exit 1
		;;
esac

if snmpi -p manager -a 3 -m 4 set iSODEPartyTestMode.$2=$S;then
    if [ ! -z "$T" ]; then
	echo "start sweeping $T"
    fi
    if [ ! -z "$L" ]; then
	echo "pay attention to $L"
    fi
else
    echo "you losing"					1>&2
    exit 1
fi
