/* compiled */

#include <stdio.h>
#include "objects.h"

static unsigned int _elems[] = {
      0, 0, /* ccitt */ 
      1, 0, /* iso */ 
      1, 3, 6, 1, 0, /* internet */ 
      1, 3, 6, 1, 1, 0, /* directory */ 
      1, 3, 6, 1, 2, 0, /* mgmt */ 
      1, 3, 6, 1, 2, 1, 0, /* mib-2 */ 
      1, 3, 6, 1, 2, 1, 1, 0, /* system */ 
      1, 3, 6, 1, 2, 1, 1, 1, 0, /* sysDescr */ 
      1, 3, 6, 1, 2, 1, 1, 2, 0, /* sysObjectID */ 
      1, 3, 6, 1, 2, 1, 1, 3, 0, /* sysUpTime */ 
      1, 3, 6, 1, 2, 1, 1, 4, 0, /* sysContact */ 
      1, 3, 6, 1, 2, 1, 1, 5, 0, /* sysName */ 
      1, 3, 6, 1, 2, 1, 1, 6, 0, /* sysLocation */ 
      1, 3, 6, 1, 2, 1, 1, 7, 0, /* sysServices */ 
      1, 3, 6, 1, 2, 1, 2, 0, /* interfaces */ 
      1, 3, 6, 1, 2, 1, 2, 1, 0, /* ifNumber */ 
      1, 3, 6, 1, 2, 1, 2, 2, 0, /* ifTable */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 0, /* ifEntry */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 1, 0, /* ifIndex */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 2, 0, /* ifDescr */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 3, 0, /* ifType */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 4, 0, /* ifMtu */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 5, 0, /* ifSpeed */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 6, 0, /* ifPhysAddress */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 7, 0, /* ifAdminStatus */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 8, 0, /* ifOperStatus */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 9, 0, /* ifLastChange */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 10, 0, /* ifInOctets */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 11, 0, /* ifInUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 12, 0, /* ifInNUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 13, 0, /* ifInDiscards */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 14, 0, /* ifInErrors */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 15, 0, /* ifInUnknownProtos */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 16, 0, /* ifOutOctets */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 17, 0, /* ifOutUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 18, 0, /* ifOutNUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 19, 0, /* ifOutDiscards */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 20, 0, /* ifOutErrors */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 21, 0, /* ifOutQLen */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 22, 0, /* ifSpecific */ 
      1, 3, 6, 1, 2, 1, 3, 0, /* at */ 
      1, 3, 6, 1, 2, 1, 3, 1, 0, /* atTable */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 0, /* atEntry */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 1, 0, /* atIfIndex */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 2, 0, /* atPhysAddress */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 3, 0, /* atNetAddress */ 
      1, 3, 6, 1, 2, 1, 4, 0, /* ip */ 
      1, 3, 6, 1, 2, 1, 4, 1, 0, /* ipForwarding */ 
      1, 3, 6, 1, 2, 1, 4, 2, 0, /* ipDefaultTTL */ 
      1, 3, 6, 1, 2, 1, 4, 3, 0, /* ipInReceives */ 
      1, 3, 6, 1, 2, 1, 4, 4, 0, /* ipInHdrErrors */ 
      1, 3, 6, 1, 2, 1, 4, 5, 0, /* ipInAddrErrors */ 
      1, 3, 6, 1, 2, 1, 4, 6, 0, /* ipForwDatagrams */ 
      1, 3, 6, 1, 2, 1, 4, 7, 0, /* ipInUnknownProtos */ 
      1, 3, 6, 1, 2, 1, 4, 8, 0, /* ipInDiscards */ 
      1, 3, 6, 1, 2, 1, 4, 9, 0, /* ipInDelivers */ 
      1, 3, 6, 1, 2, 1, 4, 10, 0, /* ipOutRequests */ 
      1, 3, 6, 1, 2, 1, 4, 11, 0, /* ipOutDiscards */ 
      1, 3, 6, 1, 2, 1, 4, 12, 0, /* ipOutNoRoutes */ 
      1, 3, 6, 1, 2, 1, 4, 13, 0, /* ipReasmTimeout */ 
      1, 3, 6, 1, 2, 1, 4, 14, 0, /* ipReasmReqds */ 
      1, 3, 6, 1, 2, 1, 4, 15, 0, /* ipReasmOKs */ 
      1, 3, 6, 1, 2, 1, 4, 16, 0, /* ipReasmFails */ 
      1, 3, 6, 1, 2, 1, 4, 17, 0, /* ipFragOKs */ 
      1, 3, 6, 1, 2, 1, 4, 18, 0, /* ipFragFails */ 
      1, 3, 6, 1, 2, 1, 4, 19, 0, /* ipFragCreates */ 
      1, 3, 6, 1, 2, 1, 4, 20, 0, /* ipAddrTable */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 0, /* ipAddrEntry */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 1, 0, /* ipAdEntAddr */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 2, 0, /* ipAdEntIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 3, 0, /* ipAdEntNetMask */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 4, 0, /* ipAdEntBcastAddr */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 5, 0, /* ipAdEntReasmMaxSize */ 
      1, 3, 6, 1, 2, 1, 4, 21, 0, /* ipRouteTable */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 0, /* ipRouteEntry */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 1, 0, /* ipRouteDest */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 2, 0, /* ipRouteIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 3, 0, /* ipRouteMetric1 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 4, 0, /* ipRouteMetric2 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 5, 0, /* ipRouteMetric3 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 6, 0, /* ipRouteMetric4 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 7, 0, /* ipRouteNextHop */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 8, 0, /* ipRouteType */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 9, 0, /* ipRouteProto */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 10, 0, /* ipRouteAge */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 11, 0, /* ipRouteMask */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 12, 0, /* ipRouteMetric5 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 13, 0, /* ipRouteInfo */ 
      1, 3, 6, 1, 2, 1, 4, 22, 0, /* ipNetToMediaTable */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 0, /* ipNetToMediaEntry */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 1, 0, /* ipNetToMediaIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 2, 0, /* ipNetToMediaPhysAddress */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 3, 0, /* ipNetToMediaNetAddress */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 4, 0, /* ipNetToMediaType */ 
      1, 3, 6, 1, 2, 1, 4, 23, 0, /* ipRoutingDiscards */ 
      1, 3, 6, 1, 2, 1, 4, 24, 0, /* ipForward */ 
      1, 3, 6, 1, 2, 1, 4, 24, 1, 0, /* ipForwardNumber */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 0, /* ipForwardTable */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 0, /* ipForwardEntry */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 1, 0, /* ipForwardDest */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 2, 0, /* ipForwardMask */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 3, 0, /* ipForwardPolicy */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 4, 0, /* ipForwardNextHop */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 5, 0, /* ipForwardIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 6, 0, /* ipForwardType */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 7, 0, /* ipForwardProto */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 8, 0, /* ipForwardAge */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 9, 0, /* ipForwardInfo */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 10, 0, /* ipForwardNextHopAS */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 11, 0, /* ipForwardMetric1 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 12, 0, /* ipForwardMetric2 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 13, 0, /* ipForwardMetric3 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 14, 0, /* ipForwardMetric4 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 15, 0, /* ipForwardMetric5 */ 
      1, 3, 6, 1, 2, 1, 5, 0, /* icmp */ 
      1, 3, 6, 1, 2, 1, 5, 1, 0, /* icmpInMsgs */ 
      1, 3, 6, 1, 2, 1, 5, 2, 0, /* icmpInErrors */ 
      1, 3, 6, 1, 2, 1, 5, 3, 0, /* icmpInDestUnreachs */ 
      1, 3, 6, 1, 2, 1, 5, 4, 0, /* icmpInTimeExcds */ 
      1, 3, 6, 1, 2, 1, 5, 5, 0, /* icmpInParmProbs */ 
      1, 3, 6, 1, 2, 1, 5, 6, 0, /* icmpInSrcQuenchs */ 
      1, 3, 6, 1, 2, 1, 5, 7, 0, /* icmpInRedirects */ 
      1, 3, 6, 1, 2, 1, 5, 8, 0, /* icmpInEchos */ 
      1, 3, 6, 1, 2, 1, 5, 9, 0, /* icmpInEchoReps */ 
      1, 3, 6, 1, 2, 1, 5, 10, 0, /* icmpInTimestamps */ 
      1, 3, 6, 1, 2, 1, 5, 11, 0, /* icmpInTimestampReps */ 
      1, 3, 6, 1, 2, 1, 5, 12, 0, /* icmpInAddrMasks */ 
      1, 3, 6, 1, 2, 1, 5, 13, 0, /* icmpInAddrMaskReps */ 
      1, 3, 6, 1, 2, 1, 5, 14, 0, /* icmpOutMsgs */ 
      1, 3, 6, 1, 2, 1, 5, 15, 0, /* icmpOutErrors */ 
      1, 3, 6, 1, 2, 1, 5, 16, 0, /* icmpOutDestUnreachs */ 
      1, 3, 6, 1, 2, 1, 5, 17, 0, /* icmpOutTimeExcds */ 
      1, 3, 6, 1, 2, 1, 5, 18, 0, /* icmpOutParmProbs */ 
      1, 3, 6, 1, 2, 1, 5, 19, 0, /* icmpOutSrcQuenchs */ 
      1, 3, 6, 1, 2, 1, 5, 20, 0, /* icmpOutRedirects */ 
      1, 3, 6, 1, 2, 1, 5, 21, 0, /* icmpOutEchos */ 
      1, 3, 6, 1, 2, 1, 5, 22, 0, /* icmpOutEchoReps */ 
      1, 3, 6, 1, 2, 1, 5, 23, 0, /* icmpOutTimestamps */ 
      1, 3, 6, 1, 2, 1, 5, 24, 0, /* icmpOutTimestampReps */ 
      1, 3, 6, 1, 2, 1, 5, 25, 0, /* icmpOutAddrMasks */ 
      1, 3, 6, 1, 2, 1, 5, 26, 0, /* icmpOutAddrMaskReps */ 
      1, 3, 6, 1, 2, 1, 6, 0, /* tcp */ 
      1, 3, 6, 1, 2, 1, 6, 1, 0, /* tcpRtoAlgorithm */ 
      1, 3, 6, 1, 2, 1, 6, 2, 0, /* tcpRtoMin */ 
      1, 3, 6, 1, 2, 1, 6, 3, 0, /* tcpRtoMax */ 
      1, 3, 6, 1, 2, 1, 6, 4, 0, /* tcpMaxConn */ 
      1, 3, 6, 1, 2, 1, 6, 5, 0, /* tcpActiveOpens */ 
      1, 3, 6, 1, 2, 1, 6, 6, 0, /* tcpPassiveOpens */ 
      1, 3, 6, 1, 2, 1, 6, 7, 0, /* tcpAttemptFails */ 
      1, 3, 6, 1, 2, 1, 6, 8, 0, /* tcpEstabResets */ 
      1, 3, 6, 1, 2, 1, 6, 9, 0, /* tcpCurrEstab */ 
      1, 3, 6, 1, 2, 1, 6, 10, 0, /* tcpInSegs */ 
      1, 3, 6, 1, 2, 1, 6, 11, 0, /* tcpOutSegs */ 
      1, 3, 6, 1, 2, 1, 6, 12, 0, /* tcpRetransSegs */ 
      1, 3, 6, 1, 2, 1, 6, 13, 0, /* tcpConnTable */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 0, /* tcpConnEntry */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 1, 0, /* tcpConnState */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 2, 0, /* tcpConnLocalAddress */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 3, 0, /* tcpConnLocalPort */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 4, 0, /* tcpConnRemAddress */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 5, 0, /* tcpConnRemPort */ 
      1, 3, 6, 1, 2, 1, 6, 14, 0, /* tcpInErrs */ 
      1, 3, 6, 1, 2, 1, 6, 15, 0, /* tcpOutRsts */ 
      1, 3, 6, 1, 2, 1, 7, 0, /* udp */ 
      1, 3, 6, 1, 2, 1, 7, 1, 0, /* udpInDatagrams */ 
      1, 3, 6, 1, 2, 1, 7, 2, 0, /* udpNoPorts */ 
      1, 3, 6, 1, 2, 1, 7, 3, 0, /* udpInErrors */ 
      1, 3, 6, 1, 2, 1, 7, 4, 0, /* udpOutDatagrams */ 
      1, 3, 6, 1, 2, 1, 7, 5, 0, /* udpTable */ 
      1, 3, 6, 1, 2, 1, 7, 5, 1, 0, /* udpEntry */ 
      1, 3, 6, 1, 2, 1, 7, 5, 1, 1, 0, /* udpLocalAddress */ 
      1, 3, 6, 1, 2, 1, 7, 5, 1, 2, 0, /* udpLocalPort */ 
      1, 3, 6, 1, 2, 1, 8, 0, /* egp */ 
      1, 3, 6, 1, 2, 1, 8, 1, 0, /* egpInMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 2, 0, /* egpInErrors */ 
      1, 3, 6, 1, 2, 1, 8, 3, 0, /* egpOutMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 4, 0, /* egpOutErrors */ 
      1, 3, 6, 1, 2, 1, 8, 5, 0, /* egpNeighTable */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 0, /* egpNeighEntry */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 1, 0, /* egpNeighState */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 2, 0, /* egpNeighAddr */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 3, 0, /* egpNeighAs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 4, 0, /* egpNeighInMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 5, 0, /* egpNeighInErrs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 6, 0, /* egpNeighOutMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 7, 0, /* egpNeighOutErrs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 8, 0, /* egpNeighInErrMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 9, 0, /* egpNeighOutErrMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 10, 0, /* egpNeighStateUps */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 11, 0, /* egpNeighStateDowns */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 12, 0, /* egpNeighIntervalHello */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 13, 0, /* egpNeighIntervalPoll */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 14, 0, /* egpNeighMode */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 15, 0, /* egpNeighEventTrigger */ 
      1, 3, 6, 1, 2, 1, 8, 6, 0, /* egpAs */ 
      1, 3, 6, 1, 2, 1, 10, 0, /* transmission */ 
      1, 3, 6, 1, 2, 1, 10, 5, 0, /* x25 */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 0, /* x25AdmnTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 0, /* x25AdmnEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 1, 0, /* x25AdmnIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 2, 0, /* x25AdmnInterfaceMode */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 3, 0, /* x25AdmnMaxActiveCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 4, 0, /* x25AdmnPacketSequencing */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 5, 0, /* x25AdmnRestartTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 6, 0, /* x25AdmnCallTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 7, 0, /* x25AdmnResetTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 8, 0, /* x25AdmnClearTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 9, 0, /* x25AdmnWindowTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 10, 0, /* x25AdmnDataRxmtTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 11, 0, /* x25AdmnInterruptTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 12, 0, /* x25AdmnRejectTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 13, 0, /* x25AdmnRegistrationRequestTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 14, 0, /* x25AdmnMinimumRecallTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 15, 0, /* x25AdmnRestartCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 16, 0, /* x25AdmnResetCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 17, 0, /* x25AdmnClearCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 18, 0, /* x25AdmnDataRxmtCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 19, 0, /* x25AdmnRejectCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 20, 0, /* x25AdmnRegistrationRequestCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 21, 0, /* x25AdmnNumberPVCs */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 22, 0, /* x25AdmnDefCallParamId */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 23, 0, /* x25AdmnLocalAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 1, 1, 24, 0, /* x25AdmnProtocolVersionSupported */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 0, /* x25OperTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 0, /* x25OperEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 1, 0, /* x25OperIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 2, 0, /* x25OperInterfaceMode */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 3, 0, /* x25OperMaxActiveCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 4, 0, /* x25OperPacketSequencing */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 5, 0, /* x25OperRestartTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 6, 0, /* x25OperCallTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 7, 0, /* x25OperResetTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 8, 0, /* x25OperClearTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 9, 0, /* x25OperWindowTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 10, 0, /* x25OperDataRxmtTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 11, 0, /* x25OperInterruptTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 12, 0, /* x25OperRejectTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 13, 0, /* x25OperRegistrationRequestTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 14, 0, /* x25OperMinimumRecallTimer */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 15, 0, /* x25OperRestartCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 16, 0, /* x25OperResetCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 17, 0, /* x25OperClearCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 18, 0, /* x25OperDataRxmtCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 19, 0, /* x25OperRejectCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 20, 0, /* x25OperRegistrationRequestCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 21, 0, /* x25OperNumberPVCs */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 22, 0, /* x25OperDefCallParamId */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 23, 0, /* x25OperLocalAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 24, 0, /* x25OperDataLinkId */ 
      1, 3, 6, 1, 2, 1, 10, 5, 2, 1, 25, 0, /* x25OperProtocolVersionSupported */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 0, /* x25StatTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 0, /* x25StatEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 1, 0, /* x25StatIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 2, 0, /* x25StatInCalls */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 3, 0, /* x25StatInCallRefusals */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 4, 0, /* x25StatInProviderInitiatedClears */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 5, 0, /* x25StatInRemotelyInitiatedResets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 6, 0, /* x25StatInProviderInitiatedResets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 7, 0, /* x25StatInRestarts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 8, 0, /* x25StatInDataPackets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 9, 0, /* x25StatInAccusedOfProtocolErrors */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 10, 0, /* x25StatInInterrupts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 11, 0, /* x25StatOutCallAttempts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 12, 0, /* x25StatOutCallFailures */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 13, 0, /* x25StatOutInterrupts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 14, 0, /* x25StatOutDataPackets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 15, 0, /* x25StatOutgoingCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 16, 0, /* x25StatIncomingCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 17, 0, /* x25StatTwowayCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 18, 0, /* x25StatRestartTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 19, 0, /* x25StatCallTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 20, 0, /* x25StatResetTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 21, 0, /* x25StatClearTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 22, 0, /* x25StatDataRxmtTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 23, 0, /* x25StatInterruptTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 24, 0, /* x25StatRetryCountExceededs */ 
      1, 3, 6, 1, 2, 1, 10, 5, 3, 1, 25, 0, /* x25StatClearCountExceededs */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 0, /* x25ChannelTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 0, /* x25ChannelEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 1, 0, /* x25ChannelIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 2, 0, /* x25ChannelLIC */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 3, 0, /* x25ChannelHIC */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 4, 0, /* x25ChannelLTC */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 5, 0, /* x25ChannelHTC */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 6, 0, /* x25ChannelLOC */ 
      1, 3, 6, 1, 2, 1, 10, 5, 4, 1, 7, 0, /* x25ChannelHOC */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 0, /* x25CircuitTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 0, /* x25CircuitEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 1, 0, /* x25CircuitIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 2, 0, /* x25CircuitChannel */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 3, 0, /* x25CircuitStatus */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 4, 0, /* x25CircuitEstablishTime */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 5, 0, /* x25CircuitDirection */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 6, 0, /* x25CircuitInOctets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 7, 0, /* x25CircuitInPdus */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 8, 0, /* x25CircuitInRemotelyInitiatedResets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 9, 0, /* x25CircuitInProviderInitiatedResets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 10, 0, /* x25CircuitInInterrupts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 11, 0, /* x25CircuitOutOctets */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 12, 0, /* x25CircuitOutPdus */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 13, 0, /* x25CircuitOutInterrupts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 14, 0, /* x25CircuitDataRetransmissionTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 15, 0, /* x25CircuitResetTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 16, 0, /* x25CircuitInterruptTimeouts */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 17, 0, /* x25CircuitCallParamId */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 18, 0, /* x25CircuitCalledDteAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 19, 0, /* x25CircuitCallingDteAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 20, 0, /* x25CircuitOriginallyCalledAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 5, 1, 21, 0, /* x25CircuitDescr */ 
      1, 3, 6, 1, 2, 1, 10, 5, 6, 0, /* x25ClearedCircuitEntriesRequested */ 
      1, 3, 6, 1, 2, 1, 10, 5, 7, 0, /* x25ClearedCircuitEntriesGranted */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 0, /* x25ClearedCircuitTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 0, /* x25ClearedCircuitEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 1, 0, /* x25ClearedCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 2, 0, /* x25ClearedCircuitPleIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 3, 0, /* x25ClearedCircuitTimeEstablished */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 4, 0, /* x25ClearedCircuitTimeCleared */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 5, 0, /* x25ClearedCircuitChannel */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 6, 0, /* x25ClearedCircuitClearingCause */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 7, 0, /* x25ClearedCircuitDiagnosticCode */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 8, 0, /* x25ClearedCircuitInPdus */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 9, 0, /* x25ClearedCircuitOutPdus */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 10, 0, /* x25ClearedCircuitCalledAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 11, 0, /* x25ClearedCircuitCallingAddress */ 
      1, 3, 6, 1, 2, 1, 10, 5, 8, 1, 12, 0, /* x25ClearedCircuitClearFacilities */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 0, /* x25CallParmTable */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 0, /* x25CallParmEntry */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 1, 0, /* x25CallParmIndex */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 2, 0, /* x25CallParmStatus */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 3, 0, /* x25CallParmRefCount */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 4, 0, /* x25CallParmInPacketSize */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 5, 0, /* x25CallParmOutPacketSize */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 6, 0, /* x25CallParmInWindowSize */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 7, 0, /* x25CallParmOutWindowSize */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 8, 0, /* x25CallParmAcceptReverseCharging */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 9, 0, /* x25CallParmProposeReverseCharging */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 10, 0, /* x25CallParmFastSelect */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 11, 0, /* x25CallParmInThruPutClasSize */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 12, 0, /* x25CallParmOutThruPutClasSize */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 13, 0, /* x25CallParmCug */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 14, 0, /* x25CallParmCugoa */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 15, 0, /* x25CallParmBcug */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 16, 0, /* x25CallParmNui */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 17, 0, /* x25CallParmChargingInfo */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 18, 0, /* x25CallParmRpoa */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 19, 0, /* x25CallParmTrnstDly */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 20, 0, /* x25CallParmCallingExt */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 21, 0, /* x25CallParmCalledExt */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 22, 0, /* x25CallParmInMinThuPutCls */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 23, 0, /* x25CallParmOutMinThuPutCls */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 24, 0, /* x25CallParmEndTrnsDly */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 25, 0, /* x25CallParmPriority */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 26, 0, /* x25CallParmProtection */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 27, 0, /* x25CallParmExptData */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 28, 0, /* x25CallParmUserData */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 29, 0, /* x25CallParmCallingNetworkFacilities */ 
      1, 3, 6, 1, 2, 1, 10, 5, 9, 1, 30, 0, /* x25CallParmCalledNetworkFacilities */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 0, /* x25ProtocolVersion */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 1, 0, /* x25protocolCcittV1976 */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 2, 0, /* x25protocolCcittV1980 */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 3, 0, /* x25protocolCcittV1984 */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 4, 0, /* x25protocolCcittV1988 */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 5, 0, /* x25protocolIso8208V1987 */ 
      1, 3, 6, 1, 2, 1, 10, 5, 10, 6, 0, /* x25protocolIso8208V1989 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 0, /* dot3 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 0, /* dot3StatsTable */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 0, /* dot3StatsEntry */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 1, 0, /* dot3StatsIndex */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 2, 0, /* dot3StatsAlignmentErrors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 3, 0, /* dot3StatsFCSErrors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 4, 0, /* dot3StatsSingleCollisionFrames */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 5, 0, /* dot3StatsMultipleCollisionFrames */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 6, 0, /* dot3StatsSQETestErrors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 7, 0, /* dot3StatsDeferredTransmissions */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 8, 0, /* dot3StatsLateCollisions */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 9, 0, /* dot3StatsExcessiveCollisions */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 10, 0, /* dot3StatsInternalMacTransmitErrors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 11, 0, /* dot3StatsCarrierSenseErrors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 13, 0, /* dot3StatsFrameTooLongs */ 
      1, 3, 6, 1, 2, 1, 10, 7, 2, 1, 16, 0, /* dot3StatsInternalMacReceiveErrors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 5, 0, /* dot3CollTable */ 
      1, 3, 6, 1, 2, 1, 10, 7, 5, 1, 0, /* dot3CollEntry */ 
      1, 3, 6, 1, 2, 1, 10, 7, 5, 1, 1, 0, /* dot3CollIndex */ 
      1, 3, 6, 1, 2, 1, 10, 7, 5, 1, 2, 0, /* dot3CollCount */ 
      1, 3, 6, 1, 2, 1, 10, 7, 5, 1, 3, 0, /* dot3CollFrequencies */ 
      1, 3, 6, 1, 2, 1, 10, 7, 6, 0, /* dot3Tests */ 
      1, 3, 6, 1, 2, 1, 10, 7, 6, 1, 0, /* dot3TestTdr */ 
      1, 3, 6, 1, 2, 1, 10, 7, 7, 0, /* dot3Errors */ 
      1, 3, 6, 1, 2, 1, 10, 7, 7, 1, 0, /* dot3ErrorInitError */ 
      1, 3, 6, 1, 2, 1, 10, 7, 7, 2, 0, /* dot3ErrorLoopbackError */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 0, /* dot3ChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 1, 0, /* dot3ChipSetAMD */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 1, 1, 0, /* dot3ChipSetAMD7990 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 1, 2, 0, /* dot3ChipSetAMD79900 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 2, 0, /* dot3ChipSetIntel */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 2, 1, 0, /* dot3ChipSetIntel82586 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 2, 2, 0, /* dot3ChipSetIntel82596 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 3, 0, /* dot3ChipSetSeeq */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 3, 1, 0, /* dot3ChipSetSeeq8003 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 4, 0, /* dot3ChipSetNational */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 4, 1, 0, /* dot3ChipSetNational8390 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 4, 2, 0, /* dot3ChipSetNationalSonic */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 5, 0, /* dot3ChipSetFujitsu */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 5, 1, 0, /* dot3ChipSetFujitsu86950 */ 
      1, 3, 6, 1, 2, 1, 10, 7, 8, 5, 2, 0, /* dot3ChipSetFujitsu86960 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 0, /* dot4 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 0, /* dot4Table */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 0, /* dot4Entry */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 1, 0, /* dot4IfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 2, 0, /* dot4Options */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 3, 0, /* dot4State */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 4, 0, /* dot4Commands */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 5, 0, /* dot4MacAddrLen */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 6, 0, /* dot4NextStation */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 7, 0, /* dot4PreviousStation */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 8, 0, /* dot4SlotTime */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 9, 0, /* dot4LastTokenRotTime */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 10, 0, /* dot4HiPriTokenHoldTime */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 11, 0, /* dot4TargetRotTimeClass4 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 12, 0, /* dot4TargetRotTimeClass2 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 13, 0, /* dot4TargetRotTimeClass0 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 14, 0, /* dot4TargetRotTimeRingMaint */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 15, 0, /* dot4RingMaintTimerInitValue */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 16, 0, /* dot4MaxInterSolicitCount */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 17, 0, /* dot4MaxRetries */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 18, 0, /* dot4MinPostSilencePreambLen */ 
      1, 3, 6, 1, 2, 1, 10, 8, 1, 1, 19, 0, /* dot4StandardRevision */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 0, /* dot4InitTable */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 0, /* dot4InitEntry */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 1, 0, /* dot4InitIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 2, 0, /* dot4InitSlotTime */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 3, 0, /* dot4InitMaxInterSolicitCount */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 4, 0, /* dot4InitMaxRetries */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 5, 0, /* dot4InitHiPriTokenHoldTime */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 6, 0, /* dot4InitTargetRotTimeClass4 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 7, 0, /* dot4InitTargetRotTimeClass2 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 8, 0, /* dot4InitTargetRotTimeClass0 */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 9, 0, /* dot4InitTargetRotTimeRingMaint */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 10, 0, /* dot4InitRingMaintTimerInitValue */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 11, 0, /* dot4InitMinPostSilencePreambLen */ 
      1, 3, 6, 1, 2, 1, 10, 8, 2, 1, 12, 0, /* dot4InitInRingDesired */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 0, /* dot4StatsTable */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 0, /* dot4StatsEntry */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 1, 0, /* dot4StatsIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 2, 0, /* dot4StatsTokenPasses */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 3, 0, /* dot4StatsTokenHeards */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 4, 0, /* dot4StatsNoSuccessors */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 5, 0, /* dot4StatsWhoFollows */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 6, 0, /* dot4StatsTokenPassFails */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 7, 0, /* dot4StatsNonSilences */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 8, 0, /* dot4StatsFcsErrors */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 9, 0, /* dot4StatsEbitErrors */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 10, 0, /* dot4StatsFrameFrags */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 11, 0, /* dot4StatsFrameTooLongs */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 12, 0, /* dot4StatsOverRuns */ 
      1, 3, 6, 1, 2, 1, 10, 8, 3, 1, 13, 0, /* dot4StatsDupAddresses */ 
      1, 3, 6, 1, 2, 1, 10, 8, 4, 0, /* dot4Errors */ 
      1, 3, 6, 1, 2, 1, 10, 8, 4, 1, 0, /* dot4ModemInitFailed */ 
      1, 3, 6, 1, 2, 1, 10, 8, 5, 0, /* dot4Tests */ 
      1, 3, 6, 1, 2, 1, 10, 8, 5, 1, 0, /* testFifoPath */ 
      1, 3, 6, 1, 2, 1, 10, 8, 5, 2, 0, /* testExternalLoopback */ 
      1, 3, 6, 1, 2, 1, 10, 8, 6, 0, /* dot4ChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 8, 6, 1, 0, /* chipSetMc68824 */ 
      1, 3, 6, 1, 2, 1, 10, 9, 0, /* dot5 */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 0, /* dot5Table */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 0, /* dot5Entry */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 1, 0, /* dot5IfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 2, 0, /* dot5Commands */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 3, 0, /* dot5RingStatus */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 4, 0, /* dot5RingState */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 5, 0, /* dot5RingOpenStatus */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 6, 0, /* dot5RingSpeed */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 7, 0, /* dot5UpStream */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 8, 0, /* dot5ActMonParticipate */ 
      1, 3, 6, 1, 2, 1, 10, 9, 1, 1, 9, 0, /* dot5Functional */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 0, /* dot5StatsTable */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 0, /* dot5StatsEntry */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 1, 0, /* dot5StatsIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 2, 0, /* dot5StatsLineErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 3, 0, /* dot5StatsBurstErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 4, 0, /* dot5StatsACErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 5, 0, /* dot5StatsAbortTransErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 6, 0, /* dot5StatsInternalErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 7, 0, /* dot5StatsLostFrameErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 8, 0, /* dot5StatsReceiveCongestions */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 9, 0, /* dot5StatsFrameCopiedErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 10, 0, /* dot5StatsTokenErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 11, 0, /* dot5StatsSoftErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 12, 0, /* dot5StatsHardErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 13, 0, /* dot5StatsSignalLoss */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 14, 0, /* dot5StatsTransmitBeacons */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 15, 0, /* dot5StatsRecoverys */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 16, 0, /* dot5StatsLobeWires */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 17, 0, /* dot5StatsRemoves */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 18, 0, /* dot5StatsSingles */ 
      1, 3, 6, 1, 2, 1, 10, 9, 2, 1, 19, 0, /* dot5StatsFreqErrors */ 
      1, 3, 6, 1, 2, 1, 10, 9, 3, 0, /* dot5Tests */ 
      1, 3, 6, 1, 2, 1, 10, 9, 3, 1, 0, /* testInsertFunc */ 
      1, 3, 6, 1, 2, 1, 10, 9, 4, 0, /* dot5ChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 9, 4, 1, 0, /* chipSetIBM16 */ 
      1, 3, 6, 1, 2, 1, 10, 9, 4, 2, 0, /* chipSetTItms380 */ 
      1, 3, 6, 1, 2, 1, 10, 9, 4, 3, 0, /* chipSetTItms380c16 */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 0, /* dot5TimerTable */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 0, /* dot5TimerEntry */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 1, 0, /* dot5TimerIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 2, 0, /* dot5TimerReturnRepeat */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 3, 0, /* dot5TimerHolding */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 4, 0, /* dot5TimerQueuePDU */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 5, 0, /* dot5TimerValidTransmit */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 6, 0, /* dot5TimerNoToken */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 7, 0, /* dot5TimerActiveMon */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 8, 0, /* dot5TimerStandbyMon */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 9, 0, /* dot5TimerErrorReport */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 10, 0, /* dot5TimerBeaconTransmit */ 
      1, 3, 6, 1, 2, 1, 10, 9, 5, 1, 11, 0, /* dot5TimerBeaconReceive */ 
      1, 3, 6, 1, 2, 1, 10, 15, 0, /* fddi */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 0, /* snmpFddiSMT */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 1, 0, /* snmpFddiSMTNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 0, /* snmpFddiSMTTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 0, /* snmpFddiSMTEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 1, 0, /* snmpFddiSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 2, 0, /* snmpFddiSMTStationId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 3, 0, /* snmpFddiSMTOpVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 4, 0, /* snmpFddiSMTHiVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 5, 0, /* snmpFddiSMTLoVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 6, 0, /* snmpFddiSMTMACCt */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 7, 0, /* snmpFddiSMTNonMasterCt */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 8, 0, /* snmpFddiSMTMasterCt */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 9, 0, /* snmpFddiSMTPathsAvailable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 10, 0, /* snmpFddiSMTConfigCapabilities */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 11, 0, /* snmpFddiSMTConfigPolicy */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 12, 0, /* snmpFddiSMTConnectionPolicy */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 13, 0, /* snmpFddiSMTTNotify */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 14, 0, /* snmpFddiSMTStatusReporting */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 15, 0, /* snmpFddiSMTECMState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 16, 0, /* snmpFddiSMTCFState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 17, 0, /* snmpFddiSMTHoldState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 18, 0, /* snmpFddiSMTRemoteDisconnectFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 1, 2, 1, 19, 0, /* snmpFddiSMTStationAction */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 0, /* snmpFddiMAC */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 1, 0, /* snmpFddiMACNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 0, /* snmpFddiMACTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 0, /* snmpFddiMACEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 1, 0, /* snmpFddiMACSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 2, 0, /* snmpFddiMACIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 3, 0, /* snmpFddiMACFrameStatusCapabilities */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 4, 0, /* snmpFddiMACTMaxGreatestLowerBound */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 5, 0, /* snmpFddiMACTVXGreatestLowerBound */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 6, 0, /* snmpFddiMACPathsAvailable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 7, 0, /* snmpFddiMACCurrentPath */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 8, 0, /* snmpFddiMACUpstreamNbr */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 9, 0, /* snmpFddiMACOldUpstreamNbr */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 10, 0, /* snmpFddiMACDupAddrTest */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 11, 0, /* snmpFddiMACPathsRequested */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 12, 0, /* snmpFddiMACDownstreamPORTType */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 13, 0, /* snmpFddiMACSMTAddress */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 14, 0, /* snmpFddiMACTReq */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 15, 0, /* snmpFddiMACTNeg */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 16, 0, /* snmpFddiMACTMax */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 17, 0, /* snmpFddiMACTvxValue */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 18, 0, /* snmpFddiMACTMin */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 19, 0, /* snmpFddiMACCurrentFrameStatus */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 20, 0, /* snmpFddiMACFrameCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 21, 0, /* snmpFddiMACErrorCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 22, 0, /* snmpFddiMACLostCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 23, 0, /* snmpFddiMACFrameErrorThreshold */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 24, 0, /* snmpFddiMACFrameErrorRatio */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 25, 0, /* snmpFddiMACRMTState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 26, 0, /* snmpFddiMACDaFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 27, 0, /* snmpFddiMACUnaDaFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 28, 0, /* snmpFddiMACFrameCondition */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 29, 0, /* snmpFddiMACChipSet */ 
      1, 3, 6, 1, 2, 1, 10, 15, 2, 2, 1, 30, 0, /* snmpFddiMACAction */ 
      1, 3, 6, 1, 2, 1, 10, 15, 3, 0, /* snmpFddiPATH */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 0, /* snmpFddiPORT */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 1, 0, /* snmpFddiPORTNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 0, /* snmpFddiPORTTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 0, /* snmpFddiPORTEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 1, 0, /* snmpFddiPORTSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 2, 0, /* snmpFddiPORTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 3, 0, /* snmpFddiPORTPCType */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 4, 0, /* snmpFddiPORTPCNeighbor */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 5, 0, /* snmpFddiPORTConnectionPolicies */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 6, 0, /* snmpFddiPORTRemoteMACIndicated */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 7, 0, /* snmpFddiPORTCEState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 8, 0, /* snmpFddiPORTPathsRequested */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 9, 0, /* snmpFddiPORTMACPlacement */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 10, 0, /* snmpFddiPORTAvailablePaths */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 11, 0, /* snmpFddiPORTMACLoopTime */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 12, 0, /* snmpFddiPORTTBMax */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 13, 0, /* snmpFddiPORTBSFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 14, 0, /* snmpFddiPORTLCTFailCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 15, 0, /* snmpFddiPORTLerEstimate */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 16, 0, /* snmpFddiPORTLemRejectCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 17, 0, /* snmpFddiPORTLemCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 18, 0, /* snmpFddiPORTLerCutoff */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 19, 0, /* snmpFddiPORTLerAlarm */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 20, 0, /* snmpFddiPORTConnectState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 21, 0, /* snmpFddiPORTPCMState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 22, 0, /* snmpFddiPORTPCWithhold */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 23, 0, /* snmpFddiPORTLerCondition */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 24, 0, /* snmpFddiPORTChipSet */ 
      1, 3, 6, 1, 2, 1, 10, 15, 4, 2, 1, 25, 0, /* snmpFddiPORTAction */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 0, /* snmpFddiATTACHMENT */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 1, 0, /* snmpFddiATTACHMENTNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 0, /* snmpFddiATTACHMENTTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 0, /* snmpFddiATTACHMENTEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 1, 0, /* snmpFddiATTACHMENTSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 2, 0, /* snmpFddiATTACHMENTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 3, 0, /* snmpFddiATTACHMENTClass */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 4, 0, /* snmpFddiATTACHMENTOpticalBypassPresent */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 5, 0, /* snmpFddiATTACHMENTIMaxExpiration */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 6, 0, /* snmpFddiATTACHMENTInsertedStatus */ 
      1, 3, 6, 1, 2, 1, 10, 15, 5, 2, 1, 7, 0, /* snmpFddiATTACHMENTInsertPolicy */ 
      1, 3, 6, 1, 2, 1, 10, 15, 6, 0, /* snmpFddiChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 15, 6, 1, 0, /* snmpFddiPHYChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 15, 6, 2, 0, /* snmpFddiMACChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 15, 6, 3, 0, /* snmpFddiPHYMACChipSets */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 0, /* fddimib */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 0, /* fddimibSMT */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 1, 0, /* fddimibSMTNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 0, /* fddimibSMTTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 0, /* fddimibSMTEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 1, 0, /* fddimibSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 2, 0, /* fddimibSMTStationId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 3, 0, /* fddimibSMTOpVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 4, 0, /* fddimibSMTHiVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 5, 0, /* fddimibSMTLoVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 6, 0, /* fddimibSMTUserData */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 7, 0, /* fddimibSMTMIBVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 8, 0, /* fddimibSMTMACCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 9, 0, /* fddimibSMTNonMasterCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 10, 0, /* fddimibSMTMasterCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 11, 0, /* fddimibSMTAvailablePaths */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 12, 0, /* fddimibSMTConfigCapabilities */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 13, 0, /* fddimibSMTConfigPolicy */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 14, 0, /* fddimibSMTConnectionPolicy */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 15, 0, /* fddimibSMTTNotify */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 16, 0, /* fddimibSMTStatRptPolicy */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 17, 0, /* fddimibSMTTraceMaxExpiration */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 18, 0, /* fddimibSMTBypassPresent */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 19, 0, /* fddimibSMTECMState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 20, 0, /* fddimibSMTCFState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 21, 0, /* fddimibSMTRemoteDisconnectFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 22, 0, /* fddimibSMTStationStatus */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 23, 0, /* fddimibSMTPeerWrapFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 24, 0, /* fddimibSMTTimeStamp */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 25, 0, /* fddimibSMTTransitionTimeStamp */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 1, 2, 1, 26, 0, /* fddimibSMTStationAction */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 0, /* fddimibMAC */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 1, 0, /* fddimibMACNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 0, /* fddimibMACTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 0, /* fddimibMACEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 1, 0, /* fddimibMACSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 2, 0, /* fddimibMACIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 3, 0, /* fddimibMACIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 4, 0, /* fddimibMACFrameStatusFunctions */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 5, 0, /* fddimibMACTMaxCapability */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 6, 0, /* fddimibMACTVXCapability */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 7, 0, /* fddimibMACAvailablePaths */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 8, 0, /* fddimibMACCurrentPath */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 9, 0, /* fddimibMACUpstreamNbr */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 10, 0, /* fddimibMACDownstreamNbr */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 11, 0, /* fddimibMACOldUpstreamNbr */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 12, 0, /* fddimibMACOldDownstreamNbr */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 13, 0, /* fddimibMACDupAddressTest */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 14, 0, /* fddimibMACRequestedPaths */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 15, 0, /* fddimibMACDownstreamPORTType */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 16, 0, /* fddimibMACSMTAddress */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 17, 0, /* fddimibMACTReq */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 18, 0, /* fddimibMACTNeg */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 19, 0, /* fddimibMACTMax */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 20, 0, /* fddimibMACTvxValue */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 21, 0, /* fddimibMACFrameCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 22, 0, /* fddimibMACCopiedCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 23, 0, /* fddimibMACTransmitCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 24, 0, /* fddimibMACErrorCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 25, 0, /* fddimibMACLostCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 26, 0, /* fddimibMACFrameErrorThreshold */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 27, 0, /* fddimibMACFrameErrorRatio */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 28, 0, /* fddimibMACRMTState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 29, 0, /* fddimibMACDaFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 30, 0, /* fddimibMACUnaDaFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 31, 0, /* fddimibMACFrameErrorFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 32, 0, /* fddimibMACMAUnitdataAvailable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 33, 0, /* fddimibMACHardwarePresent */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 2, 2, 1, 34, 0, /* fddimibMACMAUnitdataEnable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 0, /* fddimibMACCounters */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 0, /* fddimibMACCountersTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 0, /* fddimibMACCountersEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 1, 0, /* fddimibMACTokenCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 2, 0, /* fddimibMACTvxExpiredCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 3, 0, /* fddimibMACNotCopiedCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 4, 0, /* fddimibMACLateCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 5, 0, /* fddimibMACRingOpCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 6, 0, /* fddimibMACNotCopiedRatio */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 7, 0, /* fddimibMACNotCopiedFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 3, 1, 1, 8, 0, /* fddimibMACNotCopiedThreshold */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 0, /* fddimibPATH */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 1, 0, /* fddimibPATHNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 0, /* fddimibPATHTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 1, 0, /* fddimibPATHEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 1, 1, 0, /* fddimibPATHSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 1, 2, 0, /* fddimibPATHIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 1, 3, 0, /* fddimibPATHTVXLowerBound */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 1, 4, 0, /* fddimibPATHTMaxLowerBound */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 2, 1, 5, 0, /* fddimibPATHMaxTReq */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 0, /* fddimibPATHConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 0, /* fddimibPATHConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 1, 0, /* fddimibPATHConfigSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 2, 0, /* fddimibPATHConfigPATHIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 3, 0, /* fddimibPATHConfigTokenOrder */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 4, 0, /* fddimibPATHConfigResourceType */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 5, 0, /* fddimibPATHConfigResourceIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 4, 3, 1, 6, 0, /* fddimibPATHConfigCurrentPath */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 0, /* fddimibPORT */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 1, 0, /* fddimibPORTNumber */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 0, /* fddimibPORTTable */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 0, /* fddimibPORTEntry */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 1, 0, /* fddimibPORTSMTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 2, 0, /* fddimibPORTIndex */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 3, 0, /* fddimibPORTMyType */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 4, 0, /* fddimibPORTNeighborType */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 5, 0, /* fddimibPORTConnectionPolicies */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 6, 0, /* fddimibPORTMACIndicated */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 7, 0, /* fddimibPORTCurrentPath */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 8, 0, /* fddimibPORTRequestedPaths */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 9, 0, /* fddimibPORTMACPlacement */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 10, 0, /* fddimibPORTAvailablePaths */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 11, 0, /* fddimibPORTPMDClass */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 12, 0, /* fddimibPORTConnectionCapabilities */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 13, 0, /* fddimibPORTBSFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 14, 0, /* fddimibPORTLCTFailCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 15, 0, /* fddimibPORTLerEstimate */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 16, 0, /* fddimibPORTLemRejectCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 17, 0, /* fddimibPORTLemCts */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 18, 0, /* fddimibPORTLerCutoff */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 19, 0, /* fddimibPORTLerAlarm */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 20, 0, /* fddimibPORTConnectState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 21, 0, /* fddimibPORTPCMState */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 22, 0, /* fddimibPORTPCWithhold */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 23, 0, /* fddimibPORTLerFlag */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 24, 0, /* fddimibPORTHardwarePresent */ 
      1, 3, 6, 1, 2, 1, 10, 15, 73, 5, 2, 1, 25, 0, /* fddimibPORTAction */ 
      1, 3, 6, 1, 2, 1, 10, 16, 0, /* lapb */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 0, /* lapbAdmnTable */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 0, /* lapbAdmnEntry */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 1, 0, /* lapbAdmnIndex */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 2, 0, /* lapbAdmnStationType */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 3, 0, /* lapbAdmnControlField */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 4, 0, /* lapbAdmnTransmitN1FrameSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 5, 0, /* lapbAdmnReceiveN1FrameSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 6, 0, /* lapbAdmnTransmitKWindowSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 7, 0, /* lapbAdmnReceiveKWindowSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 8, 0, /* lapbAdmnN2RxmitCount */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 9, 0, /* lapbAdmnT1AckTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 10, 0, /* lapbAdmnT2AckDelayTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 11, 0, /* lapbAdmnT3DisconnectTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 12, 0, /* lapbAdmnT4IdleTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 13, 0, /* lapbAdmnActionInitiate */ 
      1, 3, 6, 1, 2, 1, 10, 16, 1, 1, 14, 0, /* lapbAdmnActionRecvDM */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 0, /* lapbOperTable */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 0, /* lapbOperEntry */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 1, 0, /* lapbOperIndex */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 2, 0, /* lapbOperStationType */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 3, 0, /* lapbOperControlField */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 4, 0, /* lapbOperTransmitN1FrameSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 5, 0, /* lapbOperReceiveN1FrameSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 6, 0, /* lapbOperTransmitKWindowSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 7, 0, /* lapbOperReceiveKWindowSize */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 8, 0, /* lapbOperN2RxmitCount */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 9, 0, /* lapbOperT1AckTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 10, 0, /* lapbOperT2AckDelayTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 11, 0, /* lapbOperT3DisconnectTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 12, 0, /* lapbOperT4IdleTimer */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 13, 0, /* lapbOperPortId */ 
      1, 3, 6, 1, 2, 1, 10, 16, 2, 1, 14, 0, /* lapbOperProtocolVersionId */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 0, /* lapbFlowTable */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 0, /* lapbFlowEntry */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 1, 0, /* lapbFlowIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 2, 0, /* lapbFlowStateChanges */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 3, 0, /* lapbFlowChangeReason */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 4, 0, /* lapbFlowCurrentMode */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 5, 0, /* lapbFlowBusyDefers */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 6, 0, /* lapbFlowRejOutPkts */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 7, 0, /* lapbFlowRejInPkts */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 8, 0, /* lapbFlowT1Timeouts */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 9, 0, /* lapbFlowFrmrSent */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 10, 0, /* lapbFlowFrmrReceived */ 
      1, 3, 6, 1, 2, 1, 10, 16, 3, 1, 11, 0, /* lapbFlowXidReceived */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 0, /* lapbXidTable */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 0, /* lapbXidEntry */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 1, 0, /* lapbXidIndex */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 2, 0, /* lapbXidAdRIdentifier */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 3, 0, /* lapbXidAdRAddress */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 4, 0, /* lapbXidParameterUniqueIdentifier */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 5, 0, /* lapbXidGroupAddress */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 6, 0, /* lapbXidPortNumber */ 
      1, 3, 6, 1, 2, 1, 10, 16, 4, 1, 7, 0, /* lapbXidUserDataSubfield */ 
      1, 3, 6, 1, 2, 1, 10, 16, 5, 0, /* lapbProtocolVersion */ 
      1, 3, 6, 1, 2, 1, 10, 16, 5, 1, 0, /* lapbProtocolIso7776v1986 */ 
      1, 3, 6, 1, 2, 1, 10, 16, 5, 2, 0, /* lapbProtocolCcittV1980 */ 
      1, 3, 6, 1, 2, 1, 10, 16, 5, 3, 0, /* lapbProtocolCcittV1984 */ 
      1, 3, 6, 1, 2, 1, 10, 18, 0, /* ds1 */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 0, /* dsx1ConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 0, /* dsx1ConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 1, 0, /* dsx1LineIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 2, 0, /* dsx1IfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 3, 0, /* dsx1TimeElapsed */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 4, 0, /* dsx1ValidIntervals */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 5, 0, /* dsx1LineType */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 6, 0, /* dsx1LineCoding */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 7, 0, /* dsx1SendCode */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 8, 0, /* dsx1CircuitIdentifier */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 9, 0, /* dsx1LoopbackConfig */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 10, 0, /* dsx1LineStatus */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 11, 0, /* dsx1SignalMode */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 12, 0, /* dsx1TransmitClockSource */ 
      1, 3, 6, 1, 2, 1, 10, 18, 6, 1, 13, 0, /* dsx1Fdl */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 0, /* dsx1CurrentTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 0, /* dsx1CurrentEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 1, 0, /* dsx1CurrentIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 2, 0, /* dsx1CurrentESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 3, 0, /* dsx1CurrentSESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 4, 0, /* dsx1CurrentSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 5, 0, /* dsx1CurrentUASs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 6, 0, /* dsx1CurrentCSSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 7, 0, /* dsx1CurrentPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 8, 0, /* dsx1CurrentLESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 9, 0, /* dsx1CurrentBESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 10, 0, /* dsx1CurrentDMs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 7, 1, 11, 0, /* dsx1CurrentLCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 0, /* dsx1IntervalTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 0, /* dsx1IntervalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 1, 0, /* dsx1IntervalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 2, 0, /* dsx1IntervalNumber */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 3, 0, /* dsx1IntervalESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 4, 0, /* dsx1IntervalSESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 5, 0, /* dsx1IntervalSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 6, 0, /* dsx1IntervalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 7, 0, /* dsx1IntervalCSSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 8, 0, /* dsx1IntervalPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 9, 0, /* dsx1IntervalLESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 10, 0, /* dsx1IntervalBESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 11, 0, /* dsx1IntervalDMs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 8, 1, 12, 0, /* dsx1IntervalLCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 0, /* dsx1TotalTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 0, /* dsx1TotalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 1, 0, /* dsx1TotalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 2, 0, /* dsx1TotalESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 3, 0, /* dsx1TotalSESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 4, 0, /* dsx1TotalSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 5, 0, /* dsx1TotalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 6, 0, /* dsx1TotalCSSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 7, 0, /* dsx1TotalPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 8, 0, /* dsx1TotalLESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 9, 0, /* dsx1TotalBESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 10, 0, /* dsx1TotalDMs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 9, 1, 11, 0, /* dsx1TotalLCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 0, /* dsx1FarEndCurrentTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 0, /* dsx1FarEndCurrentEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 1, 0, /* dsx1FarEndCurrentIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 2, 0, /* dsx1FarEndTimeElapsed */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 3, 0, /* dsx1FarEndValidIntervals */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 4, 0, /* dsx1FarEndCurrentESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 5, 0, /* dsx1FarEndCurrentSESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 6, 0, /* dsx1FarEndCurrentSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 7, 0, /* dsx1FarEndCurrentUASs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 8, 0, /* dsx1FarEndCurrentCSSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 9, 0, /* dsx1FarEndCurrentLESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 10, 0, /* dsx1FarEndCurrentPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 11, 0, /* dsx1FarEndCurrentBESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 10, 1, 12, 0, /* dsx1FarEndCurrentDMs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 0, /* dsx1FarEndIntervalTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 0, /* dsx1FarEndIntervalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 1, 0, /* dsx1FarEndIntervalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 2, 0, /* dsx1FarEndIntervalNumber */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 3, 0, /* dsx1FarEndIntervalESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 4, 0, /* dsx1FarEndIntervalSESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 5, 0, /* dsx1FarEndIntervalSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 6, 0, /* dsx1FarEndIntervalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 7, 0, /* dsx1FarEndIntervalCSSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 8, 0, /* dsx1FarEndIntervalLESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 9, 0, /* dsx1FarEndIntervalPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 10, 0, /* dsx1FarEndIntervalBESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 11, 1, 11, 0, /* dsx1FarEndIntervalDMs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 0, /* dsx1FarEndTotalTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 0, /* dsx1FarEndTotalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 1, 0, /* dsx1FarEndTotalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 2, 0, /* dsx1FarEndTotalESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 3, 0, /* dsx1FarEndTotalSESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 4, 0, /* dsx1FarEndTotalSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 5, 0, /* dsx1FarEndTotalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 6, 0, /* dsx1FarEndTotalCSSs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 7, 0, /* dsx1FarEndTotalLESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 8, 0, /* dsx1FarEndTotalPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 9, 0, /* dsx1FarEndTotalBESs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 12, 1, 10, 0, /* dsx1FarEndTotalDMs */ 
      1, 3, 6, 1, 2, 1, 10, 18, 13, 0, /* dsx1FracTable */ 
      1, 3, 6, 1, 2, 1, 10, 18, 13, 1, 0, /* dsx1FracEntry */ 
      1, 3, 6, 1, 2, 1, 10, 18, 13, 1, 1, 0, /* dsx1FracIndex */ 
      1, 3, 6, 1, 2, 1, 10, 18, 13, 1, 2, 0, /* dsx1FracNumber */ 
      1, 3, 6, 1, 2, 1, 10, 18, 13, 1, 3, 0, /* dsx1FracIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 23, 0, /* ppp */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 0, /* pppLcp */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 0, /* pppLink */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 0, /* pppLinkStatusTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 0, /* pppLinkStatusEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 1, 0, /* pppLinkStatusPhysicalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 2, 0, /* pppLinkStatusBadAddresses */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 3, 0, /* pppLinkStatusBadControls */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 4, 0, /* pppLinkStatusPacketTooLongs */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 5, 0, /* pppLinkStatusBadFCSs */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 6, 0, /* pppLinkStatusLocalMRU */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 7, 0, /* pppLinkStatusRemoteMRU */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 8, 0, /* pppLinkStatusLocalToPeerACCMap */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 9, 0, /* pppLinkStatusPeerToLocalACCMap */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 10, 0, /* pppLinkStatusLocalToRemoteProtocolCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 11, 0, /* pppLinkStatusRemoteToLocalProtocolCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 12, 0, /* pppLinkStatusLocalToRemoteACCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 13, 0, /* pppLinkStatusRemoteToLocalACCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 14, 0, /* pppLinkStatusTransmitFcsSize */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 1, 1, 15, 0, /* pppLinkStatusReceiveFcsSize */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 0, /* pppLinkConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 1, 0, /* pppLinkConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 1, 1, 0, /* pppLinkConfigInitialMRU */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 1, 2, 0, /* pppLinkConfigReceiveACCMap */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 1, 3, 0, /* pppLinkConfigTransmitACCMap */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 1, 4, 0, /* pppLinkConfigMagicNumber */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 1, 2, 1, 5, 0, /* pppLinkConfigFcsSize */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 0, /* pppLqr */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 0, /* pppLqrTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 0, /* pppLqrEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 1, 0, /* pppLqrQuality */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 2, 0, /* pppLqrInGoodOctets */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 3, 0, /* pppLqrLocalPeriod */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 4, 0, /* pppLqrRemotePeriod */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 5, 0, /* pppLqrOutLQRs */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 1, 1, 6, 0, /* pppLqrInLQRs */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 2, 0, /* pppLqrConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 2, 1, 0, /* pppLqrConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 2, 1, 1, 0, /* pppLqrConfigPeriod */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 2, 1, 2, 0, /* pppLqrConfigStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 3, 0, /* pppLqrExtnsTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 3, 1, 0, /* pppLqrExtnsEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 2, 3, 1, 1, 0, /* pppLqrExtnsLastReceivedLqrPacket */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 3, 0, /* pppTests */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 3, 1, 0, /* pppEchoTest */ 
      1, 3, 6, 1, 2, 1, 10, 23, 1, 3, 2, 0, /* pppDiscardTest */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 0, /* pppSecurity */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 1, 0, /* pppSecurityProtocols */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 1, 1, 0, /* pppSecurityPapProtocol */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 1, 2, 0, /* pppSecurityChapMD5Protocol */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 2, 0, /* pppSecurityConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 2, 1, 0, /* pppSecurityConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 2, 1, 1, 0, /* pppSecurityConfigLink */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 2, 1, 2, 0, /* pppSecurityConfigPreference */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 2, 1, 3, 0, /* pppSecurityConfigProtocol */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 2, 1, 4, 0, /* pppSecurityConfigStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 0, /* pppSecuritySecretsTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 0, /* pppSecuritySecretsEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 1, 0, /* pppSecuritySecretsLink */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 2, 0, /* pppSecuritySecretsIdIndex */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 3, 0, /* pppSecuritySecretsDirection */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 4, 0, /* pppSecuritySecretsProtocol */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 5, 0, /* pppSecuritySecretsIdentity */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 6, 0, /* pppSecuritySecretsSecret */ 
      1, 3, 6, 1, 2, 1, 10, 23, 2, 3, 1, 7, 0, /* pppSecuritySecretsStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 0, /* pppIp */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 0, /* pppIpTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 1, 0, /* pppIpEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 1, 1, 0, /* pppIpOperStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 1, 2, 0, /* pppIpLocalToRemoteCompressionProtocol */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 1, 3, 0, /* pppIpRemoteToLocalCompressionProtocol */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 1, 4, 0, /* pppIpRemoteMaxSlotId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 1, 1, 5, 0, /* pppIpLocalMaxSlotId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 2, 0, /* pppIpConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 2, 1, 0, /* pppIpConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 2, 1, 1, 0, /* pppIpConfigAdminStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 3, 2, 1, 2, 0, /* pppIpConfigCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 0, /* pppBridge */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 0, /* pppBridgeTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 1, 0, /* pppBridgeEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 1, 1, 0, /* pppBridgeOperStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 1, 2, 0, /* pppBridgeLocalToRemoteTinygramCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 1, 3, 0, /* pppBridgeRemoteToLocalTinygramCompression */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 1, 4, 0, /* pppBridgeLocalToRemoteLanId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 1, 1, 5, 0, /* pppBridgeRemoteToLocalLanId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 0, /* pppBridgeConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 1, 0, /* pppBridgeConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 1, 1, 0, /* pppBridgeConfigAdminStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 1, 2, 0, /* pppBridgeConfigTinygram */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 1, 3, 0, /* pppBridgeConfigRingId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 1, 4, 0, /* pppBridgeConfigLineId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 2, 1, 5, 0, /* pppBridgeConfigLanId */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 3, 0, /* pppBridgeMediaTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 3, 1, 0, /* pppBridgeMediaEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 3, 1, 1, 0, /* pppBridgeMediaMacType */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 3, 1, 2, 0, /* pppBridgeMediaLocalStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 3, 1, 3, 0, /* pppBridgeMediaRemoteStatus */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 4, 0, /* pppBridgeMediaConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 4, 1, 0, /* pppBridgeMediaConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 4, 1, 1, 0, /* pppBridgeMediaConfigMacType */ 
      1, 3, 6, 1, 2, 1, 10, 23, 4, 4, 1, 2, 0, /* pppBridgeMediaConfigLocalStatus */ 
      1, 3, 6, 1, 2, 1, 10, 30, 0, /* ds3 */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 0, /* dsx3ConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 0, /* dsx3ConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 1, 0, /* dsx3LineIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 2, 0, /* dsx3IfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 3, 0, /* dsx3TimeElapsed */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 4, 0, /* dsx3ValidIntervals */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 5, 0, /* dsx3LineType */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 6, 0, /* dsx3LineCoding */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 7, 0, /* dsx3SendCode */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 8, 0, /* dsx3CircuitIdentifier */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 9, 0, /* dsx3LoopbackConfig */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 10, 0, /* dsx3LineStatus */ 
      1, 3, 6, 1, 2, 1, 10, 30, 5, 1, 11, 0, /* dsx3TransmitClockSource */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 0, /* dsx3CurrentTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 0, /* dsx3CurrentEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 1, 0, /* dsx3CurrentIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 2, 0, /* dsx3CurrentPESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 3, 0, /* dsx3CurrentPSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 4, 0, /* dsx3CurrentSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 5, 0, /* dsx3CurrentUASs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 6, 0, /* dsx3CurrentLCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 7, 0, /* dsx3CurrentPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 8, 0, /* dsx3CurrentLESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 9, 0, /* dsx3CurrentCCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 10, 0, /* dsx3CurrentCESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 6, 1, 11, 0, /* dsx3CurrentCSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 0, /* dsx3IntervalTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 0, /* dsx3IntervalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 1, 0, /* dsx3IntervalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 2, 0, /* dsx3IntervalNumber */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 3, 0, /* dsx3IntervalPESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 4, 0, /* dsx3IntervalPSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 5, 0, /* dsx3IntervalSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 6, 0, /* dsx3IntervalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 7, 0, /* dsx3IntervalLCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 8, 0, /* dsx3IntervalPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 9, 0, /* dsx3IntervalLESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 10, 0, /* dsx3IntervalCCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 11, 0, /* dsx3IntervalCESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 7, 1, 12, 0, /* dsx3IntervalCSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 0, /* dsx3TotalTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 0, /* dsx3TotalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 1, 0, /* dsx3TotalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 2, 0, /* dsx3TotalPESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 3, 0, /* dsx3TotalPSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 4, 0, /* dsx3TotalSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 5, 0, /* dsx3TotalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 6, 0, /* dsx3TotalLCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 7, 0, /* dsx3TotalPCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 8, 0, /* dsx3TotalLESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 9, 0, /* dsx3TotalCCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 10, 0, /* dsx3TotalCESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 8, 1, 11, 0, /* dsx3TotalCSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 0, /* dsx3FarEndConfigTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 0, /* dsx3FarEndConfigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 1, 0, /* dsx3FarEndLineIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 2, 0, /* dsx3FarEndEquipCode */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 3, 0, /* dsx3FarEndLocationIDCode */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 4, 0, /* dsx3FarEndFrameIDCode */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 5, 0, /* dsx3FarEndUnitCode */ 
      1, 3, 6, 1, 2, 1, 10, 30, 9, 1, 6, 0, /* dsx3FarEndFacilityIDCode */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 0, /* dsx3FarEndCurrentTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 0, /* dsx3FarEndCurrentEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 1, 0, /* dsx3FarEndCurrentIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 2, 0, /* dsx3FarEndTimeElapsed */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 3, 0, /* dsx3FarEndValidIntervals */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 4, 0, /* dsx3FarEndCurrentCESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 5, 0, /* dsx3FarEndCurrentCSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 6, 0, /* dsx3FarEndCurrentCCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 10, 1, 7, 0, /* dsx3FarEndCurrentUASs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 0, /* dsx3FarEndIntervalTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 0, /* dsx3FarEndIntervalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 1, 0, /* dsx3FarEndIntervalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 2, 0, /* dsx3FarEndIntervalNumber */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 3, 0, /* dsx3FarEndIntervalCESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 4, 0, /* dsx3FarEndIntervalCSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 5, 0, /* dsx3FarEndIntervalCCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 11, 1, 6, 0, /* dsx3FarEndIntervalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 0, /* dsx3FarEndTotalTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 1, 0, /* dsx3FarEndTotalEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 1, 1, 0, /* dsx3FarEndTotalIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 1, 2, 0, /* dsx3FarEndTotalCESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 1, 3, 0, /* dsx3FarEndTotalCSESs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 1, 4, 0, /* dsx3FarEndTotalCCVs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 12, 1, 5, 0, /* dsx3FarEndTotalUASs */ 
      1, 3, 6, 1, 2, 1, 10, 30, 13, 0, /* dsx3FracTable */ 
      1, 3, 6, 1, 2, 1, 10, 30, 13, 1, 0, /* dsx3FracEntry */ 
      1, 3, 6, 1, 2, 1, 10, 30, 13, 1, 1, 0, /* dsx3FracIndex */ 
      1, 3, 6, 1, 2, 1, 10, 30, 13, 1, 2, 0, /* dsx3FracNumber */ 
      1, 3, 6, 1, 2, 1, 10, 30, 13, 1, 3, 0, /* dsx3FracIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 31, 0, /* sip */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 0, /* sipL3Table */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 0, /* sipL3Entry */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 1, 0, /* sipL3Index */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 2, 0, /* sipL3ReceivedIndividualDAs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 3, 0, /* sipL3ReceivedGAs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 4, 0, /* sipL3UnrecognizedIndividualDAs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 5, 0, /* sipL3UnrecognizedGAs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 6, 0, /* sipL3SentIndividualDAs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 7, 0, /* sipL3SentGAs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 8, 0, /* sipL3Errors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 9, 0, /* sipL3InvalidSMDSAddressTypes */ 
      1, 3, 6, 1, 2, 1, 10, 31, 1, 1, 10, 0, /* sipL3VersionSupport */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 0, /* sipL2Table */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 0, /* sipL2Entry */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 1, 0, /* sipL2Index */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 2, 0, /* sipL2ReceivedCounts */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 3, 0, /* sipL2SentCounts */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 4, 0, /* sipL2HcsOrCRCErrors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 5, 0, /* sipL2PayloadLengthErrors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 6, 0, /* sipL2SequenceNumberErrors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 7, 0, /* sipL2MidCurrentlyActiveErrors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 8, 0, /* sipL2BomOrSSMsMIDErrors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 2, 1, 9, 0, /* sipL2EomsMIDErrors */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 0, /* sipPLCP */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 1, 0, /* sipDS1PLCPTable */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 1, 1, 0, /* sipDS1PLCPEntry */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 1, 1, 1, 0, /* sipDS1PLCPIndex */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 1, 1, 2, 0, /* sipDS1PLCPSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 1, 1, 3, 0, /* sipDS1PLCPAlarmState */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 1, 1, 4, 0, /* sipDS1PLCPUASs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 2, 0, /* sipDS3PLCPTable */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 2, 1, 0, /* sipDS3PLCPEntry */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 2, 1, 1, 0, /* sipDS3PLCPIndex */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 2, 1, 2, 0, /* sipDS3PLCPSEFSs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 2, 1, 3, 0, /* sipDS3PLCPAlarmState */ 
      1, 3, 6, 1, 2, 1, 10, 31, 3, 2, 1, 4, 0, /* sipDS3PLCPUASs */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 0, /* smdsApplications */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 0, /* ipOverSMDS */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 0, /* ipOverSMDSTable */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 1, 0, /* ipOverSMDSEntry */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 1, 1, 0, /* ipOverSMDSIndex */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 1, 2, 0, /* ipOverSMDSAddress */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 1, 3, 0, /* ipOverSMDSHA */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 1, 4, 0, /* ipOverSMDSLISGA */ 
      1, 3, 6, 1, 2, 1, 10, 31, 4, 1, 1, 1, 5, 0, /* ipOverSMDSARPReq */ 
      1, 3, 6, 1, 2, 1, 10, 31, 5, 0, /* smdsCarrierSelection */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 0, /* sipErrorLog */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 0, /* sipL3PDUErrorTable */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 1, 0, /* sipL3PDUErrorEntry */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 1, 1, 0, /* sipL3PDUErrorIndex */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 1, 2, 0, /* sipL3PDUErrorType */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 1, 3, 0, /* sipL3PDUErrorSA */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 1, 4, 0, /* sipL3PDUErrorDA */ 
      1, 3, 6, 1, 2, 1, 10, 31, 6, 1, 1, 5, 0, /* sipL3PDUErrorTimeStamp */ 
      1, 3, 6, 1, 2, 1, 10, 32, 0, /* frame-relay */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 0, /* frDlcmiTable */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 0, /* frDlcmiEntry */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 1, 0, /* frDlcmiIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 2, 0, /* frDlcmiState */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 3, 0, /* frDlcmiAddress */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 4, 0, /* frDlcmiAddressLen */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 5, 0, /* frDlcmiPollingInterval */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 6, 0, /* frDlcmiFullEnquiryInterval */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 7, 0, /* frDlcmiErrorThreshold */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 8, 0, /* frDlcmiMonitoredEvents */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 9, 0, /* frDlcmiMaxSupportedVCs */ 
      1, 3, 6, 1, 2, 1, 10, 32, 1, 1, 10, 0, /* frDlcmiMulticast */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 0, /* frCircuitTable */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 0, /* frCircuitEntry */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 1, 0, /* frCircuitIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 2, 0, /* frCircuitDlci */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 3, 0, /* frCircuitState */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 4, 0, /* frCircuitReceivedFECNs */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 5, 0, /* frCircuitReceivedBECNs */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 6, 0, /* frCircuitSentFrames */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 7, 0, /* frCircuitSentOctets */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 8, 0, /* frCircuitReceivedFrames */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 9, 0, /* frCircuitReceivedOctets */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 10, 0, /* frCircuitCreationTime */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 11, 0, /* frCircuitLastTimeChange */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 12, 0, /* frCircuitCommittedBurst */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 13, 0, /* frCircuitExcessBurst */ 
      1, 3, 6, 1, 2, 1, 10, 32, 2, 1, 14, 0, /* frCircuitThroughput */ 
      1, 3, 6, 1, 2, 1, 10, 32, 3, 0, /* frErrTable */ 
      1, 3, 6, 1, 2, 1, 10, 32, 3, 1, 0, /* frErrEntry */ 
      1, 3, 6, 1, 2, 1, 10, 32, 3, 1, 1, 0, /* frErrIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 32, 3, 1, 2, 0, /* frErrType */ 
      1, 3, 6, 1, 2, 1, 10, 32, 3, 1, 3, 0, /* frErrData */ 
      1, 3, 6, 1, 2, 1, 10, 32, 3, 1, 4, 0, /* frErrTime */ 
      1, 3, 6, 1, 2, 1, 10, 32, 4, 0, /* frame-relay-globals */ 
      1, 3, 6, 1, 2, 1, 10, 32, 4, 1, 0, /* frTrapState */ 
      1, 3, 6, 1, 2, 1, 10, 33, 0, /* rs232 */ 
      1, 3, 6, 1, 2, 1, 10, 33, 1, 0, /* rs232Number */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 0, /* rs232PortTable */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 0, /* rs232PortEntry */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 1, 0, /* rs232PortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 2, 0, /* rs232PortType */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 3, 0, /* rs232PortInSigNumber */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 4, 0, /* rs232PortOutSigNumber */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 5, 0, /* rs232PortInSpeed */ 
      1, 3, 6, 1, 2, 1, 10, 33, 2, 1, 6, 0, /* rs232PortOutSpeed */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 0, /* rs232AsyncPortTable */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 0, /* rs232AsyncPortEntry */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 1, 0, /* rs232AsyncPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 2, 0, /* rs232AsyncPortBits */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 3, 0, /* rs232AsyncPortStopBits */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 4, 0, /* rs232AsyncPortParity */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 5, 0, /* rs232AsyncPortAutobaud */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 6, 0, /* rs232AsyncPortParityErrs */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 7, 0, /* rs232AsyncPortFramingErrs */ 
      1, 3, 6, 1, 2, 1, 10, 33, 3, 1, 8, 0, /* rs232AsyncPortOverrunErrs */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 0, /* rs232SyncPortTable */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 0, /* rs232SyncPortEntry */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 1, 0, /* rs232SyncPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 2, 0, /* rs232SyncPortClockSource */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 3, 0, /* rs232SyncPortFrameCheckErrs */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 4, 0, /* rs232SyncPortTransmitUnderrunErrs */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 5, 0, /* rs232SyncPortReceiveOverrunErrs */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 6, 0, /* rs232SyncPortInterruptedFrames */ 
      1, 3, 6, 1, 2, 1, 10, 33, 4, 1, 7, 0, /* rs232SyncPortAbortedFrames */ 
      1, 3, 6, 1, 2, 1, 10, 33, 5, 0, /* rs232InSigTable */ 
      1, 3, 6, 1, 2, 1, 10, 33, 5, 1, 0, /* rs232InSigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 33, 5, 1, 1, 0, /* rs232InSigPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 33, 5, 1, 2, 0, /* rs232InSigName */ 
      1, 3, 6, 1, 2, 1, 10, 33, 5, 1, 3, 0, /* rs232InSigState */ 
      1, 3, 6, 1, 2, 1, 10, 33, 5, 1, 4, 0, /* rs232InSigChanges */ 
      1, 3, 6, 1, 2, 1, 10, 33, 6, 0, /* rs232OutSigTable */ 
      1, 3, 6, 1, 2, 1, 10, 33, 6, 1, 0, /* rs232OutSigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 33, 6, 1, 1, 0, /* rs232OutSigPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 33, 6, 1, 2, 0, /* rs232OutSigName */ 
      1, 3, 6, 1, 2, 1, 10, 33, 6, 1, 3, 0, /* rs232OutSigState */ 
      1, 3, 6, 1, 2, 1, 10, 33, 6, 1, 4, 0, /* rs232OutSigChanges */ 
      1, 3, 6, 1, 2, 1, 10, 34, 0, /* para */ 
      1, 3, 6, 1, 2, 1, 10, 34, 1, 0, /* paraNumber */ 
      1, 3, 6, 1, 2, 1, 10, 34, 2, 0, /* paraPortTable */ 
      1, 3, 6, 1, 2, 1, 10, 34, 2, 1, 0, /* paraPortEntry */ 
      1, 3, 6, 1, 2, 1, 10, 34, 2, 1, 1, 0, /* paraPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 34, 2, 1, 2, 0, /* paraPortType */ 
      1, 3, 6, 1, 2, 1, 10, 34, 2, 1, 3, 0, /* paraPortInSigNumber */ 
      1, 3, 6, 1, 2, 1, 10, 34, 2, 1, 4, 0, /* paraPortOutSigNumber */ 
      1, 3, 6, 1, 2, 1, 10, 34, 3, 0, /* paraInSigTable */ 
      1, 3, 6, 1, 2, 1, 10, 34, 3, 1, 0, /* paraInSigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 34, 3, 1, 1, 0, /* paraInSigPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 34, 3, 1, 2, 0, /* paraInSigName */ 
      1, 3, 6, 1, 2, 1, 10, 34, 3, 1, 3, 0, /* paraInSigState */ 
      1, 3, 6, 1, 2, 1, 10, 34, 3, 1, 4, 0, /* paraInSigChanges */ 
      1, 3, 6, 1, 2, 1, 10, 34, 4, 0, /* paraOutSigTable */ 
      1, 3, 6, 1, 2, 1, 10, 34, 4, 1, 0, /* paraOutSigEntry */ 
      1, 3, 6, 1, 2, 1, 10, 34, 4, 1, 1, 0, /* paraOutSigPortIndex */ 
      1, 3, 6, 1, 2, 1, 10, 34, 4, 1, 2, 0, /* paraOutSigName */ 
      1, 3, 6, 1, 2, 1, 10, 34, 4, 1, 3, 0, /* paraOutSigState */ 
      1, 3, 6, 1, 2, 1, 10, 34, 4, 1, 4, 0, /* paraOutSigChanges */ 
      1, 3, 6, 1, 2, 1, 10, 38, 0, /* miox */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 0, /* mioxPle */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 0, /* mioxPleTable */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 0, /* mioxPleEntry */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 1, 0, /* mioxPleMaxCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 2, 0, /* mioxPleRefusedConnections */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 3, 0, /* mioxPleEnAddrToX121LkupFlrs */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 4, 0, /* mioxPleLastFailedEnAddr */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 5, 0, /* mioxPleEnAddrToX121LkupFlrTime */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 6, 0, /* mioxPleX121ToEnAddrLkupFlrs */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 7, 0, /* mioxPleLastFailedX121Address */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 8, 0, /* mioxPleX121ToEnAddrLkupFlrTime */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 9, 0, /* mioxPleQbitFailures */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 10, 0, /* mioxPleQbitFailureRemoteAddress */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 11, 0, /* mioxPleQbitFailureTime */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 12, 0, /* mioxPleMinimumOpenTimer */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 13, 0, /* mioxPleInactivityTimer */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 14, 0, /* mioxPleHoldDownTimer */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 15, 0, /* mioxPleCollisionRetryTimer */ 
      1, 3, 6, 1, 2, 1, 10, 38, 1, 1, 1, 16, 0, /* mioxPleDefaultPeerId */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 0, /* mioxPeer */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 0, /* mioxPeerTable */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 0, /* mioxPeerEntry */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 1, 0, /* mioxPeerIndex */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 2, 0, /* mioxPeerStatus */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 3, 0, /* mioxPeerMaxCircuits */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 4, 0, /* mioxPeerIfIndex */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 5, 0, /* mioxPeerConnectSeconds */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 6, 0, /* mioxPeerX25CallParamId */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 7, 0, /* mioxPeerEnAddr */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 8, 0, /* mioxPeerX121Address */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 9, 0, /* mioxPeerX25CircuitId */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 1, 1, 10, 0, /* mioxPeerDescr */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 2, 0, /* mioxPeerEncTable */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 2, 1, 0, /* mioxPeerEncEntry */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 2, 1, 1, 0, /* mioxPeerEncIndex */ 
      1, 3, 6, 1, 2, 1, 10, 38, 2, 2, 1, 2, 0, /* mioxPeerEncType */ 
      1, 3, 6, 1, 2, 1, 11, 0, /* snmp */ 
      1, 3, 6, 1, 2, 1, 11, 1, 0, /* snmpInPkts */ 
      1, 3, 6, 1, 2, 1, 11, 2, 0, /* snmpOutPkts */ 
      1, 3, 6, 1, 2, 1, 11, 3, 0, /* snmpInBadVersions */ 
      1, 3, 6, 1, 2, 1, 11, 4, 0, /* snmpInBadCommunityNames */ 
      1, 3, 6, 1, 2, 1, 11, 5, 0, /* snmpInBadCommunityUses */ 
      1, 3, 6, 1, 2, 1, 11, 6, 0, /* snmpInASNParseErrs */ 
      1, 3, 6, 1, 2, 1, 11, 8, 0, /* snmpInTooBigs */ 
      1, 3, 6, 1, 2, 1, 11, 9, 0, /* snmpInNoSuchNames */ 
      1, 3, 6, 1, 2, 1, 11, 10, 0, /* snmpInBadValues */ 
      1, 3, 6, 1, 2, 1, 11, 11, 0, /* snmpInReadOnlys */ 
      1, 3, 6, 1, 2, 1, 11, 12, 0, /* snmpInGenErrs */ 
      1, 3, 6, 1, 2, 1, 11, 13, 0, /* snmpInTotalReqVars */ 
      1, 3, 6, 1, 2, 1, 11, 14, 0, /* snmpInTotalSetVars */ 
      1, 3, 6, 1, 2, 1, 11, 15, 0, /* snmpInGetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 16, 0, /* snmpInGetNexts */ 
      1, 3, 6, 1, 2, 1, 11, 17, 0, /* snmpInSetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 18, 0, /* snmpInGetResponses */ 
      1, 3, 6, 1, 2, 1, 11, 19, 0, /* snmpInTraps */ 
      1, 3, 6, 1, 2, 1, 11, 20, 0, /* snmpOutTooBigs */ 
      1, 3, 6, 1, 2, 1, 11, 21, 0, /* snmpOutNoSuchNames */ 
      1, 3, 6, 1, 2, 1, 11, 22, 0, /* snmpOutBadValues */ 
      1, 3, 6, 1, 2, 1, 11, 24, 0, /* snmpOutGenErrs */ 
      1, 3, 6, 1, 2, 1, 11, 25, 0, /* snmpOutGetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 26, 0, /* snmpOutGetNexts */ 
      1, 3, 6, 1, 2, 1, 11, 27, 0, /* snmpOutSetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 28, 0, /* snmpOutGetResponses */ 
      1, 3, 6, 1, 2, 1, 11, 29, 0, /* snmpOutTraps */ 
      1, 3, 6, 1, 2, 1, 11, 30, 0, /* snmpEnableAuthenTraps */ 
      1, 3, 6, 1, 2, 1, 12, 0, /* ifExtensions */ 
      1, 3, 6, 1, 2, 1, 12, 1, 0, /* ifExtnsTable */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 0, /* ifExtnsEntry */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 1, 0, /* ifExtnsIfIndex */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 2, 0, /* ifExtnsChipSet */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 3, 0, /* ifExtnsRevWare */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 4, 0, /* ifExtnsMulticastsTransmittedOks */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 5, 0, /* ifExtnsBroadcastsTransmittedOks */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 6, 0, /* ifExtnsMulticastsReceivedOks */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 7, 0, /* ifExtnsBroadcastsReceivedOks */ 
      1, 3, 6, 1, 2, 1, 12, 1, 1, 8, 0, /* ifExtnsPromiscuous */ 
      1, 3, 6, 1, 2, 1, 12, 2, 0, /* ifExtnsTestTable */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 0, /* ifExtnsTestEntry */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 1, 0, /* ifExtnsTestIfIndex */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 2, 0, /* ifExtnsTestCommunity */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 3, 0, /* ifExtnsTestRequestId */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 4, 0, /* ifExtnsTestType */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 5, 0, /* ifExtnsTestResult */ 
      1, 3, 6, 1, 2, 1, 12, 2, 1, 6, 0, /* ifExtnsTestCode */ 
      1, 3, 6, 1, 2, 1, 12, 3, 0, /* ifExtnsRcvAddrTable */ 
      1, 3, 6, 1, 2, 1, 12, 3, 1, 0, /* ifExtnsRcvAddrEntry */ 
      1, 3, 6, 1, 2, 1, 12, 3, 1, 1, 0, /* ifExtnsRcvAddrIfIndex */ 
      1, 3, 6, 1, 2, 1, 12, 3, 1, 2, 0, /* ifExtnsRcvAddress */ 
      1, 3, 6, 1, 2, 1, 12, 3, 1, 3, 0, /* ifExtnsRcvAddrStatus */ 
      1, 3, 6, 1, 2, 1, 12, 4, 0, /* wellKnownTests */ 
      1, 3, 6, 1, 2, 1, 12, 4, 1, 0, /* testFullDuplexLoopBack */ 
      1, 3, 6, 1, 2, 1, 13, 0, /* appletalk */ 
      1, 3, 6, 1, 2, 1, 13, 1, 0, /* llap */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 0, /* llapTable */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 0, /* llapEntry */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 1, 0, /* llapIfIndex */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 2, 0, /* llapInPkts */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 3, 0, /* llapOutPkts */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 4, 0, /* llapInNoHandlers */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 5, 0, /* llapInLengthErrors */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 6, 0, /* llapInErrors */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 7, 0, /* llapCollisions */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 8, 0, /* llapDefers */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 9, 0, /* llapNoDataErrors */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 10, 0, /* llapRandomCTSErrors */ 
      1, 3, 6, 1, 2, 1, 13, 1, 1, 1, 11, 0, /* llapFCSErrors */ 
      1, 3, 6, 1, 2, 1, 13, 2, 0, /* aarp */ 
      1, 3, 6, 1, 2, 1, 13, 2, 1, 0, /* aarpTable */ 
      1, 3, 6, 1, 2, 1, 13, 2, 1, 1, 0, /* aarpEntry */ 
      1, 3, 6, 1, 2, 1, 13, 2, 1, 1, 1, 0, /* aarpIfIndex */ 
      1, 3, 6, 1, 2, 1, 13, 2, 1, 1, 2, 0, /* aarpPhysAddress */ 
      1, 3, 6, 1, 2, 1, 13, 2, 1, 1, 3, 0, /* aarpNetAddress */ 
      1, 3, 6, 1, 2, 1, 13, 3, 0, /* atport */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 0, /* atportTable */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 0, /* atportEntry */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 1, 0, /* atportIndex */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 2, 0, /* atportDescr */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 3, 0, /* atportType */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 4, 0, /* atportNetStart */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 5, 0, /* atportNetEnd */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 6, 0, /* atportNetAddress */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 7, 0, /* atportStatus */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 8, 0, /* atportNetConfig */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 9, 0, /* atportZoneConfig */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 10, 0, /* atportZone */ 
      1, 3, 6, 1, 2, 1, 13, 3, 1, 1, 11, 0, /* atportIfIndex */ 
      1, 3, 6, 1, 2, 1, 13, 4, 0, /* ddp */ 
      1, 3, 6, 1, 2, 1, 13, 4, 1, 0, /* ddpOutRequests */ 
      1, 3, 6, 1, 2, 1, 13, 4, 2, 0, /* ddpOutShorts */ 
      1, 3, 6, 1, 2, 1, 13, 4, 3, 0, /* ddpOutLongs */ 
      1, 3, 6, 1, 2, 1, 13, 4, 4, 0, /* ddpInReceives */ 
      1, 3, 6, 1, 2, 1, 13, 4, 5, 0, /* ddpForwRequests */ 
      1, 3, 6, 1, 2, 1, 13, 4, 6, 0, /* ddpInLocalDatagrams */ 
      1, 3, 6, 1, 2, 1, 13, 4, 7, 0, /* ddpNoProtocolHandlers */ 
      1, 3, 6, 1, 2, 1, 13, 4, 8, 0, /* ddpOutNoRoutes */ 
      1, 3, 6, 1, 2, 1, 13, 4, 9, 0, /* ddpTooShortErrors */ 
      1, 3, 6, 1, 2, 1, 13, 4, 10, 0, /* ddpTooLongErrors */ 
      1, 3, 6, 1, 2, 1, 13, 4, 11, 0, /* ddpBroadcastErrors */ 
      1, 3, 6, 1, 2, 1, 13, 4, 12, 0, /* ddpShortDDPErrors */ 
      1, 3, 6, 1, 2, 1, 13, 4, 13, 0, /* ddpHopCountErrors */ 
      1, 3, 6, 1, 2, 1, 13, 4, 14, 0, /* ddpChecksumErrors */ 
      1, 3, 6, 1, 2, 1, 13, 5, 0, /* rtmp */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 0, /* rtmpTable */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 0, /* rtmpEntry */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 1, 0, /* rtmpRangeStart */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 2, 0, /* rtmpRangeEnd */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 3, 0, /* rtmpNextHop */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 4, 0, /* rtmpType */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 5, 0, /* rtmpPort */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 6, 0, /* rtmpHops */ 
      1, 3, 6, 1, 2, 1, 13, 5, 1, 1, 7, 0, /* rtmpState */ 
      1, 3, 6, 1, 2, 1, 13, 6, 0, /* kip */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 0, /* kipTable */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 0, /* kipEntry */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 1, 0, /* kipNetStart */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 2, 0, /* kipNetEnd */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 3, 0, /* kipNextHop */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 4, 0, /* kipHopCount */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 5, 0, /* kipBCastAddr */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 6, 0, /* kipCore */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 7, 0, /* kipType */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 8, 0, /* kipState */ 
      1, 3, 6, 1, 2, 1, 13, 6, 1, 1, 9, 0, /* kipShare */ 
      1, 3, 6, 1, 2, 1, 13, 7, 0, /* zip */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 0, /* zipTable */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 1, 0, /* zipEntry */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 1, 1, 0, /* zipZoneName */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 1, 2, 0, /* zipZoneIndex */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 1, 3, 0, /* zipZoneNetStart */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 1, 4, 0, /* zipZoneNetEnd */ 
      1, 3, 6, 1, 2, 1, 13, 7, 1, 1, 5, 0, /* zipZoneState */ 
      1, 3, 6, 1, 2, 1, 13, 8, 0, /* nbp */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 0, /* nbpTable */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 1, 0, /* nbpEntry */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 1, 1, 0, /* nbpIndex */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 1, 2, 0, /* nbpObject */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 1, 3, 0, /* nbpType */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 1, 4, 0, /* nbpZone */ 
      1, 3, 6, 1, 2, 1, 13, 8, 1, 1, 5, 0, /* nbpState */ 
      1, 3, 6, 1, 2, 1, 13, 9, 0, /* atecho */ 
      1, 3, 6, 1, 2, 1, 13, 9, 1, 0, /* atechoRequests */ 
      1, 3, 6, 1, 2, 1, 13, 9, 2, 0, /* atechoReplies */ 
      1, 3, 6, 1, 2, 1, 14, 0, /* ospf */ 
      1, 3, 6, 1, 2, 1, 14, 1, 0, /* ospfGeneralGroup */ 
      1, 3, 6, 1, 2, 1, 14, 1, 1, 0, /* ospfRouterId */ 
      1, 3, 6, 1, 2, 1, 14, 1, 2, 0, /* ospfAdminStat */ 
      1, 3, 6, 1, 2, 1, 14, 1, 3, 0, /* ospfVersionNumber */ 
      1, 3, 6, 1, 2, 1, 14, 1, 4, 0, /* ospfAreaBdrRtrStatus */ 
      1, 3, 6, 1, 2, 1, 14, 1, 5, 0, /* ospfASBdrRtrStatus */ 
      1, 3, 6, 1, 2, 1, 14, 1, 6, 0, /* ospfExternLSACount */ 
      1, 3, 6, 1, 2, 1, 14, 1, 7, 0, /* ospfExternLSACksumSum */ 
      1, 3, 6, 1, 2, 1, 14, 1, 8, 0, /* ospfTOSSupport */ 
      1, 3, 6, 1, 2, 1, 14, 1, 9, 0, /* ospfOriginateNewLSAs */ 
      1, 3, 6, 1, 2, 1, 14, 1, 10, 0, /* ospfRxNewLSAs */ 
      1, 3, 6, 1, 2, 1, 14, 2, 0, /* ospfAreaTable */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 0, /* ospfAreaEntry */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 1, 0, /* ospfAreaId */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 2, 0, /* ospfAuthType */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 3, 0, /* ospfImportASExtern */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 4, 0, /* ospfSpfRuns */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 5, 0, /* ospfAreaBdrRtrCount */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 6, 0, /* ospfASBdrRtrCount */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 7, 0, /* ospfAreaLSACount */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 8, 0, /* ospfAreaLSACksumSum */ 
      1, 3, 6, 1, 2, 1, 14, 3, 0, /* ospfStubAreaTable */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 0, /* ospfStubAreaEntry */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 1, 0, /* ospfStubAreaID */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 2, 0, /* ospfStubTOS */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 3, 0, /* ospfStubMetric */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 4, 0, /* ospfStubStatus */ 
      1, 3, 6, 1, 2, 1, 14, 4, 0, /* ospfLsdbTable */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 0, /* ospfLsdbEntry */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 1, 0, /* ospfLsdbAreaId */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 2, 0, /* ospfLsdbType */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 3, 0, /* ospfLsdbLSID */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 4, 0, /* ospfLsdbRouterId */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 5, 0, /* ospfLsdbSequence */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 6, 0, /* ospfLsdbAge */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 7, 0, /* ospfLsdbChecksum */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 8, 0, /* ospfLsdbAdvertisement */ 
      1, 3, 6, 1, 2, 1, 14, 5, 0, /* ospfAreaRangeTable */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 0, /* ospfAreaRangeEntry */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 1, 0, /* ospfAreaRangeAreaID */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 2, 0, /* ospfAreaRangeNet */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 3, 0, /* ospfAreaRangeMask */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 4, 0, /* ospfAreaRangeStatus */ 
      1, 3, 6, 1, 2, 1, 14, 6, 0, /* ospfHostTable */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 0, /* ospfHostEntry */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 1, 0, /* ospfHostIpAddress */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 2, 0, /* ospfHostTOS */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 3, 0, /* ospfHostMetric */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 4, 0, /* ospfHostStatus */ 
      1, 3, 6, 1, 2, 1, 14, 7, 0, /* ospfIfTable */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 0, /* ospfIfEntry */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 1, 0, /* ospfIfIpAddress */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 2, 0, /* ospfAddressLessIf */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 3, 0, /* ospfIfAreaId */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 4, 0, /* ospfIfType */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 5, 0, /* ospfIfAdminStat */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 6, 0, /* ospfIfRtrPriority */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 7, 0, /* ospfIfTransitDelay */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 8, 0, /* ospfIfRetransInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 9, 0, /* ospfIfHelloInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 10, 0, /* ospfIfRtrDeadInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 11, 0, /* ospfIfPollInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 12, 0, /* ospfIfState */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 13, 0, /* ospfIfDesignatedRouter */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 14, 0, /* ospfIfBackupDesignatedRouter */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 15, 0, /* ospfIfEvents */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 16, 0, /* ospfIfAuthKey */ 
      1, 3, 6, 1, 2, 1, 14, 8, 0, /* ospfIfMetricTable */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 0, /* ospfIfMetricEntry */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 1, 0, /* ospfIfMetricIpAddress */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 2, 0, /* ospfIfMetricAddressLessIf */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 3, 0, /* ospfIfMetricTOS */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 4, 0, /* ospfIfMetricMetric */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 5, 0, /* ospfIfMetricStatus */ 
      1, 3, 6, 1, 2, 1, 14, 9, 0, /* ospfVirtIfTable */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 0, /* ospfVirtIfEntry */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 1, 0, /* ospfVirtIfAreaID */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 2, 0, /* ospfVirtIfNeighbor */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 3, 0, /* ospfVirtIfTransitDelay */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 4, 0, /* ospfVirtIfRetransInterval */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 5, 0, /* ospfVirtIfHelloInterval */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 6, 0, /* ospfVirtIfRtrDeadInterval */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 7, 0, /* ospfVirtIfState */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 8, 0, /* ospfVirtIfEvents */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 9, 0, /* ospfVirtIfAuthKey */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 10, 0, /* ospfVirtIfStatus */ 
      1, 3, 6, 1, 2, 1, 14, 10, 0, /* ospfNbrTable */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 0, /* ospfNbrEntry */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 1, 0, /* ospfNbrIpAddr */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 2, 0, /* ospfNbrAddressLessIndex */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 3, 0, /* ospfNbrRtrId */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 4, 0, /* ospfNbrOptions */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 5, 0, /* ospfNbrPriority */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 6, 0, /* ospfNbrState */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 7, 0, /* ospfNbrEvents */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 8, 0, /* ospfNbrLSRetransQLen */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 9, 0, /* ospfNBMANbrStatus */ 
      1, 3, 6, 1, 2, 1, 14, 11, 0, /* ospfVirtNbrTable */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 0, /* ospfVirtNbrEntry */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 1, 0, /* ospfVirtNbrArea */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 2, 0, /* ospfVirtNbrRtrId */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 3, 0, /* ospfVirtNbrIpAddr */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 4, 0, /* ospfVirtNbrOptions */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 5, 0, /* ospfVirtNbrState */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 6, 0, /* ospfVirtNbrEvents */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 7, 0, /* ospfVirtNbrLSRetransQLen */ 
      1, 3, 6, 1, 2, 1, 15, 0, /* bgp */ 
      1, 3, 6, 1, 2, 1, 15, 1, 0, /* bgpVersion */ 
      1, 3, 6, 1, 2, 1, 15, 2, 0, /* bgpLocalAs */ 
      1, 3, 6, 1, 2, 1, 15, 3, 0, /* bgpPeerTable */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 0, /* bgpPeerEntry */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 1, 0, /* bgpPeerIdentifier */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 2, 0, /* bgpPeerState */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 3, 0, /* bgpPeerAdminStatus */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 4, 0, /* bgpPeerNegotiatedVersion */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 5, 0, /* bgpPeerLocalAddr */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 6, 0, /* bgpPeerLocalPort */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 7, 0, /* bgpPeerRemoteAddr */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 8, 0, /* bgpPeerRemotePort */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 9, 0, /* bgpPeerRemoteAs */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 10, 0, /* bgpPeerInUpdates */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 11, 0, /* bgpPeerOutUpdates */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 12, 0, /* bgpPeerInTotalMessages */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 13, 0, /* bgpPeerOutTotalMessages */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 14, 0, /* bgpPeerLastError */ 
      1, 3, 6, 1, 2, 1, 15, 4, 0, /* bgpIdentifier */ 
      1, 3, 6, 1, 2, 1, 15, 5, 0, /* bgpRcvdPathAttrTable */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 0, /* bgpPathAttrEntry */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 1, 0, /* bgpPathAttrPeer */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 2, 0, /* bgpPathAttrDestNetwork */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 3, 0, /* bgpPathAttrOrigin */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 4, 0, /* bgpPathAttrASPath */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 5, 0, /* bgpPathAttrNextHop */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 6, 0, /* bgpPathAttrInterASMetric */ 
      1, 3, 6, 1, 2, 1, 16, 0, /* rmon */ 
      1, 3, 6, 1, 2, 1, 16, 1, 0, /* statistics */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 0, /* etherStatsTable */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 0, /* etherStatsEntry */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 1, 0, /* etherStatsIndex */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 2, 0, /* etherStatsDataSource */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 3, 0, /* etherStatsDropEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 4, 0, /* etherStatsOctets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 5, 0, /* etherStatsPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 6, 0, /* etherStatsBroadcastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 7, 0, /* etherStatsMulticastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 8, 0, /* etherStatsCRCAlignErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 9, 0, /* etherStatsUndersizePkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 10, 0, /* etherStatsOversizePkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 11, 0, /* etherStatsFragments */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 12, 0, /* etherStatsJabbers */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 13, 0, /* etherStatsCollisions */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 14, 0, /* etherStatsPkts64Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 15, 0, /* etherStatsPkts65to127Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 16, 0, /* etherStatsPkts128to255Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 17, 0, /* etherStatsPkts256to511Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 18, 0, /* etherStatsPkts512to1023Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 19, 0, /* etherStatsPkts1024to1518Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 20, 0, /* etherStatsOwner */ 
      1, 3, 6, 1, 2, 1, 16, 1, 1, 1, 21, 0, /* etherStatsStatus */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 0, /* tokenRingMLStatsTable */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 0, /* tokenRingMLStatsEntry */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 1, 0, /* tokenRingMLStatsIndex */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 2, 0, /* tokenRingMLStatsDataSource */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 3, 0, /* tokenRingMLStatsDropEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 4, 0, /* tokenRingMLStatsMacOctets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 5, 0, /* tokenRingMLStatsMacPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 6, 0, /* tokenRingMLStatsRingPurgeEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 7, 0, /* tokenRingMLStatsRingPurgePkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 8, 0, /* tokenRingMLStatsBeaconEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 9, 0, /* tokenRingMLStatsBeaconTime */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 10, 0, /* tokenRingMLStatsBeaconPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 11, 0, /* tokenRingMLStatsClaimTokenEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 12, 0, /* tokenRingMLStatsClaimTokenPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 13, 0, /* tokenRingMLStatsNAUNChanges */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 14, 0, /* tokenRingMLStatsLineErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 15, 0, /* tokenRingMLStatsInternalErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 16, 0, /* tokenRingMLStatsBurstErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 17, 0, /* tokenRingMLStatsACErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 18, 0, /* tokenRingMLStatsAbortErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 19, 0, /* tokenRingMLStatsLostFrameErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 20, 0, /* tokenRingMLStatsCongestionErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 21, 0, /* tokenRingMLStatsFrameCopiedErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 22, 0, /* tokenRingMLStatsFrequencyErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 23, 0, /* tokenRingMLStatsTokenErrors */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 24, 0, /* tokenRingMLStatsSoftErrorReports */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 25, 0, /* tokenRingMLStatsRingPollEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 26, 0, /* tokenRingMLStatsOwner */ 
      1, 3, 6, 1, 2, 1, 16, 1, 2, 1, 27, 0, /* tokenRingMLStatsStatus */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 0, /* tokenRingPStatsTable */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 0, /* tokenRingPStatsEntry */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 1, 0, /* tokenRingPStatsIndex */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 2, 0, /* tokenRingPStatsDataSource */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 3, 0, /* tokenRingPStatsDropEvents */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 4, 0, /* tokenRingPStatsDataOctets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 5, 0, /* tokenRingPStatsDataPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 6, 0, /* tokenRingPStatsDataBroadcastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 7, 0, /* tokenRingPStatsDataMulticastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 8, 0, /* tokenRingPStatsDataPkts18to63Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 9, 0, /* tokenRingPStatsDataPkts64to127Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 10, 0, /* tokenRingPStatsDataPkts128to255Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 11, 0, /* tokenRingPStatsDataPkts256to511Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 12, 0, /* tokenRingPStatsDataPkts512to1023Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 13, 0, /* tokenRingPStatsDataPkts1024to2047Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 14, 0, /* tokenRingPStatsDataPkts2048to4095Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 15, 0, /* tokenRingPStatsDataPkts4096to8191Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 16, 0, /* tokenRingPStatsDataPkts8192to18000Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 17, 0, /* tokenRingPStatsDataPktsGreaterThan18000Octets */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 18, 0, /* tokenRingPStatsOwner */ 
      1, 3, 6, 1, 2, 1, 16, 1, 3, 1, 19, 0, /* tokenRingPStatsStatus */ 
      1, 3, 6, 1, 2, 1, 16, 2, 0, /* history */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 0, /* historyControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 0, /* historyControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 1, 0, /* historyControlIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 2, 0, /* historyControlDataSource */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 3, 0, /* historyControlBucketsRequested */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 4, 0, /* historyControlBucketsGranted */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 5, 0, /* historyControlInterval */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 6, 0, /* historyControlOwner */ 
      1, 3, 6, 1, 2, 1, 16, 2, 1, 1, 7, 0, /* historyControlStatus */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 0, /* etherHistoryTable */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 0, /* etherHistoryEntry */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 1, 0, /* etherHistoryIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 2, 0, /* etherHistorySampleIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 3, 0, /* etherHistoryIntervalStart */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 4, 0, /* etherHistoryDropEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 5, 0, /* etherHistoryOctets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 6, 0, /* etherHistoryPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 7, 0, /* etherHistoryBroadcastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 8, 0, /* etherHistoryMulticastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 9, 0, /* etherHistoryCRCAlignErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 10, 0, /* etherHistoryUndersizePkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 11, 0, /* etherHistoryOversizePkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 12, 0, /* etherHistoryFragments */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 13, 0, /* etherHistoryJabbers */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 14, 0, /* etherHistoryCollisions */ 
      1, 3, 6, 1, 2, 1, 16, 2, 2, 1, 15, 0, /* etherHistoryUtilization */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 0, /* tokenRingMLHistoryTable */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 0, /* tokenRingMLHistoryEntry */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 1, 0, /* tokenRingMLHistoryIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 2, 0, /* tokenRingMLHistorySampleIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 3, 0, /* tokenRingMLHistoryIntervalStart */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 4, 0, /* tokenRingMLHistoryDropEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 5, 0, /* tokenRingMLHistoryMacOctets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 6, 0, /* tokenRingMLHistoryMacPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 7, 0, /* tokenRingMLHistoryRingPurgeEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 8, 0, /* tokenRingMLHistoryRingPurgePkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 9, 0, /* tokenRingMLHistoryBeaconEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 10, 0, /* tokenRingMLHistoryBeaconTime */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 11, 0, /* tokenRingMLHistoryBeaconPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 12, 0, /* tokenRingMLHistoryClaimTokenEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 13, 0, /* tokenRingMLHistoryClaimTokenPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 14, 0, /* tokenRingMLHistoryNAUNChanges */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 15, 0, /* tokenRingMLHistoryLineErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 16, 0, /* tokenRingMLHistoryInternalErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 17, 0, /* tokenRingMLHistoryBurstErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 18, 0, /* tokenRingMLHistoryACErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 19, 0, /* tokenRingMLHistoryAbortErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 20, 0, /* tokenRingMLHistoryLostFrameErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 21, 0, /* tokenRingMLHistoryCongestionErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 22, 0, /* tokenRingMLHistoryFrameCopiedErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 23, 0, /* tokenRingMLHistoryFrequencyErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 24, 0, /* tokenRingMLHistoryTokenErrors */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 25, 0, /* tokenRingMLHistorySoftErrorReports */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 26, 0, /* tokenRingMLHistoryRingPollEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 3, 1, 27, 0, /* tokenRingMLHistoryActiveStations */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 0, /* tokenRingPHistoryTable */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 0, /* tokenRingPHistoryEntry */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 1, 0, /* tokenRingPHistoryIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 2, 0, /* tokenRingPHistorySampleIndex */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 3, 0, /* tokenRingPHistoryIntervalStart */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 4, 0, /* tokenRingPHistoryDropEvents */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 5, 0, /* tokenRingPHistoryDataOctets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 6, 0, /* tokenRingPHistoryDataPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 7, 0, /* tokenRingPHistoryDataBroadcastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 8, 0, /* tokenRingPHistoryDataMulticastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 9, 0, /* tokenRingPHistoryDataPkts18to63Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 10, 0, /* tokenRingPHistoryDataPkts64to127Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 11, 0, /* tokenRingPHistoryDataPkts128to255Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 12, 0, /* tokenRingPHistoryDataPkts256to511Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 13, 0, /* tokenRingPHistoryDataPkts512to1023Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 14, 0, /* tokenRingPHistoryDataPkts1024to2047Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 15, 0, /* tokenRingPHistoryDataPkts2048to4095Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 16, 0, /* tokenRingPHistoryDataPkts4096to8191Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 17, 0, /* tokenRingPHistoryDataPkts8192to18000Octets */ 
      1, 3, 6, 1, 2, 1, 16, 2, 4, 1, 18, 0, /* tokenRingPHistoryDataPktsGreaterThan18000Octets */ 
      1, 3, 6, 1, 2, 1, 16, 3, 0, /* alarm */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 0, /* alarmTable */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 0, /* alarmEntry */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 1, 0, /* alarmIndex */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 2, 0, /* alarmInterval */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 3, 0, /* alarmVariable */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 4, 0, /* alarmSampleType */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 5, 0, /* alarmValue */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 6, 0, /* alarmStartupAlarm */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 7, 0, /* alarmRisingThreshold */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 8, 0, /* alarmFallingThreshold */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 9, 0, /* alarmRisingEventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 10, 0, /* alarmFallingEventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 11, 0, /* alarmOwner */ 
      1, 3, 6, 1, 2, 1, 16, 3, 1, 1, 12, 0, /* alarmStatus */ 
      1, 3, 6, 1, 2, 1, 16, 4, 0, /* hosts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 0, /* hostControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 0, /* hostControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 1, 0, /* hostControlIndex */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 2, 0, /* hostControlDataSource */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 3, 0, /* hostControlTableSize */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 4, 0, /* hostControlLastDeleteTime */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 5, 0, /* hostControlOwner */ 
      1, 3, 6, 1, 2, 1, 16, 4, 1, 1, 6, 0, /* hostControlStatus */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 0, /* hostTable */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 0, /* hostEntry */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 1, 0, /* hostAddress */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 2, 0, /* hostCreationOrder */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 3, 0, /* hostIndex */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 4, 0, /* hostInPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 5, 0, /* hostOutPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 6, 0, /* hostInOctets */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 7, 0, /* hostOutOctets */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 8, 0, /* hostOutErrors */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 9, 0, /* hostOutBroadcastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 2, 1, 10, 0, /* hostOutMulticastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 0, /* hostTimeTable */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 0, /* hostTimeEntry */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 1, 0, /* hostTimeAddress */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 2, 0, /* hostTimeCreationOrder */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 3, 0, /* hostTimeIndex */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 4, 0, /* hostTimeInPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 5, 0, /* hostTimeOutPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 6, 0, /* hostTimeInOctets */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 7, 0, /* hostTimeOutOctets */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 8, 0, /* hostTimeOutErrors */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 9, 0, /* hostTimeOutBroadcastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 4, 3, 1, 10, 0, /* hostTimeOutMulticastPkts */ 
      1, 3, 6, 1, 2, 1, 16, 5, 0, /* hostTopN */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 0, /* hostTopNControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 0, /* hostTopNControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 1, 0, /* hostTopNControlIndex */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 2, 0, /* hostTopNHostIndex */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 3, 0, /* hostTopNRateBase */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 4, 0, /* hostTopNTimeRemaining */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 5, 0, /* hostTopNDuration */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 6, 0, /* hostTopNRequestedSize */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 7, 0, /* hostTopNGrantedSize */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 8, 0, /* hostTopNStartTime */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 9, 0, /* hostTopNOwner */ 
      1, 3, 6, 1, 2, 1, 16, 5, 1, 1, 10, 0, /* hostTopNStatus */ 
      1, 3, 6, 1, 2, 1, 16, 5, 2, 0, /* hostTopNTable */ 
      1, 3, 6, 1, 2, 1, 16, 5, 2, 1, 0, /* hostTopNEntry */ 
      1, 3, 6, 1, 2, 1, 16, 5, 2, 1, 1, 0, /* hostTopNReport */ 
      1, 3, 6, 1, 2, 1, 16, 5, 2, 1, 2, 0, /* hostTopNIndex */ 
      1, 3, 6, 1, 2, 1, 16, 5, 2, 1, 3, 0, /* hostTopNAddress */ 
      1, 3, 6, 1, 2, 1, 16, 5, 2, 1, 4, 0, /* hostTopNRate */ 
      1, 3, 6, 1, 2, 1, 16, 6, 0, /* matrix */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 0, /* matrixControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 0, /* matrixControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 1, 0, /* matrixControlIndex */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 2, 0, /* matrixControlDataSource */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 3, 0, /* matrixControlTableSize */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 4, 0, /* matrixControlLastDeleteTime */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 5, 0, /* matrixControlOwner */ 
      1, 3, 6, 1, 2, 1, 16, 6, 1, 1, 6, 0, /* matrixControlStatus */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 0, /* matrixSDTable */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 0, /* matrixSDEntry */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 1, 0, /* matrixSDSourceAddress */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 2, 0, /* matrixSDDestAddress */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 3, 0, /* matrixSDIndex */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 4, 0, /* matrixSDPkts */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 5, 0, /* matrixSDOctets */ 
      1, 3, 6, 1, 2, 1, 16, 6, 2, 1, 6, 0, /* matrixSDErrors */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 0, /* matrixDSTable */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 0, /* matrixDSEntry */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 1, 0, /* matrixDSSourceAddress */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 2, 0, /* matrixDSDestAddress */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 3, 0, /* matrixDSIndex */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 4, 0, /* matrixDSPkts */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 5, 0, /* matrixDSOctets */ 
      1, 3, 6, 1, 2, 1, 16, 6, 3, 1, 6, 0, /* matrixDSErrors */ 
      1, 3, 6, 1, 2, 1, 16, 7, 0, /* filter */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 0, /* filterTable */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 0, /* filterEntry */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 1, 0, /* filterIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 2, 0, /* filterChannelIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 3, 0, /* filterPktDataOffset */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 4, 0, /* filterPktData */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 5, 0, /* filterPktDataMask */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 6, 0, /* filterPktDataNotMask */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 7, 0, /* filterPktStatus */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 8, 0, /* filterPktStatusMask */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 9, 0, /* filterPktStatusNotMask */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 10, 0, /* filterOwner */ 
      1, 3, 6, 1, 2, 1, 16, 7, 1, 1, 11, 0, /* filterStatus */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 0, /* channelTable */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 0, /* channelEntry */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 1, 0, /* channelIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 2, 0, /* channelIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 3, 0, /* channelAcceptType */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 4, 0, /* channelDataControl */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 5, 0, /* channelTurnOnEventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 6, 0, /* channelTurnOffEventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 7, 0, /* channelEventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 8, 0, /* channelEventStatus */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 9, 0, /* channelMatches */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 10, 0, /* channelDescription */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 11, 0, /* channelOwner */ 
      1, 3, 6, 1, 2, 1, 16, 7, 2, 1, 12, 0, /* channelStatus */ 
      1, 3, 6, 1, 2, 1, 16, 8, 0, /* capture */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 0, /* bufferControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 0, /* bufferControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 1, 0, /* bufferControlIndex */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 2, 0, /* bufferControlChannelIndex */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 3, 0, /* bufferControlFullStatus */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 4, 0, /* bufferControlFullAction */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 5, 0, /* bufferControlCaptureSliceSize */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 6, 0, /* bufferControlDownloadSliceSize */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 7, 0, /* bufferControlDownloadOffset */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 8, 0, /* bufferControlMaxOctetsRequested */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 9, 0, /* bufferControlMaxOctetsGranted */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 10, 0, /* bufferControlCapturedPackets */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 11, 0, /* bufferControlTurnOnTime */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 12, 0, /* bufferControlOwner */ 
      1, 3, 6, 1, 2, 1, 16, 8, 1, 1, 13, 0, /* bufferControlStatus */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 0, /* captureBufferTable */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 0, /* captureBufferEntry */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 1, 0, /* captureBufferControlIndex */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 2, 0, /* captureBufferIndex */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 3, 0, /* captureBufferPacketID */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 4, 0, /* captureBufferPacketData */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 5, 0, /* captureBufferPacketLength */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 6, 0, /* captureBufferPacketTime */ 
      1, 3, 6, 1, 2, 1, 16, 8, 2, 1, 7, 0, /* captureBufferPacketStatus */ 
      1, 3, 6, 1, 2, 1, 16, 9, 0, /* event */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 0, /* eventTable */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 0, /* eventEntry */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 1, 0, /* eventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 2, 0, /* eventDescription */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 3, 0, /* eventType */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 4, 0, /* eventCommunity */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 5, 0, /* eventLastTimeSent */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 6, 0, /* eventOwner */ 
      1, 3, 6, 1, 2, 1, 16, 9, 1, 1, 7, 0, /* eventStatus */ 
      1, 3, 6, 1, 2, 1, 16, 9, 2, 0, /* logTable */ 
      1, 3, 6, 1, 2, 1, 16, 9, 2, 1, 0, /* logEntry */ 
      1, 3, 6, 1, 2, 1, 16, 9, 2, 1, 1, 0, /* logEventIndex */ 
      1, 3, 6, 1, 2, 1, 16, 9, 2, 1, 2, 0, /* logIndex */ 
      1, 3, 6, 1, 2, 1, 16, 9, 2, 1, 3, 0, /* logTime */ 
      1, 3, 6, 1, 2, 1, 16, 9, 2, 1, 4, 0, /* logDescription */ 
      1, 3, 6, 1, 2, 1, 16, 10, 0, /* tokenRing */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 0, /* ringStationControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 0, /* ringStationControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 1, 0, /* ringStationControlIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 2, 0, /* ringStationControlTableSize */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 3, 0, /* ringStationControlActiveStations */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 4, 0, /* ringStationControlRingState */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 5, 0, /* ringStationControlBeaconSender */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 6, 0, /* ringStationControlBeaconNAUN */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 7, 0, /* ringStationControlActiveMonitor */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 8, 0, /* ringStationControlOrderChanges */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 9, 0, /* ringStationControlOwner */ 
      1, 3, 6, 1, 2, 1, 16, 10, 1, 1, 10, 0, /* ringStationControlStatus */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 0, /* ringStationTable */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 0, /* ringStationEntry */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 1, 0, /* ringStationIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 2, 0, /* ringStationMacAddress */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 3, 0, /* ringStationLastNAUN */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 4, 0, /* ringStationStationStatus */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 5, 0, /* ringStationLastEnterTime */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 6, 0, /* ringStationLastExitTime */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 7, 0, /* ringStationDuplicateAddresses */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 8, 0, /* ringStationInLineErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 9, 0, /* ringStationOutLineErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 10, 0, /* ringStationInternalErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 11, 0, /* ringStationInBurstErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 12, 0, /* ringStationOutBurstErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 13, 0, /* ringStationACErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 14, 0, /* ringStationAbortErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 15, 0, /* ringStationLostFrameErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 16, 0, /* ringStationCongestionErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 17, 0, /* ringStationFrameCopiedErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 18, 0, /* ringStationFrequencyErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 19, 0, /* ringStationTokenErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 20, 0, /* ringStationInBeaconErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 21, 0, /* ringStationOutBeaconErrors */ 
      1, 3, 6, 1, 2, 1, 16, 10, 2, 1, 22, 0, /* ringStationInsertions */ 
      1, 3, 6, 1, 2, 1, 16, 10, 3, 0, /* ringStationOrderTable */ 
      1, 3, 6, 1, 2, 1, 16, 10, 3, 1, 0, /* ringStationOrderEntry */ 
      1, 3, 6, 1, 2, 1, 16, 10, 3, 1, 1, 0, /* ringStationOrderIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 3, 1, 2, 0, /* ringStationOrderOrderIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 3, 1, 3, 0, /* ringStationOrderMacAddress */ 
      1, 3, 6, 1, 2, 1, 16, 10, 4, 0, /* ringStationConfigControlTable */ 
      1, 3, 6, 1, 2, 1, 16, 10, 4, 1, 0, /* ringStationConfigControlEntry */ 
      1, 3, 6, 1, 2, 1, 16, 10, 4, 1, 1, 0, /* ringStationConfigControlIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 4, 1, 2, 0, /* ringStationConfigControlMacAddress */ 
      1, 3, 6, 1, 2, 1, 16, 10, 4, 1, 3, 0, /* ringStationConfigControlRemove */ 
      1, 3, 6, 1, 2, 1, 16, 10, 4, 1, 4, 0, /* ringStationConfigControlUpdateStats */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 0, /* ringStationConfigTable */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 0, /* ringStationConfigEntry */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 1, 0, /* ringStationConfigIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 2, 0, /* ringStationConfigMacAddress */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 3, 0, /* ringStationConfigUpdateTime */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 4, 0, /* ringStationConfigLocation */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 5, 0, /* ringStationConfigMicrocode */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 6, 0, /* ringStationConfigGroupAddress */ 
      1, 3, 6, 1, 2, 1, 16, 10, 5, 1, 7, 0, /* ringStationConfigFunctionalAddress */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 0, /* sourceRoutingStatsTable */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 0, /* sourceRoutingStatsEntry */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 1, 0, /* sourceRoutingStatsIfIndex */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 2, 0, /* sourceRoutingStatsRingNumber */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 3, 0, /* sourceRoutingStatsInFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 4, 0, /* sourceRoutingStatsOutFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 5, 0, /* sourceRoutingStatsThroughFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 6, 0, /* sourceRoutingStatsAllRoutesBroadcastFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 7, 0, /* sourceRoutingStatsSingleRouteBroadcastFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 8, 0, /* sourceRoutingStatsInOctets */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 9, 0, /* sourceRoutingStatsOutOctets */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 10, 0, /* sourceRoutingStatsThroughOctets */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 11, 0, /* sourceRoutingStatsAllRoutesBroadcastOctets */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 12, 0, /* sourceRoutingStatsSingleRoutesBroadcastOctets */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 13, 0, /* sourceRoutingStatsLocalLLCFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 14, 0, /* sourceRoutingStats1HopFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 15, 0, /* sourceRoutingStats2HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 16, 0, /* sourceRoutingStats3HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 17, 0, /* sourceRoutingStats4HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 18, 0, /* sourceRoutingStats5HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 19, 0, /* sourceRoutingStats6HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 20, 0, /* sourceRoutingStats7HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 21, 0, /* sourceRoutingStats8HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 22, 0, /* sourceRoutingStatsMoreThan8HopsFrames */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 23, 0, /* sourceRoutingStatsOwner */ 
      1, 3, 6, 1, 2, 1, 16, 10, 6, 1, 24, 0, /* sourceRoutingStatsStatus */ 
      1, 3, 6, 1, 2, 1, 17, 0, /* dot1dBridge */ 
      1, 3, 6, 1, 2, 1, 17, 1, 0, /* dot1dBase */ 
      1, 3, 6, 1, 2, 1, 17, 1, 1, 0, /* dot1dBaseBridgeAddress */ 
      1, 3, 6, 1, 2, 1, 17, 1, 2, 0, /* dot1dBaseNumPorts */ 
      1, 3, 6, 1, 2, 1, 17, 1, 3, 0, /* dot1dBaseType */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 0, /* dot1dBasePortTable */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 1, 0, /* dot1dBasePortEntry */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 1, 1, 0, /* dot1dBasePort */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 1, 2, 0, /* dot1dBasePortIfIndex */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 1, 3, 0, /* dot1dBasePortCircuit */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 1, 4, 0, /* dot1dBasePortDelayExceededDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 1, 4, 1, 5, 0, /* dot1dBasePortMtuExceededDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 2, 0, /* dot1dStp */ 
      1, 3, 6, 1, 2, 1, 17, 2, 1, 0, /* dot1dStpProtocolSpecification */ 
      1, 3, 6, 1, 2, 1, 17, 2, 2, 0, /* dot1dStpPriority */ 
      1, 3, 6, 1, 2, 1, 17, 2, 3, 0, /* dot1dStpTimeSinceTopologyChange */ 
      1, 3, 6, 1, 2, 1, 17, 2, 4, 0, /* dot1dStpTopChanges */ 
      1, 3, 6, 1, 2, 1, 17, 2, 5, 0, /* dot1dStpDesignatedRoot */ 
      1, 3, 6, 1, 2, 1, 17, 2, 6, 0, /* dot1dStpRootCost */ 
      1, 3, 6, 1, 2, 1, 17, 2, 7, 0, /* dot1dStpRootPort */ 
      1, 3, 6, 1, 2, 1, 17, 2, 8, 0, /* dot1dStpMaxAge */ 
      1, 3, 6, 1, 2, 1, 17, 2, 9, 0, /* dot1dStpHelloTime */ 
      1, 3, 6, 1, 2, 1, 17, 2, 10, 0, /* dot1dStpHoldTime */ 
      1, 3, 6, 1, 2, 1, 17, 2, 11, 0, /* dot1dStpForwardDelay */ 
      1, 3, 6, 1, 2, 1, 17, 2, 12, 0, /* dot1dStpBridgeMaxAge */ 
      1, 3, 6, 1, 2, 1, 17, 2, 13, 0, /* dot1dStpBridgeHelloTime */ 
      1, 3, 6, 1, 2, 1, 17, 2, 14, 0, /* dot1dStpBridgeForwardDelay */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 0, /* dot1dStpPortTable */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 0, /* dot1dStpPortEntry */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 1, 0, /* dot1dStpPort */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 2, 0, /* dot1dStpPortPriority */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 3, 0, /* dot1dStpPortState */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 4, 0, /* dot1dStpPortEnable */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 5, 0, /* dot1dStpPortPathCost */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 6, 0, /* dot1dStpPortDesignatedRoot */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 7, 0, /* dot1dStpPortDesignatedCost */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 8, 0, /* dot1dStpPortDesignatedBridge */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 9, 0, /* dot1dStpPortDesignatedPort */ 
      1, 3, 6, 1, 2, 1, 17, 2, 15, 1, 10, 0, /* dot1dStpPortForwardTransitions */ 
      1, 3, 6, 1, 2, 1, 17, 3, 0, /* dot1dSr */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 0, /* dot1dSrPortTable */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 0, /* dot1dSrPortEntry */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 1, 0, /* dot1dSrPort */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 2, 0, /* dot1dSrPortHopCount */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 3, 0, /* dot1dSrPortLocalSegment */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 4, 0, /* dot1dSrPortBridgeNum */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 5, 0, /* dot1dSrPortTargetSegment */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 6, 0, /* dot1dSrPortLargestFrame */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 7, 0, /* dot1dSrPortSTESpanMode */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 8, 0, /* dot1dSrPortSpecInFrames */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 9, 0, /* dot1dSrPortSpecOutFrames */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 10, 0, /* dot1dSrPortApeInFrames */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 11, 0, /* dot1dSrPortApeOutFrames */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 12, 0, /* dot1dSrPortSteInFrames */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 13, 0, /* dot1dSrPortSteOutFrames */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 14, 0, /* dot1dSrPortSegmentMismatchDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 15, 0, /* dot1dSrPortDuplicateSegmentDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 16, 0, /* dot1dSrPortHopCountExceededDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 17, 0, /* dot1dSrPortDupLanIdOrTreeErrors */ 
      1, 3, 6, 1, 2, 1, 17, 3, 1, 1, 18, 0, /* dot1dSrPortLanIdMismatches */ 
      1, 3, 6, 1, 2, 1, 17, 3, 2, 0, /* dot1dSrBridgeLfMode */ 
      1, 3, 6, 1, 2, 1, 17, 4, 0, /* dot1dTp */ 
      1, 3, 6, 1, 2, 1, 17, 4, 1, 0, /* dot1dTpLearnedEntryDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 4, 2, 0, /* dot1dTpAgingTime */ 
      1, 3, 6, 1, 2, 1, 17, 4, 3, 0, /* dot1dTpFdbTable */ 
      1, 3, 6, 1, 2, 1, 17, 4, 3, 1, 0, /* dot1dTpFdbEntry */ 
      1, 3, 6, 1, 2, 1, 17, 4, 3, 1, 1, 0, /* dot1dTpFdbAddress */ 
      1, 3, 6, 1, 2, 1, 17, 4, 3, 1, 2, 0, /* dot1dTpFdbPort */ 
      1, 3, 6, 1, 2, 1, 17, 4, 3, 1, 3, 0, /* dot1dTpFdbStatus */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 0, /* dot1dTpPortTable */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 1, 0, /* dot1dTpPortEntry */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 1, 1, 0, /* dot1dTpPort */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 1, 2, 0, /* dot1dTpPortMaxInfo */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 1, 3, 0, /* dot1dTpPortInFrames */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 1, 4, 0, /* dot1dTpPortOutFrames */ 
      1, 3, 6, 1, 2, 1, 17, 4, 4, 1, 5, 0, /* dot1dTpPortInDiscards */ 
      1, 3, 6, 1, 2, 1, 17, 5, 0, /* dot1dStatic */ 
      1, 3, 6, 1, 2, 1, 17, 5, 1, 0, /* dot1dStaticTable */ 
      1, 3, 6, 1, 2, 1, 17, 5, 1, 1, 0, /* dot1dStaticEntry */ 
      1, 3, 6, 1, 2, 1, 17, 5, 1, 1, 1, 0, /* dot1dStaticAddress */ 
      1, 3, 6, 1, 2, 1, 17, 5, 1, 1, 2, 0, /* dot1dStaticReceivePort */ 
      1, 3, 6, 1, 2, 1, 17, 5, 1, 1, 3, 0, /* dot1dStaticAllowedToGoTo */ 
      1, 3, 6, 1, 2, 1, 17, 5, 1, 1, 4, 0, /* dot1dStaticStatus */ 
      1, 3, 6, 1, 2, 1, 17, 10, 0, /* dot1dPortPair */ 
      1, 3, 6, 1, 2, 1, 17, 10, 1, 0, /* dot1dPortPairTableSize */ 
      1, 3, 6, 1, 2, 1, 17, 10, 2, 0, /* dot1dPortPairTable */ 
      1, 3, 6, 1, 2, 1, 17, 10, 2, 1, 0, /* dot1dPortPairEntry */ 
      1, 3, 6, 1, 2, 1, 17, 10, 2, 1, 1, 0, /* dot1dPortPairLowPort */ 
      1, 3, 6, 1, 2, 1, 17, 10, 2, 1, 2, 0, /* dot1dPortPairHighPort */ 
      1, 3, 6, 1, 2, 1, 17, 10, 2, 1, 3, 0, /* dot1dPortPairBridgeNum */ 
      1, 3, 6, 1, 2, 1, 17, 10, 2, 1, 4, 0, /* dot1dPortPairBridgeState */ 
      1, 3, 6, 1, 2, 1, 18, 0, /* phiv */ 
      1, 3, 6, 1, 2, 1, 18, 1, 0, /* phivSystem */ 
      1, 3, 6, 1, 2, 1, 18, 1, 1, 0, /* phivSystemState */ 
      1, 3, 6, 1, 2, 1, 18, 1, 2, 0, /* phivExecIdent */ 
      1, 3, 6, 1, 2, 1, 18, 2, 0, /* phivManagement */ 
      1, 3, 6, 1, 2, 1, 18, 2, 1, 0, /* phivMgmtMgmtVers */ 
      1, 3, 6, 1, 2, 1, 18, 3, 0, /* session */ 
      1, 3, 6, 1, 2, 1, 18, 3, 1, 0, /* phivSessionSystemName */ 
      1, 3, 6, 1, 2, 1, 18, 3, 2, 0, /* phivSessionInTimer */ 
      1, 3, 6, 1, 2, 1, 18, 3, 3, 0, /* phivSessionOutTimer */ 
      1, 3, 6, 1, 2, 1, 18, 4, 0, /* end */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 0, /* phivEndRemoteTable */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 1, 0, /* phivEndRemoteEntry */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 1, 1, 0, /* phivEndRemoteHostNodeID */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 1, 2, 0, /* phivEndRemoteState */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 1, 3, 0, /* phivEndCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 1, 4, 0, /* phivEndActiveLinks */ 
      1, 3, 6, 1, 2, 1, 18, 4, 1, 1, 5, 0, /* phivEndDelay */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 0, /* phivEndCountTable */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 0, /* phivEndCountEntry */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 1, 0, /* phivEndCountHostNodeID */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 2, 0, /* phivEndCountSecsLastZeroed */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 3, 0, /* phivEndCountUsrBytesRec */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 4, 0, /* phivEndCountUsrBytesSent */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 5, 0, /* phivEndUCountUsrMessRec */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 6, 0, /* phivEndCountUsrMessSent */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 7, 0, /* phivEndCountTotalBytesRec */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 8, 0, /* phivEndCountTotalBytesSent */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 9, 0, /* phivEndCountTotalMessRec */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 10, 0, /* phivEndCountTotalMessSent */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 11, 0, /* phivEndCountConnectsRecd */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 12, 0, /* phivEndCountConnectsSent */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 13, 0, /* phivEndCountReponseTimeouts */ 
      1, 3, 6, 1, 2, 1, 18, 4, 2, 1, 14, 0, /* phivEndCountRecdConnectResErrs */ 
      1, 3, 6, 1, 2, 1, 18, 4, 3, 0, /* phivEndMaxLinks */ 
      1, 3, 6, 1, 2, 1, 18, 4, 4, 0, /* phivEndNSPVers */ 
      1, 3, 6, 1, 2, 1, 18, 4, 5, 0, /* phivEndRetransmitFactor */ 
      1, 3, 6, 1, 2, 1, 18, 4, 6, 0, /* phivEndDelayFact */ 
      1, 3, 6, 1, 2, 1, 18, 4, 7, 0, /* phivEndDelayWeight */ 
      1, 3, 6, 1, 2, 1, 18, 4, 8, 0, /* phivEndInactivityTimer */ 
      1, 3, 6, 1, 2, 1, 18, 4, 9, 0, /* phivEndCountZeroCount */ 
      1, 3, 6, 1, 2, 1, 18, 4, 10, 0, /* phivEndMaxLinksActive */ 
      1, 3, 6, 1, 2, 1, 18, 5, 0, /* routing */ 
      1, 3, 6, 1, 2, 1, 18, 5, 1, 0, /* phivRouteBroadcastRouteTimer */ 
      1, 3, 6, 1, 2, 1, 18, 5, 2, 0, /* phivRouteBuffSize */ 
      1, 3, 6, 1, 2, 1, 18, 5, 3, 0, /* phivRouteRoutingVers */ 
      1, 3, 6, 1, 2, 1, 18, 5, 4, 0, /* phivRouteMaxAddr */ 
      1, 3, 6, 1, 2, 1, 18, 5, 5, 0, /* phivRouteMaxBdcastNonRouters */ 
      1, 3, 6, 1, 2, 1, 18, 5, 6, 0, /* phivRouteMaxBdcastRouters */ 
      1, 3, 6, 1, 2, 1, 18, 5, 7, 0, /* phivRouteMaxBuffs */ 
      1, 3, 6, 1, 2, 1, 18, 5, 8, 0, /* phivRouteMaxCircuits */ 
      1, 3, 6, 1, 2, 1, 18, 5, 9, 0, /* phivRouteMaxCost */ 
      1, 3, 6, 1, 2, 1, 18, 5, 10, 0, /* phivRouteMaxHops */ 
      1, 3, 6, 1, 2, 1, 18, 5, 11, 0, /* phivRouteMaxVisits */ 
      1, 3, 6, 1, 2, 1, 18, 5, 12, 0, /* phivRouteRoutingTimer */ 
      1, 3, 6, 1, 2, 1, 18, 5, 13, 0, /* phivRouteSegBuffSize */ 
      1, 3, 6, 1, 2, 1, 18, 5, 14, 0, /* phivRouteType */ 
      1, 3, 6, 1, 2, 1, 18, 5, 15, 0, /* phivRouteCountAgedPktLoss */ 
      1, 3, 6, 1, 2, 1, 18, 5, 16, 0, /* phivRouteCountNodeUnrPktLoss */ 
      1, 3, 6, 1, 2, 1, 18, 5, 17, 0, /* phivRouteCountOutRngePktLoss */ 
      1, 3, 6, 1, 2, 1, 18, 5, 18, 0, /* phivRouteCountOverSzePktLoss */ 
      1, 3, 6, 1, 2, 1, 18, 5, 19, 0, /* phivRouteCountPacketFmtErr */ 
      1, 3, 6, 1, 2, 1, 18, 5, 20, 0, /* phivRouteCountPtlRteUpdtLoss */ 
      1, 3, 6, 1, 2, 1, 18, 5, 21, 0, /* phivRouteCountVerifReject */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 0, /* phivLevel1RouteTable */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 1, 0, /* phivLevel1RouteEntry */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 1, 1, 0, /* phivLevel1RouteNodeAddr */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 1, 2, 0, /* phivLevel1RouteCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 1, 3, 0, /* phivLevel1RouteCost */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 1, 4, 0, /* phivLevel1RouteHops */ 
      1, 3, 6, 1, 2, 1, 18, 5, 22, 1, 5, 0, /* phivLevel1RouteNextNode */ 
      1, 3, 6, 1, 2, 1, 18, 5, 23, 0, /* phivRouteCountZeroCount */ 
      1, 3, 6, 1, 2, 1, 18, 5, 24, 0, /* phivRouteSystemAddr */ 
      1, 3, 6, 1, 2, 1, 18, 5, 25, 0, /* phivRouteRoutingType */ 
      1, 3, 6, 1, 2, 1, 18, 5, 26, 0, /* phivRouteSystemAddress */ 
      1, 3, 6, 1, 2, 1, 18, 6, 0, /* circuit */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 0, /* phivCircuitParametersTable */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 0, /* phivCircuitParametersEntry */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 1, 0, /* phivCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 2, 0, /* phivCircuitLineIndex */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 3, 0, /* phivCircuitCommonState */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 4, 0, /* phivCircuitCommonSubState */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 5, 0, /* phivCircuitCommonName */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 6, 0, /* phivCircuitExecRecallTimer */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 7, 0, /* phivCircuitCommonType */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 8, 0, /* phivCircuitService */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 9, 0, /* phivCircuitExecCost */ 
      1, 3, 6, 1, 2, 1, 18, 6, 1, 1, 10, 0, /* phivCircuitExecHelloTimer */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 0, /* phivCircuitCountTable */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 0, /* phivCircuitCountEntry */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 1, 0, /* phivCircuitCountSecLastZeroed */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 2, 0, /* phivCircuitCountTermPacketsRecd */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 3, 0, /* phivCircuitCountOriginPackSent */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 4, 0, /* phivCircuitCountTermCongLoss */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 5, 0, /* phivCircuitCountCorruptLoss */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 6, 0, /* phivCircuitCountTransitPksRecd */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 7, 0, /* phivCircuitCountTransitPkSent */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 8, 0, /* phivCircuitCountTransitCongestLoss */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 9, 0, /* phivCircuitCountCircuitDown */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 10, 0, /* phivCircuitCountInitFailure */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 11, 0, /* phivCircuitCountAdjDown */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 12, 0, /* phivCircuitCountPeakAdj */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 13, 0, /* phivCircuitCountBytesRecd */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 14, 0, /* phivCircuitCountBytesSent */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 15, 0, /* phivCircuitCountDataBlocksRecd */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 16, 0, /* phivCircuitCountDataBlocksSent */ 
      1, 3, 6, 1, 2, 1, 18, 6, 2, 1, 17, 0, /* phivCircuitCountUsrBuffUnav */ 
      1, 3, 6, 1, 2, 1, 18, 6, 3, 0, /* phivCircuitOrigQueueLimit */ 
      1, 3, 6, 1, 2, 1, 18, 6, 4, 0, /* phivCircuitCountZeroCount */ 
      1, 3, 6, 1, 2, 1, 18, 7, 0, /* ddcmp */ 
      1, 3, 6, 1, 2, 1, 18, 7, 1, 0, /* phivDDCMPCircuitParametersTable */ 
      1, 3, 6, 1, 2, 1, 18, 7, 1, 1, 0, /* phivDDCMPCircuitParametersEntry */ 
      1, 3, 6, 1, 2, 1, 18, 7, 1, 1, 1, 0, /* phivDDCMPCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 7, 1, 1, 2, 0, /* phivDDCMPCircuitAdjNodeAddr */ 
      1, 3, 6, 1, 2, 1, 18, 7, 1, 1, 3, 0, /* phivDDCMPCircuitTributary */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 0, /* phivDDCMPCircuitCountTable */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 0, /* phivDDCMPCircuitCountEntry */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 1, 0, /* phivDDCMPCircuitErrorsInbd */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 2, 0, /* phivDDCMPCircuitErrorsOutbd */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 3, 0, /* phivDDCMPCircuitRmteReplyTimeouts */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 4, 0, /* phivDDCMPCircuitLocalReplyTimeouts */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 5, 0, /* phivDDCMPCircuitRmteBuffErrors */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 6, 0, /* phivDDCMPCircuitLocalBuffErrors */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 7, 0, /* phivDDCMPCircuitSelectIntervalsElap */ 
      1, 3, 6, 1, 2, 1, 18, 7, 2, 1, 8, 0, /* phivDDCMPCircuitSelectTimeouts */ 
      1, 3, 6, 1, 2, 1, 18, 7, 3, 0, /* phivDDCMPLineCountTable */ 
      1, 3, 6, 1, 2, 1, 18, 7, 3, 1, 0, /* phivDDCMPLineCountEntry */ 
      1, 3, 6, 1, 2, 1, 18, 7, 3, 1, 1, 0, /* phivDDCMPLineCountIndex */ 
      1, 3, 6, 1, 2, 1, 18, 7, 3, 1, 2, 0, /* phivDDCMPLineCountDataErrsIn */ 
      1, 3, 6, 1, 2, 1, 18, 7, 3, 1, 3, 0, /* phivDDCMPLineCountRmteStationErrs */ 
      1, 3, 6, 1, 2, 1, 18, 7, 3, 1, 4, 0, /* phivDDCMPLineCountLocalStationErrs */ 
      1, 3, 6, 1, 2, 1, 18, 8, 0, /* control */ 
      1, 3, 6, 1, 2, 1, 18, 8, 1, 0, /* phivControlSchedTimer */ 
      1, 3, 6, 1, 2, 1, 18, 8, 2, 0, /* phivControlDeadTimer */ 
      1, 3, 6, 1, 2, 1, 18, 8, 3, 0, /* phivControlDelayTimer */ 
      1, 3, 6, 1, 2, 1, 18, 8, 4, 0, /* phivControlStreamTimer */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 0, /* phivControlParametersTable */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 0, /* phivControlParametersEntry */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 1, 0, /* phivControlCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 2, 0, /* phivControlBabbleTimer */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 3, 0, /* phivControlMaxBuffs */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 4, 0, /* phivControlMaxTransmits */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 5, 0, /* phivControlDyingBase */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 6, 0, /* phivControlDyingIncrement */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 7, 0, /* phivControlDeadThreshold */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 8, 0, /* phivControlDyingThreshold */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 9, 0, /* phivControlInactTreshold */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 10, 0, /* phivControlPollingState */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 11, 0, /* phivControlPollingSubState */ 
      1, 3, 6, 1, 2, 1, 18, 8, 5, 1, 12, 0, /* phivControlTransTimer */ 
      1, 3, 6, 1, 2, 1, 18, 9, 0, /* ethernet */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 0, /* phivEthLinkParametersTable */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 1, 0, /* phivEthLinkParametersEntry */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 1, 1, 0, /* phivEthLinkIndex */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 1, 2, 0, /* phivEthDesigRouterNodeAddr */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 1, 3, 0, /* phivEthMaxRouters */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 1, 4, 0, /* phivEthRouterPri */ 
      1, 3, 6, 1, 2, 1, 18, 9, 1, 1, 5, 0, /* phivEthHardwareAddr */ 
      1, 3, 6, 1, 2, 1, 18, 10, 0, /* counters */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 0, /* phivCountersCountTable */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 0, /* phivCountersCountEntry */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 1, 0, /* phivCountersIndex */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 2, 0, /* phivCountersCountBytesRecd */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 3, 0, /* phivCountersCountBytesSent */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 4, 0, /* phivCountersCountDataBlocksRecd */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 5, 0, /* phivCountersCountDataBlocksSent */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 6, 0, /* phivCountersCountEthUsrBuffUnav */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 7, 0, /* phivCountersCountMcastBytesRecd */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 8, 0, /* phivCountersCountDataBlksRecd */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 9, 0, /* phivCountersCountDataBlksSent */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 10, 0, /* phivCountersCountMcastBlksRecd */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 11, 0, /* phivCountersCountBlksSentDef */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 12, 0, /* phivCountersCountBlksSentSingleCol */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 13, 0, /* phivCountersCountBlksSentMultCol */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 14, 0, /* phivCountersCountSendFailure */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 15, 0, /* phivCountersCountCollDetectFailure */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 16, 0, /* phivCountersCountReceiveFailure */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 17, 0, /* phivCountersCountUnrecFrameDest */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 18, 0, /* phivCountersCountDataOver */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 19, 0, /* phivCountersCountSysBuffUnav */ 
      1, 3, 6, 1, 2, 1, 18, 10, 1, 1, 20, 0, /* phivCountersCountUsrBuffUnav */ 
      1, 3, 6, 1, 2, 1, 18, 11, 0, /* adjacency */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 0, /* phivAdjTable */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 0, /* phivAdjEntry */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 1, 0, /* phivAdjCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 2, 0, /* phivAdjNodeAddr */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 3, 0, /* phivAdjBlockSize */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 4, 0, /* phivAdjListenTimer */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 5, 0, /* phivAdjCircuitEtherServPhysAddr */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 6, 0, /* phivAdjType */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 7, 0, /* phivAdjState */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 8, 0, /* phivAdjPriority */ 
      1, 3, 6, 1, 2, 1, 18, 11, 1, 1, 9, 0, /* phivAdjExecListenTimer */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 0, /* phivAdjNodeTable */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 0, /* phivAdjNodeEntry */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 1, 0, /* phivAdjNodeCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 2, 0, /* phivAdjAddr */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 3, 0, /* phivAdjNodeBlockSize */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 4, 0, /* phivAdjNodeListenTimer */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 5, 0, /* phivAdjNodeCircuitEtherServPhysAddr */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 6, 0, /* phivAdjNodeType */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 7, 0, /* phivAdjNodeState */ 
      1, 3, 6, 1, 2, 1, 18, 11, 2, 1, 8, 0, /* phivAdjNodePriority */ 
      1, 3, 6, 1, 2, 1, 18, 12, 0, /* line */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 0, /* phivLineTable */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 0, /* phivLineEntry */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 1, 0, /* phivLineIndex */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 2, 0, /* phivLineName */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 3, 0, /* phivLineState */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 4, 0, /* phivLineSubstate */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 5, 0, /* phivLineService */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 6, 0, /* phivLineDevice */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 7, 0, /* phivLineReceiveBuffs */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 8, 0, /* phivLineProtocol */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 9, 0, /* phivLineServiceTimer */ 
      1, 3, 6, 1, 2, 1, 18, 12, 1, 1, 10, 0, /* phivLineMaxBlock */ 
      1, 3, 6, 1, 2, 1, 18, 14, 0, /* nonBroadcastLine */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 0, /* phivNonBroadcastTable */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 1, 0, /* phivNonBroadcastEntry */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 1, 1, 0, /* phivNonBroadcastIndex */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 1, 2, 0, /* phivNonBroadcastController */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 1, 3, 0, /* phivNonBroadcastDuplex */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 1, 4, 0, /* phivNonBroadcastClock */ 
      1, 3, 6, 1, 2, 1, 18, 14, 1, 1, 5, 0, /* phivNonBroadcastRetransmitTimer */ 
      1, 3, 6, 1, 2, 1, 18, 15, 0, /* area */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 0, /* phivAreaTable */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 0, /* phivAreaEntry */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 1, 0, /* phivAreaNum */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 2, 0, /* phivAreaState */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 3, 0, /* phivAreaCost */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 4, 0, /* phivAreaHops */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 5, 0, /* phivAreaNextNode */ 
      1, 3, 6, 1, 2, 1, 18, 15, 1, 1, 6, 0, /* phivAreaCircuitIndex */ 
      1, 3, 6, 1, 2, 1, 18, 15, 2, 0, /* phivAreaMaxCost */ 
      1, 3, 6, 1, 2, 1, 18, 15, 3, 0, /* phivAreaMaxHops */ 
      1, 3, 6, 1, 2, 1, 18, 15, 4, 0, /* phivRouteMaxArea */ 
      1, 3, 6, 1, 2, 1, 19, 0, /* char */ 
      1, 3, 6, 1, 2, 1, 19, 1, 0, /* charNumber */ 
      1, 3, 6, 1, 2, 1, 19, 2, 0, /* charPortTable */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 0, /* charPortEntry */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 1, 0, /* charPortIndex */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 2, 0, /* charPortName */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 3, 0, /* charPortType */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 4, 0, /* charPortHardware */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 5, 0, /* charPortReset */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 6, 0, /* charPortAdminStatus */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 7, 0, /* charPortOperStatus */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 8, 0, /* charPortLastChange */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 9, 0, /* charPortInFlowType */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 10, 0, /* charPortOutFlowType */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 11, 0, /* charPortInFlowState */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 12, 0, /* charPortOutFlowState */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 13, 0, /* charPortInCharacters */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 14, 0, /* charPortOutCharacters */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 15, 0, /* charPortAdminOrigin */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 16, 0, /* charPortSessionMaximum */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 17, 0, /* charPortSessionNumber */ 
      1, 3, 6, 1, 2, 1, 19, 2, 1, 18, 0, /* charPortSessionIndex */ 
      1, 3, 6, 1, 2, 1, 19, 3, 0, /* charSessTable */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 0, /* charSessEntry */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 1, 0, /* charSessPortIndex */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 2, 0, /* charSessIndex */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 3, 0, /* charSessKill */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 4, 0, /* charSessState */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 5, 0, /* charSessProtocol */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 6, 0, /* charSessOperOrigin */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 7, 0, /* charSessInCharacters */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 8, 0, /* charSessOutCharacters */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 9, 0, /* charSessConnectionId */ 
      1, 3, 6, 1, 2, 1, 19, 3, 1, 10, 0, /* charSessStartTime */ 
      1, 3, 6, 1, 2, 1, 19, 4, 0, /* wellKnownProtocols */ 
      1, 3, 6, 1, 2, 1, 19, 4, 1, 0, /* protocolOther */ 
      1, 3, 6, 1, 2, 1, 19, 4, 2, 0, /* protocolTelnet */ 
      1, 3, 6, 1, 2, 1, 19, 4, 3, 0, /* protocolRlogin */ 
      1, 3, 6, 1, 2, 1, 19, 4, 4, 0, /* protocolLat */ 
      1, 3, 6, 1, 2, 1, 19, 4, 5, 0, /* protocolX29 */ 
      1, 3, 6, 1, 2, 1, 19, 4, 6, 0, /* protocolVtp */ 
      1, 3, 6, 1, 2, 1, 22, 0, /* snmpDot3RptrMgt */ 
      1, 3, 6, 1, 2, 1, 22, 1, 0, /* rptrBasicPackage */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 0, /* rptrRptrInfo */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 1, 0, /* rptrGroupCapacity */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 2, 0, /* rptrOperStatus */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 3, 0, /* rptrHealthText */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 4, 0, /* rptrReset */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 5, 0, /* rptrNonDisruptTest */ 
      1, 3, 6, 1, 2, 1, 22, 1, 1, 6, 0, /* rptrTotalPartitionedPorts */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 0, /* rptrGroupInfo */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 0, /* rptrGroupTable */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 0, /* rptrGroupEntry */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 1, 0, /* rptrGroupIndex */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 2, 0, /* rptrGroupDescr */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 3, 0, /* rptrGroupObjectID */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 4, 0, /* rptrGroupOperStatus */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 5, 0, /* rptrGroupLastOperStatusChange */ 
      1, 3, 6, 1, 2, 1, 22, 1, 2, 1, 1, 6, 0, /* rptrGroupPortCapacity */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 0, /* rptrPortInfo */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 0, /* rptrPortTable */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 1, 0, /* rptrPortEntry */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 1, 1, 0, /* rptrPortGroupIndex */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 1, 2, 0, /* rptrPortIndex */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 1, 3, 0, /* rptrPortAdminStatus */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 1, 4, 0, /* rptrPortAutoPartitionState */ 
      1, 3, 6, 1, 2, 1, 22, 1, 3, 1, 1, 5, 0, /* rptrPortOperStatus */ 
      1, 3, 6, 1, 2, 1, 22, 2, 0, /* rptrMonitorPackage */ 
      1, 3, 6, 1, 2, 1, 22, 2, 1, 0, /* rptrMonitorRptrInfo */ 
      1, 3, 6, 1, 2, 1, 22, 2, 1, 1, 0, /* rptrMonitorTransmitCollisions */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 0, /* rptrMonitorGroupInfo */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 1, 0, /* rptrMonitorGroupTable */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 1, 1, 0, /* rptrMonitorGroupEntry */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 1, 1, 1, 0, /* rptrMonitorGroupIndex */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 1, 1, 2, 0, /* rptrMonitorGroupTotalFrames */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 1, 1, 3, 0, /* rptrMonitorGroupTotalOctets */ 
      1, 3, 6, 1, 2, 1, 22, 2, 2, 1, 1, 4, 0, /* rptrMonitorGroupTotalErrors */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 0, /* rptrMonitorPortInfo */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 0, /* rptrMonitorPortTable */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 0, /* rptrMonitorPortEntry */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 1, 0, /* rptrMonitorPortGroupIndex */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 2, 0, /* rptrMonitorPortIndex */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 3, 0, /* rptrMonitorPortReadableFrames */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 4, 0, /* rptrMonitorPortReadableOctets */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 5, 0, /* rptrMonitorPortFCSErrors */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 6, 0, /* rptrMonitorPortAlignmentErrors */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 7, 0, /* rptrMonitorPortFrameTooLongs */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 8, 0, /* rptrMonitorPortShortEvents */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 9, 0, /* rptrMonitorPortRunts */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 10, 0, /* rptrMonitorPortCollisions */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 11, 0, /* rptrMonitorPortLateEvents */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 12, 0, /* rptrMonitorPortVeryLongEvents */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 13, 0, /* rptrMonitorPortDataRateMismatches */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 14, 0, /* rptrMonitorPortAutoPartitions */ 
      1, 3, 6, 1, 2, 1, 22, 2, 3, 1, 1, 15, 0, /* rptrMonitorPortTotalErrors */ 
      1, 3, 6, 1, 2, 1, 22, 3, 0, /* rptrAddrTrackPackage */ 
      1, 3, 6, 1, 2, 1, 22, 3, 1, 0, /* rptrAddrTrackRptrInfo */ 
      1, 3, 6, 1, 2, 1, 22, 3, 2, 0, /* rptrAddrTrackGroupInfo */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 0, /* rptrAddrTrackPortInfo */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 0, /* rptrAddrTrackTable */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 1, 0, /* rptrAddrTrackEntry */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 1, 1, 0, /* rptrAddrTrackGroupIndex */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 1, 2, 0, /* rptrAddrTrackPortIndex */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 1, 3, 0, /* rptrAddrTrackLastSourceAddress */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 1, 4, 0, /* rptrAddrTrackSourceAddrChanges */ 
      1, 3, 6, 1, 2, 1, 22, 3, 3, 1, 1, 5, 0, /* rptrAddrTrackNewLastSrcAddress */ 
      1, 3, 6, 1, 2, 1, 23, 0, /* rip2 */ 
      1, 3, 6, 1, 2, 1, 23, 1, 0, /* rip2GlobalGroup */ 
      1, 3, 6, 1, 2, 1, 23, 1, 1, 0, /* rip2GlobalRouteChanges */ 
      1, 3, 6, 1, 2, 1, 23, 1, 2, 0, /* rip2GlobalQueries */ 
      1, 3, 6, 1, 2, 1, 23, 2, 0, /* rip2IfStatTable */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 0, /* rip2IfStatEntry */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 1, 0, /* rip2IfStatAddress */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 2, 0, /* rip2IfStatRcvBadPackets */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 3, 0, /* rip2IfStatRcvBadRoutes */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 4, 0, /* rip2IfStatSentUpdates */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 5, 0, /* rip2IfStatStatus */ 
      1, 3, 6, 1, 2, 1, 23, 3, 0, /* rip2IfConfTable */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 0, /* rip2IfConfEntry */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 1, 0, /* rip2IfConfAddress */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 2, 0, /* rip2IfConfDomain */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 3, 0, /* rip2IfConfAuthType */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 4, 0, /* rip2IfConfAuthKey */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 5, 0, /* rip2IfConfSend */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 6, 0, /* rip2IfConfReceive */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 7, 0, /* rip2IfConfDefaultMetric */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 8, 0, /* rip2IfConfStatus */ 
      1, 3, 6, 1, 2, 1, 23, 4, 0, /* rip2PeerTable */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 0, /* rip2PeerEntry */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 1, 0, /* rip2PeerAddress */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 2, 0, /* rip2PeerDomain */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 3, 0, /* rip2PeerLastUpdate */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 4, 0, /* rip2PeerVersion */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 5, 0, /* rip2PeerRcvBadPackets */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 6, 0, /* rip2PeerRcvBadRoutes */ 
      1, 3, 6, 1, 2, 1, 24, 0, /* ident */ 
      1, 3, 6, 1, 2, 1, 24, 1, 0, /* identInfo */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 0, /* identTable */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 1, 0, /* identEntry */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 1, 1, 0, /* identStatus */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 1, 2, 0, /* identOpSys */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 1, 3, 0, /* identCharset */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 1, 4, 0, /* identUserid */ 
      1, 3, 6, 1, 2, 1, 24, 1, 1, 1, 5, 0, /* identMisc */ 
      1, 3, 6, 1, 2, 1, 25, 0, /* host */ 
      1, 3, 6, 1, 2, 1, 25, 1, 0, /* hrSystem */ 
      1, 3, 6, 1, 2, 1, 25, 1, 1, 0, /* hrSystemUptime */ 
      1, 3, 6, 1, 2, 1, 25, 1, 2, 0, /* hrSystemDate */ 
      1, 3, 6, 1, 2, 1, 25, 1, 3, 0, /* hrSystemInitialLoadDevice */ 
      1, 3, 6, 1, 2, 1, 25, 1, 4, 0, /* hrSystemInitialLoadParameters */ 
      1, 3, 6, 1, 2, 1, 25, 1, 5, 0, /* hrSystemNumUsers */ 
      1, 3, 6, 1, 2, 1, 25, 1, 6, 0, /* hrSystemProcesses */ 
      1, 3, 6, 1, 2, 1, 25, 1, 7, 0, /* hrSystemMaxProcesses */ 
      1, 3, 6, 1, 2, 1, 25, 2, 0, /* hrStorage */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 0, /* hrStorageTypes */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 1, 0, /* hrStorageOther */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 2, 0, /* hrStorageRam */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 3, 0, /* hrStorageVirtualMemory */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 4, 0, /* hrStorageFixedDisk */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 5, 0, /* hrStorageRemovableDisk */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 6, 0, /* hrStorageFloppyDisk */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 7, 0, /* hrStorageCompactDisc */ 
      1, 3, 6, 1, 2, 1, 25, 2, 1, 8, 0, /* hrStorageRamDisk */ 
      1, 3, 6, 1, 2, 1, 25, 2, 2, 0, /* hrMemorySize */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 0, /* hrStorageTable */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 0, /* hrStorageEntry */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 1, 0, /* hrStorageIndex */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 2, 0, /* hrStorageType */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 3, 0, /* hrStorageDescr */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 4, 0, /* hrStorageAllocationUnits */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 5, 0, /* hrStorageSize */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 6, 0, /* hrStorageUsed */ 
      1, 3, 6, 1, 2, 1, 25, 2, 3, 1, 7, 0, /* hrStorageAllocationFailures */ 
      1, 3, 6, 1, 2, 1, 25, 3, 0, /* hrDevice */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 0, /* hrDeviceTypes */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 1, 0, /* hrDeviceOther */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 2, 0, /* hrDeviceUnknown */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 3, 0, /* hrDeviceProcessor */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 4, 0, /* hrDeviceNetwork */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 5, 0, /* hrDevicePrinter */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 6, 0, /* hrDeviceDiskStorage */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 10, 0, /* hrDeviceVideo */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 11, 0, /* hrDeviceAudio */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 12, 0, /* hrDeviceCoprocessor */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 13, 0, /* hrDeviceKeyboard */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 14, 0, /* hrDeviceModem */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 15, 0, /* hrDeviceParallelPort */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 16, 0, /* hrDevicePointing */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 17, 0, /* hrDeviceSerialPort */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 18, 0, /* hrDeviceTape */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 19, 0, /* hrDeviceClock */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 20, 0, /* hrDeviceVolatileMemory */ 
      1, 3, 6, 1, 2, 1, 25, 3, 1, 21, 0, /* hrDeviceNonVolatileMemory */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 0, /* hrDeviceTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 0, /* hrDeviceEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 1, 0, /* hrDeviceIndex */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 2, 0, /* hrDeviceType */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 3, 0, /* hrDeviceDescr */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 4, 0, /* hrDeviceID */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 5, 0, /* hrDeviceStatus */ 
      1, 3, 6, 1, 2, 1, 25, 3, 2, 1, 6, 0, /* hrDeviceErrors */ 
      1, 3, 6, 1, 2, 1, 25, 3, 3, 0, /* hrProcessorTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 3, 1, 0, /* hrProcessorEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 3, 1, 1, 0, /* hrProcessorFrwID */ 
      1, 3, 6, 1, 2, 1, 25, 3, 3, 1, 2, 0, /* hrProcessorLoad */ 
      1, 3, 6, 1, 2, 1, 25, 3, 4, 0, /* hrNetworkTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 4, 1, 0, /* hrNetworkEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 4, 1, 1, 0, /* hrNetworkIfIndex */ 
      1, 3, 6, 1, 2, 1, 25, 3, 5, 0, /* hrPrinterTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 5, 1, 0, /* hrPrinterEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 5, 1, 1, 0, /* hrPrinterStatus */ 
      1, 3, 6, 1, 2, 1, 25, 3, 5, 1, 2, 0, /* hrPrinterDetectedErrorState */ 
      1, 3, 6, 1, 2, 1, 25, 3, 6, 0, /* hrDiskStorageTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 6, 1, 0, /* hrDiskStorageEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 6, 1, 1, 0, /* hrDiskStorageAccess */ 
      1, 3, 6, 1, 2, 1, 25, 3, 6, 1, 2, 0, /* hrDiskStorageMedia */ 
      1, 3, 6, 1, 2, 1, 25, 3, 6, 1, 3, 0, /* hrDiskStorageRemoveble */ 
      1, 3, 6, 1, 2, 1, 25, 3, 6, 1, 4, 0, /* hrDiskStorageCapacity */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 0, /* hrPartitionTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 1, 0, /* hrPartitionEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 1, 1, 0, /* hrPartitionIndex */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 1, 2, 0, /* hrPartitionLabel */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 1, 3, 0, /* hrPartitionID */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 1, 4, 0, /* hrPartitionSize */ 
      1, 3, 6, 1, 2, 1, 25, 3, 7, 1, 5, 0, /* hrPartitionFSIndex */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 0, /* hrFSTable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 0, /* hrFSEntry */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 1, 0, /* hrFSIndex */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 2, 0, /* hrFSMountPoint */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 3, 0, /* hrFSRemoteMountPoint */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 4, 0, /* hrFSType */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 5, 0, /* hrFSAccess */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 6, 0, /* hrFSBootable */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 7, 0, /* hrFSStorageIndex */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 8, 0, /* hrFSLastFullBackupDate */ 
      1, 3, 6, 1, 2, 1, 25, 3, 8, 1, 9, 0, /* hrFSLastPartialBackupDate */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 0, /* hrFSTypes */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 1, 0, /* hrFSOther */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 2, 0, /* hrFSUnknown */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 3, 0, /* hrFSBerkeleyFFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 4, 0, /* hrFSSys5FS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 5, 0, /* hrFSFat */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 6, 0, /* hrFSHPFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 7, 0, /* hrFSHFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 8, 0, /* hrFSMFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 9, 0, /* hrFSNTFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 10, 0, /* hrFSVNode */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 11, 0, /* hrFSJournaled */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 12, 0, /* hrFSiso9660 */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 13, 0, /* hrFSRockRidge */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 14, 0, /* hrFSNFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 15, 0, /* hrFSNetware */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 16, 0, /* hrFSAFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 17, 0, /* hrFSDFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 18, 0, /* hrFSAppleshare */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 19, 0, /* hrFSRFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 20, 0, /* hrFSDGCFS */ 
      1, 3, 6, 1, 2, 1, 25, 3, 9, 21, 0, /* hrFSBFS */ 
      1, 3, 6, 1, 2, 1, 25, 4, 0, /* hrSWRun */ 
      1, 3, 6, 1, 2, 1, 25, 4, 1, 0, /* hrSWOSIndex */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 0, /* hrSWRunTable */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 0, /* hrSWRunEntry */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 1, 0, /* hrSWRunIndex */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 2, 0, /* hrSWRunName */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 3, 0, /* hrSWRunID */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 4, 0, /* hrSWRunPath */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 5, 0, /* hrSWRunParameters */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 6, 0, /* hrSWRunType */ 
      1, 3, 6, 1, 2, 1, 25, 4, 2, 1, 7, 0, /* hrSWRunStatus */ 
      1, 3, 6, 1, 2, 1, 25, 5, 0, /* hrSWRunPerf */ 
      1, 3, 6, 1, 2, 1, 25, 5, 1, 0, /* hrSWRunPerfTable */ 
      1, 3, 6, 1, 2, 1, 25, 5, 1, 1, 0, /* hrSWRunPerfEntry */ 
      1, 3, 6, 1, 2, 1, 25, 5, 1, 1, 1, 0, /* hrSWRunPerfCPU */ 
      1, 3, 6, 1, 2, 1, 25, 5, 1, 1, 2, 0, /* hrSWRunPerfMem */ 
      1, 3, 6, 1, 2, 1, 25, 6, 0, /* hrSWInstalled */ 
      1, 3, 6, 1, 2, 1, 25, 6, 1, 0, /* hrSWInstalledLastChange */ 
      1, 3, 6, 1, 2, 1, 25, 6, 2, 0, /* hrSWInstalledLastUpdateTime */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 0, /* hrSWInstalledTable */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 1, 0, /* hrSWInstalledEntry */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 1, 1, 0, /* hrSWInstalledIndex */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 1, 2, 0, /* hrSWInstalledName */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 1, 3, 0, /* hrSWInstalledID */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 1, 4, 0, /* hrSWInstalledType */ 
      1, 3, 6, 1, 2, 1, 25, 6, 3, 1, 5, 0, /* hrSWInstalledDate */ 
      1, 3, 6, 1, 2, 1, 26, 0, /* snmpDot3MauMgt */ 
      1, 3, 6, 1, 2, 1, 26, 1, 0, /* dot3RpMauBasicGroup */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 0, /* rpMauTable */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 0, /* rpMauEntry */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 1, 0, /* rpMauGroupIndex */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 2, 0, /* rpMauPortIndex */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 3, 0, /* rpMauIndex */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 4, 0, /* rpMauType */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 5, 0, /* rpMauStatus */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 6, 0, /* rpMauMediaAvailable */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 7, 0, /* rpMauMediaAvailableStateExits */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 8, 0, /* rpMauJabberState */ 
      1, 3, 6, 1, 2, 1, 26, 1, 1, 1, 9, 0, /* rpMauJabberingStateEnters */ 
      1, 3, 6, 1, 2, 1, 26, 2, 0, /* dot3IfMauBasicGroup */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 0, /* ifMauTable */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 0, /* ifMauEntry */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 1, 0, /* ifMauIfIndex */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 2, 0, /* ifMauIndex */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 3, 0, /* ifMauType */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 4, 0, /* ifMauStatus */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 5, 0, /* ifMauMediaAvailable */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 6, 0, /* ifMauMediaAvailableStateExits */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 7, 0, /* ifMauJabberState */ 
      1, 3, 6, 1, 2, 1, 26, 2, 1, 1, 8, 0, /* ifMauJabberingStateEnters */ 
      1, 3, 6, 1, 2, 1, 26, 3, 0, /* dot3BroadMauBasicGroup */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 0, /* broadMauBasicTable */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 1, 0, /* broadMauBasicEntry */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 1, 1, 0, /* broadMauIfIndex */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 1, 2, 0, /* broadMauIndex */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 1, 3, 0, /* broadMauXmtRcvSplitType */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 1, 4, 0, /* broadMauXmtCarrierFreq */ 
      1, 3, 6, 1, 2, 1, 26, 3, 1, 1, 5, 0, /* broadMauTranslationFreq */ 
      1, 3, 6, 1, 2, 1, 26, 4, 0, /* dot3MauType */ 
      1, 3, 6, 1, 2, 1, 26, 4, 1, 0, /* dot3MauTypeAUI */ 
      1, 3, 6, 1, 2, 1, 26, 4, 2, 0, /* dot3MauType10Base5 */ 
      1, 3, 6, 1, 2, 1, 26, 4, 3, 0, /* dot3MauTypeFoirl */ 
      1, 3, 6, 1, 2, 1, 26, 4, 4, 0, /* dot3MauType10Base2 */ 
      1, 3, 6, 1, 2, 1, 26, 4, 5, 0, /* dot3MauType10BaseT */ 
      1, 3, 6, 1, 2, 1, 26, 4, 6, 0, /* dot3MauType10BaseFP */ 
      1, 3, 6, 1, 2, 1, 26, 4, 7, 0, /* dot3MauType10BaseFB */ 
      1, 3, 6, 1, 2, 1, 26, 4, 8, 0, /* dot3MauType10BaseFL */ 
      1, 3, 6, 1, 2, 1, 26, 4, 9, 0, /* dot3MauType10Broad36 */ 
      1, 3, 6, 1, 2, 1, 27, 0, /* application */ 
      1, 3, 6, 1, 2, 1, 27, 1, 0, /* applTable */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 0, /* applEntry */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 1, 0, /* applIndex */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 2, 0, /* applName */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 3, 0, /* applDirectoryName */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 4, 0, /* applVersion */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 5, 0, /* applUptime */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 6, 0, /* applOperStatus */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 7, 0, /* applLastChange */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 8, 0, /* applInboundAssociations */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 9, 0, /* applOutboundAssociations */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 10, 0, /* applAccumulatedInboundAssociations */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 11, 0, /* applAccumulatedOutboundAssociations */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 12, 0, /* applLastInboundActivity */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 13, 0, /* applLastOutboundActivity */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 14, 0, /* applRejectedInboundAssociations */ 
      1, 3, 6, 1, 2, 1, 27, 1, 1, 15, 0, /* applFailedOutboundAssociations */ 
      1, 3, 6, 1, 2, 1, 27, 2, 0, /* assocTable */ 
      1, 3, 6, 1, 2, 1, 27, 2, 1, 0, /* assocEntry */ 
      1, 3, 6, 1, 2, 1, 27, 2, 1, 1, 0, /* assocIndex */ 
      1, 3, 6, 1, 2, 1, 27, 2, 1, 2, 0, /* assocRemoteApplication */ 
      1, 3, 6, 1, 2, 1, 27, 2, 1, 3, 0, /* assocApplicationProtocol */ 
      1, 3, 6, 1, 2, 1, 27, 2, 1, 4, 0, /* assocApplicationType */ 
      1, 3, 6, 1, 2, 1, 27, 2, 1, 5, 0, /* assocDuration */ 
      1, 3, 6, 1, 2, 1, 27, 3, 0, /* applConformance */ 
      1, 3, 6, 1, 2, 1, 27, 3, 1, 0, /* applGroups */ 
      1, 3, 6, 1, 2, 1, 27, 3, 1, 1, 0, /* applGroup */ 
      1, 3, 6, 1, 2, 1, 27, 3, 1, 2, 0, /* assocGroup */ 
      1, 3, 6, 1, 2, 1, 27, 3, 2, 0, /* applCompliances */ 
      1, 3, 6, 1, 2, 1, 27, 3, 2, 1, 0, /* applCompliance */ 
      1, 3, 6, 1, 2, 1, 27, 3, 2, 2, 0, /* assocCompliance */ 
      1, 3, 6, 1, 2, 1, 27, 4, 0, /* applTCPProtoID */ 
      1, 3, 6, 1, 2, 1, 27, 5, 0, /* applUDPProtoID */ 
      1, 3, 6, 1, 2, 1, 28, 0, /* mta */ 
      1, 3, 6, 1, 2, 1, 28, 1, 0, /* mtaTable */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 0, /* mtaEntry */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 1, 0, /* mtaReceivedMessages */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 2, 0, /* mtaStoredMessages */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 3, 0, /* mtaTransmittedMessages */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 4, 0, /* mtaReceivedVolume */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 5, 0, /* mtaStoredVolume */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 6, 0, /* mtaTransmittedVolume */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 7, 0, /* mtaReceivedRecipients */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 8, 0, /* mtaStoredRecipients */ 
      1, 3, 6, 1, 2, 1, 28, 1, 1, 9, 0, /* mtaTransmittedRecipients */ 
      1, 3, 6, 1, 2, 1, 28, 2, 0, /* mtaGroupTable */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 0, /* mtaGroupEntry */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 1, 0, /* mtaGroupIndex */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 2, 0, /* mtaGroupReceivedMessages */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 3, 0, /* mtaGroupRejectedMessages */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 4, 0, /* mtaGroupStoredMessages */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 5, 0, /* mtaGroupTransmittedMessages */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 6, 0, /* mtaGroupReceivedVolume */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 7, 0, /* mtaGroupStoredVolume */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 8, 0, /* mtaGroupTransmittedVolume */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 9, 0, /* mtaGroupReceivedRecipients */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 10, 0, /* mtaGroupStoredRecipients */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 11, 0, /* mtaGroupTransmittedRecipients */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 12, 0, /* mtaGroupOldestMessageStored */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 13, 0, /* mtaGroupInboundAssociations */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 14, 0, /* mtaGroupOutboundAssociations */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 15, 0, /* mtaGroupAccumulatedInboundAssociations */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 16, 0, /* mtaGroupAccumulatedOutboundAssociations */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 17, 0, /* mtaGroupLastInboundActivity */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 18, 0, /* mtaGroupLastOutboundActivity */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 19, 0, /* mtaGroupRejectedInboundAssociations */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 20, 0, /* mtaGroupFailedOutboundAssociations */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 21, 0, /* mtaGroupInboundRejectionReason */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 22, 0, /* mtaGroupOutboundConnectFailureReason */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 23, 0, /* mtaGroupScheduledRetry */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 24, 0, /* mtaGroupMailProtocol */ 
      1, 3, 6, 1, 2, 1, 28, 2, 1, 25, 0, /* mtaGroupName */ 
      1, 3, 6, 1, 2, 1, 28, 3, 0, /* mtaGroupAssociationTable */ 
      1, 3, 6, 1, 2, 1, 28, 3, 1, 0, /* mtaGroupAssociationEntry */ 
      1, 3, 6, 1, 2, 1, 28, 3, 1, 1, 0, /* mtaGroupAssociationIndex */ 
      1, 3, 6, 1, 2, 1, 28, 4, 0, /* mtaConformance */ 
      1, 3, 6, 1, 2, 1, 28, 4, 1, 0, /* mtaGroups */ 
      1, 3, 6, 1, 2, 1, 28, 4, 1, 1, 0, /* mtaGroup */ 
      1, 3, 6, 1, 2, 1, 28, 4, 1, 2, 0, /* mtaAssocGroup */ 
      1, 3, 6, 1, 2, 1, 28, 4, 2, 0, /* mtaCompliances */ 
      1, 3, 6, 1, 2, 1, 28, 4, 2, 1, 0, /* mtaCompliance */ 
      1, 3, 6, 1, 2, 1, 28, 4, 2, 2, 0, /* mtaAssocCompliance */ 
      1, 3, 6, 1, 2, 1, 29, 0, /* dsaMIB */ 
      1, 3, 6, 1, 2, 1, 29, 1, 0, /* dsaOpsTable */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 0, /* dsaOpsEntry */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 1, 0, /* dsaAnonymousBinds */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 2, 0, /* dsaUnauthBinds */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 3, 0, /* dsaSimpleAuthBinds */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 4, 0, /* dsaStrongAuthBinds */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 5, 0, /* dsaBindSecurityErrors */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 6, 0, /* dsaInOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 7, 0, /* dsaReadOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 8, 0, /* dsaCompareOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 9, 0, /* dsaAddEntryOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 10, 0, /* dsaRemoveEntryOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 11, 0, /* dsaModifyEntryOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 12, 0, /* dsaModifyRDNOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 13, 0, /* dsaListOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 14, 0, /* dsaSearchOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 15, 0, /* dsaOneLevelSearchOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 16, 0, /* dsaWholeTreeSearchOps */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 17, 0, /* dsaReferrals */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 18, 0, /* dsaChainings */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 19, 0, /* dsaSecurityErrors */ 
      1, 3, 6, 1, 2, 1, 29, 1, 1, 20, 0, /* dsaErrors */ 
      1, 3, 6, 1, 2, 1, 29, 2, 0, /* dsaEntriesTable */ 
      1, 3, 6, 1, 2, 1, 29, 2, 1, 0, /* dsaEntriesEntry */ 
      1, 3, 6, 1, 2, 1, 29, 2, 1, 1, 0, /* dsaMasterEntries */ 
      1, 3, 6, 1, 2, 1, 29, 2, 1, 2, 0, /* dsaCopyEntries */ 
      1, 3, 6, 1, 2, 1, 29, 2, 1, 3, 0, /* dsaCacheEntries */ 
      1, 3, 6, 1, 2, 1, 29, 2, 1, 4, 0, /* dsaCacheHits */ 
      1, 3, 6, 1, 2, 1, 29, 2, 1, 5, 0, /* dsaSlaveHits */ 
      1, 3, 6, 1, 2, 1, 29, 3, 0, /* dsaIntTable */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 0, /* dsaIntEntry */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 1, 0, /* dsaIntIndex */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 2, 0, /* dsaName */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 3, 0, /* dsaTimeOfCreation */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 4, 0, /* dsaTimeOfLastAttempt */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 5, 0, /* dsaTimeOfLastSuccess */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 6, 0, /* dsaFailuresSinceLastSuccess */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 7, 0, /* dsaFailures */ 
      1, 3, 6, 1, 2, 1, 29, 3, 1, 8, 0, /* dsaSuccesses */ 
      1, 3, 6, 1, 2, 1, 29, 4, 0, /* dsaConformance */ 
      1, 3, 6, 1, 2, 1, 29, 4, 1, 0, /* dsaGroups */ 
      1, 3, 6, 1, 2, 1, 29, 4, 1, 1, 0, /* dsaOpsGroup */ 
      1, 3, 6, 1, 2, 1, 29, 4, 1, 2, 0, /* dsaEntryGroup */ 
      1, 3, 6, 1, 2, 1, 29, 4, 1, 3, 0, /* dsaIntGroup */ 
      1, 3, 6, 1, 2, 1, 29, 4, 2, 0, /* dsaCompliances */ 
      1, 3, 6, 1, 2, 1, 29, 4, 2, 1, 0, /* dsaOpsCompliance */ 
      1, 3, 6, 1, 2, 1, 29, 4, 2, 2, 0, /* dsaEntryCompliance */ 
      1, 3, 6, 1, 2, 1, 29, 4, 2, 3, 0, /* dsaIntCompliance */ 
      1, 3, 6, 1, 3, 0, /* experimental */ 
      1, 3, 6, 1, 3, 1, 0, /* clns */ 
      1, 3, 6, 1, 3, 1, 1, 0, /* clnp */ 
      1, 3, 6, 1, 3, 1, 1, 1, 0, /* clnpForwarding */ 
      1, 3, 6, 1, 3, 1, 1, 2, 0, /* clnpDefaultLifeTime */ 
      1, 3, 6, 1, 3, 1, 1, 3, 0, /* clnpInReceives */ 
      1, 3, 6, 1, 3, 1, 1, 4, 0, /* clnpInHdrErrors */ 
      1, 3, 6, 1, 3, 1, 1, 5, 0, /* clnpInAddrErrors */ 
      1, 3, 6, 1, 3, 1, 1, 6, 0, /* clnpForwPDUs */ 
      1, 3, 6, 1, 3, 1, 1, 7, 0, /* clnpInUnknownNLPs */ 
      1, 3, 6, 1, 3, 1, 1, 8, 0, /* clnpInUnknownULPs */ 
      1, 3, 6, 1, 3, 1, 1, 9, 0, /* clnpInDiscards */ 
      1, 3, 6, 1, 3, 1, 1, 10, 0, /* clnpInDelivers */ 
      1, 3, 6, 1, 3, 1, 1, 11, 0, /* clnpOutRequests */ 
      1, 3, 6, 1, 3, 1, 1, 12, 0, /* clnpOutDiscards */ 
      1, 3, 6, 1, 3, 1, 1, 13, 0, /* clnpOutNoRoutes */ 
      1, 3, 6, 1, 3, 1, 1, 14, 0, /* clnpReasmTimeout */ 
      1, 3, 6, 1, 3, 1, 1, 15, 0, /* clnpReasmReqds */ 
      1, 3, 6, 1, 3, 1, 1, 16, 0, /* clnpReasmOKs */ 
      1, 3, 6, 1, 3, 1, 1, 17, 0, /* clnpReasmFails */ 
      1, 3, 6, 1, 3, 1, 1, 18, 0, /* clnpSegOKs */ 
      1, 3, 6, 1, 3, 1, 1, 19, 0, /* clnpSegFails */ 
      1, 3, 6, 1, 3, 1, 1, 20, 0, /* clnpSegCreates */ 
      1, 3, 6, 1, 3, 1, 1, 21, 0, /* clnpAddrTable */ 
      1, 3, 6, 1, 3, 1, 1, 21, 1, 0, /* clnpAddrEntry */ 
      1, 3, 6, 1, 3, 1, 1, 21, 1, 1, 0, /* clnpAdEntAddr */ 
      1, 3, 6, 1, 3, 1, 1, 21, 1, 2, 0, /* clnpAdEntIfIndex */ 
      1, 3, 6, 1, 3, 1, 1, 21, 1, 3, 0, /* clnpAdEntReasmMaxSize */ 
      1, 3, 6, 1, 3, 1, 1, 22, 0, /* clnpRoutingTable */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 0, /* clnpRouteEntry */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 1, 0, /* clnpRouteDest */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 2, 0, /* clnpRouteIfIndex */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 3, 0, /* clnpRouteMetric1 */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 4, 0, /* clnpRouteMetric2 */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 5, 0, /* clnpRouteMetric3 */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 6, 0, /* clnpRouteMetric4 */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 7, 0, /* clnpRouteNextHop */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 8, 0, /* clnpRouteType */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 9, 0, /* clnpRouteProto */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 10, 0, /* clnpRouteAge */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 11, 0, /* clnpRouteMetric5 */ 
      1, 3, 6, 1, 3, 1, 1, 22, 1, 12, 0, /* clnpRouteInfo */ 
      1, 3, 6, 1, 3, 1, 1, 23, 0, /* clnpNetToMediaTable */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 0, /* clnpNetToMediaEntry */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 1, 0, /* clnpNetToMediaIfIndex */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 2, 0, /* clnpNetToMediaPhysAddress */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 3, 0, /* clnpNetToMediaNetAddress */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 4, 0, /* clnpNetToMediaType */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 5, 0, /* clnpNetToMediaAge */ 
      1, 3, 6, 1, 3, 1, 1, 23, 1, 6, 0, /* clnpNetToMediaHoldTime */ 
      1, 3, 6, 1, 3, 1, 1, 24, 0, /* clnpMediaToNetTable */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 0, /* clnpMediaToNetEntry */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 1, 0, /* clnpMediaToNetIfIndex */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 2, 0, /* clnpMediaToNetAddress */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 3, 0, /* clnpMediaToNetPhysAddress */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 4, 0, /* clnpMediaToNetType */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 5, 0, /* clnpMediaToNetAge */ 
      1, 3, 6, 1, 3, 1, 1, 24, 1, 6, 0, /* clnpMediaToNetHoldTime */ 
      1, 3, 6, 1, 3, 1, 1, 25, 0, /* clnpInOpts */ 
      1, 3, 6, 1, 3, 1, 1, 26, 0, /* clnpOutOpts */ 
      1, 3, 6, 1, 3, 1, 1, 27, 0, /* clnpRoutingDiscards */ 
      1, 3, 6, 1, 3, 1, 2, 0, /* error */ 
      1, 3, 6, 1, 3, 1, 2, 1, 0, /* clnpInErrors */ 
      1, 3, 6, 1, 3, 1, 2, 2, 0, /* clnpOutErrors */ 
      1, 3, 6, 1, 3, 1, 2, 3, 0, /* clnpInErrUnspecs */ 
      1, 3, 6, 1, 3, 1, 2, 4, 0, /* clnpInErrProcs */ 
      1, 3, 6, 1, 3, 1, 2, 5, 0, /* clnpInErrCksums */ 
      1, 3, 6, 1, 3, 1, 2, 6, 0, /* clnpInErrCongests */ 
      1, 3, 6, 1, 3, 1, 2, 7, 0, /* clnpInErrHdrs */ 
      1, 3, 6, 1, 3, 1, 2, 8, 0, /* clnpInErrSegs */ 
      1, 3, 6, 1, 3, 1, 2, 9, 0, /* clnpInErrIncomps */ 
      1, 3, 6, 1, 3, 1, 2, 10, 0, /* clnpInErrDups */ 
      1, 3, 6, 1, 3, 1, 2, 11, 0, /* clnpInErrUnreachDsts */ 
      1, 3, 6, 1, 3, 1, 2, 12, 0, /* clnpInErrUnknownDsts */ 
      1, 3, 6, 1, 3, 1, 2, 13, 0, /* clnpInErrSRUnspecs */ 
      1, 3, 6, 1, 3, 1, 2, 14, 0, /* clnpInErrSRSyntaxes */ 
      1, 3, 6, 1, 3, 1, 2, 15, 0, /* clnpInErrSRUnkAddrs */ 
      1, 3, 6, 1, 3, 1, 2, 16, 0, /* clnpInErrSRBadPaths */ 
      1, 3, 6, 1, 3, 1, 2, 17, 0, /* clnpInErrHops */ 
      1, 3, 6, 1, 3, 1, 2, 18, 0, /* clnpInErrHopReassms */ 
      1, 3, 6, 1, 3, 1, 2, 19, 0, /* clnpInErrUnsOptions */ 
      1, 3, 6, 1, 3, 1, 2, 20, 0, /* clnpInErrUnsVersions */ 
      1, 3, 6, 1, 3, 1, 2, 21, 0, /* clnpInErrUnsSecurities */ 
      1, 3, 6, 1, 3, 1, 2, 22, 0, /* clnpInErrUnsSRs */ 
      1, 3, 6, 1, 3, 1, 2, 23, 0, /* clnpInErrUnsRRs */ 
      1, 3, 6, 1, 3, 1, 2, 24, 0, /* clnpInErrInterferences */ 
      1, 3, 6, 1, 3, 1, 2, 25, 0, /* clnpOutErrUnspecs */ 
      1, 3, 6, 1, 3, 1, 2, 26, 0, /* clnpOutErrProcs */ 
      1, 3, 6, 1, 3, 1, 2, 27, 0, /* clnpOutErrCksums */ 
      1, 3, 6, 1, 3, 1, 2, 28, 0, /* clnpOutErrCongests */ 
      1, 3, 6, 1, 3, 1, 2, 29, 0, /* clnpOutErrHdrs */ 
      1, 3, 6, 1, 3, 1, 2, 30, 0, /* clnpOutErrSegs */ 
      1, 3, 6, 1, 3, 1, 2, 31, 0, /* clnpOutErrIncomps */ 
      1, 3, 6, 1, 3, 1, 2, 32, 0, /* clnpOutErrDups */ 
      1, 3, 6, 1, 3, 1, 2, 33, 0, /* clnpOutErrUnreachDsts */ 
      1, 3, 6, 1, 3, 1, 2, 34, 0, /* clnpOutErrUnknownDsts */ 
      1, 3, 6, 1, 3, 1, 2, 35, 0, /* clnpOutErrSRUnspecs */ 
      1, 3, 6, 1, 3, 1, 2, 36, 0, /* clnpOutErrSRSyntaxes */ 
      1, 3, 6, 1, 3, 1, 2, 37, 0, /* clnpOutErrSRUnkAddrs */ 
      1, 3, 6, 1, 3, 1, 2, 38, 0, /* clnpOutErrSRBadPaths */ 
      1, 3, 6, 1, 3, 1, 2, 39, 0, /* clnpOutErrHops */ 
      1, 3, 6, 1, 3, 1, 2, 40, 0, /* clnpOutErrHopReassms */ 
      1, 3, 6, 1, 3, 1, 2, 41, 0, /* clnpOutErrUnsOptions */ 
      1, 3, 6, 1, 3, 1, 2, 42, 0, /* clnpOutErrUnsVersions */ 
      1, 3, 6, 1, 3, 1, 2, 43, 0, /* clnpOutErrUnsSecurities */ 
      1, 3, 6, 1, 3, 1, 2, 44, 0, /* clnpOutErrUnsSRs */ 
      1, 3, 6, 1, 3, 1, 2, 45, 0, /* clnpOutErrUnsRRs */ 
      1, 3, 6, 1, 3, 1, 2, 46, 0, /* clnpOutErrInterferences */ 
      1, 3, 6, 1, 3, 1, 3, 0, /* echo */ 
      1, 3, 6, 1, 3, 1, 4, 0, /* es-is */ 
      1, 3, 6, 1, 3, 1, 4, 1, 0, /* esisESHins */ 
      1, 3, 6, 1, 3, 1, 4, 2, 0, /* esisESHouts */ 
      1, 3, 6, 1, 3, 1, 4, 3, 0, /* esisISHins */ 
      1, 3, 6, 1, 3, 1, 4, 4, 0, /* esisISHouts */ 
      1, 3, 6, 1, 3, 1, 4, 5, 0, /* esisRDUins */ 
      1, 3, 6, 1, 3, 1, 4, 6, 0, /* esisRDUouts */ 
      1, 3, 6, 1, 4, 0, /* private */ 
      1, 3, 6, 1, 4, 1, 0, /* enterprises */ 
      1, 3, 6, 1, 4, 1, 4, 0, /* unix */ 
      1, 3, 6, 1, 4, 1, 4, 1, 0, /* agents */ 
      1, 3, 6, 1, 4, 1, 4, 1, 2, 0, /* fourBSDisode */ 
      1, 3, 6, 1, 4, 1, 4, 1, 2, 9, 6, 0, /* fourBSDisodeAgent */ 
      1, 3, 6, 1, 4, 1, 4, 1, 3, 0, /* agentAction */ 
      1, 3, 6, 1, 4, 1, 4, 1, 4, 0, /* iSODEContextTable */ 
      1, 3, 6, 1, 4, 1, 4, 1, 4, 1, 0, /* iSODEContextEntry */ 
      1, 3, 6, 1, 4, 1, 4, 1, 4, 1, 1, 0, /* iSODEContextName */ 
      1, 3, 6, 1, 4, 1, 4, 1, 5, 0, /* iSODEPartyTestTable */ 
      1, 3, 6, 1, 4, 1, 4, 1, 5, 1, 0, /* iSODEPartyTestEntry */ 
      1, 3, 6, 1, 4, 1, 4, 1, 5, 1, 1, 0, /* iSODEPartyTestMode */ 
      1, 3, 6, 1, 4, 1, 4, 1, 6, 0, /* iSODETestTable */ 
      1, 3, 6, 1, 4, 1, 4, 1, 6, 1, 0, /* iSODETestEntry */ 
      1, 3, 6, 1, 4, 1, 4, 1, 6, 1, 1, 0, /* iSODETestIndex */ 
      1, 3, 6, 1, 4, 1, 4, 1, 6, 1, 2, 0, /* iSODETestInteger */ 
      1, 3, 6, 1, 4, 1, 4, 1, 6, 1, 3, 0, /* iSODETestString */ 
      1, 3, 6, 1, 4, 1, 4, 2, 0, /* mbuf */ 
      1, 3, 6, 1, 4, 1, 4, 2, 1, 0, /* mbufs */ 
      1, 3, 6, 1, 4, 1, 4, 2, 2, 0, /* mbufClusters */ 
      1, 3, 6, 1, 4, 1, 4, 2, 3, 0, /* mbufFreeClusters */ 
      1, 3, 6, 1, 4, 1, 4, 2, 4, 0, /* mbufDrops */ 
      1, 3, 6, 1, 4, 1, 4, 2, 5, 0, /* mbufWaits */ 
      1, 3, 6, 1, 4, 1, 4, 2, 6, 0, /* mbufDrains */ 
      1, 3, 6, 1, 4, 1, 4, 2, 7, 0, /* mbufFrees */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 0, /* mbufTable */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 0, /* mbufEntry */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 1, 0, /* mbufType */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 2, 0, /* mbufAllocates */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 3, 0, /* mbufNewAllocates */ 
      1, 3, 6, 1, 4, 1, 4, 2, 9, 0, /* mbufSpaces */ 
      1, 3, 6, 1, 4, 1, 4, 2, 10, 0, /* mbufNewClusters */ 
      1, 3, 6, 1, 4, 1, 4, 2, 11, 0, /* mbufNewFreeClusters */ 
      1, 3, 6, 1, 4, 1, 4, 2, 12, 0, /* mbufNewSpaces */ 
      1, 3, 6, 1, 4, 1, 4, 3, 0, /* peers */ 
      1, 3, 6, 1, 4, 1, 4, 3, 1, 0, /* fourBSDunixd */ 
      1, 3, 6, 1, 4, 1, 4, 3, 1, 4, 0, /* fourBSDunixdPeer */ 
      1, 3, 6, 1, 4, 1, 4, 5, 0, /* netstat */ 
      1, 3, 6, 1, 4, 1, 4, 5, 1, 0, /* unixNetstat */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 0, /* unixTcpConnTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 1, 0, /* unixTcpConnEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 1, 1, 0, /* unixTcpConnSendQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 1, 2, 0, /* unixTcpConnRecvQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 0, /* unixUdpTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 0, /* unixUdpEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 1, 0, /* unixUdpRemAddress */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 2, 0, /* unixUdpRemPort */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 3, 0, /* unixUdpSendQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 4, 0, /* unixUdpRecvQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 0, /* unixIpRoutingTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 0, /* unixIpRouteEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 1, 0, /* unixIpRouteFlags */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 2, 0, /* unixIpRouteRefCnt */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 3, 0, /* unixIpRouteUses */ 
      1, 3, 6, 1, 4, 1, 4, 5, 5, 0, /* unixRouteBadRedirects */ 
      1, 3, 6, 1, 4, 1, 4, 5, 6, 0, /* unixRouteCreatedByRedirects */ 
      1, 3, 6, 1, 4, 1, 4, 5, 7, 0, /* unixRouteModifiedByRedirects */ 
      1, 3, 6, 1, 4, 1, 4, 5, 8, 0, /* unixRouteLookupFails */ 
      1, 3, 6, 1, 4, 1, 4, 5, 9, 0, /* unixRouteWildcardUses */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 0, /* unixClnpRoutingTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 0, /* unixClnpRouteEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 1, 0, /* unixClnpRouteFlags */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 2, 0, /* unixClnpRouteRefCnt */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 3, 0, /* unixClnpRouteUses */ 
      1, 3, 6, 1, 4, 1, 4, 6, 0, /* print */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 0, /* printQTable */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 0, /* printQEntry */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 1, 0, /* printQName */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 2, 0, /* printQStatus */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 3, 0, /* printQDisplay */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 5, 0, /* printQAction */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 6, 0, /* printQEntries */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 7, 0, /* printQNewEntries */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 0, /* printJTable */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 0, /* printJEntry */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 1, 0, /* printJRank */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 2, 0, /* printJName */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 3, 0, /* printJOwner */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 4, 0, /* printJDescription */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 5, 0, /* printJSize */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 6, 0, /* printJAction */ 
      1, 3, 6, 1, 4, 1, 4, 7, 0, /* users */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 0, /* userTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 0, /* userEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 1, 0, /* userName */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 2, 0, /* userPasswd */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 3, 0, /* userID */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 4, 0, /* userGroup */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 5, 0, /* userQuota */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 6, 0, /* userComment */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 7, 0, /* userFullName */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 8, 0, /* userHome */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 9, 0, /* userShell */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 10, 0, /* userStatus */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 0, /* groupTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 0, /* groupEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 1, 0, /* groupName */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 2, 0, /* groupPasswd */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 3, 0, /* groupID */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 4, 0, /* groupStatus */ 
      1, 3, 6, 1, 4, 1, 4, 7, 3, 0, /* grUserTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 3, 1, 0, /* grUserEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 3, 1, 1, 0, /* grUserStatus */ 
      1, 3, 6, 1, 4, 1, 4, 7, 4, 0, /* grUserZero */ 
      1, 3, 6, 1, 4, 1, 4, 7, 5, 0, /* grNewUserTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 5, 1, 0, /* grNewUserEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 5, 1, 1, 0, /* grNewUserStatus */ 
      1, 3, 6, 1, 4, 1, 4, 8, 0, /* unixFs */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 0, /* fsTable */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 0, /* fsTableEntry */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 1, 0, /* fsIdentifier */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 2, 0, /* fsName */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 3, 0, /* fsMountPoint */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 4, 0, /* fsMountType */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 5, 0, /* fsMountOptions */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 6, 0, /* fsBlockSize */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 7, 0, /* fsBlockCount */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 8, 0, /* fsBlocksFree */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 9, 0, /* fsBlocksAvailable */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 10, 0, /* fsInodeCount */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 11, 0, /* fsInodesAvailable */ 
      1, 3, 6, 1, 5, 0, /* security */ 
      1, 3, 6, 1, 6, 0, /* snmpV2 */ 
      1, 3, 6, 1, 6, 1, 0, /* snmpDomains */ 
      1, 3, 6, 1, 6, 1, 1, 0, /* snmpUDPDomain */ 
      1, 3, 6, 1, 6, 1, 2, 0, /* snmpCLNSDomain */ 
      1, 3, 6, 1, 6, 1, 3, 0, /* snmpCONSDomain */ 
      1, 3, 6, 1, 6, 1, 4, 0, /* snmpDDPDomain */ 
      1, 3, 6, 1, 6, 1, 5, 0, /* snmpIPXDomain */ 
      1, 3, 6, 1, 6, 2, 0, /* snmpProxys */ 
      1, 3, 6, 1, 6, 2, 1, 0, /* rfc1157Proxy */ 
      1, 3, 6, 1, 6, 2, 1, 1, 0, /* rfc1157Domain */ 
      1, 3, 6, 1, 6, 2, 1, 2, 0, /* rfc1157noAuth */ 
      1, 3, 6, 1, 6, 3, 0, /* snmpModules */ 
      1, 3, 6, 1, 6, 3, 1, 0, /* snmpMIB */ 
      1, 3, 6, 1, 6, 3, 1, 1, 0, /* snmpMIBObjects */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 0, /* snmpStats */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 1, 0, /* snmpStatsPackets */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 2, 0, /* snmpStats30Something */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 3, 0, /* snmpStatsEncodingErrors */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 4, 0, /* snmpStatsUnknownDstParties */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 5, 0, /* snmpStatsDstPartyMismatches */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 6, 0, /* snmpStatsUnknownSrcParties */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 7, 0, /* snmpStatsBadAuths */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 8, 0, /* snmpStatsNotInLifetimes */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 9, 0, /* snmpStatsWrongDigestValues */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 10, 0, /* snmpStatsUnknownContexts */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 11, 0, /* snmpStatsBadOperations */ 
      1, 3, 6, 1, 6, 3, 1, 1, 1, 12, 0, /* snmpStatsSilentDrops */ 
      1, 3, 6, 1, 6, 3, 1, 1, 2, 0, /* snmpV1 */ 
      1, 3, 6, 1, 6, 3, 1, 1, 2, 1, 0, /* snmpV1BadCommunityNames */ 
      1, 3, 6, 1, 6, 3, 1, 1, 2, 2, 0, /* snmpV1BadCommunityUses */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 0, /* snmpOR */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 1, 0, /* snmpORLastChange */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 2, 0, /* snmpORTable */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 2, 1, 0, /* snmpOREntry */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 2, 1, 1, 0, /* snmpORIndex */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 2, 1, 2, 0, /* snmpORID */ 
      1, 3, 6, 1, 6, 3, 1, 1, 3, 2, 1, 3, 0, /* snmpORDescr */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 0, /* snmpTrap */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0, /* snmpTrapOID */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 2, 0, /* snmpTrapTable */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 2, 1, 0, /* snmpTrapEntry */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 2, 1, 1, 0, /* snmpTrapNumbers */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 3, 0, /* snmpTrapEnterprise */ 
      1, 3, 6, 1, 6, 3, 1, 1, 4, 4, 0, /* snmpV2EnableAuthenTraps */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 0, /* snmpTraps */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 1, 0, /* coldStart */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 2, 0, /* warmStart */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 3, 0, /* linkDown */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 4, 0, /* linkUp */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 5, 0, /* authenticationFailure */ 
      1, 3, 6, 1, 6, 3, 1, 1, 5, 6, 0, /* egpNeighborLoss */ 
      1, 3, 6, 1, 6, 3, 1, 1, 6, 0, /* snmpSet */ 
      1, 3, 6, 1, 6, 3, 1, 1, 6, 1, 0, /* snmpSetSerialNo */ 
      1, 3, 6, 1, 6, 3, 1, 2, 0, /* snmpMIBConformance */ 
      1, 3, 6, 1, 6, 3, 1, 2, 1, 0, /* snmpMIBCompliances */ 
      1, 3, 6, 1, 6, 3, 1, 2, 1, 1, 0, /* snmpMIBCompliance */ 
      1, 3, 6, 1, 6, 3, 1, 2, 2, 0, /* snmpMIBGroups */ 
      1, 3, 6, 1, 6, 3, 1, 2, 2, 1, 0, /* snmpStatsGroup */ 
      1, 3, 6, 1, 6, 3, 1, 2, 2, 2, 0, /* snmpV1Group */ 
      1, 3, 6, 1, 6, 3, 1, 2, 2, 3, 0, /* snmpORGroup */ 
      1, 3, 6, 1, 6, 3, 1, 2, 2, 4, 0, /* snmpTrapGroup */ 
      1, 3, 6, 1, 6, 3, 1, 2, 2, 5, 0, /* snmpSetGroup */ 
      1, 3, 6, 1, 6, 3, 2, 0, /* snmpM2M */ 
      1, 3, 6, 1, 6, 3, 2, 1, 0, /* snmpM2MObjects */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 0, /* snmpAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 1, 0, /* snmpAlarmNextIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 0, /* snmpAlarmTable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 0, /* snmpAlarmEntry */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 1, 0, /* snmpAlarmIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 2, 0, /* snmpAlarmVariable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 3, 0, /* snmpAlarmInterval */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 4, 0, /* snmpAlarmSampleType */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 5, 0, /* snmpAlarmValue */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 6, 0, /* snmpAlarmStartupAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 7, 0, /* snmpAlarmRisingThreshold */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 8, 0, /* snmpAlarmFallingThreshold */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 9, 0, /* snmpAlarmRisingEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 10, 0, /* snmpAlarmFallingEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 11, 0, /* snmpAlarmUnavailableEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 12, 0, /* snmpAlarmStatus */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 0, /* snmpAlarmNotifications */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 1, 0, /* snmpRisingAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 2, 0, /* snmpFallingAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 3, 0, /* snmpObjectUnavailableAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 0, /* snmpEvent */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 1, 0, /* snmpEventNextIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 0, /* snmpEventTable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 0, /* snmpEventEntry */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 1, 0, /* snmpEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 2, 0, /* snmpEventID */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 3, 0, /* snmpEventDescription */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 4, 0, /* snmpEventEvents */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 5, 0, /* snmpEventLastTimeSent */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 6, 0, /* snmpEventStatus */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 3, 0, /* snmpEventNotifyMinInterval */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 4, 0, /* snmpEventNotifyMaxRetransmissions */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 0, /* snmpEventNotifyTable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 0, /* snmpEventNotifyEntry */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 1, 0, /* snmpEventNotifyIntervalRequested */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 2, 0, /* snmpEventNotifyRetransmissionsRequested */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 3, 0, /* snmpEventNotifyLifetime */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 4, 0, /* snmpEventNotifyStatus */ 
      1, 3, 6, 1, 6, 3, 2, 2, 0, /* snmpM2MConformance */ 
      1, 3, 6, 1, 6, 3, 2, 2, 1, 0, /* snmpM2MCompliances */ 
      1, 3, 6, 1, 6, 3, 2, 2, 1, 1, 0, /* snmpM2MCompliance */ 
      1, 3, 6, 1, 6, 3, 2, 2, 2, 0, /* snmpM2MGroups */ 
      1, 3, 6, 1, 6, 3, 2, 2, 2, 1, 0, /* snmpAlarmGroup */ 
      1, 3, 6, 1, 6, 3, 2, 2, 2, 2, 0, /* snmpEventGroup */ 
      1, 3, 6, 1, 6, 3, 3, 0, /* partyMIB */ 
      1, 3, 6, 1, 6, 3, 3, 1, 0, /* partyAdmin */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 0, /* partyProtocols */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 1, 0, /* noAuth */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 2, 0, /* noPriv */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 3, 0, /* desPrivProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 4, 0, /* v2md5AuthProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 0, /* temporalDomains */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 1, 0, /* currentTime */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 2, 0, /* restartTime */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 3, 0, /* cacheTime */ 
      1, 3, 6, 1, 6, 3, 3, 1, 3, 0, /* initialPartyId */ 
      1, 3, 6, 1, 6, 3, 3, 1, 4, 0, /* initialContextId */ 
      1, 3, 6, 1, 6, 3, 3, 2, 0, /* partyMIBObjects */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 0, /* snmpParties */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 0, /* partyTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 0, /* partyEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 1, 0, /* partyIdentity */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 2, 0, /* partyIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 3, 0, /* partyTDomain */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 4, 0, /* partyTAddress */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 5, 0, /* partyMaxMessageSize */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 6, 0, /* partyLocal */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 7, 0, /* partyAuthProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 8, 0, /* partyAuthClock */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 9, 0, /* partyAuthPrivate */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 10, 0, /* partyAuthPublic */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 11, 0, /* partyAuthLifetime */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 12, 0, /* partyPrivProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 13, 0, /* partyPrivPrivate */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 14, 0, /* partyPrivPublic */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 15, 0, /* partyCloneFrom */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 16, 0, /* partyStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 17, 0, /* partyStatus */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 0, /* snmpContexts */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 0, /* contextTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 0, /* contextEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 1, 0, /* contextIdentity */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 2, 0, /* contextIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 3, 0, /* contextLocal */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 4, 0, /* contextViewIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 5, 0, /* contextLocalEntity */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 6, 0, /* contextLocalTime */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 7, 0, /* contextProxyDstParty */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 8, 0, /* contextProxySrcParty */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 9, 0, /* contextProxyContext */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 10, 0, /* contextStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 11, 0, /* contextStatus */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 0, /* snmpAccess */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 0, /* aclTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 0, /* aclEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 1, 0, /* aclTarget */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 2, 0, /* aclSubject */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 3, 0, /* aclResources */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 4, 0, /* aclPrivileges */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 5, 0, /* aclStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 6, 0, /* aclStatus */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 0, /* snmpViews */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 0, /* viewTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 0, /* viewEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 1, 0, /* viewIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 2, 0, /* viewSubtree */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 3, 0, /* viewMask */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 4, 0, /* viewType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 5, 0, /* viewStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 6, 0, /* viewStatus */ 
      1, 3, 6, 1, 6, 3, 3, 3, 0, /* partyMIBConformance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 0, /* partyMIBCompliances */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 1, 0, /* unSecurableCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 2, 0, /* partyNoPrivacyCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 3, 0, /* partyPrivacyCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 4, 0, /* fullPrivacyCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 2, 0, /* partyMIBGroups */ 
      1, 3, 6, 1, 6, 3, 3, 3, 2, 1, 0, /* partyMIBGroup */ 
      2, 0, /* joint-iso-ccitt */ 
      2, 6, 0, /* mhs */ 
      2, 6, 6, 0, /* group */ 
      2, 6, 6, 200, 0, /* mtr */ 
      2, 6, 6, 200, 5, 0, /* demoGroup */ 
      2, 6, 6, 200, 5, 1, 0, /* demo */ 
      2, 6, 6, 200, 5, 1, 1, 0, /* mtrBigNumber */ 
      2, 6, 6, 200, 5, 1, 2, 0, /* mtrNsapAddress */ 
      2, 6, 6, 200, 5, 1, 3, 0, /* mtrBitString */ 
      2, 6, 6, 200, 5, 1, 4, 0, /* mtrTable */ 
      2, 6, 6, 200, 5, 1, 4, 1, 0, /* mtrEntry */ 
      2, 6, 6, 200, 5, 1, 4, 1, 2, 0, /* mtrColumn */ 
      2, 6, 6, 200, 5, 1, 999, 0, /* mtrDemoMIB */ 
};

static OIDentifier _names[] = {
    { 1, &_elems[0] },
    { 1, &_elems[2] },
    { 4, &_elems[4] },
    { 5, &_elems[9] },
    { 5, &_elems[15] },
    { 6, &_elems[21] },
    { 7, &_elems[28] },
    { 8, &_elems[36] },
    { 8, &_elems[45] },
    { 8, &_elems[54] },
    { 8, &_elems[63] },
    { 8, &_elems[72] },
    { 8, &_elems[81] },
    { 8, &_elems[90] },
    { 7, &_elems[99] },
    { 8, &_elems[107] },
    { 8, &_elems[116] },
    { 9, &_elems[125] },
    { 10, &_elems[135] },
    { 10, &_elems[146] },
    { 10, &_elems[157] },
    { 10, &_elems[168] },
    { 10, &_elems[179] },
    { 10, &_elems[190] },
    { 10, &_elems[201] },
    { 10, &_elems[212] },
    { 10, &_elems[223] },
    { 10, &_elems[234] },
    { 10, &_elems[245] },
    { 10, &_elems[256] },
    { 10, &_elems[267] },
    { 10, &_elems[278] },
    { 10, &_elems[289] },
    { 10, &_elems[300] },
    { 10, &_elems[311] },
    { 10, &_elems[322] },
    { 10, &_elems[333] },
    { 10, &_elems[344] },
    { 10, &_elems[355] },
    { 10, &_elems[366] },
    { 7, &_elems[377] },
    { 8, &_elems[385] },
    { 9, &_elems[394] },
    { 10, &_elems[404] },
    { 10, &_elems[415] },
    { 10, &_elems[426] },
    { 7, &_elems[437] },
    { 8, &_elems[445] },
    { 8, &_elems[454] },
    { 8, &_elems[463] },
    { 8, &_elems[472] },
    { 8, &_elems[481] },
    { 8, &_elems[490] },
    { 8, &_elems[499] },
    { 8, &_elems[508] },
    { 8, &_elems[517] },
    { 8, &_elems[526] },
    { 8, &_elems[535] },
    { 8, &_elems[544] },
    { 8, &_elems[553] },
    { 8, &_elems[562] },
    { 8, &_elems[571] },
    { 8, &_elems[580] },
    { 8, &_elems[589] },
    { 8, &_elems[598] },
    { 8, &_elems[607] },
    { 8, &_elems[616] },
    { 9, &_elems[625] },
    { 10, &_elems[635] },
    { 10, &_elems[646] },
    { 10, &_elems[657] },
    { 10, &_elems[668] },
    { 10, &_elems[679] },
    { 8, &_elems[690] },
    { 9, &_elems[699] },
    { 10, &_elems[709] },
    { 10, &_elems[720] },
    { 10, &_elems[731] },
    { 10, &_elems[742] },
    { 10, &_elems[753] },
    { 10, &_elems[764] },
    { 10, &_elems[775] },
    { 10, &_elems[786] },
    { 10, &_elems[797] },
    { 10, &_elems[808] },
    { 10, &_elems[819] },
    { 10, &_elems[830] },
    { 10, &_elems[841] },
    { 8, &_elems[852] },
    { 9, &_elems[861] },
    { 10, &_elems[871] },
    { 10, &_elems[882] },
    { 10, &_elems[893] },
    { 10, &_elems[904] },
    { 8, &_elems[915] },
    { 8, &_elems[924] },
    { 9, &_elems[933] },
    { 9, &_elems[943] },
    { 10, &_elems[953] },
    { 11, &_elems[964] },
    { 11, &_elems[976] },
    { 11, &_elems[988] },
    { 11, &_elems[1000] },
    { 11, &_elems[1012] },
    { 11, &_elems[1024] },
    { 11, &_elems[1036] },
    { 11, &_elems[1048] },
    { 11, &_elems[1060] },
    { 11, &_elems[1072] },
    { 11, &_elems[1084] },
    { 11, &_elems[1096] },
    { 11, &_elems[1108] },
    { 11, &_elems[1120] },
    { 11, &_elems[1132] },
    { 7, &_elems[1144] },
    { 8, &_elems[1152] },
    { 8, &_elems[1161] },
    { 8, &_elems[1170] },
    { 8, &_elems[1179] },
    { 8, &_elems[1188] },
    { 8, &_elems[1197] },
    { 8, &_elems[1206] },
    { 8, &_elems[1215] },
    { 8, &_elems[1224] },
    { 8, &_elems[1233] },
    { 8, &_elems[1242] },
    { 8, &_elems[1251] },
    { 8, &_elems[1260] },
    { 8, &_elems[1269] },
    { 8, &_elems[1278] },
    { 8, &_elems[1287] },
    { 8, &_elems[1296] },
    { 8, &_elems[1305] },
    { 8, &_elems[1314] },
    { 8, &_elems[1323] },
    { 8, &_elems[1332] },
    { 8, &_elems[1341] },
    { 8, &_elems[1350] },
    { 8, &_elems[1359] },
    { 8, &_elems[1368] },
    { 8, &_elems[1377] },
    { 7, &_elems[1386] },
    { 8, &_elems[1394] },
    { 8, &_elems[1403] },
    { 8, &_elems[1412] },
    { 8, &_elems[1421] },
    { 8, &_elems[1430] },
    { 8, &_elems[1439] },
    { 8, &_elems[1448] },
    { 8, &_elems[1457] },
    { 8, &_elems[1466] },
    { 8, &_elems[1475] },
    { 8, &_elems[1484] },
    { 8, &_elems[1493] },
    { 8, &_elems[1502] },
    { 9, &_elems[1511] },
    { 10, &_elems[1521] },
    { 10, &_elems[1532] },
    { 10, &_elems[1543] },
    { 10, &_elems[1554] },
    { 10, &_elems[1565] },
    { 8, &_elems[1576] },
    { 8, &_elems[1585] },
    { 7, &_elems[1594] },
    { 8, &_elems[1602] },
    { 8, &_elems[1611] },
    { 8, &_elems[1620] },
    { 8, &_elems[1629] },
    { 8, &_elems[1638] },
    { 9, &_elems[1647] },
    { 10, &_elems[1657] },
    { 10, &_elems[1668] },
    { 7, &_elems[1679] },
    { 8, &_elems[1687] },
    { 8, &_elems[1696] },
    { 8, &_elems[1705] },
    { 8, &_elems[1714] },
    { 8, &_elems[1723] },
    { 9, &_elems[1732] },
    { 10, &_elems[1742] },
    { 10, &_elems[1753] },
    { 10, &_elems[1764] },
    { 10, &_elems[1775] },
    { 10, &_elems[1786] },
    { 10, &_elems[1797] },
    { 10, &_elems[1808] },
    { 10, &_elems[1819] },
    { 10, &_elems[1830] },
    { 10, &_elems[1841] },
    { 10, &_elems[1852] },
    { 10, &_elems[1863] },
    { 10, &_elems[1874] },
    { 10, &_elems[1885] },
    { 10, &_elems[1896] },
    { 8, &_elems[1907] },
    { 7, &_elems[1916] },
    { 8, &_elems[1924] },
    { 9, &_elems[1933] },
    { 10, &_elems[1943] },
    { 11, &_elems[1954] },
    { 11, &_elems[1966] },
    { 11, &_elems[1978] },
    { 11, &_elems[1990] },
    { 11, &_elems[2002] },
    { 11, &_elems[2014] },
    { 11, &_elems[2026] },
    { 11, &_elems[2038] },
    { 11, &_elems[2050] },
    { 11, &_elems[2062] },
    { 11, &_elems[2074] },
    { 11, &_elems[2086] },
    { 11, &_elems[2098] },
    { 11, &_elems[2110] },
    { 11, &_elems[2122] },
    { 11, &_elems[2134] },
    { 11, &_elems[2146] },
    { 11, &_elems[2158] },
    { 11, &_elems[2170] },
    { 11, &_elems[2182] },
    { 11, &_elems[2194] },
    { 11, &_elems[2206] },
    { 11, &_elems[2218] },
    { 11, &_elems[2230] },
    { 9, &_elems[2242] },
    { 10, &_elems[2252] },
    { 11, &_elems[2263] },
    { 11, &_elems[2275] },
    { 11, &_elems[2287] },
    { 11, &_elems[2299] },
    { 11, &_elems[2311] },
    { 11, &_elems[2323] },
    { 11, &_elems[2335] },
    { 11, &_elems[2347] },
    { 11, &_elems[2359] },
    { 11, &_elems[2371] },
    { 11, &_elems[2383] },
    { 11, &_elems[2395] },
    { 11, &_elems[2407] },
    { 11, &_elems[2419] },
    { 11, &_elems[2431] },
    { 11, &_elems[2443] },
    { 11, &_elems[2455] },
    { 11, &_elems[2467] },
    { 11, &_elems[2479] },
    { 11, &_elems[2491] },
    { 11, &_elems[2503] },
    { 11, &_elems[2515] },
    { 11, &_elems[2527] },
    { 11, &_elems[2539] },
    { 11, &_elems[2551] },
    { 9, &_elems[2563] },
    { 10, &_elems[2573] },
    { 11, &_elems[2584] },
    { 11, &_elems[2596] },
    { 11, &_elems[2608] },
    { 11, &_elems[2620] },
    { 11, &_elems[2632] },
    { 11, &_elems[2644] },
    { 11, &_elems[2656] },
    { 11, &_elems[2668] },
    { 11, &_elems[2680] },
    { 11, &_elems[2692] },
    { 11, &_elems[2704] },
    { 11, &_elems[2716] },
    { 11, &_elems[2728] },
    { 11, &_elems[2740] },
    { 11, &_elems[2752] },
    { 11, &_elems[2764] },
    { 11, &_elems[2776] },
    { 11, &_elems[2788] },
    { 11, &_elems[2800] },
    { 11, &_elems[2812] },
    { 11, &_elems[2824] },
    { 11, &_elems[2836] },
    { 11, &_elems[2848] },
    { 11, &_elems[2860] },
    { 11, &_elems[2872] },
    { 9, &_elems[2884] },
    { 10, &_elems[2894] },
    { 11, &_elems[2905] },
    { 11, &_elems[2917] },
    { 11, &_elems[2929] },
    { 11, &_elems[2941] },
    { 11, &_elems[2953] },
    { 11, &_elems[2965] },
    { 11, &_elems[2977] },
    { 9, &_elems[2989] },
    { 10, &_elems[2999] },
    { 11, &_elems[3010] },
    { 11, &_elems[3022] },
    { 11, &_elems[3034] },
    { 11, &_elems[3046] },
    { 11, &_elems[3058] },
    { 11, &_elems[3070] },
    { 11, &_elems[3082] },
    { 11, &_elems[3094] },
    { 11, &_elems[3106] },
    { 11, &_elems[3118] },
    { 11, &_elems[3130] },
    { 11, &_elems[3142] },
    { 11, &_elems[3154] },
    { 11, &_elems[3166] },
    { 11, &_elems[3178] },
    { 11, &_elems[3190] },
    { 11, &_elems[3202] },
    { 11, &_elems[3214] },
    { 11, &_elems[3226] },
    { 11, &_elems[3238] },
    { 11, &_elems[3250] },
    { 9, &_elems[3262] },
    { 9, &_elems[3272] },
    { 9, &_elems[3282] },
    { 10, &_elems[3292] },
    { 11, &_elems[3303] },
    { 11, &_elems[3315] },
    { 11, &_elems[3327] },
    { 11, &_elems[3339] },
    { 11, &_elems[3351] },
    { 11, &_elems[3363] },
    { 11, &_elems[3375] },
    { 11, &_elems[3387] },
    { 11, &_elems[3399] },
    { 11, &_elems[3411] },
    { 11, &_elems[3423] },
    { 11, &_elems[3435] },
    { 9, &_elems[3447] },
    { 10, &_elems[3457] },
    { 11, &_elems[3468] },
    { 11, &_elems[3480] },
    { 11, &_elems[3492] },
    { 11, &_elems[3504] },
    { 11, &_elems[3516] },
    { 11, &_elems[3528] },
    { 11, &_elems[3540] },
    { 11, &_elems[3552] },
    { 11, &_elems[3564] },
    { 11, &_elems[3576] },
    { 11, &_elems[3588] },
    { 11, &_elems[3600] },
    { 11, &_elems[3612] },
    { 11, &_elems[3624] },
    { 11, &_elems[3636] },
    { 11, &_elems[3648] },
    { 11, &_elems[3660] },
    { 11, &_elems[3672] },
    { 11, &_elems[3684] },
    { 11, &_elems[3696] },
    { 11, &_elems[3708] },
    { 11, &_elems[3720] },
    { 11, &_elems[3732] },
    { 11, &_elems[3744] },
    { 11, &_elems[3756] },
    { 11, &_elems[3768] },
    { 11, &_elems[3780] },
    { 11, &_elems[3792] },
    { 11, &_elems[3804] },
    { 11, &_elems[3816] },
    { 9, &_elems[3828] },
    { 10, &_elems[3838] },
    { 10, &_elems[3849] },
    { 10, &_elems[3860] },
    { 10, &_elems[3871] },
    { 10, &_elems[3882] },
    { 10, &_elems[3893] },
    { 8, &_elems[3904] },
    { 9, &_elems[3913] },
    { 10, &_elems[3923] },
    { 11, &_elems[3934] },
    { 11, &_elems[3946] },
    { 11, &_elems[3958] },
    { 11, &_elems[3970] },
    { 11, &_elems[3982] },
    { 11, &_elems[3994] },
    { 11, &_elems[4006] },
    { 11, &_elems[4018] },
    { 11, &_elems[4030] },
    { 11, &_elems[4042] },
    { 11, &_elems[4054] },
    { 11, &_elems[4066] },
    { 11, &_elems[4078] },
    { 9, &_elems[4090] },
    { 10, &_elems[4100] },
    { 11, &_elems[4111] },
    { 11, &_elems[4123] },
    { 11, &_elems[4135] },
    { 9, &_elems[4147] },
    { 10, &_elems[4157] },
    { 9, &_elems[4168] },
    { 10, &_elems[4178] },
    { 10, &_elems[4189] },
    { 9, &_elems[4200] },
    { 10, &_elems[4210] },
    { 11, &_elems[4221] },
    { 11, &_elems[4233] },
    { 10, &_elems[4245] },
    { 11, &_elems[4256] },
    { 11, &_elems[4268] },
    { 10, &_elems[4280] },
    { 11, &_elems[4291] },
    { 10, &_elems[4303] },
    { 11, &_elems[4314] },
    { 11, &_elems[4326] },
    { 10, &_elems[4338] },
    { 11, &_elems[4349] },
    { 11, &_elems[4361] },
    { 8, &_elems[4373] },
    { 9, &_elems[4382] },
    { 10, &_elems[4392] },
    { 11, &_elems[4403] },
    { 11, &_elems[4415] },
    { 11, &_elems[4427] },
    { 11, &_elems[4439] },
    { 11, &_elems[4451] },
    { 11, &_elems[4463] },
    { 11, &_elems[4475] },
    { 11, &_elems[4487] },
    { 11, &_elems[4499] },
    { 11, &_elems[4511] },
    { 11, &_elems[4523] },
    { 11, &_elems[4535] },
    { 11, &_elems[4547] },
    { 11, &_elems[4559] },
    { 11, &_elems[4571] },
    { 11, &_elems[4583] },
    { 11, &_elems[4595] },
    { 11, &_elems[4607] },
    { 11, &_elems[4619] },
    { 9, &_elems[4631] },
    { 10, &_elems[4641] },
    { 11, &_elems[4652] },
    { 11, &_elems[4664] },
    { 11, &_elems[4676] },
    { 11, &_elems[4688] },
    { 11, &_elems[4700] },
    { 11, &_elems[4712] },
    { 11, &_elems[4724] },
    { 11, &_elems[4736] },
    { 11, &_elems[4748] },
    { 11, &_elems[4760] },
    { 11, &_elems[4772] },
    { 11, &_elems[4784] },
    { 9, &_elems[4796] },
    { 10, &_elems[4806] },
    { 11, &_elems[4817] },
    { 11, &_elems[4829] },
    { 11, &_elems[4841] },
    { 11, &_elems[4853] },
    { 11, &_elems[4865] },
    { 11, &_elems[4877] },
    { 11, &_elems[4889] },
    { 11, &_elems[4901] },
    { 11, &_elems[4913] },
    { 11, &_elems[4925] },
    { 11, &_elems[4937] },
    { 11, &_elems[4949] },
    { 11, &_elems[4961] },
    { 9, &_elems[4973] },
    { 10, &_elems[4983] },
    { 9, &_elems[4994] },
    { 10, &_elems[5004] },
    { 10, &_elems[5015] },
    { 9, &_elems[5026] },
    { 10, &_elems[5036] },
    { 8, &_elems[5047] },
    { 9, &_elems[5056] },
    { 10, &_elems[5066] },
    { 11, &_elems[5077] },
    { 11, &_elems[5089] },
    { 11, &_elems[5101] },
    { 11, &_elems[5113] },
    { 11, &_elems[5125] },
    { 11, &_elems[5137] },
    { 11, &_elems[5149] },
    { 11, &_elems[5161] },
    { 11, &_elems[5173] },
    { 9, &_elems[5185] },
    { 10, &_elems[5195] },
    { 11, &_elems[5206] },
    { 11, &_elems[5218] },
    { 11, &_elems[5230] },
    { 11, &_elems[5242] },
    { 11, &_elems[5254] },
    { 11, &_elems[5266] },
    { 11, &_elems[5278] },
    { 11, &_elems[5290] },
    { 11, &_elems[5302] },
    { 11, &_elems[5314] },
    { 11, &_elems[5326] },
    { 11, &_elems[5338] },
    { 11, &_elems[5350] },
    { 11, &_elems[5362] },
    { 11, &_elems[5374] },
    { 11, &_elems[5386] },
    { 11, &_elems[5398] },
    { 11, &_elems[5410] },
    { 11, &_elems[5422] },
    { 9, &_elems[5434] },
    { 10, &_elems[5444] },
    { 9, &_elems[5455] },
    { 10, &_elems[5465] },
    { 10, &_elems[5476] },
    { 10, &_elems[5487] },
    { 9, &_elems[5498] },
    { 10, &_elems[5508] },
    { 11, &_elems[5519] },
    { 11, &_elems[5531] },
    { 11, &_elems[5543] },
    { 11, &_elems[5555] },
    { 11, &_elems[5567] },
    { 11, &_elems[5579] },
    { 11, &_elems[5591] },
    { 11, &_elems[5603] },
    { 11, &_elems[5615] },
    { 11, &_elems[5627] },
    { 11, &_elems[5639] },
    { 8, &_elems[5651] },
    { 9, &_elems[5660] },
    { 10, &_elems[5670] },
    { 10, &_elems[5681] },
    { 11, &_elems[5692] },
    { 12, &_elems[5704] },
    { 12, &_elems[5717] },
    { 12, &_elems[5730] },
    { 12, &_elems[5743] },
    { 12, &_elems[5756] },
    { 12, &_elems[5769] },
    { 12, &_elems[5782] },
    { 12, &_elems[5795] },
    { 12, &_elems[5808] },
    { 12, &_elems[5821] },
    { 12, &_elems[5834] },
    { 12, &_elems[5847] },
    { 12, &_elems[5860] },
    { 12, &_elems[5873] },
    { 12, &_elems[5886] },
    { 12, &_elems[5899] },
    { 12, &_elems[5912] },
    { 12, &_elems[5925] },
    { 12, &_elems[5938] },
    { 9, &_elems[5951] },
    { 10, &_elems[5961] },
    { 10, &_elems[5972] },
    { 11, &_elems[5983] },
    { 12, &_elems[5995] },
    { 12, &_elems[6008] },
    { 12, &_elems[6021] },
    { 12, &_elems[6034] },
    { 12, &_elems[6047] },
    { 12, &_elems[6060] },
    { 12, &_elems[6073] },
    { 12, &_elems[6086] },
    { 12, &_elems[6099] },
    { 12, &_elems[6112] },
    { 12, &_elems[6125] },
    { 12, &_elems[6138] },
    { 12, &_elems[6151] },
    { 12, &_elems[6164] },
    { 12, &_elems[6177] },
    { 12, &_elems[6190] },
    { 12, &_elems[6203] },
    { 12, &_elems[6216] },
    { 12, &_elems[6229] },
    { 12, &_elems[6242] },
    { 12, &_elems[6255] },
    { 12, &_elems[6268] },
    { 12, &_elems[6281] },
    { 12, &_elems[6294] },
    { 12, &_elems[6307] },
    { 12, &_elems[6320] },
    { 12, &_elems[6333] },
    { 12, &_elems[6346] },
    { 12, &_elems[6359] },
    { 12, &_elems[6372] },
    { 9, &_elems[6385] },
    { 9, &_elems[6395] },
    { 10, &_elems[6405] },
    { 10, &_elems[6416] },
    { 11, &_elems[6427] },
    { 12, &_elems[6439] },
    { 12, &_elems[6452] },
    { 12, &_elems[6465] },
    { 12, &_elems[6478] },
    { 12, &_elems[6491] },
    { 12, &_elems[6504] },
    { 12, &_elems[6517] },
    { 12, &_elems[6530] },
    { 12, &_elems[6543] },
    { 12, &_elems[6556] },
    { 12, &_elems[6569] },
    { 12, &_elems[6582] },
    { 12, &_elems[6595] },
    { 12, &_elems[6608] },
    { 12, &_elems[6621] },
    { 12, &_elems[6634] },
    { 12, &_elems[6647] },
    { 12, &_elems[6660] },
    { 12, &_elems[6673] },
    { 12, &_elems[6686] },
    { 12, &_elems[6699] },
    { 12, &_elems[6712] },
    { 12, &_elems[6725] },
    { 12, &_elems[6738] },
    { 12, &_elems[6751] },
    { 9, &_elems[6764] },
    { 10, &_elems[6774] },
    { 10, &_elems[6785] },
    { 11, &_elems[6796] },
    { 12, &_elems[6808] },
    { 12, &_elems[6821] },
    { 12, &_elems[6834] },
    { 12, &_elems[6847] },
    { 12, &_elems[6860] },
    { 12, &_elems[6873] },
    { 12, &_elems[6886] },
    { 9, &_elems[6899] },
    { 10, &_elems[6909] },
    { 10, &_elems[6920] },
    { 10, &_elems[6931] },
    { 9, &_elems[6942] },
    { 10, &_elems[6952] },
    { 11, &_elems[6963] },
    { 11, &_elems[6975] },
    { 12, &_elems[6987] },
    { 13, &_elems[7000] },
    { 13, &_elems[7014] },
    { 13, &_elems[7028] },
    { 13, &_elems[7042] },
    { 13, &_elems[7056] },
    { 13, &_elems[7070] },
    { 13, &_elems[7084] },
    { 13, &_elems[7098] },
    { 13, &_elems[7112] },
    { 13, &_elems[7126] },
    { 13, &_elems[7140] },
    { 13, &_elems[7154] },
    { 13, &_elems[7168] },
    { 13, &_elems[7182] },
    { 13, &_elems[7196] },
    { 13, &_elems[7210] },
    { 13, &_elems[7224] },
    { 13, &_elems[7238] },
    { 13, &_elems[7252] },
    { 13, &_elems[7266] },
    { 13, &_elems[7280] },
    { 13, &_elems[7294] },
    { 13, &_elems[7308] },
    { 13, &_elems[7322] },
    { 13, &_elems[7336] },
    { 13, &_elems[7350] },
    { 10, &_elems[7364] },
    { 11, &_elems[7375] },
    { 11, &_elems[7387] },
    { 12, &_elems[7399] },
    { 13, &_elems[7412] },
    { 13, &_elems[7426] },
    { 13, &_elems[7440] },
    { 13, &_elems[7454] },
    { 13, &_elems[7468] },
    { 13, &_elems[7482] },
    { 13, &_elems[7496] },
    { 13, &_elems[7510] },
    { 13, &_elems[7524] },
    { 13, &_elems[7538] },
    { 13, &_elems[7552] },
    { 13, &_elems[7566] },
    { 13, &_elems[7580] },
    { 13, &_elems[7594] },
    { 13, &_elems[7608] },
    { 13, &_elems[7622] },
    { 13, &_elems[7636] },
    { 13, &_elems[7650] },
    { 13, &_elems[7664] },
    { 13, &_elems[7678] },
    { 13, &_elems[7692] },
    { 13, &_elems[7706] },
    { 13, &_elems[7720] },
    { 13, &_elems[7734] },
    { 13, &_elems[7748] },
    { 13, &_elems[7762] },
    { 13, &_elems[7776] },
    { 13, &_elems[7790] },
    { 13, &_elems[7804] },
    { 13, &_elems[7818] },
    { 13, &_elems[7832] },
    { 13, &_elems[7846] },
    { 13, &_elems[7860] },
    { 13, &_elems[7874] },
    { 10, &_elems[7888] },
    { 11, &_elems[7899] },
    { 12, &_elems[7911] },
    { 13, &_elems[7924] },
    { 13, &_elems[7938] },
    { 13, &_elems[7952] },
    { 13, &_elems[7966] },
    { 13, &_elems[7980] },
    { 13, &_elems[7994] },
    { 13, &_elems[8008] },
    { 13, &_elems[8022] },
    { 10, &_elems[8036] },
    { 11, &_elems[8047] },
    { 11, &_elems[8059] },
    { 12, &_elems[8071] },
    { 13, &_elems[8084] },
    { 13, &_elems[8098] },
    { 13, &_elems[8112] },
    { 13, &_elems[8126] },
    { 13, &_elems[8140] },
    { 11, &_elems[8154] },
    { 12, &_elems[8166] },
    { 13, &_elems[8179] },
    { 13, &_elems[8193] },
    { 13, &_elems[8207] },
    { 13, &_elems[8221] },
    { 13, &_elems[8235] },
    { 13, &_elems[8249] },
    { 10, &_elems[8263] },
    { 11, &_elems[8274] },
    { 11, &_elems[8286] },
    { 12, &_elems[8298] },
    { 13, &_elems[8311] },
    { 13, &_elems[8325] },
    { 13, &_elems[8339] },
    { 13, &_elems[8353] },
    { 13, &_elems[8367] },
    { 13, &_elems[8381] },
    { 13, &_elems[8395] },
    { 13, &_elems[8409] },
    { 13, &_elems[8423] },
    { 13, &_elems[8437] },
    { 13, &_elems[8451] },
    { 13, &_elems[8465] },
    { 13, &_elems[8479] },
    { 13, &_elems[8493] },
    { 13, &_elems[8507] },
    { 13, &_elems[8521] },
    { 13, &_elems[8535] },
    { 13, &_elems[8549] },
    { 13, &_elems[8563] },
    { 13, &_elems[8577] },
    { 13, &_elems[8591] },
    { 13, &_elems[8605] },
    { 13, &_elems[8619] },
    { 13, &_elems[8633] },
    { 13, &_elems[8647] },
    { 8, &_elems[8661] },
    { 9, &_elems[8670] },
    { 10, &_elems[8680] },
    { 11, &_elems[8691] },
    { 11, &_elems[8703] },
    { 11, &_elems[8715] },
    { 11, &_elems[8727] },
    { 11, &_elems[8739] },
    { 11, &_elems[8751] },
    { 11, &_elems[8763] },
    { 11, &_elems[8775] },
    { 11, &_elems[8787] },
    { 11, &_elems[8799] },
    { 11, &_elems[8811] },
    { 11, &_elems[8823] },
    { 11, &_elems[8835] },
    { 11, &_elems[8847] },
    { 9, &_elems[8859] },
    { 10, &_elems[8869] },
    { 11, &_elems[8880] },
    { 11, &_elems[8892] },
    { 11, &_elems[8904] },
    { 11, &_elems[8916] },
    { 11, &_elems[8928] },
    { 11, &_elems[8940] },
    { 11, &_elems[8952] },
    { 11, &_elems[8964] },
    { 11, &_elems[8976] },
    { 11, &_elems[8988] },
    { 11, &_elems[9000] },
    { 11, &_elems[9012] },
    { 11, &_elems[9024] },
    { 11, &_elems[9036] },
    { 9, &_elems[9048] },
    { 10, &_elems[9058] },
    { 11, &_elems[9069] },
    { 11, &_elems[9081] },
    { 11, &_elems[9093] },
    { 11, &_elems[9105] },
    { 11, &_elems[9117] },
    { 11, &_elems[9129] },
    { 11, &_elems[9141] },
    { 11, &_elems[9153] },
    { 11, &_elems[9165] },
    { 11, &_elems[9177] },
    { 11, &_elems[9189] },
    { 9, &_elems[9201] },
    { 10, &_elems[9211] },
    { 11, &_elems[9222] },
    { 11, &_elems[9234] },
    { 11, &_elems[9246] },
    { 11, &_elems[9258] },
    { 11, &_elems[9270] },
    { 11, &_elems[9282] },
    { 11, &_elems[9294] },
    { 9, &_elems[9306] },
    { 10, &_elems[9316] },
    { 10, &_elems[9327] },
    { 10, &_elems[9338] },
    { 8, &_elems[9349] },
    { 9, &_elems[9358] },
    { 10, &_elems[9368] },
    { 11, &_elems[9379] },
    { 11, &_elems[9391] },
    { 11, &_elems[9403] },
    { 11, &_elems[9415] },
    { 11, &_elems[9427] },
    { 11, &_elems[9439] },
    { 11, &_elems[9451] },
    { 11, &_elems[9463] },
    { 11, &_elems[9475] },
    { 11, &_elems[9487] },
    { 11, &_elems[9499] },
    { 11, &_elems[9511] },
    { 11, &_elems[9523] },
    { 9, &_elems[9535] },
    { 10, &_elems[9545] },
    { 11, &_elems[9556] },
    { 11, &_elems[9568] },
    { 11, &_elems[9580] },
    { 11, &_elems[9592] },
    { 11, &_elems[9604] },
    { 11, &_elems[9616] },
    { 11, &_elems[9628] },
    { 11, &_elems[9640] },
    { 11, &_elems[9652] },
    { 11, &_elems[9664] },
    { 11, &_elems[9676] },
    { 9, &_elems[9688] },
    { 10, &_elems[9698] },
    { 11, &_elems[9709] },
    { 11, &_elems[9721] },
    { 11, &_elems[9733] },
    { 11, &_elems[9745] },
    { 11, &_elems[9757] },
    { 11, &_elems[9769] },
    { 11, &_elems[9781] },
    { 11, &_elems[9793] },
    { 11, &_elems[9805] },
    { 11, &_elems[9817] },
    { 11, &_elems[9829] },
    { 11, &_elems[9841] },
    { 9, &_elems[9853] },
    { 10, &_elems[9863] },
    { 11, &_elems[9874] },
    { 11, &_elems[9886] },
    { 11, &_elems[9898] },
    { 11, &_elems[9910] },
    { 11, &_elems[9922] },
    { 11, &_elems[9934] },
    { 11, &_elems[9946] },
    { 11, &_elems[9958] },
    { 11, &_elems[9970] },
    { 11, &_elems[9982] },
    { 11, &_elems[9994] },
    { 9, &_elems[10006] },
    { 10, &_elems[10016] },
    { 11, &_elems[10027] },
    { 11, &_elems[10039] },
    { 11, &_elems[10051] },
    { 11, &_elems[10063] },
    { 11, &_elems[10075] },
    { 11, &_elems[10087] },
    { 11, &_elems[10099] },
    { 11, &_elems[10111] },
    { 11, &_elems[10123] },
    { 11, &_elems[10135] },
    { 11, &_elems[10147] },
    { 11, &_elems[10159] },
    { 9, &_elems[10171] },
    { 10, &_elems[10181] },
    { 11, &_elems[10192] },
    { 11, &_elems[10204] },
    { 11, &_elems[10216] },
    { 11, &_elems[10228] },
    { 11, &_elems[10240] },
    { 11, &_elems[10252] },
    { 11, &_elems[10264] },
    { 11, &_elems[10276] },
    { 11, &_elems[10288] },
    { 11, &_elems[10300] },
    { 11, &_elems[10312] },
    { 9, &_elems[10324] },
    { 10, &_elems[10334] },
    { 11, &_elems[10345] },
    { 11, &_elems[10357] },
    { 11, &_elems[10369] },
    { 11, &_elems[10381] },
    { 11, &_elems[10393] },
    { 11, &_elems[10405] },
    { 11, &_elems[10417] },
    { 11, &_elems[10429] },
    { 11, &_elems[10441] },
    { 11, &_elems[10453] },
    { 9, &_elems[10465] },
    { 10, &_elems[10475] },
    { 11, &_elems[10486] },
    { 11, &_elems[10498] },
    { 11, &_elems[10510] },
    { 8, &_elems[10522] },
    { 9, &_elems[10531] },
    { 10, &_elems[10541] },
    { 11, &_elems[10552] },
    { 12, &_elems[10564] },
    { 13, &_elems[10577] },
    { 13, &_elems[10591] },
    { 13, &_elems[10605] },
    { 13, &_elems[10619] },
    { 13, &_elems[10633] },
    { 13, &_elems[10647] },
    { 13, &_elems[10661] },
    { 13, &_elems[10675] },
    { 13, &_elems[10689] },
    { 13, &_elems[10703] },
    { 13, &_elems[10717] },
    { 13, &_elems[10731] },
    { 13, &_elems[10745] },
    { 13, &_elems[10759] },
    { 13, &_elems[10773] },
    { 11, &_elems[10787] },
    { 12, &_elems[10799] },
    { 13, &_elems[10812] },
    { 13, &_elems[10826] },
    { 13, &_elems[10840] },
    { 13, &_elems[10854] },
    { 13, &_elems[10868] },
    { 10, &_elems[10882] },
    { 11, &_elems[10893] },
    { 12, &_elems[10905] },
    { 13, &_elems[10918] },
    { 13, &_elems[10932] },
    { 13, &_elems[10946] },
    { 13, &_elems[10960] },
    { 13, &_elems[10974] },
    { 13, &_elems[10988] },
    { 11, &_elems[11002] },
    { 12, &_elems[11014] },
    { 13, &_elems[11027] },
    { 13, &_elems[11041] },
    { 11, &_elems[11055] },
    { 12, &_elems[11067] },
    { 13, &_elems[11080] },
    { 10, &_elems[11094] },
    { 11, &_elems[11105] },
    { 11, &_elems[11117] },
    { 9, &_elems[11129] },
    { 10, &_elems[11139] },
    { 11, &_elems[11150] },
    { 11, &_elems[11162] },
    { 10, &_elems[11174] },
    { 11, &_elems[11185] },
    { 12, &_elems[11197] },
    { 12, &_elems[11210] },
    { 12, &_elems[11223] },
    { 12, &_elems[11236] },
    { 10, &_elems[11249] },
    { 11, &_elems[11260] },
    { 12, &_elems[11272] },
    { 12, &_elems[11285] },
    { 12, &_elems[11298] },
    { 12, &_elems[11311] },
    { 12, &_elems[11324] },
    { 12, &_elems[11337] },
    { 12, &_elems[11350] },
    { 9, &_elems[11363] },
    { 10, &_elems[11373] },
    { 11, &_elems[11384] },
    { 12, &_elems[11396] },
    { 12, &_elems[11409] },
    { 12, &_elems[11422] },
    { 12, &_elems[11435] },
    { 12, &_elems[11448] },
    { 10, &_elems[11461] },
    { 11, &_elems[11472] },
    { 12, &_elems[11484] },
    { 12, &_elems[11497] },
    { 9, &_elems[11510] },
    { 10, &_elems[11520] },
    { 11, &_elems[11531] },
    { 12, &_elems[11543] },
    { 12, &_elems[11556] },
    { 12, &_elems[11569] },
    { 12, &_elems[11582] },
    { 12, &_elems[11595] },
    { 10, &_elems[11608] },
    { 11, &_elems[11619] },
    { 12, &_elems[11631] },
    { 12, &_elems[11644] },
    { 12, &_elems[11657] },
    { 12, &_elems[11670] },
    { 12, &_elems[11683] },
    { 10, &_elems[11696] },
    { 11, &_elems[11707] },
    { 12, &_elems[11719] },
    { 12, &_elems[11732] },
    { 12, &_elems[11745] },
    { 10, &_elems[11758] },
    { 11, &_elems[11769] },
    { 12, &_elems[11781] },
    { 12, &_elems[11794] },
    { 8, &_elems[11807] },
    { 9, &_elems[11816] },
    { 10, &_elems[11826] },
    { 11, &_elems[11837] },
    { 11, &_elems[11849] },
    { 11, &_elems[11861] },
    { 11, &_elems[11873] },
    { 11, &_elems[11885] },
    { 11, &_elems[11897] },
    { 11, &_elems[11909] },
    { 11, &_elems[11921] },
    { 11, &_elems[11933] },
    { 11, &_elems[11945] },
    { 11, &_elems[11957] },
    { 9, &_elems[11969] },
    { 10, &_elems[11979] },
    { 11, &_elems[11990] },
    { 11, &_elems[12002] },
    { 11, &_elems[12014] },
    { 11, &_elems[12026] },
    { 11, &_elems[12038] },
    { 11, &_elems[12050] },
    { 11, &_elems[12062] },
    { 11, &_elems[12074] },
    { 11, &_elems[12086] },
    { 11, &_elems[12098] },
    { 11, &_elems[12110] },
    { 9, &_elems[12122] },
    { 10, &_elems[12132] },
    { 11, &_elems[12143] },
    { 11, &_elems[12155] },
    { 11, &_elems[12167] },
    { 11, &_elems[12179] },
    { 11, &_elems[12191] },
    { 11, &_elems[12203] },
    { 11, &_elems[12215] },
    { 11, &_elems[12227] },
    { 11, &_elems[12239] },
    { 11, &_elems[12251] },
    { 11, &_elems[12263] },
    { 11, &_elems[12275] },
    { 9, &_elems[12287] },
    { 10, &_elems[12297] },
    { 11, &_elems[12308] },
    { 11, &_elems[12320] },
    { 11, &_elems[12332] },
    { 11, &_elems[12344] },
    { 11, &_elems[12356] },
    { 11, &_elems[12368] },
    { 11, &_elems[12380] },
    { 11, &_elems[12392] },
    { 11, &_elems[12404] },
    { 11, &_elems[12416] },
    { 11, &_elems[12428] },
    { 9, &_elems[12440] },
    { 10, &_elems[12450] },
    { 11, &_elems[12461] },
    { 11, &_elems[12473] },
    { 11, &_elems[12485] },
    { 11, &_elems[12497] },
    { 11, &_elems[12509] },
    { 11, &_elems[12521] },
    { 9, &_elems[12533] },
    { 10, &_elems[12543] },
    { 11, &_elems[12554] },
    { 11, &_elems[12566] },
    { 11, &_elems[12578] },
    { 11, &_elems[12590] },
    { 11, &_elems[12602] },
    { 11, &_elems[12614] },
    { 11, &_elems[12626] },
    { 9, &_elems[12638] },
    { 10, &_elems[12648] },
    { 11, &_elems[12659] },
    { 11, &_elems[12671] },
    { 11, &_elems[12683] },
    { 11, &_elems[12695] },
    { 11, &_elems[12707] },
    { 11, &_elems[12719] },
    { 9, &_elems[12731] },
    { 10, &_elems[12741] },
    { 11, &_elems[12752] },
    { 11, &_elems[12764] },
    { 11, &_elems[12776] },
    { 11, &_elems[12788] },
    { 11, &_elems[12800] },
    { 9, &_elems[12812] },
    { 10, &_elems[12822] },
    { 11, &_elems[12833] },
    { 11, &_elems[12845] },
    { 11, &_elems[12857] },
    { 8, &_elems[12869] },
    { 9, &_elems[12878] },
    { 10, &_elems[12888] },
    { 11, &_elems[12899] },
    { 11, &_elems[12911] },
    { 11, &_elems[12923] },
    { 11, &_elems[12935] },
    { 11, &_elems[12947] },
    { 11, &_elems[12959] },
    { 11, &_elems[12971] },
    { 11, &_elems[12983] },
    { 11, &_elems[12995] },
    { 11, &_elems[13007] },
    { 9, &_elems[13019] },
    { 10, &_elems[13029] },
    { 11, &_elems[13040] },
    { 11, &_elems[13052] },
    { 11, &_elems[13064] },
    { 11, &_elems[13076] },
    { 11, &_elems[13088] },
    { 11, &_elems[13100] },
    { 11, &_elems[13112] },
    { 11, &_elems[13124] },
    { 11, &_elems[13136] },
    { 9, &_elems[13148] },
    { 10, &_elems[13158] },
    { 11, &_elems[13169] },
    { 12, &_elems[13181] },
    { 12, &_elems[13194] },
    { 12, &_elems[13207] },
    { 12, &_elems[13220] },
    { 10, &_elems[13233] },
    { 11, &_elems[13244] },
    { 12, &_elems[13256] },
    { 12, &_elems[13269] },
    { 12, &_elems[13282] },
    { 12, &_elems[13295] },
    { 9, &_elems[13308] },
    { 10, &_elems[13318] },
    { 11, &_elems[13329] },
    { 12, &_elems[13341] },
    { 13, &_elems[13354] },
    { 13, &_elems[13368] },
    { 13, &_elems[13382] },
    { 13, &_elems[13396] },
    { 13, &_elems[13410] },
    { 9, &_elems[13424] },
    { 9, &_elems[13434] },
    { 10, &_elems[13444] },
    { 11, &_elems[13455] },
    { 12, &_elems[13467] },
    { 12, &_elems[13480] },
    { 12, &_elems[13493] },
    { 12, &_elems[13506] },
    { 12, &_elems[13519] },
    { 8, &_elems[13532] },
    { 9, &_elems[13541] },
    { 10, &_elems[13551] },
    { 11, &_elems[13562] },
    { 11, &_elems[13574] },
    { 11, &_elems[13586] },
    { 11, &_elems[13598] },
    { 11, &_elems[13610] },
    { 11, &_elems[13622] },
    { 11, &_elems[13634] },
    { 11, &_elems[13646] },
    { 11, &_elems[13658] },
    { 11, &_elems[13670] },
    { 9, &_elems[13682] },
    { 10, &_elems[13692] },
    { 11, &_elems[13703] },
    { 11, &_elems[13715] },
    { 11, &_elems[13727] },
    { 11, &_elems[13739] },
    { 11, &_elems[13751] },
    { 11, &_elems[13763] },
    { 11, &_elems[13775] },
    { 11, &_elems[13787] },
    { 11, &_elems[13799] },
    { 11, &_elems[13811] },
    { 11, &_elems[13823] },
    { 11, &_elems[13835] },
    { 11, &_elems[13847] },
    { 11, &_elems[13859] },
    { 9, &_elems[13871] },
    { 10, &_elems[13881] },
    { 11, &_elems[13892] },
    { 11, &_elems[13904] },
    { 11, &_elems[13916] },
    { 11, &_elems[13928] },
    { 9, &_elems[13940] },
    { 10, &_elems[13950] },
    { 8, &_elems[13961] },
    { 9, &_elems[13970] },
    { 9, &_elems[13980] },
    { 10, &_elems[13990] },
    { 11, &_elems[14001] },
    { 11, &_elems[14013] },
    { 11, &_elems[14025] },
    { 11, &_elems[14037] },
    { 11, &_elems[14049] },
    { 11, &_elems[14061] },
    { 9, &_elems[14073] },
    { 10, &_elems[14083] },
    { 11, &_elems[14094] },
    { 11, &_elems[14106] },
    { 11, &_elems[14118] },
    { 11, &_elems[14130] },
    { 11, &_elems[14142] },
    { 11, &_elems[14154] },
    { 11, &_elems[14166] },
    { 11, &_elems[14178] },
    { 9, &_elems[14190] },
    { 10, &_elems[14200] },
    { 11, &_elems[14211] },
    { 11, &_elems[14223] },
    { 11, &_elems[14235] },
    { 11, &_elems[14247] },
    { 11, &_elems[14259] },
    { 11, &_elems[14271] },
    { 11, &_elems[14283] },
    { 9, &_elems[14295] },
    { 10, &_elems[14305] },
    { 11, &_elems[14316] },
    { 11, &_elems[14328] },
    { 11, &_elems[14340] },
    { 11, &_elems[14352] },
    { 9, &_elems[14364] },
    { 10, &_elems[14374] },
    { 11, &_elems[14385] },
    { 11, &_elems[14397] },
    { 11, &_elems[14409] },
    { 11, &_elems[14421] },
    { 8, &_elems[14433] },
    { 9, &_elems[14442] },
    { 9, &_elems[14452] },
    { 10, &_elems[14462] },
    { 11, &_elems[14473] },
    { 11, &_elems[14485] },
    { 11, &_elems[14497] },
    { 11, &_elems[14509] },
    { 9, &_elems[14521] },
    { 10, &_elems[14531] },
    { 11, &_elems[14542] },
    { 11, &_elems[14554] },
    { 11, &_elems[14566] },
    { 11, &_elems[14578] },
    { 9, &_elems[14590] },
    { 10, &_elems[14600] },
    { 11, &_elems[14611] },
    { 11, &_elems[14623] },
    { 11, &_elems[14635] },
    { 11, &_elems[14647] },
    { 8, &_elems[14659] },
    { 9, &_elems[14668] },
    { 10, &_elems[14678] },
    { 11, &_elems[14689] },
    { 12, &_elems[14701] },
    { 12, &_elems[14714] },
    { 12, &_elems[14727] },
    { 12, &_elems[14740] },
    { 12, &_elems[14753] },
    { 12, &_elems[14766] },
    { 12, &_elems[14779] },
    { 12, &_elems[14792] },
    { 12, &_elems[14805] },
    { 12, &_elems[14818] },
    { 12, &_elems[14831] },
    { 12, &_elems[14844] },
    { 12, &_elems[14857] },
    { 12, &_elems[14870] },
    { 12, &_elems[14883] },
    { 12, &_elems[14896] },
    { 9, &_elems[14909] },
    { 10, &_elems[14919] },
    { 11, &_elems[14930] },
    { 12, &_elems[14942] },
    { 12, &_elems[14955] },
    { 12, &_elems[14968] },
    { 12, &_elems[14981] },
    { 12, &_elems[14994] },
    { 12, &_elems[15007] },
    { 12, &_elems[15020] },
    { 12, &_elems[15033] },
    { 12, &_elems[15046] },
    { 12, &_elems[15059] },
    { 10, &_elems[15072] },
    { 11, &_elems[15083] },
    { 12, &_elems[15095] },
    { 12, &_elems[15108] },
    { 7, &_elems[15121] },
    { 8, &_elems[15129] },
    { 8, &_elems[15138] },
    { 8, &_elems[15147] },
    { 8, &_elems[15156] },
    { 8, &_elems[15165] },
    { 8, &_elems[15174] },
    { 8, &_elems[15183] },
    { 8, &_elems[15192] },
    { 8, &_elems[15201] },
    { 8, &_elems[15210] },
    { 8, &_elems[15219] },
    { 8, &_elems[15228] },
    { 8, &_elems[15237] },
    { 8, &_elems[15246] },
    { 8, &_elems[15255] },
    { 8, &_elems[15264] },
    { 8, &_elems[15273] },
    { 8, &_elems[15282] },
    { 8, &_elems[15291] },
    { 8, &_elems[15300] },
    { 8, &_elems[15309] },
    { 8, &_elems[15318] },
    { 8, &_elems[15327] },
    { 8, &_elems[15336] },
    { 8, &_elems[15345] },
    { 8, &_elems[15354] },
    { 8, &_elems[15363] },
    { 8, &_elems[15372] },
    { 7, &_elems[15381] },
    { 8, &_elems[15389] },
    { 9, &_elems[15398] },
    { 10, &_elems[15408] },
    { 10, &_elems[15419] },
    { 10, &_elems[15430] },
    { 10, &_elems[15441] },
    { 10, &_elems[15452] },
    { 10, &_elems[15463] },
    { 10, &_elems[15474] },
    { 10, &_elems[15485] },
    { 8, &_elems[15496] },
    { 9, &_elems[15505] },
    { 10, &_elems[15515] },
    { 10, &_elems[15526] },
    { 10, &_elems[15537] },
    { 10, &_elems[15548] },
    { 10, &_elems[15559] },
    { 10, &_elems[15570] },
    { 8, &_elems[15581] },
    { 9, &_elems[15590] },
    { 10, &_elems[15600] },
    { 10, &_elems[15611] },
    { 10, &_elems[15622] },
    { 8, &_elems[15633] },
    { 9, &_elems[15642] },
    { 7, &_elems[15652] },
    { 8, &_elems[15660] },
    { 9, &_elems[15669] },
    { 10, &_elems[15679] },
    { 11, &_elems[15690] },
    { 11, &_elems[15702] },
    { 11, &_elems[15714] },
    { 11, &_elems[15726] },
    { 11, &_elems[15738] },
    { 11, &_elems[15750] },
    { 11, &_elems[15762] },
    { 11, &_elems[15774] },
    { 11, &_elems[15786] },
    { 11, &_elems[15798] },
    { 11, &_elems[15810] },
    { 8, &_elems[15822] },
    { 9, &_elems[15831] },
    { 10, &_elems[15841] },
    { 11, &_elems[15852] },
    { 11, &_elems[15864] },
    { 11, &_elems[15876] },
    { 8, &_elems[15888] },
    { 9, &_elems[15897] },
    { 10, &_elems[15907] },
    { 11, &_elems[15918] },
    { 11, &_elems[15930] },
    { 11, &_elems[15942] },
    { 11, &_elems[15954] },
    { 11, &_elems[15966] },
    { 11, &_elems[15978] },
    { 11, &_elems[15990] },
    { 11, &_elems[16002] },
    { 11, &_elems[16014] },
    { 11, &_elems[16026] },
    { 11, &_elems[16038] },
    { 8, &_elems[16050] },
    { 9, &_elems[16059] },
    { 9, &_elems[16069] },
    { 9, &_elems[16079] },
    { 9, &_elems[16089] },
    { 9, &_elems[16099] },
    { 9, &_elems[16109] },
    { 9, &_elems[16119] },
    { 9, &_elems[16129] },
    { 9, &_elems[16139] },
    { 9, &_elems[16149] },
    { 9, &_elems[16159] },
    { 9, &_elems[16169] },
    { 9, &_elems[16179] },
    { 9, &_elems[16189] },
    { 8, &_elems[16199] },
    { 9, &_elems[16208] },
    { 10, &_elems[16218] },
    { 11, &_elems[16229] },
    { 11, &_elems[16241] },
    { 11, &_elems[16253] },
    { 11, &_elems[16265] },
    { 11, &_elems[16277] },
    { 11, &_elems[16289] },
    { 11, &_elems[16301] },
    { 8, &_elems[16313] },
    { 9, &_elems[16322] },
    { 10, &_elems[16332] },
    { 11, &_elems[16343] },
    { 11, &_elems[16355] },
    { 11, &_elems[16367] },
    { 11, &_elems[16379] },
    { 11, &_elems[16391] },
    { 11, &_elems[16403] },
    { 11, &_elems[16415] },
    { 11, &_elems[16427] },
    { 11, &_elems[16439] },
    { 8, &_elems[16451] },
    { 9, &_elems[16460] },
    { 10, &_elems[16470] },
    { 11, &_elems[16481] },
    { 11, &_elems[16493] },
    { 11, &_elems[16505] },
    { 11, &_elems[16517] },
    { 11, &_elems[16529] },
    { 8, &_elems[16541] },
    { 9, &_elems[16550] },
    { 10, &_elems[16560] },
    { 11, &_elems[16571] },
    { 11, &_elems[16583] },
    { 11, &_elems[16595] },
    { 11, &_elems[16607] },
    { 11, &_elems[16619] },
    { 8, &_elems[16631] },
    { 9, &_elems[16640] },
    { 9, &_elems[16650] },
    { 7, &_elems[16660] },
    { 8, &_elems[16668] },
    { 9, &_elems[16677] },
    { 9, &_elems[16687] },
    { 9, &_elems[16697] },
    { 9, &_elems[16707] },
    { 9, &_elems[16717] },
    { 9, &_elems[16727] },
    { 9, &_elems[16737] },
    { 9, &_elems[16747] },
    { 9, &_elems[16757] },
    { 9, &_elems[16767] },
    { 8, &_elems[16777] },
    { 9, &_elems[16786] },
    { 10, &_elems[16796] },
    { 10, &_elems[16807] },
    { 10, &_elems[16818] },
    { 10, &_elems[16829] },
    { 10, &_elems[16840] },
    { 10, &_elems[16851] },
    { 10, &_elems[16862] },
    { 10, &_elems[16873] },
    { 8, &_elems[16884] },
    { 9, &_elems[16893] },
    { 10, &_elems[16903] },
    { 10, &_elems[16914] },
    { 10, &_elems[16925] },
    { 10, &_elems[16936] },
    { 8, &_elems[16947] },
    { 9, &_elems[16956] },
    { 10, &_elems[16966] },
    { 10, &_elems[16977] },
    { 10, &_elems[16988] },
    { 10, &_elems[16999] },
    { 10, &_elems[17010] },
    { 10, &_elems[17021] },
    { 10, &_elems[17032] },
    { 10, &_elems[17043] },
    { 8, &_elems[17054] },
    { 9, &_elems[17063] },
    { 10, &_elems[17073] },
    { 10, &_elems[17084] },
    { 10, &_elems[17095] },
    { 10, &_elems[17106] },
    { 8, &_elems[17117] },
    { 9, &_elems[17126] },
    { 10, &_elems[17136] },
    { 10, &_elems[17147] },
    { 10, &_elems[17158] },
    { 10, &_elems[17169] },
    { 8, &_elems[17180] },
    { 9, &_elems[17189] },
    { 10, &_elems[17199] },
    { 10, &_elems[17210] },
    { 10, &_elems[17221] },
    { 10, &_elems[17232] },
    { 10, &_elems[17243] },
    { 10, &_elems[17254] },
    { 10, &_elems[17265] },
    { 10, &_elems[17276] },
    { 10, &_elems[17287] },
    { 10, &_elems[17298] },
    { 10, &_elems[17309] },
    { 10, &_elems[17320] },
    { 10, &_elems[17331] },
    { 10, &_elems[17342] },
    { 10, &_elems[17353] },
    { 10, &_elems[17364] },
    { 8, &_elems[17375] },
    { 9, &_elems[17384] },
    { 10, &_elems[17394] },
    { 10, &_elems[17405] },
    { 10, &_elems[17416] },
    { 10, &_elems[17427] },
    { 10, &_elems[17438] },
    { 8, &_elems[17449] },
    { 9, &_elems[17458] },
    { 10, &_elems[17468] },
    { 10, &_elems[17479] },
    { 10, &_elems[17490] },
    { 10, &_elems[17501] },
    { 10, &_elems[17512] },
    { 10, &_elems[17523] },
    { 10, &_elems[17534] },
    { 10, &_elems[17545] },
    { 10, &_elems[17556] },
    { 10, &_elems[17567] },
    { 8, &_elems[17578] },
    { 9, &_elems[17587] },
    { 10, &_elems[17597] },
    { 10, &_elems[17608] },
    { 10, &_elems[17619] },
    { 10, &_elems[17630] },
    { 10, &_elems[17641] },
    { 10, &_elems[17652] },
    { 10, &_elems[17663] },
    { 10, &_elems[17674] },
    { 10, &_elems[17685] },
    { 8, &_elems[17696] },
    { 9, &_elems[17705] },
    { 10, &_elems[17715] },
    { 10, &_elems[17726] },
    { 10, &_elems[17737] },
    { 10, &_elems[17748] },
    { 10, &_elems[17759] },
    { 10, &_elems[17770] },
    { 10, &_elems[17781] },
    { 7, &_elems[17792] },
    { 8, &_elems[17800] },
    { 8, &_elems[17809] },
    { 8, &_elems[17818] },
    { 9, &_elems[17827] },
    { 10, &_elems[17837] },
    { 10, &_elems[17848] },
    { 10, &_elems[17859] },
    { 10, &_elems[17870] },
    { 10, &_elems[17881] },
    { 10, &_elems[17892] },
    { 10, &_elems[17903] },
    { 10, &_elems[17914] },
    { 10, &_elems[17925] },
    { 10, &_elems[17936] },
    { 10, &_elems[17947] },
    { 10, &_elems[17958] },
    { 10, &_elems[17969] },
    { 10, &_elems[17980] },
    { 8, &_elems[17991] },
    { 8, &_elems[18000] },
    { 9, &_elems[18009] },
    { 10, &_elems[18019] },
    { 10, &_elems[18030] },
    { 10, &_elems[18041] },
    { 10, &_elems[18052] },
    { 10, &_elems[18063] },
    { 10, &_elems[18074] },
    { 7, &_elems[18085] },
    { 8, &_elems[18093] },
    { 9, &_elems[18102] },
    { 10, &_elems[18112] },
    { 11, &_elems[18123] },
    { 11, &_elems[18135] },
    { 11, &_elems[18147] },
    { 11, &_elems[18159] },
    { 11, &_elems[18171] },
    { 11, &_elems[18183] },
    { 11, &_elems[18195] },
    { 11, &_elems[18207] },
    { 11, &_elems[18219] },
    { 11, &_elems[18231] },
    { 11, &_elems[18243] },
    { 11, &_elems[18255] },
    { 11, &_elems[18267] },
    { 11, &_elems[18279] },
    { 11, &_elems[18291] },
    { 11, &_elems[18303] },
    { 11, &_elems[18315] },
    { 11, &_elems[18327] },
    { 11, &_elems[18339] },
    { 11, &_elems[18351] },
    { 11, &_elems[18363] },
    { 9, &_elems[18375] },
    { 10, &_elems[18385] },
    { 11, &_elems[18396] },
    { 11, &_elems[18408] },
    { 11, &_elems[18420] },
    { 11, &_elems[18432] },
    { 11, &_elems[18444] },
    { 11, &_elems[18456] },
    { 11, &_elems[18468] },
    { 11, &_elems[18480] },
    { 11, &_elems[18492] },
    { 11, &_elems[18504] },
    { 11, &_elems[18516] },
    { 11, &_elems[18528] },
    { 11, &_elems[18540] },
    { 11, &_elems[18552] },
    { 11, &_elems[18564] },
    { 11, &_elems[18576] },
    { 11, &_elems[18588] },
    { 11, &_elems[18600] },
    { 11, &_elems[18612] },
    { 11, &_elems[18624] },
    { 11, &_elems[18636] },
    { 11, &_elems[18648] },
    { 11, &_elems[18660] },
    { 11, &_elems[18672] },
    { 11, &_elems[18684] },
    { 11, &_elems[18696] },
    { 11, &_elems[18708] },
    { 9, &_elems[18720] },
    { 10, &_elems[18730] },
    { 11, &_elems[18741] },
    { 11, &_elems[18753] },
    { 11, &_elems[18765] },
    { 11, &_elems[18777] },
    { 11, &_elems[18789] },
    { 11, &_elems[18801] },
    { 11, &_elems[18813] },
    { 11, &_elems[18825] },
    { 11, &_elems[18837] },
    { 11, &_elems[18849] },
    { 11, &_elems[18861] },
    { 11, &_elems[18873] },
    { 11, &_elems[18885] },
    { 11, &_elems[18897] },
    { 11, &_elems[18909] },
    { 11, &_elems[18921] },
    { 11, &_elems[18933] },
    { 11, &_elems[18945] },
    { 11, &_elems[18957] },
    { 8, &_elems[18969] },
    { 9, &_elems[18978] },
    { 10, &_elems[18988] },
    { 11, &_elems[18999] },
    { 11, &_elems[19011] },
    { 11, &_elems[19023] },
    { 11, &_elems[19035] },
    { 11, &_elems[19047] },
    { 11, &_elems[19059] },
    { 11, &_elems[19071] },
    { 9, &_elems[19083] },
    { 10, &_elems[19093] },
    { 11, &_elems[19104] },
    { 11, &_elems[19116] },
    { 11, &_elems[19128] },
    { 11, &_elems[19140] },
    { 11, &_elems[19152] },
    { 11, &_elems[19164] },
    { 11, &_elems[19176] },
    { 11, &_elems[19188] },
    { 11, &_elems[19200] },
    { 11, &_elems[19212] },
    { 11, &_elems[19224] },
    { 11, &_elems[19236] },
    { 11, &_elems[19248] },
    { 11, &_elems[19260] },
    { 11, &_elems[19272] },
    { 9, &_elems[19284] },
    { 10, &_elems[19294] },
    { 11, &_elems[19305] },
    { 11, &_elems[19317] },
    { 11, &_elems[19329] },
    { 11, &_elems[19341] },
    { 11, &_elems[19353] },
    { 11, &_elems[19365] },
    { 11, &_elems[19377] },
    { 11, &_elems[19389] },
    { 11, &_elems[19401] },
    { 11, &_elems[19413] },
    { 11, &_elems[19425] },
    { 11, &_elems[19437] },
    { 11, &_elems[19449] },
    { 11, &_elems[19461] },
    { 11, &_elems[19473] },
    { 11, &_elems[19485] },
    { 11, &_elems[19497] },
    { 11, &_elems[19509] },
    { 11, &_elems[19521] },
    { 11, &_elems[19533] },
    { 11, &_elems[19545] },
    { 11, &_elems[19557] },
    { 11, &_elems[19569] },
    { 11, &_elems[19581] },
    { 11, &_elems[19593] },
    { 11, &_elems[19605] },
    { 11, &_elems[19617] },
    { 9, &_elems[19629] },
    { 10, &_elems[19639] },
    { 11, &_elems[19650] },
    { 11, &_elems[19662] },
    { 11, &_elems[19674] },
    { 11, &_elems[19686] },
    { 11, &_elems[19698] },
    { 11, &_elems[19710] },
    { 11, &_elems[19722] },
    { 11, &_elems[19734] },
    { 11, &_elems[19746] },
    { 11, &_elems[19758] },
    { 11, &_elems[19770] },
    { 11, &_elems[19782] },
    { 11, &_elems[19794] },
    { 11, &_elems[19806] },
    { 11, &_elems[19818] },
    { 11, &_elems[19830] },
    { 11, &_elems[19842] },
    { 11, &_elems[19854] },
    { 8, &_elems[19866] },
    { 9, &_elems[19875] },
    { 10, &_elems[19885] },
    { 11, &_elems[19896] },
    { 11, &_elems[19908] },
    { 11, &_elems[19920] },
    { 11, &_elems[19932] },
    { 11, &_elems[19944] },
    { 11, &_elems[19956] },
    { 11, &_elems[19968] },
    { 11, &_elems[19980] },
    { 11, &_elems[19992] },
    { 11, &_elems[20004] },
    { 11, &_elems[20016] },
    { 11, &_elems[20028] },
    { 8, &_elems[20040] },
    { 9, &_elems[20049] },
    { 10, &_elems[20059] },
    { 11, &_elems[20070] },
    { 11, &_elems[20082] },
    { 11, &_elems[20094] },
    { 11, &_elems[20106] },
    { 11, &_elems[20118] },
    { 11, &_elems[20130] },
    { 9, &_elems[20142] },
    { 10, &_elems[20152] },
    { 11, &_elems[20163] },
    { 11, &_elems[20175] },
    { 11, &_elems[20187] },
    { 11, &_elems[20199] },
    { 11, &_elems[20211] },
    { 11, &_elems[20223] },
    { 11, &_elems[20235] },
    { 11, &_elems[20247] },
    { 11, &_elems[20259] },
    { 11, &_elems[20271] },
    { 9, &_elems[20283] },
    { 10, &_elems[20293] },
    { 11, &_elems[20304] },
    { 11, &_elems[20316] },
    { 11, &_elems[20328] },
    { 11, &_elems[20340] },
    { 11, &_elems[20352] },
    { 11, &_elems[20364] },
    { 11, &_elems[20376] },
    { 11, &_elems[20388] },
    { 11, &_elems[20400] },
    { 11, &_elems[20412] },
    { 8, &_elems[20424] },
    { 9, &_elems[20433] },
    { 10, &_elems[20443] },
    { 11, &_elems[20454] },
    { 11, &_elems[20466] },
    { 11, &_elems[20478] },
    { 11, &_elems[20490] },
    { 11, &_elems[20502] },
    { 11, &_elems[20514] },
    { 11, &_elems[20526] },
    { 11, &_elems[20538] },
    { 11, &_elems[20550] },
    { 11, &_elems[20562] },
    { 9, &_elems[20574] },
    { 10, &_elems[20584] },
    { 11, &_elems[20595] },
    { 11, &_elems[20607] },
    { 11, &_elems[20619] },
    { 11, &_elems[20631] },
    { 8, &_elems[20643] },
    { 9, &_elems[20652] },
    { 10, &_elems[20662] },
    { 11, &_elems[20673] },
    { 11, &_elems[20685] },
    { 11, &_elems[20697] },
    { 11, &_elems[20709] },
    { 11, &_elems[20721] },
    { 11, &_elems[20733] },
    { 9, &_elems[20745] },
    { 10, &_elems[20755] },
    { 11, &_elems[20766] },
    { 11, &_elems[20778] },
    { 11, &_elems[20790] },
    { 11, &_elems[20802] },
    { 11, &_elems[20814] },
    { 11, &_elems[20826] },
    { 9, &_elems[20838] },
    { 10, &_elems[20848] },
    { 11, &_elems[20859] },
    { 11, &_elems[20871] },
    { 11, &_elems[20883] },
    { 11, &_elems[20895] },
    { 11, &_elems[20907] },
    { 11, &_elems[20919] },
    { 8, &_elems[20931] },
    { 9, &_elems[20940] },
    { 10, &_elems[20950] },
    { 11, &_elems[20961] },
    { 11, &_elems[20973] },
    { 11, &_elems[20985] },
    { 11, &_elems[20997] },
    { 11, &_elems[21009] },
    { 11, &_elems[21021] },
    { 11, &_elems[21033] },
    { 11, &_elems[21045] },
    { 11, &_elems[21057] },
    { 11, &_elems[21069] },
    { 11, &_elems[21081] },
    { 9, &_elems[21093] },
    { 10, &_elems[21103] },
    { 11, &_elems[21114] },
    { 11, &_elems[21126] },
    { 11, &_elems[21138] },
    { 11, &_elems[21150] },
    { 11, &_elems[21162] },
    { 11, &_elems[21174] },
    { 11, &_elems[21186] },
    { 11, &_elems[21198] },
    { 11, &_elems[21210] },
    { 11, &_elems[21222] },
    { 11, &_elems[21234] },
    { 11, &_elems[21246] },
    { 8, &_elems[21258] },
    { 9, &_elems[21267] },
    { 10, &_elems[21277] },
    { 11, &_elems[21288] },
    { 11, &_elems[21300] },
    { 11, &_elems[21312] },
    { 11, &_elems[21324] },
    { 11, &_elems[21336] },
    { 11, &_elems[21348] },
    { 11, &_elems[21360] },
    { 11, &_elems[21372] },
    { 11, &_elems[21384] },
    { 11, &_elems[21396] },
    { 11, &_elems[21408] },
    { 11, &_elems[21420] },
    { 11, &_elems[21432] },
    { 9, &_elems[21444] },
    { 10, &_elems[21454] },
    { 11, &_elems[21465] },
    { 11, &_elems[21477] },
    { 11, &_elems[21489] },
    { 11, &_elems[21501] },
    { 11, &_elems[21513] },
    { 11, &_elems[21525] },
    { 11, &_elems[21537] },
    { 8, &_elems[21549] },
    { 9, &_elems[21558] },
    { 10, &_elems[21568] },
    { 11, &_elems[21579] },
    { 11, &_elems[21591] },
    { 11, &_elems[21603] },
    { 11, &_elems[21615] },
    { 11, &_elems[21627] },
    { 11, &_elems[21639] },
    { 11, &_elems[21651] },
    { 9, &_elems[21663] },
    { 10, &_elems[21673] },
    { 11, &_elems[21684] },
    { 11, &_elems[21696] },
    { 11, &_elems[21708] },
    { 11, &_elems[21720] },
    { 8, &_elems[21732] },
    { 9, &_elems[21741] },
    { 10, &_elems[21751] },
    { 11, &_elems[21762] },
    { 11, &_elems[21774] },
    { 11, &_elems[21786] },
    { 11, &_elems[21798] },
    { 11, &_elems[21810] },
    { 11, &_elems[21822] },
    { 11, &_elems[21834] },
    { 11, &_elems[21846] },
    { 11, &_elems[21858] },
    { 11, &_elems[21870] },
    { 9, &_elems[21882] },
    { 10, &_elems[21892] },
    { 11, &_elems[21903] },
    { 11, &_elems[21915] },
    { 11, &_elems[21927] },
    { 11, &_elems[21939] },
    { 11, &_elems[21951] },
    { 11, &_elems[21963] },
    { 11, &_elems[21975] },
    { 11, &_elems[21987] },
    { 11, &_elems[21999] },
    { 11, &_elems[22011] },
    { 11, &_elems[22023] },
    { 11, &_elems[22035] },
    { 11, &_elems[22047] },
    { 11, &_elems[22059] },
    { 11, &_elems[22071] },
    { 11, &_elems[22083] },
    { 11, &_elems[22095] },
    { 11, &_elems[22107] },
    { 11, &_elems[22119] },
    { 11, &_elems[22131] },
    { 11, &_elems[22143] },
    { 11, &_elems[22155] },
    { 9, &_elems[22167] },
    { 10, &_elems[22177] },
    { 11, &_elems[22188] },
    { 11, &_elems[22200] },
    { 11, &_elems[22212] },
    { 9, &_elems[22224] },
    { 10, &_elems[22234] },
    { 11, &_elems[22245] },
    { 11, &_elems[22257] },
    { 11, &_elems[22269] },
    { 11, &_elems[22281] },
    { 9, &_elems[22293] },
    { 10, &_elems[22303] },
    { 11, &_elems[22314] },
    { 11, &_elems[22326] },
    { 11, &_elems[22338] },
    { 11, &_elems[22350] },
    { 11, &_elems[22362] },
    { 11, &_elems[22374] },
    { 11, &_elems[22386] },
    { 9, &_elems[22398] },
    { 10, &_elems[22408] },
    { 11, &_elems[22419] },
    { 11, &_elems[22431] },
    { 11, &_elems[22443] },
    { 11, &_elems[22455] },
    { 11, &_elems[22467] },
    { 11, &_elems[22479] },
    { 11, &_elems[22491] },
    { 11, &_elems[22503] },
    { 11, &_elems[22515] },
    { 11, &_elems[22527] },
    { 11, &_elems[22539] },
    { 11, &_elems[22551] },
    { 11, &_elems[22563] },
    { 11, &_elems[22575] },
    { 11, &_elems[22587] },
    { 11, &_elems[22599] },
    { 11, &_elems[22611] },
    { 11, &_elems[22623] },
    { 11, &_elems[22635] },
    { 11, &_elems[22647] },
    { 11, &_elems[22659] },
    { 11, &_elems[22671] },
    { 11, &_elems[22683] },
    { 11, &_elems[22695] },
    { 7, &_elems[22707] },
    { 8, &_elems[22715] },
    { 9, &_elems[22724] },
    { 9, &_elems[22734] },
    { 9, &_elems[22744] },
    { 9, &_elems[22754] },
    { 10, &_elems[22764] },
    { 11, &_elems[22775] },
    { 11, &_elems[22787] },
    { 11, &_elems[22799] },
    { 11, &_elems[22811] },
    { 11, &_elems[22823] },
    { 8, &_elems[22835] },
    { 9, &_elems[22844] },
    { 9, &_elems[22854] },
    { 9, &_elems[22864] },
    { 9, &_elems[22874] },
    { 9, &_elems[22884] },
    { 9, &_elems[22894] },
    { 9, &_elems[22904] },
    { 9, &_elems[22914] },
    { 9, &_elems[22924] },
    { 9, &_elems[22934] },
    { 9, &_elems[22944] },
    { 9, &_elems[22954] },
    { 9, &_elems[22964] },
    { 9, &_elems[22974] },
    { 9, &_elems[22984] },
    { 10, &_elems[22994] },
    { 11, &_elems[23005] },
    { 11, &_elems[23017] },
    { 11, &_elems[23029] },
    { 11, &_elems[23041] },
    { 11, &_elems[23053] },
    { 11, &_elems[23065] },
    { 11, &_elems[23077] },
    { 11, &_elems[23089] },
    { 11, &_elems[23101] },
    { 11, &_elems[23113] },
    { 8, &_elems[23125] },
    { 9, &_elems[23134] },
    { 10, &_elems[23144] },
    { 11, &_elems[23155] },
    { 11, &_elems[23167] },
    { 11, &_elems[23179] },
    { 11, &_elems[23191] },
    { 11, &_elems[23203] },
    { 11, &_elems[23215] },
    { 11, &_elems[23227] },
    { 11, &_elems[23239] },
    { 11, &_elems[23251] },
    { 11, &_elems[23263] },
    { 11, &_elems[23275] },
    { 11, &_elems[23287] },
    { 11, &_elems[23299] },
    { 11, &_elems[23311] },
    { 11, &_elems[23323] },
    { 11, &_elems[23335] },
    { 11, &_elems[23347] },
    { 11, &_elems[23359] },
    { 9, &_elems[23371] },
    { 8, &_elems[23381] },
    { 9, &_elems[23390] },
    { 9, &_elems[23400] },
    { 9, &_elems[23410] },
    { 10, &_elems[23420] },
    { 11, &_elems[23431] },
    { 11, &_elems[23443] },
    { 11, &_elems[23455] },
    { 9, &_elems[23467] },
    { 10, &_elems[23477] },
    { 11, &_elems[23488] },
    { 11, &_elems[23500] },
    { 11, &_elems[23512] },
    { 11, &_elems[23524] },
    { 11, &_elems[23536] },
    { 8, &_elems[23548] },
    { 9, &_elems[23557] },
    { 10, &_elems[23567] },
    { 11, &_elems[23578] },
    { 11, &_elems[23590] },
    { 11, &_elems[23602] },
    { 11, &_elems[23614] },
    { 8, &_elems[23626] },
    { 9, &_elems[23635] },
    { 9, &_elems[23645] },
    { 10, &_elems[23655] },
    { 11, &_elems[23666] },
    { 11, &_elems[23678] },
    { 11, &_elems[23690] },
    { 11, &_elems[23702] },
    { 7, &_elems[23714] },
    { 8, &_elems[23722] },
    { 9, &_elems[23731] },
    { 9, &_elems[23741] },
    { 8, &_elems[23751] },
    { 9, &_elems[23760] },
    { 8, &_elems[23770] },
    { 9, &_elems[23779] },
    { 9, &_elems[23789] },
    { 9, &_elems[23799] },
    { 8, &_elems[23809] },
    { 9, &_elems[23818] },
    { 10, &_elems[23828] },
    { 11, &_elems[23839] },
    { 11, &_elems[23851] },
    { 11, &_elems[23863] },
    { 11, &_elems[23875] },
    { 11, &_elems[23887] },
    { 9, &_elems[23899] },
    { 10, &_elems[23909] },
    { 11, &_elems[23920] },
    { 11, &_elems[23932] },
    { 11, &_elems[23944] },
    { 11, &_elems[23956] },
    { 11, &_elems[23968] },
    { 11, &_elems[23980] },
    { 11, &_elems[23992] },
    { 11, &_elems[24004] },
    { 11, &_elems[24016] },
    { 11, &_elems[24028] },
    { 11, &_elems[24040] },
    { 11, &_elems[24052] },
    { 11, &_elems[24064] },
    { 11, &_elems[24076] },
    { 9, &_elems[24088] },
    { 9, &_elems[24098] },
    { 9, &_elems[24108] },
    { 9, &_elems[24118] },
    { 9, &_elems[24128] },
    { 9, &_elems[24138] },
    { 9, &_elems[24148] },
    { 9, &_elems[24158] },
    { 8, &_elems[24168] },
    { 9, &_elems[24177] },
    { 9, &_elems[24187] },
    { 9, &_elems[24197] },
    { 9, &_elems[24207] },
    { 9, &_elems[24217] },
    { 9, &_elems[24227] },
    { 9, &_elems[24237] },
    { 9, &_elems[24247] },
    { 9, &_elems[24257] },
    { 9, &_elems[24267] },
    { 9, &_elems[24277] },
    { 9, &_elems[24287] },
    { 9, &_elems[24297] },
    { 9, &_elems[24307] },
    { 9, &_elems[24317] },
    { 9, &_elems[24327] },
    { 9, &_elems[24337] },
    { 9, &_elems[24347] },
    { 9, &_elems[24357] },
    { 9, &_elems[24367] },
    { 9, &_elems[24377] },
    { 9, &_elems[24387] },
    { 10, &_elems[24397] },
    { 11, &_elems[24408] },
    { 11, &_elems[24420] },
    { 11, &_elems[24432] },
    { 11, &_elems[24444] },
    { 11, &_elems[24456] },
    { 9, &_elems[24468] },
    { 9, &_elems[24478] },
    { 9, &_elems[24488] },
    { 9, &_elems[24498] },
    { 8, &_elems[24508] },
    { 9, &_elems[24517] },
    { 10, &_elems[24527] },
    { 11, &_elems[24538] },
    { 11, &_elems[24550] },
    { 11, &_elems[24562] },
    { 11, &_elems[24574] },
    { 11, &_elems[24586] },
    { 11, &_elems[24598] },
    { 11, &_elems[24610] },
    { 11, &_elems[24622] },
    { 11, &_elems[24634] },
    { 11, &_elems[24646] },
    { 9, &_elems[24658] },
    { 10, &_elems[24668] },
    { 11, &_elems[24679] },
    { 11, &_elems[24691] },
    { 11, &_elems[24703] },
    { 11, &_elems[24715] },
    { 11, &_elems[24727] },
    { 11, &_elems[24739] },
    { 11, &_elems[24751] },
    { 11, &_elems[24763] },
    { 11, &_elems[24775] },
    { 11, &_elems[24787] },
    { 11, &_elems[24799] },
    { 11, &_elems[24811] },
    { 11, &_elems[24823] },
    { 11, &_elems[24835] },
    { 11, &_elems[24847] },
    { 11, &_elems[24859] },
    { 11, &_elems[24871] },
    { 9, &_elems[24883] },
    { 9, &_elems[24893] },
    { 8, &_elems[24903] },
    { 9, &_elems[24912] },
    { 10, &_elems[24922] },
    { 11, &_elems[24933] },
    { 11, &_elems[24945] },
    { 11, &_elems[24957] },
    { 9, &_elems[24969] },
    { 10, &_elems[24979] },
    { 11, &_elems[24990] },
    { 11, &_elems[25002] },
    { 11, &_elems[25014] },
    { 11, &_elems[25026] },
    { 11, &_elems[25038] },
    { 11, &_elems[25050] },
    { 11, &_elems[25062] },
    { 11, &_elems[25074] },
    { 9, &_elems[25086] },
    { 10, &_elems[25096] },
    { 11, &_elems[25107] },
    { 11, &_elems[25119] },
    { 11, &_elems[25131] },
    { 11, &_elems[25143] },
    { 8, &_elems[25155] },
    { 9, &_elems[25164] },
    { 9, &_elems[25174] },
    { 9, &_elems[25184] },
    { 9, &_elems[25194] },
    { 9, &_elems[25204] },
    { 10, &_elems[25214] },
    { 11, &_elems[25225] },
    { 11, &_elems[25237] },
    { 11, &_elems[25249] },
    { 11, &_elems[25261] },
    { 11, &_elems[25273] },
    { 11, &_elems[25285] },
    { 11, &_elems[25297] },
    { 11, &_elems[25309] },
    { 11, &_elems[25321] },
    { 11, &_elems[25333] },
    { 11, &_elems[25345] },
    { 11, &_elems[25357] },
    { 8, &_elems[25369] },
    { 9, &_elems[25378] },
    { 10, &_elems[25388] },
    { 11, &_elems[25399] },
    { 11, &_elems[25411] },
    { 11, &_elems[25423] },
    { 11, &_elems[25435] },
    { 11, &_elems[25447] },
    { 8, &_elems[25459] },
    { 9, &_elems[25468] },
    { 10, &_elems[25478] },
    { 11, &_elems[25489] },
    { 11, &_elems[25501] },
    { 11, &_elems[25513] },
    { 11, &_elems[25525] },
    { 11, &_elems[25537] },
    { 11, &_elems[25549] },
    { 11, &_elems[25561] },
    { 11, &_elems[25573] },
    { 11, &_elems[25585] },
    { 11, &_elems[25597] },
    { 11, &_elems[25609] },
    { 11, &_elems[25621] },
    { 11, &_elems[25633] },
    { 11, &_elems[25645] },
    { 11, &_elems[25657] },
    { 11, &_elems[25669] },
    { 11, &_elems[25681] },
    { 11, &_elems[25693] },
    { 11, &_elems[25705] },
    { 11, &_elems[25717] },
    { 8, &_elems[25729] },
    { 9, &_elems[25738] },
    { 10, &_elems[25748] },
    { 11, &_elems[25759] },
    { 11, &_elems[25771] },
    { 11, &_elems[25783] },
    { 11, &_elems[25795] },
    { 11, &_elems[25807] },
    { 11, &_elems[25819] },
    { 11, &_elems[25831] },
    { 11, &_elems[25843] },
    { 11, &_elems[25855] },
    { 9, &_elems[25867] },
    { 10, &_elems[25877] },
    { 11, &_elems[25888] },
    { 11, &_elems[25900] },
    { 11, &_elems[25912] },
    { 11, &_elems[25924] },
    { 11, &_elems[25936] },
    { 11, &_elems[25948] },
    { 11, &_elems[25960] },
    { 11, &_elems[25972] },
    { 8, &_elems[25984] },
    { 9, &_elems[25993] },
    { 10, &_elems[26003] },
    { 11, &_elems[26014] },
    { 11, &_elems[26026] },
    { 11, &_elems[26038] },
    { 11, &_elems[26050] },
    { 11, &_elems[26062] },
    { 11, &_elems[26074] },
    { 11, &_elems[26086] },
    { 11, &_elems[26098] },
    { 11, &_elems[26110] },
    { 11, &_elems[26122] },
    { 8, &_elems[26134] },
    { 9, &_elems[26143] },
    { 10, &_elems[26153] },
    { 11, &_elems[26164] },
    { 11, &_elems[26176] },
    { 11, &_elems[26188] },
    { 11, &_elems[26200] },
    { 11, &_elems[26212] },
    { 8, &_elems[26224] },
    { 9, &_elems[26233] },
    { 10, &_elems[26243] },
    { 11, &_elems[26254] },
    { 11, &_elems[26266] },
    { 11, &_elems[26278] },
    { 11, &_elems[26290] },
    { 11, &_elems[26302] },
    { 11, &_elems[26314] },
    { 9, &_elems[26326] },
    { 9, &_elems[26336] },
    { 9, &_elems[26346] },
    { 7, &_elems[26356] },
    { 8, &_elems[26364] },
    { 8, &_elems[26373] },
    { 9, &_elems[26382] },
    { 10, &_elems[26392] },
    { 10, &_elems[26403] },
    { 10, &_elems[26414] },
    { 10, &_elems[26425] },
    { 10, &_elems[26436] },
    { 10, &_elems[26447] },
    { 10, &_elems[26458] },
    { 10, &_elems[26469] },
    { 10, &_elems[26480] },
    { 10, &_elems[26491] },
    { 10, &_elems[26502] },
    { 10, &_elems[26513] },
    { 10, &_elems[26524] },
    { 10, &_elems[26535] },
    { 10, &_elems[26546] },
    { 10, &_elems[26557] },
    { 10, &_elems[26568] },
    { 10, &_elems[26579] },
    { 8, &_elems[26590] },
    { 9, &_elems[26599] },
    { 10, &_elems[26609] },
    { 10, &_elems[26620] },
    { 10, &_elems[26631] },
    { 10, &_elems[26642] },
    { 10, &_elems[26653] },
    { 10, &_elems[26664] },
    { 10, &_elems[26675] },
    { 10, &_elems[26686] },
    { 10, &_elems[26697] },
    { 10, &_elems[26708] },
    { 8, &_elems[26719] },
    { 9, &_elems[26728] },
    { 9, &_elems[26738] },
    { 9, &_elems[26748] },
    { 9, &_elems[26758] },
    { 9, &_elems[26768] },
    { 9, &_elems[26778] },
    { 7, &_elems[26788] },
    { 8, &_elems[26796] },
    { 9, &_elems[26805] },
    { 10, &_elems[26815] },
    { 10, &_elems[26826] },
    { 10, &_elems[26837] },
    { 10, &_elems[26848] },
    { 10, &_elems[26859] },
    { 10, &_elems[26870] },
    { 9, &_elems[26881] },
    { 10, &_elems[26891] },
    { 11, &_elems[26902] },
    { 12, &_elems[26914] },
    { 12, &_elems[26927] },
    { 12, &_elems[26940] },
    { 12, &_elems[26953] },
    { 12, &_elems[26966] },
    { 12, &_elems[26979] },
    { 9, &_elems[26992] },
    { 10, &_elems[27002] },
    { 11, &_elems[27013] },
    { 12, &_elems[27025] },
    { 12, &_elems[27038] },
    { 12, &_elems[27051] },
    { 12, &_elems[27064] },
    { 12, &_elems[27077] },
    { 8, &_elems[27090] },
    { 9, &_elems[27099] },
    { 10, &_elems[27109] },
    { 9, &_elems[27120] },
    { 10, &_elems[27130] },
    { 11, &_elems[27141] },
    { 12, &_elems[27153] },
    { 12, &_elems[27166] },
    { 12, &_elems[27179] },
    { 12, &_elems[27192] },
    { 9, &_elems[27205] },
    { 10, &_elems[27215] },
    { 11, &_elems[27226] },
    { 12, &_elems[27238] },
    { 12, &_elems[27251] },
    { 12, &_elems[27264] },
    { 12, &_elems[27277] },
    { 12, &_elems[27290] },
    { 12, &_elems[27303] },
    { 12, &_elems[27316] },
    { 12, &_elems[27329] },
    { 12, &_elems[27342] },
    { 12, &_elems[27355] },
    { 12, &_elems[27368] },
    { 12, &_elems[27381] },
    { 12, &_elems[27394] },
    { 12, &_elems[27407] },
    { 12, &_elems[27420] },
    { 8, &_elems[27433] },
    { 9, &_elems[27442] },
    { 9, &_elems[27452] },
    { 9, &_elems[27462] },
    { 10, &_elems[27472] },
    { 11, &_elems[27483] },
    { 12, &_elems[27495] },
    { 12, &_elems[27508] },
    { 12, &_elems[27521] },
    { 12, &_elems[27534] },
    { 12, &_elems[27547] },
    { 7, &_elems[27560] },
    { 8, &_elems[27568] },
    { 9, &_elems[27577] },
    { 9, &_elems[27587] },
    { 8, &_elems[27597] },
    { 9, &_elems[27606] },
    { 10, &_elems[27616] },
    { 10, &_elems[27627] },
    { 10, &_elems[27638] },
    { 10, &_elems[27649] },
    { 10, &_elems[27660] },
    { 8, &_elems[27671] },
    { 9, &_elems[27680] },
    { 10, &_elems[27690] },
    { 10, &_elems[27701] },
    { 10, &_elems[27712] },
    { 10, &_elems[27723] },
    { 10, &_elems[27734] },
    { 10, &_elems[27745] },
    { 10, &_elems[27756] },
    { 10, &_elems[27767] },
    { 8, &_elems[27778] },
    { 9, &_elems[27787] },
    { 10, &_elems[27797] },
    { 10, &_elems[27808] },
    { 10, &_elems[27819] },
    { 10, &_elems[27830] },
    { 10, &_elems[27841] },
    { 10, &_elems[27852] },
    { 7, &_elems[27863] },
    { 8, &_elems[27871] },
    { 9, &_elems[27880] },
    { 10, &_elems[27890] },
    { 11, &_elems[27901] },
    { 11, &_elems[27913] },
    { 11, &_elems[27925] },
    { 11, &_elems[27937] },
    { 11, &_elems[27949] },
    { 7, &_elems[27961] },
    { 8, &_elems[27969] },
    { 9, &_elems[27978] },
    { 9, &_elems[27988] },
    { 9, &_elems[27998] },
    { 9, &_elems[28008] },
    { 9, &_elems[28018] },
    { 9, &_elems[28028] },
    { 9, &_elems[28038] },
    { 8, &_elems[28048] },
    { 9, &_elems[28057] },
    { 10, &_elems[28067] },
    { 10, &_elems[28078] },
    { 10, &_elems[28089] },
    { 10, &_elems[28100] },
    { 10, &_elems[28111] },
    { 10, &_elems[28122] },
    { 10, &_elems[28133] },
    { 10, &_elems[28144] },
    { 9, &_elems[28155] },
    { 9, &_elems[28165] },
    { 10, &_elems[28175] },
    { 11, &_elems[28186] },
    { 11, &_elems[28198] },
    { 11, &_elems[28210] },
    { 11, &_elems[28222] },
    { 11, &_elems[28234] },
    { 11, &_elems[28246] },
    { 11, &_elems[28258] },
    { 8, &_elems[28270] },
    { 9, &_elems[28279] },
    { 10, &_elems[28289] },
    { 10, &_elems[28300] },
    { 10, &_elems[28311] },
    { 10, &_elems[28322] },
    { 10, &_elems[28333] },
    { 10, &_elems[28344] },
    { 10, &_elems[28355] },
    { 10, &_elems[28366] },
    { 10, &_elems[28377] },
    { 10, &_elems[28388] },
    { 10, &_elems[28399] },
    { 10, &_elems[28410] },
    { 10, &_elems[28421] },
    { 10, &_elems[28432] },
    { 10, &_elems[28443] },
    { 10, &_elems[28454] },
    { 10, &_elems[28465] },
    { 10, &_elems[28476] },
    { 9, &_elems[28487] },
    { 10, &_elems[28497] },
    { 11, &_elems[28508] },
    { 11, &_elems[28520] },
    { 11, &_elems[28532] },
    { 11, &_elems[28544] },
    { 11, &_elems[28556] },
    { 11, &_elems[28568] },
    { 9, &_elems[28580] },
    { 10, &_elems[28590] },
    { 11, &_elems[28601] },
    { 11, &_elems[28613] },
    { 9, &_elems[28625] },
    { 10, &_elems[28635] },
    { 11, &_elems[28646] },
    { 9, &_elems[28658] },
    { 10, &_elems[28668] },
    { 11, &_elems[28679] },
    { 11, &_elems[28691] },
    { 9, &_elems[28703] },
    { 10, &_elems[28713] },
    { 11, &_elems[28724] },
    { 11, &_elems[28736] },
    { 11, &_elems[28748] },
    { 11, &_elems[28760] },
    { 9, &_elems[28772] },
    { 10, &_elems[28782] },
    { 11, &_elems[28793] },
    { 11, &_elems[28805] },
    { 11, &_elems[28817] },
    { 11, &_elems[28829] },
    { 11, &_elems[28841] },
    { 9, &_elems[28853] },
    { 10, &_elems[28863] },
    { 11, &_elems[28874] },
    { 11, &_elems[28886] },
    { 11, &_elems[28898] },
    { 11, &_elems[28910] },
    { 11, &_elems[28922] },
    { 11, &_elems[28934] },
    { 11, &_elems[28946] },
    { 11, &_elems[28958] },
    { 11, &_elems[28970] },
    { 9, &_elems[28982] },
    { 10, &_elems[28992] },
    { 10, &_elems[29003] },
    { 10, &_elems[29014] },
    { 10, &_elems[29025] },
    { 10, &_elems[29036] },
    { 10, &_elems[29047] },
    { 10, &_elems[29058] },
    { 10, &_elems[29069] },
    { 10, &_elems[29080] },
    { 10, &_elems[29091] },
    { 10, &_elems[29102] },
    { 10, &_elems[29113] },
    { 10, &_elems[29124] },
    { 10, &_elems[29135] },
    { 10, &_elems[29146] },
    { 10, &_elems[29157] },
    { 10, &_elems[29168] },
    { 10, &_elems[29179] },
    { 10, &_elems[29190] },
    { 10, &_elems[29201] },
    { 10, &_elems[29212] },
    { 8, &_elems[29223] },
    { 9, &_elems[29232] },
    { 9, &_elems[29242] },
    { 10, &_elems[29252] },
    { 11, &_elems[29263] },
    { 11, &_elems[29275] },
    { 11, &_elems[29287] },
    { 11, &_elems[29299] },
    { 11, &_elems[29311] },
    { 11, &_elems[29323] },
    { 11, &_elems[29335] },
    { 8, &_elems[29347] },
    { 9, &_elems[29356] },
    { 10, &_elems[29366] },
    { 11, &_elems[29377] },
    { 11, &_elems[29389] },
    { 8, &_elems[29401] },
    { 9, &_elems[29410] },
    { 9, &_elems[29420] },
    { 9, &_elems[29430] },
    { 10, &_elems[29440] },
    { 11, &_elems[29451] },
    { 11, &_elems[29463] },
    { 11, &_elems[29475] },
    { 11, &_elems[29487] },
    { 11, &_elems[29499] },
    { 7, &_elems[29511] },
    { 8, &_elems[29519] },
    { 9, &_elems[29528] },
    { 10, &_elems[29538] },
    { 11, &_elems[29549] },
    { 11, &_elems[29561] },
    { 11, &_elems[29573] },
    { 11, &_elems[29585] },
    { 11, &_elems[29597] },
    { 11, &_elems[29609] },
    { 11, &_elems[29621] },
    { 11, &_elems[29633] },
    { 11, &_elems[29645] },
    { 8, &_elems[29657] },
    { 9, &_elems[29666] },
    { 10, &_elems[29676] },
    { 11, &_elems[29687] },
    { 11, &_elems[29699] },
    { 11, &_elems[29711] },
    { 11, &_elems[29723] },
    { 11, &_elems[29735] },
    { 11, &_elems[29747] },
    { 11, &_elems[29759] },
    { 11, &_elems[29771] },
    { 8, &_elems[29783] },
    { 9, &_elems[29792] },
    { 10, &_elems[29802] },
    { 11, &_elems[29813] },
    { 11, &_elems[29825] },
    { 11, &_elems[29837] },
    { 11, &_elems[29849] },
    { 11, &_elems[29861] },
    { 8, &_elems[29873] },
    { 9, &_elems[29882] },
    { 9, &_elems[29892] },
    { 9, &_elems[29902] },
    { 9, &_elems[29912] },
    { 9, &_elems[29922] },
    { 9, &_elems[29932] },
    { 9, &_elems[29942] },
    { 9, &_elems[29952] },
    { 9, &_elems[29962] },
    { 7, &_elems[29972] },
    { 8, &_elems[29980] },
    { 9, &_elems[29989] },
    { 10, &_elems[29999] },
    { 10, &_elems[30010] },
    { 10, &_elems[30021] },
    { 10, &_elems[30032] },
    { 10, &_elems[30043] },
    { 10, &_elems[30054] },
    { 10, &_elems[30065] },
    { 10, &_elems[30076] },
    { 10, &_elems[30087] },
    { 10, &_elems[30098] },
    { 10, &_elems[30109] },
    { 10, &_elems[30120] },
    { 10, &_elems[30131] },
    { 10, &_elems[30142] },
    { 10, &_elems[30153] },
    { 8, &_elems[30164] },
    { 9, &_elems[30173] },
    { 10, &_elems[30183] },
    { 10, &_elems[30194] },
    { 10, &_elems[30205] },
    { 10, &_elems[30216] },
    { 10, &_elems[30227] },
    { 8, &_elems[30238] },
    { 9, &_elems[30247] },
    { 10, &_elems[30257] },
    { 10, &_elems[30268] },
    { 9, &_elems[30279] },
    { 10, &_elems[30289] },
    { 10, &_elems[30300] },
    { 8, &_elems[30311] },
    { 8, &_elems[30320] },
    { 7, &_elems[30329] },
    { 8, &_elems[30337] },
    { 9, &_elems[30346] },
    { 10, &_elems[30356] },
    { 10, &_elems[30367] },
    { 10, &_elems[30378] },
    { 10, &_elems[30389] },
    { 10, &_elems[30400] },
    { 10, &_elems[30411] },
    { 10, &_elems[30422] },
    { 10, &_elems[30433] },
    { 10, &_elems[30444] },
    { 8, &_elems[30455] },
    { 9, &_elems[30464] },
    { 10, &_elems[30474] },
    { 10, &_elems[30485] },
    { 10, &_elems[30496] },
    { 10, &_elems[30507] },
    { 10, &_elems[30518] },
    { 10, &_elems[30529] },
    { 10, &_elems[30540] },
    { 10, &_elems[30551] },
    { 10, &_elems[30562] },
    { 10, &_elems[30573] },
    { 10, &_elems[30584] },
    { 10, &_elems[30595] },
    { 10, &_elems[30606] },
    { 10, &_elems[30617] },
    { 10, &_elems[30628] },
    { 10, &_elems[30639] },
    { 10, &_elems[30650] },
    { 10, &_elems[30661] },
    { 10, &_elems[30672] },
    { 10, &_elems[30683] },
    { 10, &_elems[30694] },
    { 10, &_elems[30705] },
    { 10, &_elems[30716] },
    { 10, &_elems[30727] },
    { 10, &_elems[30738] },
    { 8, &_elems[30749] },
    { 9, &_elems[30758] },
    { 10, &_elems[30768] },
    { 8, &_elems[30779] },
    { 9, &_elems[30788] },
    { 10, &_elems[30798] },
    { 10, &_elems[30809] },
    { 9, &_elems[30820] },
    { 10, &_elems[30830] },
    { 10, &_elems[30841] },
    { 7, &_elems[30852] },
    { 8, &_elems[30860] },
    { 9, &_elems[30869] },
    { 10, &_elems[30879] },
    { 10, &_elems[30890] },
    { 10, &_elems[30901] },
    { 10, &_elems[30912] },
    { 10, &_elems[30923] },
    { 10, &_elems[30934] },
    { 10, &_elems[30945] },
    { 10, &_elems[30956] },
    { 10, &_elems[30967] },
    { 10, &_elems[30978] },
    { 10, &_elems[30989] },
    { 10, &_elems[31000] },
    { 10, &_elems[31011] },
    { 10, &_elems[31022] },
    { 10, &_elems[31033] },
    { 10, &_elems[31044] },
    { 10, &_elems[31055] },
    { 10, &_elems[31066] },
    { 10, &_elems[31077] },
    { 10, &_elems[31088] },
    { 8, &_elems[31099] },
    { 9, &_elems[31108] },
    { 10, &_elems[31118] },
    { 10, &_elems[31129] },
    { 10, &_elems[31140] },
    { 10, &_elems[31151] },
    { 10, &_elems[31162] },
    { 8, &_elems[31173] },
    { 9, &_elems[31182] },
    { 10, &_elems[31192] },
    { 10, &_elems[31203] },
    { 10, &_elems[31214] },
    { 10, &_elems[31225] },
    { 10, &_elems[31236] },
    { 10, &_elems[31247] },
    { 10, &_elems[31258] },
    { 10, &_elems[31269] },
    { 8, &_elems[31280] },
    { 9, &_elems[31289] },
    { 10, &_elems[31299] },
    { 10, &_elems[31310] },
    { 10, &_elems[31321] },
    { 9, &_elems[31332] },
    { 10, &_elems[31342] },
    { 10, &_elems[31353] },
    { 10, &_elems[31364] },
    { 5, &_elems[31375] },
    { 6, &_elems[31381] },
    { 7, &_elems[31388] },
    { 8, &_elems[31396] },
    { 8, &_elems[31405] },
    { 8, &_elems[31414] },
    { 8, &_elems[31423] },
    { 8, &_elems[31432] },
    { 8, &_elems[31441] },
    { 8, &_elems[31450] },
    { 8, &_elems[31459] },
    { 8, &_elems[31468] },
    { 8, &_elems[31477] },
    { 8, &_elems[31486] },
    { 8, &_elems[31495] },
    { 8, &_elems[31504] },
    { 8, &_elems[31513] },
    { 8, &_elems[31522] },
    { 8, &_elems[31531] },
    { 8, &_elems[31540] },
    { 8, &_elems[31549] },
    { 8, &_elems[31558] },
    { 8, &_elems[31567] },
    { 8, &_elems[31576] },
    { 9, &_elems[31585] },
    { 10, &_elems[31595] },
    { 10, &_elems[31606] },
    { 10, &_elems[31617] },
    { 8, &_elems[31628] },
    { 9, &_elems[31637] },
    { 10, &_elems[31647] },
    { 10, &_elems[31658] },
    { 10, &_elems[31669] },
    { 10, &_elems[31680] },
    { 10, &_elems[31691] },
    { 10, &_elems[31702] },
    { 10, &_elems[31713] },
    { 10, &_elems[31724] },
    { 10, &_elems[31735] },
    { 10, &_elems[31746] },
    { 10, &_elems[31757] },
    { 10, &_elems[31768] },
    { 8, &_elems[31779] },
    { 9, &_elems[31788] },
    { 10, &_elems[31798] },
    { 10, &_elems[31809] },
    { 10, &_elems[31820] },
    { 10, &_elems[31831] },
    { 10, &_elems[31842] },
    { 10, &_elems[31853] },
    { 8, &_elems[31864] },
    { 9, &_elems[31873] },
    { 10, &_elems[31883] },
    { 10, &_elems[31894] },
    { 10, &_elems[31905] },
    { 10, &_elems[31916] },
    { 10, &_elems[31927] },
    { 10, &_elems[31938] },
    { 8, &_elems[31949] },
    { 8, &_elems[31958] },
    { 8, &_elems[31967] },
    { 7, &_elems[31976] },
    { 8, &_elems[31984] },
    { 8, &_elems[31993] },
    { 8, &_elems[32002] },
    { 8, &_elems[32011] },
    { 8, &_elems[32020] },
    { 8, &_elems[32029] },
    { 8, &_elems[32038] },
    { 8, &_elems[32047] },
    { 8, &_elems[32056] },
    { 8, &_elems[32065] },
    { 8, &_elems[32074] },
    { 8, &_elems[32083] },
    { 8, &_elems[32092] },
    { 8, &_elems[32101] },
    { 8, &_elems[32110] },
    { 8, &_elems[32119] },
    { 8, &_elems[32128] },
    { 8, &_elems[32137] },
    { 8, &_elems[32146] },
    { 8, &_elems[32155] },
    { 8, &_elems[32164] },
    { 8, &_elems[32173] },
    { 8, &_elems[32182] },
    { 8, &_elems[32191] },
    { 8, &_elems[32200] },
    { 8, &_elems[32209] },
    { 8, &_elems[32218] },
    { 8, &_elems[32227] },
    { 8, &_elems[32236] },
    { 8, &_elems[32245] },
    { 8, &_elems[32254] },
    { 8, &_elems[32263] },
    { 8, &_elems[32272] },
    { 8, &_elems[32281] },
    { 8, &_elems[32290] },
    { 8, &_elems[32299] },
    { 8, &_elems[32308] },
    { 8, &_elems[32317] },
    { 8, &_elems[32326] },
    { 8, &_elems[32335] },
    { 8, &_elems[32344] },
    { 8, &_elems[32353] },
    { 8, &_elems[32362] },
    { 8, &_elems[32371] },
    { 8, &_elems[32380] },
    { 8, &_elems[32389] },
    { 7, &_elems[32398] },
    { 7, &_elems[32406] },
    { 8, &_elems[32414] },
    { 8, &_elems[32423] },
    { 8, &_elems[32432] },
    { 8, &_elems[32441] },
    { 8, &_elems[32450] },
    { 8, &_elems[32459] },
    { 5, &_elems[32468] },
    { 6, &_elems[32474] },
    { 7, &_elems[32481] },
    { 8, &_elems[32489] },
    { 9, &_elems[32498] },
    { 11, &_elems[32508] },
    { 9, &_elems[32520] },
    { 9, &_elems[32530] },
    { 10, &_elems[32540] },
    { 11, &_elems[32551] },
    { 9, &_elems[32563] },
    { 10, &_elems[32573] },
    { 11, &_elems[32584] },
    { 9, &_elems[32596] },
    { 10, &_elems[32606] },
    { 11, &_elems[32617] },
    { 11, &_elems[32629] },
    { 11, &_elems[32641] },
    { 8, &_elems[32653] },
    { 9, &_elems[32662] },
    { 9, &_elems[32672] },
    { 9, &_elems[32682] },
    { 9, &_elems[32692] },
    { 9, &_elems[32702] },
    { 9, &_elems[32712] },
    { 9, &_elems[32722] },
    { 9, &_elems[32732] },
    { 10, &_elems[32742] },
    { 11, &_elems[32753] },
    { 11, &_elems[32765] },
    { 11, &_elems[32777] },
    { 9, &_elems[32789] },
    { 9, &_elems[32799] },
    { 9, &_elems[32809] },
    { 9, &_elems[32819] },
    { 8, &_elems[32829] },
    { 9, &_elems[32838] },
    { 10, &_elems[32848] },
    { 8, &_elems[32859] },
    { 9, &_elems[32868] },
    { 9, &_elems[32878] },
    { 10, &_elems[32888] },
    { 11, &_elems[32899] },
    { 11, &_elems[32911] },
    { 9, &_elems[32923] },
    { 10, &_elems[32933] },
    { 11, &_elems[32944] },
    { 11, &_elems[32956] },
    { 11, &_elems[32968] },
    { 11, &_elems[32980] },
    { 9, &_elems[32992] },
    { 10, &_elems[33002] },
    { 11, &_elems[33013] },
    { 11, &_elems[33025] },
    { 11, &_elems[33037] },
    { 9, &_elems[33049] },
    { 9, &_elems[33059] },
    { 9, &_elems[33069] },
    { 9, &_elems[33079] },
    { 9, &_elems[33089] },
    { 9, &_elems[33099] },
    { 10, &_elems[33109] },
    { 11, &_elems[33120] },
    { 11, &_elems[33132] },
    { 11, &_elems[33144] },
    { 8, &_elems[33156] },
    { 9, &_elems[33165] },
    { 10, &_elems[33175] },
    { 11, &_elems[33186] },
    { 11, &_elems[33198] },
    { 11, &_elems[33210] },
    { 11, &_elems[33222] },
    { 11, &_elems[33234] },
    { 11, &_elems[33246] },
    { 9, &_elems[33258] },
    { 10, &_elems[33268] },
    { 11, &_elems[33279] },
    { 11, &_elems[33291] },
    { 11, &_elems[33303] },
    { 11, &_elems[33315] },
    { 11, &_elems[33327] },
    { 11, &_elems[33339] },
    { 8, &_elems[33351] },
    { 9, &_elems[33360] },
    { 10, &_elems[33370] },
    { 11, &_elems[33381] },
    { 11, &_elems[33393] },
    { 11, &_elems[33405] },
    { 11, &_elems[33417] },
    { 11, &_elems[33429] },
    { 11, &_elems[33441] },
    { 11, &_elems[33453] },
    { 11, &_elems[33465] },
    { 11, &_elems[33477] },
    { 11, &_elems[33489] },
    { 9, &_elems[33501] },
    { 10, &_elems[33511] },
    { 11, &_elems[33522] },
    { 11, &_elems[33534] },
    { 11, &_elems[33546] },
    { 11, &_elems[33558] },
    { 9, &_elems[33570] },
    { 10, &_elems[33580] },
    { 11, &_elems[33591] },
    { 9, &_elems[33603] },
    { 9, &_elems[33613] },
    { 10, &_elems[33623] },
    { 11, &_elems[33634] },
    { 8, &_elems[33646] },
    { 9, &_elems[33655] },
    { 10, &_elems[33665] },
    { 11, &_elems[33676] },
    { 11, &_elems[33688] },
    { 11, &_elems[33700] },
    { 11, &_elems[33712] },
    { 11, &_elems[33724] },
    { 11, &_elems[33736] },
    { 11, &_elems[33748] },
    { 11, &_elems[33760] },
    { 11, &_elems[33772] },
    { 11, &_elems[33784] },
    { 11, &_elems[33796] },
    { 5, &_elems[33808] },
    { 5, &_elems[33814] },
    { 6, &_elems[33820] },
    { 7, &_elems[33827] },
    { 7, &_elems[33835] },
    { 7, &_elems[33843] },
    { 7, &_elems[33851] },
    { 7, &_elems[33859] },
    { 6, &_elems[33867] },
    { 7, &_elems[33874] },
    { 8, &_elems[33882] },
    { 8, &_elems[33891] },
    { 6, &_elems[33900] },
    { 7, &_elems[33907] },
    { 8, &_elems[33915] },
    { 9, &_elems[33924] },
    { 10, &_elems[33934] },
    { 10, &_elems[33945] },
    { 10, &_elems[33956] },
    { 10, &_elems[33967] },
    { 10, &_elems[33978] },
    { 10, &_elems[33989] },
    { 10, &_elems[34000] },
    { 10, &_elems[34011] },
    { 10, &_elems[34022] },
    { 10, &_elems[34033] },
    { 10, &_elems[34044] },
    { 10, &_elems[34055] },
    { 9, &_elems[34066] },
    { 10, &_elems[34076] },
    { 10, &_elems[34087] },
    { 9, &_elems[34098] },
    { 10, &_elems[34108] },
    { 10, &_elems[34119] },
    { 11, &_elems[34130] },
    { 12, &_elems[34142] },
    { 12, &_elems[34155] },
    { 12, &_elems[34168] },
    { 9, &_elems[34181] },
    { 10, &_elems[34191] },
    { 10, &_elems[34202] },
    { 11, &_elems[34213] },
    { 12, &_elems[34225] },
    { 10, &_elems[34238] },
    { 10, &_elems[34249] },
    { 9, &_elems[34260] },
    { 10, &_elems[34270] },
    { 10, &_elems[34281] },
    { 10, &_elems[34292] },
    { 10, &_elems[34303] },
    { 10, &_elems[34314] },
    { 10, &_elems[34325] },
    { 9, &_elems[34336] },
    { 10, &_elems[34346] },
    { 8, &_elems[34357] },
    { 9, &_elems[34366] },
    { 10, &_elems[34376] },
    { 9, &_elems[34387] },
    { 10, &_elems[34397] },
    { 10, &_elems[34408] },
    { 10, &_elems[34419] },
    { 10, &_elems[34430] },
    { 10, &_elems[34441] },
    { 7, &_elems[34452] },
    { 8, &_elems[34460] },
    { 9, &_elems[34469] },
    { 10, &_elems[34479] },
    { 10, &_elems[34490] },
    { 11, &_elems[34501] },
    { 12, &_elems[34513] },
    { 12, &_elems[34526] },
    { 12, &_elems[34539] },
    { 12, &_elems[34552] },
    { 12, &_elems[34565] },
    { 12, &_elems[34578] },
    { 12, &_elems[34591] },
    { 12, &_elems[34604] },
    { 12, &_elems[34617] },
    { 12, &_elems[34630] },
    { 12, &_elems[34643] },
    { 12, &_elems[34656] },
    { 10, &_elems[34669] },
    { 11, &_elems[34680] },
    { 11, &_elems[34692] },
    { 11, &_elems[34704] },
    { 9, &_elems[34716] },
    { 10, &_elems[34726] },
    { 10, &_elems[34737] },
    { 11, &_elems[34748] },
    { 12, &_elems[34760] },
    { 12, &_elems[34773] },
    { 12, &_elems[34786] },
    { 12, &_elems[34799] },
    { 12, &_elems[34812] },
    { 12, &_elems[34825] },
    { 10, &_elems[34838] },
    { 10, &_elems[34849] },
    { 10, &_elems[34860] },
    { 11, &_elems[34871] },
    { 12, &_elems[34883] },
    { 12, &_elems[34896] },
    { 12, &_elems[34909] },
    { 12, &_elems[34922] },
    { 8, &_elems[34935] },
    { 9, &_elems[34944] },
    { 10, &_elems[34954] },
    { 9, &_elems[34965] },
    { 10, &_elems[34975] },
    { 10, &_elems[34986] },
    { 7, &_elems[34997] },
    { 8, &_elems[35005] },
    { 9, &_elems[35014] },
    { 10, &_elems[35024] },
    { 10, &_elems[35035] },
    { 10, &_elems[35046] },
    { 10, &_elems[35057] },
    { 9, &_elems[35068] },
    { 10, &_elems[35078] },
    { 10, &_elems[35089] },
    { 10, &_elems[35100] },
    { 9, &_elems[35111] },
    { 9, &_elems[35121] },
    { 8, &_elems[35131] },
    { 9, &_elems[35140] },
    { 10, &_elems[35150] },
    { 11, &_elems[35161] },
    { 12, &_elems[35173] },
    { 12, &_elems[35186] },
    { 12, &_elems[35199] },
    { 12, &_elems[35212] },
    { 12, &_elems[35225] },
    { 12, &_elems[35238] },
    { 12, &_elems[35251] },
    { 12, &_elems[35264] },
    { 12, &_elems[35277] },
    { 12, &_elems[35290] },
    { 12, &_elems[35303] },
    { 12, &_elems[35316] },
    { 12, &_elems[35329] },
    { 12, &_elems[35342] },
    { 12, &_elems[35355] },
    { 12, &_elems[35368] },
    { 12, &_elems[35381] },
    { 9, &_elems[35394] },
    { 10, &_elems[35404] },
    { 11, &_elems[35415] },
    { 12, &_elems[35427] },
    { 12, &_elems[35440] },
    { 12, &_elems[35453] },
    { 12, &_elems[35466] },
    { 12, &_elems[35479] },
    { 12, &_elems[35492] },
    { 12, &_elems[35505] },
    { 12, &_elems[35518] },
    { 12, &_elems[35531] },
    { 12, &_elems[35544] },
    { 12, &_elems[35557] },
    { 9, &_elems[35570] },
    { 10, &_elems[35580] },
    { 11, &_elems[35591] },
    { 12, &_elems[35603] },
    { 12, &_elems[35616] },
    { 12, &_elems[35629] },
    { 12, &_elems[35642] },
    { 12, &_elems[35655] },
    { 12, &_elems[35668] },
    { 9, &_elems[35681] },
    { 10, &_elems[35691] },
    { 11, &_elems[35702] },
    { 12, &_elems[35714] },
    { 12, &_elems[35727] },
    { 12, &_elems[35740] },
    { 12, &_elems[35753] },
    { 12, &_elems[35766] },
    { 12, &_elems[35779] },
    { 8, &_elems[35792] },
    { 9, &_elems[35801] },
    { 10, &_elems[35811] },
    { 10, &_elems[35822] },
    { 10, &_elems[35833] },
    { 10, &_elems[35844] },
    { 9, &_elems[35855] },
    { 10, &_elems[35865] },
    { 1, &_elems[35876] },
    { 2, &_elems[35878] },
    { 3, &_elems[35881] },
    { 4, &_elems[35885] },
    { 5, &_elems[35890] },
    { 6, &_elems[35896] },
    { 7, &_elems[35903] },
    { 7, &_elems[35911] },
    { 7, &_elems[35919] },
    { 7, &_elems[35927] },
    { 8, &_elems[35935] },
    { 9, &_elems[35944] },
    { 7, &_elems[35954] },
};

static struct enum_syntax _enums[] = {
    { &_enums[1], "false", 2 },
    { NULL, "true", 1 },
    { &_enums[3], "destroy", 6 },
    { &_enums[4], "createAndWait", 5 },
    { &_enums[5], "createAndGo", 4 },
    { &_enums[6], "notReady", 3 },
    { &_enums[7], "notInService", 2 },
    { NULL, "active", 1 },
    { &_enums[9], "permanent", 4 },
    { &_enums[10], "nonVolatile", 3 },
    { &_enums[11], "volatile", 2 },
    { NULL, "other", 1 },
    { &_enums[13], "excluded", 2 },
    { NULL, "included", 1 },
    { &_enums[15], "deltaValue", 2 },
    { NULL, "absoluteValue", 1 },
    { &_enums[17], "risingOrFallingAlarm", 3 },
    { &_enums[18], "fallingAlarm", 2 },
    { NULL, "risingAlarm", 1 },
    { &_enums[20], "frame-relay", 32 },
    { &_enums[21], "sip", 31 },
    { &_enums[22], "ds3", 30 },
    { &_enums[23], "ultra", 29 },
    { &_enums[24], "slip", 28 },
    { &_enums[25], "nsip", 27 },
    { &_enums[26], "ethernet-3Mbit", 26 },
    { &_enums[27], "eon", 25 },
    { &_enums[28], "softwareLoopback", 24 },
    { &_enums[29], "ppp", 23 },
    { &_enums[30], "propPointToPointSerial", 22 },
    { &_enums[31], "primaryISDN", 21 },
    { &_enums[32], "basicISDN", 20 },
    { &_enums[33], "e1", 19 },
    { &_enums[34], "ds1", 18 },
    { &_enums[35], "sdlc", 17 },
    { &_enums[36], "lapb", 16 },
    { &_enums[37], "fddi", 15 },
    { &_enums[38], "hyperchannel", 14 },
    { &_enums[39], "proteon-80Mbit", 13 },
    { &_enums[40], "proteon-10Mbit", 12 },
    { &_enums[41], "starLan", 11 },
    { &_enums[42], "iso88026-man", 10 },
    { &_enums[43], "iso88025-tokenRing", 9 },
    { &_enums[44], "iso88024-tokenBus", 8 },
    { &_enums[45], "iso88023-csmacd", 7 },
    { &_enums[46], "ethernet-csmacd", 6 },
    { &_enums[47], "rfc877-x25", 5 },
    { &_enums[48], "ddn-x25", 4 },
    { &_enums[49], "hdh1822", 3 },
    { &_enums[50], "regular1822", 2 },
    { NULL, "other", 1 },
    { &_enums[52], "testing", 3 },
    { &_enums[53], "down", 2 },
    { NULL, "up", 1 },
    { &_enums[55], "not-forwarding", 2 },
    { NULL, "forwarding", 1 },
    { &_enums[57], "indirect", 4 },
    { &_enums[58], "direct", 3 },
    { &_enums[59], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[61], "bgp", 14 },
    { &_enums[62], "ospf", 13 },
    { &_enums[63], "bbnSpfIgp", 12 },
    { &_enums[64], "ciscoIgrp", 11 },
    { &_enums[65], "es-is", 10 },
    { &_enums[66], "is-is", 9 },
    { &_enums[67], "rip", 8 },
    { &_enums[68], "hello", 7 },
    { &_enums[69], "ggp", 6 },
    { &_enums[70], "egp", 5 },
    { &_enums[71], "icmp", 4 },
    { &_enums[72], "netmgmt", 3 },
    { &_enums[73], "local", 2 },
    { NULL, "other", 1 },
    { &_enums[75], "static", 4 },
    { &_enums[76], "dynamic", 3 },
    { &_enums[77], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[79], "vanj", 4 },
    { &_enums[80], "rsre", 3 },
    { &_enums[81], "constant", 2 },
    { NULL, "other", 1 },
    { &_enums[83], "deleteTCB", 12 },
    { &_enums[84], "timeWait", 11 },
    { &_enums[85], "closing", 10 },
    { &_enums[86], "lastAck", 9 },
    { &_enums[87], "closeWait", 8 },
    { &_enums[88], "finWait2", 7 },
    { &_enums[89], "finWait1", 6 },
    { &_enums[90], "established", 5 },
    { &_enums[91], "synReceived", 4 },
    { &_enums[92], "synSent", 3 },
    { &_enums[93], "listen", 2 },
    { NULL, "closed", 1 },
    { &_enums[95], "cease", 5 },
    { &_enums[96], "up", 4 },
    { &_enums[97], "down", 3 },
    { &_enums[98], "acquisition", 2 },
    { NULL, "idle", 1 },
    { &_enums[100], "passive", 2 },
    { NULL, "active", 1 },
    { &_enums[102], "stop", 2 },
    { NULL, "start", 1 },
    { &_enums[104], "disabled", 2 },
    { NULL, "enabled", 1 },
    { &_enums[106], "remote", 4 },
    { &_enums[107], "local", 3 },
    { &_enums[108], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[110], "idpr", 15 },
    { &_enums[111], "bgp", 14 },
    { &_enums[112], "ospf", 13 },
    { &_enums[113], "bbnSpfIgp", 12 },
    { &_enums[114], "ciscoIgrp", 11 },
    { &_enums[115], "es-is", 10 },
    { &_enums[116], "is-is", 9 },
    { &_enums[117], "rip", 8 },
    { &_enums[118], "hello", 7 },
    { &_enums[119], "ggp", 6 },
    { &_enums[120], "egp", 5 },
    { &_enums[121], "icmp", 4 },
    { &_enums[122], "netmgmt", 3 },
    { &_enums[123], "local", 2 },
    { NULL, "other", 1 },
    { &_enums[125], "failed", 7 },
    { &_enums[126], "aborted", 6 },
    { &_enums[127], "unAbleToRun", 5 },
    { &_enums[128], "notSupported", 4 },
    { &_enums[129], "inProgress", 3 },
    { &_enums[130], "success", 2 },
    { NULL, "none", 1 },
    { &_enums[132], "nonVolatile", 4 },
    { &_enums[133], "volatile", 3 },
    { &_enums[134], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[136], "virtual", 9 },
    { &_enums[137], "serial-nonstandard", 8 },
    { &_enums[138], "serial-ppp", 7 },
    { &_enums[139], "iptalk", 6 },
    { &_enums[140], "tokentalk", 5 },
    { &_enums[141], "ethertalk2", 4 },
    { &_enums[142], "ethertalk1", 3 },
    { &_enums[143], "localtalk", 2 },
    { NULL, "other", 1 },
    { &_enums[145], "invalid", 4 },
    { &_enums[146], "off", 3 },
    { &_enums[147], "unconfigured", 2 },
    { NULL, "operational", 1 },
    { &_enums[149], "unconfigured", 4 },
    { &_enums[150], "guessed", 3 },
    { &_enums[151], "garnered", 2 },
    { NULL, "configured", 1 },
    { &_enums[153], "serial-nonstandard", 4 },
    { &_enums[154], "serial-ppp", 3 },
    { &_enums[155], "appletalk", 2 },
    { NULL, "other", 1 },
    { &_enums[157], "bad", 4 },
    { &_enums[158], "goingBad", 3 },
    { &_enums[159], "suspect", 2 },
    { NULL, "good", 1 },
    { &_enums[161], "notcore", 2 },
    { NULL, "core", 1 },
    { &_enums[163], "other", 4 },
    { &_enums[164], "host", 3 },
    { &_enums[165], "net", 2 },
    { NULL, "kipRouter", 1 },
    { &_enums[167], "invalid", 3 },
    { &_enums[168], "learned", 2 },
    { NULL, "configured", 1 },
    { &_enums[170], "private", 2 },
    { NULL, "shared", 1 },
    { &_enums[172], "invalid", 2 },
    { NULL, "valid", 1 },
    { NULL, "version2", 2 },
    { &_enums[175], "asExternalLink", 5 },
    { &_enums[176], "asSummaryLink", 4 },
    { &_enums[177], "summaryLink", 3 },
    { &_enums[178], "networkLink", 2 },
    { NULL, "routerLink", 1 },
    { &_enums[180], "pointToPoint", 3 },
    { &_enums[181], "nbma", 2 },
    { NULL, "broadcast", 1 },
    { &_enums[183], "otherDesignatedRouter", 7 },
    { &_enums[184], "backupDesignatedRouter", 6 },
    { &_enums[185], "designatedRouter", 5 },
    { &_enums[186], "pointToPoint", 4 },
    { &_enums[187], "waiting", 3 },
    { &_enums[188], "loopback", 2 },
    { NULL, "down", 1 },
    { &_enums[190], "pointToPoint", 4 },
    { NULL, "down", 1 },
    { &_enums[192], "full", 8 },
    { &_enums[193], "loading", 7 },
    { &_enums[194], "exchange", 6 },
    { &_enums[195], "exchangeStart", 5 },
    { &_enums[196], "twoWay", 4 },
    { &_enums[197], "init", 3 },
    { &_enums[198], "attempt", 2 },
    { NULL, "down", 1 },
    { &_enums[200], "established", 6 },
    { &_enums[201], "openconfirm", 5 },
    { &_enums[202], "opensent", 4 },
    { &_enums[203], "active", 3 },
    { &_enums[204], "connect", 2 },
    { NULL, "idle", 1 },
    { &_enums[206], "incomplete", 3 },
    { &_enums[207], "egp", 2 },
    { NULL, "igp", 1 },
    { &_enums[209], "invalid", 4 },
    { &_enums[210], "underCreation", 3 },
    { &_enums[211], "createRequest", 2 },
    { NULL, "valid", 1 },
    { &_enums[213], "hostTopNOutMulticastPkts", 7 },
    { &_enums[214], "hostTopNOutBroadcastPkts", 6 },
    { &_enums[215], "hostTopNOutErrors", 5 },
    { &_enums[216], "hostTopNOutOctets", 4 },
    { &_enums[217], "hostTopNInOctets", 3 },
    { &_enums[218], "hostTopNOutPkts", 2 },
    { NULL, "hostTopNInPkts", 1 },
    { &_enums[220], "acceptFailed", 2 },
    { NULL, "acceptMatched", 1 },
    { &_enums[222], "off", 2 },
    { NULL, "on", 1 },
    { &_enums[224], "eventAlwaysReady", 3 },
    { &_enums[225], "eventFired", 2 },
    { NULL, "eventReady", 1 },
    { &_enums[227], "full", 2 },
    { NULL, "spaceAvailable", 1 },
    { &_enums[229], "wrapWhenFull", 2 },
    { NULL, "lockWhenFull", 1 },
    { &_enums[231], "log-and-trap", 4 },
    { &_enums[232], "snmp-trap", 3 },
    { &_enums[233], "log", 2 },
    { NULL, "none", 1 },
    { &_enums[235], "beaconSetRecoveryModeState", 7 },
    { &_enums[236], "beaconRingSignalLossState", 6 },
    { &_enums[237], "beaconBitStreamingState", 5 },
    { &_enums[238], "beaconFrameStreamingState", 4 },
    { &_enums[239], "claimTokenState", 3 },
    { &_enums[240], "ringPurgeState", 2 },
    { NULL, "normalOperation", 1 },
    { &_enums[242], "forcedRemoval", 3 },
    { &_enums[243], "inactive", 2 },
    { NULL, "active", 1 },
    { &_enums[245], "removing", 2 },
    { NULL, "stable", 1 },
    { &_enums[247], "updating", 2 },
    { NULL, "stable", 1 },
    { &_enums[249], "srt", 4 },
    { &_enums[250], "sourceroute-only", 3 },
    { &_enums[251], "transparent-only", 2 },
    { NULL, "unknown", 1 },
    { &_enums[253], "ieee8021d", 3 },
    { &_enums[254], "decLb100", 2 },
    { NULL, "unknown", 1 },
    { &_enums[256], "broken", 6 },
    { &_enums[257], "forwarding", 5 },
    { &_enums[258], "learning", 4 },
    { &_enums[259], "listening", 3 },
    { &_enums[260], "blocking", 2 },
    { NULL, "disabled", 1 },
    { &_enums[262], "mgmt", 5 },
    { &_enums[263], "self", 4 },
    { &_enums[264], "learned", 3 },
    { &_enums[265], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[267], "deleteOnTimeout", 5 },
    { &_enums[268], "deleteOnReset", 4 },
    { &_enums[269], "permanent", 3 },
    { &_enums[270], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[272], "forced", 3 },
    { &_enums[273], "disabled", 2 },
    { NULL, "auto-span", 1 },
    { &_enums[275], "mode6", 2 },
    { NULL, "mode3", 1 },
    { &_enums[277], "invalid", 3 },
    { &_enums[278], "disabled", 2 },
    { NULL, "enabled", 1 },
    { &_enums[280], "restricted", 4 },
    { &_enums[281], "shut", 3 },
    { &_enums[282], "off", 2 },
    { NULL, "on", 1 },
    { &_enums[284], "reset", 2 },
    { NULL, "other", 1 },
    { &_enums[286], "nonrouting-IV", 5 },
    { &_enums[287], "routing-IV", 4 },
    { &_enums[288], "area", 3 },
    { &_enums[289], "nonrouting-III", 2 },
    { NULL, "routing-III", 1 },
    { &_enums[291], "cleared", 4 },
    { &_enums[292], "service", 3 },
    { &_enums[293], "off", 2 },
    { NULL, "on", 1 },
    { &_enums[295], "running", 13 },
    { &_enums[296], "failed", 12 },
    { &_enums[297], "synchronizing", 11 },
    { &_enums[298], "autotriggering", 10 },
    { &_enums[299], "autodumping", 9 },
    { &_enums[300], "autoloading", 8 },
    { &_enums[301], "autoservice", 7 },
    { &_enums[302], "triggering", 6 },
    { &_enums[303], "dumping", 5 },
    { &_enums[304], "loading", 4 },
    { &_enums[305], "looping", 3 },
    { &_enums[306], "reflecting", 2 },
    { NULL, "starting", 1 },
    { &_enums[308], "fddi", 15 },
    { &_enums[309], "other", 14 },
    { &_enums[310], "bisync", 9 },
    { &_enums[311], "qp2-dte20", 8 },
    { &_enums[312], "ci", 7 },
    { &_enums[313], "ethernet", 6 },
    { &_enums[314], "ddcmp-dmc", 5 },
    { &_enums[315], "x25", 4 },
    { &_enums[316], "ddcmp-tributary", 3 },
    { &_enums[317], "ddcmp-control", 2 },
    { NULL, "ddcmp-point", 1 },
    { &_enums[319], "dead", 5 },
    { &_enums[320], "dying", 4 },
    { &_enums[321], "inactive", 3 },
    { &_enums[322], "active", 2 },
    { NULL, "automatic", 1 },
    { &_enums[324], "dead", 4 },
    { &_enums[325], "dying", 3 },
    { &_enums[326], "inactive", 2 },
    { NULL, "active", 1 },
    { &_enums[328], "halt", 10 },
    { &_enums[329], "off", 9 },
    { &_enums[330], "routing-layer-complete", 8 },
    { &_enums[331], "routing-layer-verify", 7 },
    { &_enums[332], "routing-layer-initialize", 6 },
    { &_enums[333], "data-link-start", 5 },
    { &_enums[334], "circuit-rejected", 4 },
    { &_enums[335], "run", 3 },
    { &_enums[336], "up", 2 },
    { NULL, "initializing", 1 },
    { &_enums[338], "running", 13 },
    { &_enums[339], "failed", 12 },
    { &_enums[340], "synchronizing", 11 },
    { &_enums[341], "auto-triggering", 10 },
    { &_enums[342], "auto-dumping", 9 },
    { &_enums[343], "auto-loading", 8 },
    { &_enums[344], "auto-service", 7 },
    { &_enums[345], "triggering", 6 },
    { &_enums[346], "dumping", 5 },
    { &_enums[347], "loading", 4 },
    { &_enums[348], "looping", 3 },
    { &_enums[349], "reflecting", 2 },
    { NULL, "starting", 1 },
    { &_enums[351], "other", 4 },
    { &_enums[352], "looping", 3 },
    { &_enums[353], "reflecting", 2 },
    { NULL, "starting", 1 },
    { &_enums[355], "fddi", 15 },
    { &_enums[356], "other", 14 },
    { &_enums[357], "qp2", 9 },
    { &_enums[358], "ci", 8 },
    { &_enums[359], "ethernet", 7 },
    { &_enums[360], "olapb", 6 },
    { &_enums[361], "ddcmp-dmc", 5 },
    { &_enums[362], "reserved", 4 },
    { &_enums[363], "ddcmp-tributary", 3 },
    { &_enums[364], "ddcmp-control", 2 },
    { NULL, "ddcmp-point", 1 },
    { &_enums[366], "other", 3 },
    { &_enums[367], "loopback", 2 },
    { NULL, "normal", 1 },
    { &_enums[369], "half", 2 },
    { NULL, "full", 1 },
    { &_enums[371], "other", 3 },
    { &_enums[372], "internal", 2 },
    { NULL, "external", 1 },
    { &_enums[374], "unreachable", 5 },
    { NULL, "reachable", 4 },
    { &_enums[376], "virtual", 2 },
    { NULL, "physical", 1 },
    { &_enums[378], "execute", 2 },
    { NULL, "ready", 1 },
    { &_enums[380], "maintenance", 4 },
    { &_enums[381], "off", 3 },
    { &_enums[382], "disabled", 2 },
    { NULL, "enabled", 1 },
    { &_enums[384], "active", 5 },
    { &_enums[385], "absent", 4 },
    { &_enums[386], "maintenance", 3 },
    { &_enums[387], "down", 2 },
    { NULL, "up", 1 },
    { &_enums[389], "dsrDtr", 5 },
    { &_enums[390], "ctsRts", 4 },
    { &_enums[391], "hardware", 3 },
    { &_enums[392], "xonXoff", 2 },
    { NULL, "none", 1 },
    { &_enums[394], "go", 4 },
    { &_enums[395], "stop", 3 },
    { &_enums[396], "unknown", 2 },
    { NULL, "none", 1 },
    { &_enums[398], "none", 4 },
    { &_enums[399], "local", 3 },
    { &_enums[400], "network", 2 },
    { NULL, "dynamic", 1 },
    { &_enums[402], "disconnecting", 3 },
    { &_enums[403], "connected", 2 },
    { NULL, "connecting", 1 },
    { &_enums[405], "local", 3 },
    { &_enums[406], "network", 2 },
    { NULL, "unknown", 1 },
    { &_enums[408], "generalFailure", 6 },
    { &_enums[409], "portFailure", 5 },
    { &_enums[410], "groupFailure", 4 },
    { &_enums[411], "rptrFailure", 3 },
    { &_enums[412], "ok", 2 },
    { NULL, "other", 1 },
    { &_enums[414], "reset", 2 },
    { NULL, "noReset", 1 },
    { &_enums[416], "selfTest", 2 },
    { NULL, "noSelfTest", 1 },
    { &_enums[418], "resetInProgress", 6 },
    { &_enums[419], "underTest", 5 },
    { &_enums[420], "notPresent", 4 },
    { &_enums[421], "malfunctioning", 3 },
    { &_enums[422], "operational", 2 },
    { NULL, "other", 1 },
    { &_enums[424], "autoPartitioned", 2 },
    { NULL, "notAutoPartitioned", 1 },
    { &_enums[426], "notPresent", 3 },
    { &_enums[427], "notOperational", 2 },
    { NULL, "operational", 1 },
    { &_enums[429], "simplePassword", 2 },
    { NULL, "noAuthentication", 1 },
    { &_enums[431], "ripVersion2", 4 },
    { &_enums[432], "rip1Compatible", 3 },
    { &_enums[433], "ripVersion1", 2 },
    { NULL, "doNotSend", 1 },
    { &_enums[435], "rip1OrRip2", 3 },
    { &_enums[436], "rip2", 2 },
    { NULL, "rip1", 1 },
    { &_enums[438], "unknownError", 2 },
    { NULL, "noError", 1 },
    { &_enums[440], "down", 5 },
    { &_enums[441], "testing", 4 },
    { &_enums[442], "warning", 3 },
    { &_enums[443], "running", 2 },
    { NULL, "unknown", 1 },
    { &_enums[445], "warmup", 5 },
    { &_enums[446], "printing", 4 },
    { &_enums[447], "idle", 3 },
    { &_enums[448], "unknown", 2 },
    { NULL, "other", 1 },
    { &_enums[450], "readOnly", 2 },
    { NULL, "readWrite", 1 },
    { &_enums[452], "ramDisk", 8 },
    { &_enums[453], "opticalDiskRW", 7 },
    { &_enums[454], "opticalDiskWORM", 6 },
    { &_enums[455], "opticalDiskROM", 5 },
    { &_enums[456], "floppyDisk", 4 },
    { &_enums[457], "hardDisk", 3 },
    { &_enums[458], "unknown", 2 },
    { NULL, "other", 1 },
    { &_enums[460], "application", 4 },
    { &_enums[461], "deviceDriver", 3 },
    { &_enums[462], "operatingSystem", 2 },
    { NULL, "unknown", 1 },
    { &_enums[464], "invalid", 4 },
    { &_enums[465], "notRunnable", 3 },
    { &_enums[466], "runnable", 2 },
    { NULL, "running", 1 },
    { &_enums[468], "reset", 6 },
    { &_enums[469], "shutdown", 5 },
    { &_enums[470], "standby", 4 },
    { &_enums[471], "operational", 3 },
    { &_enums[472], "unknown", 2 },
    { NULL, "other", 1 },
    { &_enums[474], "invalidSignal", 6 },
    { &_enums[475], "remoteFault", 5 },
    { &_enums[476], "notAvailable", 4 },
    { &_enums[477], "available", 3 },
    { &_enums[478], "unknown", 2 },
    { NULL, "other", 1 },
    { &_enums[480], "jabbering", 4 },
    { &_enums[481], "noJabber", 3 },
    { &_enums[482], "unknown", 2 },
    { NULL, "other", 1 },
    { &_enums[484], "dual", 3 },
    { &_enums[485], "single", 2 },
    { NULL, "other", 1 },
    { &_enums[487], "restarting", 5 },
    { &_enums[488], "congested", 4 },
    { &_enums[489], "halted", 3 },
    { &_enums[490], "down", 2 },
    { NULL, "up", 1 },
    { &_enums[492], "peer-responder", 4 },
    { &_enums[493], "peer-initiator", 3 },
    { &_enums[494], "ua-responder", 2 },
    { NULL, "ua-initiator", 1 },
    { &_enums[496], "dxe", 3 },
    { &_enums[497], "dce", 2 },
    { NULL, "dte", 1 },
    { &_enums[499], "modulo128", 2 },
    { NULL, "modulo8", 1 },
    { &_enums[501], "other", 10 },
    { &_enums[502], "startPvcResetting", 9 },
    { &_enums[503], "startClear", 8 },
    { &_enums[504], "pvcResetting", 7 },
    { &_enums[505], "pvc", 6 },
    { &_enums[506], "clearing", 5 },
    { &_enums[507], "open", 4 },
    { &_enums[508], "calling", 3 },
    { &_enums[509], "closed", 2 },
    { NULL, "invalid", 1 },
    { &_enums[511], "pvc", 3 },
    { &_enums[512], "outgoing", 2 },
    { NULL, "incoming", 1 },
    { &_enums[514], "neverAccept", 4 },
    { &_enums[515], "refuse", 3 },
    { &_enums[516], "accept", 2 },
    { NULL, "default", 1 },
    { &_enums[518], "local", 3 },
    { &_enums[519], "reverse", 2 },
    { NULL, "default", 1 },
    { &_enums[521], "noRestrictedFastResponse", 6 },
    { &_enums[522], "noFastSelect", 5 },
    { &_enums[523], "restrictedFastResponse", 4 },
    { &_enums[524], "fastSelect", 3 },
    { &_enums[525], "notSpecified", 2 },
    { NULL, "default", 1 },
    { &_enums[527], "tcDefault", 18 },
    { &_enums[528], "tcNone", 17 },
    { &_enums[529], "tcReserved0", 16 },
    { &_enums[530], "tcReserved15", 15 },
    { &_enums[531], "tcReserved14", 14 },
    { &_enums[532], "tc64000", 13 },
    { &_enums[533], "tc48000", 12 },
    { &_enums[534], "tc19200", 11 },
    { &_enums[535], "tc9600", 10 },
    { &_enums[536], "tc4800", 9 },
    { &_enums[537], "tc2400", 8 },
    { &_enums[538], "tc1200", 7 },
    { &_enums[539], "tc600", 6 },
    { &_enums[540], "tc300", 5 },
    { &_enums[541], "tc150", 4 },
    { &_enums[542], "tc75", 3 },
    { &_enums[543], "tcReserved2", 2 },
    { NULL, "tcReserved1", 1 },
    { &_enums[545], "chargingInfo", 4 },
    { &_enums[546], "noChargingInfo", 3 },
    { &_enums[547], "noFacility", 2 },
    { NULL, "default", 1 },
    { &_enums[549], "expeditedData", 3 },
    { &_enums[550], "noExpeditedData", 2 },
    { NULL, "default", 1 },
    { &_enums[552], "inRing", 5 },
    { &_enums[553], "enteringRing", 4 },
    { &_enums[554], "outOfRing", 3 },
    { &_enums[555], "offline", 2 },
    { NULL, "other", 1 },
    { &_enums[557], "initialize", 5 },
    { &_enums[558], "reset", 4 },
    { &_enums[559], "exitRing", 3 },
    { &_enums[560], "enterRing", 2 },
    { NULL, "no-op", 1 },
    { &_enums[562], "forty-eightBit", 2 },
    { NULL, "sixteenBit", 1 },
    { NULL, "rev2", 2 },
    { &_enums[565], "outOfRing", 2 },
    { NULL, "inRing", 1 },
    { &_enums[567], "close", 4 },
    { &_enums[568], "reset", 3 },
    { &_enums[569], "open", 2 },
    { NULL, "no-op", 1 },
    { &_enums[571], "ringFailure", 6 },
    { &_enums[572], "openFailure", 5 },
    { &_enums[573], "closing", 4 },
    { &_enums[574], "opening", 3 },
    { &_enums[575], "closed", 2 },
    { NULL, "opened", 1 },
    { &_enums[577], "open", 11 },
    { &_enums[578], "removeReceived", 10 },
    { &_enums[579], "requestFailed", 9 },
    { &_enums[580], "duplicateMAC", 8 },
    { &_enums[581], "beaconing", 7 },
    { &_enums[582], "ringFailed", 6 },
    { &_enums[583], "insertionTimeout", 5 },
    { &_enums[584], "signalLoss", 4 },
    { &_enums[585], "lobeFailed", 3 },
    { &_enums[586], "badParam", 2 },
    { NULL, "noOpen", 1 },
    { &_enums[588], "sixteenMegabit", 4 },
    { &_enums[589], "fourMegabit", 3 },
    { &_enums[590], "oneMegabit", 2 },
    { NULL, "unknown", 1 },
    { &_enums[592], "ec7", 8 },
    { &_enums[593], "ec6", 7 },
    { &_enums[594], "ec5", 6 },
    { &_enums[595], "ec4", 5 },
    { &_enums[596], "ec3", 4 },
    { &_enums[597], "ec2", 3 },
    { &_enums[598], "ec1", 2 },
    { NULL, "ec0", 1 },
    { &_enums[600], "cf5", 6 },
    { &_enums[601], "cf4", 5 },
    { &_enums[602], "cf3", 4 },
    { &_enums[603], "cf2", 3 },
    { &_enums[604], "cf1", 2 },
    { NULL, "cf0", 1 },
    { &_enums[606], "holding-sec", 4 },
    { &_enums[607], "holding-prm", 3 },
    { &_enums[608], "not-holding", 2 },
    { NULL, "not-implemented", 1 },
    { &_enums[610], "self-Test", 5 },
    { &_enums[611], "path-Test", 4 },
    { &_enums[612], "disconnect", 3 },
    { &_enums[613], "connect", 2 },
    { NULL, "other", 1 },
    { &_enums[615], "isolated", 16 },
    { &_enums[616], "local", 8 },
    { &_enums[617], "secondary", 4 },
    { &_enums[618], "primary", 2 },
    { NULL, "unknown", 1 },
    { &_enums[620], "fail", 3 },
    { &_enums[621], "pass", 2 },
    { NULL, "none", 1 },
    { &_enums[623], "unknown", 5 },
    { &_enums[624], "m", 4 },
    { &_enums[625], "s", 3 },
    { &_enums[626], "b", 2 },
    { NULL, "a", 1 },
    { &_enums[628], "rm7", 8 },
    { &_enums[629], "rm6", 7 },
    { &_enums[630], "rm5", 6 },
    { &_enums[631], "rm4", 5 },
    { &_enums[632], "rm3", 4 },
    { &_enums[633], "rm2", 3 },
    { &_enums[634], "rm1", 2 },
    { NULL, "rm0", 1 },
    { &_enums[636], "disconnectMAC", 5 },
    { &_enums[637], "connectMAC", 4 },
    { &_enums[638], "disableLLCService", 3 },
    { &_enums[639], "enableLLCService", 2 },
    { NULL, "other", 1 },
    { &_enums[641], "m", 4 },
    { &_enums[642], "s", 3 },
    { &_enums[643], "b", 2 },
    { NULL, "a", 1 },
    { &_enums[645], "ce4", 5 },
    { &_enums[646], "ce3", 4 },
    { &_enums[647], "ce2", 3 },
    { &_enums[648], "ce1", 2 },
    { NULL, "ce0", 1 },
    { &_enums[650], "active", 4 },
    { &_enums[651], "standby", 3 },
    { &_enums[652], "connecting", 2 },
    { NULL, "disabled", 1 },
    { &_enums[654], "pc9", 10 },
    { &_enums[655], "pc8", 9 },
    { &_enums[656], "pc7", 8 },
    { &_enums[657], "pc6", 7 },
    { &_enums[658], "pc5", 6 },
    { &_enums[659], "pc4", 5 },
    { &_enums[660], "pc3", 4 },
    { &_enums[661], "pc2", 3 },
    { &_enums[662], "pc1", 2 },
    { NULL, "pc0", 1 },
    { &_enums[664], "other", 3 },
    { &_enums[665], "m-m", 2 },
    { NULL, "none", 1 },
    { &_enums[667], "stopPORT", 6 },
    { &_enums[668], "startPORT", 5 },
    { &_enums[669], "disablePORT", 4 },
    { &_enums[670], "enablePORT", 3 },
    { &_enums[671], "maintPORT", 2 },
    { NULL, "other", 1 },
    { &_enums[673], "concentrator", 3 },
    { &_enums[674], "dual-attachment", 2 },
    { NULL, "single-attachment", 1 },
    { &_enums[676], "unimplemented", 3 },
    { &_enums[677], "false", 2 },
    { NULL, "true", 1 },
    { &_enums[679], "cf12", 13 },
    { &_enums[680], "cf11", 12 },
    { &_enums[681], "cf10", 11 },
    { &_enums[682], "cf9", 10 },
    { &_enums[683], "cf8", 9 },
    { &_enums[684], "cf7", 8 },
    { &_enums[685], "cf6", 7 },
    { &_enums[686], "cf5", 6 },
    { &_enums[687], "cf4", 5 },
    { &_enums[688], "cf3", 4 },
    { &_enums[689], "cf2", 3 },
    { &_enums[690], "cf1", 2 },
    { NULL, "cf0", 1 },
    { &_enums[692], "thru", 3 },
    { &_enums[693], "separated", 2 },
    { NULL, "concatenated", 1 },
    { &_enums[695], "disable-m", 8 },
    { &_enums[696], "disable-b", 7 },
    { &_enums[697], "disable-a", 6 },
    { &_enums[698], "self-Test", 5 },
    { &_enums[699], "path-Test", 4 },
    { &_enums[700], "disconnect", 3 },
    { &_enums[701], "connect", 2 },
    { NULL, "other", 1 },
    { &_enums[703], "thru", 6 },
    { &_enums[704], "concatenated", 5 },
    { &_enums[705], "primary", 4 },
    { &_enums[706], "secondary", 3 },
    { &_enums[707], "local", 2 },
    { NULL, "isolated", 1 },
    { &_enums[709], "none", 5 },
    { &_enums[710], "m", 4 },
    { &_enums[711], "s", 3 },
    { &_enums[712], "b", 2 },
    { NULL, "a", 1 },
    { &_enums[714], "port", 4 },
    { NULL, "mac", 2 },
    { &_enums[716], "tVal9TrueRVal9True", 4 },
    { &_enums[717], "tVal9TrueRVal9False", 3 },
    { &_enums[718], "tVal9FalseRVal9True", 2 },
    { NULL, "tVal9FalseRVal9False", 1 },
    { &_enums[720], "ce5", 6 },
    { &_enums[721], "ce4", 5 },
    { &_enums[722], "ce3", 4 },
    { &_enums[723], "ce2", 3 },
    { &_enums[724], "ce1", 2 },
    { NULL, "ce0", 1 },
    { &_enums[726], "unspecified", 8 },
    { &_enums[727], "unknown", 7 },
    { &_enums[728], "twisted-pair", 6 },
    { &_enums[729], "low-cost-fiber", 5 },
    { &_enums[730], "sonet", 4 },
    { &_enums[731], "single-mode2", 3 },
    { &_enums[732], "single-mode1", 2 },
    { NULL, "multimode", 1 },
    { &_enums[734], "pathnotavailable", 4 },
    { &_enums[735], "otherincompatible", 3 },
    { &_enums[736], "m-m", 2 },
    { NULL, "none", 1 },
    { &_enums[738], "other", 5 },
    { &_enums[739], "none", 4 },
    { &_enums[740], "sendDM", 3 },
    { &_enums[741], "sendDISC", 2 },
    { NULL, "sendSABM", 1 },
    { &_enums[743], "other", 3 },
    { &_enums[744], "sendDISC", 2 },
    { NULL, "sendSABM", 1 },
    { &_enums[746], "other", 13 },
    { &_enums[747], "n2Timeout", 12 },
    { &_enums[748], "frmrSent", 11 },
    { &_enums[749], "frmrReceived", 10 },
    { &_enums[750], "discSent", 9 },
    { &_enums[751], "discReceived", 8 },
    { &_enums[752], "dmSent", 7 },
    { &_enums[753], "dmReceived", 6 },
    { &_enums[754], "abmeReset", 5 },
    { &_enums[755], "abmReset", 4 },
    { &_enums[756], "abmeEntered", 3 },
    { &_enums[757], "abmEntered", 2 },
    { NULL, "notStarted", 1 },
    { &_enums[759], "other", 17 },
    { &_enums[760], "error", 16 },
    { &_enums[761], "xidFrameSent", 15 },
    { &_enums[762], "rejFrameSentRemoteBusy", 14 },
    { &_enums[763], "waitingAckBothBusy", 13 },
    { &_enums[764], "waitingAckRemoteBusy", 12 },
    { &_enums[765], "waitingAckStationBusy", 11 },
    { &_enums[766], "bothStationsBusy", 10 },
    { &_enums[767], "remoteStationBusy", 9 },
    { &_enums[768], "stationBusy", 8 },
    { &_enums[769], "waitingAcknowledgement", 7 },
    { &_enums[770], "rejFrameSent", 6 },
    { &_enums[771], "informationTransfer", 5 },
    { &_enums[772], "disconnectRequest", 4 },
    { &_enums[773], "frameReject", 3 },
    { &_enums[774], "linkSetup", 2 },
    { NULL, "disconnected", 1 },
    { &_enums[776], "dsx1E1-CRC-MF", 7 },
    { &_enums[777], "dsx1E1-MF", 6 },
    { &_enums[778], "dsx1E1-CRC", 5 },
    { &_enums[779], "dsx1E1", 4 },
    { &_enums[780], "dsx1D4", 3 },
    { &_enums[781], "dsx1ESF", 2 },
    { NULL, "other", 1 },
    { &_enums[783], "other", 6 },
    { &_enums[784], "dsx1AMI", 5 },
    { &_enums[785], "dsx1ZBTSI", 4 },
    { &_enums[786], "dsx1HDB3", 3 },
    { &_enums[787], "dsx1B8ZS", 2 },
    { NULL, "dsx1JBZS", 1 },
    { &_enums[789], "dsx1SendOtherTestPattern", 8 },
    { &_enums[790], "dsx1Send3in24Pattern", 7 },
    { &_enums[791], "dsx1Send511Pattern", 6 },
    { &_enums[792], "dsx1SendQRS", 5 },
    { &_enums[793], "dsx1SendResetCode", 4 },
    { &_enums[794], "dsx1SendPayloadCode", 3 },
    { &_enums[795], "dsx1SendLineCode", 2 },
    { NULL, "dsx1SendNoCode", 1 },
    { &_enums[797], "dsx1OtherLoop", 4 },
    { &_enums[798], "dsx1LineLoop", 3 },
    { &_enums[799], "dsx1PayloadLoop", 2 },
    { NULL, "dsx1NoLoop", 1 },
    { &_enums[801], "messageOriented", 4 },
    { &_enums[802], "bitOriented", 3 },
    { &_enums[803], "robbedBit", 2 },
    { NULL, "none", 1 },
    { &_enums[805], "throughTiming", 3 },
    { &_enums[806], "localTiming", 2 },
    { NULL, "loopTiming", 1 },
    { &_enums[808], "dsx1Fdl-none", 8 },
    { &_enums[809], "dsx1Att-54016", 4 },
    { &_enums[810], "dsx1Ansi-T1-403", 2 },
    { NULL, "other", 1 },
    { &_enums[812], "true", 2 },
    { NULL, "false", 1 },
    { &_enums[814], "not-determined", 3 },
    { &_enums[815], "bad", 2 },
    { NULL, "good", 1 },
    { &_enums[817], "enabled", 2 },
    { NULL, "disabled", 1 },
    { &_enums[819], "valid", 2 },
    { NULL, "invalid", 1 },
    { &_enums[821], "remote-to-local", 2 },
    { NULL, "local-to-remote", 1 },
    { &_enums[823], "not-opened", 2 },
    { NULL, "opened", 1 },
    { &_enums[825], "vj-tcp", 2 },
    { NULL, "none", 1 },
    { &_enums[827], "close", 2 },
    { NULL, "open", 1 },
    { &_enums[829], "dont-accept", 2 },
    { NULL, "accept", 1 },
    { &_enums[831], "e3Plcp", 8 },
    { &_enums[832], "e3Framed", 7 },
    { &_enums[833], "e3other", 6 },
    { &_enums[834], "dsx3ClearChannel", 5 },
    { &_enums[835], "dsx3CbitParity", 4 },
    { &_enums[836], "dsx3SYNTRAN", 3 },
    { &_enums[837], "dsx3M23", 2 },
    { NULL, "dsx3other", 1 },
    { &_enums[839], "e3HDB3", 3 },
    { &_enums[840], "dsx3B3ZS", 2 },
    { NULL, "dsx3Other", 1 },
    { &_enums[842], "dsx3SendTestPattern", 6 },
    { &_enums[843], "dsx3SendDS1LoopCode", 5 },
    { &_enums[844], "dsx3SendResetCode", 4 },
    { &_enums[845], "dsx3SendPayloadCode", 3 },
    { &_enums[846], "dsx3SendLineCode", 2 },
    { NULL, "dsx3SendNoCode", 1 },
    { &_enums[848], "dsx3OtherLoop", 4 },
    { &_enums[849], "dsx3LineLoop", 3 },
    { &_enums[850], "dsx3PayloadLoop", 2 },
    { NULL, "dsx3NoLoop", 1 },
    { &_enums[852], "incomingLOF", 3 },
    { &_enums[853], "receivedFarEndAlarm", 2 },
    { NULL, "noAlarm", 1 },
    { &_enums[855], "mriTimeout", 12 },
    { &_enums[856], "incorrectLength", 11 },
    { &_enums[857], "baSizeFieldNotEqualToLengthField", 10 },
    { &_enums[858], "beTagMismatch", 9 },
    { &_enums[859], "hePADError", 8 },
    { &_enums[860], "invalidHdrExtCarSelectElementPositionLenghtValueOrFormat", 7 },
    { &_enums[861], "invalidHdrExtVersionElementPositionLenthOrValue", 6 },
    { &_enums[862], "invalidHdrExtElementLength", 5 },
    { &_enums[863], "invalidHdrExtLength", 4 },
    { &_enums[864], "invalidBAsizeFieldValue", 3 },
    { &_enums[865], "erroredSAFieldFormat", 2 },
    { NULL, "erroredDAFieldFormat", 1 },
    { &_enums[867], "ansiT1-617-B", 4 },
    { &_enums[868], "ansiT1-617-D", 3 },
    { &_enums[869], "lmiRev1", 2 },
    { NULL, "noLmiConfigured", 1 },
    { &_enums[871], "q922", 4 },
    { &_enums[872], "q922November90", 3 },
    { &_enums[873], "q922March90", 2 },
    { NULL, "q921", 1 },
    { &_enums[875], "four-octets", 4 },
    { &_enums[876], "three-octets", 3 },
    { NULL, "two-octets", 2 },
    { &_enums[878], "broadcast", 2 },
    { NULL, "nonBroadcast", 1 },
    { &_enums[880], "inactive", 3 },
    { &_enums[881], "active", 2 },
    { NULL, "invalid", 1 },
    { &_enums[883], "noErrorSinceReset", 10 },
    { &_enums[884], "dlcmiUnknownRpt", 9 },
    { &_enums[885], "dlcmiSequenceErr", 8 },
    { &_enums[886], "dlcmiUnknownIE", 7 },
    { &_enums[887], "dlcmiProtoErr", 6 },
    { &_enums[888], "unknownDLCI", 5 },
    { &_enums[889], "illegalDLCI", 4 },
    { &_enums[890], "receiveLong", 3 },
    { &_enums[891], "receiveShort", 2 },
    { NULL, "unknownError", 1 },
    { &_enums[893], "v35", 5 },
    { &_enums[894], "rs423", 4 },
    { &_enums[895], "rs422", 3 },
    { &_enums[896], "rs232", 2 },
    { NULL, "other", 1 },
    { &_enums[898], "dynamic", 4 },
    { &_enums[899], "one-and-half", 3 },
    { &_enums[900], "two", 2 },
    { NULL, "one", 1 },
    { &_enums[902], "space", 5 },
    { &_enums[903], "mark", 4 },
    { &_enums[904], "even", 3 },
    { &_enums[905], "odd", 2 },
    { NULL, "none", 1 },
    { &_enums[907], "split", 3 },
    { &_enums[908], "external", 2 },
    { NULL, "internal", 1 },
    { &_enums[910], "sdcd", 11 },
    { &_enums[911], "scts", 10 },
    { &_enums[912], "srts", 9 },
    { &_enums[913], "srs", 8 },
    { &_enums[914], "sq", 7 },
    { &_enums[915], "dcd", 6 },
    { &_enums[916], "ri", 5 },
    { &_enums[917], "dtr", 4 },
    { &_enums[918], "dsr", 3 },
    { &_enums[919], "cts", 2 },
    { NULL, "rts", 1 },
    { &_enums[921], "off", 3 },
    { &_enums[922], "on", 2 },
    { NULL, "none", 1 },
    { &_enums[924], "dataproducts", 3 },
    { &_enums[925], "centronics", 2 },
    { NULL, "other", 1 },
    { &_enums[927], "fault", 5 },
    { &_enums[928], "paperout", 4 },
    { &_enums[929], "busy", 3 },
    { &_enums[930], "online", 2 },
    { NULL, "power", 1 },
    { &_enums[932], "makeCall", 6 },
    { &_enums[933], "clearCall", 5 },
    { &_enums[934], "invalid", 4 },
    { &_enums[935], "underCreation", 3 },
    { &_enums[936], "createRequest", 2 },
    { NULL, "valid", 1 },
    { &_enums[938], "es", 2 },
    { NULL, "is", 1 },
    { &_enums[940], "remote", 4 },
    { &_enums[941], "direct", 3 },
    { &_enums[942], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[944], "bgp", 14 },
    { &_enums[945], "ospf", 13 },
    { &_enums[946], "bbnSpfIgp", 12 },
    { &_enums[947], "ciscoIgrp", 11 },
    { &_enums[948], "is-is", 9 },
    { &_enums[949], "netmgmt", 3 },
    { &_enums[950], "local", 2 },
    { NULL, "other", 1 },
    { &_enums[952], "debugOff", 7 },
    { &_enums[953], "debugOn", 6 },
    { &_enums[954], "warmStart", 5 },
    { &_enums[955], "terminate", 4 },
    { &_enums[956], "dumpPartyDB", 3 },
    { &_enums[957], "coldStart", 2 },
    { NULL, "other", 1 },
    { &_enums[959], "tooBig", 30 },
    { &_enums[960], "bigGauge", 29 },
    { &_enums[961], "rollCounter", 28 },
    { &_enums[962], "bigCounter", 27 },
    { &_enums[963], "sendXxx", 26 },
    { &_enums[964], "sendSet", 25 },
    { &_enums[965], "sendNext", 24 },
    { &_enums[966], "sendGet", 23 },
    { &_enums[967], "udpLesBer", 22 },
    { &_enums[968], "berLesUdp", 21 },
    { &_enums[969], "varValueBinds", 20 },
    { &_enums[970], "varNameBinds", 19 },
    { &_enums[971], "varVarBinds", 18 },
    { &_enums[972], "readOnly", 17 },
    { &_enums[973], "sendResponse", 16 },
    { &_enums[974], "indfLen", 15 },
    { &_enums[975], "tooBigStr", 14 },
    { &_enums[976], "tooSmallStr", 13 },
    { &_enums[977], "conString", 12 },
    { &_enums[978], "notCrNullOrLf", 11 },
    { &_enums[979], "nonAscii", 10 },
    { &_enums[980], "notAnEnum", 9 },
    { &_enums[981], "tooBigInt", 8 },
    { &_enums[982], "tooSmallInt", 7 },
    { &_enums[983], "notMinLen", 6 },
    { &_enums[984], "wrongTag", 5 },
    { &_enums[985], "longRow", 4 },
    { &_enums[986], "newRow", 3 },
    { &_enums[987], "cellMissing", 2 },
    { &_enums[988], "lexiBroken", 1 },
    { NULL, "none", 0 },
    { &_enums[990], "stop", 8 },
    { &_enums[991], "start", 7 },
    { &_enums[992], "restart", 6 },
    { &_enums[993], "disable", 5 },
    { &_enums[994], "enable", 4 },
    { &_enums[995], "clean", 3 },
    { &_enums[996], "abort", 2 },
    { NULL, "other", 1 },
    { &_enums[998], "remove", 3 },
    { &_enums[999], "topq", 2 },
    { NULL, "other", 1 },
    { &_enums[1001], "invalid", 2 },
    { NULL, "other", 1 },
    { &_enums[1003], "eleventh", 10 },
    { &_enums[1004], "tenth", 9 },
    { &_enums[1005], "nineth", 8 },
    { &_enums[1006], "eighth", 7 },
    { &_enums[1007], "seventh", 6 },
    { &_enums[1008], "sixth", 5 },
    { &_enums[1009], "fifth", 4 },
    { &_enums[1010], "fourth", 3 },
    { &_enums[1011], "third", 2 },
    { &_enums[1012], "second", 1 },
    { NULL, "first", 0 },
    NULL
};

static struct _syntax {
    char   *name;
    OS      value;
    char   *textual;
    char   *display;
    struct enum_syntax *es;
}	_syntaxes[] = {
    { "INTEGER", NULLOS, NULL, NULL, NULL },
    { "Integer32", NULLOS, NULL, NULL, NULL },
    { "OctetString", NULLOS, NULL, NULL, NULL },
    { "DisplayString", NULLOS, NULL, NULL, NULL },
    { "ObjectID", NULLOS, NULL, NULL, NULL },
    { "BitString", NULLOS, NULL, NULL, NULL },
    { "IpAddress", NULLOS, NULL, NULL, NULL },
    { "NetworkAddress", NULLOS, NULL, NULL, NULL },
    { "Counter", NULLOS, NULL, NULL, NULL },
    { "Counter32", NULLOS, NULL, NULL, NULL },
    { "Counter64", NULLOS, NULL, NULL, NULL },
    { "Gauge", NULLOS, NULL, NULL, NULL },
    { "Gauge32", NULLOS, NULL, NULL, NULL },
    { "UInteger32", NULLOS, NULL, NULL, NULL },
    { "TimeTicks", NULLOS, NULL, NULL, NULL },
    { "NsapAddress", NULLOS, NULL, NULL, NULL },
    { "PhysAddress", NULLOS, "OctetString", "1x:", NULL },
    { "MacAddress", NULLOS, "OctetString", "1x:", NULL },
    { "TruthValue", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "TestAndIncr", NULLOS, "INTEGER", NULL, NULL },
    { "AutonomousType", NULLOS, "ObjectID", NULL, NULL },
    { "InstancePointer", NULLOS, "ObjectID", NULL, NULL },
    { "RowStatus", NULLOS, "INTEGER", NULL, &_enums[2] },
    { "TimeStamp", NULLOS, "TimeTicks", NULL, NULL },
    { "TimeInterval", NULLOS, "INTEGER", NULL, NULL },
    { "DateAndTime", NULLOS, "OctetString", "2d-1d-1d,1d:1d:1d.1d,1a1d:1d", NULL },
    { "SnmpUDPAddress", NULLOS, "OctetString", "1d.1d.1d.1d/2d", NULL },
    { "SnmpOSIAddress", NULLOS, "OctetString", "*1x:/1x:", NULL },
    { "SnmpNBPAddress", NULLOS, "OctetString", NULL, NULL },
    { "SnmpIPXAddress", NULLOS, "OctetString", "4x.1x:1x:1x:1x:1x:1x.2d", NULL },
    { "Party", NULLOS, "ObjectID", NULL, NULL },
    { "TAddress", NULLOS, "OctetString", NULL, NULL },
    { "Clock", NULLOS, "UInteger32", NULL, NULL },
    { "Context", NULLOS, "ObjectID", NULL, NULL },
    { "StorageType", NULLOS, "INTEGER", NULL, &_enums[8] },
    { "viewType", NULLOS, "INTEGER", NULL, &_enums[12] },
    { "snmpAlarmSampleType", NULLOS, "INTEGER", NULL, &_enums[14] },
    { "snmpAlarmStartupAlarm", NULLOS, "INTEGER", NULL, &_enums[16] },
    { "ifType", NULLOS, "INTEGER", NULL, &_enums[19] },
    { "ifAdminStatus", NULLOS, "INTEGER", NULL, &_enums[51] },
    { "ifOperStatus", NULLOS, "INTEGER", NULL, &_enums[51] },
    { "ipForwarding", NULLOS, "INTEGER", NULL, &_enums[54] },
    { "ipRouteType", NULLOS, "INTEGER", NULL, &_enums[56] },
    { "ipRouteProto", NULLOS, "INTEGER", NULL, &_enums[60] },
    { "ipNetToMediaType", NULLOS, "INTEGER", NULL, &_enums[74] },
    { "tcpRtoAlgorithm", NULLOS, "INTEGER", NULL, &_enums[78] },
    { "tcpConnState", NULLOS, "INTEGER", NULL, &_enums[82] },
    { "egpNeighState", NULLOS, "INTEGER", NULL, &_enums[94] },
    { "egpNeighMode", NULLOS, "INTEGER", NULL, &_enums[99] },
    { "egpNeighEventTrigger", NULLOS, "INTEGER", NULL, &_enums[101] },
    { "snmpEnableAuthenTraps", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "ipForwardType", NULLOS, "INTEGER", NULL, &_enums[105] },
    { "ipForwardProto", NULLOS, "INTEGER", NULL, &_enums[109] },
    { "ifExtnsPromiscuous", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "ifExtnsTestResult", NULLOS, "INTEGER", NULL, &_enums[124] },
    { "ifExtnsRcvAddrStatus", NULLOS, "INTEGER", NULL, &_enums[131] },
    { "atportType", NULLOS, "INTEGER", NULL, &_enums[135] },
    { "atportStatus", NULLOS, "INTEGER", NULL, &_enums[144] },
    { "atportNetConfig", NULLOS, "INTEGER", NULL, &_enums[148] },
    { "atportZoneConfig", NULLOS, "INTEGER", NULL, &_enums[148] },
    { "rtmpType", NULLOS, "INTEGER", NULL, &_enums[152] },
    { "rtmpState", NULLOS, "INTEGER", NULL, &_enums[156] },
    { "kipCore", NULLOS, "INTEGER", NULL, &_enums[160] },
    { "kipType", NULLOS, "INTEGER", NULL, &_enums[162] },
    { "kipState", NULLOS, "INTEGER", NULL, &_enums[166] },
    { "kipShare", NULLOS, "INTEGER", NULL, &_enums[169] },
    { "zipZoneState", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "nbpState", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfAdminStat", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "ospfVersionNumber", NULLOS, "INTEGER", NULL, &_enums[173] },
    { "ospfAreaBdrRtrStatus", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "ospfASBdrRtrStatus", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "ospfTOSSupport", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "ospfImportASExtern", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "ospfStubStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfLsdbType", NULLOS, "INTEGER", NULL, &_enums[174] },
    { "ospfAreaRangeStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfHostStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfIfType", NULLOS, "INTEGER", NULL, &_enums[179] },
    { "ospfIfAdminStat", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "ospfIfState", NULLOS, "INTEGER", NULL, &_enums[182] },
    { "ospfIfMetricStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfVirtIfState", NULLOS, "INTEGER", NULL, &_enums[189] },
    { "ospfVirtIfStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfNbrState", NULLOS, "INTEGER", NULL, &_enums[191] },
    { "ospfNBMANbrStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "ospfVirtNbrState", NULLOS, "INTEGER", NULL, &_enums[191] },
    { "bgpPeerState", NULLOS, "INTEGER", NULL, &_enums[199] },
    { "bgpPathAttrOrigin", NULLOS, "INTEGER", NULL, &_enums[205] },
    { "etherStatsStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "historyControlStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "alarmSampleType", NULLOS, "INTEGER", NULL, &_enums[14] },
    { "alarmStartupAlarm", NULLOS, "INTEGER", NULL, &_enums[16] },
    { "alarmStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "hostControlStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "hostTopNRateBase", NULLOS, "INTEGER", NULL, &_enums[212] },
    { "hostTopNStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "matrixControlStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "filterStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "channelAcceptType", NULLOS, "INTEGER", NULL, &_enums[219] },
    { "channelDataControl", NULLOS, "INTEGER", NULL, &_enums[221] },
    { "channelEventStatus", NULLOS, "INTEGER", NULL, &_enums[223] },
    { "channelStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "bufferControlFullStatus", NULLOS, "INTEGER", NULL, &_enums[226] },
    { "bufferControlFullAction", NULLOS, "INTEGER", NULL, &_enums[228] },
    { "bufferControlStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "eventType", NULLOS, "INTEGER", NULL, &_enums[230] },
    { "eventStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "tokenRingMLStatsStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "tokenRingPStatsStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "ringStationControlRingState", NULLOS, "INTEGER", NULL, &_enums[234] },
    { "ringStationControlStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "ringStationStationStatus", NULLOS, "INTEGER", NULL, &_enums[241] },
    { "ringStationConfigControlRemove", NULLOS, "INTEGER", NULL, &_enums[244] },
    { "ringStationConfigControlUpdateStats", NULLOS, "INTEGER", NULL, &_enums[246] },
    { "sourceRoutingStatsStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "dot1dBaseType", NULLOS, "INTEGER", NULL, &_enums[248] },
    { "dot1dStpProtocolSpecification", NULLOS, "INTEGER", NULL, &_enums[252] },
    { "dot1dStpPortState", NULLOS, "INTEGER", NULL, &_enums[255] },
    { "dot1dStpPortEnable", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "dot1dTpFdbStatus", NULLOS, "INTEGER", NULL, &_enums[261] },
    { "dot1dStaticStatus", NULLOS, "INTEGER", NULL, &_enums[266] },
    { "dot1dSrPortSTESpanMode", NULLOS, "INTEGER", NULL, &_enums[271] },
    { "dot1dSrBridgeLfMode", NULLOS, "INTEGER", NULL, &_enums[274] },
    { "dot1dPortPairBridgeState", NULLOS, "INTEGER", NULL, &_enums[276] },
    { "phivSystemState", NULLOS, "INTEGER", NULL, &_enums[279] },
    { "phivEndRemoteState", NULLOS, "INTEGER", NULL, &_enums[279] },
    { "phivEndCountZeroCount", NULLOS, "INTEGER", NULL, &_enums[283] },
    { "phivRouteType", NULLOS, "INTEGER", NULL, &_enums[285] },
    { "phivRouteCountZeroCount", NULLOS, "INTEGER", NULL, &_enums[283] },
    { "phivRouteRoutingType", NULLOS, "INTEGER", NULL, &_enums[285] },
    { "phivCircuitCommonState", NULLOS, "INTEGER", NULL, &_enums[290] },
    { "phivCircuitCommonSubState", NULLOS, "INTEGER", NULL, &_enums[294] },
    { "phivCircuitCommonType", NULLOS, "INTEGER", NULL, &_enums[307] },
    { "phivCircuitService", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "phivCircuitCountZeroCount", NULLOS, "INTEGER", NULL, &_enums[283] },
    { "phivControlPollingState", NULLOS, "INTEGER", NULL, &_enums[318] },
    { "phivControlPollingSubState", NULLOS, "INTEGER", NULL, &_enums[323] },
    { "phivAdjType", NULLOS, "INTEGER", NULL, &_enums[285] },
    { "phivAdjState", NULLOS, "INTEGER", NULL, &_enums[327] },
    { "phivAdjNodeType", NULLOS, "INTEGER", NULL, &_enums[285] },
    { "phivAdjNodeState", NULLOS, "INTEGER", NULL, &_enums[327] },
    { "phivLineState", NULLOS, "INTEGER", NULL, &_enums[290] },
    { "phivLineSubstate", NULLOS, "INTEGER", NULL, &_enums[337] },
    { "phivLineService", NULLOS, "INTEGER", NULL, &_enums[350] },
    { "phivLineProtocol", NULLOS, "INTEGER", NULL, &_enums[354] },
    { "phivNonBroadcastController", NULLOS, "INTEGER", NULL, &_enums[365] },
    { "phivNonBroadcastDuplex", NULLOS, "INTEGER", NULL, &_enums[368] },
    { "phivNonBroadcastClock", NULLOS, "INTEGER", NULL, &_enums[370] },
    { "phivAreaState", NULLOS, "INTEGER", NULL, &_enums[373] },
    { "charPortType", NULLOS, "INTEGER", NULL, &_enums[375] },
    { "charPortReset", NULLOS, "INTEGER", NULL, &_enums[377] },
    { "charPortAdminStatus", NULLOS, "INTEGER", NULL, &_enums[379] },
    { "charPortOperStatus", NULLOS, "INTEGER", NULL, &_enums[383] },
    { "charPortInFlowType", NULLOS, "INTEGER", NULL, &_enums[388] },
    { "charPortOutFlowType", NULLOS, "INTEGER", NULL, &_enums[388] },
    { "charPortInFlowState", NULLOS, "INTEGER", NULL, &_enums[393] },
    { "charPortOutFlowState", NULLOS, "INTEGER", NULL, &_enums[393] },
    { "charPortAdminOrigin", NULLOS, "INTEGER", NULL, &_enums[397] },
    { "charSessKill", NULLOS, "INTEGER", NULL, &_enums[377] },
    { "charSessState", NULLOS, "INTEGER", NULL, &_enums[401] },
    { "charSessOperOrigin", NULLOS, "INTEGER", NULL, &_enums[404] },
    { "rptrOperStatus", NULLOS, "INTEGER", NULL, &_enums[407] },
    { "rptrReset", NULLOS, "INTEGER", NULL, &_enums[413] },
    { "rptrNonDisruptTest", NULLOS, "INTEGER", NULL, &_enums[415] },
    { "rptrGroupOperStatus", NULLOS, "INTEGER", NULL, &_enums[417] },
    { "rptrPortAdminStatus", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "rptrPortAutoPartitionState", NULLOS, "INTEGER", NULL, &_enums[423] },
    { "rptrPortOperStatus", NULLOS, "INTEGER", NULL, &_enums[425] },
    { "rip2IfStatStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "rip2IfConfAuthType", NULLOS, "INTEGER", NULL, &_enums[428] },
    { "rip2IfConfSend", NULLOS, "INTEGER", NULL, &_enums[430] },
    { "rip2IfConfReceive", NULLOS, "INTEGER", NULL, &_enums[434] },
    { "rip2IfConfStatus", NULLOS, "INTEGER", NULL, &_enums[171] },
    { "identStatus", NULLOS, "INTEGER", NULL, &_enums[437] },
    { "hrDeviceStatus", NULLOS, "INTEGER", NULL, &_enums[439] },
    { "hrPrinterStatus", NULLOS, "INTEGER", NULL, &_enums[444] },
    { "hrDiskStorageAccess", NULLOS, "INTEGER", NULL, &_enums[449] },
    { "hrDiskStorageMedia", NULLOS, "INTEGER", NULL, &_enums[451] },
    { "hrDiskStorageRemoveble", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "hrFSAccess", NULLOS, "INTEGER", NULL, &_enums[449] },
    { "hrFSBootable", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "hrSWRunType", NULLOS, "INTEGER", NULL, &_enums[459] },
    { "hrSWRunStatus", NULLOS, "INTEGER", NULL, &_enums[463] },
    { "hrSWInstalledType", NULLOS, "INTEGER", NULL, &_enums[459] },
    { "rpMauStatus", NULLOS, "INTEGER", NULL, &_enums[467] },
    { "rpMauMediaAvailable", NULLOS, "INTEGER", NULL, &_enums[473] },
    { "rpMauJabberState", NULLOS, "INTEGER", NULL, &_enums[479] },
    { "ifMauStatus", NULLOS, "INTEGER", NULL, &_enums[467] },
    { "ifMauMediaAvailable", NULLOS, "INTEGER", NULL, &_enums[473] },
    { "ifMauJabberState", NULLOS, "INTEGER", NULL, &_enums[479] },
    { "broadMauXmtRcvSplitType", NULLOS, "INTEGER", NULL, &_enums[483] },
    { "DistinguishedName", NULLOS, "DisplayString", NULL, NULL },
    { "applOperStatus", NULLOS, "INTEGER", NULL, &_enums[486] },
    { "assocApplicationType", NULLOS, "INTEGER", NULL, &_enums[491] },
    { "x25AdmnInterfaceMode", NULLOS, "INTEGER", NULL, &_enums[495] },
    { "x25AdmnPacketSequencing", NULLOS, "INTEGER", NULL, &_enums[498] },
    { "x25OperInterfaceMode", NULLOS, "INTEGER", NULL, &_enums[495] },
    { "x25OperPacketSequencing", NULLOS, "INTEGER", NULL, &_enums[498] },
    { "x25CircuitStatus", NULLOS, "INTEGER", NULL, &_enums[500] },
    { "x25CircuitDirection", NULLOS, "INTEGER", NULL, &_enums[510] },
    { "x25CallParmStatus", NULLOS, "INTEGER", NULL, &_enums[208] },
    { "x25CallParmAcceptReverseCharging", NULLOS, "INTEGER", NULL, &_enums[513] },
    { "x25CallParmProposeReverseCharging", NULLOS, "INTEGER", NULL, &_enums[517] },
    { "x25CallParmFastSelect", NULLOS, "INTEGER", NULL, &_enums[520] },
    { "x25CallParmInThruPutClasSize", NULLOS, "INTEGER", NULL, &_enums[526] },
    { "x25CallParmOutThruPutClasSize", NULLOS, "INTEGER", NULL, &_enums[526] },
    { "x25CallParmChargingInfo", NULLOS, "INTEGER", NULL, &_enums[544] },
    { "x25CallParmExptData", NULLOS, "INTEGER", NULL, &_enums[548] },
    { "dot4State", NULLOS, "INTEGER", NULL, &_enums[551] },
    { "dot4Commands", NULLOS, "INTEGER", NULL, &_enums[556] },
    { "dot4MacAddrLen", NULLOS, "INTEGER", NULL, &_enums[561] },
    { "dot4StandardRevision", NULLOS, "INTEGER", NULL, &_enums[563] },
    { "dot4InitInRingDesired", NULLOS, "INTEGER", NULL, &_enums[564] },
    { "dot5Commands", NULLOS, "INTEGER", NULL, &_enums[566] },
    { "dot5RingState", NULLOS, "INTEGER", NULL, &_enums[570] },
    { "dot5RingOpenStatus", NULLOS, "INTEGER", NULL, &_enums[576] },
    { "dot5RingSpeed", NULLOS, "INTEGER", NULL, &_enums[587] },
    { "dot5ActMonParticipate", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiSMTStatusReporting", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiSMTECMState", NULLOS, "INTEGER", NULL, &_enums[591] },
    { "snmpFddiSMTCFState", NULLOS, "INTEGER", NULL, &_enums[599] },
    { "snmpFddiSMTHoldState", NULLOS, "INTEGER", NULL, &_enums[605] },
    { "snmpFddiSMTRemoteDisconnectFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiSMTStationAction", NULLOS, "INTEGER", NULL, &_enums[609] },
    { "snmpFddiMACCurrentPath", NULLOS, "INTEGER", NULL, &_enums[614] },
    { "snmpFddiMACDupAddrTest", NULLOS, "INTEGER", NULL, &_enums[619] },
    { "snmpFddiMACDownstreamPORTType", NULLOS, "INTEGER", NULL, &_enums[622] },
    { "snmpFddiMACRMTState", NULLOS, "INTEGER", NULL, &_enums[627] },
    { "snmpFddiMACDaFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiMACUnaDaFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiMACFrameCondition", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiMACAction", NULLOS, "INTEGER", NULL, &_enums[635] },
    { "snmpFddiPORTPCType", NULLOS, "INTEGER", NULL, &_enums[640] },
    { "snmpFddiPORTPCNeighbor", NULLOS, "INTEGER", NULL, &_enums[622] },
    { "snmpFddiPORTRemoteMACIndicated", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiPORTCEState", NULLOS, "INTEGER", NULL, &_enums[644] },
    { "snmpFddiPORTBSFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiPORTConnectState", NULLOS, "INTEGER", NULL, &_enums[649] },
    { "snmpFddiPORTPCMState", NULLOS, "INTEGER", NULL, &_enums[653] },
    { "snmpFddiPORTPCWithhold", NULLOS, "INTEGER", NULL, &_enums[663] },
    { "snmpFddiPORTLerCondition", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiPORTAction", NULLOS, "INTEGER", NULL, &_enums[666] },
    { "snmpFddiATTACHMENTClass", NULLOS, "INTEGER", NULL, &_enums[672] },
    { "snmpFddiATTACHMENTOpticalBypassPresent", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "snmpFddiATTACHMENTInsertedStatus", NULLOS, "INTEGER", NULL, &_enums[675] },
    { "snmpFddiATTACHMENTInsertPolicy", NULLOS, "INTEGER", NULL, &_enums[675] },
    { "fddimibSMTStatRptPolicy", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibSMTBypassPresent", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibSMTECMState", NULLOS, "INTEGER", NULL, &_enums[591] },
    { "fddimibSMTCFState", NULLOS, "INTEGER", NULL, &_enums[678] },
    { "fddimibSMTRemoteDisconnectFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibSMTStationStatus", NULLOS, "INTEGER", NULL, &_enums[691] },
    { "fddimibSMTPeerWrapFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibSMTStationAction", NULLOS, "INTEGER", NULL, &_enums[694] },
    { "fddimibMACCurrentPath", NULLOS, "INTEGER", NULL, &_enums[702] },
    { "fddimibMACDupAddressTest", NULLOS, "INTEGER", NULL, &_enums[619] },
    { "fddimibMACDownstreamPORTType", NULLOS, "INTEGER", NULL, &_enums[708] },
    { "fddimibMACRMTState", NULLOS, "INTEGER", NULL, &_enums[627] },
    { "fddimibMACDaFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibMACUnaDaFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibMACFrameErrorFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibMACMAUnitdataAvailable", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibMACHardwarePresent", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibMACMAUnitdataEnable", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibMACNotCopiedFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibPATHConfigResourceType", NULLOS, "INTEGER", NULL, &_enums[713] },
    { "fddimibPATHConfigCurrentPath", NULLOS, "INTEGER", NULL, &_enums[702] },
    { "fddimibPORTMyType", NULLOS, "INTEGER", NULL, &_enums[708] },
    { "fddimibPORTNeighborType", NULLOS, "INTEGER", NULL, &_enums[708] },
    { "fddimibPORTMACIndicated", NULLOS, "INTEGER", NULL, &_enums[715] },
    { "fddimibPORTCurrentPath", NULLOS, "INTEGER", NULL, &_enums[719] },
    { "fddimibPORTPMDClass", NULLOS, "INTEGER", NULL, &_enums[725] },
    { "fddimibPORTBSFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibPORTConnectState", NULLOS, "INTEGER", NULL, &_enums[649] },
    { "fddimibPORTPCMState", NULLOS, "INTEGER", NULL, &_enums[653] },
    { "fddimibPORTPCWithhold", NULLOS, "INTEGER", NULL, &_enums[733] },
    { "fddimibPORTLerFlag", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibPORTHardwarePresent", NULLOS, "INTEGER", NULL, &_enums[0] },
    { "fddimibPORTAction", NULLOS, "INTEGER", NULL, &_enums[666] },
    { "lapbAdmnStationType", NULLOS, "INTEGER", NULL, &_enums[495] },
    { "lapbAdmnControlField", NULLOS, "INTEGER", NULL, &_enums[498] },
    { "lapbAdmnActionInitiate", NULLOS, "INTEGER", NULL, &_enums[737] },
    { "lapbAdmnActionRecvDM", NULLOS, "INTEGER", NULL, &_enums[742] },
    { "lapbOperStationType", NULLOS, "INTEGER", NULL, &_enums[495] },
    { "lapbOperControlField", NULLOS, "INTEGER", NULL, &_enums[498] },
    { "lapbFlowChangeReason", NULLOS, "INTEGER", NULL, &_enums[745] },
    { "lapbFlowCurrentMode", NULLOS, "INTEGER", NULL, &_enums[758] },
    { "dsx1LineType", NULLOS, "INTEGER", NULL, &_enums[775] },
    { "dsx1LineCoding", NULLOS, "INTEGER", NULL, &_enums[782] },
    { "dsx1SendCode", NULLOS, "INTEGER", NULL, &_enums[788] },
    { "dsx1LoopbackConfig", NULLOS, "INTEGER", NULL, &_enums[796] },
    { "dsx1SignalMode", NULLOS, "INTEGER", NULL, &_enums[800] },
    { "dsx1TransmitClockSource", NULLOS, "INTEGER", NULL, &_enums[804] },
    { "dsx1Fdl", NULLOS, "INTEGER", NULL, &_enums[807] },
    { "pppLinkStatusLocalToRemoteProtocolCompression", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "pppLinkStatusRemoteToLocalProtocolCompression", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "pppLinkStatusLocalToRemoteACCompression", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "pppLinkStatusRemoteToLocalACCompression", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "pppLinkConfigMagicNumber", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppLqrQuality", NULLOS, "INTEGER", NULL, &_enums[813] },
    { "pppLqrConfigStatus", NULLOS, "INTEGER", NULL, &_enums[816] },
    { "pppSecurityConfigStatus", NULLOS, "INTEGER", NULL, &_enums[818] },
    { "pppSecuritySecretsDirection", NULLOS, "INTEGER", NULL, &_enums[820] },
    { "pppSecuritySecretsStatus", NULLOS, "INTEGER", NULL, &_enums[818] },
    { "pppIpOperStatus", NULLOS, "INTEGER", NULL, &_enums[822] },
    { "pppIpLocalToRemoteCompressionProtocol", NULLOS, "INTEGER", NULL, &_enums[824] },
    { "pppIpRemoteToLocalCompressionProtocol", NULLOS, "INTEGER", NULL, &_enums[824] },
    { "pppIpConfigAdminStatus", NULLOS, "INTEGER", NULL, &_enums[826] },
    { "pppIpConfigCompression", NULLOS, "INTEGER", NULL, &_enums[824] },
    { "pppBridgeOperStatus", NULLOS, "INTEGER", NULL, &_enums[822] },
    { "pppBridgeLocalToRemoteTinygramCompression", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeRemoteToLocalTinygramCompression", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeLocalToRemoteLanId", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeRemoteToLocalLanId", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeConfigAdminStatus", NULLOS, "INTEGER", NULL, &_enums[826] },
    { "pppBridgeConfigTinygram", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeConfigRingId", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeConfigLineId", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeConfigLanId", NULLOS, "INTEGER", NULL, &_enums[811] },
    { "pppBridgeMediaLocalStatus", NULLOS, "INTEGER", NULL, &_enums[828] },
    { "pppBridgeMediaRemoteStatus", NULLOS, "INTEGER", NULL, &_enums[828] },
    { "pppBridgeMediaConfigLocalStatus", NULLOS, "INTEGER", NULL, &_enums[828] },
    { "dsx3LineType", NULLOS, "INTEGER", NULL, &_enums[830] },
    { "dsx3LineCoding", NULLOS, "INTEGER", NULL, &_enums[838] },
    { "dsx3SendCode", NULLOS, "INTEGER", NULL, &_enums[841] },
    { "dsx3LoopbackConfig", NULLOS, "INTEGER", NULL, &_enums[847] },
    { "dsx3TransmitClockSource", NULLOS, "INTEGER", NULL, &_enums[804] },
    { "sipDS1PLCPAlarmState", NULLOS, "INTEGER", NULL, &_enums[851] },
    { "sipDS3PLCPAlarmState", NULLOS, "INTEGER", NULL, &_enums[851] },
    { "sipL3PDUErrorType", NULLOS, "INTEGER", NULL, &_enums[854] },
    { "frDlcmiState", NULLOS, "INTEGER", NULL, &_enums[866] },
    { "frDlcmiAddress", NULLOS, "INTEGER", NULL, &_enums[870] },
    { "frDlcmiAddressLen", NULLOS, "INTEGER", NULL, &_enums[874] },
    { "frDlcmiMulticast", NULLOS, "INTEGER", NULL, &_enums[877] },
    { "frCircuitState", NULLOS, "INTEGER", NULL, &_enums[879] },
    { "frErrType", NULLOS, "INTEGER", NULL, &_enums[882] },
    { "frTrapState", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "rs232PortType", NULLOS, "INTEGER", NULL, &_enums[892] },
    { "rs232AsyncPortStopBits", NULLOS, "INTEGER", NULL, &_enums[897] },
    { "rs232AsyncPortParity", NULLOS, "INTEGER", NULL, &_enums[901] },
    { "rs232AsyncPortAutobaud", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "rs232SyncPortClockSource", NULLOS, "INTEGER", NULL, &_enums[906] },
    { "rs232InSigName", NULLOS, "INTEGER", NULL, &_enums[909] },
    { "rs232InSigState", NULLOS, "INTEGER", NULL, &_enums[920] },
    { "rs232OutSigName", NULLOS, "INTEGER", NULL, &_enums[909] },
    { "rs232OutSigState", NULLOS, "INTEGER", NULL, &_enums[920] },
    { "paraPortType", NULLOS, "INTEGER", NULL, &_enums[923] },
    { "paraInSigName", NULLOS, "INTEGER", NULL, &_enums[926] },
    { "paraInSigState", NULLOS, "INTEGER", NULL, &_enums[920] },
    { "paraOutSigName", NULLOS, "INTEGER", NULL, &_enums[926] },
    { "paraOutSigState", NULLOS, "INTEGER", NULL, &_enums[920] },
    { "mioxPeerStatus", NULLOS, "INTEGER", NULL, &_enums[931] },
    { "clnpForwarding", NULLOS, "INTEGER", NULL, &_enums[937] },
    { "clnpRouteType", NULLOS, "INTEGER", NULL, &_enums[939] },
    { "clnpRouteProto", NULLOS, "INTEGER", NULL, &_enums[943] },
    { "clnpNetToMediaType", NULLOS, "INTEGER", NULL, &_enums[74] },
    { "clnpMediaToNetType", NULLOS, "INTEGER", NULL, &_enums[74] },
    { "agentAction", NULLOS, "INTEGER", NULL, &_enums[951] },
    { "iSODEPartyTestMode", NULLOS, "INTEGER", NULL, &_enums[958] },
    { "unixNetstat", NULLOS, "INTEGER", NULL, &_enums[103] },
    { "printQAction", NULLOS, "INTEGER", NULL, &_enums[989] },
    { "printJAction", NULLOS, "INTEGER", NULL, &_enums[997] },
    { "userStatus", NULLOS, "INTEGER", NULL, &_enums[1000] },
    { "groupStatus", NULLOS, "INTEGER", NULL, &_enums[1000] },
    { "grUserStatus", NULLOS, "INTEGER", NULL, &_enums[1000] },
    { "grNewUserStatus", NULLOS, "INTEGER", NULL, &_enums[1000] },
    { "mtrBitString", NULLOS, "BitString", NULL, &_enums[1002] },
    NULL
};

static object_type _types[] = {
    { "ccitt", "0", &_names[0],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[1] },
    { "iso", "1", &_names[1],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[2], &_types[2] },
    { "internet", "1.3.6.1", &_names[2],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[3], &_types[3] },
    { "directory", "1.3.6.1.1", &_names[3],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2862], NULLOT, &_types[4] },
    { "mgmt", "1.3.6.1.2", &_names[4],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2984], &_types[5], &_types[5] },
    { "mib-2", "1.3.6.1.2.1", &_names[5],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[195], &_types[6] },
    { "system", "1.3.6.1.2.1.1", &_names[6],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3047], &_types[1431], &_types[8], &_types[7] },
    { "sysDescr", "1.3.6.1.2.1.1.1", &_names[7],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[3075], NULLOT, NULLOT, &_types[8] },
    { "sysObjectID", "1.3.6.1.2.1.1.2", &_names[8],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3092], &_types[10], NULLOT, &_types[9] },
    { "sysUpTime", "1.3.6.1.2.1.1.3", &_names[9],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3135], &_types[7], NULLOT, &_types[10] },
    { "sysContact", "1.3.6.1.2.1.1.4", &_names[10],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[3087], &_types[12], NULLOT, &_types[11] },
    { "sysName", "1.3.6.1.2.1.1.5", &_names[11],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[3013], &_types[9], NULLOT, &_types[12] },
    { "sysLocation", "1.3.6.1.2.1.1.6", &_names[12],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[3086], &_types[13], NULLOT, &_types[13] },
    { "sysServices", "1.3.6.1.2.1.1.7", &_names[13],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[12], &_types[11], NULLOT, &_types[14] },
    { "interfaces", "1.3.6.1.2.1.2", &_names[14],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3079], &_types[172], &_types[15], &_types[15] },
    { "ifNumber", "1.3.6.1.2.1.2.1", &_names[15],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3117], &_types[16], NULLOT, &_types[16] },
    { "ifTable", "1.3.6.1.2.1.2.2", &_names[16],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3081], NULLOT, &_types[17], &_types[17] },
    { "ifEntry", "1.3.6.1.2.1.2.2.1", &_names[17],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[3082], NULLOT, &_types[20], &_types[18] },
    { "ifIndex", "1.3.6.1.2.1.2.2.1.1", &_names[18],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3073], &_types[26], NULLOT, &_types[19] },
    { "ifDescr", "1.3.6.1.2.1.2.2.1.2", &_names[19],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[7], &_types[21], NULLOT, &_types[20] },
    { "ifType", "1.3.6.1.2.1.2.2.1.3", &_names[20],
      (OS) 38, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[17], &_types[31], NULLOT, &_types[21] },
    { "ifMtu", "1.3.6.1.2.1.2.2.1.4", &_names[21],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[172], &_types[30], NULLOT, &_types[22] },
    { "ifSpeed", "1.3.6.1.2.1.2.2.1.5", &_names[22],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[39], NULLOT, &_types[23] },
    { "ifPhysAddress", "1.3.6.1.2.1.2.2.1.6", &_names[23],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[163], &_types[24], NULLOT, &_types[24] },
    { "ifAdminStatus", "1.3.6.1.2.1.2.2.1.7", &_names[24],
      (OS) 39, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[13], &_types[25], NULLOT, &_types[25] },
    { "ifOperStatus", "1.3.6.1.2.1.2.2.1.8", &_names[25],
      (OS) 40, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[24], &_types[27], NULLOT, &_types[26] },
    { "ifLastChange", "1.3.6.1.2.1.2.2.1.9", &_names[26],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3077], &_types[28], NULLOT, &_types[27] },
    { "ifInOctets", "1.3.6.1.2.1.2.2.1.10", &_names[27],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[25], &_types[33], NULLOT, &_types[28] },
    { "ifInUcastPkts", "1.3.6.1.2.1.2.2.1.11", &_names[28],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[29], NULLOT, &_types[29] },
    { "ifInNUcastPkts", "1.3.6.1.2.1.2.2.1.12", &_names[29],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[28], &_types[34], NULLOT, &_types[30] },
    { "ifInDiscards", "1.3.6.1.2.1.2.2.1.13", &_names[30],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[21], &_types[36], NULLOT, &_types[31] },
    { "ifInErrors", "1.3.6.1.2.1.2.2.1.14", &_names[31],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3144], &_types[37], NULLOT, &_types[32] },
    { "ifInUnknownProtos", "1.3.6.1.2.1.2.2.1.15", &_names[32],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[6], NULLOT, NULLOT, &_types[33] },
    { "ifOutOctets", "1.3.6.1.2.1.2.2.1.16", &_names[33],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[27], &_types[18], NULLOT, &_types[34] },
    { "ifOutUcastPkts", "1.3.6.1.2.1.2.2.1.17", &_names[34],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[29], &_types[35], NULLOT, &_types[35] },
    { "ifOutNUcastPkts", "1.3.6.1.2.1.2.2.1.18", &_names[35],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[34], &_types[38], NULLOT, &_types[36] },
    { "ifOutDiscards", "1.3.6.1.2.1.2.2.1.19", &_names[36],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[30], &_types[32], NULLOT, &_types[37] },
    { "ifOutErrors", "1.3.6.1.2.1.2.2.1.20", &_names[37],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[31], &_types[23], NULLOT, &_types[38] },
    { "ifOutQLen", "1.3.6.1.2.1.2.2.1.21", &_names[38],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[16], &_types[22], NULLOT, &_types[39] },
    { "ifSpecific", "1.3.6.1.2.1.2.2.1.22", &_names[39],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[22], &_types[19], NULLOT, &_types[40] },
    { "at", "1.3.6.1.2.1.3", &_names[40],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[14], &_types[41], &_types[41] },
    { "atTable", "1.3.6.1.2.1.3.1", &_names[41],
      (OS) -1, 0, (u_long) 0, 4,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[38], NULLOT, &_types[42], &_types[42] },
    { "atEntry", "1.3.6.1.2.1.3.1.1", &_names[42],
      (OS) -1, 0, (u_long) 0, 4,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "atIfIndex atNetAddress", NULL, NULL,
      &_types[20], NULLOT, &_types[44], &_types[43] },
    { "atIfIndex", "1.3.6.1.2.1.3.1.1.1", &_names[43],
      (OS) 0, 3, (u_long) 0, 4,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[18], NULLOT, NULLOT, &_types[44] },
    { "atPhysAddress", "1.3.6.1.2.1.3.1.1.2", &_names[44],
      (OS) 2, 3, (u_long) 0, 4,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[23], &_types[45], NULLOT, &_types[45] },
    { "atNetAddress", "1.3.6.1.2.1.3.1.1.3", &_names[45],
      (OS) 7, 3, (u_long) 0, 4,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[44], &_types[43], NULLOT, &_types[46] },
    { "ip", "1.3.6.1.2.1.4", &_names[46],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[40], &_types[61], &_types[47] },
    { "ipForwarding", "1.3.6.1.2.1.4.1", &_names[47],
      (OS) 41, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[95], NULLOT, &_types[48] },
    { "ipDefaultTTL", "1.3.6.1.2.1.4.2", &_names[48],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3032], &_types[55], NULLOT, &_types[49] },
    { "ipInReceives", "1.3.6.1.2.1.4.3", &_names[49],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[62], NULLOT, &_types[50] },
    { "ipInHdrErrors", "1.3.6.1.2.1.4.4", &_names[50],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[37], &_types[51], NULLOT, &_types[51] },
    { "ipInAddrErrors", "1.3.6.1.2.1.4.5", &_names[51],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[50], &_types[56], NULLOT, &_types[52] },
    { "ipForwDatagrams", "1.3.6.1.2.1.4.6", &_names[52],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3048], &_types[65], NULLOT, &_types[53] },
    { "ipInUnknownProtos", "1.3.6.1.2.1.4.7", &_names[53],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[32], &_types[48], NULLOT, &_types[54] },
    { "ipInDiscards", "1.3.6.1.2.1.4.8", &_names[54],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[36], &_types[57], NULLOT, &_types[55] },
    { "ipInDelivers", "1.3.6.1.2.1.4.9", &_names[55],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[42], &_types[47], NULLOT, &_types[56] },
    { "ipOutRequests", "1.3.6.1.2.1.4.10", &_names[56],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3084], &_types[60], NULLOT, &_types[57] },
    { "ipOutDiscards", "1.3.6.1.2.1.4.11", &_names[57],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[54], &_types[94], NULLOT, &_types[58] },
    { "ipOutNoRoutes", "1.3.6.1.2.1.4.12", &_names[58],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[9], &_types[59], NULLOT, &_types[59] },
    { "ipReasmTimeout", "1.3.6.1.2.1.4.13", &_names[59],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[58], &_types[52], NULLOT, &_types[60] },
    { "ipReasmReqds", "1.3.6.1.2.1.4.14", &_names[60],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[56], &_types[58], NULLOT, &_types[61] },
    { "ipReasmOKs", "1.3.6.1.2.1.4.15", &_names[61],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[63], NULLOT, &_types[62] },
    { "ipReasmFails", "1.3.6.1.2.1.4.16", &_names[62],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3034], &_types[64], NULLOT, &_types[63] },
    { "ipFragOKs", "1.3.6.1.2.1.4.17", &_names[63],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[61], &_types[54], NULLOT, &_types[64] },
    { "ipFragFails", "1.3.6.1.2.1.4.18", &_names[64],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[62], NULLOT, NULLOT, &_types[65] },
    { "ipFragCreates", "1.3.6.1.2.1.4.19", &_names[65],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3068], &_types[66], NULLOT, &_types[66] },
    { "ipAddrTable", "1.3.6.1.2.1.4.20", &_names[66],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[41], &_types[73], &_types[67], &_types[67] },
    { "ipAddrEntry", "1.3.6.1.2.1.4.20.1", &_names[67],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ipAdEntAddr", NULL, NULL,
      &_types[55], NULLOT, &_types[72], &_types[68] },
    { "ipAdEntAddr", "1.3.6.1.2.1.4.20.1.1", &_names[68],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[45], &_types[71], NULLOT, &_types[69] },
    { "ipAdEntIfIndex", "1.3.6.1.2.1.4.20.1.2", &_names[69],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[43], &_types[70], NULLOT, &_types[70] },
    { "ipAdEntNetMask", "1.3.6.1.2.1.4.20.1.3", &_names[70],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[69], NULLOT, NULLOT, &_types[71] },
    { "ipAdEntBcastAddr", "1.3.6.1.2.1.4.20.1.4", &_names[71],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[68], &_types[69], NULLOT, &_types[72] },
    { "ipAdEntReasmMaxSize", "1.3.6.1.2.1.4.20.1.5", &_names[72],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[8], &_types[68], NULLOT, &_types[73] },
    { "ipRouteTable", "1.3.6.1.2.1.4.21", &_names[73],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[66], &_types[88], &_types[74], &_types[74] },
    { "ipRouteEntry", "1.3.6.1.2.1.4.21.1", &_names[74],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ipRouteDest", NULL, NULL,
      &_types[67], NULLOT, &_types[82], &_types[75] },
    { "ipRouteDest", "1.3.6.1.2.1.4.21.1.1", &_names[75],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[19], &_types[83], NULLOT, &_types[76] },
    { "ipRouteIfIndex", "1.3.6.1.2.1.4.21.1.2", &_names[76],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[70], &_types[84], NULLOT, &_types[77] },
    { "ipRouteMetric1", "1.3.6.1.2.1.4.21.1.3", &_names[77],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[26], &_types[78], NULLOT, &_types[78] },
    { "ipRouteMetric2", "1.3.6.1.2.1.4.21.1.4", &_names[78],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[77], &_types[79], NULLOT, &_types[79] },
    { "ipRouteMetric3", "1.3.6.1.2.1.4.21.1.5", &_names[79],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[78], &_types[80], NULLOT, &_types[80] },
    { "ipRouteMetric4", "1.3.6.1.2.1.4.21.1.6", &_names[80],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[79], &_types[86], NULLOT, &_types[81] },
    { "ipRouteNextHop", "1.3.6.1.2.1.4.21.1.7", &_names[81],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[47], &_types[87], NULLOT, &_types[82] },
    { "ipRouteType", "1.3.6.1.2.1.4.21.1.8", &_names[82],
      (OS) 42, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[74], &_types[81], NULLOT, &_types[83] },
    { "ipRouteProto", "1.3.6.1.2.1.4.21.1.9", &_names[83],
      (OS) 43, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[53], NULLOT, NULLOT, &_types[84] },
    { "ipRouteAge", "1.3.6.1.2.1.4.21.1.10", &_names[84],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[76], &_types[85], NULLOT, &_types[85] },
    { "ipRouteMask", "1.3.6.1.2.1.4.21.1.11", &_names[85],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[84], &_types[77], NULLOT, &_types[86] },
    { "ipRouteMetric5", "1.3.6.1.2.1.4.21.1.12", &_names[86],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[80], &_types[75], NULLOT, &_types[87] },
    { "ipRouteInfo", "1.3.6.1.2.1.4.21.1.13", &_names[87],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[71], &_types[76], NULLOT, &_types[88] },
    { "ipNetToMediaTable", "1.3.6.1.2.1.4.22", &_names[88],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[73], &_types[49], &_types[89], &_types[89] },
    { "ipNetToMediaEntry", "1.3.6.1.2.1.4.22.1", &_names[89],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ipNetToMediaIfIndex ipNetToMediaNetAddress", NULL, NULL,
      &_types[82], NULLOT, &_types[93], &_types[90] },
    { "ipNetToMediaIfIndex", "1.3.6.1.2.1.4.22.1.1", &_names[90],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[85], NULLOT, NULLOT, &_types[91] },
    { "ipNetToMediaPhysAddress", "1.3.6.1.2.1.4.22.1.2", &_names[91],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[87], &_types[92], NULLOT, &_types[92] },
    { "ipNetToMediaNetAddress", "1.3.6.1.2.1.4.22.1.3", &_names[92],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[91], &_types[90], NULLOT, &_types[93] },
    { "ipNetToMediaType", "1.3.6.1.2.1.4.22.1.4", &_names[93],
      (OS) 44, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[89], &_types[91], NULLOT, &_types[94] },
    { "ipRoutingDiscards", "1.3.6.1.2.1.4.23", &_names[94],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[57], &_types[53], NULLOT, &_types[95] },
    { "ipForward", "1.3.6.1.2.1.4.24", &_names[95],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[81], &_types[50], &_types[96], &_types[96] },
    { "ipForwardNumber", "1.3.6.1.2.1.4.24.1", &_names[96],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[150], &_types[97], NULLOT, &_types[97] },
    { "ipForwardTable", "1.3.6.1.2.1.4.24.2", &_names[97],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[177], NULLOT, &_types[98], &_types[98] },
    { "ipForwardEntry", "1.3.6.1.2.1.4.24.2.1", &_names[98],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ipForwardDest ipForwardProto ipForwardPolicy ipForwardNextHop", NULL, NULL,
      &_types[178], NULLOT, &_types[104], &_types[99] },
    { "ipForwardDest", "1.3.6.1.2.1.4.24.2.1.1", &_names[99],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[75], &_types[105], NULLOT, &_types[100] },
    { "ipForwardMask", "1.3.6.1.2.1.4.24.2.1.2", &_names[100],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[139], &_types[103], NULLOT, &_types[101] },
    { "ipForwardPolicy", "1.3.6.1.2.1.4.24.2.1.3", &_names[101],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1295], &_types[108], NULLOT, &_types[102] },
    { "ipForwardNextHop", "1.3.6.1.2.1.4.24.2.1.4", &_names[102],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[95], &_types[107], NULLOT, &_types[103] },
    { "ipForwardIfIndex", "1.3.6.1.2.1.4.24.2.1.5", &_names[103],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[100], &_types[106], NULLOT, &_types[104] },
    { "ipForwardType", "1.3.6.1.2.1.4.24.2.1.6", &_names[104],
      (OS) 51, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[98], &_types[102], NULLOT, &_types[105] },
    { "ipForwardProto", "1.3.6.1.2.1.4.24.2.1.7", &_names[105],
      (OS) 52, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[132], NULLOT, NULLOT, &_types[106] },
    { "ipForwardAge", "1.3.6.1.2.1.4.24.2.1.8", &_names[106],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[103], &_types[109], NULLOT, &_types[107] },
    { "ipForwardInfo", "1.3.6.1.2.1.4.24.2.1.9", &_names[107],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1309], &_types[100], NULLOT, &_types[108] },
    { "ipForwardNextHopAS", "1.3.6.1.2.1.4.24.2.1.10", &_names[108],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[162], &_types[99], NULLOT, &_types[109] },
    { "ipForwardMetric1", "1.3.6.1.2.1.4.24.2.1.11", &_names[109],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[142], &_types[110], NULLOT, &_types[110] },
    { "ipForwardMetric2", "1.3.6.1.2.1.4.24.2.1.12", &_names[110],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[109], &_types[111], NULLOT, &_types[111] },
    { "ipForwardMetric3", "1.3.6.1.2.1.4.24.2.1.13", &_names[111],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[110], &_types[112], NULLOT, &_types[112] },
    { "ipForwardMetric4", "1.3.6.1.2.1.4.24.2.1.14", &_names[112],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[111], &_types[113], NULLOT, &_types[113] },
    { "ipForwardMetric5", "1.3.6.1.2.1.4.24.2.1.15", &_names[113],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[112], &_types[101], NULLOT, &_types[114] },
    { "icmp", "1.3.6.1.2.1.5", &_names[114],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[4], &_types[1285], &_types[121], &_types[115] },
    { "icmpInMsgs", "1.3.6.1.2.1.5.1", &_names[115],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[92], &_types[120], NULLOT, &_types[116] },
    { "icmpInErrors", "1.3.6.1.2.1.5.2", &_names[116],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[51], &_types[129], NULLOT, &_types[117] },
    { "icmpInDestUnreachs", "1.3.6.1.2.1.5.3", &_names[117],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[35], &_types[130], NULLOT, &_types[118] },
    { "icmpInTimeExcds", "1.3.6.1.2.1.5.4", &_names[118],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[49], &_types[131], NULLOT, &_types[119] },
    { "icmpInParmProbs", "1.3.6.1.2.1.5.5", &_names[119],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[83], &_types[132], NULLOT, &_types[120] },
    { "icmpInSrcQuenchs", "1.3.6.1.2.1.5.6", &_names[120],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[115], &_types[128], NULLOT, &_types[121] },
    { "icmpInRedirects", "1.3.6.1.2.1.5.7", &_names[121],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3001], &_types[134], NULLOT, &_types[122] },
    { "icmpInEchos", "1.3.6.1.2.1.5.8", &_names[122],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3130], &_types[135], NULLOT, &_types[123] },
    { "icmpInEchoReps", "1.3.6.1.2.1.5.9", &_names[123],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3123], &_types[125], NULLOT, &_types[124] },
    { "icmpInTimestamps", "1.3.6.1.2.1.5.10", &_names[124],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[59], &_types[137], NULLOT, &_types[125] },
    { "icmpInTimestampReps", "1.3.6.1.2.1.5.11", &_names[125],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[123], &_types[127], NULLOT, &_types[126] },
    { "icmpInAddrMasks", "1.3.6.1.2.1.5.12", &_names[126],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[90], &_types[139], NULLOT, &_types[127] },
    { "icmpInAddrMaskReps", "1.3.6.1.2.1.5.13", &_names[127],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[125], &_types[136], NULLOT, &_types[128] },
    { "icmpOutMsgs", "1.3.6.1.2.1.5.14", &_names[128],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[120], &_types[133], NULLOT, &_types[129] },
    { "icmpOutErrors", "1.3.6.1.2.1.5.15", &_names[129],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[116], &_types[115], NULLOT, &_types[130] },
    { "icmpOutDestUnreachs", "1.3.6.1.2.1.5.16", &_names[130],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[117], &_types[124], NULLOT, &_types[131] },
    { "icmpOutTimeExcds", "1.3.6.1.2.1.5.17", &_names[131],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[118], &_types[122], NULLOT, &_types[132] },
    { "icmpOutParmProbs", "1.3.6.1.2.1.5.18", &_names[132],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[119], &_types[116], NULLOT, &_types[133] },
    { "icmpOutSrcQuenchs", "1.3.6.1.2.1.5.19", &_names[133],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[128], &_types[126], NULLOT, &_types[134] },
    { "icmpOutRedirects", "1.3.6.1.2.1.5.20", &_names[134],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[121], &_types[118], NULLOT, &_types[135] },
    { "icmpOutEchos", "1.3.6.1.2.1.5.21", &_names[135],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[122], &_types[119], NULLOT, &_types[136] },
    { "icmpOutEchoReps", "1.3.6.1.2.1.5.22", &_names[136],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[127], &_types[138], NULLOT, &_types[137] },
    { "icmpOutTimestamps", "1.3.6.1.2.1.5.23", &_names[137],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[124], NULLOT, NULLOT, &_types[138] },
    { "icmpOutTimestampReps", "1.3.6.1.2.1.5.24", &_names[138],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[136], &_types[140], NULLOT, &_types[139] },
    { "icmpOutAddrMasks", "1.3.6.1.2.1.5.25", &_names[139],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[126], &_types[123], NULLOT, &_types[140] },
    { "icmpOutAddrMaskReps", "1.3.6.1.2.1.5.26", &_names[140],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[138], &_types[117], NULLOT, &_types[141] },
    { "tcp", "1.3.6.1.2.1.6", &_names[141],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3089], &_types[163], &_types[149], &_types[142] },
    { "tcpRtoAlgorithm", "1.3.6.1.2.1.6.1", &_names[142],
      (OS) 45, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[86], &_types[151], NULLOT, &_types[143] },
    { "tcpRtoMin", "1.3.6.1.2.1.6.2", &_names[143],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1285], &_types[148], NULLOT, &_types[144] },
    { "tcpRtoMax", "1.3.6.1.2.1.6.3", &_names[144],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[72], &_types[146], NULLOT, &_types[145] },
    { "tcpMaxConn", "1.3.6.1.2.1.6.4", &_names[145],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[10], NULLOT, NULLOT, &_types[146] },
    { "tcpActiveOpens", "1.3.6.1.2.1.6.5", &_names[146],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[144], &_types[147], NULLOT, &_types[147] },
    { "tcpPassiveOpens", "1.3.6.1.2.1.6.6", &_names[147],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[146], &_types[145], NULLOT, &_types[148] },
    { "tcpAttemptFails", "1.3.6.1.2.1.6.7", &_names[148],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[64], &_types[162], NULLOT, &_types[149] },
    { "tcpEstabResets", "1.3.6.1.2.1.6.8", &_names[149],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[33], &_types[142], NULLOT, &_types[150] },
    { "tcpCurrEstab", "1.3.6.1.2.1.6.9", &_names[150],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[15], &_types[161], NULLOT, &_types[151] },
    { "tcpInSegs", "1.3.6.1.2.1.6.10", &_names[151],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[88], &_types[152], NULLOT, &_types[152] },
    { "tcpOutSegs", "1.3.6.1.2.1.6.11", &_names[152],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[151], &_types[153], NULLOT, &_types[153] },
    { "tcpRetransSegs", "1.3.6.1.2.1.6.12", &_names[153],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[152], &_types[154], NULLOT, &_types[154] },
    { "tcpConnTable", "1.3.6.1.2.1.6.13", &_names[154],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[153], &_types[143], &_types[155], &_types[155] },
    { "tcpConnEntry", "1.3.6.1.2.1.6.13.1", &_names[155],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "tcpConnLocalAddress tcpConnLocalPort tcpConnRemAddress tcpConnRemPort", NULL, NULL,
      &_types[93], NULLOT, &_types[157], &_types[156] },
    { "tcpConnState", "1.3.6.1.2.1.6.13.1.1", &_names[156],
      (OS) 46, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[149], &_types[158], NULLOT, &_types[157] },
    { "tcpConnLocalAddress", "1.3.6.1.2.1.6.13.1.2", &_names[157],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[133], &_types[159], NULLOT, &_types[158] },
    { "tcpConnLocalPort", "1.3.6.1.2.1.6.13.1.3", &_names[158],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[114], &_types[160], NULLOT, &_types[159] },
    { "tcpConnRemAddress", "1.3.6.1.2.1.6.13.1.4", &_names[159],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[157], &_types[156], NULLOT, &_types[160] },
    { "tcpConnRemPort", "1.3.6.1.2.1.6.13.1.5", &_names[160],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[158], NULLOT, NULLOT, &_types[161] },
    { "tcpInErrs", "1.3.6.1.2.1.6.14", &_names[161],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[129], &_types[144], NULLOT, &_types[162] },
    { "tcpOutRsts", "1.3.6.1.2.1.6.15", &_names[162],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3065], &_types[150], NULLOT, &_types[163] },
    { "udp", "1.3.6.1.2.1.7", &_names[163],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[141], &_types[1314], &_types[164], &_types[164] },
    { "udpInDatagrams", "1.3.6.1.2.1.7.1", &_names[164],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[52], &_types[167], NULLOT, &_types[165] },
    { "udpNoPorts", "1.3.6.1.2.1.7.2", &_names[165],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[160], &_types[166], NULLOT, &_types[166] },
    { "udpInErrors", "1.3.6.1.2.1.7.3", &_names[166],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[161], NULLOT, NULLOT, &_types[167] },
    { "udpOutDatagrams", "1.3.6.1.2.1.7.4", &_names[167],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[164], &_types[168], NULLOT, &_types[168] },
    { "udpTable", "1.3.6.1.2.1.7.5", &_names[168],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[154], &_types[165], &_types[169], &_types[169] },
    { "udpEntry", "1.3.6.1.2.1.7.5.1", &_names[169],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "udpLocalAddress udpLocalPort", NULL, NULL,
      &_types[155], NULLOT, &_types[170], &_types[170] },
    { "udpLocalAddress", "1.3.6.1.2.1.7.5.1.1", &_names[170],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[159], &_types[171], NULLOT, &_types[171] },
    { "udpLocalPort", "1.3.6.1.2.1.7.5.1.2", &_names[171],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[165], NULLOT, NULLOT, &_types[172] },
    { "egp", "1.3.6.1.2.1.8", &_names[172],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[6], &_types[174], &_types[173] },
    { "egpInMsgs", "1.3.6.1.2.1.8.1", &_names[173],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[170], &_types[175], NULLOT, &_types[174] },
    { "egpInErrors", "1.3.6.1.2.1.8.2", &_names[174],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[166], &_types[176], NULLOT, &_types[175] },
    { "egpOutMsgs", "1.3.6.1.2.1.8.3", &_names[175],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[173], &_types[177], NULLOT, &_types[176] },
    { "egpOutErrors", "1.3.6.1.2.1.8.4", &_names[176],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[174], &_types[173], NULLOT, &_types[177] },
    { "egpNeighTable", "1.3.6.1.2.1.8.5", &_names[177],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[168], &_types[194], &_types[178], &_types[178] },
    { "egpNeighEntry", "1.3.6.1.2.1.8.5.1", &_names[178],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "egpNeighAddr", NULL, NULL,
      &_types[169], NULLOT, &_types[183], &_types[179] },
    { "egpNeighState", "1.3.6.1.2.1.8.5.1.1", &_names[179],
      (OS) 47, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[156], &_types[188], NULLOT, &_types[180] },
    { "egpNeighAddr", "1.3.6.1.2.1.8.5.1.2", &_names[180],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[175], &_types[182], NULLOT, &_types[181] },
    { "egpNeighAs", "1.3.6.1.2.1.8.5.1.3", &_names[181],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[189], NULLOT, &_types[182] },
    { "egpNeighInMsgs", "1.3.6.1.2.1.8.5.1.4", &_names[182],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[180], &_types[184], NULLOT, &_types[183] },
    { "egpNeighInErrs", "1.3.6.1.2.1.8.5.1.5", &_names[183],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[176], &_types[185], NULLOT, &_types[184] },
    { "egpNeighOutMsgs", "1.3.6.1.2.1.8.5.1.6", &_names[184],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[182], &_types[186], NULLOT, &_types[185] },
    { "egpNeighOutErrs", "1.3.6.1.2.1.8.5.1.7", &_names[185],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[183], &_types[192], NULLOT, &_types[186] },
    { "egpNeighInErrMsgs", "1.3.6.1.2.1.8.5.1.8", &_names[186],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[184], &_types[187], NULLOT, &_types[187] },
    { "egpNeighOutErrMsgs", "1.3.6.1.2.1.8.5.1.9", &_names[187],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[186], &_types[179], NULLOT, &_types[188] },
    { "egpNeighStateUps", "1.3.6.1.2.1.8.5.1.10", &_names[188],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[137], &_types[190], NULLOT, &_types[189] },
    { "egpNeighStateDowns", "1.3.6.1.2.1.8.5.1.11", &_names[189],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[48], NULLOT, NULLOT, &_types[190] },
    { "egpNeighIntervalHello", "1.3.6.1.2.1.8.5.1.12", &_names[190],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[191], NULLOT, &_types[191] },
    { "egpNeighIntervalPoll", "1.3.6.1.2.1.8.5.1.13", &_names[191],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[193], NULLOT, &_types[192] },
    { "egpNeighMode", "1.3.6.1.2.1.8.5.1.14", &_names[192],
      (OS) 48, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[145], &_types[180], NULLOT, &_types[193] },
    { "egpNeighEventTrigger", "1.3.6.1.2.1.8.5.1.15", &_names[193],
      (OS) 49, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[181], NULLOT, &_types[194] },
    { "egpAs", "1.3.6.1.2.1.8.6", &_names[194],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[181], NULLOT, NULLOT, &_types[195] },
    { "transmission", "1.3.6.1.2.1.10", &_names[195],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3028], &_types[46], &_types[1187], &_types[196] },
    { "x25", "1.3.6.1.2.1.10.5", &_names[196],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2180], &_types[364], &_types[357], &_types[197] },
    { "x25AdmnTable", "1.3.6.1.2.1.10.5.1", &_names[197],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2727], &_types[223], &_types[198], &_types[198] },
    { "x25AdmnEntry", "1.3.6.1.2.1.10.5.1.1", &_names[198],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25AdmnIndex", NULL, NULL,
      &_types[2728], NULLOT, &_types[213], &_types[199] },
    { "x25AdmnIndex", "1.3.6.1.2.1.10.5.1.1.1", &_names[199],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2729], &_types[202], NULLOT, &_types[200] },
    { "x25AdmnInterfaceMode", "1.3.6.1.2.1.10.5.1.1.2", &_names[200],
      (OS) 195, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2737], &_types[221], NULLOT, &_types[201] },
    { "x25AdmnMaxActiveCircuits", "1.3.6.1.2.1.10.5.1.1.3", &_names[201],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4096,
      NULL, NULL, NULL,
      &_types[2612], NULLOT, NULLOT, &_types[202] },
    { "x25AdmnPacketSequencing", "1.3.6.1.2.1.10.5.1.1.4", &_names[202],
      (OS) 196, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[199], &_types[203], NULLOT, &_types[203] },
    { "x25AdmnRestartTimer", "1.3.6.1.2.1.10.5.1.1.5", &_names[203],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2564], &_types[204], NULLOT, &_types[204] },
    { "x25AdmnCallTimer", "1.3.6.1.2.1.10.5.1.1.6", &_names[204],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[203], &_types[205], NULLOT, &_types[205] },
    { "x25AdmnResetTimer", "1.3.6.1.2.1.10.5.1.1.7", &_names[205],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[204], &_types[206], NULLOT, &_types[206] },
    { "x25AdmnClearTimer", "1.3.6.1.2.1.10.5.1.1.8", &_names[206],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[205], &_types[207], NULLOT, &_types[207] },
    { "x25AdmnWindowTimer", "1.3.6.1.2.1.10.5.1.1.9", &_names[207],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[206], &_types[208], NULLOT, &_types[208] },
    { "x25AdmnDataRxmtTimer", "1.3.6.1.2.1.10.5.1.1.10", &_names[208],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[207], &_types[209], NULLOT, &_types[209] },
    { "x25AdmnInterruptTimer", "1.3.6.1.2.1.10.5.1.1.11", &_names[209],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[208], &_types[210], NULLOT, &_types[210] },
    { "x25AdmnRejectTimer", "1.3.6.1.2.1.10.5.1.1.12", &_names[210],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[209], &_types[211], NULLOT, &_types[211] },
    { "x25AdmnRegistrationRequestTimer", "1.3.6.1.2.1.10.5.1.1.13", &_names[211],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[210], &_types[212], NULLOT, &_types[212] },
    { "x25AdmnMinimumRecallTimer", "1.3.6.1.2.1.10.5.1.1.14", &_names[212],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[211], &_types[219], NULLOT, &_types[213] },
    { "x25AdmnRestartCount", "1.3.6.1.2.1.10.5.1.1.15", &_names[213],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2605], &_types[214], NULLOT, &_types[214] },
    { "x25AdmnResetCount", "1.3.6.1.2.1.10.5.1.1.16", &_names[214],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[213], &_types[215], NULLOT, &_types[215] },
    { "x25AdmnClearCount", "1.3.6.1.2.1.10.5.1.1.17", &_names[215],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[214], &_types[216], NULLOT, &_types[216] },
    { "x25AdmnDataRxmtCount", "1.3.6.1.2.1.10.5.1.1.18", &_names[216],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[215], &_types[217], NULLOT, &_types[217] },
    { "x25AdmnRejectCount", "1.3.6.1.2.1.10.5.1.1.19", &_names[217],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[216], &_types[218], NULLOT, &_types[218] },
    { "x25AdmnRegistrationRequestCount", "1.3.6.1.2.1.10.5.1.1.20", &_names[218],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[217], &_types[200], NULLOT, &_types[219] },
    { "x25AdmnNumberPVCs", "1.3.6.1.2.1.10.5.1.1.21", &_names[219],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4096,
      NULL, NULL, NULL,
      NULLOT, &_types[220], NULLOT, &_types[220] },
    { "x25AdmnDefCallParamId", "1.3.6.1.2.1.10.5.1.1.22", &_names[220],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2320], &_types[222], NULLOT, &_types[221] },
    { "x25AdmnLocalAddress", "1.3.6.1.2.1.10.5.1.1.23", &_names[221],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[2745], &_types[199], NULLOT, &_types[222] },
    { "x25AdmnProtocolVersionSupported", "1.3.6.1.2.1.10.5.1.1.24", &_names[222],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2673], &_types[201], NULLOT, &_types[223] },
    { "x25OperTable", "1.3.6.1.2.1.10.5.2", &_names[223],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[197], &_types[250], &_types[224], &_types[224] },
    { "x25OperEntry", "1.3.6.1.2.1.10.5.2.1", &_names[224],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25OperIndex", NULL, NULL,
      &_types[198], NULLOT, &_types[239], &_types[225] },
    { "x25OperIndex", "1.3.6.1.2.1.10.5.2.1.1", &_names[225],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[202], &_types[228], NULLOT, &_types[226] },
    { "x25OperInterfaceMode", "1.3.6.1.2.1.10.5.2.1.2", &_names[226],
      (OS) 197, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[200], &_types[247], NULLOT, &_types[227] },
    { "x25OperMaxActiveCircuits", "1.3.6.1.2.1.10.5.2.1.3", &_names[227],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4096,
      NULL, NULL, NULL,
      &_types[201], NULLOT, NULLOT, &_types[228] },
    { "x25OperPacketSequencing", "1.3.6.1.2.1.10.5.2.1.4", &_names[228],
      (OS) 198, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[225], &_types[229], NULLOT, &_types[229] },
    { "x25OperRestartTimer", "1.3.6.1.2.1.10.5.2.1.5", &_names[229],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[212], &_types[230], NULLOT, &_types[230] },
    { "x25OperCallTimer", "1.3.6.1.2.1.10.5.2.1.6", &_names[230],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[229], &_types[231], NULLOT, &_types[231] },
    { "x25OperResetTimer", "1.3.6.1.2.1.10.5.2.1.7", &_names[231],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[230], &_types[232], NULLOT, &_types[232] },
    { "x25OperClearTimer", "1.3.6.1.2.1.10.5.2.1.8", &_names[232],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[231], &_types[233], NULLOT, &_types[233] },
    { "x25OperWindowTimer", "1.3.6.1.2.1.10.5.2.1.9", &_names[233],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[232], &_types[234], NULLOT, &_types[234] },
    { "x25OperDataRxmtTimer", "1.3.6.1.2.1.10.5.2.1.10", &_names[234],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[233], &_types[235], NULLOT, &_types[235] },
    { "x25OperInterruptTimer", "1.3.6.1.2.1.10.5.2.1.11", &_names[235],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[234], &_types[236], NULLOT, &_types[236] },
    { "x25OperRejectTimer", "1.3.6.1.2.1.10.5.2.1.12", &_names[236],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[235], &_types[237], NULLOT, &_types[237] },
    { "x25OperRegistrationRequestTimer", "1.3.6.1.2.1.10.5.2.1.13", &_names[237],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[236], &_types[238], NULLOT, &_types[238] },
    { "x25OperMinimumRecallTimer", "1.3.6.1.2.1.10.5.2.1.14", &_names[238],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[237], &_types[245], NULLOT, &_types[239] },
    { "x25OperRestartCount", "1.3.6.1.2.1.10.5.2.1.15", &_names[239],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[218], &_types[240], NULLOT, &_types[240] },
    { "x25OperResetCount", "1.3.6.1.2.1.10.5.2.1.16", &_names[240],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[239], &_types[241], NULLOT, &_types[241] },
    { "x25OperClearCount", "1.3.6.1.2.1.10.5.2.1.17", &_names[241],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[240], &_types[242], NULLOT, &_types[242] },
    { "x25OperDataRxmtCount", "1.3.6.1.2.1.10.5.2.1.18", &_names[242],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[241], &_types[243], NULLOT, &_types[243] },
    { "x25OperRejectCount", "1.3.6.1.2.1.10.5.2.1.19", &_names[243],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[242], &_types[244], NULLOT, &_types[244] },
    { "x25OperRegistrationRequestCount", "1.3.6.1.2.1.10.5.2.1.20", &_names[244],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[243], &_types[226], NULLOT, &_types[245] },
    { "x25OperNumberPVCs", "1.3.6.1.2.1.10.5.2.1.21", &_names[245],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4096,
      NULL, NULL, NULL,
      &_types[219], &_types[246], NULLOT, &_types[246] },
    { "x25OperDefCallParamId", "1.3.6.1.2.1.10.5.2.1.22", &_names[246],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[220], &_types[248], NULLOT, &_types[247] },
    { "x25OperLocalAddress", "1.3.6.1.2.1.10.5.2.1.23", &_names[247],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[221], &_types[225], NULLOT, &_types[248] },
    { "x25OperDataLinkId", "1.3.6.1.2.1.10.5.2.1.24", &_names[248],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[246], &_types[249], NULLOT, &_types[249] },
    { "x25OperProtocolVersionSupported", "1.3.6.1.2.1.10.5.2.1.25", &_names[249],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[222], &_types[227], NULLOT, &_types[250] },
    { "x25StatTable", "1.3.6.1.2.1.10.5.3", &_names[250],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[223], &_types[277], &_types[251], &_types[251] },
    { "x25StatEntry", "1.3.6.1.2.1.10.5.3.1", &_names[251],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25StatIndex", NULL, NULL,
      &_types[224], NULLOT, &_types[260], &_types[252] },
    { "x25StatIndex", "1.3.6.1.2.1.10.5.3.1.1", &_names[252],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[228], &_types[255], NULLOT, &_types[253] },
    { "x25StatInCalls", "1.3.6.1.2.1.10.5.3.1.2", &_names[253],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2735], &_types[263], NULLOT, &_types[254] },
    { "x25StatInCallRefusals", "1.3.6.1.2.1.10.5.3.1.3", &_names[254],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2716], &_types[259], NULLOT, &_types[255] },
    { "x25StatInProviderInitiatedClears", "1.3.6.1.2.1.10.5.3.1.4", &_names[255],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2717], &_types[269], NULLOT, &_types[256] },
    { "x25StatInRemotelyInitiatedResets", "1.3.6.1.2.1.10.5.3.1.5", &_names[256],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2622], &_types[257], NULLOT, &_types[257] },
    { "x25StatInProviderInitiatedResets", "1.3.6.1.2.1.10.5.3.1.6", &_names[257],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[256], &_types[258], NULLOT, &_types[258] },
    { "x25StatInRestarts", "1.3.6.1.2.1.10.5.3.1.7", &_names[258],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[257], &_types[252], NULLOT, &_types[259] },
    { "x25StatInDataPackets", "1.3.6.1.2.1.10.5.3.1.8", &_names[259],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2505], &_types[265], NULLOT, &_types[260] },
    { "x25StatInAccusedOfProtocolErrors", "1.3.6.1.2.1.10.5.3.1.9", &_names[260],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2719], &_types[262], NULLOT, &_types[261] },
    { "x25StatInInterrupts", "1.3.6.1.2.1.10.5.3.1.10", &_names[261],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1973], &_types[264], NULLOT, &_types[262] },
    { "x25StatOutCallAttempts", "1.3.6.1.2.1.10.5.3.1.11", &_names[262],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[247], &_types[256], NULLOT, &_types[263] },
    { "x25StatOutCallFailures", "1.3.6.1.2.1.10.5.3.1.12", &_names[263],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[253], &_types[261], NULLOT, &_types[264] },
    { "x25StatOutInterrupts", "1.3.6.1.2.1.10.5.3.1.13", &_names[264],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[261], &_types[266], NULLOT, &_types[265] },
    { "x25StatOutDataPackets", "1.3.6.1.2.1.10.5.3.1.14", &_names[265],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[259], &_types[275], NULLOT, &_types[266] },
    { "x25StatOutgoingCircuits", "1.3.6.1.2.1.10.5.3.1.15", &_names[266],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[227], &_types[267], NULLOT, &_types[267] },
    { "x25StatIncomingCircuits", "1.3.6.1.2.1.10.5.3.1.16", &_names[267],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[266], &_types[268], NULLOT, &_types[268] },
    { "x25StatTwowayCircuits", "1.3.6.1.2.1.10.5.3.1.17", &_names[268],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[267], NULLOT, NULLOT, &_types[269] },
    { "x25StatRestartTimeouts", "1.3.6.1.2.1.10.5.3.1.18", &_names[269],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[238], &_types[270], NULLOT, &_types[270] },
    { "x25StatCallTimeouts", "1.3.6.1.2.1.10.5.3.1.19", &_names[270],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[269], &_types[271], NULLOT, &_types[271] },
    { "x25StatResetTimeouts", "1.3.6.1.2.1.10.5.3.1.20", &_names[271],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[270], &_types[272], NULLOT, &_types[272] },
    { "x25StatClearTimeouts", "1.3.6.1.2.1.10.5.3.1.21", &_names[272],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[271], &_types[273], NULLOT, &_types[273] },
    { "x25StatDataRxmtTimeouts", "1.3.6.1.2.1.10.5.3.1.22", &_names[273],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[272], &_types[274], NULLOT, &_types[274] },
    { "x25StatInterruptTimeouts", "1.3.6.1.2.1.10.5.3.1.23", &_names[274],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[273], &_types[254], NULLOT, &_types[275] },
    { "x25StatRetryCountExceededs", "1.3.6.1.2.1.10.5.3.1.24", &_names[275],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2672], &_types[276], NULLOT, &_types[276] },
    { "x25StatClearCountExceededs", "1.3.6.1.2.1.10.5.3.1.25", &_names[276],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[275], &_types[253], NULLOT, &_types[277] },
    { "x25ChannelTable", "1.3.6.1.2.1.10.5.4", &_names[277],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[250], &_types[286], &_types[278], &_types[278] },
    { "x25ChannelEntry", "1.3.6.1.2.1.10.5.4.1", &_names[278],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25ChannelIndex", NULL, NULL,
      &_types[251], NULLOT, &_types[280], &_types[279] },
    { "x25ChannelIndex", "1.3.6.1.2.1.10.5.4.1.1", &_names[279],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[252], NULLOT, NULLOT, &_types[280] },
    { "x25ChannelLIC", "1.3.6.1.2.1.10.5.4.1.2", &_names[280],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[357], &_types[281], NULLOT, &_types[281] },
    { "x25ChannelHIC", "1.3.6.1.2.1.10.5.4.1.3", &_names[281],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[280], &_types[282], NULLOT, &_types[282] },
    { "x25ChannelLTC", "1.3.6.1.2.1.10.5.4.1.4", &_names[282],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[281], &_types[283], NULLOT, &_types[283] },
    { "x25ChannelHTC", "1.3.6.1.2.1.10.5.4.1.5", &_names[283],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[282], &_types[284], NULLOT, &_types[284] },
    { "x25ChannelLOC", "1.3.6.1.2.1.10.5.4.1.6", &_names[284],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[283], &_types[285], NULLOT, &_types[285] },
    { "x25ChannelHOC", "1.3.6.1.2.1.10.5.4.1.7", &_names[285],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[284], &_types[279], NULLOT, &_types[286] },
    { "x25CircuitTable", "1.3.6.1.2.1.10.5.5", &_names[286],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[277], &_types[311], &_types[287], &_types[287] },
    { "x25CircuitEntry", "1.3.6.1.2.1.10.5.5.1", &_names[287],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25CircuitIndex x25CircuitChannel", NULL, NULL,
      &_types[278], NULLOT, &_types[294], &_types[288] },
    { "x25CircuitIndex", "1.3.6.1.2.1.10.5.5.1.1", &_names[288],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[279], &_types[289], NULLOT, &_types[289] },
    { "x25CircuitChannel", "1.3.6.1.2.1.10.5.5.1.2", &_names[289],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[255], &_types[291], NULLOT, &_types[290] },
    { "x25CircuitStatus", "1.3.6.1.2.1.10.5.5.1.3", &_names[290],
      (OS) 199, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[258], &_types[293], NULLOT, &_types[291] },
    { "x25CircuitEstablishTime", "1.3.6.1.2.1.10.5.5.1.4", &_names[291],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[274], &_types[301], NULLOT, &_types[292] },
    { "x25CircuitDirection", "1.3.6.1.2.1.10.5.5.1.5", &_names[292],
      (OS) 200, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2685], NULLOT, NULLOT, &_types[293] },
    { "x25CircuitInOctets", "1.3.6.1.2.1.10.5.5.1.6", &_names[293],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[290], &_types[295], NULLOT, &_types[294] },
    { "x25CircuitInPdus", "1.3.6.1.2.1.10.5.5.1.7", &_names[294],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[262], &_types[299], NULLOT, &_types[295] },
    { "x25CircuitInRemotelyInitiatedResets", "1.3.6.1.2.1.10.5.5.1.8", &_names[295],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[293], &_types[296], NULLOT, &_types[296] },
    { "x25CircuitInProviderInitiatedResets", "1.3.6.1.2.1.10.5.5.1.9", &_names[296],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[295], &_types[298], NULLOT, &_types[297] },
    { "x25CircuitInInterrupts", "1.3.6.1.2.1.10.5.5.1.10", &_names[297],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[264], &_types[300], NULLOT, &_types[298] },
    { "x25CircuitOutOctets", "1.3.6.1.2.1.10.5.5.1.11", &_names[298],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[296], &_types[288], NULLOT, &_types[299] },
    { "x25CircuitOutPdus", "1.3.6.1.2.1.10.5.5.1.12", &_names[299],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[294], &_types[305], NULLOT, &_types[300] },
    { "x25CircuitOutInterrupts", "1.3.6.1.2.1.10.5.5.1.13", &_names[300],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[297], &_types[292], NULLOT, &_types[301] },
    { "x25CircuitDataRetransmissionTimeouts", "1.3.6.1.2.1.10.5.5.1.14", &_names[301],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[291], &_types[302], NULLOT, &_types[302] },
    { "x25CircuitResetTimeouts", "1.3.6.1.2.1.10.5.5.1.15", &_names[302],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[301], &_types[303], NULLOT, &_types[303] },
    { "x25CircuitInterruptTimeouts", "1.3.6.1.2.1.10.5.5.1.16", &_names[303],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[302], &_types[304], NULLOT, &_types[304] },
    { "x25CircuitCallParamId", "1.3.6.1.2.1.10.5.5.1.17", &_names[304],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[248], &_types[308], NULLOT, &_types[305] },
    { "x25CircuitCalledDteAddress", "1.3.6.1.2.1.10.5.5.1.18", &_names[305],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[299], &_types[306], NULLOT, &_types[306] },
    { "x25CircuitCallingDteAddress", "1.3.6.1.2.1.10.5.5.1.19", &_names[306],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[305], &_types[307], NULLOT, &_types[307] },
    { "x25CircuitOriginallyCalledAddress", "1.3.6.1.2.1.10.5.5.1.20", &_names[307],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[306], &_types[290], NULLOT, &_types[308] },
    { "x25CircuitDescr", "1.3.6.1.2.1.10.5.5.1.21", &_names[308],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2715], &_types[297], NULLOT, &_types[309] },
    { "x25ClearedCircuitEntriesRequested", "1.3.6.1.2.1.10.5.6", &_names[309],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2492], &_types[310], NULLOT, &_types[310] },
    { "x25ClearedCircuitEntriesGranted", "1.3.6.1.2.1.10.5.7", &_names[310],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2731], &_types[197], NULLOT, &_types[311] },
    { "x25ClearedCircuitTable", "1.3.6.1.2.1.10.5.8", &_names[311],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[286], &_types[325], &_types[312], &_types[312] },
    { "x25ClearedCircuitEntry", "1.3.6.1.2.1.10.5.8.1", &_names[312],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25ClearedCircuitIndex", NULL, NULL,
      &_types[287], NULLOT, &_types[315], &_types[313] },
    { "x25ClearedCircuitIndex", "1.3.6.1.2.1.10.5.8.1.1", &_names[313],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[288], &_types[314], NULLOT, &_types[314] },
    { "x25ClearedCircuitPleIndex", "1.3.6.1.2.1.10.5.8.1.2", &_names[314],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[313], &_types[316], NULLOT, &_types[315] },
    { "x25ClearedCircuitTimeEstablished", "1.3.6.1.2.1.10.5.8.1.3", &_names[315],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2478], &_types[320], NULLOT, &_types[316] },
    { "x25ClearedCircuitTimeCleared", "1.3.6.1.2.1.10.5.8.1.4", &_names[316],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[289], &_types[317], NULLOT, &_types[317] },
    { "x25ClearedCircuitChannel", "1.3.6.1.2.1.10.5.8.1.5", &_names[317],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4095,
      NULL, NULL, NULL,
      &_types[316], &_types[319], NULLOT, &_types[318] },
    { "x25ClearedCircuitClearingCause", "1.3.6.1.2.1.10.5.8.1.6", &_names[318],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2571], &_types[324], NULLOT, &_types[319] },
    { "x25ClearedCircuitDiagnosticCode", "1.3.6.1.2.1.10.5.8.1.7", &_names[319],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[303], &_types[318], NULLOT, &_types[320] },
    { "x25ClearedCircuitInPdus", "1.3.6.1.2.1.10.5.8.1.8", &_names[320],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[307], &_types[321], NULLOT, &_types[321] },
    { "x25ClearedCircuitOutPdus", "1.3.6.1.2.1.10.5.8.1.9", &_names[321],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[320], &_types[322], NULLOT, &_types[322] },
    { "x25ClearedCircuitCalledAddress", "1.3.6.1.2.1.10.5.8.1.10", &_names[322],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[321], &_types[323], NULLOT, &_types[323] },
    { "x25ClearedCircuitCallingAddress", "1.3.6.1.2.1.10.5.8.1.11", &_names[323],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[322], &_types[313], NULLOT, &_types[324] },
    { "x25ClearedCircuitClearFacilities", "1.3.6.1.2.1.10.5.8.1.12", &_names[324],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 109,
      NULL, NULL, NULL,
      &_types[2232], NULLOT, NULLOT, &_types[325] },
    { "x25CallParmTable", "1.3.6.1.2.1.10.5.9", &_names[325],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[311], NULLOT, &_types[326], &_types[326] },
    { "x25CallParmEntry", "1.3.6.1.2.1.10.5.9.1", &_names[326],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "x25CallParmIndex", NULL, NULL,
      &_types[312], NULLOT, &_types[348], &_types[327] },
    { "x25CallParmIndex", "1.3.6.1.2.1.10.5.9.1.1", &_names[327],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[314], &_types[334], NULLOT, &_types[328] },
    { "x25CallParmStatus", "1.3.6.1.2.1.10.5.9.1.2", &_names[328],
      (OS) 201, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[298], &_types[327], NULLOT, &_types[329] },
    { "x25CallParmRefCount", "1.3.6.1.2.1.10.5.9.1.3", &_names[329],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[244], &_types[351], NULLOT, &_types[330] },
    { "x25CallParmInPacketSize", "1.3.6.1.2.1.10.5.9.1.4", &_names[330],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4096,
      NULL, NULL, NULL,
      &_types[2741], &_types[331], NULLOT, &_types[331] },
    { "x25CallParmOutPacketSize", "1.3.6.1.2.1.10.5.9.1.5", &_names[331],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4096,
      NULL, NULL, NULL,
      &_types[330], &_types[332], NULLOT, &_types[332] },
    { "x25CallParmInWindowSize", "1.3.6.1.2.1.10.5.9.1.6", &_names[332],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[331], &_types[333], NULLOT, &_types[333] },
    { "x25CallParmOutWindowSize", "1.3.6.1.2.1.10.5.9.1.7", &_names[333],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[332], &_types[337], NULLOT, &_types[334] },
    { "x25CallParmAcceptReverseCharging", "1.3.6.1.2.1.10.5.9.1.8", &_names[334],
      (OS) 202, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[317], &_types[335], NULLOT, &_types[335] },
    { "x25CallParmProposeReverseCharging", "1.3.6.1.2.1.10.5.9.1.9", &_names[335],
      (OS) 203, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[334], &_types[336], NULLOT, &_types[336] },
    { "x25CallParmFastSelect", "1.3.6.1.2.1.10.5.9.1.10", &_names[336],
      (OS) 204, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2730], &_types[353], NULLOT, &_types[337] },
    { "x25CallParmInThruPutClasSize", "1.3.6.1.2.1.10.5.9.1.11", &_names[337],
      (OS) 205, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[333], &_types[338], NULLOT, &_types[338] },
    { "x25CallParmOutThruPutClasSize", "1.3.6.1.2.1.10.5.9.1.12", &_names[338],
      (OS) 206, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[337], &_types[342], NULLOT, &_types[339] },
    { "x25CallParmCug", "1.3.6.1.2.1.10.5.9.1.13", &_names[339],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4,
      NULL, NULL, NULL,
      &_types[325], &_types[340], NULLOT, &_types[340] },
    { "x25CallParmCugoa", "1.3.6.1.2.1.10.5.9.1.14", &_names[340],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 4,
      NULL, NULL, NULL,
      &_types[339], &_types[344], NULLOT, &_types[341] },
    { "x25CallParmBcug", "1.3.6.1.2.1.10.5.9.1.15", &_names[341],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 3,
      NULL, NULL, NULL,
      &_types[2609], &_types[345], NULLOT, &_types[342] },
    { "x25CallParmNui", "1.3.6.1.2.1.10.5.9.1.16", &_names[342],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 108,
      NULL, NULL, NULL,
      &_types[226], &_types[343], NULLOT, &_types[343] },
    { "x25CallParmChargingInfo", "1.3.6.1.2.1.10.5.9.1.17", &_names[343],
      (OS) 207, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[323], &_types[346], NULLOT, &_types[344] },
    { "x25CallParmRpoa", "1.3.6.1.2.1.10.5.9.1.18", &_names[344],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 108,
      NULL, NULL, NULL,
      &_types[2469], &_types[355], NULLOT, &_types[345] },
    { "x25CallParmTrnstDly", "1.3.6.1.2.1.10.5.9.1.19", &_names[345],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65537,
      NULL, NULL, NULL,
      NULLOT, &_types[350], NULLOT, &_types[346] },
    { "x25CallParmCallingExt", "1.3.6.1.2.1.10.5.9.1.20", &_names[346],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 40,
      NULL, NULL, NULL,
      &_types[343], &_types[347], NULLOT, &_types[347] },
    { "x25CallParmCalledExt", "1.3.6.1.2.1.10.5.9.1.21", &_names[347],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 40,
      NULL, NULL, NULL,
      &_types[346], &_types[328], NULLOT, &_types[348] },
    { "x25CallParmInMinThuPutCls", "1.3.6.1.2.1.10.5.9.1.22", &_names[348],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[3094], &_types[349], NULLOT, &_types[349] },
    { "x25CallParmOutMinThuPutCls", "1.3.6.1.2.1.10.5.9.1.23", &_names[349],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[348], &_types[329], NULLOT, &_types[350] },
    { "x25CallParmEndTrnsDly", "1.3.6.1.2.1.10.5.9.1.24", &_names[350],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 6,
      NULL, NULL, NULL,
      &_types[345], &_types[352], NULLOT, &_types[351] },
    { "x25CallParmPriority", "1.3.6.1.2.1.10.5.9.1.25", &_names[351],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 6,
      NULL, NULL, NULL,
      &_types[2703], &_types[330], NULLOT, &_types[352] },
    { "x25CallParmProtection", "1.3.6.1.2.1.10.5.9.1.26", &_names[352],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 108,
      NULL, NULL, NULL,
      &_types[292], NULLOT, NULLOT, &_types[353] },
    { "x25CallParmExptData", "1.3.6.1.2.1.10.5.9.1.27", &_names[353],
      (OS) 208, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[318], &_types[354], NULLOT, &_types[354] },
    { "x25CallParmUserData", "1.3.6.1.2.1.10.5.9.1.28", &_names[354],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 128,
      NULL, NULL, NULL,
      &_types[353], &_types[339], NULLOT, &_types[355] },
    { "x25CallParmCallingNetworkFacilities", "1.3.6.1.2.1.10.5.9.1.29", &_names[355],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 108,
      NULL, NULL, NULL,
      &_types[324], &_types[356], NULLOT, &_types[356] },
    { "x25CallParmCalledNetworkFacilities", "1.3.6.1.2.1.10.5.9.1.30", &_names[356],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 108,
      NULL, NULL, NULL,
      &_types[355], &_types[341], NULLOT, &_types[357] },
    { "x25ProtocolVersion", "1.3.6.1.2.1.10.5.10", &_names[357],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2620], &_types[309], &_types[358], &_types[358] },
    { "x25protocolCcittV1976", "1.3.6.1.2.1.10.5.10.1", &_names[358],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[359], NULLOT, &_types[359] },
    { "x25protocolCcittV1980", "1.3.6.1.2.1.10.5.10.2", &_names[359],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[358], &_types[360], NULLOT, &_types[360] },
    { "x25protocolCcittV1984", "1.3.6.1.2.1.10.5.10.3", &_names[360],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[359], &_types[361], NULLOT, &_types[361] },
    { "x25protocolCcittV1988", "1.3.6.1.2.1.10.5.10.4", &_names[361],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[360], &_types[362], NULLOT, &_types[362] },
    { "x25protocolIso8208V1987", "1.3.6.1.2.1.10.5.10.5", &_names[362],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[361], &_types[363], NULLOT, &_types[363] },
    { "x25protocolIso8208V1989", "1.3.6.1.2.1.10.5.10.6", &_names[363],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[362], NULLOT, NULLOT, &_types[364] },
    { "dot3", "1.3.6.1.2.1.10.7", &_names[364],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[329], &_types[405], &_types[387], &_types[365] },
    { "dot3StatsTable", "1.3.6.1.2.1.10.7.2", &_names[365],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[340], &_types[380], &_types[366], &_types[366] },
    { "dot3StatsEntry", "1.3.6.1.2.1.10.7.2.1", &_names[366],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot3StatsIndex", NULL, NULL,
      &_types[326], NULLOT, &_types[378], &_types[367] },
    { "dot3StatsIndex", "1.3.6.1.2.1.10.7.2.1.1", &_names[367],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[327], &_types[370], NULLOT, &_types[368] },
    { "dot3StatsAlignmentErrors", "1.3.6.1.2.1.10.7.2.1.2", &_names[368],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[389], &_types[369], NULLOT, &_types[369] },
    { "dot3StatsFCSErrors", "1.3.6.1.2.1.10.7.2.1.3", &_names[369],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[368], &_types[372], NULLOT, &_types[370] },
    { "dot3StatsSingleCollisionFrames", "1.3.6.1.2.1.10.7.2.1.4", &_names[370],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[365], &_types[371], NULLOT, &_types[371] },
    { "dot3StatsMultipleCollisionFrames", "1.3.6.1.2.1.10.7.2.1.5", &_names[371],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[370], &_types[373], NULLOT, &_types[372] },
    { "dot3StatsSQETestErrors", "1.3.6.1.2.1.10.7.2.1.6", &_names[372],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[369], &_types[376], NULLOT, &_types[373] },
    { "dot3StatsDeferredTransmissions", "1.3.6.1.2.1.10.7.2.1.7", &_names[373],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2193], NULLOT, NULLOT, &_types[374] },
    { "dot3StatsLateCollisions", "1.3.6.1.2.1.10.7.2.1.8", &_names[374],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[328], &_types[375], NULLOT, &_types[375] },
    { "dot3StatsExcessiveCollisions", "1.3.6.1.2.1.10.7.2.1.9", &_names[375],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[374], &_types[367], NULLOT, &_types[376] },
    { "dot3StatsInternalMacTransmitErrors", "1.3.6.1.2.1.10.7.2.1.10", &_names[376],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[372], &_types[377], NULLOT, &_types[377] },
    { "dot3StatsCarrierSenseErrors", "1.3.6.1.2.1.10.7.2.1.11", &_names[377],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[376], &_types[379], NULLOT, &_types[378] },
    { "dot3StatsFrameTooLongs", "1.3.6.1.2.1.10.7.2.1.13", &_names[378],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[366], &_types[368], NULLOT, &_types[379] },
    { "dot3StatsInternalMacReceiveErrors", "1.3.6.1.2.1.10.7.2.1.16", &_names[379],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[377], &_types[374], NULLOT, &_types[380] },
    { "dot3CollTable", "1.3.6.1.2.1.10.7.5", &_names[380],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[371], NULLOT, &_types[381], &_types[381] },
    { "dot3CollEntry", "1.3.6.1.2.1.10.7.5.1", &_names[381],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot3CollIndex dot3CollCount", NULL, NULL,
      &_types[378], NULLOT, &_types[383], &_types[382] },
    { "dot3CollIndex", "1.3.6.1.2.1.10.7.5.1.1", &_names[382],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[367], &_types[384], NULLOT, &_types[383] },
    { "dot3CollCount", "1.3.6.1.2.1.10.7.5.1.2", &_names[383],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 16,
      NULL, NULL, NULL,
      &_types[364], &_types[382], NULLOT, &_types[384] },
    { "dot3CollFrequencies", "1.3.6.1.2.1.10.7.5.1.3", &_names[384],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2621], NULLOT, NULLOT, &_types[385] },
    { "dot3Tests", "1.3.6.1.2.1.10.7.6", &_names[385],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[342], &_types[390], &_types[386], &_types[386] },
    { "dot3TestTdr", "1.3.6.1.2.1.10.7.6.1", &_names[386],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[385], NULLOT, NULLOT, &_types[387] },
    { "dot3Errors", "1.3.6.1.2.1.10.7.7", &_names[387],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[260], &_types[385], &_types[388], &_types[388] },
    { "dot3ErrorInitError", "1.3.6.1.2.1.10.7.7.1", &_names[388],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[387], &_types[389], NULLOT, &_types[389] },
    { "dot3ErrorLoopbackError", "1.3.6.1.2.1.10.7.7.2", &_names[389],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[388], NULLOT, NULLOT, &_types[390] },
    { "dot3ChipSets", "1.3.6.1.2.1.10.7.8", &_names[390],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[386], &_types[365], &_types[399], &_types[391] },
    { "dot3ChipSetAMD", "1.3.6.1.2.1.10.7.8.1", &_names[391],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[338], NULLOT, &_types[392], &_types[392] },
    { "dot3ChipSetAMD7990", "1.3.6.1.2.1.10.7.8.1.1", &_names[392],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[393], NULLOT, &_types[393] },
    { "dot3ChipSetAMD79900", "1.3.6.1.2.1.10.7.8.1.2", &_names[393],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[392], NULLOT, NULLOT, &_types[394] },
    { "dot3ChipSetIntel", "1.3.6.1.2.1.10.7.8.2", &_names[394],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[300], &_types[391], &_types[395], &_types[395] },
    { "dot3ChipSetIntel82586", "1.3.6.1.2.1.10.7.8.2.1", &_names[395],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[394], &_types[396], NULLOT, &_types[396] },
    { "dot3ChipSetIntel82596", "1.3.6.1.2.1.10.7.8.2.2", &_names[396],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[395], NULLOT, NULLOT, &_types[397] },
    { "dot3ChipSetSeeq", "1.3.6.1.2.1.10.7.8.3", &_names[397],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[254], &_types[394], &_types[398], &_types[398] },
    { "dot3ChipSetSeeq8003", "1.3.6.1.2.1.10.7.8.3.1", &_names[398],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[397], NULLOT, NULLOT, &_types[399] },
    { "dot3ChipSetNational", "1.3.6.1.2.1.10.7.8.4", &_names[399],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[347], &_types[402], &_types[400], &_types[400] },
    { "dot3ChipSetNational8390", "1.3.6.1.2.1.10.7.8.4.1", &_names[400],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[399], &_types[401], NULLOT, &_types[401] },
    { "dot3ChipSetNationalSonic", "1.3.6.1.2.1.10.7.8.4.2", &_names[401],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[265], NULLOT, NULLOT, &_types[402] },
    { "dot3ChipSetFujitsu", "1.3.6.1.2.1.10.7.8.5", &_names[402],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2666], &_types[397], &_types[403], &_types[403] },
    { "dot3ChipSetFujitsu86950", "1.3.6.1.2.1.10.7.8.5.1", &_names[403],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[402], &_types[404], NULLOT, &_types[404] },
    { "dot3ChipSetFujitsu86960", "1.3.6.1.2.1.10.7.8.5.2", &_names[404],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[403], NULLOT, NULLOT, &_types[405] },
    { "dot4", "1.3.6.1.2.1.10.8", &_names[405],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[383], &_types[463], &_types[456], &_types[406] },
    { "dot4Table", "1.3.6.1.2.1.10.8.1", &_names[406],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[380], &_types[427], &_types[407], &_types[407] },
    { "dot4Entry", "1.3.6.1.2.1.10.8.1.1", &_names[407],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot4IfIndex", NULL, NULL,
      &_types[381], NULLOT, &_types[423], &_types[408] },
    { "dot4IfIndex", "1.3.6.1.2.1.10.8.1.1.1", &_names[408],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[382], &_types[415], NULLOT, &_types[409] },
    { "dot4Options", "1.3.6.1.2.1.10.8.1.1.2", &_names[409],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2726], NULLOT, NULLOT, &_types[410] },
    { "dot4State", "1.3.6.1.2.1.10.8.1.1.3", &_names[410],
      (OS) 209, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[375], &_types[413], NULLOT, &_types[411] },
    { "dot4Commands", "1.3.6.1.2.1.10.8.1.1.4", &_names[411],
      (OS) 210, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[400], &_types[422], NULLOT, &_types[412] },
    { "dot4MacAddrLen", "1.3.6.1.2.1.10.8.1.1.5", &_names[412],
      (OS) 211, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[406], &_types[421], NULLOT, &_types[413] },
    { "dot4NextStation", "1.3.6.1.2.1.10.8.1.1.6", &_names[413],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[410], &_types[414], NULLOT, &_types[414] },
    { "dot4PreviousStation", "1.3.6.1.2.1.10.8.1.1.7", &_names[414],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[413], &_types[408], NULLOT, &_types[415] },
    { "dot4SlotTime", "1.3.6.1.2.1.10.8.1.1.8", &_names[415],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[319], &_types[416], NULLOT, &_types[416] },
    { "dot4LastTokenRotTime", "1.3.6.1.2.1.10.8.1.1.9", &_names[416],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[415], &_types[417], NULLOT, &_types[417] },
    { "dot4HiPriTokenHoldTime", "1.3.6.1.2.1.10.8.1.1.10", &_names[417],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[416], &_types[418], NULLOT, &_types[418] },
    { "dot4TargetRotTimeClass4", "1.3.6.1.2.1.10.8.1.1.11", &_names[418],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[417], &_types[419], NULLOT, &_types[419] },
    { "dot4TargetRotTimeClass2", "1.3.6.1.2.1.10.8.1.1.12", &_names[419],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[418], &_types[420], NULLOT, &_types[420] },
    { "dot4TargetRotTimeClass0", "1.3.6.1.2.1.10.8.1.1.13", &_names[420],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[419], &_types[412], NULLOT, &_types[421] },
    { "dot4TargetRotTimeRingMaint", "1.3.6.1.2.1.10.8.1.1.14", &_names[421],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[412], &_types[425], NULLOT, &_types[422] },
    { "dot4RingMaintTimerInitValue", "1.3.6.1.2.1.10.8.1.1.15", &_names[422],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[411], &_types[424], NULLOT, &_types[423] },
    { "dot4MaxInterSolicitCount", "1.3.6.1.2.1.10.8.1.1.16", &_names[423],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 16, 255,
      NULL, NULL, NULL,
      &_types[405], &_types[426], NULLOT, &_types[424] },
    { "dot4MaxRetries", "1.3.6.1.2.1.10.8.1.1.17", &_names[424],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[422], &_types[410], NULLOT, &_types[425] },
    { "dot4MinPostSilencePreambLen", "1.3.6.1.2.1.10.8.1.1.18", &_names[425],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[421], &_types[409], NULLOT, &_types[426] },
    { "dot4StandardRevision", "1.3.6.1.2.1.10.8.1.1.19", &_names[426],
      (OS) 212, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[459], &_types[411], NULLOT, &_types[427] },
    { "dot4InitTable", "1.3.6.1.2.1.10.8.2", &_names[427],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[425], &_types[441], &_types[428], &_types[428] },
    { "dot4InitEntry", "1.3.6.1.2.1.10.8.2.1", &_names[428],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot4InitIfIndex", NULL, NULL,
      &_types[407], NULLOT, &_types[431], &_types[429] },
    { "dot4InitIfIndex", "1.3.6.1.2.1.10.8.2.1.1", &_names[429],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[408], &_types[430], NULLOT, &_types[430] },
    { "dot4InitSlotTime", "1.3.6.1.2.1.10.8.2.1.2", &_names[430],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[420], &_types[433], NULLOT, &_types[431] },
    { "dot4InitMaxInterSolicitCount", "1.3.6.1.2.1.10.8.2.1.3", &_names[431],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 16, 255,
      NULL, NULL, NULL,
      &_types[423], &_types[432], NULLOT, &_types[432] },
    { "dot4InitMaxRetries", "1.3.6.1.2.1.10.8.2.1.4", &_names[432],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[424], &_types[438], NULLOT, &_types[433] },
    { "dot4InitHiPriTokenHoldTime", "1.3.6.1.2.1.10.8.2.1.5", &_names[433],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[430], &_types[434], NULLOT, &_types[434] },
    { "dot4InitTargetRotTimeClass4", "1.3.6.1.2.1.10.8.2.1.6", &_names[434],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[433], &_types[435], NULLOT, &_types[435] },
    { "dot4InitTargetRotTimeClass2", "1.3.6.1.2.1.10.8.2.1.7", &_names[435],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[434], &_types[436], NULLOT, &_types[436] },
    { "dot4InitTargetRotTimeClass0", "1.3.6.1.2.1.10.8.2.1.8", &_names[436],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[435], &_types[437], NULLOT, &_types[437] },
    { "dot4InitTargetRotTimeRingMaint", "1.3.6.1.2.1.10.8.2.1.9", &_names[437],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[427], &_types[439], NULLOT, &_types[438] },
    { "dot4InitRingMaintTimerInitValue", "1.3.6.1.2.1.10.8.2.1.10", &_names[438],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[432], &_types[429], NULLOT, &_types[439] },
    { "dot4InitMinPostSilencePreambLen", "1.3.6.1.2.1.10.8.2.1.11", &_names[439],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[437], &_types[440], NULLOT, &_types[440] },
    { "dot4InitInRingDesired", "1.3.6.1.2.1.10.8.2.1.12", &_names[440],
      (OS) 213, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[308], NULLOT, NULLOT, &_types[441] },
    { "dot4StatsTable", "1.3.6.1.2.1.10.8.3", &_names[441],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[439], NULLOT, &_types[442], &_types[442] },
    { "dot4StatsEntry", "1.3.6.1.2.1.10.8.3.1", &_names[442],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot4StatsIfIndex", NULL, NULL,
      &_types[428], NULLOT, &_types[453], &_types[443] },
    { "dot4StatsIfIndex", "1.3.6.1.2.1.10.8.3.1.1", &_names[443],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[429], &_types[449], NULLOT, &_types[444] },
    { "dot4StatsTokenPasses", "1.3.6.1.2.1.10.8.3.1.2", &_names[444],
      (OS) 8, 1, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[461], &_types[446], NULLOT, &_types[445] },
    { "dot4StatsTokenHeards", "1.3.6.1.2.1.10.8.3.1.3", &_names[445],
      (OS) 8, 1, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1339], NULLOT, NULLOT, &_types[446] },
    { "dot4StatsNoSuccessors", "1.3.6.1.2.1.10.8.3.1.4", &_names[446],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[438], &_types[455], NULLOT, &_types[447] },
    { "dot4StatsWhoFollows", "1.3.6.1.2.1.10.8.3.1.5", &_names[447],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[426], &_types[444], NULLOT, &_types[448] },
    { "dot4StatsTokenPassFails", "1.3.6.1.2.1.10.8.3.1.6", &_names[448],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[457], &_types[445], NULLOT, &_types[449] },
    { "dot4StatsNonSilences", "1.3.6.1.2.1.10.8.3.1.7", &_names[449],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[310], &_types[452], NULLOT, &_types[450] },
    { "dot4StatsFcsErrors", "1.3.6.1.2.1.10.8.3.1.8", &_names[450],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[456], &_types[451], NULLOT, &_types[451] },
    { "dot4StatsEbitErrors", "1.3.6.1.2.1.10.8.3.1.9", &_names[451],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[450], &_types[447], NULLOT, &_types[452] },
    { "dot4StatsFrameFrags", "1.3.6.1.2.1.10.8.3.1.10", &_names[452],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[441], &_types[448], NULLOT, &_types[453] },
    { "dot4StatsFrameTooLongs", "1.3.6.1.2.1.10.8.3.1.11", &_names[453],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[442], &_types[454], NULLOT, &_types[454] },
    { "dot4StatsOverRuns", "1.3.6.1.2.1.10.8.3.1.12", &_names[454],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[453], &_types[450], NULLOT, &_types[455] },
    { "dot4StatsDupAddresses", "1.3.6.1.2.1.10.8.3.1.13", &_names[455],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[446], &_types[443], NULLOT, &_types[456] },
    { "dot4Errors", "1.3.6.1.2.1.10.8.4", &_names[456],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[379], &_types[458], &_types[457], &_types[457] },
    { "dot4ModemInitFailed", "1.3.6.1.2.1.10.8.4.1", &_names[457],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[263], NULLOT, NULLOT, &_types[458] },
    { "dot4Tests", "1.3.6.1.2.1.10.8.5", &_names[458],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[390], &_types[461], &_types[460], &_types[459] },
    { "testFifoPath", "1.3.6.1.2.1.10.8.5.1", &_names[459],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[285], NULLOT, NULLOT, &_types[460] },
    { "testExternalLoopback", "1.3.6.1.2.1.10.8.5.2", &_names[460],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[268], &_types[459], NULLOT, &_types[461] },
    { "dot4ChipSets", "1.3.6.1.2.1.10.8.6", &_names[461],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[458], &_types[406], &_types[462], &_types[462] },
    { "chipSetMc68824", "1.3.6.1.2.1.10.8.6.1", &_names[462],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[463] },
    { "dot5", "1.3.6.1.2.1.10.9", &_names[463],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[431], &_types[1228], &_types[496], &_types[464] },
    { "dot5Table", "1.3.6.1.2.1.10.9.1", &_names[464],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[452], &_types[475], &_types[465], &_types[465] },
    { "dot5Entry", "1.3.6.1.2.1.10.9.1.1", &_names[465],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot5IfIndex", NULL, NULL,
      &_types[454], NULLOT, &_types[467], &_types[466] },
    { "dot5IfIndex", "1.3.6.1.2.1.10.9.1.1.1", &_names[466],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[497], &_types[474], NULLOT, &_types[467] },
    { "dot5Commands", "1.3.6.1.2.1.10.9.1.1.2", &_names[467],
      (OS) 214, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[455], &_types[473], NULLOT, &_types[468] },
    { "dot5RingStatus", "1.3.6.1.2.1.10.9.1.1.3", &_names[468],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[414], &_types[469], NULLOT, &_types[469] },
    { "dot5RingState", "1.3.6.1.2.1.10.9.1.1.4", &_names[469],
      (OS) 215, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[468], &_types[470], NULLOT, &_types[470] },
    { "dot5RingOpenStatus", "1.3.6.1.2.1.10.9.1.1.5", &_names[470],
      (OS) 216, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[469], &_types[466], NULLOT, &_types[471] },
    { "dot5RingSpeed", "1.3.6.1.2.1.10.9.1.1.6", &_names[471],
      (OS) 217, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[356], &_types[472], NULLOT, &_types[472] },
    { "dot5UpStream", "1.3.6.1.2.1.10.9.1.1.7", &_names[472],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[350], NULLOT, NULLOT, &_types[473] },
    { "dot5ActMonParticipate", "1.3.6.1.2.1.10.9.1.1.8", &_names[473],
      (OS) 218, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[467], &_types[468], NULLOT, &_types[474] },
    { "dot5Functional", "1.3.6.1.2.1.10.9.1.1.9", &_names[474],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[466], &_types[471], NULLOT, &_types[475] },
    { "dot5StatsTable", "1.3.6.1.2.1.10.9.2", &_names[475],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[464], &_types[502], &_types[476], &_types[476] },
    { "dot5StatsEntry", "1.3.6.1.2.1.10.9.2.1", &_names[476],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot5StatsIfIndex", NULL, NULL,
      &_types[465], NULLOT, &_types[478], &_types[477] },
    { "dot5StatsIfIndex", "1.3.6.1.2.1.10.9.2.1.1", &_names[477],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[474], &_types[490], NULLOT, &_types[478] },
    { "dot5StatsLineErrors", "1.3.6.1.2.1.10.9.2.1.2", &_names[478],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[451], &_types[479], NULLOT, &_types[479] },
    { "dot5StatsBurstErrors", "1.3.6.1.2.1.10.9.2.1.3", &_names[479],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[478], &_types[480], NULLOT, &_types[480] },
    { "dot5StatsACErrors", "1.3.6.1.2.1.10.9.2.1.4", &_names[480],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[479], &_types[481], NULLOT, &_types[481] },
    { "dot5StatsAbortTransErrors", "1.3.6.1.2.1.10.9.2.1.5", &_names[481],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[480], &_types[482], NULLOT, &_types[482] },
    { "dot5StatsInternalErrors", "1.3.6.1.2.1.10.9.2.1.6", &_names[482],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[481], &_types[483], NULLOT, &_types[483] },
    { "dot5StatsLostFrameErrors", "1.3.6.1.2.1.10.9.2.1.7", &_names[483],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[482], &_types[485], NULLOT, &_types[484] },
    { "dot5StatsReceiveCongestions", "1.3.6.1.2.1.10.9.2.1.8", &_names[484],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[501], &_types[492], NULLOT, &_types[485] },
    { "dot5StatsFrameCopiedErrors", "1.3.6.1.2.1.10.9.2.1.9", &_names[485],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[483], &_types[486], NULLOT, &_types[486] },
    { "dot5StatsTokenErrors", "1.3.6.1.2.1.10.9.2.1.10", &_names[486],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[485], &_types[487], NULLOT, &_types[487] },
    { "dot5StatsSoftErrors", "1.3.6.1.2.1.10.9.2.1.11", &_names[487],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[486], &_types[488], NULLOT, &_types[488] },
    { "dot5StatsHardErrors", "1.3.6.1.2.1.10.9.2.1.12", &_names[488],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[487], &_types[495], NULLOT, &_types[489] },
    { "dot5StatsSignalLoss", "1.3.6.1.2.1.10.9.2.1.13", &_names[489],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2610], NULLOT, NULLOT, &_types[490] },
    { "dot5StatsTransmitBeacons", "1.3.6.1.2.1.10.9.2.1.14", &_names[490],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[309], &_types[493], NULLOT, &_types[491] },
    { "dot5StatsRecoverys", "1.3.6.1.2.1.10.9.2.1.15", &_names[491],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[276], &_types[489], NULLOT, &_types[492] },
    { "dot5StatsLobeWires", "1.3.6.1.2.1.10.9.2.1.16", &_names[492],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[470], &_types[477], NULLOT, &_types[493] },
    { "dot5StatsRemoves", "1.3.6.1.2.1.10.9.2.1.17", &_names[493],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[336], &_types[494], NULLOT, &_types[494] },
    { "dot5StatsSingles", "1.3.6.1.2.1.10.9.2.1.18", &_names[494],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[436], &_types[491], NULLOT, &_types[495] },
    { "dot5StatsFreqErrors", "1.3.6.1.2.1.10.9.2.1.19", &_names[495],
      (OS) 8, 1, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[488], &_types[484], NULLOT, &_types[496] },
    { "dot5Tests", "1.3.6.1.2.1.10.9.3", &_names[496],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[444], &_types[498], &_types[497], &_types[497] },
    { "testInsertFunc", "1.3.6.1.2.1.10.9.3.1", &_names[497],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[443], NULLOT, NULLOT, &_types[498] },
    { "dot5ChipSets", "1.3.6.1.2.1.10.9.4", &_names[498],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[496], &_types[464], &_types[500], &_types[499] },
    { "chipSetIBM16", "1.3.6.1.2.1.10.9.4.1", &_names[499],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[500] },
    { "chipSetTItms380", "1.3.6.1.2.1.10.9.4.2", &_names[500],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[498], &_types[501], NULLOT, &_types[501] },
    { "chipSetTItms380c16", "1.3.6.1.2.1.10.9.4.3", &_names[501],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[500], &_types[499], NULLOT, &_types[502] },
    { "dot5TimerTable", "1.3.6.1.2.1.10.9.5", &_names[502],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[475], NULLOT, &_types[503], &_types[503] },
    { "dot5TimerEntry", "1.3.6.1.2.1.10.9.5.1", &_names[503],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot5TimerIfIndex", NULL, NULL,
      &_types[476], NULLOT, &_types[506], &_types[504] },
    { "dot5TimerIfIndex", "1.3.6.1.2.1.10.9.5.1.1", &_names[504],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[477], &_types[505], NULLOT, &_types[505] },
    { "dot5TimerReturnRepeat", "1.3.6.1.2.1.10.9.5.1.2", &_names[505],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2539], &_types[512], NULLOT, &_types[506] },
    { "dot5TimerHolding", "1.3.6.1.2.1.10.9.5.1.3", &_names[506],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[495], &_types[504], NULLOT, &_types[507] },
    { "dot5TimerQueuePDU", "1.3.6.1.2.1.10.9.5.1.4", &_names[507],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2560], &_types[510], NULLOT, &_types[508] },
    { "dot5TimerValidTransmit", "1.3.6.1.2.1.10.9.5.1.5", &_names[508],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[373], &_types[513], NULLOT, &_types[509] },
    { "dot5TimerNoToken", "1.3.6.1.2.1.10.9.5.1.6", &_names[509],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[491], &_types[514], NULLOT, &_types[510] },
    { "dot5TimerActiveMon", "1.3.6.1.2.1.10.9.5.1.7", &_names[510],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[460], &_types[511], NULLOT, &_types[511] },
    { "dot5TimerStandbyMon", "1.3.6.1.2.1.10.9.5.1.8", &_names[511],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[510], NULLOT, NULLOT, &_types[512] },
    { "dot5TimerErrorReport", "1.3.6.1.2.1.10.9.5.1.9", &_names[512],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[505], &_types[509], NULLOT, &_types[513] },
    { "dot5TimerBeaconTransmit", "1.3.6.1.2.1.10.9.5.1.10", &_names[513],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[508], &_types[507], NULLOT, &_types[514] },
    { "dot5TimerBeaconReceive", "1.3.6.1.2.1.10.9.5.1.11", &_names[514],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[509], &_types[508], NULLOT, &_types[515] },
    { "fddi", "1.3.6.1.2.1.10.15", &_names[515],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[5], NULLOT, &_types[618], &_types[516] },
    { "snmpFddiSMT", "1.3.6.1.2.1.10.15.1", &_names[516],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[341], &_types[574], &_types[517], &_types[517] },
    { "snmpFddiSMTNumber", "1.3.6.1.2.1.10.15.1.1", &_names[517],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[315], &_types[518], NULLOT, &_types[518] },
    { "snmpFddiSMTTable", "1.3.6.1.2.1.10.15.1.2", &_names[518],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[502], NULLOT, &_types[519], &_types[519] },
    { "snmpFddiSMTEntry", "1.3.6.1.2.1.10.15.1.2.1", &_names[519],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpFddiSMTIndex", NULL, NULL,
      &_types[503], NULLOT, &_types[534], &_types[520] },
    { "snmpFddiSMTIndex", "1.3.6.1.2.1.10.15.1.2.1.1", &_names[520],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[504], &_types[533], NULLOT, &_types[521] },
    { "snmpFddiSMTStationId", "1.3.6.1.2.1.10.15.1.2.1.2", &_names[521],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[304], &_types[522], NULLOT, &_types[522] },
    { "snmpFddiSMTOpVersionId", "1.3.6.1.2.1.10.15.1.2.1.3", &_names[522],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[521], &_types[523], NULLOT, &_types[523] },
    { "snmpFddiSMTHiVersionId", "1.3.6.1.2.1.10.15.1.2.1.4", &_names[523],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[522], &_types[524], NULLOT, &_types[524] },
    { "snmpFddiSMTLoVersionId", "1.3.6.1.2.1.10.15.1.2.1.5", &_names[524],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[523], &_types[532], NULLOT, &_types[525] },
    { "snmpFddiSMTMACCt", "1.3.6.1.2.1.10.15.1.2.1.6", &_names[525],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      NULLOT, &_types[526], NULLOT, &_types[526] },
    { "snmpFddiSMTNonMasterCt", "1.3.6.1.2.1.10.15.1.2.1.7", &_names[526],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2,
      NULL, NULL, NULL,
      &_types[525], &_types[527], NULLOT, &_types[527] },
    { "snmpFddiSMTMasterCt", "1.3.6.1.2.1.10.15.1.2.1.8", &_names[527],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[526], &_types[521], NULLOT, &_types[528] },
    { "snmpFddiSMTPathsAvailable", "1.3.6.1.2.1.10.15.1.2.1.9", &_names[528],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[2592], &_types[525], NULLOT, &_types[529] },
    { "snmpFddiSMTConfigCapabilities", "1.3.6.1.2.1.10.15.1.2.1.10", &_names[529],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 3,
      NULL, NULL, NULL,
      &_types[401], &_types[530], NULLOT, &_types[530] },
    { "snmpFddiSMTConfigPolicy", "1.3.6.1.2.1.10.15.1.2.1.11", &_names[530],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 3,
      NULL, NULL, NULL,
      &_types[2509], &_types[531], NULLOT, &_types[531] },
    { "snmpFddiSMTConnectionPolicy", "1.3.6.1.2.1.10.15.1.2.1.12", &_names[531],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[530], &_types[528], NULLOT, &_types[532] },
    { "snmpFddiSMTTNotify", "1.3.6.1.2.1.10.15.1.2.1.13", &_names[532],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 30,
      NULL, NULL, NULL,
      &_types[409], &_types[538], NULLOT, &_types[533] },
    { "snmpFddiSMTStatusReporting", "1.3.6.1.2.1.10.15.1.2.1.14", &_names[533],
      (OS) 219, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[512], &_types[537], NULLOT, &_types[534] },
    { "snmpFddiSMTECMState", "1.3.6.1.2.1.10.15.1.2.1.15", &_names[534],
      (OS) 220, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[492], &_types[535], NULLOT, &_types[535] },
    { "snmpFddiSMTCFState", "1.3.6.1.2.1.10.15.1.2.1.16", &_names[535],
      (OS) 221, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[534], &_types[536], NULLOT, &_types[536] },
    { "snmpFddiSMTHoldState", "1.3.6.1.2.1.10.15.1.2.1.17", &_names[536],
      (OS) 222, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[535], &_types[520], NULLOT, &_types[537] },
    { "snmpFddiSMTRemoteDisconnectFlag", "1.3.6.1.2.1.10.15.1.2.1.18", &_names[537],
      (OS) 223, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[404], &_types[529], NULLOT, &_types[538] },
    { "snmpFddiSMTStationAction", "1.3.6.1.2.1.10.15.1.2.1.19", &_names[538],
      (OS) 224, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[440], NULLOT, NULLOT, &_types[539] },
    { "snmpFddiMAC", "1.3.6.1.2.1.10.15.2", &_names[539],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[447], &_types[614], &_types[541], &_types[540] },
    { "snmpFddiMACNumber", "1.3.6.1.2.1.10.15.2.1", &_names[540],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[517], NULLOT, NULLOT, &_types[541] },
    { "snmpFddiMACTable", "1.3.6.1.2.1.10.15.2.2", &_names[541],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[518], &_types[540], &_types[542], &_types[542] },
    { "snmpFddiMACEntry", "1.3.6.1.2.1.10.15.2.2.1", &_names[542],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpFddiMACSMTIndex snmpFddiMACIndex", NULL, NULL,
      &_types[519], NULLOT, &_types[554], &_types[543] },
    { "snmpFddiMACSMTIndex", "1.3.6.1.2.1.10.15.2.2.1.1", &_names[543],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[520], &_types[544], NULLOT, &_types[544] },
    { "snmpFddiMACIndex", "1.3.6.1.2.1.10.15.2.2.1.2", &_names[544],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[543], &_types[550], NULLOT, &_types[545] },
    { "snmpFddiMACFrameStatusCapabilities", "1.3.6.1.2.1.10.15.2.2.1.3", &_names[545],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 1799,
      NULL, NULL, NULL,
      &_types[529], &_types[560], NULLOT, &_types[546] },
    { "snmpFddiMACTMaxGreatestLowerBound", "1.3.6.1.2.1.10.15.2.2.1.4", &_names[546],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[573], &_types[547], NULLOT, &_types[547] },
    { "snmpFddiMACTVXGreatestLowerBound", "1.3.6.1.2.1.10.15.2.2.1.5", &_names[547],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[546], &_types[566], NULLOT, &_types[548] },
    { "snmpFddiMACPathsAvailable", "1.3.6.1.2.1.10.15.2.2.1.6", &_names[548],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[528], &_types[572], NULLOT, &_types[549] },
    { "snmpFddiMACCurrentPath", "1.3.6.1.2.1.10.15.2.2.1.7", &_names[549],
      (OS) 225, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[539], &_types[552], NULLOT, &_types[550] },
    { "snmpFddiMACUpstreamNbr", "1.3.6.1.2.1.10.15.2.2.1.8", &_names[550],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[490], &_types[551], NULLOT, &_types[551] },
    { "snmpFddiMACOldUpstreamNbr", "1.3.6.1.2.1.10.15.2.2.1.9", &_names[551],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[550], &_types[553], NULLOT, &_types[552] },
    { "snmpFddiMACDupAddrTest", "1.3.6.1.2.1.10.15.2.2.1.10", &_names[552],
      (OS) 226, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[617], &_types[562], NULLOT, &_types[553] },
    { "snmpFddiMACPathsRequested", "1.3.6.1.2.1.10.15.2.2.1.11", &_names[553],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[551], &_types[556], NULLOT, &_types[554] },
    { "snmpFddiMACDownstreamPORTType", "1.3.6.1.2.1.10.15.2.2.1.12", &_names[554],
      (OS) 227, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[542], &_types[546], NULLOT, &_types[555] },
    { "snmpFddiMACSMTAddress", "1.3.6.1.2.1.10.15.2.2.1.13", &_names[555],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[473], &_types[559], NULLOT, &_types[556] },
    { "snmpFddiMACTReq", "1.3.6.1.2.1.10.15.2.2.1.14", &_names[556],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[553], &_types[565], NULLOT, &_types[557] },
    { "snmpFddiMACTNeg", "1.3.6.1.2.1.10.15.2.2.1.15", &_names[557],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[514], &_types[548], NULLOT, &_types[558] },
    { "snmpFddiMACTMax", "1.3.6.1.2.1.10.15.2.2.1.16", &_names[558],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[391], &_types[549], NULLOT, &_types[559] },
    { "snmpFddiMACTvxValue", "1.3.6.1.2.1.10.15.2.2.1.17", &_names[559],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[555], &_types[561], NULLOT, &_types[560] },
    { "snmpFddiMACTMin", "1.3.6.1.2.1.10.15.2.2.1.18", &_names[560],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[545], &_types[557], NULLOT, &_types[561] },
    { "snmpFddiMACCurrentFrameStatus", "1.3.6.1.2.1.10.15.2.2.1.19", &_names[561],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[536], &_types[567], NULLOT, &_types[562] },
    { "snmpFddiMACFrameCts", "1.3.6.1.2.1.10.15.2.2.1.20", &_names[562],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[552], &_types[563], NULLOT, &_types[563] },
    { "snmpFddiMACErrorCts", "1.3.6.1.2.1.10.15.2.2.1.21", &_names[563],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[562], &_types[564], NULLOT, &_types[564] },
    { "snmpFddiMACLostCts", "1.3.6.1.2.1.10.15.2.2.1.22", &_names[564],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[563], &_types[570], NULLOT, &_types[565] },
    { "snmpFddiMACFrameErrorThreshold", "1.3.6.1.2.1.10.15.2.2.1.23", &_names[565],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[556], &_types[568], NULLOT, &_types[566] },
    { "snmpFddiMACFrameErrorRatio", "1.3.6.1.2.1.10.15.2.2.1.24", &_names[566],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[506], &_types[558], NULLOT, &_types[567] },
    { "snmpFddiMACRMTState", "1.3.6.1.2.1.10.15.2.2.1.25", &_names[567],
      (OS) 228, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[561], &_types[543], NULLOT, &_types[568] },
    { "snmpFddiMACDaFlag", "1.3.6.1.2.1.10.15.2.2.1.26", &_names[568],
      (OS) 229, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[537], &_types[569], NULLOT, &_types[569] },
    { "snmpFddiMACUnaDaFlag", "1.3.6.1.2.1.10.15.2.2.1.27", &_names[569],
      (OS) 230, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[568], &_types[545], NULLOT, &_types[570] },
    { "snmpFddiMACFrameCondition", "1.3.6.1.2.1.10.15.2.2.1.28", &_names[570],
      (OS) 231, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[564], &_types[571], NULLOT, &_types[571] },
    { "snmpFddiMACChipSet", "1.3.6.1.2.1.10.15.2.2.1.29", &_names[571],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[570], &_types[555], NULLOT, &_types[572] },
    { "snmpFddiMACAction", "1.3.6.1.2.1.10.15.2.2.1.30", &_names[572],
      (OS) 232, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[538], NULLOT, NULLOT, &_types[573] },
    { "snmpFddiPATH", "1.3.6.1.2.1.10.15.3", &_names[573],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1319], &_types[539], NULLOT, &_types[574] },
    { "snmpFddiPORT", "1.3.6.1.2.1.10.15.4", &_names[574],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[516], &_types[603], &_types[575], &_types[575] },
    { "snmpFddiPORTNumber", "1.3.6.1.2.1.10.15.4.1", &_names[575],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[540], &_types[576], NULLOT, &_types[576] },
    { "snmpFddiPORTTable", "1.3.6.1.2.1.10.15.4.2", &_names[576],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[541], NULLOT, &_types[577], &_types[577] },
    { "snmpFddiPORTEntry", "1.3.6.1.2.1.10.15.4.2.1", &_names[577],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpFddiPORTSMTIndex snmpFddiPORTIndex", NULL, NULL,
      &_types[554], NULLOT, &_types[580], &_types[578] },
    { "snmpFddiPORTSMTIndex", "1.3.6.1.2.1.10.15.4.2.1.1", &_names[578],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[544], &_types[579], NULLOT, &_types[579] },
    { "snmpFddiPORTIndex", "1.3.6.1.2.1.10.15.4.2.1.2", &_names[579],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[578], &_types[583], NULLOT, &_types[580] },
    { "snmpFddiPORTPCType", "1.3.6.1.2.1.10.15.4.2.1.3", &_names[580],
      (OS) 233, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[577], &_types[592], NULLOT, &_types[581] },
    { "snmpFddiPORTPCNeighbor", "1.3.6.1.2.1.10.15.4.2.1.4", &_names[581],
      (OS) 234, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[560], &_types[582], NULLOT, &_types[582] },
    { "snmpFddiPORTConnectionPolicies", "1.3.6.1.2.1.10.15.4.2.1.5", &_names[582],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[531], &_types[586], NULLOT, &_types[583] },
    { "snmpFddiPORTRemoteMACIndicated", "1.3.6.1.2.1.10.15.4.2.1.6", &_names[583],
      (OS) 235, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[579], &_types[585], NULLOT, &_types[584] },
    { "snmpFddiPORTCEState", "1.3.6.1.2.1.10.15.4.2.1.7", &_names[584],
      (OS) 236, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[567], &_types[597], NULLOT, &_types[585] },
    { "snmpFddiPORTPathsRequested", "1.3.6.1.2.1.10.15.4.2.1.8", &_names[585],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 15,
      NULL, NULL, NULL,
      &_types[565], &_types[590], NULLOT, &_types[586] },
    { "snmpFddiPORTMACPlacement", "1.3.6.1.2.1.10.15.4.2.1.9", &_names[586],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      NULLOT, &_types[602], NULLOT, &_types[587] },
    { "snmpFddiPORTAvailablePaths", "1.3.6.1.2.1.10.15.4.2.1.10", &_names[587],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[549], &_types[591], NULLOT, &_types[588] },
    { "snmpFddiPORTMACLoopTime", "1.3.6.1.2.1.10.15.4.2.1.11", &_names[588],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[494], &_types[596], NULLOT, &_types[589] },
    { "snmpFddiPORTTBMax", "1.3.6.1.2.1.10.15.4.2.1.12", &_names[589],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[558], &_types[587], NULLOT, &_types[590] },
    { "snmpFddiPORTBSFlag", "1.3.6.1.2.1.10.15.4.2.1.13", &_names[590],
      (OS) 237, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[569], &_types[588], NULLOT, &_types[591] },
    { "snmpFddiPORTLCTFailCts", "1.3.6.1.2.1.10.15.4.2.1.14", &_names[591],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[571], &_types[593], NULLOT, &_types[592] },
    { "snmpFddiPORTLerEstimate", "1.3.6.1.2.1.10.15.4.2.1.15", &_names[592],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 15,
      NULL, NULL, NULL,
      &_types[575], &_types[589], NULLOT, &_types[593] },
    { "snmpFddiPORTLemRejectCts", "1.3.6.1.2.1.10.15.4.2.1.16", &_names[593],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[591], &_types[594], NULLOT, &_types[594] },
    { "snmpFddiPORTLemCts", "1.3.6.1.2.1.10.15.4.2.1.17", &_names[594],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[593], &_types[595], NULLOT, &_types[595] },
    { "snmpFddiPORTLerCutoff", "1.3.6.1.2.1.10.15.4.2.1.18", &_names[595],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 15,
      NULL, NULL, NULL,
      &_types[594], &_types[599], NULLOT, &_types[596] },
    { "snmpFddiPORTLerAlarm", "1.3.6.1.2.1.10.15.4.2.1.19", &_names[596],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 15,
      NULL, NULL, NULL,
      &_types[449], &_types[581], NULLOT, &_types[597] },
    { "snmpFddiPORTConnectState", "1.3.6.1.2.1.10.15.4.2.1.20", &_names[597],
      (OS) 238, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[584], &_types[598], NULLOT, &_types[598] },
    { "snmpFddiPORTPCMState", "1.3.6.1.2.1.10.15.4.2.1.21", &_names[598],
      (OS) 239, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[597], &_types[578], NULLOT, &_types[599] },
    { "snmpFddiPORTPCWithhold", "1.3.6.1.2.1.10.15.4.2.1.22", &_names[599],
      (OS) 240, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[595], &_types[600], NULLOT, &_types[600] },
    { "snmpFddiPORTLerCondition", "1.3.6.1.2.1.10.15.4.2.1.23", &_names[600],
      (OS) 241, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[599], &_types[601], NULLOT, &_types[601] },
    { "snmpFddiPORTChipSet", "1.3.6.1.2.1.10.15.4.2.1.24", &_names[601],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[600], &_types[584], NULLOT, &_types[602] },
    { "snmpFddiPORTAction", "1.3.6.1.2.1.10.15.4.2.1.25", &_names[602],
      (OS) 242, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[572], NULLOT, NULLOT, &_types[603] },
    { "snmpFddiATTACHMENT", "1.3.6.1.2.1.10.15.5", &_names[603],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[574], &_types[573], &_types[604], &_types[604] },
    { "snmpFddiATTACHMENTNumber", "1.3.6.1.2.1.10.15.5.1", &_names[604],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[592], &_types[605], NULLOT, &_types[605] },
    { "snmpFddiATTACHMENTTable", "1.3.6.1.2.1.10.15.5.2", &_names[605],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[576], NULLOT, &_types[606], &_types[606] },
    { "snmpFddiATTACHMENTEntry", "1.3.6.1.2.1.10.15.5.2.1", &_names[606],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpFddiATTACHMENTSMTIndex snmpFddiATTACHMENTIndex", NULL, NULL,
      &_types[580], NULLOT, &_types[610], &_types[607] },
    { "snmpFddiATTACHMENTSMTIndex", "1.3.6.1.2.1.10.15.5.2.1.1", &_names[607],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[583], &_types[608], NULLOT, &_types[608] },
    { "snmpFddiATTACHMENTIndex", "1.3.6.1.2.1.10.15.5.2.1.2", &_names[608],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[607], &_types[611], NULLOT, &_types[609] },
    { "snmpFddiATTACHMENTClass", "1.3.6.1.2.1.10.15.5.2.1.3", &_names[609],
      (OS) 243, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[588], &_types[613], NULLOT, &_types[610] },
    { "snmpFddiATTACHMENTOpticalBypassPresent", "1.3.6.1.2.1.10.15.5.2.1.4", &_names[610],
      (OS) 244, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[587], &_types[612], NULLOT, &_types[611] },
    { "snmpFddiATTACHMENTIMaxExpiration", "1.3.6.1.2.1.10.15.5.2.1.5", &_names[611],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[533], &_types[609], NULLOT, &_types[612] },
    { "snmpFddiATTACHMENTInsertedStatus", "1.3.6.1.2.1.10.15.5.2.1.6", &_names[612],
      (OS) 245, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[598], &_types[607], NULLOT, &_types[613] },
    { "snmpFddiATTACHMENTInsertPolicy", "1.3.6.1.2.1.10.15.5.2.1.7", &_names[613],
      (OS) 246, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[582], NULLOT, NULLOT, &_types[614] },
    { "snmpFddiChipSets", "1.3.6.1.2.1.10.15.6", &_names[614],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[484], NULLOT, &_types[615], &_types[615] },
    { "snmpFddiPHYChipSets", "1.3.6.1.2.1.10.15.6.1", &_names[615],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[614], &_types[616], NULLOT, &_types[616] },
    { "snmpFddiMACChipSets", "1.3.6.1.2.1.10.15.6.2", &_names[616],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[615], &_types[617], NULLOT, &_types[617] },
    { "snmpFddiPHYMACChipSets", "1.3.6.1.2.1.10.15.6.3", &_names[617],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[616], NULLOT, NULLOT, &_types[618] },
    { "fddimib", "1.3.6.1.2.1.10.15.73", &_names[618],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[515], &_types[516], &_types[619], &_types[619] },
    { "fddimibSMT", "1.3.6.1.2.1.10.15.73.1", &_names[619],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[603], &_types[715], &_types[620], &_types[620] },
    { "fddimibSMTNumber", "1.3.6.1.2.1.10.15.73.1.1", &_names[620],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[604], &_types[621], NULLOT, &_types[621] },
    { "fddimibSMTTable", "1.3.6.1.2.1.10.15.73.1.2", &_names[621],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[605], NULLOT, &_types[622], &_types[622] },
    { "fddimibSMTEntry", "1.3.6.1.2.1.10.15.73.1.2.1", &_names[622],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fddimibSMTIndex", NULL, NULL,
      &_types[606], NULLOT, &_types[633], &_types[623] },
    { "fddimibSMTIndex", "1.3.6.1.2.1.10.15.73.1.2.1.1", &_names[623],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[608], &_types[639], NULLOT, &_types[624] },
    { "fddimibSMTStationId", "1.3.6.1.2.1.10.15.73.1.2.1.2", &_names[624],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[524], &_types[625], NULLOT, &_types[625] },
    { "fddimibSMTOpVersionId", "1.3.6.1.2.1.10.15.73.1.2.1.3", &_names[625],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[624], &_types[626], NULLOT, &_types[626] },
    { "fddimibSMTHiVersionId", "1.3.6.1.2.1.10.15.73.1.2.1.4", &_names[626],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[625], &_types[627], NULLOT, &_types[627] },
    { "fddimibSMTLoVersionId", "1.3.6.1.2.1.10.15.73.1.2.1.5", &_names[627],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[626], &_types[629], NULLOT, &_types[628] },
    { "fddimibSMTUserData", "1.3.6.1.2.1.10.15.73.1.2.1.6", &_names[628],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 32, 32,
      NULL, NULL, NULL,
      &_types[354], &_types[634], NULLOT, &_types[629] },
    { "fddimibSMTMIBVersionId", "1.3.6.1.2.1.10.15.73.1.2.1.7", &_names[629],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[627], &_types[637], NULLOT, &_types[630] },
    { "fddimibSMTMACCts", "1.3.6.1.2.1.10.15.73.1.2.1.8", &_names[630],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[601], &_types[631], NULLOT, &_types[631] },
    { "fddimibSMTNonMasterCts", "1.3.6.1.2.1.10.15.73.1.2.1.9", &_names[631],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2,
      NULL, NULL, NULL,
      &_types[630], &_types[632], NULLOT, &_types[632] },
    { "fddimibSMTMasterCts", "1.3.6.1.2.1.10.15.73.1.2.1.10", &_names[632],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[631], &_types[641], NULLOT, &_types[633] },
    { "fddimibSMTAvailablePaths", "1.3.6.1.2.1.10.15.73.1.2.1.11", &_names[633],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[649], &_types[640], NULLOT, &_types[634] },
    { "fddimibSMTConfigCapabilities", "1.3.6.1.2.1.10.15.73.1.2.1.12", &_names[634],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 3,
      NULL, NULL, NULL,
      &_types[581], &_types[635], NULLOT, &_types[635] },
    { "fddimibSMTConfigPolicy", "1.3.6.1.2.1.10.15.73.1.2.1.13", &_names[635],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 1,
      NULL, NULL, NULL,
      &_types[613], &_types[636], NULLOT, &_types[636] },
    { "fddimibSMTConnectionPolicy", "1.3.6.1.2.1.10.15.73.1.2.1.14", &_names[636],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 32768, 65535,
      NULL, NULL, NULL,
      &_types[635], &_types[638], NULLOT, &_types[637] },
    { "fddimibSMTTNotify", "1.3.6.1.2.1.10.15.73.1.2.1.15", &_names[637],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 30,
      NULL, NULL, NULL,
      &_types[532], &_types[648], NULLOT, &_types[638] },
    { "fddimibSMTStatRptPolicy", "1.3.6.1.2.1.10.15.73.1.2.1.16", &_names[638],
      (OS) 247, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[636], &_types[624], NULLOT, &_types[639] },
    { "fddimibSMTTraceMaxExpiration", "1.3.6.1.2.1.10.15.73.1.2.1.17", &_names[639],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[611], &_types[643], NULLOT, &_types[640] },
    { "fddimibSMTBypassPresent", "1.3.6.1.2.1.10.15.73.1.2.1.18", &_names[640],
      (OS) 248, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[633], &_types[630], NULLOT, &_types[641] },
    { "fddimibSMTECMState", "1.3.6.1.2.1.10.15.73.1.2.1.19", &_names[641],
      (OS) 249, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[612], &_types[642], NULLOT, &_types[642] },
    { "fddimibSMTCFState", "1.3.6.1.2.1.10.15.73.1.2.1.20", &_names[642],
      (OS) 250, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[641], &_types[644], NULLOT, &_types[643] },
    { "fddimibSMTRemoteDisconnectFlag", "1.3.6.1.2.1.10.15.73.1.2.1.21", &_names[643],
      (OS) 251, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[590], &_types[645], NULLOT, &_types[644] },
    { "fddimibSMTStationStatus", "1.3.6.1.2.1.10.15.73.1.2.1.22", &_names[644],
      (OS) 252, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[642], &_types[646], NULLOT, &_types[645] },
    { "fddimibSMTPeerWrapFlag", "1.3.6.1.2.1.10.15.73.1.2.1.23", &_names[645],
      (OS) 253, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[643], &_types[628], NULLOT, &_types[646] },
    { "fddimibSMTTimeStamp", "1.3.6.1.2.1.10.15.73.1.2.1.24", &_names[646],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[644], &_types[647], NULLOT, &_types[647] },
    { "fddimibSMTTransitionTimeStamp", "1.3.6.1.2.1.10.15.73.1.2.1.25", &_names[647],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[646], &_types[623], NULLOT, &_types[648] },
    { "fddimibSMTStationAction", "1.3.6.1.2.1.10.15.73.1.2.1.26", &_names[648],
      (OS) 254, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[602], NULLOT, NULLOT, &_types[649] },
    { "fddimibMAC", "1.3.6.1.2.1.10.15.73.2", &_names[649],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[610], NULLOT, &_types[651], &_types[650] },
    { "fddimibMACNumber", "1.3.6.1.2.1.10.15.73.2.1", &_names[650],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[620], NULLOT, NULLOT, &_types[651] },
    { "fddimibMACTable", "1.3.6.1.2.1.10.15.73.2.2", &_names[651],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[621], &_types[650], &_types[652], &_types[652] },
    { "fddimibMACEntry", "1.3.6.1.2.1.10.15.73.2.2.1", &_names[652],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fddimibMACSMTIndex fddimibMACIndex", NULL, NULL,
      &_types[622], NULLOT, &_types[667], &_types[653] },
    { "fddimibMACSMTIndex", "1.3.6.1.2.1.10.15.73.2.2.1.1", &_names[653],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[623], &_types[654], NULLOT, &_types[654] },
    { "fddimibMACIndex", "1.3.6.1.2.1.10.15.73.2.2.1.2", &_names[654],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[653], &_types[655], NULLOT, &_types[655] },
    { "fddimibMACIfIndex", "1.3.6.1.2.1.10.15.73.2.2.1.3", &_names[655],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[654], &_types[656], NULLOT, &_types[656] },
    { "fddimibMACFrameStatusFunctions", "1.3.6.1.2.1.10.15.73.2.2.1.4", &_names[656],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[655], &_types[661], NULLOT, &_types[657] },
    { "fddimibMACTMaxCapability", "1.3.6.1.2.1.10.15.73.2.2.1.5", &_names[657],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[634], &_types[658], NULLOT, &_types[658] },
    { "fddimibMACTVXCapability", "1.3.6.1.2.1.10.15.73.2.2.1.6", &_names[658],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[657], &_types[670], NULLOT, &_types[659] },
    { "fddimibMACAvailablePaths", "1.3.6.1.2.1.10.15.73.2.2.1.7", &_names[659],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[640], &_types[660], NULLOT, &_types[660] },
    { "fddimibMACCurrentPath", "1.3.6.1.2.1.10.15.73.2.2.1.8", &_names[660],
      (OS) 255, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[659], &_types[666], NULLOT, &_types[661] },
    { "fddimibMACUpstreamNbr", "1.3.6.1.2.1.10.15.73.2.2.1.9", &_names[661],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[585], &_types[662], NULLOT, &_types[662] },
    { "fddimibMACDownstreamNbr", "1.3.6.1.2.1.10.15.73.2.2.1.10", &_names[662],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[661], &_types[663], NULLOT, &_types[663] },
    { "fddimibMACOldUpstreamNbr", "1.3.6.1.2.1.10.15.73.2.2.1.11", &_names[663],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[662], &_types[664], NULLOT, &_types[664] },
    { "fddimibMACOldDownstreamNbr", "1.3.6.1.2.1.10.15.73.2.2.1.12", &_names[664],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[663], &_types[669], NULLOT, &_types[665] },
    { "fddimibMACDupAddressTest", "1.3.6.1.2.1.10.15.73.2.2.1.13", &_names[665],
      (OS) 256, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[632], &_types[673], NULLOT, &_types[666] },
    { "fddimibMACRequestedPaths", "1.3.6.1.2.1.10.15.73.2.2.1.14", &_names[666],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[660], &_types[685], NULLOT, &_types[667] },
    { "fddimibMACDownstreamPORTType", "1.3.6.1.2.1.10.15.73.2.2.1.15", &_names[667],
      (OS) 257, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[652], &_types[679], NULLOT, &_types[668] },
    { "fddimibMACSMTAddress", "1.3.6.1.2.1.10.15.73.2.2.1.16", &_names[668],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[559], &_types[672], NULLOT, &_types[669] },
    { "fddimibMACTReq", "1.3.6.1.2.1.10.15.73.2.2.1.17", &_names[669],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[664], &_types[678], NULLOT, &_types[670] },
    { "fddimibMACTNeg", "1.3.6.1.2.1.10.15.73.2.2.1.18", &_names[670],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[557], &_types[684], NULLOT, &_types[671] },
    { "fddimibMACTMax", "1.3.6.1.2.1.10.15.73.2.2.1.19", &_names[671],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[589], &_types[659], NULLOT, &_types[672] },
    { "fddimibMACTvxValue", "1.3.6.1.2.1.10.15.73.2.2.1.20", &_names[672],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[668], &_types[680], NULLOT, &_types[673] },
    { "fddimibMACFrameCts", "1.3.6.1.2.1.10.15.73.2.2.1.21", &_names[673],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[665], &_types[674], NULLOT, &_types[674] },
    { "fddimibMACCopiedCts", "1.3.6.1.2.1.10.15.73.2.2.1.22", &_names[674],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[673], &_types[675], NULLOT, &_types[675] },
    { "fddimibMACTransmitCts", "1.3.6.1.2.1.10.15.73.2.2.1.23", &_names[675],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[674], &_types[676], NULLOT, &_types[676] },
    { "fddimibMACErrorCts", "1.3.6.1.2.1.10.15.73.2.2.1.24", &_names[676],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[675], &_types[677], NULLOT, &_types[677] },
    { "fddimibMACLostCts", "1.3.6.1.2.1.10.15.73.2.2.1.25", &_names[677],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[676], &_types[668], NULLOT, &_types[678] },
    { "fddimibMACFrameErrorThreshold", "1.3.6.1.2.1.10.15.73.2.2.1.26", &_names[678],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[669], &_types[681], NULLOT, &_types[679] },
    { "fddimibMACFrameErrorRatio", "1.3.6.1.2.1.10.15.73.2.2.1.27", &_names[679],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[566], &_types[671], NULLOT, &_types[680] },
    { "fddimibMACRMTState", "1.3.6.1.2.1.10.15.73.2.2.1.28", &_names[680],
      (OS) 258, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[647], &_types[653], NULLOT, &_types[681] },
    { "fddimibMACDaFlag", "1.3.6.1.2.1.10.15.73.2.2.1.29", &_names[681],
      (OS) 259, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[645], &_types[682], NULLOT, &_types[682] },
    { "fddimibMACUnaDaFlag", "1.3.6.1.2.1.10.15.73.2.2.1.30", &_names[682],
      (OS) 260, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[681], &_types[683], NULLOT, &_types[683] },
    { "fddimibMACFrameErrorFlag", "1.3.6.1.2.1.10.15.73.2.2.1.31", &_names[683],
      (OS) 261, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[682], &_types[686], NULLOT, &_types[684] },
    { "fddimibMACMAUnitdataAvailable", "1.3.6.1.2.1.10.15.73.2.2.1.32", &_names[684],
      (OS) 262, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[548], NULLOT, NULLOT, &_types[685] },
    { "fddimibMACHardwarePresent", "1.3.6.1.2.1.10.15.73.2.2.1.33", &_names[685],
      (OS) 263, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[666], &_types[665], NULLOT, &_types[686] },
    { "fddimibMACMAUnitdataEnable", "1.3.6.1.2.1.10.15.73.2.2.1.34", &_names[686],
      (OS) 264, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[609], &_types[657], NULLOT, &_types[687] },
    { "fddimibMACCounters", "1.3.6.1.2.1.10.15.73.3", &_names[687],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[463], &_types[698], &_types[688], &_types[688] },
    { "fddimibMACCountersTable", "1.3.6.1.2.1.10.15.73.3.1", &_names[688],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[651], NULLOT, &_types[689], &_types[689] },
    { "fddimibMACCountersEntry", "1.3.6.1.2.1.10.15.73.3.1.1", &_names[689],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fddimibMACSMTIndex fddimibMACIndex", NULL, NULL,
      &_types[667], NULLOT, &_types[695], &_types[690] },
    { "fddimibMACTokenCts", "1.3.6.1.2.1.10.15.73.3.1.1.1", &_names[690],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[677], &_types[691], NULLOT, &_types[691] },
    { "fddimibMACTvxExpiredCts", "1.3.6.1.2.1.10.15.73.3.1.1.2", &_names[691],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[690], &_types[692], NULLOT, &_types[692] },
    { "fddimibMACNotCopiedCts", "1.3.6.1.2.1.10.15.73.3.1.1.3", &_names[692],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[691], &_types[693], NULLOT, &_types[693] },
    { "fddimibMACLateCts", "1.3.6.1.2.1.10.15.73.3.1.1.4", &_names[693],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[692], &_types[694], NULLOT, &_types[694] },
    { "fddimibMACRingOpCts", "1.3.6.1.2.1.10.15.73.3.1.1.5", &_names[694],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[693], &_types[697], NULLOT, &_types[695] },
    { "fddimibMACNotCopiedRatio", "1.3.6.1.2.1.10.15.73.3.1.1.6", &_names[695],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[679], &_types[690], NULLOT, &_types[696] },
    { "fddimibMACNotCopiedFlag", "1.3.6.1.2.1.10.15.73.3.1.1.7", &_names[696],
      (OS) 265, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[683], NULLOT, NULLOT, &_types[697] },
    { "fddimibMACNotCopiedThreshold", "1.3.6.1.2.1.10.15.73.3.1.1.8", &_names[697],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[678], &_types[696], NULLOT, &_types[698] },
    { "fddimibPATH", "1.3.6.1.2.1.10.15.73.4", &_names[698],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[547], &_types[649], &_types[699], &_types[699] },
    { "fddimibPATHNumber", "1.3.6.1.2.1.10.15.73.4.1", &_names[699],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[650], &_types[700], NULLOT, &_types[700] },
    { "fddimibPATHTable", "1.3.6.1.2.1.10.15.73.4.2", &_names[700],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[688], &_types[707], &_types[701], &_types[701] },
    { "fddimibPATHEntry", "1.3.6.1.2.1.10.15.73.4.2.1", &_names[701],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fddimibPATHSMTIndex fddimibPATHIndex", NULL, NULL,
      &_types[689], NULLOT, &_types[704], &_types[702] },
    { "fddimibPATHSMTIndex", "1.3.6.1.2.1.10.15.73.4.2.1.1", &_names[702],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[656], &_types[703], NULLOT, &_types[703] },
    { "fddimibPATHIndex", "1.3.6.1.2.1.10.15.73.4.2.1.2", &_names[703],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[702], &_types[706], NULLOT, &_types[704] },
    { "fddimibPATHTVXLowerBound", "1.3.6.1.2.1.10.15.73.4.2.1.3", &_names[704],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[698], &_types[705], NULLOT, &_types[705] },
    { "fddimibPATHTMaxLowerBound", "1.3.6.1.2.1.10.15.73.4.2.1.4", &_names[705],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[704], &_types[702], NULLOT, &_types[706] },
    { "fddimibPATHMaxTReq", "1.3.6.1.2.1.10.15.73.4.2.1.5", &_names[706],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[697], NULLOT, NULLOT, &_types[707] },
    { "fddimibPATHConfigTable", "1.3.6.1.2.1.10.15.73.4.3", &_names[707],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[700], NULLOT, &_types[708], &_types[708] },
    { "fddimibPATHConfigEntry", "1.3.6.1.2.1.10.15.73.4.3.1", &_names[708],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fddimibPATHConfigSMTIndex fddimibPATHConfigPATHIndex fddimibPATHConfigTokenOrder", NULL, NULL,
      &_types[701], NULLOT, &_types[712], &_types[709] },
    { "fddimibPATHConfigSMTIndex", "1.3.6.1.2.1.10.15.73.4.3.1.1", &_names[709],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[703], &_types[710], NULLOT, &_types[710] },
    { "fddimibPATHConfigPATHIndex", "1.3.6.1.2.1.10.15.73.4.3.1.2", &_names[710],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[709], &_types[713], NULLOT, &_types[711] },
    { "fddimibPATHConfigTokenOrder", "1.3.6.1.2.1.10.15.73.4.3.1.3", &_names[711],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[672], &_types[709], NULLOT, &_types[712] },
    { "fddimibPATHConfigResourceType", "1.3.6.1.2.1.10.15.73.4.3.1.4", &_names[712],
      (OS) 266, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[708], &_types[714], NULLOT, &_types[713] },
    { "fddimibPATHConfigResourceIndex", "1.3.6.1.2.1.10.15.73.4.3.1.5", &_names[713],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[710], NULLOT, NULLOT, &_types[714] },
    { "fddimibPATHConfigCurrentPath", "1.3.6.1.2.1.10.15.73.4.3.1.6", &_names[714],
      (OS) 267, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[685], &_types[711], NULLOT, &_types[715] },
    { "fddimibPORT", "1.3.6.1.2.1.10.15.73.5", &_names[715],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[619], &_types[687], &_types[716], &_types[716] },
    { "fddimibPORTNumber", "1.3.6.1.2.1.10.15.73.5.1", &_names[716],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[699], &_types[717], NULLOT, &_types[717] },
    { "fddimibPORTTable", "1.3.6.1.2.1.10.15.73.5.2", &_names[717],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[707], NULLOT, &_types[718], &_types[718] },
    { "fddimibPORTEntry", "1.3.6.1.2.1.10.15.73.5.2.1", &_names[718],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fddimibPORTSMTIndex fddimibPORTIndex", NULL, NULL,
      &_types[712], NULLOT, &_types[721], &_types[719] },
    { "fddimibPORTSMTIndex", "1.3.6.1.2.1.10.15.73.5.2.1.1", &_names[719],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[713], &_types[720], NULLOT, &_types[720] },
    { "fddimibPORTIndex", "1.3.6.1.2.1.10.15.73.5.2.1.2", &_names[720],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[719], &_types[724], NULLOT, &_types[721] },
    { "fddimibPORTMyType", "1.3.6.1.2.1.10.15.73.5.2.1.3", &_names[721],
      (OS) 268, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[718], &_types[722], NULLOT, &_types[722] },
    { "fddimibPORTNeighborType", "1.3.6.1.2.1.10.15.73.5.2.1.4", &_names[722],
      (OS) 269, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[721], &_types[733], NULLOT, &_types[723] },
    { "fddimibPORTConnectionPolicies", "1.3.6.1.2.1.10.15.73.5.2.1.5", &_names[723],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 3,
      NULL, NULL, NULL,
      &_types[638], &_types[727], NULLOT, &_types[724] },
    { "fddimibPORTMACIndicated", "1.3.6.1.2.1.10.15.73.5.2.1.6", &_names[724],
      (OS) 270, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[720], &_types[731], NULLOT, &_types[725] },
    { "fddimibPORTCurrentPath", "1.3.6.1.2.1.10.15.73.5.2.1.7", &_names[725],
      (OS) 271, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[714], &_types[726], NULLOT, &_types[726] },
    { "fddimibPORTRequestedPaths", "1.3.6.1.2.1.10.15.73.5.2.1.8", &_names[726],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 3, 3,
      NULL, NULL, NULL,
      &_types[725], &_types[728], NULLOT, &_types[727] },
    { "fddimibPORTMACPlacement", "1.3.6.1.2.1.10.15.73.5.2.1.9", &_names[727],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[586], &_types[743], NULLOT, &_types[728] },
    { "fddimibPORTAvailablePaths", "1.3.6.1.2.1.10.15.73.5.2.1.10", &_names[728],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[726], &_types[742], NULLOT, &_types[729] },
    { "fddimibPORTPMDClass", "1.3.6.1.2.1.10.15.73.5.2.1.11", &_names[729],
      (OS) 272, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[686], &_types[737], NULLOT, &_types[730] },
    { "fddimibPORTConnectionCapabilities", "1.3.6.1.2.1.10.15.73.5.2.1.12", &_names[730],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 3,
      NULL, NULL, NULL,
      &_types[658], &_types[723], NULLOT, &_types[731] },
    { "fddimibPORTBSFlag", "1.3.6.1.2.1.10.15.73.5.2.1.13", &_names[731],
      (OS) 273, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[696], &_types[741], NULLOT, &_types[732] },
    { "fddimibPORTLCTFailCts", "1.3.6.1.2.1.10.15.73.5.2.1.14", &_names[732],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[694], &_types[734], NULLOT, &_types[733] },
    { "fddimibPORTLerEstimate", "1.3.6.1.2.1.10.15.73.5.2.1.15", &_names[733],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 15,
      NULL, NULL, NULL,
      &_types[716], &_types[725], NULLOT, &_types[734] },
    { "fddimibPORTLemRejectCts", "1.3.6.1.2.1.10.15.73.5.2.1.16", &_names[734],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[732], &_types[735], NULLOT, &_types[735] },
    { "fddimibPORTLemCts", "1.3.6.1.2.1.10.15.73.5.2.1.17", &_names[735],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[734], &_types[736], NULLOT, &_types[736] },
    { "fddimibPORTLerCutoff", "1.3.6.1.2.1.10.15.73.5.2.1.18", &_names[736],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 15,
      NULL, NULL, NULL,
      &_types[735], &_types[740], NULLOT, &_types[737] },
    { "fddimibPORTLerAlarm", "1.3.6.1.2.1.10.15.73.5.2.1.19", &_names[737],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 15,
      NULL, NULL, NULL,
      &_types[596], &_types[730], NULLOT, &_types[738] },
    { "fddimibPORTConnectState", "1.3.6.1.2.1.10.15.73.5.2.1.20", &_names[738],
      (OS) 274, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[680], &_types[739], NULLOT, &_types[739] },
    { "fddimibPORTPCMState", "1.3.6.1.2.1.10.15.73.5.2.1.21", &_names[739],
      (OS) 275, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[738], &_types[719], NULLOT, &_types[740] },
    { "fddimibPORTPCWithhold", "1.3.6.1.2.1.10.15.73.5.2.1.22", &_names[740],
      (OS) 276, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[736], &_types[738], NULLOT, &_types[741] },
    { "fddimibPORTLerFlag", "1.3.6.1.2.1.10.15.73.5.2.1.23", &_names[741],
      (OS) 277, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[731], &_types[729], NULLOT, &_types[742] },
    { "fddimibPORTHardwarePresent", "1.3.6.1.2.1.10.15.73.5.2.1.24", &_names[742],
      (OS) 278, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[728], &_types[732], NULLOT, &_types[743] },
    { "fddimibPORTAction", "1.3.6.1.2.1.10.15.73.5.2.1.25", &_names[743],
      (OS) 279, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[648], NULLOT, NULLOT, &_types[744] },
    { "lapb", "1.3.6.1.2.1.10.16", &_names[744],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[741], &_types[1095], &_types[745], &_types[745] },
    { "lapbAdmnTable", "1.3.6.1.2.1.10.16.1", &_names[745],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[717], &_types[761], &_types[746], &_types[746] },
    { "lapbAdmnEntry", "1.3.6.1.2.1.10.16.1.1", &_names[746],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "lapbAdmnIndex", NULL, NULL,
      &_types[722], NULLOT, &_types[748], &_types[747] },
    { "lapbAdmnIndex", "1.3.6.1.2.1.10.16.1.1.1", &_names[747],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[724], &_types[755], NULLOT, &_types[748] },
    { "lapbAdmnStationType", "1.3.6.1.2.1.10.16.1.1.2", &_names[748],
      (OS) 280, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[746], &_types[754], NULLOT, &_types[749] },
    { "lapbAdmnControlField", "1.3.6.1.2.1.10.16.1.1.3", &_names[749],
      (OS) 281, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[740], &_types[747], NULLOT, &_types[750] },
    { "lapbAdmnTransmitN1FrameSize", "1.3.6.1.2.1.10.16.1.1.4", &_names[750],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[671], &_types[751], NULLOT, &_types[751] },
    { "lapbAdmnReceiveN1FrameSize", "1.3.6.1.2.1.10.16.1.1.5", &_names[751],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[750], &_types[752], NULLOT, &_types[752] },
    { "lapbAdmnTransmitKWindowSize", "1.3.6.1.2.1.10.16.1.1.6", &_names[752],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 127,
      NULL, NULL, NULL,
      &_types[751], &_types[753], NULLOT, &_types[753] },
    { "lapbAdmnReceiveKWindowSize", "1.3.6.1.2.1.10.16.1.1.7", &_names[753],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 127,
      NULL, NULL, NULL,
      &_types[752], &_types[759], NULLOT, &_types[754] },
    { "lapbAdmnN2RxmitCount", "1.3.6.1.2.1.10.16.1.1.8", &_names[754],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[687], &_types[750], NULLOT, &_types[755] },
    { "lapbAdmnT1AckTimer", "1.3.6.1.2.1.10.16.1.1.9", &_names[755],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[729], &_types[756], NULLOT, &_types[756] },
    { "lapbAdmnT2AckDelayTimer", "1.3.6.1.2.1.10.16.1.1.10", &_names[756],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[755], &_types[757], NULLOT, &_types[757] },
    { "lapbAdmnT3DisconnectTimer", "1.3.6.1.2.1.10.16.1.1.11", &_names[757],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[756], &_types[758], NULLOT, &_types[758] },
    { "lapbAdmnT4IdleTimer", "1.3.6.1.2.1.10.16.1.1.12", &_names[758],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[757], &_types[760], NULLOT, &_types[759] },
    { "lapbAdmnActionInitiate", "1.3.6.1.2.1.10.16.1.1.13", &_names[759],
      (OS) 282, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[753], &_types[749], NULLOT, &_types[760] },
    { "lapbAdmnActionRecvDM", "1.3.6.1.2.1.10.16.1.1.14", &_names[760],
      (OS) 283, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[352], NULLOT, NULLOT, &_types[761] },
    { "lapbOperTable", "1.3.6.1.2.1.10.16.2", &_names[761],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[745], &_types[777], &_types[762], &_types[762] },
    { "lapbOperEntry", "1.3.6.1.2.1.10.16.2.1", &_names[762],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "lapbOperIndex", NULL, NULL,
      &_types[748], NULLOT, &_types[764], &_types[763] },
    { "lapbOperIndex", "1.3.6.1.2.1.10.16.2.1.1", &_names[763],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[747], &_types[771], NULLOT, &_types[764] },
    { "lapbOperStationType", "1.3.6.1.2.1.10.16.2.1.2", &_names[764],
      (OS) 284, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[762], &_types[770], NULLOT, &_types[765] },
    { "lapbOperControlField", "1.3.6.1.2.1.10.16.2.1.3", &_names[765],
      (OS) 285, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[749], &_types[763], NULLOT, &_types[766] },
    { "lapbOperTransmitN1FrameSize", "1.3.6.1.2.1.10.16.2.1.4", &_names[766],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[759], &_types[767], NULLOT, &_types[767] },
    { "lapbOperReceiveN1FrameSize", "1.3.6.1.2.1.10.16.2.1.5", &_names[767],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[766], &_types[768], NULLOT, &_types[768] },
    { "lapbOperTransmitKWindowSize", "1.3.6.1.2.1.10.16.2.1.6", &_names[768],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 127,
      NULL, NULL, NULL,
      &_types[767], &_types[769], NULLOT, &_types[769] },
    { "lapbOperReceiveKWindowSize", "1.3.6.1.2.1.10.16.2.1.7", &_names[769],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 127,
      NULL, NULL, NULL,
      &_types[768], &_types[765], NULLOT, &_types[770] },
    { "lapbOperN2RxmitCount", "1.3.6.1.2.1.10.16.2.1.8", &_names[770],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[754], &_types[766], NULLOT, &_types[771] },
    { "lapbOperT1AckTimer", "1.3.6.1.2.1.10.16.2.1.9", &_names[771],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[758], &_types[772], NULLOT, &_types[772] },
    { "lapbOperT2AckDelayTimer", "1.3.6.1.2.1.10.16.2.1.10", &_names[772],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[771], &_types[773], NULLOT, &_types[773] },
    { "lapbOperT3DisconnectTimer", "1.3.6.1.2.1.10.16.2.1.11", &_names[773],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[772], &_types[774], NULLOT, &_types[774] },
    { "lapbOperT4IdleTimer", "1.3.6.1.2.1.10.16.2.1.12", &_names[774],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[773], &_types[775], NULLOT, &_types[775] },
    { "lapbOperPortId", "1.3.6.1.2.1.10.16.2.1.13", &_names[775],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[629], &_types[776], NULLOT, &_types[776] },
    { "lapbOperProtocolVersionId", "1.3.6.1.2.1.10.16.2.1.14", &_names[776],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[775], NULLOT, NULLOT, &_types[777] },
    { "lapbFlowTable", "1.3.6.1.2.1.10.16.3", &_names[777],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[761], &_types[790], &_types[778], &_types[778] },
    { "lapbFlowEntry", "1.3.6.1.2.1.10.16.3.1", &_names[778],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "lapbFlowIfIndex", NULL, NULL,
      &_types[764], NULLOT, &_types[783], &_types[779] },
    { "lapbFlowIfIndex", "1.3.6.1.2.1.10.16.3.1.1", &_names[779],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[763], &_types[780], NULLOT, &_types[780] },
    { "lapbFlowStateChanges", "1.3.6.1.2.1.10.16.3.1.2", &_names[780],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[335], &_types[787], NULLOT, &_types[781] },
    { "lapbFlowChangeReason", "1.3.6.1.2.1.10.16.3.1.3", &_names[781],
      (OS) 286, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[448], NULLOT, NULLOT, &_types[782] },
    { "lapbFlowCurrentMode", "1.3.6.1.2.1.10.16.3.1.4", &_names[782],
      (OS) 287, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[765], &_types[779], NULLOT, &_types[783] },
    { "lapbFlowBusyDefers", "1.3.6.1.2.1.10.16.3.1.5", &_names[783],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[800], &_types[782], NULLOT, &_types[784] },
    { "lapbFlowRejOutPkts", "1.3.6.1.2.1.10.16.3.1.6", &_names[784],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[384], &_types[785], NULLOT, &_types[785] },
    { "lapbFlowRejInPkts", "1.3.6.1.2.1.10.16.3.1.7", &_names[785],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[784], &_types[786], NULLOT, &_types[786] },
    { "lapbFlowT1Timeouts", "1.3.6.1.2.1.10.16.3.1.8", &_names[786],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[774], &_types[788], NULLOT, &_types[787] },
    { "lapbFlowFrmrSent", "1.3.6.1.2.1.10.16.3.1.9", &_names[787],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[780], &_types[784], NULLOT, &_types[788] },
    { "lapbFlowFrmrReceived", "1.3.6.1.2.1.10.16.3.1.10", &_names[788],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 7,
      NULL, NULL, NULL,
      &_types[670], &_types[789], NULLOT, &_types[789] },
    { "lapbFlowXidReceived", "1.3.6.1.2.1.10.16.3.1.11", &_names[789],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 8206,
      NULL, NULL, NULL,
      &_types[788], &_types[781], NULLOT, &_types[790] },
    { "lapbXidTable", "1.3.6.1.2.1.10.16.4", &_names[790],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[777], &_types[799], &_types[791], &_types[791] },
    { "lapbXidEntry", "1.3.6.1.2.1.10.16.4.1", &_names[791],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "lapbXidIndex", NULL, NULL,
      &_types[778], NULLOT, &_types[797], &_types[792] },
    { "lapbXidIndex", "1.3.6.1.2.1.10.16.4.1.1", &_names[792],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[779], &_types[793], NULLOT, &_types[793] },
    { "lapbXidAdRIdentifier", "1.3.6.1.2.1.10.16.4.1.2", &_names[793],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2517], &_types[795], NULLOT, &_types[794] },
    { "lapbXidAdRAddress", "1.3.6.1.2.1.10.16.4.1.3", &_names[794],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[711], &_types[796], NULLOT, &_types[795] },
    { "lapbXidParameterUniqueIdentifier", "1.3.6.1.2.1.10.16.4.1.4", &_names[795],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[793], NULLOT, NULLOT, &_types[796] },
    { "lapbXidGroupAddress", "1.3.6.1.2.1.10.16.4.1.5", &_names[796],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[794], &_types[798], NULLOT, &_types[797] },
    { "lapbXidPortNumber", "1.3.6.1.2.1.10.16.4.1.6", &_names[797],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[733], &_types[794], NULLOT, &_types[798] },
    { "lapbXidUserDataSubfield", "1.3.6.1.2.1.10.16.4.1.7", &_names[798],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 8206,
      NULL, NULL, NULL,
      &_types[739], &_types[792], NULLOT, &_types[799] },
    { "lapbProtocolVersion", "1.3.6.1.2.1.10.16.5", &_names[799],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[742], NULLOT, &_types[801], &_types[800] },
    { "lapbProtocolIso7776v1986", "1.3.6.1.2.1.10.16.5.1", &_names[800],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[695], NULLOT, NULLOT, &_types[801] },
    { "lapbProtocolCcittV1980", "1.3.6.1.2.1.10.16.5.2", &_names[801],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[363], &_types[802], NULLOT, &_types[802] },
    { "lapbProtocolCcittV1984", "1.3.6.1.2.1.10.16.5.3", &_names[802],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[801], &_types[800], NULLOT, &_types[803] },
    { "ds1", "1.3.6.1.2.1.10.18", &_names[803],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[196], &_types[804], &_types[804] },
    { "dsx1ConfigTable", "1.3.6.1.2.1.10.18.6", &_names[804],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[790], &_types[819], &_types[805], &_types[805] },
    { "dsx1ConfigEntry", "1.3.6.1.2.1.10.18.6.1", &_names[805],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1LineIndex", NULL, NULL,
      &_types[791], NULLOT, &_types[810], &_types[806] },
    { "dsx1LineIndex", "1.3.6.1.2.1.10.18.6.1.1", &_names[806],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[792], &_types[807], NULLOT, &_types[807] },
    { "dsx1IfIndex", "1.3.6.1.2.1.10.18.6.1.2", &_names[807],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[806], &_types[808], NULLOT, &_types[808] },
    { "dsx1TimeElapsed", "1.3.6.1.2.1.10.18.6.1.3", &_names[808],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 899,
      NULL, NULL, NULL,
      &_types[493], &_types[817], NULLOT, &_types[809] },
    { "dsx1ValidIntervals", "1.3.6.1.2.1.10.18.6.1.4", &_names[809],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 96,
      NULL, NULL, NULL,
      &_types[396], NULLOT, NULLOT, &_types[810] },
    { "dsx1LineType", "1.3.6.1.2.1.10.18.6.1.5", &_names[810],
      (OS) 288, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[805], &_types[814], NULLOT, &_types[811] },
    { "dsx1LineCoding", "1.3.6.1.2.1.10.18.6.1.6", &_names[811],
      (OS) 289, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[786], &_types[812], NULLOT, &_types[812] },
    { "dsx1SendCode", "1.3.6.1.2.1.10.18.6.1.7", &_names[812],
      (OS) 290, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[811], &_types[818], NULLOT, &_types[813] },
    { "dsx1CircuitIdentifier", "1.3.6.1.2.1.10.18.6.1.8", &_names[813],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[795], &_types[809], NULLOT, &_types[814] },
    { "dsx1LoopbackConfig", "1.3.6.1.2.1.10.18.6.1.9", &_names[814],
      (OS) 291, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[782], &_types[816], NULLOT, &_types[815] },
    { "dsx1LineStatus", "1.3.6.1.2.1.10.18.6.1.10", &_names[815],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 8191,
      NULL, NULL, NULL,
      &_types[798], &_types[806], NULLOT, &_types[816] },
    { "dsx1SignalMode", "1.3.6.1.2.1.10.18.6.1.11", &_names[816],
      (OS) 292, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[814], &_types[815], NULLOT, &_types[817] },
    { "dsx1TransmitClockSource", "1.3.6.1.2.1.10.18.6.1.12", &_names[817],
      (OS) 293, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[785], &_types[811], NULLOT, &_types[818] },
    { "dsx1Fdl", "1.3.6.1.2.1.10.18.6.1.13", &_names[818],
      (OS) 294, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[781], &_types[813], NULLOT, &_types[819] },
    { "dsx1CurrentTable", "1.3.6.1.2.1.10.18.7", &_names[819],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[804], &_types[832], &_types[820], &_types[820] },
    { "dsx1CurrentEntry", "1.3.6.1.2.1.10.18.7.1", &_names[820],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1CurrentIndex", NULL, NULL,
      &_types[810], NULLOT, &_types[821], &_types[821] },
    { "dsx1CurrentIndex", "1.3.6.1.2.1.10.18.7.1.1", &_names[821],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[807], &_types[830], NULLOT, &_types[822] },
    { "dsx1CurrentESs", "1.3.6.1.2.1.10.18.7.1.2", &_names[822],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[823], NULLOT, &_types[823] },
    { "dsx1CurrentSESs", "1.3.6.1.2.1.10.18.7.1.3", &_names[823],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[822], &_types[824], NULLOT, &_types[824] },
    { "dsx1CurrentSEFSs", "1.3.6.1.2.1.10.18.7.1.4", &_names[824],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[823], &_types[825], NULLOT, &_types[825] },
    { "dsx1CurrentUASs", "1.3.6.1.2.1.10.18.7.1.5", &_names[825],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[824], &_types[826], NULLOT, &_types[826] },
    { "dsx1CurrentCSSs", "1.3.6.1.2.1.10.18.7.1.6", &_names[826],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[825], &_types[828], NULLOT, &_types[827] },
    { "dsx1CurrentPCVs", "1.3.6.1.2.1.10.18.7.1.7", &_names[827],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1502], &_types[831], NULLOT, &_types[828] },
    { "dsx1CurrentLESs", "1.3.6.1.2.1.10.18.7.1.8", &_names[828],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[826], &_types[829], NULLOT, &_types[829] },
    { "dsx1CurrentBESs", "1.3.6.1.2.1.10.18.7.1.9", &_names[829],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[828], NULLOT, NULLOT, &_types[830] },
    { "dsx1CurrentDMs", "1.3.6.1.2.1.10.18.7.1.10", &_names[830],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[827], NULLOT, &_types[831] },
    { "dsx1CurrentLCVs", "1.3.6.1.2.1.10.18.7.1.11", &_names[831],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[827], &_types[822], NULLOT, &_types[832] },
    { "dsx1IntervalTable", "1.3.6.1.2.1.10.18.8", &_names[832],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[819], &_types[846], &_types[833], &_types[833] },
    { "dsx1IntervalEntry", "1.3.6.1.2.1.10.18.8.1", &_names[833],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1IntervalIndex dsx1IntervalNumber", NULL, NULL,
      &_types[820], NULLOT, &_types[835], &_types[834] },
    { "dsx1IntervalIndex", "1.3.6.1.2.1.10.18.8.1.1", &_names[834],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[821], &_types[844], NULLOT, &_types[835] },
    { "dsx1IntervalNumber", "1.3.6.1.2.1.10.18.8.1.2", &_names[835],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 96,
      NULL, NULL, NULL,
      &_types[797], &_types[834], NULLOT, &_types[836] },
    { "dsx1IntervalESs", "1.3.6.1.2.1.10.18.8.1.3", &_names[836],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[829], &_types[837], NULLOT, &_types[837] },
    { "dsx1IntervalSESs", "1.3.6.1.2.1.10.18.8.1.4", &_names[837],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[836], &_types[838], NULLOT, &_types[838] },
    { "dsx1IntervalSEFSs", "1.3.6.1.2.1.10.18.8.1.5", &_names[838],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[837], &_types[839], NULLOT, &_types[839] },
    { "dsx1IntervalUASs", "1.3.6.1.2.1.10.18.8.1.6", &_names[839],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[838], &_types[840], NULLOT, &_types[840] },
    { "dsx1IntervalCSSs", "1.3.6.1.2.1.10.18.8.1.7", &_names[840],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[839], &_types[842], NULLOT, &_types[841] },
    { "dsx1IntervalPCVs", "1.3.6.1.2.1.10.18.8.1.8", &_names[841],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[831], &_types[845], NULLOT, &_types[842] },
    { "dsx1IntervalLESs", "1.3.6.1.2.1.10.18.8.1.9", &_names[842],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[840], &_types[843], NULLOT, &_types[843] },
    { "dsx1IntervalBESs", "1.3.6.1.2.1.10.18.8.1.10", &_names[843],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[842], NULLOT, NULLOT, &_types[844] },
    { "dsx1IntervalDMs", "1.3.6.1.2.1.10.18.8.1.11", &_names[844],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[830], &_types[841], NULLOT, &_types[845] },
    { "dsx1IntervalLCVs", "1.3.6.1.2.1.10.18.8.1.12", &_names[845],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[841], &_types[836], NULLOT, &_types[846] },
    { "dsx1TotalTable", "1.3.6.1.2.1.10.18.9", &_names[846],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[832], &_types[859], &_types[847], &_types[847] },
    { "dsx1TotalEntry", "1.3.6.1.2.1.10.18.9.1", &_names[847],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1TotalIndex", NULL, NULL,
      &_types[833], NULLOT, &_types[848], &_types[848] },
    { "dsx1TotalIndex", "1.3.6.1.2.1.10.18.9.1.1", &_names[848],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[834], &_types[857], NULLOT, &_types[849] },
    { "dsx1TotalESs", "1.3.6.1.2.1.10.18.9.1.2", &_names[849],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[843], &_types[850], NULLOT, &_types[850] },
    { "dsx1TotalSESs", "1.3.6.1.2.1.10.18.9.1.3", &_names[850],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[849], &_types[851], NULLOT, &_types[851] },
    { "dsx1TotalSEFSs", "1.3.6.1.2.1.10.18.9.1.4", &_names[851],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[850], &_types[852], NULLOT, &_types[852] },
    { "dsx1TotalUASs", "1.3.6.1.2.1.10.18.9.1.5", &_names[852],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[851], &_types[853], NULLOT, &_types[853] },
    { "dsx1TotalCSSs", "1.3.6.1.2.1.10.18.9.1.6", &_names[853],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[852], &_types[855], NULLOT, &_types[854] },
    { "dsx1TotalPCVs", "1.3.6.1.2.1.10.18.9.1.7", &_names[854],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[845], &_types[858], NULLOT, &_types[855] },
    { "dsx1TotalLESs", "1.3.6.1.2.1.10.18.9.1.8", &_names[855],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[853], &_types[856], NULLOT, &_types[856] },
    { "dsx1TotalBESs", "1.3.6.1.2.1.10.18.9.1.9", &_names[856],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[855], NULLOT, NULLOT, &_types[857] },
    { "dsx1TotalDMs", "1.3.6.1.2.1.10.18.9.1.10", &_names[857],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[844], &_types[854], NULLOT, &_types[858] },
    { "dsx1TotalLCVs", "1.3.6.1.2.1.10.18.9.1.11", &_names[858],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[854], &_types[849], NULLOT, &_types[859] },
    { "dsx1FarEndCurrentTable", "1.3.6.1.2.1.10.18.10", &_names[859],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[846], &_types[873], &_types[860], &_types[860] },
    { "dsx1FarEndCurrentEntry", "1.3.6.1.2.1.10.18.10.1", &_names[860],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1FarEndCurrentIndex", NULL, NULL,
      &_types[847], NULLOT, &_types[861], &_types[861] },
    { "dsx1FarEndCurrentIndex", "1.3.6.1.2.1.10.18.10.1.1", &_names[861],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[848], &_types[862], NULLOT, &_types[862] },
    { "dsx1FarEndTimeElapsed", "1.3.6.1.2.1.10.18.10.1.2", &_names[862],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 899,
      NULL, NULL, NULL,
      &_types[808], &_types[872], NULLOT, &_types[863] },
    { "dsx1FarEndValidIntervals", "1.3.6.1.2.1.10.18.10.1.3", &_names[863],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 96,
      NULL, NULL, NULL,
      &_types[809], NULLOT, NULLOT, &_types[864] },
    { "dsx1FarEndCurrentESs", "1.3.6.1.2.1.10.18.10.1.4", &_names[864],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[856], &_types[865], NULLOT, &_types[865] },
    { "dsx1FarEndCurrentSESs", "1.3.6.1.2.1.10.18.10.1.5", &_names[865],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[864], &_types[866], NULLOT, &_types[866] },
    { "dsx1FarEndCurrentSEFSs", "1.3.6.1.2.1.10.18.10.1.6", &_names[866],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[865], &_types[867], NULLOT, &_types[867] },
    { "dsx1FarEndCurrentUASs", "1.3.6.1.2.1.10.18.10.1.7", &_names[867],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[866], &_types[868], NULLOT, &_types[868] },
    { "dsx1FarEndCurrentCSSs", "1.3.6.1.2.1.10.18.10.1.8", &_names[868],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[867], &_types[869], NULLOT, &_types[869] },
    { "dsx1FarEndCurrentLESs", "1.3.6.1.2.1.10.18.10.1.9", &_names[869],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[868], &_types[871], NULLOT, &_types[870] },
    { "dsx1FarEndCurrentPCVs", "1.3.6.1.2.1.10.18.10.1.10", &_names[870],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[858], &_types[864], NULLOT, &_types[871] },
    { "dsx1FarEndCurrentBESs", "1.3.6.1.2.1.10.18.10.1.11", &_names[871],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[869], &_types[863], NULLOT, &_types[872] },
    { "dsx1FarEndCurrentDMs", "1.3.6.1.2.1.10.18.10.1.12", &_names[872],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[857], &_types[870], NULLOT, &_types[873] },
    { "dsx1FarEndIntervalTable", "1.3.6.1.2.1.10.18.11", &_names[873],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[859], &_types[886], &_types[874], &_types[874] },
    { "dsx1FarEndIntervalEntry", "1.3.6.1.2.1.10.18.11.1", &_names[874],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1FarEndIntervalIndex dsx1FarEndIntervalNumber", NULL, NULL,
      &_types[860], NULLOT, &_types[876], &_types[875] },
    { "dsx1FarEndIntervalIndex", "1.3.6.1.2.1.10.18.11.1.1", &_names[875],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[861], &_types[885], NULLOT, &_types[876] },
    { "dsx1FarEndIntervalNumber", "1.3.6.1.2.1.10.18.11.1.2", &_names[876],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 96,
      NULL, NULL, NULL,
      &_types[835], &_types[875], NULLOT, &_types[877] },
    { "dsx1FarEndIntervalESs", "1.3.6.1.2.1.10.18.11.1.3", &_names[877],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[871], &_types[878], NULLOT, &_types[878] },
    { "dsx1FarEndIntervalSESs", "1.3.6.1.2.1.10.18.11.1.4", &_names[878],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[877], &_types[879], NULLOT, &_types[879] },
    { "dsx1FarEndIntervalSEFSs", "1.3.6.1.2.1.10.18.11.1.5", &_names[879],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[878], &_types[880], NULLOT, &_types[880] },
    { "dsx1FarEndIntervalUASs", "1.3.6.1.2.1.10.18.11.1.6", &_names[880],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[879], &_types[881], NULLOT, &_types[881] },
    { "dsx1FarEndIntervalCSSs", "1.3.6.1.2.1.10.18.11.1.7", &_names[881],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[880], &_types[882], NULLOT, &_types[882] },
    { "dsx1FarEndIntervalLESs", "1.3.6.1.2.1.10.18.11.1.8", &_names[882],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[881], &_types[884], NULLOT, &_types[883] },
    { "dsx1FarEndIntervalPCVs", "1.3.6.1.2.1.10.18.11.1.9", &_names[883],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[870], &_types[877], NULLOT, &_types[884] },
    { "dsx1FarEndIntervalBESs", "1.3.6.1.2.1.10.18.11.1.10", &_names[884],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[882], NULLOT, NULLOT, &_types[885] },
    { "dsx1FarEndIntervalDMs", "1.3.6.1.2.1.10.18.11.1.11", &_names[885],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[872], &_types[883], NULLOT, &_types[886] },
    { "dsx1FarEndTotalTable", "1.3.6.1.2.1.10.18.12", &_names[886],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[873], &_types[898], &_types[887], &_types[887] },
    { "dsx1FarEndTotalEntry", "1.3.6.1.2.1.10.18.12.1", &_names[887],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1FarEndTotalIndex", NULL, NULL,
      &_types[874], NULLOT, &_types[888], &_types[888] },
    { "dsx1FarEndTotalIndex", "1.3.6.1.2.1.10.18.12.1.1", &_names[888],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[875], &_types[897], NULLOT, &_types[889] },
    { "dsx1FarEndTotalESs", "1.3.6.1.2.1.10.18.12.1.2", &_names[889],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[884], &_types[890], NULLOT, &_types[890] },
    { "dsx1FarEndTotalSESs", "1.3.6.1.2.1.10.18.12.1.3", &_names[890],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[889], &_types[891], NULLOT, &_types[891] },
    { "dsx1FarEndTotalSEFSs", "1.3.6.1.2.1.10.18.12.1.4", &_names[891],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[890], &_types[892], NULLOT, &_types[892] },
    { "dsx1FarEndTotalUASs", "1.3.6.1.2.1.10.18.12.1.5", &_names[892],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[891], &_types[893], NULLOT, &_types[893] },
    { "dsx1FarEndTotalCSSs", "1.3.6.1.2.1.10.18.12.1.6", &_names[893],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[892], &_types[894], NULLOT, &_types[894] },
    { "dsx1FarEndTotalLESs", "1.3.6.1.2.1.10.18.12.1.7", &_names[894],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[893], &_types[896], NULLOT, &_types[895] },
    { "dsx1FarEndTotalPCVs", "1.3.6.1.2.1.10.18.12.1.8", &_names[895],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[883], &_types[889], NULLOT, &_types[896] },
    { "dsx1FarEndTotalBESs", "1.3.6.1.2.1.10.18.12.1.9", &_names[896],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[894], NULLOT, NULLOT, &_types[897] },
    { "dsx1FarEndTotalDMs", "1.3.6.1.2.1.10.18.12.1.10", &_names[897],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[885], &_types[895], NULLOT, &_types[898] },
    { "dsx1FracTable", "1.3.6.1.2.1.10.18.13", &_names[898],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[886], NULLOT, &_types[899], &_types[899] },
    { "dsx1FracEntry", "1.3.6.1.2.1.10.18.13.1", &_names[899],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx1FracIndex dsx1FracNumber", NULL, NULL,
      &_types[887], NULLOT, &_types[901], &_types[900] },
    { "dsx1FracIndex", "1.3.6.1.2.1.10.18.13.1.1", &_names[900],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[888], &_types[902], NULLOT, &_types[901] },
    { "dsx1FracNumber", "1.3.6.1.2.1.10.18.13.1.2", &_names[901],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 31,
      NULL, NULL, NULL,
      &_types[876], &_types[900], NULLOT, &_types[902] },
    { "dsx1FracIfIndex", "1.3.6.1.2.1.10.18.13.1.3", &_names[902],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[900], NULLOT, NULLOT, &_types[903] },
    { "ppp", "1.3.6.1.2.1.10.23", &_names[903],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[789], &_types[515], &_types[968], &_types[904] },
    { "pppLcp", "1.3.6.1.2.1.10.23.1", &_names[904],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[817], &_types[980], &_types[905], &_types[905] },
    { "pppLink", "1.3.6.1.2.1.10.23.1.1", &_names[905],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[344], &_types[930], &_types[906], &_types[906] },
    { "pppLinkStatusTable", "1.3.6.1.2.1.10.23.1.1.1", &_names[906],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[898], &_types[923], &_types[907], &_types[907] },
    { "pppLinkStatusEntry", "1.3.6.1.2.1.10.23.1.1.1.1", &_names[907],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[899], NULLOT, &_types[911], &_types[908] },
    { "pppLinkStatusPhysicalIndex", "1.3.6.1.2.1.10.23.1.1.1.1.1", &_names[908],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[902], &_types[915], NULLOT, &_types[909] },
    { "pppLinkStatusBadAddresses", "1.3.6.1.2.1.10.23.1.1.1.1.2", &_names[909],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[796], &_types[917], NULLOT, &_types[910] },
    { "pppLinkStatusBadControls", "1.3.6.1.2.1.10.23.1.1.1.1.3", &_names[910],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[948], &_types[909], NULLOT, &_types[911] },
    { "pppLinkStatusPacketTooLongs", "1.3.6.1.2.1.10.23.1.1.1.1.4", &_names[911],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[907], &_types[921], NULLOT, &_types[912] },
    { "pppLinkStatusBadFCSs", "1.3.6.1.2.1.10.23.1.1.1.1.5", &_names[912],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[896], &_types[913], NULLOT, &_types[913] },
    { "pppLinkStatusLocalMRU", "1.3.6.1.2.1.10.23.1.1.1.1.6", &_names[913],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[507], &_types[914], NULLOT, &_types[914] },
    { "pppLinkStatusRemoteMRU", "1.3.6.1.2.1.10.23.1.1.1.1.7", &_names[914],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[913], NULLOT, NULLOT, &_types[915] },
    { "pppLinkStatusLocalToPeerACCMap", "1.3.6.1.2.1.10.23.1.1.1.1.8", &_names[915],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[787], &_types[916], NULLOT, &_types[916] },
    { "pppLinkStatusPeerToLocalACCMap", "1.3.6.1.2.1.10.23.1.1.1.1.9", &_names[916],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[915], &_types[912], NULLOT, &_types[917] },
    { "pppLinkStatusLocalToRemoteProtocolCompression", "1.3.6.1.2.1.10.23.1.1.1.1.10", &_names[917],
      (OS) 295, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[909], &_types[918], NULLOT, &_types[918] },
    { "pppLinkStatusRemoteToLocalProtocolCompression", "1.3.6.1.2.1.10.23.1.1.1.1.11", &_names[918],
      (OS) 296, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[917], &_types[919], NULLOT, &_types[919] },
    { "pppLinkStatusLocalToRemoteACCompression", "1.3.6.1.2.1.10.23.1.1.1.1.12", &_names[919],
      (OS) 297, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[918], &_types[920], NULLOT, &_types[920] },
    { "pppLinkStatusRemoteToLocalACCompression", "1.3.6.1.2.1.10.23.1.1.1.1.13", &_names[920],
      (OS) 298, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[919], &_types[908], NULLOT, &_types[921] },
    { "pppLinkStatusTransmitFcsSize", "1.3.6.1.2.1.10.23.1.1.1.1.14", &_names[921],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 128,
      NULL, NULL, NULL,
      &_types[769], &_types[922], NULLOT, &_types[922] },
    { "pppLinkStatusReceiveFcsSize", "1.3.6.1.2.1.10.23.1.1.1.1.15", &_names[922],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 128,
      NULL, NULL, NULL,
      &_types[921], &_types[910], NULLOT, &_types[923] },
    { "pppLinkConfigTable", "1.3.6.1.2.1.10.23.1.1.2", &_names[923],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[906], NULLOT, &_types[924], &_types[924] },
    { "pppLinkConfigEntry", "1.3.6.1.2.1.10.23.1.1.2.1", &_names[924],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[911], NULLOT, &_types[928], &_types[925] },
    { "pppLinkConfigInitialMRU", "1.3.6.1.2.1.10.23.1.1.2.1.1", &_names[925],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[914], NULLOT, NULLOT, &_types[926] },
    { "pppLinkConfigReceiveACCMap", "1.3.6.1.2.1.10.23.1.1.2.1.2", &_names[926],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[916], &_types[927], NULLOT, &_types[927] },
    { "pppLinkConfigTransmitACCMap", "1.3.6.1.2.1.10.23.1.1.2.1.3", &_names[927],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[926], &_types[925], NULLOT, &_types[928] },
    { "pppLinkConfigMagicNumber", "1.3.6.1.2.1.10.23.1.1.2.1.4", &_names[928],
      (OS) 299, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[901], &_types[929], NULLOT, &_types[929] },
    { "pppLinkConfigFcsSize", "1.3.6.1.2.1.10.23.1.1.2.1.5", &_names[929],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 128,
      NULL, NULL, NULL,
      &_types[922], &_types[926], NULLOT, &_types[930] },
    { "pppLqr", "1.3.6.1.2.1.10.23.1.2", &_names[930],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[760], &_types[946], &_types[931], &_types[931] },
    { "pppLqrTable", "1.3.6.1.2.1.10.23.1.2.1", &_names[931],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[923], &_types[939], &_types[932], &_types[932] },
    { "pppLqrEntry", "1.3.6.1.2.1.10.23.1.2.1.1", &_names[932],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[924], NULLOT, &_types[934], &_types[933] },
    { "pppLqrQuality", "1.3.6.1.2.1.10.23.1.2.1.1.1", &_names[933],
      (OS) 300, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[639], &_types[935], NULLOT, &_types[934] },
    { "pppLqrInGoodOctets", "1.3.6.1.2.1.10.23.1.2.1.1.2", &_names[934],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[815], &_types[933], NULLOT, &_types[935] },
    { "pppLqrLocalPeriod", "1.3.6.1.2.1.10.23.1.2.1.1.3", &_names[935],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[933], &_types[936], NULLOT, &_types[936] },
    { "pppLqrRemotePeriod", "1.3.6.1.2.1.10.23.1.2.1.1.4", &_names[936],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[935], &_types[937], NULLOT, &_types[937] },
    { "pppLqrOutLQRs", "1.3.6.1.2.1.10.23.1.2.1.1.5", &_names[937],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2327], &_types[938], NULLOT, &_types[938] },
    { "pppLqrInLQRs", "1.3.6.1.2.1.10.23.1.2.1.1.6", &_names[938],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[937], NULLOT, NULLOT, &_types[939] },
    { "pppLqrConfigTable", "1.3.6.1.2.1.10.23.1.2.2", &_names[939],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[931], &_types[943], &_types[940], &_types[940] },
    { "pppLqrConfigEntry", "1.3.6.1.2.1.10.23.1.2.2.1", &_names[940],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[932], NULLOT, &_types[942], &_types[941] },
    { "pppLqrConfigPeriod", "1.3.6.1.2.1.10.23.1.2.2.1.1", &_names[941],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[936], NULLOT, NULLOT, &_types[942] },
    { "pppLqrConfigStatus", "1.3.6.1.2.1.10.23.1.2.2.1.2", &_names[942],
      (OS) 301, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[934], &_types[941], NULLOT, &_types[943] },
    { "pppLqrExtnsTable", "1.3.6.1.2.1.10.23.1.2.3", &_names[943],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[939], NULLOT, &_types[944], &_types[944] },
    { "pppLqrExtnsEntry", "1.3.6.1.2.1.10.23.1.2.3.1", &_names[944],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[940], NULLOT, &_types[945], &_types[945] },
    { "pppLqrExtnsLastReceivedLqrPacket", "1.3.6.1.2.1.10.23.1.2.3.1.1", &_names[945],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 68, 68,
      NULL, NULL, NULL,
      &_types[730], NULLOT, NULLOT, &_types[946] },
    { "pppTests", "1.3.6.1.2.1.10.23.1.3", &_names[946],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[816], NULLOT, &_types[947], &_types[947] },
    { "pppEchoTest", "1.3.6.1.2.1.10.23.1.3.1", &_names[947],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[946], &_types[948], NULLOT, &_types[948] },
    { "pppDiscardTest", "1.3.6.1.2.1.10.23.1.3.2", &_names[948],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[947], NULLOT, NULLOT, &_types[949] },
    { "pppSecurity", "1.3.6.1.2.1.10.23.2", &_names[949],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[905], NULLOT, &_types[950], &_types[950] },
    { "pppSecurityProtocols", "1.3.6.1.2.1.10.23.2.1", &_names[950],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[930], &_types[953], &_types[951], &_types[951] },
    { "pppSecurityPapProtocol", "1.3.6.1.2.1.10.23.2.1.1", &_names[951],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[950], &_types[952], NULLOT, &_types[952] },
    { "pppSecurityChapMD5Protocol", "1.3.6.1.2.1.10.23.2.1.2", &_names[952],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[951], NULLOT, NULLOT, &_types[953] },
    { "pppSecurityConfigTable", "1.3.6.1.2.1.10.23.2.2", &_names[953],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[943], &_types[959], &_types[954], &_types[954] },
    { "pppSecurityConfigEntry", "1.3.6.1.2.1.10.23.2.2.1", &_names[954],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "pppSecurityConfigLink pppSecurityConfigPreference", NULL, NULL,
      &_types[944], NULLOT, &_types[956], &_types[955] },
    { "pppSecurityConfigLink", "1.3.6.1.2.1.10.23.2.2.1.1", &_names[955],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[949], &_types[957], NULLOT, &_types[956] },
    { "pppSecurityConfigPreference", "1.3.6.1.2.1.10.23.2.2.1.2", &_names[956],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[799], &_types[958], NULLOT, &_types[957] },
    { "pppSecurityConfigProtocol", "1.3.6.1.2.1.10.23.2.2.1.3", &_names[957],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[952], NULLOT, NULLOT, &_types[958] },
    { "pppSecurityConfigStatus", "1.3.6.1.2.1.10.23.2.2.1.4", &_names[958],
      (OS) 302, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[942], &_types[955], NULLOT, &_types[959] },
    { "pppSecuritySecretsTable", "1.3.6.1.2.1.10.23.2.3", &_names[959],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[953], NULLOT, &_types[960], &_types[960] },
    { "pppSecuritySecretsEntry", "1.3.6.1.2.1.10.23.2.3.1", &_names[960],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "pppSecuritySecretsLink pppSecuritySecretsIdIndex", NULL, NULL,
      &_types[954], NULLOT, &_types[967], &_types[961] },
    { "pppSecuritySecretsLink", "1.3.6.1.2.1.10.23.2.3.1.1", &_names[961],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[955], &_types[966], NULLOT, &_types[962] },
    { "pppSecuritySecretsIdIndex", "1.3.6.1.2.1.10.23.2.3.1.2", &_names[962],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[908], &_types[961], NULLOT, &_types[963] },
    { "pppSecuritySecretsDirection", "1.3.6.1.2.1.10.23.2.3.1.3", &_names[963],
      (OS) 303, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[957], &_types[964], NULLOT, &_types[964] },
    { "pppSecuritySecretsProtocol", "1.3.6.1.2.1.10.23.2.3.1.4", &_names[964],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[963], NULLOT, NULLOT, &_types[965] },
    { "pppSecuritySecretsIdentity", "1.3.6.1.2.1.10.23.2.3.1.5", &_names[965],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[813], &_types[963], NULLOT, &_types[966] },
    { "pppSecuritySecretsSecret", "1.3.6.1.2.1.10.23.2.3.1.6", &_names[966],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[961], &_types[965], NULLOT, &_types[967] },
    { "pppSecuritySecretsStatus", "1.3.6.1.2.1.10.23.2.3.1.7", &_names[967],
      (OS) 304, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[958], &_types[962], NULLOT, &_types[968] },
    { "pppIp", "1.3.6.1.2.1.10.23.3", &_names[968],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[46], &_types[904], &_types[969], &_types[969] },
    { "pppIpTable", "1.3.6.1.2.1.10.23.3.1", &_names[969],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[959], &_types[976], &_types[970], &_types[970] },
    { "pppIpEntry", "1.3.6.1.2.1.10.23.3.1.1", &_names[970],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[960], NULLOT, &_types[971], &_types[971] },
    { "pppIpOperStatus", "1.3.6.1.2.1.10.23.3.1.1.1", &_names[971],
      (OS) 305, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[967], &_types[974], NULLOT, &_types[972] },
    { "pppIpLocalToRemoteCompressionProtocol", "1.3.6.1.2.1.10.23.3.1.1.2", &_names[972],
      (OS) 306, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[964], &_types[973], NULLOT, &_types[973] },
    { "pppIpRemoteToLocalCompressionProtocol", "1.3.6.1.2.1.10.23.3.1.1.3", &_names[973],
      (OS) 307, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[972], NULLOT, NULLOT, &_types[974] },
    { "pppIpRemoteMaxSlotId", "1.3.6.1.2.1.10.23.3.1.1.4", &_names[974],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[776], &_types[975], NULLOT, &_types[975] },
    { "pppIpLocalMaxSlotId", "1.3.6.1.2.1.10.23.3.1.1.5", &_names[975],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[974], &_types[972], NULLOT, &_types[976] },
    { "pppIpConfigTable", "1.3.6.1.2.1.10.23.3.2", &_names[976],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[969], NULLOT, &_types[977], &_types[977] },
    { "pppIpConfigEntry", "1.3.6.1.2.1.10.23.3.2.1", &_names[977],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[970], NULLOT, &_types[979], &_types[978] },
    { "pppIpConfigAdminStatus", "1.3.6.1.2.1.10.23.3.2.1.1", &_names[978],
      (OS) 308, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[971], NULLOT, NULLOT, &_types[979] },
    { "pppIpConfigCompression", "1.3.6.1.2.1.10.23.3.2.1.2", &_names[979],
      (OS) 309, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[920], &_types[978], NULLOT, &_types[980] },
    { "pppBridge", "1.3.6.1.2.1.10.23.4", &_names[980],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[904], &_types[949], &_types[981], &_types[981] },
    { "pppBridgeTable", "1.3.6.1.2.1.10.23.4.1", &_names[981],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[976], &_types[988], &_types[982], &_types[982] },
    { "pppBridgeEntry", "1.3.6.1.2.1.10.23.4.1.1", &_names[982],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[977], NULLOT, &_types[984], &_types[983] },
    { "pppBridgeOperStatus", "1.3.6.1.2.1.10.23.4.1.1.1", &_names[983],
      (OS) 310, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[978], &_types[986], NULLOT, &_types[984] },
    { "pppBridgeLocalToRemoteTinygramCompression", "1.3.6.1.2.1.10.23.4.1.1.2", &_names[984],
      (OS) 311, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[979], &_types[985], NULLOT, &_types[985] },
    { "pppBridgeRemoteToLocalTinygramCompression", "1.3.6.1.2.1.10.23.4.1.1.3", &_names[985],
      (OS) 312, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[984], &_types[983], NULLOT, &_types[986] },
    { "pppBridgeLocalToRemoteLanId", "1.3.6.1.2.1.10.23.4.1.1.4", &_names[986],
      (OS) 313, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[975], &_types[987], NULLOT, &_types[987] },
    { "pppBridgeRemoteToLocalLanId", "1.3.6.1.2.1.10.23.4.1.1.5", &_names[987],
      (OS) 314, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[986], NULLOT, NULLOT, &_types[988] },
    { "pppBridgeConfigTable", "1.3.6.1.2.1.10.23.4.2", &_names[988],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[981], &_types[995], &_types[989], &_types[989] },
    { "pppBridgeConfigEntry", "1.3.6.1.2.1.10.23.4.2.1", &_names[989],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[982], NULLOT, &_types[990], &_types[990] },
    { "pppBridgeConfigAdminStatus", "1.3.6.1.2.1.10.23.4.2.1.1", &_names[990],
      (OS) 315, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[983], &_types[991], NULLOT, &_types[991] },
    { "pppBridgeConfigTinygram", "1.3.6.1.2.1.10.23.4.2.1.2", &_names[991],
      (OS) 316, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[980], &_types[992], NULLOT, &_types[992] },
    { "pppBridgeConfigRingId", "1.3.6.1.2.1.10.23.4.2.1.3", &_names[992],
      (OS) 317, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[987], &_types[993], NULLOT, &_types[993] },
    { "pppBridgeConfigLineId", "1.3.6.1.2.1.10.23.4.2.1.4", &_names[993],
      (OS) 318, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[992], &_types[994], NULLOT, &_types[994] },
    { "pppBridgeConfigLanId", "1.3.6.1.2.1.10.23.4.2.1.5", &_names[994],
      (OS) 319, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[993], NULLOT, NULLOT, &_types[995] },
    { "pppBridgeMediaTable", "1.3.6.1.2.1.10.23.4.3", &_names[995],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[988], &_types[1000], &_types[996], &_types[996] },
    { "pppBridgeMediaEntry", "1.3.6.1.2.1.10.23.4.3.1", &_names[996],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex pppBridgeMediaMacType", NULL, NULL,
      &_types[989], NULLOT, &_types[997], &_types[997] },
    { "pppBridgeMediaMacType", "1.3.6.1.2.1.10.23.4.3.1.1", &_names[997],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[996], &_types[998], NULLOT, &_types[998] },
    { "pppBridgeMediaLocalStatus", "1.3.6.1.2.1.10.23.4.3.1.2", &_names[998],
      (OS) 320, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[990], &_types[999], NULLOT, &_types[999] },
    { "pppBridgeMediaRemoteStatus", "1.3.6.1.2.1.10.23.4.3.1.3", &_names[999],
      (OS) 321, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[998], NULLOT, NULLOT, &_types[1000] },
    { "pppBridgeMediaConfigTable", "1.3.6.1.2.1.10.23.4.4", &_names[1000],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[995], NULLOT, &_types[1001], &_types[1001] },
    { "pppBridgeMediaConfigEntry", "1.3.6.1.2.1.10.23.4.4.1", &_names[1001],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex pppBridgeMediaConfigMacType", NULL, NULL,
      &_types[997], NULLOT, &_types[1002], &_types[1002] },
    { "pppBridgeMediaConfigMacType", "1.3.6.1.2.1.10.23.4.4.1.1", &_names[1002],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1001], &_types[1003], NULLOT, &_types[1003] },
    { "pppBridgeMediaConfigLocalStatus", "1.3.6.1.2.1.10.23.4.4.1.2", &_names[1003],
      (OS) 322, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[999], NULLOT, NULLOT, &_types[1004] },
    { "ds3", "1.3.6.1.2.1.10.30", &_names[1004],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[803], &_types[1005], &_types[1005] },
    { "dsx3ConfigTable", "1.3.6.1.2.1.10.30.5", &_names[1005],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1000], &_types[1018], &_types[1006], &_types[1006] },
    { "dsx3ConfigEntry", "1.3.6.1.2.1.10.30.5.1", &_names[1006],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3LineIndex", NULL, NULL,
      &_types[1002], NULLOT, &_types[1011], &_types[1007] },
    { "dsx3LineIndex", "1.3.6.1.2.1.10.30.5.1.1", &_names[1007],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[962], &_types[1008], NULLOT, &_types[1008] },
    { "dsx3IfIndex", "1.3.6.1.2.1.10.30.5.1.2", &_names[1008],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1007], &_types[1009], NULLOT, &_types[1009] },
    { "dsx3TimeElapsed", "1.3.6.1.2.1.10.30.5.1.3", &_names[1009],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 899,
      NULL, NULL, NULL,
      &_types[862], &_types[1017], NULLOT, &_types[1010] },
    { "dsx3ValidIntervals", "1.3.6.1.2.1.10.30.5.1.4", &_names[1010],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 96,
      NULL, NULL, NULL,
      &_types[863], NULLOT, NULLOT, &_types[1011] },
    { "dsx3LineType", "1.3.6.1.2.1.10.30.5.1.5", &_names[1011],
      (OS) 323, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1006], &_types[1015], NULLOT, &_types[1012] },
    { "dsx3LineCoding", "1.3.6.1.2.1.10.30.5.1.6", &_names[1012],
      (OS) 324, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[812], &_types[1013], NULLOT, &_types[1013] },
    { "dsx3SendCode", "1.3.6.1.2.1.10.30.5.1.7", &_names[1013],
      (OS) 325, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1012], &_types[1014], NULLOT, &_types[1014] },
    { "dsx3CircuitIdentifier", "1.3.6.1.2.1.10.30.5.1.8", &_names[1014],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[965], &_types[1010], NULLOT, &_types[1015] },
    { "dsx3LoopbackConfig", "1.3.6.1.2.1.10.30.5.1.9", &_names[1015],
      (OS) 326, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[910], &_types[1016], NULLOT, &_types[1016] },
    { "dsx3LineStatus", "1.3.6.1.2.1.10.30.5.1.10", &_names[1016],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1023,
      NULL, NULL, NULL,
      &_types[1003], &_types[1007], NULLOT, &_types[1017] },
    { "dsx3TransmitClockSource", "1.3.6.1.2.1.10.30.5.1.11", &_names[1017],
      (OS) 327, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[991], &_types[1012], NULLOT, &_types[1018] },
    { "dsx3CurrentTable", "1.3.6.1.2.1.10.30.6", &_names[1018],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1005], &_types[1031], &_types[1019], &_types[1019] },
    { "dsx3CurrentEntry", "1.3.6.1.2.1.10.30.6.1", &_names[1019],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3CurrentIndex", NULL, NULL,
      &_types[1011], NULLOT, &_types[1020], &_types[1020] },
    { "dsx3CurrentIndex", "1.3.6.1.2.1.10.30.6.1.1", &_names[1020],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1008], &_types[1025], NULLOT, &_types[1021] },
    { "dsx3CurrentPESs", "1.3.6.1.2.1.10.30.6.1.2", &_names[1021],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[912], &_types[1022], NULLOT, &_types[1022] },
    { "dsx3CurrentPSESs", "1.3.6.1.2.1.10.30.6.1.3", &_names[1022],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1021], &_types[1023], NULLOT, &_types[1023] },
    { "dsx3CurrentSEFSs", "1.3.6.1.2.1.10.30.6.1.4", &_names[1023],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1022], &_types[1024], NULLOT, &_types[1024] },
    { "dsx3CurrentUASs", "1.3.6.1.2.1.10.30.6.1.5", &_names[1024],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1023], &_types[1027], NULLOT, &_types[1025] },
    { "dsx3CurrentLCVs", "1.3.6.1.2.1.10.30.6.1.6", &_names[1025],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[895], &_types[1026], NULLOT, &_types[1026] },
    { "dsx3CurrentPCVs", "1.3.6.1.2.1.10.30.6.1.7", &_names[1026],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1025], &_types[1028], NULLOT, &_types[1027] },
    { "dsx3CurrentLESs", "1.3.6.1.2.1.10.30.6.1.8", &_names[1027],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1024], &_types[1029], NULLOT, &_types[1028] },
    { "dsx3CurrentCCVs", "1.3.6.1.2.1.10.30.6.1.9", &_names[1028],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1026], &_types[1021], NULLOT, &_types[1029] },
    { "dsx3CurrentCESs", "1.3.6.1.2.1.10.30.6.1.10", &_names[1029],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1027], &_types[1030], NULLOT, &_types[1030] },
    { "dsx3CurrentCSESs", "1.3.6.1.2.1.10.30.6.1.11", &_names[1030],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1029], NULLOT, NULLOT, &_types[1031] },
    { "dsx3IntervalTable", "1.3.6.1.2.1.10.30.7", &_names[1031],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1018], &_types[1045], &_types[1032], &_types[1032] },
    { "dsx3IntervalEntry", "1.3.6.1.2.1.10.30.7.1", &_names[1032],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3IntervalIndex dsx3IntervalNumber", NULL, NULL,
      &_types[1019], NULLOT, &_types[1034], &_types[1033] },
    { "dsx3IntervalIndex", "1.3.6.1.2.1.10.30.7.1.1", &_names[1033],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1020], &_types[1039], NULLOT, &_types[1034] },
    { "dsx3IntervalNumber", "1.3.6.1.2.1.10.30.7.1.2", &_names[1034],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 96,
      NULL, NULL, NULL,
      &_types[928], &_types[1033], NULLOT, &_types[1035] },
    { "dsx3IntervalPESs", "1.3.6.1.2.1.10.30.7.1.3", &_names[1035],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1030], &_types[1036], NULLOT, &_types[1036] },
    { "dsx3IntervalPSESs", "1.3.6.1.2.1.10.30.7.1.4", &_names[1036],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1035], &_types[1037], NULLOT, &_types[1037] },
    { "dsx3IntervalSEFSs", "1.3.6.1.2.1.10.30.7.1.5", &_names[1037],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1036], &_types[1038], NULLOT, &_types[1038] },
    { "dsx3IntervalUASs", "1.3.6.1.2.1.10.30.7.1.6", &_names[1038],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1037], &_types[1041], NULLOT, &_types[1039] },
    { "dsx3IntervalLCVs", "1.3.6.1.2.1.10.30.7.1.7", &_names[1039],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1028], &_types[1040], NULLOT, &_types[1040] },
    { "dsx3IntervalPCVs", "1.3.6.1.2.1.10.30.7.1.8", &_names[1040],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1039], &_types[1042], NULLOT, &_types[1041] },
    { "dsx3IntervalLESs", "1.3.6.1.2.1.10.30.7.1.9", &_names[1041],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1038], &_types[1043], NULLOT, &_types[1042] },
    { "dsx3IntervalCCVs", "1.3.6.1.2.1.10.30.7.1.10", &_names[1042],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1040], &_types[1035], NULLOT, &_types[1043] },
    { "dsx3IntervalCESs", "1.3.6.1.2.1.10.30.7.1.11", &_names[1043],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1041], &_types[1044], NULLOT, &_types[1044] },
    { "dsx3IntervalCSESs", "1.3.6.1.2.1.10.30.7.1.12", &_names[1044],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1043], NULLOT, NULLOT, &_types[1045] },
    { "dsx3TotalTable", "1.3.6.1.2.1.10.30.8", &_names[1045],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1031], &_types[1058], &_types[1046], &_types[1046] },
    { "dsx3TotalEntry", "1.3.6.1.2.1.10.30.8.1", &_names[1046],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3TotalIndex", NULL, NULL,
      &_types[1032], NULLOT, &_types[1047], &_types[1047] },
    { "dsx3TotalIndex", "1.3.6.1.2.1.10.30.8.1.1", &_names[1047],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1033], &_types[1052], NULLOT, &_types[1048] },
    { "dsx3TotalPESs", "1.3.6.1.2.1.10.30.8.1.2", &_names[1048],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1044], &_types[1049], NULLOT, &_types[1049] },
    { "dsx3TotalPSESs", "1.3.6.1.2.1.10.30.8.1.3", &_names[1049],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1048], &_types[1050], NULLOT, &_types[1050] },
    { "dsx3TotalSEFSs", "1.3.6.1.2.1.10.30.8.1.4", &_names[1050],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1049], &_types[1051], NULLOT, &_types[1051] },
    { "dsx3TotalUASs", "1.3.6.1.2.1.10.30.8.1.5", &_names[1051],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1050], &_types[1054], NULLOT, &_types[1052] },
    { "dsx3TotalLCVs", "1.3.6.1.2.1.10.30.8.1.6", &_names[1052],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1042], &_types[1053], NULLOT, &_types[1053] },
    { "dsx3TotalPCVs", "1.3.6.1.2.1.10.30.8.1.7", &_names[1053],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1052], &_types[1055], NULLOT, &_types[1054] },
    { "dsx3TotalLESs", "1.3.6.1.2.1.10.30.8.1.8", &_names[1054],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1051], &_types[1056], NULLOT, &_types[1055] },
    { "dsx3TotalCCVs", "1.3.6.1.2.1.10.30.8.1.9", &_names[1055],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1053], &_types[1048], NULLOT, &_types[1056] },
    { "dsx3TotalCESs", "1.3.6.1.2.1.10.30.8.1.10", &_names[1056],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1054], &_types[1057], NULLOT, &_types[1057] },
    { "dsx3TotalCSESs", "1.3.6.1.2.1.10.30.8.1.11", &_names[1057],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1056], NULLOT, NULLOT, &_types[1058] },
    { "dsx3FarEndConfigTable", "1.3.6.1.2.1.10.30.9", &_names[1058],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1045], &_types[1066], &_types[1059], &_types[1059] },
    { "dsx3FarEndConfigEntry", "1.3.6.1.2.1.10.30.9.1", &_names[1059],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3FarEndLineIndex", NULL, NULL,
      &_types[1046], NULLOT, &_types[1060], &_types[1060] },
    { "dsx3FarEndLineIndex", "1.3.6.1.2.1.10.30.9.1.1", &_names[1060],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1047], &_types[1061], NULLOT, &_types[1061] },
    { "dsx3FarEndEquipCode", "1.3.6.1.2.1.10.30.9.1.2", &_names[1061],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 10,
      NULL, NULL, NULL,
      &_types[1013], &_types[1062], NULLOT, &_types[1062] },
    { "dsx3FarEndLocationIDCode", "1.3.6.1.2.1.10.30.9.1.3", &_names[1062],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 11,
      NULL, NULL, NULL,
      &_types[1061], &_types[1063], NULLOT, &_types[1063] },
    { "dsx3FarEndFrameIDCode", "1.3.6.1.2.1.10.30.9.1.4", &_names[1063],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 10,
      NULL, NULL, NULL,
      &_types[1062], &_types[1064], NULLOT, &_types[1064] },
    { "dsx3FarEndUnitCode", "1.3.6.1.2.1.10.30.9.1.5", &_names[1064],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 6,
      NULL, NULL, NULL,
      &_types[1063], &_types[1065], NULLOT, &_types[1065] },
    { "dsx3FarEndFacilityIDCode", "1.3.6.1.2.1.10.30.9.1.6", &_names[1065],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 38,
      NULL, NULL, NULL,
      &_types[1064], NULLOT, NULLOT, &_types[1066] },
    { "dsx3FarEndCurrentTable", "1.3.6.1.2.1.10.30.10", &_names[1066],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1058], &_types[1075], &_types[1067], &_types[1067] },
    { "dsx3FarEndCurrentEntry", "1.3.6.1.2.1.10.30.10.1", &_names[1067],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3FarEndCurrentIndex", NULL, NULL,
      &_types[1059], NULLOT, &_types[1068], &_types[1068] },
    { "dsx3FarEndCurrentIndex", "1.3.6.1.2.1.10.30.10.1.1", &_names[1068],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1060], &_types[1069], NULLOT, &_types[1069] },
    { "dsx3FarEndTimeElapsed", "1.3.6.1.2.1.10.30.10.1.2", &_names[1069],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 899,
      NULL, NULL, NULL,
      &_types[1009], &_types[1073], NULLOT, &_types[1070] },
    { "dsx3FarEndValidIntervals", "1.3.6.1.2.1.10.30.10.1.3", &_names[1070],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 96,
      NULL, NULL, NULL,
      &_types[1010], NULLOT, NULLOT, &_types[1071] },
    { "dsx3FarEndCurrentCESs", "1.3.6.1.2.1.10.30.10.1.4", &_names[1071],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1057], &_types[1072], NULLOT, &_types[1072] },
    { "dsx3FarEndCurrentCSESs", "1.3.6.1.2.1.10.30.10.1.5", &_names[1072],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1071], &_types[1074], NULLOT, &_types[1073] },
    { "dsx3FarEndCurrentCCVs", "1.3.6.1.2.1.10.30.10.1.6", &_names[1073],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1055], &_types[1071], NULLOT, &_types[1074] },
    { "dsx3FarEndCurrentUASs", "1.3.6.1.2.1.10.30.10.1.7", &_names[1074],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1072], &_types[1070], NULLOT, &_types[1075] },
    { "dsx3FarEndIntervalTable", "1.3.6.1.2.1.10.30.11", &_names[1075],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1066], &_types[1083], &_types[1076], &_types[1076] },
    { "dsx3FarEndIntervalEntry", "1.3.6.1.2.1.10.30.11.1", &_names[1076],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3FarEndIntervalIndex dsx3FarEndIntervalNumber", NULL, NULL,
      &_types[1067], NULLOT, &_types[1078], &_types[1077] },
    { "dsx3FarEndIntervalIndex", "1.3.6.1.2.1.10.30.11.1.1", &_names[1077],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1068], &_types[1081], NULLOT, &_types[1078] },
    { "dsx3FarEndIntervalNumber", "1.3.6.1.2.1.10.30.11.1.2", &_names[1078],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 96,
      NULL, NULL, NULL,
      &_types[1034], &_types[1077], NULLOT, &_types[1079] },
    { "dsx3FarEndIntervalCESs", "1.3.6.1.2.1.10.30.11.1.3", &_names[1079],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1074], &_types[1080], NULLOT, &_types[1080] },
    { "dsx3FarEndIntervalCSESs", "1.3.6.1.2.1.10.30.11.1.4", &_names[1080],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1079], &_types[1082], NULLOT, &_types[1081] },
    { "dsx3FarEndIntervalCCVs", "1.3.6.1.2.1.10.30.11.1.5", &_names[1081],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1073], &_types[1079], NULLOT, &_types[1082] },
    { "dsx3FarEndIntervalUASs", "1.3.6.1.2.1.10.30.11.1.6", &_names[1082],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1080], NULLOT, NULLOT, &_types[1083] },
    { "dsx3FarEndTotalTable", "1.3.6.1.2.1.10.30.12", &_names[1083],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1075], &_types[1090], &_types[1084], &_types[1084] },
    { "dsx3FarEndTotalEntry", "1.3.6.1.2.1.10.30.12.1", &_names[1084],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3FarEndTotalIndex", NULL, NULL,
      &_types[1076], NULLOT, &_types[1085], &_types[1085] },
    { "dsx3FarEndTotalIndex", "1.3.6.1.2.1.10.30.12.1.1", &_names[1085],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1077], &_types[1088], NULLOT, &_types[1086] },
    { "dsx3FarEndTotalCESs", "1.3.6.1.2.1.10.30.12.1.2", &_names[1086],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1082], &_types[1087], NULLOT, &_types[1087] },
    { "dsx3FarEndTotalCSESs", "1.3.6.1.2.1.10.30.12.1.3", &_names[1087],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1086], &_types[1089], NULLOT, &_types[1088] },
    { "dsx3FarEndTotalCCVs", "1.3.6.1.2.1.10.30.12.1.4", &_names[1088],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1081], &_types[1086], NULLOT, &_types[1089] },
    { "dsx3FarEndTotalUASs", "1.3.6.1.2.1.10.30.12.1.5", &_names[1089],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1087], NULLOT, NULLOT, &_types[1090] },
    { "dsx3FracTable", "1.3.6.1.2.1.10.30.13", &_names[1090],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1083], NULLOT, &_types[1091], &_types[1091] },
    { "dsx3FracEntry", "1.3.6.1.2.1.10.30.13.1", &_names[1091],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dsx3FracIndex dsx3FracNumber", NULL, NULL,
      &_types[1084], NULLOT, &_types[1093], &_types[1092] },
    { "dsx3FracIndex", "1.3.6.1.2.1.10.30.13.1.1", &_names[1092],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[1085], &_types[1094], NULLOT, &_types[1093] },
    { "dsx3FracNumber", "1.3.6.1.2.1.10.30.13.1.2", &_names[1093],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 31,
      NULL, NULL, NULL,
      &_types[1078], &_types[1092], NULLOT, &_types[1094] },
    { "dsx3FracIfIndex", "1.3.6.1.2.1.10.30.13.1.3", &_names[1094],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[1092], NULLOT, NULLOT, &_types[1095] },
    { "sip", "1.3.6.1.2.1.10.31", &_names[1095],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1069], &_types[1150], &_types[1141], &_types[1096] },
    { "sipL3Table", "1.3.6.1.2.1.10.31.1", &_names[1096],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1090], &_types[1108], &_types[1097], &_types[1097] },
    { "sipL3Entry", "1.3.6.1.2.1.10.31.1.1", &_names[1097],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "sipL3Index", NULL, NULL,
      &_types[1091], NULLOT, &_types[1106], &_types[1098] },
    { "sipL3Index", "1.3.6.1.2.1.10.31.1.1.1", &_names[1098],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1094], &_types[1099], NULLOT, &_types[1099] },
    { "sipL3ReceivedIndividualDAs", "1.3.6.1.2.1.10.31.1.1.2", &_names[1099],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1551], &_types[1100], NULLOT, &_types[1100] },
    { "sipL3ReceivedGAs", "1.3.6.1.2.1.10.31.1.1.3", &_names[1100],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1099], &_types[1101], NULLOT, &_types[1101] },
    { "sipL3UnrecognizedIndividualDAs", "1.3.6.1.2.1.10.31.1.1.4", &_names[1101],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1100], &_types[1102], NULLOT, &_types[1102] },
    { "sipL3UnrecognizedGAs", "1.3.6.1.2.1.10.31.1.1.5", &_names[1102],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1101], &_types[1103], NULLOT, &_types[1103] },
    { "sipL3SentIndividualDAs", "1.3.6.1.2.1.10.31.1.1.6", &_names[1103],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1102], &_types[1104], NULLOT, &_types[1104] },
    { "sipL3SentGAs", "1.3.6.1.2.1.10.31.1.1.7", &_names[1104],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1103], &_types[1107], NULLOT, &_types[1105] },
    { "sipL3Errors", "1.3.6.1.2.1.10.31.1.1.8", &_names[1105],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[783], &_types[1098], NULLOT, &_types[1106] },
    { "sipL3InvalidSMDSAddressTypes", "1.3.6.1.2.1.10.31.1.1.9", &_names[1106],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1097], &_types[1105], NULLOT, &_types[1107] },
    { "sipL3VersionSupport", "1.3.6.1.2.1.10.31.1.1.10", &_names[1107],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[249], NULLOT, NULLOT, &_types[1108] },
    { "sipL2Table", "1.3.6.1.2.1.10.31.2", &_names[1108],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1096], &_types[1119], &_types[1109], &_types[1109] },
    { "sipL2Entry", "1.3.6.1.2.1.10.31.2.1", &_names[1109],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "sipL2Index", NULL, NULL,
      &_types[1106], NULLOT, &_types[1111], &_types[1110] },
    { "sipL2Index", "1.3.6.1.2.1.10.31.2.1.1", &_names[1110],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1098], NULLOT, NULLOT, &_types[1111] },
    { "sipL2ReceivedCounts", "1.3.6.1.2.1.10.31.2.1.2", &_names[1111],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[770], &_types[1112], NULLOT, &_types[1112] },
    { "sipL2SentCounts", "1.3.6.1.2.1.10.31.2.1.3", &_names[1112],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1111], &_types[1113], NULLOT, &_types[1113] },
    { "sipL2HcsOrCRCErrors", "1.3.6.1.2.1.10.31.2.1.4", &_names[1113],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1105], &_types[1114], NULLOT, &_types[1114] },
    { "sipL2PayloadLengthErrors", "1.3.6.1.2.1.10.31.2.1.5", &_names[1114],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1113], &_types[1115], NULLOT, &_types[1115] },
    { "sipL2SequenceNumberErrors", "1.3.6.1.2.1.10.31.2.1.6", &_names[1115],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1114], &_types[1116], NULLOT, &_types[1116] },
    { "sipL2MidCurrentlyActiveErrors", "1.3.6.1.2.1.10.31.2.1.7", &_names[1116],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1115], &_types[1117], NULLOT, &_types[1117] },
    { "sipL2BomOrSSMsMIDErrors", "1.3.6.1.2.1.10.31.2.1.8", &_names[1117],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1116], &_types[1118], NULLOT, &_types[1118] },
    { "sipL2EomsMIDErrors", "1.3.6.1.2.1.10.31.2.1.9", &_names[1118],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1117], &_types[1110], NULLOT, &_types[1119] },
    { "sipPLCP", "1.3.6.1.2.1.10.31.3", &_names[1119],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[489], &_types[1142], &_types[1120], &_types[1120] },
    { "sipDS1PLCPTable", "1.3.6.1.2.1.10.31.3.1", &_names[1120],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1108], &_types[1126], &_types[1121], &_types[1121] },
    { "sipDS1PLCPEntry", "1.3.6.1.2.1.10.31.3.1.1", &_names[1121],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "sipDS1PLCPIndex", NULL, NULL,
      &_types[1109], NULLOT, &_types[1124], &_types[1122] },
    { "sipDS1PLCPIndex", "1.3.6.1.2.1.10.31.3.1.1.1", &_names[1122],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1110], &_types[1123], NULLOT, &_types[1123] },
    { "sipDS1PLCPSEFSs", "1.3.6.1.2.1.10.31.3.1.1.2", &_names[1123],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1089], &_types[1125], NULLOT, &_types[1124] },
    { "sipDS1PLCPAlarmState", "1.3.6.1.2.1.10.31.3.1.1.3", &_names[1124],
      (OS) 328, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1016], &_types[1122], NULLOT, &_types[1125] },
    { "sipDS1PLCPUASs", "1.3.6.1.2.1.10.31.3.1.1.4", &_names[1125],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1123], NULLOT, NULLOT, &_types[1126] },
    { "sipDS3PLCPTable", "1.3.6.1.2.1.10.31.3.2", &_names[1126],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1120], NULLOT, &_types[1127], &_types[1127] },
    { "sipDS3PLCPEntry", "1.3.6.1.2.1.10.31.3.2.1", &_names[1127],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "sipDS3PLCPIndex", NULL, NULL,
      &_types[1121], NULLOT, &_types[1130], &_types[1128] },
    { "sipDS3PLCPIndex", "1.3.6.1.2.1.10.31.3.2.1.1", &_names[1128],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1122], &_types[1129], NULLOT, &_types[1129] },
    { "sipDS3PLCPSEFSs", "1.3.6.1.2.1.10.31.3.2.1.2", &_names[1129],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1125], &_types[1131], NULLOT, &_types[1130] },
    { "sipDS3PLCPAlarmState", "1.3.6.1.2.1.10.31.3.2.1.3", &_names[1130],
      (OS) 329, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1124], &_types[1128], NULLOT, &_types[1131] },
    { "sipDS3PLCPUASs", "1.3.6.1.2.1.10.31.3.2.1.4", &_names[1131],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1129], NULLOT, NULLOT, &_types[1132] },
    { "smdsApplications", "1.3.6.1.2.1.10.31.4", &_names[1132],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[985], NULLOT, &_types[1133], &_types[1133] },
    { "ipOverSMDS", "1.3.6.1.2.1.10.31.4.1", &_names[1133],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[637], NULLOT, &_types[1134], &_types[1134] },
    { "ipOverSMDSTable", "1.3.6.1.2.1.10.31.4.1.1", &_names[1134],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1126], NULLOT, &_types[1135], &_types[1135] },
    { "ipOverSMDSEntry", "1.3.6.1.2.1.10.31.4.1.1.1", &_names[1135],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ipOverSMDSIndex ipOverSMDSAddress", NULL, NULL,
      &_types[1127], NULLOT, &_types[1137], &_types[1136] },
    { "ipOverSMDSIndex", "1.3.6.1.2.1.10.31.4.1.1.1.1", &_names[1136],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1128], &_types[1140], NULLOT, &_types[1137] },
    { "ipOverSMDSAddress", "1.3.6.1.2.1.10.31.4.1.1.1.2", &_names[1137],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1132], &_types[1138], NULLOT, &_types[1138] },
    { "ipOverSMDSHA", "1.3.6.1.2.1.10.31.4.1.1.1.3", &_names[1138],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1137], &_types[1139], NULLOT, &_types[1139] },
    { "ipOverSMDSLISGA", "1.3.6.1.2.1.10.31.4.1.1.1.4", &_names[1139],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1138], &_types[1136], NULLOT, &_types[1140] },
    { "ipOverSMDSARPReq", "1.3.6.1.2.1.10.31.4.1.1.1.5", &_names[1140],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[706], NULLOT, NULLOT, &_types[1141] },
    { "smdsCarrierSelection", "1.3.6.1.2.1.10.31.5", &_names[1141],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1095], &_types[1096], NULLOT, &_types[1142] },
    { "sipErrorLog", "1.3.6.1.2.1.10.31.6", &_names[1142],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[929], &_types[1132], &_types[1143], &_types[1143] },
    { "sipL3PDUErrorTable", "1.3.6.1.2.1.10.31.6.1", &_names[1143],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1134], NULLOT, &_types[1144], &_types[1144] },
    { "sipL3PDUErrorEntry", "1.3.6.1.2.1.10.31.6.1.1", &_names[1144],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "sipL3PDUErrorIndex sipL3PDUErrorType", NULL, NULL,
      &_types[1135], NULLOT, &_types[1146], &_types[1145] },
    { "sipL3PDUErrorIndex", "1.3.6.1.2.1.10.31.6.1.1.1", &_names[1145],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1136], NULLOT, NULLOT, &_types[1146] },
    { "sipL3PDUErrorType", "1.3.6.1.2.1.10.31.6.1.1.2", &_names[1146],
      (OS) 330, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1144], &_types[1147], NULLOT, &_types[1147] },
    { "sipL3PDUErrorSA", "1.3.6.1.2.1.10.31.6.1.1.3", &_names[1147],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1139], &_types[1148], NULLOT, &_types[1148] },
    { "sipL3PDUErrorDA", "1.3.6.1.2.1.10.31.6.1.1.4", &_names[1148],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1147], &_types[1149], NULLOT, &_types[1149] },
    { "sipL3PDUErrorTimeStamp", "1.3.6.1.2.1.10.31.6.1.1.5", &_names[1149],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1130], &_types[1145], NULLOT, &_types[1150] },
    { "frame-relay", "1.3.6.1.2.1.10.32", &_names[1150],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1143], &_types[1248], &_types[1185], &_types[1151] },
    { "frDlcmiTable", "1.3.6.1.2.1.10.32.1", &_names[1151],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1185], &_types[1163], &_types[1152], &_types[1152] },
    { "frDlcmiEntry", "1.3.6.1.2.1.10.32.1.1", &_names[1152],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "frDlcmiIfIndex", NULL, NULL,
      &_types[1146], NULLOT, &_types[1162], &_types[1153] },
    { "frDlcmiIfIndex", "1.3.6.1.2.1.10.32.1.1.1", &_names[1153],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1145], &_types[1159], NULLOT, &_types[1154] },
    { "frDlcmiState", "1.3.6.1.2.1.10.32.1.1.2", &_names[1154],
      (OS) 331, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1149], &_types[1153], NULLOT, &_types[1155] },
    { "frDlcmiAddress", "1.3.6.1.2.1.10.32.1.1.3", &_names[1155],
      (OS) 332, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1148], &_types[1154], NULLOT, &_types[1156] },
    { "frDlcmiAddressLen", "1.3.6.1.2.1.10.32.1.1.4", &_names[1156],
      (OS) 333, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1151], &_types[1160], NULLOT, &_types[1157] },
    { "frDlcmiPollingInterval", "1.3.6.1.2.1.10.32.1.1.5", &_names[1157],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 5, 30,
      NULL, NULL, NULL,
      &_types[1070], &_types[1158], NULLOT, &_types[1158] },
    { "frDlcmiFullEnquiryInterval", "1.3.6.1.2.1.10.32.1.1.6", &_names[1158],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 255,
      NULL, NULL, NULL,
      &_types[1157], NULLOT, NULLOT, &_types[1159] },
    { "frDlcmiErrorThreshold", "1.3.6.1.2.1.10.32.1.1.7", &_names[1159],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 10,
      NULL, NULL, NULL,
      &_types[1140], &_types[1156], NULLOT, &_types[1160] },
    { "frDlcmiMonitoredEvents", "1.3.6.1.2.1.10.32.1.1.8", &_names[1160],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 10,
      NULL, NULL, NULL,
      &_types[2608], &_types[1161], NULLOT, &_types[1161] },
    { "frDlcmiMaxSupportedVCs", "1.3.6.1.2.1.10.32.1.1.9", &_names[1161],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[245], &_types[1157], NULLOT, &_types[1162] },
    { "frDlcmiMulticast", "1.3.6.1.2.1.10.32.1.1.10", &_names[1162],
      (OS) 334, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1142], &_types[1155], NULLOT, &_types[1163] },
    { "frCircuitTable", "1.3.6.1.2.1.10.32.2", &_names[1163],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1156], &_types[1179], &_types[1164], &_types[1164] },
    { "frCircuitEntry", "1.3.6.1.2.1.10.32.2.1", &_names[1164],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "frCircuitIfIndex frCircuitDlci", NULL, NULL,
      &_types[1152], NULLOT, &_types[1167], &_types[1165] },
    { "frCircuitIfIndex", "1.3.6.1.2.1.10.32.2.1.1", &_names[1165],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1153], &_types[1176], NULLOT, &_types[1166] },
    { "frCircuitDlci", "1.3.6.1.2.1.10.32.2.1.2", &_names[1166],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[744], &_types[1174], NULLOT, &_types[1167] },
    { "frCircuitState", "1.3.6.1.2.1.10.32.2.1.3", &_names[1167],
      (OS) 335, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1154], &_types[1171], NULLOT, &_types[1168] },
    { "frCircuitReceivedFECNs", "1.3.6.1.2.1.10.32.2.1.4", &_names[1168],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[196], &_types[1169], NULLOT, &_types[1169] },
    { "frCircuitReceivedBECNs", "1.3.6.1.2.1.10.32.2.1.5", &_names[1169],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1168], NULLOT, NULLOT, &_types[1170] },
    { "frCircuitSentFrames", "1.3.6.1.2.1.10.32.2.1.6", &_names[1170],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1163], &_types[1172], NULLOT, &_types[1171] },
    { "frCircuitSentOctets", "1.3.6.1.2.1.10.32.2.1.7", &_names[1171],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1167], &_types[1173], NULLOT, &_types[1172] },
    { "frCircuitReceivedFrames", "1.3.6.1.2.1.10.32.2.1.8", &_names[1172],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1170], &_types[1168], NULLOT, &_types[1173] },
    { "frCircuitReceivedOctets", "1.3.6.1.2.1.10.32.2.1.9", &_names[1173],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1171], &_types[1165], NULLOT, &_types[1174] },
    { "frCircuitCreationTime", "1.3.6.1.2.1.10.32.2.1.10", &_names[1174],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1065], &_types[1170], NULLOT, &_types[1175] },
    { "frCircuitLastTimeChange", "1.3.6.1.2.1.10.32.2.1.11", &_names[1175],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[927], &_types[1166], NULLOT, &_types[1176] },
    { "frCircuitCommittedBurst", "1.3.6.1.2.1.10.32.2.1.12", &_names[1176],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1165], &_types[1177], NULLOT, &_types[1177] },
    { "frCircuitExcessBurst", "1.3.6.1.2.1.10.32.2.1.13", &_names[1177],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1176], &_types[1178], NULLOT, &_types[1178] },
    { "frCircuitThroughput", "1.3.6.1.2.1.10.32.2.1.14", &_names[1178],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1159], &_types[1175], NULLOT, &_types[1179] },
    { "frErrTable", "1.3.6.1.2.1.10.32.3", &_names[1179],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1172], NULLOT, &_types[1180], &_types[1180] },
    { "frErrEntry", "1.3.6.1.2.1.10.32.3.1", &_names[1180],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "frErrIfIndex", NULL, NULL,
      &_types[1164], NULLOT, &_types[1182], &_types[1181] },
    { "frErrIfIndex", "1.3.6.1.2.1.10.32.3.1.1", &_names[1181],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1177], &_types[1184], NULLOT, &_types[1182] },
    { "frErrType", "1.3.6.1.2.1.10.32.3.1.2", &_names[1182],
      (OS) 336, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1180], &_types[1181], NULLOT, &_types[1183] },
    { "frErrData", "1.3.6.1.2.1.10.32.3.1.3", &_names[1183],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[628], NULLOT, NULLOT, &_types[1184] },
    { "frErrTime", "1.3.6.1.2.1.10.32.3.1.4", &_names[1184],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1174], &_types[1183], NULLOT, &_types[1185] },
    { "frame-relay-globals", "1.3.6.1.2.1.10.32.4", &_names[1185],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1150], &_types[1151], &_types[1186], &_types[1186] },
    { "frTrapState", "1.3.6.1.2.1.10.32.4.1", &_names[1186],
      (OS) 337, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1173], NULLOT, NULLOT, &_types[1187] },
    { "rs232", "1.3.6.1.2.1.10.33", &_names[1187],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[1004], &_types[1188], &_types[1188] },
    { "rs232Number", "1.3.6.1.2.1.10.33.1", &_names[1188],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1093], &_types[1189], NULLOT, &_types[1189] },
    { "rs232PortTable", "1.3.6.1.2.1.10.33.2", &_names[1189],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1179], &_types[1197], &_types[1190], &_types[1190] },
    { "rs232PortEntry", "1.3.6.1.2.1.10.33.2.1", &_names[1190],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rs232PortIndex", NULL, NULL,
      &_types[1182], NULLOT, &_types[1192], &_types[1191] },
    { "rs232PortIndex", "1.3.6.1.2.1.10.33.2.1.1", &_names[1191],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1181], &_types[1195], NULLOT, &_types[1192] },
    { "rs232PortType", "1.3.6.1.2.1.10.33.2.1.2", &_names[1192],
      (OS) 338, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1190], &_types[1193], NULLOT, &_types[1193] },
    { "rs232PortInSigNumber", "1.3.6.1.2.1.10.33.2.1.3", &_names[1193],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1188], &_types[1194], NULLOT, &_types[1194] },
    { "rs232PortOutSigNumber", "1.3.6.1.2.1.10.33.2.1.4", &_names[1194],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1193], &_types[1191], NULLOT, &_types[1195] },
    { "rs232PortInSpeed", "1.3.6.1.2.1.10.33.2.1.5", &_names[1195],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[471], &_types[1196], NULLOT, &_types[1196] },
    { "rs232PortOutSpeed", "1.3.6.1.2.1.10.33.2.1.6", &_names[1196],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1195], NULLOT, NULLOT, &_types[1197] },
    { "rs232AsyncPortTable", "1.3.6.1.2.1.10.33.3", &_names[1197],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1189], &_types[1207], &_types[1198], &_types[1198] },
    { "rs232AsyncPortEntry", "1.3.6.1.2.1.10.33.3.1", &_names[1198],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rs232AsyncPortIndex", NULL, NULL,
      &_types[1192], NULLOT, &_types[1204], &_types[1199] },
    { "rs232AsyncPortIndex", "1.3.6.1.2.1.10.33.3.1.1", &_names[1199],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1191], &_types[1200], NULLOT, &_types[1200] },
    { "rs232AsyncPortBits", "1.3.6.1.2.1.10.33.3.1.2", &_names[1200],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 5, 8,
      NULL, NULL, NULL,
      &_types[973], &_types[1201], NULLOT, &_types[1201] },
    { "rs232AsyncPortStopBits", "1.3.6.1.2.1.10.33.3.1.3", &_names[1201],
      (OS) 339, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1200], NULLOT, NULLOT, &_types[1202] },
    { "rs232AsyncPortParity", "1.3.6.1.2.1.10.33.3.1.4", &_names[1202],
      (OS) 340, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1155], &_types[1203], NULLOT, &_types[1203] },
    { "rs232AsyncPortAutobaud", "1.3.6.1.2.1.10.33.3.1.5", &_names[1203],
      (OS) 341, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1186], &_types[1199], NULLOT, &_types[1204] },
    { "rs232AsyncPortParityErrs", "1.3.6.1.2.1.10.33.3.1.6", &_names[1204],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1118], &_types[1205], NULLOT, &_types[1205] },
    { "rs232AsyncPortFramingErrs", "1.3.6.1.2.1.10.33.3.1.7", &_names[1205],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1204], &_types[1206], NULLOT, &_types[1206] },
    { "rs232AsyncPortOverrunErrs", "1.3.6.1.2.1.10.33.3.1.8", &_names[1206],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1205], &_types[1202], NULLOT, &_types[1207] },
    { "rs232SyncPortTable", "1.3.6.1.2.1.10.33.4", &_names[1207],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1197], &_types[1216], &_types[1208], &_types[1208] },
    { "rs232SyncPortEntry", "1.3.6.1.2.1.10.33.4.1", &_names[1208],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rs232SyncPortIndex", NULL, NULL,
      &_types[1198], NULLOT, &_types[1211], &_types[1209] },
    { "rs232SyncPortIndex", "1.3.6.1.2.1.10.33.4.1.1", &_names[1209],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1199], &_types[1210], NULLOT, &_types[1210] },
    { "rs232SyncPortClockSource", "1.3.6.1.2.1.10.33.4.1.2", &_names[1210],
      (OS) 342, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1017], &_types[1214], NULLOT, &_types[1211] },
    { "rs232SyncPortFrameCheckErrs", "1.3.6.1.2.1.10.33.4.1.3", &_names[1211],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1206], &_types[1212], NULLOT, &_types[1212] },
    { "rs232SyncPortTransmitUnderrunErrs", "1.3.6.1.2.1.10.33.4.1.4", &_names[1212],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1211], &_types[1213], NULLOT, &_types[1213] },
    { "rs232SyncPortReceiveOverrunErrs", "1.3.6.1.2.1.10.33.4.1.5", &_names[1213],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1212], &_types[1209], NULLOT, &_types[1214] },
    { "rs232SyncPortInterruptedFrames", "1.3.6.1.2.1.10.33.4.1.6", &_names[1214],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1207], &_types[1215], NULLOT, &_types[1215] },
    { "rs232SyncPortAbortedFrames", "1.3.6.1.2.1.10.33.4.1.7", &_names[1215],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1214], NULLOT, NULLOT, &_types[1216] },
    { "rs232InSigTable", "1.3.6.1.2.1.10.33.5", &_names[1216],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1215], &_types[1222], &_types[1217], &_types[1217] },
    { "rs232InSigEntry", "1.3.6.1.2.1.10.33.5.1", &_names[1217],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rs232InSigPortIndex rs232InSigName", NULL, NULL,
      &_types[1208], NULLOT, &_types[1220], &_types[1218] },
    { "rs232InSigPortIndex", "1.3.6.1.2.1.10.33.5.1.1", &_names[1218],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1209], &_types[1221], NULLOT, &_types[1219] },
    { "rs232InSigName", "1.3.6.1.2.1.10.33.5.1.2", &_names[1219],
      (OS) 343, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1141], NULLOT, NULLOT, &_types[1220] },
    { "rs232InSigState", "1.3.6.1.2.1.10.33.5.1.3", &_names[1220],
      (OS) 344, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1203], &_types[1218], NULLOT, &_types[1221] },
    { "rs232InSigChanges", "1.3.6.1.2.1.10.33.5.1.4", &_names[1221],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1175], &_types[1219], NULLOT, &_types[1222] },
    { "rs232OutSigTable", "1.3.6.1.2.1.10.33.6", &_names[1222],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1216], NULLOT, &_types[1223], &_types[1223] },
    { "rs232OutSigEntry", "1.3.6.1.2.1.10.33.6.1", &_names[1223],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rs232OutSigPortIndex rs232OutSigName", NULL, NULL,
      &_types[1217], NULLOT, &_types[1226], &_types[1224] },
    { "rs232OutSigPortIndex", "1.3.6.1.2.1.10.33.6.1.1", &_names[1224],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1218], &_types[1227], NULLOT, &_types[1225] },
    { "rs232OutSigName", "1.3.6.1.2.1.10.33.6.1.2", &_names[1225],
      (OS) 345, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1219], NULLOT, NULLOT, &_types[1226] },
    { "rs232OutSigState", "1.3.6.1.2.1.10.33.6.1.3", &_names[1226],
      (OS) 346, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1220], &_types[1224], NULLOT, &_types[1227] },
    { "rs232OutSigChanges", "1.3.6.1.2.1.10.33.6.1.4", &_names[1227],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1221], &_types[1225], NULLOT, &_types[1228] },
    { "para", "1.3.6.1.2.1.10.34", &_names[1228],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1202], &_types[744], &_types[1230], &_types[1229] },
    { "paraNumber", "1.3.6.1.2.1.10.34.1", &_names[1229],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1194], NULLOT, NULLOT, &_types[1230] },
    { "paraPortTable", "1.3.6.1.2.1.10.34.2", &_names[1230],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1222], &_types[1236], &_types[1231], &_types[1231] },
    { "paraPortEntry", "1.3.6.1.2.1.10.34.2.1", &_names[1231],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "paraPortIndex", NULL, NULL,
      &_types[1223], NULLOT, &_types[1233], &_types[1232] },
    { "paraPortIndex", "1.3.6.1.2.1.10.34.2.1.1", &_names[1232],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1224], NULLOT, NULLOT, &_types[1233] },
    { "paraPortType", "1.3.6.1.2.1.10.34.2.1.2", &_names[1233],
      (OS) 347, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1231], &_types[1234], NULLOT, &_types[1234] },
    { "paraPortInSigNumber", "1.3.6.1.2.1.10.34.2.1.3", &_names[1234],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1229], &_types[1235], NULLOT, &_types[1235] },
    { "paraPortOutSigNumber", "1.3.6.1.2.1.10.34.2.1.4", &_names[1235],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1234], &_types[1232], NULLOT, &_types[1236] },
    { "paraInSigTable", "1.3.6.1.2.1.10.34.3", &_names[1236],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1230], &_types[1242], &_types[1237], &_types[1237] },
    { "paraInSigEntry", "1.3.6.1.2.1.10.34.3.1", &_names[1237],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "paraInSigPortIndex paraInSigName", NULL, NULL,
      &_types[1233], NULLOT, &_types[1240], &_types[1238] },
    { "paraInSigPortIndex", "1.3.6.1.2.1.10.34.3.1.1", &_names[1238],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1232], &_types[1241], NULLOT, &_types[1239] },
    { "paraInSigName", "1.3.6.1.2.1.10.34.3.1.2", &_names[1239],
      (OS) 348, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1225], NULLOT, NULLOT, &_types[1240] },
    { "paraInSigState", "1.3.6.1.2.1.10.34.3.1.3", &_names[1240],
      (OS) 349, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1226], &_types[1238], NULLOT, &_types[1241] },
    { "paraInSigChanges", "1.3.6.1.2.1.10.34.3.1.4", &_names[1241],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1227], &_types[1239], NULLOT, &_types[1242] },
    { "paraOutSigTable", "1.3.6.1.2.1.10.34.4", &_names[1242],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1236], &_types[1229], &_types[1243], &_types[1243] },
    { "paraOutSigEntry", "1.3.6.1.2.1.10.34.4.1", &_names[1243],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "paraOutSigPortIndex paraOutSigName", NULL, NULL,
      &_types[1237], NULLOT, &_types[1246], &_types[1244] },
    { "paraOutSigPortIndex", "1.3.6.1.2.1.10.34.4.1.1", &_names[1244],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1238], &_types[1247], NULLOT, &_types[1245] },
    { "paraOutSigName", "1.3.6.1.2.1.10.34.4.1.2", &_names[1245],
      (OS) 350, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1239], NULLOT, NULLOT, &_types[1246] },
    { "paraOutSigState", "1.3.6.1.2.1.10.34.4.1.3", &_names[1246],
      (OS) 351, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1240], &_types[1244], NULLOT, &_types[1247] },
    { "paraOutSigChanges", "1.3.6.1.2.1.10.34.4.1.4", &_names[1247],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1241], &_types[1245], NULLOT, &_types[1248] },
    { "miox", "1.3.6.1.2.1.10.38", &_names[1248],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[398], &_types[903], &_types[1268], &_types[1249] },
    { "mioxPle", "1.3.6.1.2.1.10.38.1", &_names[1249],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2419], NULLOT, &_types[1250], &_types[1250] },
    { "mioxPleTable", "1.3.6.1.2.1.10.38.1.1", &_names[1250],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1242], NULLOT, &_types[1251], &_types[1251] },
    { "mioxPleEntry", "1.3.6.1.2.1.10.38.1.1.1", &_names[1251],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifIndex", NULL, NULL,
      &_types[1243], NULLOT, &_types[1253], &_types[1252] },
    { "mioxPleMaxCircuits", "1.3.6.1.2.1.10.38.1.1.1.1", &_names[1252],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[511], &_types[1254], NULLOT, &_types[1253] },
    { "mioxPleRefusedConnections", "1.3.6.1.2.1.10.38.1.1.1.2", &_names[1253],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1015], &_types[1255], NULLOT, &_types[1254] },
    { "mioxPleEnAddrToX121LkupFlrs", "1.3.6.1.2.1.10.38.1.1.1.3", &_names[1254],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1252], &_types[1257], NULLOT, &_types[1255] },
    { "mioxPleLastFailedEnAddr", "1.3.6.1.2.1.10.38.1.1.1.4", &_names[1255],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 128,
      NULL, NULL, NULL,
      &_types[1228], &_types[1258], NULLOT, &_types[1256] },
    { "mioxPleEnAddrToX121LkupFlrTime", "1.3.6.1.2.1.10.38.1.1.1.5", &_names[1256],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1184], &_types[1259], NULLOT, &_types[1257] },
    { "mioxPleX121ToEnAddrLkupFlrs", "1.3.6.1.2.1.10.38.1.1.1.6", &_names[1257],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1254], NULLOT, NULLOT, &_types[1258] },
    { "mioxPleLastFailedX121Address", "1.3.6.1.2.1.10.38.1.1.1.7", &_names[1258],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[1255], &_types[1261], NULLOT, &_types[1259] },
    { "mioxPleX121ToEnAddrLkupFlrTime", "1.3.6.1.2.1.10.38.1.1.1.8", &_names[1259],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1256], &_types[1262], NULLOT, &_types[1260] },
    { "mioxPleQbitFailures", "1.3.6.1.2.1.10.38.1.1.1.9", &_names[1260],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[818], &_types[1267], NULLOT, &_types[1261] },
    { "mioxPleQbitFailureRemoteAddress", "1.3.6.1.2.1.10.38.1.1.1.10", &_names[1261],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[1258], &_types[1256], NULLOT, &_types[1262] },
    { "mioxPleQbitFailureTime", "1.3.6.1.2.1.10.38.1.1.1.11", &_names[1262],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1259], &_types[1263], NULLOT, &_types[1263] },
    { "mioxPleMinimumOpenTimer", "1.3.6.1.2.1.10.38.1.1.1.12", &_names[1263],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1262], &_types[1264], NULLOT, &_types[1264] },
    { "mioxPleInactivityTimer", "1.3.6.1.2.1.10.38.1.1.1.13", &_names[1264],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1263], &_types[1265], NULLOT, &_types[1265] },
    { "mioxPleHoldDownTimer", "1.3.6.1.2.1.10.38.1.1.1.14", &_names[1265],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1264], &_types[1266], NULLOT, &_types[1266] },
    { "mioxPleCollisionRetryTimer", "1.3.6.1.2.1.10.38.1.1.1.15", &_names[1266],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1265], &_types[1260], NULLOT, &_types[1267] },
    { "mioxPleDefaultPeerId", "1.3.6.1.2.1.10.38.1.1.1.16", &_names[1267],
      (OS) 21, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[994], &_types[1252], NULLOT, &_types[1268] },
    { "mioxPeer", "1.3.6.1.2.1.10.38.2", &_names[1268],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[903], &_types[1249], &_types[1269], &_types[1269] },
    { "mioxPeerTable", "1.3.6.1.2.1.10.38.2.1", &_names[1269],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1250], &_types[1281], &_types[1270], &_types[1270] },
    { "mioxPeerEntry", "1.3.6.1.2.1.10.38.2.1.1", &_names[1270],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "mioxPeerIndex", NULL, NULL,
      &_types[1251], NULLOT, &_types[1277], &_types[1271] },
    { "mioxPeerIndex", "1.3.6.1.2.1.10.38.2.1.1.1", &_names[1271],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1244], &_types[1274], NULLOT, &_types[1272] },
    { "mioxPeerStatus", "1.3.6.1.2.1.10.38.2.1.1.2", &_names[1272],
      (OS) 352, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1246], &_types[1271], NULLOT, &_types[1273] },
    { "mioxPeerMaxCircuits", "1.3.6.1.2.1.10.38.2.1.1.3", &_names[1273],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1257], NULLOT, NULLOT, &_types[1274] },
    { "mioxPeerIfIndex", "1.3.6.1.2.1.10.38.2.1.1.4", &_names[1274],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1271], &_types[1275], NULLOT, &_types[1275] },
    { "mioxPeerConnectSeconds", "1.3.6.1.2.1.10.38.2.1.1.5", &_names[1275],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[966], &_types[1276], NULLOT, &_types[1276] },
    { "mioxPeerX25CallParamId", "1.3.6.1.2.1.10.38.2.1.1.6", &_names[1276],
      (OS) 21, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1267], &_types[1279], NULLOT, &_types[1277] },
    { "mioxPeerEnAddr", "1.3.6.1.2.1.10.38.2.1.1.7", &_names[1277],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 128,
      NULL, NULL, NULL,
      &_types[1261], &_types[1278], NULLOT, &_types[1278] },
    { "mioxPeerX121Address", "1.3.6.1.2.1.10.38.2.1.1.8", &_names[1278],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 17,
      NULL, NULL, NULL,
      &_types[1277], &_types[1272], NULLOT, &_types[1279] },
    { "mioxPeerX25CircuitId", "1.3.6.1.2.1.10.38.2.1.1.9", &_names[1279],
      (OS) 21, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1276], &_types[1280], NULLOT, &_types[1280] },
    { "mioxPeerDescr", "1.3.6.1.2.1.10.38.2.1.1.10", &_names[1280],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[743], &_types[1273], NULLOT, &_types[1281] },
    { "mioxPeerEncTable", "1.3.6.1.2.1.10.38.2.2", &_names[1281],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1269], NULLOT, &_types[1282], &_types[1282] },
    { "mioxPeerEncEntry", "1.3.6.1.2.1.10.38.2.2.1", &_names[1282],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "mioxPeerIndex mioxPeerEncIndex", NULL, NULL,
      &_types[1270], NULLOT, &_types[1284], &_types[1283] },
    { "mioxPeerEncIndex", "1.3.6.1.2.1.10.38.2.2.1.1", &_names[1283],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[1274], NULLOT, NULLOT, &_types[1284] },
    { "mioxPeerEncType", "1.3.6.1.2.1.10.38.2.2.1.2", &_names[1284],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 256,
      NULL, NULL, NULL,
      &_types[1282], &_types[1283], NULLOT, &_types[1285] },
    { "snmp", "1.3.6.1.2.1.11", &_names[1285],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3150], &_types[2052], &_types[1295], &_types[1286] },
    { "snmpInPkts", "1.3.6.1.2.1.11.1", &_names[1286],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[130], &_types[1287], NULLOT, &_types[1287] },
    { "snmpOutPkts", "1.3.6.1.2.1.11.2", &_names[1287],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1286], NULLOT, NULLOT, &_types[1288] },
    { "snmpInBadVersions", "1.3.6.1.2.1.11.3", &_names[1288],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3124], &_types[1294], NULLOT, &_types[1289] },
    { "snmpInBadCommunityNames", "1.3.6.1.2.1.11.4", &_names[1289],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[11], &_types[1293], NULLOT, &_types[1290] },
    { "snmpInBadCommunityUses", "1.3.6.1.2.1.11.5", &_names[1290],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3014], &_types[1303], NULLOT, &_types[1291] },
    { "snmpInASNParseErrs", "1.3.6.1.2.1.11.6", &_names[1291],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[185], &_types[1296], NULLOT, &_types[1292] },
    { "snmpInTooBigs", "1.3.6.1.2.1.11.8", &_names[1292],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[179], &_types[1302], NULLOT, &_types[1293] },
    { "snmpInNoSuchNames", "1.3.6.1.2.1.11.9", &_names[1293],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1289], &_types[1305], NULLOT, &_types[1294] },
    { "snmpInBadValues", "1.3.6.1.2.1.11.10", &_names[1294],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[187], &_types[1300], NULLOT, &_types[1295] },
    { "snmpInReadOnlys", "1.3.6.1.2.1.11.11", &_names[1295],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[191], &_types[1290], NULLOT, &_types[1296] },
    { "snmpInGenErrs", "1.3.6.1.2.1.11.12", &_names[1296],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1291], &_types[1307], NULLOT, &_types[1297] },
    { "snmpInTotalReqVars", "1.3.6.1.2.1.11.13", &_names[1297],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3054], &_types[1298], NULLOT, &_types[1298] },
    { "snmpInTotalSetVars", "1.3.6.1.2.1.11.14", &_names[1298],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1297], &_types[1291], NULLOT, &_types[1299] },
    { "snmpInGetRequests", "1.3.6.1.2.1.11.15", &_names[1299],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[60], &_types[1301], NULLOT, &_types[1300] },
    { "snmpInGetNexts", "1.3.6.1.2.1.11.16", &_names[1300],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1294], &_types[1306], NULLOT, &_types[1301] },
    { "snmpInSetRequests", "1.3.6.1.2.1.11.17", &_names[1301],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1299], &_types[1308], NULLOT, &_types[1302] },
    { "snmpInGetResponses", "1.3.6.1.2.1.11.18", &_names[1302],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1292], &_types[1304], NULLOT, &_types[1303] },
    { "snmpInTraps", "1.3.6.1.2.1.11.19", &_names[1303],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[195], &_types[1312], NULLOT, &_types[1304] },
    { "snmpOutTooBigs", "1.3.6.1.2.1.11.20", &_names[1304],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1302], &_types[1311], NULLOT, &_types[1305] },
    { "snmpOutNoSuchNames", "1.3.6.1.2.1.11.21", &_names[1305],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1293], &_types[1286], NULLOT, &_types[1306] },
    { "snmpOutBadValues", "1.3.6.1.2.1.11.22", &_names[1306],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1300], &_types[1309], NULLOT, &_types[1307] },
    { "snmpOutGenErrs", "1.3.6.1.2.1.11.24", &_names[1307],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1296], &_types[1288], NULLOT, &_types[1308] },
    { "snmpOutGetRequests", "1.3.6.1.2.1.11.25", &_names[1308],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1301], &_types[1310], NULLOT, &_types[1309] },
    { "snmpOutGetNexts", "1.3.6.1.2.1.11.26", &_names[1309],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1306], &_types[1292], NULLOT, &_types[1310] },
    { "snmpOutSetRequests", "1.3.6.1.2.1.11.27", &_names[1310],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1308], &_types[1289], NULLOT, &_types[1311] },
    { "snmpOutGetResponses", "1.3.6.1.2.1.11.28", &_names[1311],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1304], &_types[1299], NULLOT, &_types[1312] },
    { "snmpOutTraps", "1.3.6.1.2.1.11.29", &_names[1312],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1303], &_types[1313], NULLOT, &_types[1313] },
    { "snmpEnableAuthenTraps", "1.3.6.1.2.1.11.30", &_names[1313],
      (OS) 50, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1312], &_types[1297], NULLOT, &_types[1314] },
    { "ifExtensions", "1.3.6.1.2.1.12", &_names[1314],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[107], &_types[1340], &_types[1315], &_types[1315] },
    { "ifExtnsTable", "1.3.6.1.2.1.12.1", &_names[1315],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[97], &_types[1325], &_types[1316], &_types[1316] },
    { "ifExtnsEntry", "1.3.6.1.2.1.12.1.1", &_names[1316],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifExtnsIfIndex", NULL, NULL,
      &_types[104], NULLOT, &_types[1319], &_types[1317] },
    { "ifExtnsIfIndex", "1.3.6.1.2.1.12.1.1.1", &_names[1317],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[106], &_types[1320], NULLOT, &_types[1318] },
    { "ifExtnsChipSet", "1.3.6.1.2.1.12.1.1.2", &_names[1318],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1338], &_types[1317], NULLOT, &_types[1319] },
    { "ifExtnsRevWare", "1.3.6.1.2.1.12.1.1.3", &_names[1319],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      NULLOT, &_types[1318], NULLOT, &_types[1320] },
    { "ifExtnsMulticastsTransmittedOks", "1.3.6.1.2.1.12.1.1.4", &_names[1320],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[167], &_types[1321], NULLOT, &_types[1321] },
    { "ifExtnsBroadcastsTransmittedOks", "1.3.6.1.2.1.12.1.1.5", &_names[1321],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1320], &_types[1322], NULLOT, &_types[1322] },
    { "ifExtnsMulticastsReceivedOks", "1.3.6.1.2.1.12.1.1.6", &_names[1322],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1321], &_types[1323], NULLOT, &_types[1323] },
    { "ifExtnsBroadcastsReceivedOks", "1.3.6.1.2.1.12.1.1.7", &_names[1323],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1322], &_types[1324], NULLOT, &_types[1324] },
    { "ifExtnsPromiscuous", "1.3.6.1.2.1.12.1.1.8", &_names[1324],
      (OS) 53, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[105], NULLOT, NULLOT, &_types[1325] },
    { "ifExtnsTestTable", "1.3.6.1.2.1.12.2", &_names[1325],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1315], &_types[1333], &_types[1326], &_types[1326] },
    { "ifExtnsTestEntry", "1.3.6.1.2.1.12.2.1", &_names[1326],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifExtnsTestIfIndex", NULL, NULL,
      &_types[1316], NULLOT, &_types[1330], &_types[1327] },
    { "ifExtnsTestIfIndex", "1.3.6.1.2.1.12.2.1.1", &_names[1327],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1317], &_types[1332], NULLOT, &_types[1328] },
    { "ifExtnsTestCommunity", "1.3.6.1.2.1.12.2.1.2", &_names[1328],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1314], &_types[1331], NULLOT, &_types[1329] },
    { "ifExtnsTestRequestId", "1.3.6.1.2.1.12.2.1.3", &_names[1329],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3105], NULLOT, NULLOT, &_types[1330] },
    { "ifExtnsTestType", "1.3.6.1.2.1.12.2.1.4", &_names[1330],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1326], &_types[1328], NULLOT, &_types[1331] },
    { "ifExtnsTestResult", "1.3.6.1.2.1.12.2.1.5", &_names[1331],
      (OS) 54, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1311], &_types[1327], NULLOT, &_types[1332] },
    { "ifExtnsTestCode", "1.3.6.1.2.1.12.2.1.6", &_names[1332],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[188], &_types[1329], NULLOT, &_types[1333] },
    { "ifExtnsRcvAddrTable", "1.3.6.1.2.1.12.3", &_names[1333],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1325], &_types[1338], &_types[1334], &_types[1334] },
    { "ifExtnsRcvAddrEntry", "1.3.6.1.2.1.12.3.1", &_names[1334],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifExtnsRcvAddrIfIndex ifExtnsRcvAddress", NULL, NULL,
      &_types[1330], NULLOT, &_types[1336], &_types[1335] },
    { "ifExtnsRcvAddrIfIndex", "1.3.6.1.2.1.12.3.1.1", &_names[1335],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1327], NULLOT, NULLOT, &_types[1336] },
    { "ifExtnsRcvAddress", "1.3.6.1.2.1.12.3.1.2", &_names[1336],
      (OS) 16, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1328], &_types[1337], NULLOT, &_types[1337] },
    { "ifExtnsRcvAddrStatus", "1.3.6.1.2.1.12.3.1.3", &_names[1337],
      (OS) 55, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1331], &_types[1335], NULLOT, &_types[1338] },
    { "wellKnownTests", "1.3.6.1.2.1.12.4", &_names[1338],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[192], NULLOT, &_types[1339], &_types[1339] },
    { "testFullDuplexLoopBack", "1.3.6.1.2.1.12.4.1", &_names[1339],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[1340] },
    { "appletalk", "1.3.6.1.2.1.13", &_names[1340],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1336], &_types[2614], &_types[1412], &_types[1341] },
    { "llap", "1.3.6.1.2.1.13.1", &_names[1341],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[1390], &_types[1342], &_types[1342] },
    { "llapTable", "1.3.6.1.2.1.13.1.1", &_names[1342],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1333], NULLOT, &_types[1343], &_types[1343] },
    { "llapEntry", "1.3.6.1.2.1.13.1.1.1", &_names[1343],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "llapIfIndex", NULL, NULL,
      &_types[1390], NULLOT, &_types[1348], &_types[1344] },
    { "llapIfIndex", "1.3.6.1.2.1.13.1.1.1.1", &_names[1344],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1335], &_types[1345], NULLOT, &_types[1345] },
    { "llapInPkts", "1.3.6.1.2.1.13.1.1.1.2", &_names[1345],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1287], &_types[1346], NULLOT, &_types[1346] },
    { "llapOutPkts", "1.3.6.1.2.1.13.1.1.1.3", &_names[1346],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1345], &_types[1347], NULLOT, &_types[1347] },
    { "llapInNoHandlers", "1.3.6.1.2.1.13.1.1.1.4", &_names[1347],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1342], NULLOT, NULLOT, &_types[1348] },
    { "llapInLengthErrors", "1.3.6.1.2.1.13.1.1.1.5", &_names[1348],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1307], &_types[1349], NULLOT, &_types[1349] },
    { "llapInErrors", "1.3.6.1.2.1.13.1.1.1.6", &_names[1349],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1348], &_types[1351], NULLOT, &_types[1350] },
    { "llapCollisions", "1.3.6.1.2.1.13.1.1.1.7", &_names[1350],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1337], &_types[1344], NULLOT, &_types[1351] },
    { "llapDefers", "1.3.6.1.2.1.13.1.1.1.8", &_names[1351],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1349], &_types[1352], NULLOT, &_types[1352] },
    { "llapNoDataErrors", "1.3.6.1.2.1.13.1.1.1.9", &_names[1352],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1351], &_types[1353], NULLOT, &_types[1353] },
    { "llapRandomCTSErrors", "1.3.6.1.2.1.13.1.1.1.10", &_names[1353],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1352], &_types[1354], NULLOT, &_types[1354] },
    { "llapFCSErrors", "1.3.6.1.2.1.13.1.1.1.11", &_names[1354],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1353], &_types[1350], NULLOT, &_types[1355] },
    { "aarp", "1.3.6.1.2.1.13.2", &_names[1355],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[143], &_types[1400], &_types[1356], &_types[1356] },
    { "aarpTable", "1.3.6.1.2.1.13.2.1", &_names[1356],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1347], NULLOT, &_types[1357], &_types[1357] },
    { "aarpEntry", "1.3.6.1.2.1.13.2.1.1", &_names[1357],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "aarpIfIndex aarpNetAddress", NULL, NULL,
      &_types[1343], NULLOT, &_types[1359], &_types[1358] },
    { "aarpIfIndex", "1.3.6.1.2.1.13.2.1.1.1", &_names[1358],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1344], NULLOT, NULLOT, &_types[1359] },
    { "aarpPhysAddress", "1.3.6.1.2.1.13.2.1.1.2", &_names[1359],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1412], &_types[1360], NULLOT, &_types[1360] },
    { "aarpNetAddress", "1.3.6.1.2.1.13.2.1.1.3", &_names[1360],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 3, 3,
      NULL, NULL, NULL,
      &_types[1359], &_types[1358], NULLOT, &_types[1361] },
    { "atport", "1.3.6.1.2.1.13.3", &_names[1361],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[140], &_types[1420], &_types[1362], &_types[1362] },
    { "atportTable", "1.3.6.1.2.1.13.3.1", &_names[1362],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1356], NULLOT, &_types[1363], &_types[1363] },
    { "atportEntry", "1.3.6.1.2.1.13.3.1.1", &_names[1363],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "atportIndex", NULL, NULL,
      &_types[1357], NULLOT, &_types[1366], &_types[1364] },
    { "atportIndex", "1.3.6.1.2.1.13.3.1.1.1", &_names[1364],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1358], &_types[1374], NULLOT, &_types[1365] },
    { "atportDescr", "1.3.6.1.2.1.13.3.1.1.2", &_names[1365],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[99], NULLOT, NULLOT, &_types[1366] },
    { "atportType", "1.3.6.1.2.1.13.3.1.1.3", &_names[1366],
      (OS) 56, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1363], &_types[1371], NULLOT, &_types[1367] },
    { "atportNetStart", "1.3.6.1.2.1.13.3.1.1.4", &_names[1367],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1350], &_types[1370], NULLOT, &_types[1368] },
    { "atportNetEnd", "1.3.6.1.2.1.13.3.1.1.5", &_names[1368],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      NULLOT, &_types[1373], NULLOT, &_types[1369] },
    { "atportNetAddress", "1.3.6.1.2.1.13.3.1.1.6", &_names[1369],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 3, 3,
      NULL, NULL, NULL,
      &_types[1360], &_types[1367], NULLOT, &_types[1370] },
    { "atportStatus", "1.3.6.1.2.1.13.3.1.1.7", &_names[1370],
      (OS) 57, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1367], &_types[1364], NULLOT, &_types[1371] },
    { "atportNetConfig", "1.3.6.1.2.1.13.3.1.1.8", &_names[1371],
      (OS) 58, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1318], &_types[1372], NULLOT, &_types[1372] },
    { "atportZoneConfig", "1.3.6.1.2.1.13.3.1.1.9", &_names[1372],
      (OS) 59, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1371], &_types[1369], NULLOT, &_types[1373] },
    { "atportZone", "1.3.6.1.2.1.13.3.1.1.10", &_names[1373],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1346], &_types[1365], NULLOT, &_types[1374] },
    { "atportIfIndex", "1.3.6.1.2.1.13.3.1.1.11", &_names[1374],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1364], &_types[1368], NULLOT, &_types[1375] },
    { "ddp", "1.3.6.1.2.1.13.4", &_names[1375],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[131], &_types[1341], &_types[1379], &_types[1376] },
    { "ddpOutRequests", "1.3.6.1.2.1.13.4.1", &_names[1376],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1310], &_types[1380], NULLOT, &_types[1377] },
    { "ddpOutShorts", "1.3.6.1.2.1.13.4.2", &_names[1377],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1305], &_types[1383], NULLOT, &_types[1378] },
    { "ddpOutLongs", "1.3.6.1.2.1.13.4.3", &_names[1378],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1366], &_types[1384], NULLOT, &_types[1379] },
    { "ddpInReceives", "1.3.6.1.2.1.13.4.4", &_names[1379],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1375], &_types[1378], NULLOT, &_types[1380] },
    { "ddpForwRequests", "1.3.6.1.2.1.13.4.5", &_names[1380],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1376], &_types[1377], NULLOT, &_types[1381] },
    { "ddpInLocalDatagrams", "1.3.6.1.2.1.13.4.6", &_names[1381],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1323], &_types[1382], NULLOT, &_types[1382] },
    { "ddpNoProtocolHandlers", "1.3.6.1.2.1.13.4.7", &_names[1382],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1362], NULLOT, NULLOT, &_types[1383] },
    { "ddpOutNoRoutes", "1.3.6.1.2.1.13.4.8", &_names[1383],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1332], &_types[1381], NULLOT, &_types[1384] },
    { "ddpTooShortErrors", "1.3.6.1.2.1.13.4.9", &_names[1384],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1354], &_types[1385], NULLOT, &_types[1385] },
    { "ddpTooLongErrors", "1.3.6.1.2.1.13.4.10", &_names[1385],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1384], &_types[1386], NULLOT, &_types[1386] },
    { "ddpBroadcastErrors", "1.3.6.1.2.1.13.4.11", &_names[1386],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1385], &_types[1387], NULLOT, &_types[1387] },
    { "ddpShortDDPErrors", "1.3.6.1.2.1.13.4.12", &_names[1387],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1386], &_types[1388], NULLOT, &_types[1388] },
    { "ddpHopCountErrors", "1.3.6.1.2.1.13.4.13", &_names[1388],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1387], &_types[1389], NULLOT, &_types[1389] },
    { "ddpChecksumErrors", "1.3.6.1.2.1.13.4.14", &_names[1389],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1388], &_types[1376], NULLOT, &_types[1390] },
    { "rtmp", "1.3.6.1.2.1.13.5", &_names[1390],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1334], NULLOT, &_types[1391], &_types[1391] },
    { "rtmpTable", "1.3.6.1.2.1.13.5.1", &_names[1391],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1382], NULLOT, &_types[1392], &_types[1392] },
    { "rtmpEntry", "1.3.6.1.2.1.13.5.1.1", &_names[1392],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rtmpRangeStart", NULL, NULL,
      &_types[1378], NULLOT, &_types[1396], &_types[1393] },
    { "rtmpRangeStart", "1.3.6.1.2.1.13.5.1.1.1", &_names[1393],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1370], &_types[1399], NULLOT, &_types[1394] },
    { "rtmpRangeEnd", "1.3.6.1.2.1.13.5.1.1.2", &_names[1394],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1368], &_types[1397], NULLOT, &_types[1395] },
    { "rtmpNextHop", "1.3.6.1.2.1.13.5.1.1.3", &_names[1395],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[102], &_types[1398], NULLOT, &_types[1396] },
    { "rtmpType", "1.3.6.1.2.1.13.5.1.1.4", &_names[1396],
      (OS) 60, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1392], &_types[1395], NULLOT, &_types[1397] },
    { "rtmpPort", "1.3.6.1.2.1.13.5.1.1.5", &_names[1397],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[171], NULLOT, NULLOT, &_types[1398] },
    { "rtmpHops", "1.3.6.1.2.1.13.5.1.1.6", &_names[1398],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1395], &_types[1393], NULLOT, &_types[1399] },
    { "rtmpState", "1.3.6.1.2.1.13.5.1.1.7", &_names[1399],
      (OS) 61, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1393], &_types[1394], NULLOT, &_types[1400] },
    { "kip", "1.3.6.1.2.1.13.6", &_names[1400],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1355], &_types[1428], &_types[1401], &_types[1401] },
    { "kipTable", "1.3.6.1.2.1.13.6.1", &_names[1401],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1391], NULLOT, &_types[1402], &_types[1402] },
    { "kipEntry", "1.3.6.1.2.1.13.6.1.1", &_names[1402],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "kipNetStart", NULL, NULL,
      &_types[1396], NULLOT, &_types[1409], &_types[1403] },
    { "kipNetStart", "1.3.6.1.2.1.13.6.1.1.1", &_names[1403],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1399], &_types[1410], NULLOT, &_types[1404] },
    { "kipNetEnd", "1.3.6.1.2.1.13.6.1.1.2", &_names[1404],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1394], &_types[1411], NULLOT, &_types[1405] },
    { "kipNextHop", "1.3.6.1.2.1.13.6.1.1.3", &_names[1405],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1398], &_types[1406], NULLOT, &_types[1406] },
    { "kipHopCount", "1.3.6.1.2.1.13.6.1.1.4", &_names[1406],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1405], &_types[1408], NULLOT, &_types[1407] },
    { "kipBCastAddr", "1.3.6.1.2.1.13.6.1.1.5", &_names[1407],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1369], &_types[1403], NULLOT, &_types[1408] },
    { "kipCore", "1.3.6.1.2.1.13.6.1.1.6", &_names[1408],
      (OS) 62, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[96], &_types[1407], NULLOT, &_types[1409] },
    { "kipType", "1.3.6.1.2.1.13.6.1.1.7", &_names[1409],
      (OS) 63, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1402], &_types[1405], NULLOT, &_types[1410] },
    { "kipState", "1.3.6.1.2.1.13.6.1.1.8", &_names[1410],
      (OS) 64, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1403], &_types[1404], NULLOT, &_types[1411] },
    { "kipShare", "1.3.6.1.2.1.13.6.1.1.9", &_names[1411],
      (OS) 65, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[1412] },
    { "zip", "1.3.6.1.2.1.13.7", &_names[1412],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1340], &_types[1361], &_types[1413], &_types[1413] },
    { "zipTable", "1.3.6.1.2.1.13.7.1", &_names[1413],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1401], NULLOT, &_types[1414], &_types[1414] },
    { "zipEntry", "1.3.6.1.2.1.13.7.1.1", &_names[1414],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "zipZoneNetStart zipZoneIndex", NULL, NULL,
      &_types[1409], NULLOT, &_types[1417], &_types[1415] },
    { "zipZoneName", "1.3.6.1.2.1.13.7.1.1.1", &_names[1415],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1377], NULLOT, NULLOT, &_types[1416] },
    { "zipZoneIndex", "1.3.6.1.2.1.13.7.1.1.2", &_names[1416],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1374], &_types[1418], NULLOT, &_types[1417] },
    { "zipZoneNetStart", "1.3.6.1.2.1.13.7.1.1.3", &_names[1417],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1410], &_types[1419], NULLOT, &_types[1418] },
    { "zipZoneNetEnd", "1.3.6.1.2.1.13.7.1.1.4", &_names[1418],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1404], &_types[1415], NULLOT, &_types[1419] },
    { "zipZoneState", "1.3.6.1.2.1.13.7.1.1.5", &_names[1419],
      (OS) 66, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1417], &_types[1416], NULLOT, &_types[1420] },
    { "nbp", "1.3.6.1.2.1.13.8", &_names[1420],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[113], &_types[1355], &_types[1421], &_types[1421] },
    { "nbpTable", "1.3.6.1.2.1.13.8.1", &_names[1421],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1413], NULLOT, &_types[1422], &_types[1422] },
    { "nbpEntry", "1.3.6.1.2.1.13.8.1.1", &_names[1422],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "nbpIndex", NULL, NULL,
      &_types[1414], NULLOT, &_types[1425], &_types[1423] },
    { "nbpIndex", "1.3.6.1.2.1.13.8.1.1.1", &_names[1423],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1416], &_types[1426], NULLOT, &_types[1424] },
    { "nbpObject", "1.3.6.1.2.1.13.8.1.1.2", &_names[1424],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1381], NULLOT, NULLOT, &_types[1425] },
    { "nbpType", "1.3.6.1.2.1.13.8.1.1.3", &_names[1425],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1422], &_types[1427], NULLOT, &_types[1426] },
    { "nbpZone", "1.3.6.1.2.1.13.8.1.1.4", &_names[1426],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1373], &_types[1424], NULLOT, &_types[1427] },
    { "nbpState", "1.3.6.1.2.1.13.8.1.1.5", &_names[1427],
      (OS) 67, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1419], &_types[1423], NULLOT, &_types[1428] },
    { "atecho", "1.3.6.1.2.1.13.9", &_names[1428],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1400], &_types[1375], &_types[1429], &_types[1429] },
    { "atechoRequests", "1.3.6.1.2.1.13.9.1", &_names[1429],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1380], &_types[1430], NULLOT, &_types[1430] },
    { "atechoReplies", "1.3.6.1.2.1.13.9.2", &_names[1430],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1361], NULLOT, NULLOT, &_types[1431] },
    { "ospf", "1.3.6.1.2.1.14", &_names[1431],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[189], &_types[2432], &_types[1432], &_types[1432] },
    { "ospfGeneralGroup", "1.3.6.1.2.1.14.1", &_names[1432],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[147], &_types[1443], &_types[1434], &_types[1433] },
    { "ospfRouterId", "1.3.6.1.2.1.14.1.1", &_names[1433],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1329], &_types[1440], NULLOT, &_types[1434] },
    { "ospfAdminStat", "1.3.6.1.2.1.14.1.2", &_names[1434],
      (OS) 68, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1427], &_types[1436], NULLOT, &_types[1435] },
    { "ospfVersionNumber", "1.3.6.1.2.1.14.1.3", &_names[1435],
      (OS) 69, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1408], NULLOT, NULLOT, &_types[1436] },
    { "ospfAreaBdrRtrStatus", "1.3.6.1.2.1.14.1.4", &_names[1436],
      (OS) 70, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1434], &_types[1437], NULLOT, &_types[1437] },
    { "ospfASBdrRtrStatus", "1.3.6.1.2.1.14.1.5", &_names[1437],
      (OS) 71, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1436], &_types[1441], NULLOT, &_types[1438] },
    { "ospfExternLSACount", "1.3.6.1.2.1.14.1.6", &_names[1438],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1406], &_types[1435], NULLOT, &_types[1439] },
    { "ospfExternLSACksumSum", "1.3.6.1.2.1.14.1.7", &_names[1439],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1425], &_types[1438], NULLOT, &_types[1440] },
    { "ospfTOSSupport", "1.3.6.1.2.1.14.1.8", &_names[1440],
      (OS) 72, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[94], &_types[1439], NULLOT, &_types[1441] },
    { "ospfOriginateNewLSAs", "1.3.6.1.2.1.14.1.9", &_names[1441],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[194], &_types[1442], NULLOT, &_types[1442] },
    { "ospfRxNewLSAs", "1.3.6.1.2.1.14.1.10", &_names[1442],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1441], &_types[1433], NULLOT, &_types[1443] },
    { "ospfAreaTable", "1.3.6.1.2.1.14.2", &_names[1443],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1421], &_types[1453], &_types[1444], &_types[1444] },
    { "ospfAreaEntry", "1.3.6.1.2.1.14.2.1", &_names[1444],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfAreaId", NULL, NULL,
      &_types[1439], NULLOT, &_types[1446], &_types[1445] },
    { "ospfAreaId", "1.3.6.1.2.1.14.2.1.1", &_names[1445],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1433], NULLOT, NULLOT, &_types[1446] },
    { "ospfAuthType", "1.3.6.1.2.1.14.2.1.2", &_names[1446],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1444], &_types[1448], NULLOT, &_types[1447] },
    { "ospfImportASExtern", "1.3.6.1.2.1.14.2.1.3", &_names[1447],
      (OS) 73, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1407], &_types[1445], NULLOT, &_types[1448] },
    { "ospfSpfRuns", "1.3.6.1.2.1.14.2.1.4", &_names[1448],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1446], &_types[1452], NULLOT, &_types[1449] },
    { "ospfAreaBdrRtrCount", "1.3.6.1.2.1.14.2.1.5", &_names[1449],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1438], &_types[1450], NULLOT, &_types[1450] },
    { "ospfASBdrRtrCount", "1.3.6.1.2.1.14.2.1.6", &_names[1450],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1449], &_types[1451], NULLOT, &_types[1451] },
    { "ospfAreaLSACount", "1.3.6.1.2.1.14.2.1.7", &_names[1451],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1450], &_types[1447], NULLOT, &_types[1452] },
    { "ospfAreaLSACksumSum", "1.3.6.1.2.1.14.2.1.8", &_names[1452],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1448], &_types[1449], NULLOT, &_types[1453] },
    { "ospfStubAreaTable", "1.3.6.1.2.1.14.3", &_names[1453],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1443], &_types[1459], &_types[1454], &_types[1454] },
    { "ospfStubAreaEntry", "1.3.6.1.2.1.14.3.1", &_names[1454],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfStubAreaID ospfStubTOS", NULL, NULL,
      &_types[1452], NULLOT, &_types[1455], &_types[1455] },
    { "ospfStubAreaID", "1.3.6.1.2.1.14.3.1.1", &_names[1455],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1432], &_types[1458], NULLOT, &_types[1456] },
    { "ospfStubTOS", "1.3.6.1.2.1.14.3.1.2", &_names[1456],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 31,
      NULL, NULL, NULL,
      &_types[108], NULLOT, NULLOT, &_types[1457] },
    { "ospfStubMetric", "1.3.6.1.2.1.14.3.1.3", &_names[1457],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 16777215,
      NULL, NULL, NULL,
      &_types[1420], &_types[1456], NULLOT, &_types[1458] },
    { "ospfStubStatus", "1.3.6.1.2.1.14.3.1.4", &_names[1458],
      (OS) 74, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1437], &_types[1457], NULLOT, &_types[1459] },
    { "ospfLsdbTable", "1.3.6.1.2.1.14.4", &_names[1459],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1453], &_types[1469], &_types[1460], &_types[1460] },
    { "ospfLsdbEntry", "1.3.6.1.2.1.14.4.1", &_names[1460],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfLsdbAreaId ospfLsdbType ospfLsdbLSID ospfLsdbRouterId", NULL, NULL,
      &_types[1454], NULLOT, &_types[1462], &_types[1461] },
    { "ospfLsdbAreaId", "1.3.6.1.2.1.14.4.1.1", &_names[1461],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1445], &_types[1464], NULLOT, &_types[1462] },
    { "ospfLsdbType", "1.3.6.1.2.1.14.4.1.2", &_names[1462],
      (OS) 75, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1460], &_types[1463], NULLOT, &_types[1463] },
    { "ospfLsdbLSID", "1.3.6.1.2.1.14.4.1.3", &_names[1463],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1455], &_types[1467], NULLOT, &_types[1464] },
    { "ospfLsdbRouterId", "1.3.6.1.2.1.14.4.1.4", &_names[1464],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1461], &_types[1468], NULLOT, &_types[1465] },
    { "ospfLsdbSequence", "1.3.6.1.2.1.14.4.1.5", &_names[1465],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1423], &_types[1466], NULLOT, &_types[1466] },
    { "ospfLsdbAge", "1.3.6.1.2.1.14.4.1.6", &_names[1466],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1465], &_types[1461], NULLOT, &_types[1467] },
    { "ospfLsdbChecksum", "1.3.6.1.2.1.14.4.1.7", &_names[1467],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1458], &_types[1465], NULLOT, &_types[1468] },
    { "ospfLsdbAdvertisement", "1.3.6.1.2.1.14.4.1.8", &_names[1468],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1456], NULLOT, NULLOT, &_types[1469] },
    { "ospfAreaRangeTable", "1.3.6.1.2.1.14.5", &_names[1469],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1459], &_types[1475], &_types[1470], &_types[1470] },
    { "ospfAreaRangeEntry", "1.3.6.1.2.1.14.5.1", &_names[1470],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfAreaRangeAreaID ospfAreaRangeNet", NULL, NULL,
      &_types[1462], NULLOT, &_types[1471], &_types[1471] },
    { "ospfAreaRangeAreaID", "1.3.6.1.2.1.14.5.1.1", &_names[1471],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1463], &_types[1474], NULLOT, &_types[1472] },
    { "ospfAreaRangeNet", "1.3.6.1.2.1.14.5.1.2", &_names[1472],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1430], NULLOT, NULLOT, &_types[1473] },
    { "ospfAreaRangeMask", "1.3.6.1.2.1.14.5.1.3", &_names[1473],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1466], &_types[1472], NULLOT, &_types[1474] },
    { "ospfAreaRangeStatus", "1.3.6.1.2.1.14.5.1.4", &_names[1474],
      (OS) 76, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1467], &_types[1473], NULLOT, &_types[1475] },
    { "ospfHostTable", "1.3.6.1.2.1.14.6", &_names[1475],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1469], &_types[1481], &_types[1476], &_types[1476] },
    { "ospfHostEntry", "1.3.6.1.2.1.14.6.1", &_names[1476],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfHostIpAddress ospfHostTOS", NULL, NULL,
      &_types[1470], NULLOT, &_types[1477], &_types[1477] },
    { "ospfHostIpAddress", "1.3.6.1.2.1.14.6.1.1", &_names[1477],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1447], &_types[1480], NULLOT, &_types[1478] },
    { "ospfHostTOS", "1.3.6.1.2.1.14.6.1.2", &_names[1478],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 31,
      NULL, NULL, NULL,
      &_types[1468], NULLOT, NULLOT, &_types[1479] },
    { "ospfHostMetric", "1.3.6.1.2.1.14.6.1.3", &_names[1479],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1457], &_types[1478], NULLOT, &_types[1480] },
    { "ospfHostStatus", "1.3.6.1.2.1.14.6.1.4", &_names[1480],
      (OS) 77, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1474], &_types[1479], NULLOT, &_types[1481] },
    { "ospfIfTable", "1.3.6.1.2.1.14.7", &_names[1481],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1475], &_types[1499], &_types[1482], &_types[1482] },
    { "ospfIfEntry", "1.3.6.1.2.1.14.7.1", &_names[1482],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfIfIpAddress ospfAddressLessIf", NULL, NULL,
      &_types[1476], NULLOT, &_types[1486], &_types[1483] },
    { "ospfIfIpAddress", "1.3.6.1.2.1.14.7.1.1", &_names[1483],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1477], &_types[1487], NULLOT, &_types[1484] },
    { "ospfAddressLessIf", "1.3.6.1.2.1.14.7.1.2", &_names[1484],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[1490], NULLOT, &_types[1485] },
    { "ospfIfAreaId", "1.3.6.1.2.1.14.7.1.3", &_names[1485],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1464], &_types[1484], NULLOT, &_types[1486] },
    { "ospfIfType", "1.3.6.1.2.1.14.7.1.4", &_names[1486],
      (OS) 78, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1482], &_types[1489], NULLOT, &_types[1487] },
    { "ospfIfAdminStat", "1.3.6.1.2.1.14.7.1.5", &_names[1487],
      (OS) 79, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1480], &_types[1494], NULLOT, &_types[1488] },
    { "ospfIfRtrPriority", "1.3.6.1.2.1.14.7.1.6", &_names[1488],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1298], &_types[1483], NULLOT, &_types[1489] },
    { "ospfIfTransitDelay", "1.3.6.1.2.1.14.7.1.7", &_names[1489],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 3600,
      NULL, NULL, NULL,
      &_types[1486], &_types[1488], NULLOT, &_types[1490] },
    { "ospfIfRetransInterval", "1.3.6.1.2.1.14.7.1.8", &_names[1490],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 3600,
      NULL, NULL, NULL,
      &_types[14], &_types[1491], NULLOT, &_types[1491] },
    { "ospfIfHelloInterval", "1.3.6.1.2.1.14.7.1.9", &_names[1491],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1490], &_types[1492], NULLOT, &_types[1492] },
    { "ospfIfRtrDeadInterval", "1.3.6.1.2.1.14.7.1.10", &_names[1492],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1491], &_types[1493], NULLOT, &_types[1493] },
    { "ospfIfPollInterval", "1.3.6.1.2.1.14.7.1.11", &_names[1493],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1492], NULLOT, NULLOT, &_types[1494] },
    { "ospfIfState", "1.3.6.1.2.1.14.7.1.12", &_names[1494],
      (OS) 80, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1487], &_types[1498], NULLOT, &_types[1495] },
    { "ospfIfDesignatedRouter", "1.3.6.1.2.1.14.7.1.13", &_names[1495],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1383], &_types[1496], NULLOT, &_types[1496] },
    { "ospfIfBackupDesignatedRouter", "1.3.6.1.2.1.14.7.1.14", &_names[1496],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1495], &_types[1497], NULLOT, &_types[1497] },
    { "ospfIfEvents", "1.3.6.1.2.1.14.7.1.15", &_names[1497],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3076], &_types[1485], NULLOT, &_types[1498] },
    { "ospfIfAuthKey", "1.3.6.1.2.1.14.7.1.16", &_names[1498],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1473], &_types[1495], NULLOT, &_types[1499] },
    { "ospfIfMetricTable", "1.3.6.1.2.1.14.8", &_names[1499],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1481], &_types[1506], &_types[1500], &_types[1500] },
    { "ospfIfMetricEntry", "1.3.6.1.2.1.14.8.1", &_names[1500],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfIfMetricIpAddress ospfIfMetricAddressLessIf ospfIfMetricTOS", NULL, NULL,
      &_types[1489], NULLOT, &_types[1501], &_types[1501] },
    { "ospfIfMetricIpAddress", "1.3.6.1.2.1.14.8.1.1", &_names[1501],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1483], &_types[1505], NULLOT, &_types[1502] },
    { "ospfIfMetricAddressLessIf", "1.3.6.1.2.1.14.8.1.2", &_names[1502],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1484], &_types[1503], NULLOT, &_types[1503] },
    { "ospfIfMetricTOS", "1.3.6.1.2.1.14.8.1.3", &_names[1503],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 31,
      NULL, NULL, NULL,
      &_types[1478], NULLOT, NULLOT, &_types[1504] },
    { "ospfIfMetricMetric", "1.3.6.1.2.1.14.8.1.4", &_names[1504],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1479], &_types[1502], NULLOT, &_types[1505] },
    { "ospfIfMetricStatus", "1.3.6.1.2.1.14.8.1.5", &_names[1505],
      (OS) 81, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1494], &_types[1504], NULLOT, &_types[1506] },
    { "ospfVirtIfTable", "1.3.6.1.2.1.14.9", &_names[1506],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1499], &_types[1518], &_types[1507], &_types[1507] },
    { "ospfVirtIfEntry", "1.3.6.1.2.1.14.9.1", &_names[1507],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfVirtIfAreaID ospfVirtIfNeighbor", NULL, NULL,
      &_types[1500], NULLOT, &_types[1510], &_types[1508] },
    { "ospfVirtIfAreaID", "1.3.6.1.2.1.14.9.1.1", &_names[1508],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1471], &_types[1514], NULLOT, &_types[1509] },
    { "ospfVirtIfNeighbor", "1.3.6.1.2.1.14.9.1.2", &_names[1509],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1428], &_types[1511], NULLOT, &_types[1510] },
    { "ospfVirtIfTransitDelay", "1.3.6.1.2.1.14.9.1.3", &_names[1510],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 3600,
      NULL, NULL, NULL,
      &_types[1507], &_types[1508], NULLOT, &_types[1511] },
    { "ospfVirtIfRetransInterval", "1.3.6.1.2.1.14.9.1.4", &_names[1511],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 3600,
      NULL, NULL, NULL,
      &_types[1493], &_types[1512], NULLOT, &_types[1512] },
    { "ospfVirtIfHelloInterval", "1.3.6.1.2.1.14.9.1.5", &_names[1512],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1511], &_types[1513], NULLOT, &_types[1513] },
    { "ospfVirtIfRtrDeadInterval", "1.3.6.1.2.1.14.9.1.6", &_names[1513],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1512], NULLOT, NULLOT, &_types[1514] },
    { "ospfVirtIfState", "1.3.6.1.2.1.14.9.1.7", &_names[1514],
      (OS) 82, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1505], &_types[1517], NULLOT, &_types[1515] },
    { "ospfVirtIfEvents", "1.3.6.1.2.1.14.9.1.8", &_names[1515],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1497], &_types[1509], NULLOT, &_types[1516] },
    { "ospfVirtIfAuthKey", "1.3.6.1.2.1.14.9.1.9", &_names[1516],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1498], &_types[1515], NULLOT, &_types[1517] },
    { "ospfVirtIfStatus", "1.3.6.1.2.1.14.9.1.10", &_names[1517],
      (OS) 83, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1514], &_types[1516], NULLOT, &_types[1518] },
    { "ospfNbrTable", "1.3.6.1.2.1.14.10", &_names[1518],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1506], &_types[1529], &_types[1519], &_types[1519] },
    { "ospfNbrEntry", "1.3.6.1.2.1.14.10.1", &_names[1519],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfNbrIpAddr ospfNbrAddressLessIndex", NULL, NULL,
      &_types[1510], NULLOT, &_types[1524], &_types[1520] },
    { "ospfNbrIpAddr", "1.3.6.1.2.1.14.10.1.1", &_names[1520],
      (OS) 6, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1501], &_types[1525], NULLOT, &_types[1521] },
    { "ospfNbrAddressLessIndex", "1.3.6.1.2.1.14.10.1.2", &_names[1521],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1516], &_types[1527], NULLOT, &_types[1522] },
    { "ospfNbrRtrId", "1.3.6.1.2.1.14.10.1.3", &_names[1522],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1485], &_types[1523], NULLOT, &_types[1523] },
    { "ospfNbrOptions", "1.3.6.1.2.1.14.10.1.4", &_names[1523],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1503], NULLOT, NULLOT, &_types[1524] },
    { "ospfNbrPriority", "1.3.6.1.2.1.14.10.1.5", &_names[1524],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1488], &_types[1520], NULLOT, &_types[1525] },
    { "ospfNbrState", "1.3.6.1.2.1.14.10.1.6", &_names[1525],
      (OS) 84, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1517], &_types[1528], NULLOT, &_types[1526] },
    { "ospfNbrEvents", "1.3.6.1.2.1.14.10.1.7", &_names[1526],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1515], &_types[1522], NULLOT, &_types[1527] },
    { "ospfNbrLSRetransQLen", "1.3.6.1.2.1.14.10.1.8", &_names[1527],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1518], &_types[1526], NULLOT, &_types[1528] },
    { "ospfNBMANbrStatus", "1.3.6.1.2.1.14.10.1.9", &_names[1528],
      (OS) 85, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1525], &_types[1521], NULLOT, &_types[1529] },
    { "ospfVirtNbrTable", "1.3.6.1.2.1.14.11", &_names[1529],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1527], NULLOT, &_types[1530], &_types[1530] },
    { "ospfVirtNbrEntry", "1.3.6.1.2.1.14.11.1", &_names[1530],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ospfVirtNbrArea ospfVirtNbrRtrId", NULL, NULL,
      &_types[1519], NULLOT, &_types[1533], &_types[1531] },
    { "ospfVirtNbrArea", "1.3.6.1.2.1.14.11.1.1", &_names[1531],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1526], &_types[1536], NULLOT, &_types[1532] },
    { "ospfVirtNbrRtrId", "1.3.6.1.2.1.14.11.1.2", &_names[1532],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1522], &_types[1534], NULLOT, &_types[1533] },
    { "ospfVirtNbrIpAddr", "1.3.6.1.2.1.14.11.1.3", &_names[1533],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1520], &_types[1535], NULLOT, &_types[1534] },
    { "ospfVirtNbrOptions", "1.3.6.1.2.1.14.11.1.4", &_names[1534],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1523], NULLOT, NULLOT, &_types[1535] },
    { "ospfVirtNbrState", "1.3.6.1.2.1.14.11.1.5", &_names[1535],
      (OS) 86, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1528], &_types[1537], NULLOT, &_types[1536] },
    { "ospfVirtNbrEvents", "1.3.6.1.2.1.14.11.1.6", &_names[1536],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1531], &_types[1532], NULLOT, &_types[1537] },
    { "ospfVirtNbrLSRetransQLen", "1.3.6.1.2.1.14.11.1.7", &_names[1537],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1529], &_types[1531], NULLOT, &_types[1538] },
    { "bgp", "1.3.6.1.2.1.15", &_names[1538],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1530], &_types[2697], &_types[1539], &_types[1539] },
    { "bgpVersion", "1.3.6.1.2.1.15.1", &_names[1539],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1288], &_types[1541], NULLOT, &_types[1540] },
    { "bgpLocalAs", "1.3.6.1.2.1.15.2", &_names[1540],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1442], NULLOT, NULLOT, &_types[1541] },
    { "bgpPeerTable", "1.3.6.1.2.1.15.3", &_names[1541],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1537], &_types[1558], &_types[1542], &_types[1542] },
    { "bgpPeerEntry", "1.3.6.1.2.1.15.3.1", &_names[1542],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "bgpPeerRemoteAddr", NULL, NULL,
      &_types[1538], NULLOT, &_types[1556], &_types[1543] },
    { "bgpPeerIdentifier", "1.3.6.1.2.1.15.3.1.1", &_names[1543],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1557], &_types[1552], NULLOT, &_types[1544] },
    { "bgpPeerState", "1.3.6.1.2.1.15.3.1.2", &_names[1544],
      (OS) 87, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1535], &_types[1545], NULLOT, &_types[1545] },
    { "bgpPeerAdminStatus", "1.3.6.1.2.1.15.3.1.3", &_names[1545],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1544], &_types[1554], NULLOT, &_types[1546] },
    { "bgpPeerNegotiatedVersion", "1.3.6.1.2.1.15.3.1.4", &_names[1546],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1539], &_types[1547], NULLOT, &_types[1547] },
    { "bgpPeerLocalAddr", "1.3.6.1.2.1.15.3.1.5", &_names[1547],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1533], &_types[1549], NULLOT, &_types[1548] },
    { "bgpPeerLocalPort", "1.3.6.1.2.1.15.3.1.6", &_names[1548],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1397], &_types[1550], NULLOT, &_types[1549] },
    { "bgpPeerRemoteAddr", "1.3.6.1.2.1.15.3.1.7", &_names[1549],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1547], &_types[1544], NULLOT, &_types[1550] },
    { "bgpPeerRemotePort", "1.3.6.1.2.1.15.3.1.8", &_names[1550],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1548], &_types[1543], NULLOT, &_types[1551] },
    { "bgpPeerRemoteAs", "1.3.6.1.2.1.15.3.1.9", &_names[1551],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1540], NULLOT, NULLOT, &_types[1552] },
    { "bgpPeerInUpdates", "1.3.6.1.2.1.15.3.1.10", &_names[1552],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3085], &_types[1553], NULLOT, &_types[1553] },
    { "bgpPeerOutUpdates", "1.3.6.1.2.1.15.3.1.11", &_names[1553],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1552], &_types[1551], NULLOT, &_types[1554] },
    { "bgpPeerInTotalMessages", "1.3.6.1.2.1.15.3.1.12", &_names[1554],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1418], &_types[1555], NULLOT, &_types[1555] },
    { "bgpPeerOutTotalMessages", "1.3.6.1.2.1.15.3.1.13", &_names[1555],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1554], &_types[1548], NULLOT, &_types[1556] },
    { "bgpPeerLastError", "1.3.6.1.2.1.15.3.1.14", &_names[1556],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1389], &_types[1546], NULLOT, &_types[1557] },
    { "bgpIdentifier", "1.3.6.1.2.1.15.4", &_names[1557],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[135], &_types[1540], NULLOT, &_types[1558] },
    { "bgpRcvdPathAttrTable", "1.3.6.1.2.1.15.5", &_names[1558],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1541], &_types[1557], &_types[1559], &_types[1559] },
    { "bgpPathAttrEntry", "1.3.6.1.2.1.15.5.1", &_names[1559],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "bgpPathAttrDestNetwork bgpPathAttrPeer", NULL, NULL,
      &_types[1542], NULLOT, &_types[1564], &_types[1560] },
    { "bgpPathAttrPeer", "1.3.6.1.2.1.15.5.1.1", &_names[1560],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1379], NULLOT, NULLOT, &_types[1561] },
    { "bgpPathAttrDestNetwork", "1.3.6.1.2.1.15.5.1.2", &_names[1561],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1472], &_types[1565], NULLOT, &_types[1562] },
    { "bgpPathAttrOrigin", "1.3.6.1.2.1.15.5.1.3", &_names[1562],
      (OS) 88, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1435], &_types[1563], NULLOT, &_types[1563] },
    { "bgpPathAttrASPath", "1.3.6.1.2.1.15.5.1.4", &_names[1563],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1546], &_types[1561], NULLOT, &_types[1564] },
    { "bgpPathAttrNextHop", "1.3.6.1.2.1.15.5.1.5", &_names[1564],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1451], &_types[1562], NULLOT, &_types[1565] },
    { "bgpPathAttrInterASMetric", "1.3.6.1.2.1.15.5.1.6", &_names[1565],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1504], &_types[1560], NULLOT, &_types[1566] },
    { "rmon", "1.3.6.1.2.1.16", &_names[1566],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1536], &_types[114], &_types[1862], &_types[1567] },
    { "statistics", "1.3.6.1.2.1.16.1", &_names[1567],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1545], &_types[1784], &_types[1568], &_types[1568] },
    { "etherStatsTable", "1.3.6.1.2.1.16.1.1", &_names[1568],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1558], &_types[1591], &_types[1569], &_types[1569] },
    { "etherStatsEntry", "1.3.6.1.2.1.16.1.1.1", &_names[1569],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "etherStatsIndex", NULL, NULL,
      &_types[1559], NULLOT, &_types[1589], &_types[1570] },
    { "etherStatsIndex", "1.3.6.1.2.1.16.1.1.1.1", &_names[1570],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1521], &_types[1571], NULLOT, &_types[1571] },
    { "etherStatsDataSource", "1.3.6.1.2.1.16.1.1.1.2", &_names[1571],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1426], &_types[1574], NULLOT, &_types[1572] },
    { "etherStatsDropEvents", "1.3.6.1.2.1.16.1.1.1.3", &_names[1572],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1862], &_types[1581], NULLOT, &_types[1573] },
    { "etherStatsOctets", "1.3.6.1.2.1.16.1.1.1.4", &_names[1573],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1784], &_types[1582], NULLOT, &_types[1574] },
    { "etherStatsPkts", "1.3.6.1.2.1.16.1.1.1.5", &_names[1574],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1571], &_types[1575], NULLOT, &_types[1575] },
    { "etherStatsBroadcastPkts", "1.3.6.1.2.1.16.1.1.1.6", &_names[1575],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1574], &_types[1576], NULLOT, &_types[1576] },
    { "etherStatsMulticastPkts", "1.3.6.1.2.1.16.1.1.1.7", &_names[1576],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1575], &_types[1578], NULLOT, &_types[1577] },
    { "etherStatsCRCAlignErrors", "1.3.6.1.2.1.16.1.1.1.8", &_names[1577],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1556], &_types[1573], NULLOT, &_types[1578] },
    { "etherStatsUndersizePkts", "1.3.6.1.2.1.16.1.1.1.9", &_names[1578],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1576], &_types[1579], NULLOT, &_types[1579] },
    { "etherStatsOversizePkts", "1.3.6.1.2.1.16.1.1.1.10", &_names[1579],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1578], &_types[1580], NULLOT, &_types[1580] },
    { "etherStatsFragments", "1.3.6.1.2.1.16.1.1.1.11", &_names[1580],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1568], &_types[1572], NULLOT, &_types[1581] },
    { "etherStatsJabbers", "1.3.6.1.2.1.16.1.1.1.12", &_names[1581],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[193], NULLOT, NULLOT, &_types[1582] },
    { "etherStatsCollisions", "1.3.6.1.2.1.16.1.1.1.13", &_names[1582],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1573], &_types[1583], NULLOT, &_types[1583] },
    { "etherStatsPkts64Octets", "1.3.6.1.2.1.16.1.1.1.14", &_names[1583],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1582], &_types[1584], NULLOT, &_types[1584] },
    { "etherStatsPkts65to127Octets", "1.3.6.1.2.1.16.1.1.1.15", &_names[1584],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1583], &_types[1585], NULLOT, &_types[1585] },
    { "etherStatsPkts128to255Octets", "1.3.6.1.2.1.16.1.1.1.16", &_names[1585],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1584], &_types[1586], NULLOT, &_types[1586] },
    { "etherStatsPkts256to511Octets", "1.3.6.1.2.1.16.1.1.1.17", &_names[1586],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1585], &_types[1587], NULLOT, &_types[1587] },
    { "etherStatsPkts512to1023Octets", "1.3.6.1.2.1.16.1.1.1.18", &_names[1587],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1586], &_types[1588], NULLOT, &_types[1588] },
    { "etherStatsPkts1024to1518Octets", "1.3.6.1.2.1.16.1.1.1.19", &_names[1588],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1587], &_types[1590], NULLOT, &_types[1589] },
    { "etherStatsOwner", "1.3.6.1.2.1.16.1.1.1.20", &_names[1589],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1562], &_types[1577], NULLOT, &_types[1590] },
    { "etherStatsStatus", "1.3.6.1.2.1.16.1.1.1.21", &_names[1590],
      (OS) 89, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1588], &_types[1570], NULLOT, &_types[1591] },
    { "tokenRingMLStatsTable", "1.3.6.1.2.1.16.1.2", &_names[1591],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1872], &_types[1620], &_types[1592], &_types[1592] },
    { "tokenRingMLStatsEntry", "1.3.6.1.2.1.16.1.2.1", &_names[1592],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "tokenRingMLStatsIndex", NULL, NULL,
      &_types[1873], NULLOT, &_types[1618], &_types[1593] },
    { "tokenRingMLStatsIndex", "1.3.6.1.2.1.16.1.2.1.1", &_names[1593],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1875], &_types[1616], NULLOT, &_types[1594] },
    { "tokenRingMLStatsDataSource", "1.3.6.1.2.1.16.1.2.1.2", &_names[1594],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1806], &_types[1597], NULLOT, &_types[1595] },
    { "tokenRingMLStatsDropEvents", "1.3.6.1.2.1.16.1.2.1.3", &_names[1595],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1770], &_types[1598], NULLOT, &_types[1596] },
    { "tokenRingMLStatsMacOctets", "1.3.6.1.2.1.16.1.2.1.4", &_names[1596],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1871], &_types[1619], NULLOT, &_types[1597] },
    { "tokenRingMLStatsMacPkts", "1.3.6.1.2.1.16.1.2.1.5", &_names[1597],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1594], &_types[1599], NULLOT, &_types[1598] },
    { "tokenRingMLStatsRingPurgeEvents", "1.3.6.1.2.1.16.1.2.1.6", &_names[1598],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1595], &_types[1600], NULLOT, &_types[1599] },
    { "tokenRingMLStatsRingPurgePkts", "1.3.6.1.2.1.16.1.2.1.7", &_names[1599],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1597], &_types[1602], NULLOT, &_types[1600] },
    { "tokenRingMLStatsBeaconEvents", "1.3.6.1.2.1.16.1.2.1.8", &_names[1600],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1598], &_types[1603], NULLOT, &_types[1601] },
    { "tokenRingMLStatsBeaconTime", "1.3.6.1.2.1.16.1.2.1.9", &_names[1601],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1876], &_types[1595], NULLOT, &_types[1602] },
    { "tokenRingMLStatsBeaconPkts", "1.3.6.1.2.1.16.1.2.1.10", &_names[1602],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1599], &_types[1604], NULLOT, &_types[1603] },
    { "tokenRingMLStatsClaimTokenEvents", "1.3.6.1.2.1.16.1.2.1.11", &_names[1603],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1600], &_types[1617], NULLOT, &_types[1604] },
    { "tokenRingMLStatsClaimTokenPkts", "1.3.6.1.2.1.16.1.2.1.12", &_names[1604],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1602], &_types[1601], NULLOT, &_types[1605] },
    { "tokenRingMLStatsNAUNChanges", "1.3.6.1.2.1.16.1.2.1.13", &_names[1605],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1869], &_types[1594], NULLOT, &_types[1606] },
    { "tokenRingMLStatsLineErrors", "1.3.6.1.2.1.16.1.2.1.14", &_names[1606],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1808], &_types[1607], NULLOT, &_types[1607] },
    { "tokenRingMLStatsInternalErrors", "1.3.6.1.2.1.16.1.2.1.15", &_names[1607],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1606], &_types[1608], NULLOT, &_types[1608] },
    { "tokenRingMLStatsBurstErrors", "1.3.6.1.2.1.16.1.2.1.16", &_names[1608],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1607], &_types[1609], NULLOT, &_types[1609] },
    { "tokenRingMLStatsACErrors", "1.3.6.1.2.1.16.1.2.1.17", &_names[1609],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1608], &_types[1610], NULLOT, &_types[1610] },
    { "tokenRingMLStatsAbortErrors", "1.3.6.1.2.1.16.1.2.1.18", &_names[1610],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1609], &_types[1611], NULLOT, &_types[1611] },
    { "tokenRingMLStatsLostFrameErrors", "1.3.6.1.2.1.16.1.2.1.19", &_names[1611],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1610], &_types[1612], NULLOT, &_types[1612] },
    { "tokenRingMLStatsCongestionErrors", "1.3.6.1.2.1.16.1.2.1.20", &_names[1612],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1611], &_types[1613], NULLOT, &_types[1613] },
    { "tokenRingMLStatsFrameCopiedErrors", "1.3.6.1.2.1.16.1.2.1.21", &_names[1613],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1612], &_types[1614], NULLOT, &_types[1614] },
    { "tokenRingMLStatsFrequencyErrors", "1.3.6.1.2.1.16.1.2.1.22", &_names[1614],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1613], &_types[1615], NULLOT, &_types[1615] },
    { "tokenRingMLStatsTokenErrors", "1.3.6.1.2.1.16.1.2.1.23", &_names[1615],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1614], &_types[1596], NULLOT, &_types[1616] },
    { "tokenRingMLStatsSoftErrorReports", "1.3.6.1.2.1.16.1.2.1.24", &_names[1616],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1780], &_types[1605], NULLOT, &_types[1617] },
    { "tokenRingMLStatsRingPollEvents", "1.3.6.1.2.1.16.1.2.1.25", &_names[1617],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1603], NULLOT, NULLOT, &_types[1618] },
    { "tokenRingMLStatsOwner", "1.3.6.1.2.1.16.1.2.1.26", &_names[1618],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1870], &_types[1606], NULLOT, &_types[1619] },
    { "tokenRingMLStatsStatus", "1.3.6.1.2.1.16.1.2.1.27", &_names[1619],
      (OS) 108, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1596], &_types[1593], NULLOT, &_types[1620] },
    { "tokenRingPStatsTable", "1.3.6.1.2.1.16.1.3", &_names[1620],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1591], NULLOT, &_types[1621], &_types[1621] },
    { "tokenRingPStatsEntry", "1.3.6.1.2.1.16.1.3.1", &_names[1621],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "tokenRingPStatsIndex", NULL, NULL,
      &_types[1592], NULLOT, &_types[1639], &_types[1622] },
    { "tokenRingPStatsIndex", "1.3.6.1.2.1.16.1.3.1.1", &_names[1622],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1593], &_types[1623], NULLOT, &_types[1623] },
    { "tokenRingPStatsDataSource", "1.3.6.1.2.1.16.1.3.1.2", &_names[1623],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1604], &_types[1626], NULLOT, &_types[1624] },
    { "tokenRingPStatsDropEvents", "1.3.6.1.2.1.16.1.3.1.3", &_names[1624],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1617], NULLOT, NULLOT, &_types[1625] },
    { "tokenRingPStatsDataOctets", "1.3.6.1.2.1.16.1.3.1.4", &_names[1625],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1619], &_types[1629], NULLOT, &_types[1626] },
    { "tokenRingPStatsDataPkts", "1.3.6.1.2.1.16.1.3.1.5", &_names[1626],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1623], &_types[1627], NULLOT, &_types[1627] },
    { "tokenRingPStatsDataBroadcastPkts", "1.3.6.1.2.1.16.1.3.1.6", &_names[1627],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1626], &_types[1628], NULLOT, &_types[1628] },
    { "tokenRingPStatsDataMulticastPkts", "1.3.6.1.2.1.16.1.3.1.7", &_names[1628],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1627], &_types[1624], NULLOT, &_types[1629] },
    { "tokenRingPStatsDataPkts18to63Octets", "1.3.6.1.2.1.16.1.3.1.8", &_names[1629],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1625], &_types[1630], NULLOT, &_types[1630] },
    { "tokenRingPStatsDataPkts64to127Octets", "1.3.6.1.2.1.16.1.3.1.9", &_names[1630],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1629], &_types[1631], NULLOT, &_types[1631] },
    { "tokenRingPStatsDataPkts128to255Octets", "1.3.6.1.2.1.16.1.3.1.10", &_names[1631],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1630], &_types[1632], NULLOT, &_types[1632] },
    { "tokenRingPStatsDataPkts256to511Octets", "1.3.6.1.2.1.16.1.3.1.11", &_names[1632],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1631], &_types[1633], NULLOT, &_types[1633] },
    { "tokenRingPStatsDataPkts512to1023Octets", "1.3.6.1.2.1.16.1.3.1.12", &_names[1633],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1632], &_types[1634], NULLOT, &_types[1634] },
    { "tokenRingPStatsDataPkts1024to2047Octets", "1.3.6.1.2.1.16.1.3.1.13", &_names[1634],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1633], &_types[1635], NULLOT, &_types[1635] },
    { "tokenRingPStatsDataPkts2048to4095Octets", "1.3.6.1.2.1.16.1.3.1.14", &_names[1635],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1634], &_types[1636], NULLOT, &_types[1636] },
    { "tokenRingPStatsDataPkts4096to8191Octets", "1.3.6.1.2.1.16.1.3.1.15", &_names[1636],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1635], &_types[1637], NULLOT, &_types[1637] },
    { "tokenRingPStatsDataPkts8192to18000Octets", "1.3.6.1.2.1.16.1.3.1.16", &_names[1637],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1636], &_types[1638], NULLOT, &_types[1638] },
    { "tokenRingPStatsDataPktsGreaterThan18000Octets", "1.3.6.1.2.1.16.1.3.1.17", &_names[1638],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1637], &_types[1640], NULLOT, &_types[1639] },
    { "tokenRingPStatsOwner", "1.3.6.1.2.1.16.1.3.1.18", &_names[1639],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1618], &_types[1625], NULLOT, &_types[1640] },
    { "tokenRingPStatsStatus", "1.3.6.1.2.1.16.1.3.1.19", &_names[1640],
      (OS) 109, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1638], &_types[1622], NULLOT, &_types[1641] },
    { "history", "1.3.6.1.2.1.16.2", &_names[1641],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1365], &_types[1765], &_types[1642], &_types[1642] },
    { "historyControlTable", "1.3.6.1.2.1.16.2.1", &_names[1642],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1580], &_types[1651], &_types[1643], &_types[1643] },
    { "historyControlEntry", "1.3.6.1.2.1.16.2.1.1", &_names[1643],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "historyControlIndex", NULL, NULL,
      &_types[1569], NULLOT, &_types[1649], &_types[1644] },
    { "historyControlIndex", "1.3.6.1.2.1.16.2.1.1.1", &_names[1644],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1570], &_types[1646], NULLOT, &_types[1645] },
    { "historyControlDataSource", "1.3.6.1.2.1.16.2.1.1.2", &_names[1645],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1579], &_types[1647], NULLOT, &_types[1646] },
    { "historyControlBucketsRequested", "1.3.6.1.2.1.16.2.1.1.3", &_names[1646],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1429], &_types[1645], NULLOT, &_types[1647] },
    { "historyControlBucketsGranted", "1.3.6.1.2.1.16.2.1.1.4", &_names[1647],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1717], &_types[1648], NULLOT, &_types[1648] },
    { "historyControlInterval", "1.3.6.1.2.1.16.2.1.1.5", &_names[1648],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 3600,
      NULL, NULL, NULL,
      &_types[1513], NULLOT, NULLOT, &_types[1649] },
    { "historyControlOwner", "1.3.6.1.2.1.16.2.1.1.6", &_names[1649],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1589], &_types[1650], NULLOT, &_types[1650] },
    { "historyControlStatus", "1.3.6.1.2.1.16.2.1.1.7", &_names[1650],
      (OS) 90, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1590], &_types[1644], NULLOT, &_types[1651] },
    { "etherHistoryTable", "1.3.6.1.2.1.16.2.2", &_names[1651],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1642], &_types[1668], &_types[1652], &_types[1652] },
    { "etherHistoryEntry", "1.3.6.1.2.1.16.2.2.1", &_names[1652],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "etherHistoryIndex etherHistorySampleIndex", NULL, NULL,
      &_types[1643], NULLOT, &_types[1661], &_types[1653] },
    { "etherHistoryIndex", "1.3.6.1.2.1.16.2.2.1.1", &_names[1653],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1644], &_types[1654], NULLOT, &_types[1654] },
    { "etherHistorySampleIndex", "1.3.6.1.2.1.16.2.2.1.2", &_names[1654],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1653], &_types[1658], NULLOT, &_types[1655] },
    { "etherHistoryIntervalStart", "1.3.6.1.2.1.16.2.2.1.3", &_names[1655],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1650], &_types[1657], NULLOT, &_types[1656] },
    { "etherHistoryDropEvents", "1.3.6.1.2.1.16.2.2.1.4", &_names[1656],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1572], &_types[1665], NULLOT, &_types[1657] },
    { "etherHistoryOctets", "1.3.6.1.2.1.16.2.2.1.5", &_names[1657],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1655], &_types[1666], NULLOT, &_types[1658] },
    { "etherHistoryPkts", "1.3.6.1.2.1.16.2.2.1.6", &_names[1658],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1645], &_types[1659], NULLOT, &_types[1659] },
    { "etherHistoryBroadcastPkts", "1.3.6.1.2.1.16.2.2.1.7", &_names[1659],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1658], &_types[1660], NULLOT, &_types[1660] },
    { "etherHistoryMulticastPkts", "1.3.6.1.2.1.16.2.2.1.8", &_names[1660],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1659], &_types[1662], NULLOT, &_types[1661] },
    { "etherHistoryCRCAlignErrors", "1.3.6.1.2.1.16.2.2.1.9", &_names[1661],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1577], &_types[1655], NULLOT, &_types[1662] },
    { "etherHistoryUndersizePkts", "1.3.6.1.2.1.16.2.2.1.10", &_names[1662],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1660], &_types[1663], NULLOT, &_types[1663] },
    { "etherHistoryOversizePkts", "1.3.6.1.2.1.16.2.2.1.11", &_names[1663],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1662], &_types[1664], NULLOT, &_types[1664] },
    { "etherHistoryFragments", "1.3.6.1.2.1.16.2.2.1.12", &_names[1664],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1651], &_types[1656], NULLOT, &_types[1665] },
    { "etherHistoryJabbers", "1.3.6.1.2.1.16.2.2.1.13", &_names[1665],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1581], &_types[1667], NULLOT, &_types[1666] },
    { "etherHistoryCollisions", "1.3.6.1.2.1.16.2.2.1.14", &_names[1666],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1657], &_types[1653], NULLOT, &_types[1667] },
    { "etherHistoryUtilization", "1.3.6.1.2.1.16.2.2.1.15", &_names[1667],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 10000,
      NULL, NULL, NULL,
      &_types[1543], NULLOT, NULLOT, &_types[1668] },
    { "tokenRingMLHistoryTable", "1.3.6.1.2.1.16.2.3", &_names[1668],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1620], &_types[1697], &_types[1669], &_types[1669] },
    { "tokenRingMLHistoryEntry", "1.3.6.1.2.1.16.2.3.1", &_names[1669],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "tokenRingMLHistoryIndex tokenRingMLHistorySampleIndex", NULL, NULL,
      &_types[1621], NULLOT, &_types[1684], &_types[1670] },
    { "tokenRingMLHistoryIndex", "1.3.6.1.2.1.16.2.3.1.1", &_names[1670],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1622], &_types[1671], NULLOT, &_types[1671] },
    { "tokenRingMLHistorySampleIndex", "1.3.6.1.2.1.16.2.3.1.2", &_names[1671],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1670], &_types[1694], NULLOT, &_types[1672] },
    { "tokenRingMLHistoryIntervalStart", "1.3.6.1.2.1.16.2.3.1.3", &_names[1672],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1640], &_types[1674], NULLOT, &_types[1673] },
    { "tokenRingMLHistoryDropEvents", "1.3.6.1.2.1.16.2.3.1.4", &_names[1673],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1624], &_types[1676], NULLOT, &_types[1674] },
    { "tokenRingMLHistoryMacOctets", "1.3.6.1.2.1.16.2.3.1.5", &_names[1674],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1672], &_types[1696], NULLOT, &_types[1675] },
    { "tokenRingMLHistoryMacPkts", "1.3.6.1.2.1.16.2.3.1.6", &_names[1675],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1628], &_types[1677], NULLOT, &_types[1676] },
    { "tokenRingMLHistoryRingPurgeEvents", "1.3.6.1.2.1.16.2.3.1.7", &_names[1676],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1673], &_types[1678], NULLOT, &_types[1677] },
    { "tokenRingMLHistoryRingPurgePkts", "1.3.6.1.2.1.16.2.3.1.8", &_names[1677],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1675], &_types[1680], NULLOT, &_types[1678] },
    { "tokenRingMLHistoryBeaconEvents", "1.3.6.1.2.1.16.2.3.1.9", &_names[1678],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1676], &_types[1681], NULLOT, &_types[1679] },
    { "tokenRingMLHistoryBeaconTime", "1.3.6.1.2.1.16.2.3.1.10", &_names[1679],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1601], &_types[1673], NULLOT, &_types[1680] },
    { "tokenRingMLHistoryBeaconPkts", "1.3.6.1.2.1.16.2.3.1.11", &_names[1680],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1677], &_types[1682], NULLOT, &_types[1681] },
    { "tokenRingMLHistoryClaimTokenEvents", "1.3.6.1.2.1.16.2.3.1.12", &_names[1681],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1678], &_types[1695], NULLOT, &_types[1682] },
    { "tokenRingMLHistoryClaimTokenPkts", "1.3.6.1.2.1.16.2.3.1.13", &_names[1682],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1680], &_types[1679], NULLOT, &_types[1683] },
    { "tokenRingMLHistoryNAUNChanges", "1.3.6.1.2.1.16.2.3.1.14", &_names[1683],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1605], &_types[1675], NULLOT, &_types[1684] },
    { "tokenRingMLHistoryLineErrors", "1.3.6.1.2.1.16.2.3.1.15", &_names[1684],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1615], &_types[1685], NULLOT, &_types[1685] },
    { "tokenRingMLHistoryInternalErrors", "1.3.6.1.2.1.16.2.3.1.16", &_names[1685],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1684], &_types[1686], NULLOT, &_types[1686] },
    { "tokenRingMLHistoryBurstErrors", "1.3.6.1.2.1.16.2.3.1.17", &_names[1686],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1685], &_types[1687], NULLOT, &_types[1687] },
    { "tokenRingMLHistoryACErrors", "1.3.6.1.2.1.16.2.3.1.18", &_names[1687],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1686], &_types[1688], NULLOT, &_types[1688] },
    { "tokenRingMLHistoryAbortErrors", "1.3.6.1.2.1.16.2.3.1.19", &_names[1688],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1687], &_types[1689], NULLOT, &_types[1689] },
    { "tokenRingMLHistoryLostFrameErrors", "1.3.6.1.2.1.16.2.3.1.20", &_names[1689],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1688], &_types[1690], NULLOT, &_types[1690] },
    { "tokenRingMLHistoryCongestionErrors", "1.3.6.1.2.1.16.2.3.1.21", &_names[1690],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1689], &_types[1691], NULLOT, &_types[1691] },
    { "tokenRingMLHistoryFrameCopiedErrors", "1.3.6.1.2.1.16.2.3.1.22", &_names[1691],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1690], &_types[1692], NULLOT, &_types[1692] },
    { "tokenRingMLHistoryFrequencyErrors", "1.3.6.1.2.1.16.2.3.1.23", &_names[1692],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1691], &_types[1693], NULLOT, &_types[1693] },
    { "tokenRingMLHistoryTokenErrors", "1.3.6.1.2.1.16.2.3.1.24", &_names[1693],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1692], &_types[1672], NULLOT, &_types[1694] },
    { "tokenRingMLHistorySoftErrorReports", "1.3.6.1.2.1.16.2.3.1.25", &_names[1694],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1616], &_types[1683], NULLOT, &_types[1695] },
    { "tokenRingMLHistoryRingPollEvents", "1.3.6.1.2.1.16.2.3.1.26", &_names[1695],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1681], NULLOT, NULLOT, &_types[1696] },
    { "tokenRingMLHistoryActiveStations", "1.3.6.1.2.1.16.2.3.1.27", &_names[1696],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1674], &_types[1670], NULLOT, &_types[1697] },
    { "tokenRingPHistoryTable", "1.3.6.1.2.1.16.2.4", &_names[1697],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1668], NULLOT, &_types[1698], &_types[1698] },
    { "tokenRingPHistoryEntry", "1.3.6.1.2.1.16.2.4.1", &_names[1698],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "tokenRingPHistoryIndex tokenRingPHistorySampleIndex", NULL, NULL,
      &_types[1669], NULLOT, &_types[1701], &_types[1699] },
    { "tokenRingPHistoryIndex", "1.3.6.1.2.1.16.2.4.1.1", &_names[1699],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1671], &_types[1700], NULLOT, &_types[1700] },
    { "tokenRingPHistorySampleIndex", "1.3.6.1.2.1.16.2.4.1.2", &_names[1700],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1699], &_types[1704], NULLOT, &_types[1701] },
    { "tokenRingPHistoryIntervalStart", "1.3.6.1.2.1.16.2.4.1.3", &_names[1701],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1696], &_types[1703], NULLOT, &_types[1702] },
    { "tokenRingPHistoryDropEvents", "1.3.6.1.2.1.16.2.4.1.4", &_names[1702],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1695], NULLOT, NULLOT, &_types[1703] },
    { "tokenRingPHistoryDataOctets", "1.3.6.1.2.1.16.2.4.1.5", &_names[1703],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1701], &_types[1707], NULLOT, &_types[1704] },
    { "tokenRingPHistoryDataPkts", "1.3.6.1.2.1.16.2.4.1.6", &_names[1704],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1682], &_types[1705], NULLOT, &_types[1705] },
    { "tokenRingPHistoryDataBroadcastPkts", "1.3.6.1.2.1.16.2.4.1.7", &_names[1705],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1704], &_types[1706], NULLOT, &_types[1706] },
    { "tokenRingPHistoryDataMulticastPkts", "1.3.6.1.2.1.16.2.4.1.8", &_names[1706],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1705], &_types[1702], NULLOT, &_types[1707] },
    { "tokenRingPHistoryDataPkts18to63Octets", "1.3.6.1.2.1.16.2.4.1.9", &_names[1707],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1703], &_types[1708], NULLOT, &_types[1708] },
    { "tokenRingPHistoryDataPkts64to127Octets", "1.3.6.1.2.1.16.2.4.1.10", &_names[1708],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1707], &_types[1709], NULLOT, &_types[1709] },
    { "tokenRingPHistoryDataPkts128to255Octets", "1.3.6.1.2.1.16.2.4.1.11", &_names[1709],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1708], &_types[1710], NULLOT, &_types[1710] },
    { "tokenRingPHistoryDataPkts256to511Octets", "1.3.6.1.2.1.16.2.4.1.12", &_names[1710],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1709], &_types[1711], NULLOT, &_types[1711] },
    { "tokenRingPHistoryDataPkts512to1023Octets", "1.3.6.1.2.1.16.2.4.1.13", &_names[1711],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1710], &_types[1712], NULLOT, &_types[1712] },
    { "tokenRingPHistoryDataPkts1024to2047Octets", "1.3.6.1.2.1.16.2.4.1.14", &_names[1712],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1711], &_types[1713], NULLOT, &_types[1713] },
    { "tokenRingPHistoryDataPkts2048to4095Octets", "1.3.6.1.2.1.16.2.4.1.15", &_names[1713],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1712], &_types[1714], NULLOT, &_types[1714] },
    { "tokenRingPHistoryDataPkts4096to8191Octets", "1.3.6.1.2.1.16.2.4.1.16", &_names[1714],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1713], &_types[1715], NULLOT, &_types[1715] },
    { "tokenRingPHistoryDataPkts8192to18000Octets", "1.3.6.1.2.1.16.2.4.1.17", &_names[1715],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1714], &_types[1716], NULLOT, &_types[1716] },
    { "tokenRingPHistoryDataPktsGreaterThan18000Octets", "1.3.6.1.2.1.16.2.4.1.18", &_names[1716],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1715], &_types[1699], NULLOT, &_types[1717] },
    { "alarm", "1.3.6.1.2.1.16.3", &_names[1717],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[65], NULLOT, &_types[1718], &_types[1718] },
    { "alarmTable", "1.3.6.1.2.1.16.3.1", &_names[1718],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1664], NULLOT, &_types[1719], &_types[1719] },
    { "alarmEntry", "1.3.6.1.2.1.16.3.1.1", &_names[1719],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "alarmIndex", NULL, NULL,
      &_types[1652], NULLOT, &_types[1723], &_types[1720] },
    { "alarmIndex", "1.3.6.1.2.1.16.3.1.1.1", &_names[1720],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1654], &_types[1728], NULLOT, &_types[1721] },
    { "alarmInterval", "1.3.6.1.2.1.16.3.1.1.2", &_names[1721],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1648], NULLOT, NULLOT, &_types[1722] },
    { "alarmVariable", "1.3.6.1.2.1.16.3.1.1.3", &_names[1722],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1524], &_types[1730], NULLOT, &_types[1723] },
    { "alarmSampleType", "1.3.6.1.2.1.16.3.1.1.4", &_names[1723],
      (OS) 91, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1719], &_types[1722], NULLOT, &_types[1724] },
    { "alarmValue", "1.3.6.1.2.1.16.3.1.1.5", &_names[1724],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1549], &_types[1731], NULLOT, &_types[1725] },
    { "alarmStartupAlarm", "1.3.6.1.2.1.16.3.1.1.6", &_names[1725],
      (OS) 92, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1647], &_types[1721], NULLOT, &_types[1726] },
    { "alarmRisingThreshold", "1.3.6.1.2.1.16.3.1.1.7", &_names[1726],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1646], &_types[1727], NULLOT, &_types[1727] },
    { "alarmFallingThreshold", "1.3.6.1.2.1.16.3.1.1.8", &_names[1727],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1726], &_types[1725], NULLOT, &_types[1728] },
    { "alarmRisingEventIndex", "1.3.6.1.2.1.16.3.1.1.9", &_names[1728],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1720], &_types[1729], NULLOT, &_types[1729] },
    { "alarmFallingEventIndex", "1.3.6.1.2.1.16.3.1.1.10", &_names[1729],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1728], &_types[1726], NULLOT, &_types[1730] },
    { "alarmOwner", "1.3.6.1.2.1.16.3.1.1.11", &_names[1730],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1649], &_types[1724], NULLOT, &_types[1731] },
    { "alarmStatus", "1.3.6.1.2.1.16.3.1.1.12", &_names[1731],
      (OS) 93, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1666], &_types[1720], NULLOT, &_types[1732] },
    { "hosts", "1.3.6.1.2.1.16.4", &_names[1732],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1431], &_types[1809], &_types[1733], &_types[1733] },
    { "hostControlTable", "1.3.6.1.2.1.16.4.1", &_names[1733],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1718], &_types[1741], &_types[1734], &_types[1734] },
    { "hostControlEntry", "1.3.6.1.2.1.16.4.1.1", &_names[1734],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hostControlIndex", NULL, NULL,
      &_types[1723], NULLOT, &_types[1739], &_types[1735] },
    { "hostControlIndex", "1.3.6.1.2.1.16.4.1.1.1", &_names[1735],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1729], &_types[1736], NULLOT, &_types[1736] },
    { "hostControlDataSource", "1.3.6.1.2.1.16.4.1.1.2", &_names[1736],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1663], &_types[1738], NULLOT, &_types[1737] },
    { "hostControlTableSize", "1.3.6.1.2.1.16.4.1.1.3", &_names[1737],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1508], &_types[1740], NULLOT, &_types[1738] },
    { "hostControlLastDeleteTime", "1.3.6.1.2.1.16.4.1.1.4", &_names[1738],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1496], NULLOT, NULLOT, &_types[1739] },
    { "hostControlOwner", "1.3.6.1.2.1.16.4.1.1.5", &_names[1739],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1730], &_types[1737], NULLOT, &_types[1740] },
    { "hostControlStatus", "1.3.6.1.2.1.16.4.1.1.6", &_names[1740],
      (OS) 94, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1731], &_types[1735], NULLOT, &_types[1741] },
    { "hostTable", "1.3.6.1.2.1.16.4.2", &_names[1741],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1733], &_types[1753], &_types[1742], &_types[1742] },
    { "hostEntry", "1.3.6.1.2.1.16.4.2.1", &_names[1742],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hostIndex hostAddress", NULL, NULL,
      &_types[1734], NULLOT, &_types[1750], &_types[1743] },
    { "hostAddress", "1.3.6.1.2.1.16.4.2.1.1", &_names[1743],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1724], &_types[1744], NULLOT, &_types[1744] },
    { "hostCreationOrder", "1.3.6.1.2.1.16.4.2.1.2", &_names[1744],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1743], &_types[1748], NULLOT, &_types[1745] },
    { "hostIndex", "1.3.6.1.2.1.16.4.2.1.3", &_names[1745],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1735], &_types[1746], NULLOT, &_types[1746] },
    { "hostInPkts", "1.3.6.1.2.1.16.4.2.1.4", &_names[1746],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1736], &_types[1747], NULLOT, &_types[1747] },
    { "hostOutPkts", "1.3.6.1.2.1.16.4.2.1.5", &_names[1747],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1746], &_types[1751], NULLOT, &_types[1748] },
    { "hostInOctets", "1.3.6.1.2.1.16.4.2.1.6", &_names[1748],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1740], &_types[1749], NULLOT, &_types[1749] },
    { "hostOutOctets", "1.3.6.1.2.1.16.4.2.1.7", &_names[1749],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1748], &_types[1745], NULLOT, &_types[1750] },
    { "hostOutErrors", "1.3.6.1.2.1.16.4.2.1.8", &_names[1750],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1661], &_types[1743], NULLOT, &_types[1751] },
    { "hostOutBroadcastPkts", "1.3.6.1.2.1.16.4.2.1.9", &_names[1751],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1747], &_types[1752], NULLOT, &_types[1752] },
    { "hostOutMulticastPkts", "1.3.6.1.2.1.16.4.2.1.10", &_names[1752],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1751], NULLOT, NULLOT, &_types[1753] },
    { "hostTimeTable", "1.3.6.1.2.1.16.4.3", &_names[1753],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1741], NULLOT, &_types[1754], &_types[1754] },
    { "hostTimeEntry", "1.3.6.1.2.1.16.4.3.1", &_names[1754],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hostTimeIndex hostTimeCreationOrder", NULL, NULL,
      &_types[1742], NULLOT, &_types[1762], &_types[1755] },
    { "hostTimeAddress", "1.3.6.1.2.1.16.4.3.1.1", &_names[1755],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1744], &_types[1756], NULLOT, &_types[1756] },
    { "hostTimeCreationOrder", "1.3.6.1.2.1.16.4.3.1.2", &_names[1756],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1755], &_types[1760], NULLOT, &_types[1757] },
    { "hostTimeIndex", "1.3.6.1.2.1.16.4.3.1.3", &_names[1757],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1745], &_types[1758], NULLOT, &_types[1758] },
    { "hostTimeInPkts", "1.3.6.1.2.1.16.4.3.1.4", &_names[1758],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1752], &_types[1759], NULLOT, &_types[1759] },
    { "hostTimeOutPkts", "1.3.6.1.2.1.16.4.3.1.5", &_names[1759],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1758], &_types[1763], NULLOT, &_types[1760] },
    { "hostTimeInOctets", "1.3.6.1.2.1.16.4.3.1.6", &_names[1760],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1749], &_types[1761], NULLOT, &_types[1761] },
    { "hostTimeOutOctets", "1.3.6.1.2.1.16.4.3.1.7", &_names[1761],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1760], &_types[1757], NULLOT, &_types[1762] },
    { "hostTimeOutErrors", "1.3.6.1.2.1.16.4.3.1.8", &_names[1762],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1750], &_types[1755], NULLOT, &_types[1763] },
    { "hostTimeOutBroadcastPkts", "1.3.6.1.2.1.16.4.3.1.9", &_names[1763],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1759], &_types[1764], NULLOT, &_types[1764] },
    { "hostTimeOutMulticastPkts", "1.3.6.1.2.1.16.4.3.1.10", &_names[1764],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1763], NULLOT, NULLOT, &_types[1765] },
    { "hostTopN", "1.3.6.1.2.1.16.5", &_names[1765],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1440], &_types[1732], &_types[1766], &_types[1766] },
    { "hostTopNControlTable", "1.3.6.1.2.1.16.5.1", &_names[1766],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1753], &_types[1778], &_types[1767], &_types[1767] },
    { "hostTopNControlEntry", "1.3.6.1.2.1.16.5.1.1", &_names[1767],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hostTopNControlIndex", NULL, NULL,
      &_types[1754], NULLOT, &_types[1776], &_types[1768] },
    { "hostTopNControlIndex", "1.3.6.1.2.1.16.5.1.1.1", &_names[1768],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1757], &_types[1769], NULLOT, &_types[1769] },
    { "hostTopNHostIndex", "1.3.6.1.2.1.16.5.1.1.2", &_names[1769],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1768], &_types[1771], NULLOT, &_types[1770] },
    { "hostTopNRateBase", "1.3.6.1.2.1.16.5.1.1.3", &_names[1770],
      (OS) 95, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1656], NULLOT, NULLOT, &_types[1771] },
    { "hostTopNTimeRemaining", "1.3.6.1.2.1.16.5.1.1.4", &_names[1771],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1415], &_types[1775], NULLOT, &_types[1772] },
    { "hostTopNDuration", "1.3.6.1.2.1.16.5.1.1.5", &_names[1772],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1756], &_types[1777], NULLOT, &_types[1773] },
    { "hostTopNRequestedSize", "1.3.6.1.2.1.16.5.1.1.6", &_names[1773],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1737], &_types[1774], NULLOT, &_types[1774] },
    { "hostTopNGrantedSize", "1.3.6.1.2.1.16.5.1.1.7", &_names[1774],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1773], &_types[1772], NULLOT, &_types[1775] },
    { "hostTopNStartTime", "1.3.6.1.2.1.16.5.1.1.8", &_names[1775],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1738], &_types[1770], NULLOT, &_types[1776] },
    { "hostTopNOwner", "1.3.6.1.2.1.16.5.1.1.9", &_names[1776],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1739], &_types[1773], NULLOT, &_types[1777] },
    { "hostTopNStatus", "1.3.6.1.2.1.16.5.1.1.10", &_names[1777],
      (OS) 96, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1761], &_types[1768], NULLOT, &_types[1778] },
    { "hostTopNTable", "1.3.6.1.2.1.16.5.2", &_names[1778],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1766], NULLOT, &_types[1779], &_types[1779] },
    { "hostTopNEntry", "1.3.6.1.2.1.16.5.2.1", &_names[1779],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hostTopNReport hostTopNIndex", NULL, NULL,
      &_types[1767], NULLOT, &_types[1783], &_types[1780] },
    { "hostTopNReport", "1.3.6.1.2.1.16.5.2.1.1", &_names[1780],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1561], NULLOT, NULLOT, &_types[1781] },
    { "hostTopNIndex", "1.3.6.1.2.1.16.5.2.1.2", &_names[1781],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1769], &_types[1780], NULLOT, &_types[1782] },
    { "hostTopNAddress", "1.3.6.1.2.1.16.5.2.1.3", &_names[1782],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1772], &_types[1781], NULLOT, &_types[1783] },
    { "hostTopNRate", "1.3.6.1.2.1.16.5.2.1.4", &_names[1783],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1762], &_types[1782], NULLOT, &_types[1784] },
    { "matrix", "1.3.6.1.2.1.16.6", &_names[1784],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1567], &_types[1878], &_types[1785], &_types[1785] },
    { "matrixControlTable", "1.3.6.1.2.1.16.6.1", &_names[1785],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1778], &_types[1793], &_types[1786], &_types[1786] },
    { "matrixControlEntry", "1.3.6.1.2.1.16.6.1.1", &_names[1786],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "matrixControlIndex", NULL, NULL,
      &_types[1779], NULLOT, &_types[1791], &_types[1787] },
    { "matrixControlIndex", "1.3.6.1.2.1.16.6.1.1.1", &_names[1787],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1781], &_types[1788], NULLOT, &_types[1788] },
    { "matrixControlDataSource", "1.3.6.1.2.1.16.6.1.1.2", &_names[1788],
      (OS) 4, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1764], &_types[1790], NULLOT, &_types[1789] },
    { "matrixControlTableSize", "1.3.6.1.2.1.16.6.1.1.3", &_names[1789],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1774], &_types[1792], NULLOT, &_types[1790] },
    { "matrixControlLastDeleteTime", "1.3.6.1.2.1.16.6.1.1.4", &_names[1790],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1775], NULLOT, NULLOT, &_types[1791] },
    { "matrixControlOwner", "1.3.6.1.2.1.16.6.1.1.5", &_names[1791],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1776], &_types[1789], NULLOT, &_types[1792] },
    { "matrixControlStatus", "1.3.6.1.2.1.16.6.1.1.6", &_names[1792],
      (OS) 97, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1777], &_types[1787], NULLOT, &_types[1793] },
    { "matrixSDTable", "1.3.6.1.2.1.16.6.2", &_names[1793],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1785], &_types[1801], &_types[1794], &_types[1794] },
    { "matrixSDEntry", "1.3.6.1.2.1.16.6.2.1", &_names[1794],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "matrixSDIndex matrixSDSourceAddress matrixSDDestAddress", NULL, NULL,
      &_types[1786], NULLOT, &_types[1800], &_types[1795] },
    { "matrixSDSourceAddress", "1.3.6.1.2.1.16.6.2.1.1", &_names[1795],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1782], &_types[1796], NULLOT, &_types[1796] },
    { "matrixSDDestAddress", "1.3.6.1.2.1.16.6.2.1.2", &_names[1796],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1795], &_types[1799], NULLOT, &_types[1797] },
    { "matrixSDIndex", "1.3.6.1.2.1.16.6.2.1.3", &_names[1797],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1787], &_types[1798], NULLOT, &_types[1798] },
    { "matrixSDPkts", "1.3.6.1.2.1.16.6.2.1.4", &_names[1798],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1788], NULLOT, NULLOT, &_types[1799] },
    { "matrixSDOctets", "1.3.6.1.2.1.16.6.2.1.5", &_names[1799],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1792], &_types[1797], NULLOT, &_types[1800] },
    { "matrixSDErrors", "1.3.6.1.2.1.16.6.2.1.6", &_names[1800],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1783], &_types[1795], NULLOT, &_types[1801] },
    { "matrixDSTable", "1.3.6.1.2.1.16.6.3", &_names[1801],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1793], NULLOT, &_types[1802], &_types[1802] },
    { "matrixDSEntry", "1.3.6.1.2.1.16.6.3.1", &_names[1802],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "matrixDSIndex matrixDSDestAddress matrixDSSourceAddress", NULL, NULL,
      &_types[1794], NULLOT, &_types[1808], &_types[1803] },
    { "matrixDSSourceAddress", "1.3.6.1.2.1.16.6.3.1.1", &_names[1803],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1796], &_types[1804], NULLOT, &_types[1804] },
    { "matrixDSDestAddress", "1.3.6.1.2.1.16.6.3.1.2", &_names[1804],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1803], &_types[1807], NULLOT, &_types[1805] },
    { "matrixDSIndex", "1.3.6.1.2.1.16.6.3.1.3", &_names[1805],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1797], &_types[1806], NULLOT, &_types[1806] },
    { "matrixDSPkts", "1.3.6.1.2.1.16.6.3.1.4", &_names[1806],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1798], NULLOT, NULLOT, &_types[1807] },
    { "matrixDSOctets", "1.3.6.1.2.1.16.6.3.1.5", &_names[1807],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1799], &_types[1805], NULLOT, &_types[1808] },
    { "matrixDSErrors", "1.3.6.1.2.1.16.6.3.1.6", &_names[1808],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1800], &_types[1803], NULLOT, &_types[1809] },
    { "filter", "1.3.6.1.2.1.16.7", &_names[1809],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1564], &_types[1567], &_types[1810], &_types[1810] },
    { "filterTable", "1.3.6.1.2.1.16.7.1", &_names[1810],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1801], &_types[1823], &_types[1811], &_types[1811] },
    { "filterEntry", "1.3.6.1.2.1.16.7.1.1", &_names[1811],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "filterIndex", NULL, NULL,
      &_types[1802], NULLOT, &_types[1821], &_types[1812] },
    { "filterIndex", "1.3.6.1.2.1.16.7.1.1.1", &_names[1812],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1805], &_types[1813], NULLOT, &_types[1813] },
    { "filterChannelIndex", "1.3.6.1.2.1.16.7.1.1.2", &_names[1813],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1812], &_types[1816], NULLOT, &_types[1814] },
    { "filterPktDataOffset", "1.3.6.1.2.1.16.7.1.1.3", &_names[1814],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[190], NULLOT, NULLOT, &_types[1815] },
    { "filterPktData", "1.3.6.1.2.1.16.7.1.1.4", &_names[1815],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1424], &_types[1814], NULLOT, &_types[1816] },
    { "filterPktDataMask", "1.3.6.1.2.1.16.7.1.1.5", &_names[1816],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1813], &_types[1817], NULLOT, &_types[1817] },
    { "filterPktDataNotMask", "1.3.6.1.2.1.16.7.1.1.6", &_names[1817],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1816], &_types[1819], NULLOT, &_types[1818] },
    { "filterPktStatus", "1.3.6.1.2.1.16.7.1.1.7", &_names[1818],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1807], &_types[1822], NULLOT, &_types[1819] },
    { "filterPktStatusMask", "1.3.6.1.2.1.16.7.1.1.8", &_names[1819],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1817], &_types[1820], NULLOT, &_types[1820] },
    { "filterPktStatusNotMask", "1.3.6.1.2.1.16.7.1.1.9", &_names[1820],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1819], &_types[1815], NULLOT, &_types[1821] },
    { "filterOwner", "1.3.6.1.2.1.16.7.1.1.10", &_names[1821],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1791], &_types[1818], NULLOT, &_types[1822] },
    { "filterStatus", "1.3.6.1.2.1.16.7.1.1.11", &_names[1822],
      (OS) 98, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1818], &_types[1812], NULLOT, &_types[1823] },
    { "channelTable", "1.3.6.1.2.1.16.7.2", &_names[1823],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1810], NULLOT, &_types[1824], &_types[1824] },
    { "channelEntry", "1.3.6.1.2.1.16.7.2.1", &_names[1824],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "channelIndex", NULL, NULL,
      &_types[1811], NULLOT, &_types[1827], &_types[1825] },
    { "channelIndex", "1.3.6.1.2.1.16.7.2.1.1", &_names[1825],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1820], &_types[1826], NULLOT, &_types[1826] },
    { "channelIfIndex", "1.3.6.1.2.1.16.7.2.1.2", &_names[1826],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1825], &_types[1829], NULLOT, &_types[1827] },
    { "channelAcceptType", "1.3.6.1.2.1.16.7.2.1.3", &_names[1827],
      (OS) 99, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1824], &_types[1835], NULLOT, &_types[1828] },
    { "channelDataControl", "1.3.6.1.2.1.16.7.2.1.4", &_names[1828],
      (OS) 100, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1372], &_types[1832], NULLOT, &_types[1829] },
    { "channelTurnOnEventIndex", "1.3.6.1.2.1.16.7.2.1.5", &_names[1829],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1826], &_types[1830], NULLOT, &_types[1830] },
    { "channelTurnOffEventIndex", "1.3.6.1.2.1.16.7.2.1.6", &_names[1830],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1829], &_types[1831], NULLOT, &_types[1831] },
    { "channelEventIndex", "1.3.6.1.2.1.16.7.2.1.7", &_names[1831],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1830], &_types[1834], NULLOT, &_types[1832] },
    { "channelEventStatus", "1.3.6.1.2.1.16.7.2.1.8", &_names[1832],
      (OS) 101, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1822], &_types[1833], NULLOT, &_types[1833] },
    { "channelMatches", "1.3.6.1.2.1.16.7.2.1.9", &_names[1833],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1832], &_types[1836], NULLOT, &_types[1834] },
    { "channelDescription", "1.3.6.1.2.1.16.7.2.1.10", &_names[1834],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[1641], NULLOT, NULLOT, &_types[1835] },
    { "channelOwner", "1.3.6.1.2.1.16.7.2.1.11", &_names[1835],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1821], &_types[1828], NULLOT, &_types[1836] },
    { "channelStatus", "1.3.6.1.2.1.16.7.2.1.12", &_names[1836],
      (OS) 102, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1833], &_types[1825], NULLOT, &_types[1837] },
    { "capture", "1.3.6.1.2.1.16.8", &_names[1837],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1509], &_types[1641], &_types[1838], &_types[1838] },
    { "bufferControlTable", "1.3.6.1.2.1.16.8.1", &_names[1838],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1823], &_types[1853], &_types[1839], &_types[1839] },
    { "bufferControlEntry", "1.3.6.1.2.1.16.8.1.1", &_names[1839],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "bufferControlIndex", NULL, NULL,
      &_types[1827], NULLOT, &_types[1851], &_types[1840] },
    { "bufferControlIndex", "1.3.6.1.2.1.16.8.1.1.1", &_names[1840],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1831], &_types[1841], NULLOT, &_types[1841] },
    { "bufferControlChannelIndex", "1.3.6.1.2.1.16.8.1.1.2", &_names[1841],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1840], &_types[1847], NULLOT, &_types[1842] },
    { "bufferControlFullStatus", "1.3.6.1.2.1.16.8.1.1.3", &_names[1842],
      (OS) 103, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1836], &_types[1852], NULLOT, &_types[1843] },
    { "bufferControlFullAction", "1.3.6.1.2.1.16.8.1.1.4", &_names[1843],
      (OS) 104, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1834], NULLOT, NULLOT, &_types[1844] },
    { "bufferControlCaptureSliceSize", "1.3.6.1.2.1.16.8.1.1.5", &_names[1844],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1789], &_types[1845], NULLOT, &_types[1845] },
    { "bufferControlDownloadSliceSize", "1.3.6.1.2.1.16.8.1.1.6", &_names[1845],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1844], &_types[1842], NULLOT, &_types[1846] },
    { "bufferControlDownloadOffset", "1.3.6.1.2.1.16.8.1.1.7", &_names[1846],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1814], &_types[1843], NULLOT, &_types[1847] },
    { "bufferControlMaxOctetsRequested", "1.3.6.1.2.1.16.8.1.1.8", &_names[1847],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1727], &_types[1850], NULLOT, &_types[1848] },
    { "bufferControlMaxOctetsGranted", "1.3.6.1.2.1.16.8.1.1.9", &_names[1848],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1725], &_types[1849], NULLOT, &_types[1849] },
    { "bufferControlCapturedPackets", "1.3.6.1.2.1.16.8.1.1.10", &_names[1849],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1837], &_types[1846], NULLOT, &_types[1850] },
    { "bufferControlTurnOnTime", "1.3.6.1.2.1.16.8.1.1.11", &_names[1850],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1790], &_types[1848], NULLOT, &_types[1851] },
    { "bufferControlOwner", "1.3.6.1.2.1.16.8.1.1.12", &_names[1851],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1835], &_types[1844], NULLOT, &_types[1852] },
    { "bufferControlStatus", "1.3.6.1.2.1.16.8.1.1.13", &_names[1852],
      (OS) 105, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1842], &_types[1840], NULLOT, &_types[1853] },
    { "captureBufferTable", "1.3.6.1.2.1.16.8.2", &_names[1853],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1838], NULLOT, &_types[1854], &_types[1854] },
    { "captureBufferEntry", "1.3.6.1.2.1.16.8.2.1", &_names[1854],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "captureBufferControlIndex captureBufferIndex", NULL, NULL,
      &_types[1839], NULLOT, &_types[1857], &_types[1855] },
    { "captureBufferControlIndex", "1.3.6.1.2.1.16.8.2.1.1", &_names[1855],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1841], &_types[1856], NULLOT, &_types[1856] },
    { "captureBufferIndex", "1.3.6.1.2.1.16.8.2.1.2", &_names[1856],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1855], &_types[1860], NULLOT, &_types[1857] },
    { "captureBufferPacketID", "1.3.6.1.2.1.16.8.2.1.3", &_names[1857],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1845], &_types[1861], NULLOT, &_types[1858] },
    { "captureBufferPacketData", "1.3.6.1.2.1.16.8.2.1.4", &_names[1858],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1815], &_types[1859], NULLOT, &_types[1859] },
    { "captureBufferPacketLength", "1.3.6.1.2.1.16.8.2.1.5", &_names[1859],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1853], NULLOT, NULLOT, &_types[1860] },
    { "captureBufferPacketTime", "1.3.6.1.2.1.16.8.2.1.6", &_names[1860],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1850], &_types[1858], NULLOT, &_types[1861] },
    { "captureBufferPacketStatus", "1.3.6.1.2.1.16.8.2.1.7", &_names[1861],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1852], &_types[1855], NULLOT, &_types[1862] },
    { "event", "1.3.6.1.2.1.16.9", &_names[1862],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1566], &_types[1837], &_types[1863], &_types[1863] },
    { "eventTable", "1.3.6.1.2.1.16.9.1", &_names[1863],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1859], &_types[1872], &_types[1864], &_types[1864] },
    { "eventEntry", "1.3.6.1.2.1.16.9.1.1", &_names[1864],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "eventIndex", NULL, NULL,
      &_types[1854], NULLOT, &_types[1867], &_types[1865] },
    { "eventIndex", "1.3.6.1.2.1.16.9.1.1.1", &_names[1865],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1856], &_types[1869], NULLOT, &_types[1866] },
    { "eventDescription", "1.3.6.1.2.1.16.9.1.1.2", &_names[1866],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[1843], NULLOT, NULLOT, &_types[1867] },
    { "eventType", "1.3.6.1.2.1.16.9.1.1.3", &_names[1867],
      (OS) 106, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1864], &_types[1870], NULLOT, &_types[1868] },
    { "eventCommunity", "1.3.6.1.2.1.16.9.1.1.4", &_names[1868],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[1804], &_types[1871], NULLOT, &_types[1869] },
    { "eventLastTimeSent", "1.3.6.1.2.1.16.9.1.1.5", &_names[1869],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1565], &_types[1866], NULLOT, &_types[1870] },
    { "eventOwner", "1.3.6.1.2.1.16.9.1.1.6", &_names[1870],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1851], &_types[1868], NULLOT, &_types[1871] },
    { "eventStatus", "1.3.6.1.2.1.16.9.1.1.7", &_names[1871],
      (OS) 107, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1861], &_types[1865], NULLOT, &_types[1872] },
    { "logTable", "1.3.6.1.2.1.16.9.2", &_names[1872],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1863], NULLOT, &_types[1873], &_types[1873] },
    { "logEntry", "1.3.6.1.2.1.16.9.2.1", &_names[1873],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "logEventIndex logIndex", NULL, NULL,
      &_types[1867], NULLOT, &_types[1874], &_types[1874] },
    { "logEventIndex", "1.3.6.1.2.1.16.9.2.1.1", &_names[1874],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1865], &_types[1875], NULLOT, &_types[1875] },
    { "logIndex", "1.3.6.1.2.1.16.9.2.1.2", &_names[1875],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1874], &_types[1876], NULLOT, &_types[1876] },
    { "logTime", "1.3.6.1.2.1.16.9.2.1.3", &_names[1876],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1860], &_types[1877], NULLOT, &_types[1877] },
    { "logDescription", "1.3.6.1.2.1.16.9.2.1.4", &_names[1877],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1866], NULLOT, NULLOT, &_types[1878] },
    { "tokenRing", "1.3.6.1.2.1.16.10", &_names[1878],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1858], &_types[1717], &_types[1879], &_types[1879] },
    { "ringStationControlTable", "1.3.6.1.2.1.16.10.1", &_names[1879],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1697], &_types[1891], &_types[1880], &_types[1880] },
    { "ringStationControlEntry", "1.3.6.1.2.1.16.10.1.1", &_names[1880],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ringStationControlIfIndex", NULL, NULL,
      &_types[1698], NULLOT, &_types[1889], &_types[1881] },
    { "ringStationControlIfIndex", "1.3.6.1.2.1.16.10.1.1.1", &_names[1881],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1700], &_types[1885], NULLOT, &_types[1882] },
    { "ringStationControlTableSize", "1.3.6.1.2.1.16.10.1.1.2", &_names[1882],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1857], &_types[1883], NULLOT, &_types[1883] },
    { "ringStationControlActiveStations", "1.3.6.1.2.1.16.10.1.1.3", &_names[1883],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1716], &_types[1884], NULLOT, &_types[1884] },
    { "ringStationControlRingState", "1.3.6.1.2.1.16.10.1.1.4", &_names[1884],
      (OS) 110, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1883], &_types[1890], NULLOT, &_types[1885] },
    { "ringStationControlBeaconSender", "1.3.6.1.2.1.16.10.1.1.5", &_names[1885],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1683], &_types[1888], NULLOT, &_types[1886] },
    { "ringStationControlBeaconNAUN", "1.3.6.1.2.1.16.10.1.1.6", &_names[1886],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1765], &_types[1887], NULLOT, &_types[1887] },
    { "ringStationControlActiveMonitor", "1.3.6.1.2.1.16.10.1.1.7", &_names[1887],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1732], NULLOT, NULLOT, &_types[1888] },
    { "ringStationControlOrderChanges", "1.3.6.1.2.1.16.10.1.1.8", &_names[1888],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1885], &_types[1886], NULLOT, &_types[1889] },
    { "ringStationControlOwner", "1.3.6.1.2.1.16.10.1.1.9", &_names[1889],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1639], &_types[1882], NULLOT, &_types[1890] },
    { "ringStationControlStatus", "1.3.6.1.2.1.16.10.1.1.10", &_names[1890],
      (OS) 111, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1884], &_types[1881], NULLOT, &_types[1891] },
    { "ringStationTable", "1.3.6.1.2.1.16.10.2", &_names[1891],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1879], &_types[1915], &_types[1892], &_types[1892] },
    { "ringStationEntry", "1.3.6.1.2.1.16.10.2.1", &_names[1892],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ringStationIfIndex ringStationMacAddress", NULL, NULL,
      &_types[1880], NULLOT, &_types[1900], &_types[1893] },
    { "ringStationIfIndex", "1.3.6.1.2.1.16.10.2.1.1", &_names[1893],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1881], &_types[1897], NULLOT, &_types[1894] },
    { "ringStationMacAddress", "1.3.6.1.2.1.16.10.2.1.2", &_names[1894],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1868], &_types[1899], NULLOT, &_types[1895] },
    { "ringStationLastNAUN", "1.3.6.1.2.1.16.10.2.1.3", &_names[1895],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1886], &_types[1914], NULLOT, &_types[1896] },
    { "ringStationStationStatus", "1.3.6.1.2.1.16.10.2.1.4", &_names[1896],
      (OS) 112, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1890], &_types[1893], NULLOT, &_types[1897] },
    { "ringStationLastEnterTime", "1.3.6.1.2.1.16.10.2.1.5", &_names[1897],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1679], &_types[1898], NULLOT, &_types[1898] },
    { "ringStationLastExitTime", "1.3.6.1.2.1.16.10.2.1.6", &_names[1898],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1897], &_types[1895], NULLOT, &_types[1899] },
    { "ringStationDuplicateAddresses", "1.3.6.1.2.1.16.10.2.1.7", &_names[1899],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1894], &_types[1896], NULLOT, &_types[1900] },
    { "ringStationInLineErrors", "1.3.6.1.2.1.16.10.2.1.8", &_names[1900],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1693], &_types[1901], NULLOT, &_types[1901] },
    { "ringStationOutLineErrors", "1.3.6.1.2.1.16.10.2.1.9", &_names[1901],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1900], &_types[1902], NULLOT, &_types[1902] },
    { "ringStationInternalErrors", "1.3.6.1.2.1.16.10.2.1.10", &_names[1902],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1901], &_types[1903], NULLOT, &_types[1903] },
    { "ringStationInBurstErrors", "1.3.6.1.2.1.16.10.2.1.11", &_names[1903],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1902], &_types[1904], NULLOT, &_types[1904] },
    { "ringStationOutBurstErrors", "1.3.6.1.2.1.16.10.2.1.12", &_names[1904],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1903], &_types[1905], NULLOT, &_types[1905] },
    { "ringStationACErrors", "1.3.6.1.2.1.16.10.2.1.13", &_names[1905],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1904], &_types[1906], NULLOT, &_types[1906] },
    { "ringStationAbortErrors", "1.3.6.1.2.1.16.10.2.1.14", &_names[1906],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1905], &_types[1907], NULLOT, &_types[1907] },
    { "ringStationLostFrameErrors", "1.3.6.1.2.1.16.10.2.1.15", &_names[1907],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1906], &_types[1908], NULLOT, &_types[1908] },
    { "ringStationCongestionErrors", "1.3.6.1.2.1.16.10.2.1.16", &_names[1908],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1907], &_types[1909], NULLOT, &_types[1909] },
    { "ringStationFrameCopiedErrors", "1.3.6.1.2.1.16.10.2.1.17", &_names[1909],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1908], &_types[1910], NULLOT, &_types[1910] },
    { "ringStationFrequencyErrors", "1.3.6.1.2.1.16.10.2.1.18", &_names[1910],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1909], &_types[1911], NULLOT, &_types[1911] },
    { "ringStationTokenErrors", "1.3.6.1.2.1.16.10.2.1.19", &_names[1911],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1910], &_types[1912], NULLOT, &_types[1912] },
    { "ringStationInBeaconErrors", "1.3.6.1.2.1.16.10.2.1.20", &_names[1912],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1911], &_types[1913], NULLOT, &_types[1913] },
    { "ringStationOutBeaconErrors", "1.3.6.1.2.1.16.10.2.1.21", &_names[1913],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1912], &_types[1894], NULLOT, &_types[1914] },
    { "ringStationInsertions", "1.3.6.1.2.1.16.10.2.1.22", &_names[1914],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1895], NULLOT, NULLOT, &_types[1915] },
    { "ringStationOrderTable", "1.3.6.1.2.1.16.10.3", &_names[1915],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1891], &_types[1920], &_types[1916], &_types[1916] },
    { "ringStationOrderEntry", "1.3.6.1.2.1.16.10.3.1", &_names[1916],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ringStationOrderIfIndex ringStationOrderOrderIndex", NULL, NULL,
      &_types[1892], NULLOT, &_types[1919], &_types[1917] },
    { "ringStationOrderIfIndex", "1.3.6.1.2.1.16.10.3.1.1", &_names[1917],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1893], &_types[1918], NULLOT, &_types[1918] },
    { "ringStationOrderOrderIndex", "1.3.6.1.2.1.16.10.3.1.2", &_names[1918],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1917], NULLOT, NULLOT, &_types[1919] },
    { "ringStationOrderMacAddress", "1.3.6.1.2.1.16.10.3.1.3", &_names[1919],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1899], &_types[1917], NULLOT, &_types[1920] },
    { "ringStationConfigControlTable", "1.3.6.1.2.1.16.10.4", &_names[1920],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1915], &_types[1926], &_types[1921], &_types[1921] },
    { "ringStationConfigControlEntry", "1.3.6.1.2.1.16.10.4.1", &_names[1921],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ringStationConfigControlIfIndex ringStationConfigControlMacAddress", NULL, NULL,
      &_types[1916], NULLOT, &_types[1923], &_types[1922] },
    { "ringStationConfigControlIfIndex", "1.3.6.1.2.1.16.10.4.1.1", &_names[1922],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1918], &_types[1924], NULLOT, &_types[1923] },
    { "ringStationConfigControlMacAddress", "1.3.6.1.2.1.16.10.4.1.2", &_names[1923],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1919], &_types[1925], NULLOT, &_types[1924] },
    { "ringStationConfigControlRemove", "1.3.6.1.2.1.16.10.4.1.3", &_names[1924],
      (OS) 113, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1771], NULLOT, NULLOT, &_types[1925] },
    { "ringStationConfigControlUpdateStats", "1.3.6.1.2.1.16.10.4.1.4", &_names[1925],
      (OS) 114, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1896], &_types[1922], NULLOT, &_types[1926] },
    { "ringStationConfigTable", "1.3.6.1.2.1.16.10.5", &_names[1926],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1920], &_types[1935], &_types[1927], &_types[1927] },
    { "ringStationConfigEntry", "1.3.6.1.2.1.16.10.5.1", &_names[1927],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ringStationConfigIfIndex ringStationConfigMacAddress", NULL, NULL,
      &_types[1921], NULLOT, &_types[1929], &_types[1928] },
    { "ringStationConfigIfIndex", "1.3.6.1.2.1.16.10.5.1.1", &_names[1928],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1922], &_types[1930], NULLOT, &_types[1929] },
    { "ringStationConfigMacAddress", "1.3.6.1.2.1.16.10.5.1.2", &_names[1929],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1923], &_types[1933], NULLOT, &_types[1930] },
    { "ringStationConfigUpdateTime", "1.3.6.1.2.1.16.10.5.1.3", &_names[1930],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1898], &_types[1932], NULLOT, &_types[1931] },
    { "ringStationConfigLocation", "1.3.6.1.2.1.16.10.5.1.4", &_names[1931],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[1925], &_types[1928], NULLOT, &_types[1932] },
    { "ringStationConfigMicrocode", "1.3.6.1.2.1.16.10.5.1.5", &_names[1932],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 10, 10,
      NULL, NULL, NULL,
      &_types[1290], NULLOT, NULLOT, &_types[1933] },
    { "ringStationConfigGroupAddress", "1.3.6.1.2.1.16.10.5.1.6", &_names[1933],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[1929], &_types[1934], NULLOT, &_types[1934] },
    { "ringStationConfigFunctionalAddress", "1.3.6.1.2.1.16.10.5.1.7", &_names[1934],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 4, 4,
      NULL, NULL, NULL,
      &_types[1933], &_types[1931], NULLOT, &_types[1935] },
    { "sourceRoutingStatsTable", "1.3.6.1.2.1.16.10.6", &_names[1935],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1926], NULLOT, &_types[1936], &_types[1936] },
    { "sourceRoutingStatsEntry", "1.3.6.1.2.1.16.10.6.1", &_names[1936],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "sourceRoutingStatsIfIndex", NULL, NULL,
      &_types[1927], NULLOT, &_types[1938], &_types[1937] },
    { "sourceRoutingStatsIfIndex", "1.3.6.1.2.1.16.10.6.1.1", &_names[1937],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1928], &_types[1939], NULLOT, &_types[1938] },
    { "sourceRoutingStatsRingNumber", "1.3.6.1.2.1.16.10.6.1.2", &_names[1938],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1889], &_types[1959], NULLOT, &_types[1939] },
    { "sourceRoutingStatsInFrames", "1.3.6.1.2.1.16.10.6.1.3", &_names[1939],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1935], &_types[1940], NULLOT, &_types[1940] },
    { "sourceRoutingStatsOutFrames", "1.3.6.1.2.1.16.10.6.1.4", &_names[1940],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1939], &_types[1941], NULLOT, &_types[1941] },
    { "sourceRoutingStatsThroughFrames", "1.3.6.1.2.1.16.10.6.1.5", &_names[1941],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1940], &_types[1942], NULLOT, &_types[1942] },
    { "sourceRoutingStatsAllRoutesBroadcastFrames", "1.3.6.1.2.1.16.10.6.1.6", &_names[1942],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1941], &_types[1943], NULLOT, &_types[1943] },
    { "sourceRoutingStatsSingleRouteBroadcastFrames", "1.3.6.1.2.1.16.10.6.1.7", &_names[1943],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1942], &_types[1949], NULLOT, &_types[1944] },
    { "sourceRoutingStatsInOctets", "1.3.6.1.2.1.16.10.6.1.8", &_names[1944],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1931], &_types[1945], NULLOT, &_types[1945] },
    { "sourceRoutingStatsOutOctets", "1.3.6.1.2.1.16.10.6.1.9", &_names[1945],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1944], &_types[1946], NULLOT, &_types[1946] },
    { "sourceRoutingStatsThroughOctets", "1.3.6.1.2.1.16.10.6.1.10", &_names[1946],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1945], &_types[1947], NULLOT, &_types[1947] },
    { "sourceRoutingStatsAllRoutesBroadcastOctets", "1.3.6.1.2.1.16.10.6.1.11", &_names[1947],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1946], &_types[1948], NULLOT, &_types[1948] },
    { "sourceRoutingStatsSingleRoutesBroadcastOctets", "1.3.6.1.2.1.16.10.6.1.12", &_names[1948],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1947], &_types[1960], NULLOT, &_types[1949] },
    { "sourceRoutingStatsLocalLLCFrames", "1.3.6.1.2.1.16.10.6.1.13", &_names[1949],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1943], &_types[1950], NULLOT, &_types[1950] },
    { "sourceRoutingStats1HopFrames", "1.3.6.1.2.1.16.10.6.1.14", &_names[1950],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1949], &_types[1951], NULLOT, &_types[1951] },
    { "sourceRoutingStats2HopsFrames", "1.3.6.1.2.1.16.10.6.1.15", &_names[1951],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1950], &_types[1952], NULLOT, &_types[1952] },
    { "sourceRoutingStats3HopsFrames", "1.3.6.1.2.1.16.10.6.1.16", &_names[1952],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1951], &_types[1953], NULLOT, &_types[1953] },
    { "sourceRoutingStats4HopsFrames", "1.3.6.1.2.1.16.10.6.1.17", &_names[1953],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1952], &_types[1954], NULLOT, &_types[1954] },
    { "sourceRoutingStats5HopsFrames", "1.3.6.1.2.1.16.10.6.1.18", &_names[1954],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1953], &_types[1955], NULLOT, &_types[1955] },
    { "sourceRoutingStats6HopsFrames", "1.3.6.1.2.1.16.10.6.1.19", &_names[1955],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1954], &_types[1956], NULLOT, &_types[1956] },
    { "sourceRoutingStats7HopsFrames", "1.3.6.1.2.1.16.10.6.1.20", &_names[1956],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1955], &_types[1957], NULLOT, &_types[1957] },
    { "sourceRoutingStats8HopsFrames", "1.3.6.1.2.1.16.10.6.1.21", &_names[1957],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1956], &_types[1958], NULLOT, &_types[1958] },
    { "sourceRoutingStatsMoreThan8HopsFrames", "1.3.6.1.2.1.16.10.6.1.22", &_names[1958],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1957], NULLOT, NULLOT, &_types[1959] },
    { "sourceRoutingStatsOwner", "1.3.6.1.2.1.16.10.6.1.23", &_names[1959],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1938], &_types[1944], NULLOT, &_types[1960] },
    { "sourceRoutingStatsStatus", "1.3.6.1.2.1.16.10.6.1.24", &_names[1960],
      (OS) 115, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1948], &_types[1937], NULLOT, &_types[1961] },
    { "dot1dBridge", "1.3.6.1.2.1.17", &_names[1961],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1706], &_types[2394], &_types[2044], &_types[1962] },
    { "dot1dBase", "1.3.6.1.2.1.17.1", &_names[1962],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1702], &_types[2022], &_types[1964], &_types[1963] },
    { "dot1dBaseBridgeAddress", "1.3.6.1.2.1.17.1.1", &_names[1963],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1934], &_types[1966], NULLOT, &_types[1964] },
    { "dot1dBaseNumPorts", "1.3.6.1.2.1.17.1.2", &_names[1964],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1550], &_types[1965], NULLOT, &_types[1965] },
    { "dot1dBaseType", "1.3.6.1.2.1.17.1.3", &_names[1965],
      (OS) 116, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1936], &_types[1963], NULLOT, &_types[1966] },
    { "dot1dBasePortTable", "1.3.6.1.2.1.17.1.4", &_names[1966],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1958], NULLOT, &_types[1967], &_types[1967] },
    { "dot1dBasePortEntry", "1.3.6.1.2.1.17.1.4.1", &_names[1967],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dBasePort", NULL, NULL,
      &_types[1965], NULLOT, &_types[1969], &_types[1968] },
    { "dot1dBasePort", "1.3.6.1.2.1.17.1.4.1.1", &_names[1968],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1964], &_types[1971], NULLOT, &_types[1969] },
    { "dot1dBasePortIfIndex", "1.3.6.1.2.1.17.1.4.1.2", &_names[1969],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1937], &_types[1968], NULLOT, &_types[1970] },
    { "dot1dBasePortCircuit", "1.3.6.1.2.1.17.1.4.1.3", &_names[1970],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1887], NULLOT, NULLOT, &_types[1971] },
    { "dot1dBasePortDelayExceededDiscards", "1.3.6.1.2.1.17.1.4.1.4", &_names[1971],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1914], &_types[1972], NULLOT, &_types[1972] },
    { "dot1dBasePortMtuExceededDiscards", "1.3.6.1.2.1.17.1.4.1.5", &_names[1972],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1971], &_types[1970], NULLOT, &_types[1973] },
    { "dot1dStp", "1.3.6.1.2.1.17.2", &_names[1973],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1721], &_types[2037], &_types[1984], &_types[1974] },
    { "dot1dStpProtocolSpecification", "1.3.6.1.2.1.17.2.1", &_names[1974],
      (OS) 117, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[39], NULLOT, NULLOT, &_types[1975] },
    { "dot1dStpPriority", "1.3.6.1.2.1.17.2.2", &_names[1975],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1722], &_types[1979], NULLOT, &_types[1976] },
    { "dot1dStpTimeSinceTopologyChange", "1.3.6.1.2.1.17.2.3", &_names[1976],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1888], &_types[1977], NULLOT, &_types[1977] },
    { "dot1dStpTopChanges", "1.3.6.1.2.1.17.2.4", &_names[1977],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1976], &_types[1982], NULLOT, &_types[1978] },
    { "dot1dStpDesignatedRoot", "1.3.6.1.2.1.17.2.5", &_names[1978],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1849], &_types[1974], NULLOT, &_types[1979] },
    { "dot1dStpRootCost", "1.3.6.1.2.1.17.2.6", &_names[1979],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1975], &_types[1981], NULLOT, &_types[1980] },
    { "dot1dStpRootPort", "1.3.6.1.2.1.17.2.7", &_names[1980],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1968], &_types[1978], NULLOT, &_types[1981] },
    { "dot1dStpMaxAge", "1.3.6.1.2.1.17.2.8", &_names[1981],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1969], &_types[1985], NULLOT, &_types[1982] },
    { "dot1dStpHelloTime", "1.3.6.1.2.1.17.2.9", &_names[1982],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1930], &_types[1983], NULLOT, &_types[1983] },
    { "dot1dStpHoldTime", "1.3.6.1.2.1.17.2.10", &_names[1983],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1982], &_types[1986], NULLOT, &_types[1984] },
    { "dot1dStpForwardDelay", "1.3.6.1.2.1.17.2.11", &_names[1984],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1967], &_types[1987], NULLOT, &_types[1985] },
    { "dot1dStpBridgeMaxAge", "1.3.6.1.2.1.17.2.12", &_names[1985],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1981], &_types[1976], NULLOT, &_types[1986] },
    { "dot1dStpBridgeHelloTime", "1.3.6.1.2.1.17.2.13", &_names[1986],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1983], &_types[1988], NULLOT, &_types[1987] },
    { "dot1dStpBridgeForwardDelay", "1.3.6.1.2.1.17.2.14", &_names[1987],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1984], &_types[1975], NULLOT, &_types[1988] },
    { "dot1dStpPortTable", "1.3.6.1.2.1.17.2.15", &_names[1988],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1966], &_types[1980], &_types[1989], &_types[1989] },
    { "dot1dStpPortEntry", "1.3.6.1.2.1.17.2.15.1", &_names[1989],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dStpPort", NULL, NULL,
      &_types[1987], NULLOT, &_types[1991], &_types[1990] },
    { "dot1dStpPort", "1.3.6.1.2.1.17.2.15.1.1", &_names[1990],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1980], &_types[1998], NULLOT, &_types[1991] },
    { "dot1dStpPortPriority", "1.3.6.1.2.1.17.2.15.1.2", &_names[1991],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1979], &_types[1994], NULLOT, &_types[1992] },
    { "dot1dStpPortState", "1.3.6.1.2.1.17.2.15.1.3", &_names[1992],
      (OS) 118, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2037], &_types[1997], NULLOT, &_types[1993] },
    { "dot1dStpPortEnable", "1.3.6.1.2.1.17.2.15.1.4", &_names[1993],
      (OS) 119, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1986], &_types[1990], NULLOT, &_types[1994] },
    { "dot1dStpPortPathCost", "1.3.6.1.2.1.17.2.15.1.5", &_names[1994],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1991], &_types[1996], NULLOT, &_types[1995] },
    { "dot1dStpPortDesignatedRoot", "1.3.6.1.2.1.17.2.15.1.6", &_names[1995],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1978], &_types[1999], NULLOT, &_types[1996] },
    { "dot1dStpPortDesignatedCost", "1.3.6.1.2.1.17.2.15.1.7", &_names[1996],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1994], &_types[1992], NULLOT, &_types[1997] },
    { "dot1dStpPortDesignatedBridge", "1.3.6.1.2.1.17.2.15.1.8", &_names[1997],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[1961], &_types[1993], NULLOT, &_types[1998] },
    { "dot1dStpPortDesignatedPort", "1.3.6.1.2.1.17.2.15.1.9", &_names[1998],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[1990], &_types[1995], NULLOT, &_types[1999] },
    { "dot1dStpPortForwardTransitions", "1.3.6.1.2.1.17.2.15.1.10", &_names[1999],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1313], NULLOT, NULLOT, &_types[2000] },
    { "dot1dSr", "1.3.6.1.2.1.17.3", &_names[2000],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[1973], &_types[2021], &_types[2001] },
    { "dot1dSrPortTable", "1.3.6.1.2.1.17.3.1", &_names[2001],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2038], NULLOT, &_types[2002], &_types[2002] },
    { "dot1dSrPortEntry", "1.3.6.1.2.1.17.3.1.1", &_names[2002],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dSrPort", NULL, NULL,
      &_types[2039], NULLOT, &_types[2004], &_types[2003] },
    { "dot1dSrPort", "1.3.6.1.2.1.17.3.1.1.1", &_names[2003],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2041], &_types[2016], NULLOT, &_types[2004] },
    { "dot1dSrPortHopCount", "1.3.6.1.2.1.17.3.1.1.2", &_names[2004],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1809], &_types[2006], NULLOT, &_types[2005] },
    { "dot1dSrPortLocalSegment", "1.3.6.1.2.1.17.3.1.1.3", &_names[2005],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2001], &_types[2007], NULLOT, &_types[2006] },
    { "dot1dSrPortBridgeNum", "1.3.6.1.2.1.17.3.1.1.4", &_names[2006],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1959], &_types[2019], NULLOT, &_types[2007] },
    { "dot1dSrPortTargetSegment", "1.3.6.1.2.1.17.3.1.1.5", &_names[2007],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2005], &_types[2008], NULLOT, &_types[2008] },
    { "dot1dSrPortLargestFrame", "1.3.6.1.2.1.17.3.1.1.6", &_names[2008],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2007], &_types[2010], NULLOT, &_types[2009] },
    { "dot1dSrPortSTESpanMode", "1.3.6.1.2.1.17.3.1.1.7", &_names[2009],
      (OS) 122, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1828], &_types[2020], NULLOT, &_types[2010] },
    { "dot1dSrPortSpecInFrames", "1.3.6.1.2.1.17.3.1.1.8", &_names[2010],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2008], &_types[2011], NULLOT, &_types[2011] },
    { "dot1dSrPortSpecOutFrames", "1.3.6.1.2.1.17.3.1.1.9", &_names[2011],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2010], &_types[2012], NULLOT, &_types[2012] },
    { "dot1dSrPortApeInFrames", "1.3.6.1.2.1.17.3.1.1.10", &_names[2012],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2011], &_types[2013], NULLOT, &_types[2013] },
    { "dot1dSrPortApeOutFrames", "1.3.6.1.2.1.17.3.1.1.11", &_names[2013],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2012], &_types[2014], NULLOT, &_types[2014] },
    { "dot1dSrPortSteInFrames", "1.3.6.1.2.1.17.3.1.1.12", &_names[2014],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2013], &_types[2015], NULLOT, &_types[2015] },
    { "dot1dSrPortSteOutFrames", "1.3.6.1.2.1.17.3.1.1.13", &_names[2015],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2014], &_types[2003], NULLOT, &_types[2016] },
    { "dot1dSrPortSegmentMismatchDiscards", "1.3.6.1.2.1.17.3.1.1.14", &_names[2016],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2036], &_types[2017], NULLOT, &_types[2017] },
    { "dot1dSrPortDuplicateSegmentDiscards", "1.3.6.1.2.1.17.3.1.1.15", &_names[2017],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2016], &_types[2018], NULLOT, &_types[2018] },
    { "dot1dSrPortHopCountExceededDiscards", "1.3.6.1.2.1.17.3.1.1.16", &_names[2018],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2017], NULLOT, NULLOT, &_types[2019] },
    { "dot1dSrPortDupLanIdOrTreeErrors", "1.3.6.1.2.1.17.3.1.1.17", &_names[2019],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1913], &_types[2009], NULLOT, &_types[2020] },
    { "dot1dSrPortLanIdMismatches", "1.3.6.1.2.1.17.3.1.1.18", &_names[2020],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1878], &_types[2005], NULLOT, &_types[2021] },
    { "dot1dSrBridgeLfMode", "1.3.6.1.2.1.17.3.2", &_names[2021],
      (OS) 123, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2009], &_types[2001], NULLOT, &_types[2022] },
    { "dot1dTp", "1.3.6.1.2.1.17.4", &_names[2022],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2985], &_types[2000], &_types[2023], &_types[2023] },
    { "dot1dTpLearnedEntryDiscards", "1.3.6.1.2.1.17.4.1", &_names[2023],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1972], &_types[2024], NULLOT, &_types[2024] },
    { "dot1dTpAgingTime", "1.3.6.1.2.1.17.4.2", &_names[2024],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 10, 1000000,
      NULL, NULL, NULL,
      &_types[1993], &_types[2025], NULLOT, &_types[2025] },
    { "dot1dTpFdbTable", "1.3.6.1.2.1.17.4.3", &_names[2025],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1988], &_types[2030], &_types[2026], &_types[2026] },
    { "dot1dTpFdbEntry", "1.3.6.1.2.1.17.4.3.1", &_names[2026],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dTpFdbAddress", NULL, NULL,
      &_types[1989], NULLOT, &_types[2027], &_types[2027] },
    { "dot1dTpFdbAddress", "1.3.6.1.2.1.17.4.3.1.1", &_names[2027],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[1963], &_types[2029], NULLOT, &_types[2028] },
    { "dot1dTpFdbPort", "1.3.6.1.2.1.17.4.3.1.2", &_names[2028],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1998], NULLOT, NULLOT, &_types[2029] },
    { "dot1dTpFdbStatus", "1.3.6.1.2.1.17.4.3.1.3", &_names[2029],
      (OS) 120, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1992], &_types[2028], NULLOT, &_types[2030] },
    { "dot1dTpPortTable", "1.3.6.1.2.1.17.4.4", &_names[2030],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2025], NULLOT, &_types[2031], &_types[2031] },
    { "dot1dTpPortEntry", "1.3.6.1.2.1.17.4.4.1", &_names[2031],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dTpPort", NULL, NULL,
      &_types[2026], NULLOT, &_types[2033], &_types[2032] },
    { "dot1dTpPort", "1.3.6.1.2.1.17.4.4.1.1", &_names[2032],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2028], &_types[2036], NULLOT, &_types[2033] },
    { "dot1dTpPortMaxInfo", "1.3.6.1.2.1.17.4.4.1.2", &_names[2033],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2027], &_types[2034], NULLOT, &_types[2034] },
    { "dot1dTpPortInFrames", "1.3.6.1.2.1.17.4.4.1.3", &_names[2034],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2030], &_types[2035], NULLOT, &_types[2035] },
    { "dot1dTpPortOutFrames", "1.3.6.1.2.1.17.4.4.1.4", &_names[2035],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2034], &_types[2032], NULLOT, &_types[2036] },
    { "dot1dTpPortInDiscards", "1.3.6.1.2.1.17.4.4.1.5", &_names[2036],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2023], NULLOT, NULLOT, &_types[2037] },
    { "dot1dStatic", "1.3.6.1.2.1.17.5", &_names[2037],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1960], NULLOT, &_types[2038], &_types[2038] },
    { "dot1dStaticTable", "1.3.6.1.2.1.17.5.1", &_names[2038],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2035], NULLOT, &_types[2039], &_types[2039] },
    { "dot1dStaticEntry", "1.3.6.1.2.1.17.5.1.1", &_names[2039],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dStaticAddress dot1dStaticReceivePort", NULL, NULL,
      &_types[2031], NULLOT, &_types[2040], &_types[2040] },
    { "dot1dStaticAddress", "1.3.6.1.2.1.17.5.1.1.1", &_names[2040],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[2033], &_types[2043], NULLOT, &_types[2041] },
    { "dot1dStaticReceivePort", "1.3.6.1.2.1.17.5.1.1.2", &_names[2041],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2032], &_types[2042], NULLOT, &_types[2042] },
    { "dot1dStaticAllowedToGoTo", "1.3.6.1.2.1.17.5.1.1.3", &_names[2042],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1532], NULLOT, NULLOT, &_types[2043] },
    { "dot1dStaticStatus", "1.3.6.1.2.1.17.5.1.1.4", &_names[2043],
      (OS) 121, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2029], &_types[2041], NULLOT, &_types[2044] },
    { "dot1dPortPair", "1.3.6.1.2.1.17.10", &_names[2044],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2024], &_types[1962], &_types[2046], &_types[2045] },
    { "dot1dPortPairTableSize", "1.3.6.1.2.1.17.10.1", &_names[2045],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1882], NULLOT, NULLOT, &_types[2046] },
    { "dot1dPortPairTable", "1.3.6.1.2.1.17.10.2", &_names[2046],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2015], &_types[2045], &_types[2047], &_types[2047] },
    { "dot1dPortPairEntry", "1.3.6.1.2.1.17.10.2.1", &_names[2047],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "dot1dPortPairLowPort dot1dPortPairHighPort", NULL, NULL,
      &_types[2002], NULLOT, &_types[2050], &_types[2048] },
    { "dot1dPortPairLowPort", "1.3.6.1.2.1.17.10.2.1.1", &_names[2048],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2003], &_types[2049], NULLOT, &_types[2049] },
    { "dot1dPortPairHighPort", "1.3.6.1.2.1.17.10.2.1.2", &_names[2049],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2048], NULLOT, NULLOT, &_types[2050] },
    { "dot1dPortPairBridgeNum", "1.3.6.1.2.1.17.10.2.1.3", &_names[2050],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2006], &_types[2051], NULLOT, &_types[2051] },
    { "dot1dPortPairBridgeState", "1.3.6.1.2.1.17.10.2.1.4", &_names[2051],
      (OS) 124, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2043], &_types[2048], NULLOT, &_types[2052] },
    { "phiv", "1.3.6.1.2.1.18", &_names[2052],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[134], &_types[2423], &_types[2255], &_types[2053] },
    { "phivSystem", "1.3.6.1.2.1.18.1", &_names[2053],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1324], &_types[2127], &_types[2054], &_types[2054] },
    { "phivSystemState", "1.3.6.1.2.1.18.1.1", &_names[2054],
      (OS) 125, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2051], &_types[2055], NULLOT, &_types[2055] },
    { "phivExecIdent", "1.3.6.1.2.1.18.1.2", &_names[2055],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 32,
      NULL, NULL, NULL,
      &_types[1667], NULLOT, NULLOT, &_types[2056] },
    { "phivManagement", "1.3.6.1.2.1.18.2", &_names[2056],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1924], &_types[2202], &_types[2057], &_types[2057] },
    { "phivMgmtMgmtVers", "1.3.6.1.2.1.18.2.1", &_names[2057],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1563], NULLOT, NULLOT, &_types[2058] },
    { "session", "1.3.6.1.2.1.18.3", &_names[2058],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2040], &_types[2062], &_types[2059], &_types[2059] },
    { "phivSessionSystemName", "1.3.6.1.2.1.18.3.1", &_names[2059],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 6,
      NULL, NULL, NULL,
      &_types[2056], &_types[2060], NULLOT, &_types[2060] },
    { "phivSessionInTimer", "1.3.6.1.2.1.18.3.2", &_names[2060],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2094], &_types[2061], NULLOT, &_types[2061] },
    { "phivSessionOutTimer", "1.3.6.1.2.1.18.3.3", &_names[2061],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2060], NULLOT, NULLOT, &_types[2062] },
    { "end", "1.3.6.1.2.1.18.4", &_names[2062],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1555], &_types[2056], &_types[2090], &_types[2063] },
    { "phivEndRemoteTable", "1.3.6.1.2.1.18.4.1", &_names[2063],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2046], &_types[2070], &_types[2064], &_types[2064] },
    { "phivEndRemoteEntry", "1.3.6.1.2.1.18.4.1.1", &_names[2064],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivEndRemoteHostNodeID", NULL, NULL,
      &_types[2047], NULLOT, &_types[2069], &_types[2065] },
    { "phivEndRemoteHostNodeID", "1.3.6.1.2.1.18.4.1.1.1", &_names[2065],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2045], &_types[2066], NULLOT, &_types[2066] },
    { "phivEndRemoteState", "1.3.6.1.2.1.18.4.1.1.2", &_names[2066],
      (OS) 126, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2054], &_types[2067], NULLOT, &_types[2067] },
    { "phivEndCircuitIndex", "1.3.6.1.2.1.18.4.1.1.3", &_names[2067],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1985], &_types[2068], NULLOT, &_types[2068] },
    { "phivEndActiveLinks", "1.3.6.1.2.1.18.4.1.1.4", &_names[2068],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2268], NULLOT, NULLOT, &_types[2069] },
    { "phivEndDelay", "1.3.6.1.2.1.18.4.1.1.5", &_names[2069],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2064], &_types[2065], NULLOT, &_types[2070] },
    { "phivEndCountTable", "1.3.6.1.2.1.18.4.2", &_names[2070],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2063], &_types[2086], &_types[2071], &_types[2071] },
    { "phivEndCountEntry", "1.3.6.1.2.1.18.4.2.1", &_names[2071],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivEndCountHostNodeID", NULL, NULL,
      &_types[2069], NULLOT, &_types[2073], &_types[2072] },
    { "phivEndCountHostNodeID", "1.3.6.1.2.1.18.4.2.1.1", &_names[2072],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2065], &_types[2075], NULLOT, &_types[2073] },
    { "phivEndCountSecsLastZeroed", "1.3.6.1.2.1.18.4.2.1.2", &_names[2073],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2233], &_types[2085], NULLOT, &_types[2074] },
    { "phivEndCountUsrBytesRec", "1.3.6.1.2.1.18.4.2.1.3", &_names[2074],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1560], &_types[2076], NULLOT, &_types[2075] },
    { "phivEndCountUsrBytesSent", "1.3.6.1.2.1.18.4.2.1.4", &_names[2075],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1977], &_types[2077], NULLOT, &_types[2076] },
    { "phivEndUCountUsrMessRec", "1.3.6.1.2.1.18.4.2.1.5", &_names[2076],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2074], &_types[2078], NULLOT, &_types[2077] },
    { "phivEndCountUsrMessSent", "1.3.6.1.2.1.18.4.2.1.6", &_names[2077],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2075], &_types[2079], NULLOT, &_types[2078] },
    { "phivEndCountTotalBytesRec", "1.3.6.1.2.1.18.4.2.1.7", &_names[2078],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2076], &_types[2080], NULLOT, &_types[2079] },
    { "phivEndCountTotalBytesSent", "1.3.6.1.2.1.18.4.2.1.8", &_names[2079],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2077], &_types[2081], NULLOT, &_types[2080] },
    { "phivEndCountTotalMessRec", "1.3.6.1.2.1.18.4.2.1.9", &_names[2080],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2078], &_types[2082], NULLOT, &_types[2081] },
    { "phivEndCountTotalMessSent", "1.3.6.1.2.1.18.4.2.1.10", &_names[2081],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2079], &_types[2083], NULLOT, &_types[2082] },
    { "phivEndCountConnectsRecd", "1.3.6.1.2.1.18.4.2.1.11", &_names[2082],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2080], NULLOT, NULLOT, &_types[2083] },
    { "phivEndCountConnectsSent", "1.3.6.1.2.1.18.4.2.1.12", &_names[2083],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2081], &_types[2084], NULLOT, &_types[2084] },
    { "phivEndCountReponseTimeouts", "1.3.6.1.2.1.18.4.2.1.13", &_names[2084],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2061], &_types[2074], NULLOT, &_types[2085] },
    { "phivEndCountRecdConnectResErrs", "1.3.6.1.2.1.18.4.2.1.14", &_names[2085],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2019], &_types[2072], NULLOT, &_types[2086] },
    { "phivEndMaxLinks", "1.3.6.1.2.1.18.4.3", &_names[2086],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2068], &_types[2088], NULLOT, &_types[2087] },
    { "phivEndNSPVers", "1.3.6.1.2.1.18.4.4", &_names[2087],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2057], NULLOT, NULLOT, &_types[2088] },
    { "phivEndRetransmitFactor", "1.3.6.1.2.1.18.4.5", &_names[2088],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[1974], &_types[2089], NULLOT, &_types[2089] },
    { "phivEndDelayFact", "1.3.6.1.2.1.18.4.6", &_names[2089],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 255,
      NULL, NULL, NULL,
      &_types[2088], &_types[2093], NULLOT, &_types[2090] },
    { "phivEndDelayWeight", "1.3.6.1.2.1.18.4.7", &_names[2090],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 255,
      NULL, NULL, NULL,
      &_types[2062], &_types[2091], NULLOT, &_types[2091] },
    { "phivEndInactivityTimer", "1.3.6.1.2.1.18.4.8", &_names[2091],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2084], &_types[2063], NULLOT, &_types[2092] },
    { "phivEndCountZeroCount", "1.3.6.1.2.1.18.4.9", &_names[2092],
      (OS) 127, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2210], &_types[2087], NULLOT, &_types[2093] },
    { "phivEndMaxLinksActive", "1.3.6.1.2.1.18.4.10", &_names[2093],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1877], &_types[2092], NULLOT, &_types[2094] },
    { "routing", "1.3.6.1.2.1.18.5", &_names[2094],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2044], &_types[2276], &_types[2095], &_types[2095] },
    { "phivRouteBroadcastRouteTimer", "1.3.6.1.2.1.18.5.1", &_names[2095],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2091], &_types[2099], NULLOT, &_types[2096] },
    { "phivRouteBuffSize", "1.3.6.1.2.1.18.5.2", &_names[2096],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2072], &_types[2107], NULLOT, &_types[2097] },
    { "phivRouteRoutingVers", "1.3.6.1.2.1.18.5.3", &_names[2097],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2087], &_types[2098], NULLOT, &_types[2098] },
    { "phivRouteMaxAddr", "1.3.6.1.2.1.18.5.4", &_names[2098],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1023,
      NULL, NULL, NULL,
      &_types[2058], &_types[2124], NULLOT, &_types[2099] },
    { "phivRouteMaxBdcastNonRouters", "1.3.6.1.2.1.18.5.5", &_names[2099],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2095], &_types[2100], NULLOT, &_types[2100] },
    { "phivRouteMaxBdcastRouters", "1.3.6.1.2.1.18.5.6", &_names[2100],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2099], &_types[2106], NULLOT, &_types[2101] },
    { "phivRouteMaxBuffs", "1.3.6.1.2.1.18.5.7", &_names[2101],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2049], &_types[2109], NULLOT, &_types[2102] },
    { "phivRouteMaxCircuits", "1.3.6.1.2.1.18.5.8", &_names[2102],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2127], &_types[2108], NULLOT, &_types[2103] },
    { "phivRouteMaxCost", "1.3.6.1.2.1.18.5.9", &_names[2103],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1022,
      NULL, NULL, NULL,
      &_types[2073], &_types[2113], NULLOT, &_types[2104] },
    { "phivRouteMaxHops", "1.3.6.1.2.1.18.5.10", &_names[2104],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 30,
      NULL, NULL, NULL,
      &_types[2092], &_types[2123], NULLOT, &_types[2105] },
    { "phivRouteMaxVisits", "1.3.6.1.2.1.18.5.11", &_names[2105],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 63,
      NULL, NULL, NULL,
      &_types[2066], NULLOT, NULLOT, &_types[2106] },
    { "phivRouteRoutingTimer", "1.3.6.1.2.1.18.5.12", &_names[2106],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2100], &_types[2115], NULLOT, &_types[2107] },
    { "phivRouteSegBuffSize", "1.3.6.1.2.1.18.5.13", &_names[2107],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2096], &_types[2097], NULLOT, &_types[2108] },
    { "phivRouteType", "1.3.6.1.2.1.18.5.14", &_names[2108],
      (OS) 128, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2071], &_types[2125], NULLOT, &_types[2109] },
    { "phivRouteCountAgedPktLoss", "1.3.6.1.2.1.18.5.15", &_names[2109],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3035], &_types[2110], NULLOT, &_types[2110] },
    { "phivRouteCountNodeUnrPktLoss", "1.3.6.1.2.1.18.5.16", &_names[2110],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2109], &_types[2111], NULLOT, &_types[2111] },
    { "phivRouteCountOutRngePktLoss", "1.3.6.1.2.1.18.5.17", &_names[2111],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2110], &_types[2112], NULLOT, &_types[2112] },
    { "phivRouteCountOverSzePktLoss", "1.3.6.1.2.1.18.5.18", &_names[2112],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2111], &_types[2114], NULLOT, &_types[2113] },
    { "phivRouteCountPacketFmtErr", "1.3.6.1.2.1.18.5.19", &_names[2113],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2085], &_types[2096], NULLOT, &_types[2114] },
    { "phivRouteCountPtlRteUpdtLoss", "1.3.6.1.2.1.18.5.20", &_names[2114],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2112], &_types[2102], NULLOT, &_types[2115] },
    { "phivRouteCountVerifReject", "1.3.6.1.2.1.18.5.21", &_names[2115],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2020], &_types[2116], NULLOT, &_types[2116] },
    { "phivLevel1RouteTable", "1.3.6.1.2.1.18.5.22", &_names[2116],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2070], &_types[2101], &_types[2117], &_types[2117] },
    { "phivLevel1RouteEntry", "1.3.6.1.2.1.18.5.22.1", &_names[2117],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivLevel1RouteNodeAddr", NULL, NULL,
      &_types[2108], NULLOT, &_types[2121], &_types[2118] },
    { "phivLevel1RouteNodeAddr", "1.3.6.1.2.1.18.5.22.1.1", &_names[2118],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2098], &_types[2119], NULLOT, &_types[2119] },
    { "phivLevel1RouteCircuitIndex", "1.3.6.1.2.1.18.5.22.1.2", &_names[2119],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2067], NULLOT, NULLOT, &_types[2120] },
    { "phivLevel1RouteCost", "1.3.6.1.2.1.18.5.22.1.3", &_names[2120],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2103], &_types[2122], NULLOT, &_types[2121] },
    { "phivLevel1RouteHops", "1.3.6.1.2.1.18.5.22.1.4", &_names[2121],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[2104], &_types[2120], NULLOT, &_types[2122] },
    { "phivLevel1RouteNextNode", "1.3.6.1.2.1.18.5.22.1.5", &_names[2122],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2097], &_types[2118], NULLOT, &_types[2123] },
    { "phivRouteCountZeroCount", "1.3.6.1.2.1.18.5.23", &_names[2123],
      (OS) 129, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2121], &_types[2103], NULLOT, &_types[2124] },
    { "phivRouteSystemAddr", "1.3.6.1.2.1.18.5.24", &_names[2124],
      (OS) 2, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2118], &_types[2126], NULLOT, &_types[2125] },
    { "phivRouteRoutingType", "1.3.6.1.2.1.18.5.25", &_names[2125],
      (OS) 130, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2117], &_types[2104], NULLOT, &_types[2126] },
    { "phivRouteSystemAddress", "1.3.6.1.2.1.18.5.26", &_names[2126],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2124], &_types[2105], NULLOT, &_types[2127] },
    { "circuit", "1.3.6.1.2.1.18.6", &_names[2127],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1970], &_types[2210], &_types[2160], &_types[2128] },
    { "phivCircuitParametersTable", "1.3.6.1.2.1.18.6.1", &_names[2128],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2116], &_types[2140], &_types[2129], &_types[2129] },
    { "phivCircuitParametersEntry", "1.3.6.1.2.1.18.6.1.1", &_names[2129],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivCircuitIndex", NULL, NULL,
      &_types[2125], NULLOT, &_types[2136], &_types[2130] },
    { "phivCircuitIndex", "1.3.6.1.2.1.18.6.1.1.1", &_names[2130],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2119], &_types[2131], NULLOT, &_types[2131] },
    { "phivCircuitLineIndex", "1.3.6.1.2.1.18.6.1.1.2", &_names[2131],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2130], &_types[2134], NULLOT, &_types[2132] },
    { "phivCircuitCommonState", "1.3.6.1.2.1.18.6.1.1.3", &_names[2132],
      (OS) 131, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2105], &_types[2133], NULLOT, &_types[2133] },
    { "phivCircuitCommonSubState", "1.3.6.1.2.1.18.6.1.1.4", &_names[2133],
      (OS) 132, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2132], &_types[2137], NULLOT, &_types[2134] },
    { "phivCircuitCommonName", "1.3.6.1.2.1.18.6.1.1.5", &_names[2134],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 16,
      NULL, NULL, NULL,
      &_types[2059], &_types[2135], NULLOT, &_types[2135] },
    { "phivCircuitExecRecallTimer", "1.3.6.1.2.1.18.6.1.1.6", &_names[2135],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2106], &_types[2139], NULLOT, &_types[2136] },
    { "phivCircuitCommonType", "1.3.6.1.2.1.18.6.1.1.7", &_names[2136],
      (OS) 133, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2129], &_types[2138], NULLOT, &_types[2137] },
    { "phivCircuitService", "1.3.6.1.2.1.18.6.1.1.8", &_names[2137],
      (OS) 134, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2133], &_types[2130], NULLOT, &_types[2138] },
    { "phivCircuitExecCost", "1.3.6.1.2.1.18.6.1.1.9", &_names[2138],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 25,
      NULL, NULL, NULL,
      &_types[2120], &_types[2132], NULLOT, &_types[2139] },
    { "phivCircuitExecHelloTimer", "1.3.6.1.2.1.18.6.1.1.10", &_names[2139],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 8191,
      NULL, NULL, NULL,
      &_types[2135], NULLOT, NULLOT, &_types[2140] },
    { "phivCircuitCountTable", "1.3.6.1.2.1.18.6.2", &_names[2140],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2128], &_types[2159], &_types[2141], &_types[2141] },
    { "phivCircuitCountEntry", "1.3.6.1.2.1.18.6.2.1", &_names[2141],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivCircuitIndex", NULL, NULL,
      &_types[2136], NULLOT, &_types[2142], &_types[2142] },
    { "phivCircuitCountSecLastZeroed", "1.3.6.1.2.1.18.6.2.1.1", &_names[2142],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2138], &_types[2153], NULLOT, &_types[2143] },
    { "phivCircuitCountTermPacketsRecd", "1.3.6.1.2.1.18.6.2.1.2", &_names[2143],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2082], &_types[2147], NULLOT, &_types[2144] },
    { "phivCircuitCountOriginPackSent", "1.3.6.1.2.1.18.6.2.1.3", &_names[2144],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2083], &_types[2148], NULLOT, &_types[2145] },
    { "phivCircuitCountTermCongLoss", "1.3.6.1.2.1.18.6.2.1.4", &_names[2145],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2114], &_types[2146], NULLOT, &_types[2146] },
    { "phivCircuitCountCorruptLoss", "1.3.6.1.2.1.18.6.2.1.5", &_names[2146],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2145], &_types[2149], NULLOT, &_types[2147] },
    { "phivCircuitCountTransitPksRecd", "1.3.6.1.2.1.18.6.2.1.6", &_names[2147],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2143], &_types[2154], NULLOT, &_types[2148] },
    { "phivCircuitCountTransitPkSent", "1.3.6.1.2.1.18.6.2.1.7", &_names[2148],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2144], &_types[2155], NULLOT, &_types[2149] },
    { "phivCircuitCountTransitCongestLoss", "1.3.6.1.2.1.18.6.2.1.8", &_names[2149],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2146], &_types[2150], NULLOT, &_types[2150] },
    { "phivCircuitCountCircuitDown", "1.3.6.1.2.1.18.6.2.1.9", &_names[2150],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2102], &_types[2152], NULLOT, &_types[2151] },
    { "phivCircuitCountInitFailure", "1.3.6.1.2.1.18.6.2.1.10", &_names[2151],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[148], &_types[2158], NULLOT, &_types[2152] },
    { "phivCircuitCountAdjDown", "1.3.6.1.2.1.18.6.2.1.11", &_names[2152],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2150], NULLOT, NULLOT, &_types[2153] },
    { "phivCircuitCountPeakAdj", "1.3.6.1.2.1.18.6.2.1.12", &_names[2153],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2142], &_types[2144], NULLOT, &_types[2154] },
    { "phivCircuitCountBytesRecd", "1.3.6.1.2.1.18.6.2.1.13", &_names[2154],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2147], &_types[2156], NULLOT, &_types[2155] },
    { "phivCircuitCountBytesSent", "1.3.6.1.2.1.18.6.2.1.14", &_names[2155],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2148], &_types[2157], NULLOT, &_types[2156] },
    { "phivCircuitCountDataBlocksRecd", "1.3.6.1.2.1.18.6.2.1.15", &_names[2156],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2154], &_types[2151], NULLOT, &_types[2157] },
    { "phivCircuitCountDataBlocksSent", "1.3.6.1.2.1.18.6.2.1.16", &_names[2157],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2155], &_types[2143], NULLOT, &_types[2158] },
    { "phivCircuitCountUsrBuffUnav", "1.3.6.1.2.1.18.6.2.1.17", &_names[2158],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2089], &_types[2145], NULLOT, &_types[2159] },
    { "phivCircuitOrigQueueLimit", "1.3.6.1.2.1.18.6.3", &_names[2159],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2156], NULLOT, NULLOT, &_types[2160] },
    { "phivCircuitCountZeroCount", "1.3.6.1.2.1.18.6.4", &_names[2160],
      (OS) 135, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2123], &_types[2128], NULLOT, &_types[2161] },
    { "ddcmp", "1.3.6.1.2.1.18.7", &_names[2161],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1999], &_types[2053], &_types[2162], &_types[2162] },
    { "phivDDCMPCircuitParametersTable", "1.3.6.1.2.1.18.7.1", &_names[2162],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2140], &_types[2167], &_types[2163], &_types[2163] },
    { "phivDDCMPCircuitParametersEntry", "1.3.6.1.2.1.18.7.1.1", &_names[2163],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivDDCMPCircuitIndex", NULL, NULL,
      &_types[2141], NULLOT, &_types[2165], &_types[2164] },
    { "phivDDCMPCircuitIndex", "1.3.6.1.2.1.18.7.1.1.1", &_names[2164],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2131], &_types[2166], NULLOT, &_types[2165] },
    { "phivDDCMPCircuitAdjNodeAddr", "1.3.6.1.2.1.18.7.1.1.2", &_names[2165],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2126], &_types[2164], NULLOT, &_types[2166] },
    { "phivDDCMPCircuitTributary", "1.3.6.1.2.1.18.7.1.1.3", &_names[2166],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1665], NULLOT, NULLOT, &_types[2167] },
    { "phivDDCMPCircuitCountTable", "1.3.6.1.2.1.18.7.2", &_names[2167],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2162], &_types[2177], &_types[2168], &_types[2168] },
    { "phivDDCMPCircuitCountEntry", "1.3.6.1.2.1.18.7.2.1", &_names[2168],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivCircuitIndex", NULL, NULL,
      &_types[2163], NULLOT, &_types[2173], &_types[2169] },
    { "phivDDCMPCircuitErrorsInbd", "1.3.6.1.2.1.18.7.2.1.1", &_names[2169],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1694], &_types[2175], NULLOT, &_types[2170] },
    { "phivDDCMPCircuitErrorsOutbd", "1.3.6.1.2.1.18.7.2.1.2", &_names[2170],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2018], NULLOT, NULLOT, &_types[2171] },
    { "phivDDCMPCircuitRmteReplyTimeouts", "1.3.6.1.2.1.18.7.2.1.3", &_names[2171],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2139], &_types[2172], NULLOT, &_types[2172] },
    { "phivDDCMPCircuitLocalReplyTimeouts", "1.3.6.1.2.1.18.7.2.1.4", &_names[2172],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2171], &_types[2176], NULLOT, &_types[2173] },
    { "phivDDCMPCircuitRmteBuffErrors", "1.3.6.1.2.1.18.7.2.1.5", &_names[2173],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2113], &_types[2174], NULLOT, &_types[2174] },
    { "phivDDCMPCircuitLocalBuffErrors", "1.3.6.1.2.1.18.7.2.1.6", &_names[2174],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2173], &_types[2169], NULLOT, &_types[2175] },
    { "phivDDCMPCircuitSelectIntervalsElap", "1.3.6.1.2.1.18.7.2.1.7", &_names[2175],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2134], &_types[2171], NULLOT, &_types[2176] },
    { "phivDDCMPCircuitSelectTimeouts", "1.3.6.1.2.1.18.7.2.1.8", &_names[2176],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2172], &_types[2170], NULLOT, &_types[2177] },
    { "phivDDCMPLineCountTable", "1.3.6.1.2.1.18.7.3", &_names[2177],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2167], NULLOT, &_types[2178], &_types[2178] },
    { "phivDDCMPLineCountEntry", "1.3.6.1.2.1.18.7.3.1", &_names[2178],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivDDCMPLineCountIndex", NULL, NULL,
      &_types[2168], NULLOT, &_types[2181], &_types[2179] },
    { "phivDDCMPLineCountIndex", "1.3.6.1.2.1.18.7.3.1.1", &_names[2179],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2164], &_types[2180], NULLOT, &_types[2180] },
    { "phivDDCMPLineCountDataErrsIn", "1.3.6.1.2.1.18.7.3.1.2", &_names[2180],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[2181] },
    { "phivDDCMPLineCountRmteStationErrs", "1.3.6.1.2.1.18.7.3.1.3", &_names[2181],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2174], &_types[2182], NULLOT, &_types[2182] },
    { "phivDDCMPLineCountLocalStationErrs", "1.3.6.1.2.1.18.7.3.1.4", &_names[2182],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2181], &_types[2179], NULLOT, &_types[2183] },
    { "control", "1.3.6.1.2.1.18.8", &_names[2183],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2021], &_types[2058], &_types[2184], &_types[2184] },
    { "phivControlSchedTimer", "1.3.6.1.2.1.18.8.1", &_names[2184],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 50, 65535,
      NULL, NULL, NULL,
      &_types[2176], &_types[2185], NULLOT, &_types[2185] },
    { "phivControlDeadTimer", "1.3.6.1.2.1.18.8.2", &_names[2185],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2184], &_types[2186], NULLOT, &_types[2186] },
    { "phivControlDelayTimer", "1.3.6.1.2.1.18.8.3", &_names[2186],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2185], &_types[2187], NULLOT, &_types[2187] },
    { "phivControlStreamTimer", "1.3.6.1.2.1.18.8.4", &_names[2187],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2186], &_types[2188], NULLOT, &_types[2188] },
    { "phivControlParametersTable", "1.3.6.1.2.1.18.8.5", &_names[2188],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2177], NULLOT, &_types[2189], &_types[2189] },
    { "phivControlParametersEntry", "1.3.6.1.2.1.18.8.5.1", &_names[2189],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivControlCircuitIndex", NULL, NULL,
      &_types[2178], NULLOT, &_types[2199], &_types[2190] },
    { "phivControlCircuitIndex", "1.3.6.1.2.1.18.8.5.1.1", &_names[2190],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2179], &_types[2195], NULLOT, &_types[2191] },
    { "phivControlBabbleTimer", "1.3.6.1.2.1.18.8.5.1.2", &_names[2191],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2187], &_types[2201], NULLOT, &_types[2192] },
    { "phivControlMaxBuffs", "1.3.6.1.2.1.18.8.5.1.3", &_names[2192],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 254,
      NULL, NULL, NULL,
      &_types[2101], &_types[2198], NULLOT, &_types[2193] },
    { "phivControlMaxTransmits", "1.3.6.1.2.1.18.8.5.1.4", &_names[2193],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 255,
      NULL, NULL, NULL,
      &_types[2161], NULLOT, NULLOT, &_types[2194] },
    { "phivControlDyingBase", "1.3.6.1.2.1.18.8.5.1.5", &_names[2194],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2276], &_types[2192], NULLOT, &_types[2195] },
    { "phivControlDyingIncrement", "1.3.6.1.2.1.18.8.5.1.6", &_names[2195],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1847], &_types[2196], NULLOT, &_types[2196] },
    { "phivControlDeadThreshold", "1.3.6.1.2.1.18.8.5.1.7", &_names[2196],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2195], &_types[2197], NULLOT, &_types[2197] },
    { "phivControlDyingThreshold", "1.3.6.1.2.1.18.8.5.1.8", &_names[2197],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2196], &_types[2191], NULLOT, &_types[2198] },
    { "phivControlInactTreshold", "1.3.6.1.2.1.18.8.5.1.9", &_names[2198],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[1932], &_types[2193], NULLOT, &_types[2199] },
    { "phivControlPollingState", "1.3.6.1.2.1.18.8.5.1.10", &_names[2199],
      (OS) 136, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2137], &_types[2200], NULLOT, &_types[2200] },
    { "phivControlPollingSubState", "1.3.6.1.2.1.18.8.5.1.11", &_names[2200],
      (OS) 137, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2199], &_types[2190], NULLOT, &_types[2201] },
    { "phivControlTransTimer", "1.3.6.1.2.1.18.8.5.1.12", &_names[2201],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2191], &_types[2194], NULLOT, &_types[2202] },
    { "ethernet", "1.3.6.1.2.1.18.9", &_names[2202],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1997], &_types[2094], &_types[2203], &_types[2203] },
    { "phivEthLinkParametersTable", "1.3.6.1.2.1.18.9.1", &_names[2203],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2188], NULLOT, &_types[2204], &_types[2204] },
    { "phivEthLinkParametersEntry", "1.3.6.1.2.1.18.9.1.1", &_names[2204],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivEthLinkIndex", NULL, NULL,
      &_types[2189], NULLOT, &_types[2208], &_types[2205] },
    { "phivEthLinkIndex", "1.3.6.1.2.1.18.9.1.1.1", &_names[2205],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2190], &_types[2207], NULLOT, &_types[2206] },
    { "phivEthDesigRouterNodeAddr", "1.3.6.1.2.1.18.9.1.1.2", &_names[2206],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2165], &_types[2209], NULLOT, &_types[2207] },
    { "phivEthMaxRouters", "1.3.6.1.2.1.18.9.1.1.3", &_names[2207],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2201], NULLOT, NULLOT, &_types[2208] },
    { "phivEthRouterPri", "1.3.6.1.2.1.18.9.1.1.4", &_names[2208],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[2153], &_types[2206], NULLOT, &_types[2209] },
    { "phivEthHardwareAddr", "1.3.6.1.2.1.18.9.1.1.5", &_names[2209],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[2206], &_types[2205], NULLOT, &_types[2210] },
    { "counters", "1.3.6.1.2.1.18.10", &_names[2210],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2004], &_types[2233], &_types[2211], &_types[2211] },
    { "phivCountersCountTable", "1.3.6.1.2.1.18.10.1", &_names[2211],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2203], NULLOT, &_types[2212], &_types[2212] },
    { "phivCountersCountEntry", "1.3.6.1.2.1.18.10.1.1", &_names[2212],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivCountersIndex", NULL, NULL,
      &_types[2204], NULLOT, &_types[2223], &_types[2213] },
    { "phivCountersIndex", "1.3.6.1.2.1.18.10.1.1.1", &_names[2213],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2205], &_types[2230], NULLOT, &_types[2214] },
    { "phivCountersCountBytesRecd", "1.3.6.1.2.1.18.10.1.1.2", &_names[2214],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2159], &_types[2216], NULLOT, &_types[2215] },
    { "phivCountersCountBytesSent", "1.3.6.1.2.1.18.10.1.1.3", &_names[2215],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2157], &_types[2217], NULLOT, &_types[2216] },
    { "phivCountersCountDataBlocksRecd", "1.3.6.1.2.1.18.10.1.1.4", &_names[2216],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2214], &_types[2219], NULLOT, &_types[2217] },
    { "phivCountersCountDataBlocksSent", "1.3.6.1.2.1.18.10.1.1.5", &_names[2217],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2215], &_types[2221], NULLOT, &_types[2218] },
    { "phivCountersCountEthUsrBuffUnav", "1.3.6.1.2.1.18.10.1.1.6", &_names[2218],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2158], &_types[2231], NULLOT, &_types[2219] },
    { "phivCountersCountMcastBytesRecd", "1.3.6.1.2.1.18.10.1.1.7", &_names[2219],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2216], &_types[2220], NULLOT, &_types[2220] },
    { "phivCountersCountDataBlksRecd", "1.3.6.1.2.1.18.10.1.1.8", &_names[2220],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2219], &_types[2222], NULLOT, &_types[2221] },
    { "phivCountersCountDataBlksSent", "1.3.6.1.2.1.18.10.1.1.9", &_names[2221],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2217], &_types[2214], NULLOT, &_types[2222] },
    { "phivCountersCountMcastBlksRecd", "1.3.6.1.2.1.18.10.1.1.10", &_names[2222],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2220], &_types[2226], NULLOT, &_types[2223] },
    { "phivCountersCountBlksSentDef", "1.3.6.1.2.1.18.10.1.1.11", &_names[2223],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2182], &_types[2224], NULLOT, &_types[2224] },
    { "phivCountersCountBlksSentSingleCol", "1.3.6.1.2.1.18.10.1.1.12", &_names[2224],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2200], &_types[2225], NULLOT, &_types[2225] },
    { "phivCountersCountBlksSentMultCol", "1.3.6.1.2.1.18.10.1.1.13", &_names[2225],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2224], &_types[2213], NULLOT, &_types[2226] },
    { "phivCountersCountSendFailure", "1.3.6.1.2.1.18.10.1.1.14", &_names[2226],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2151], &_types[2227], NULLOT, &_types[2227] },
    { "phivCountersCountCollDetectFailure", "1.3.6.1.2.1.18.10.1.1.15", &_names[2227],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2226], &_types[2228], NULLOT, &_types[2228] },
    { "phivCountersCountReceiveFailure", "1.3.6.1.2.1.18.10.1.1.16", &_names[2228],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2227], &_types[2218], NULLOT, &_types[2229] },
    { "phivCountersCountUnrecFrameDest", "1.3.6.1.2.1.18.10.1.1.17", &_names[2229],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2093], NULLOT, NULLOT, &_types[2230] },
    { "phivCountersCountDataOver", "1.3.6.1.2.1.18.10.1.1.18", &_names[2230],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2197], &_types[2215], NULLOT, &_types[2231] },
    { "phivCountersCountSysBuffUnav", "1.3.6.1.2.1.18.10.1.1.19", &_names[2231],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2218], &_types[2232], NULLOT, &_types[2232] },
    { "phivCountersCountUsrBuffUnav", "1.3.6.1.2.1.18.10.1.1.20", &_names[2232],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2231], &_types[2229], NULLOT, &_types[2233] },
    { "adjacency", "1.3.6.1.2.1.18.11", &_names[2233],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1996], &_types[2183], &_types[2234], &_types[2234] },
    { "phivAdjTable", "1.3.6.1.2.1.18.11.1", &_names[2234],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2211], &_types[2245], &_types[2235], &_types[2235] },
    { "phivAdjEntry", "1.3.6.1.2.1.18.11.1.1", &_names[2235],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivAdjCircuitIndex", NULL, NULL,
      &_types[2212], NULLOT, &_types[2241], &_types[2236] },
    { "phivAdjCircuitIndex", "1.3.6.1.2.1.18.11.1.1.1", &_names[2236],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2213], &_types[2239], NULLOT, &_types[2237] },
    { "phivAdjNodeAddr", "1.3.6.1.2.1.18.11.1.1.2", &_names[2237],
      (OS) 2, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2209], &_types[2240], NULLOT, &_types[2238] },
    { "phivAdjBlockSize", "1.3.6.1.2.1.18.11.1.1.3", &_names[2238],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2107], &_types[2237], NULLOT, &_types[2239] },
    { "phivAdjListenTimer", "1.3.6.1.2.1.18.11.1.1.4", &_names[2239],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2207], &_types[2244], NULLOT, &_types[2240] },
    { "phivAdjCircuitEtherServPhysAddr", "1.3.6.1.2.1.18.11.1.1.5", &_names[2240],
      (OS) 2, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[2237], &_types[2242], NULLOT, &_types[2241] },
    { "phivAdjType", "1.3.6.1.2.1.18.11.1.1.6", &_names[2241],
      (OS) 138, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2235], &_types[2243], NULLOT, &_types[2242] },
    { "phivAdjState", "1.3.6.1.2.1.18.11.1.1.7", &_names[2242],
      (OS) 139, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2225], &_types[2236], NULLOT, &_types[2243] },
    { "phivAdjPriority", "1.3.6.1.2.1.18.11.1.1.8", &_names[2243],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2208], &_types[2238], NULLOT, &_types[2244] },
    { "phivAdjExecListenTimer", "1.3.6.1.2.1.18.11.1.1.9", &_names[2244],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2239], NULLOT, NULLOT, &_types[2245] },
    { "phivAdjNodeTable", "1.3.6.1.2.1.18.11.2", &_names[2245],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2234], NULLOT, &_types[2246], &_types[2246] },
    { "phivAdjNodeEntry", "1.3.6.1.2.1.18.11.2.1", &_names[2246],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivAdjNodeCircuitIndex phivAdjAddr", NULL, NULL,
      &_types[2241], NULLOT, &_types[2252], &_types[2247] },
    { "phivAdjNodeCircuitIndex", "1.3.6.1.2.1.18.11.2.1.1", &_names[2247],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2236], &_types[2250], NULLOT, &_types[2248] },
    { "phivAdjAddr", "1.3.6.1.2.1.18.11.2.1.2", &_names[2248],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2240], &_types[2251], NULLOT, &_types[2249] },
    { "phivAdjNodeBlockSize", "1.3.6.1.2.1.18.11.2.1.3", &_names[2249],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2238], &_types[2248], NULLOT, &_types[2250] },
    { "phivAdjNodeListenTimer", "1.3.6.1.2.1.18.11.2.1.4", &_names[2250],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2244], NULLOT, NULLOT, &_types[2251] },
    { "phivAdjNodeCircuitEtherServPhysAddr", "1.3.6.1.2.1.18.11.2.1.5", &_names[2251],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[2248], &_types[2253], NULLOT, &_types[2252] },
    { "phivAdjNodeType", "1.3.6.1.2.1.18.11.2.1.6", &_names[2252],
      (OS) 140, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2246], &_types[2254], NULLOT, &_types[2253] },
    { "phivAdjNodeState", "1.3.6.1.2.1.18.11.2.1.7", &_names[2253],
      (OS) 141, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2242], &_types[2247], NULLOT, &_types[2254] },
    { "phivAdjNodePriority", "1.3.6.1.2.1.18.11.2.1.8", &_names[2254],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2243], &_types[2249], NULLOT, &_types[2255] },
    { "line", "1.3.6.1.2.1.18.12", &_names[2255],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2052], &_types[2268], &_types[2256], &_types[2256] },
    { "phivLineTable", "1.3.6.1.2.1.18.12.1", &_names[2256],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2245], NULLOT, &_types[2257], &_types[2257] },
    { "phivLineEntry", "1.3.6.1.2.1.18.12.1.1", &_names[2257],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivLineIndex", NULL, NULL,
      &_types[2252], NULLOT, &_types[2267], &_types[2258] },
    { "phivLineIndex", "1.3.6.1.2.1.18.12.1.1.1", &_names[2258],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2247], &_types[2259], NULLOT, &_types[2259] },
    { "phivLineName", "1.3.6.1.2.1.18.12.1.1.2", &_names[2259],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 16,
      NULL, NULL, NULL,
      &_types[2175], &_types[2266], NULLOT, &_types[2260] },
    { "phivLineState", "1.3.6.1.2.1.18.12.1.1.3", &_names[2260],
      (OS) 142, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2253], &_types[2261], NULLOT, &_types[2261] },
    { "phivLineSubstate", "1.3.6.1.2.1.18.12.1.1.4", &_names[2261],
      (OS) 143, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2260], &_types[2262], NULLOT, &_types[2262] },
    { "phivLineService", "1.3.6.1.2.1.18.12.1.1.5", &_names[2262],
      (OS) 144, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2261], &_types[2258], NULLOT, &_types[2263] },
    { "phivLineDevice", "1.3.6.1.2.1.18.12.1.1.6", &_names[2263],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 16,
      NULL, NULL, NULL,
      NULLOT, &_types[2265], NULLOT, &_types[2264] },
    { "phivLineReceiveBuffs", "1.3.6.1.2.1.18.12.1.1.7", &_names[2264],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2192], &_types[2263], NULLOT, &_types[2265] },
    { "phivLineProtocol", "1.3.6.1.2.1.18.12.1.1.8", &_names[2265],
      (OS) 145, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2053], NULLOT, NULLOT, &_types[2266] },
    { "phivLineServiceTimer", "1.3.6.1.2.1.18.12.1.1.9", &_names[2266],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2250], &_types[2264], NULLOT, &_types[2267] },
    { "phivLineMaxBlock", "1.3.6.1.2.1.18.12.1.1.10", &_names[2267],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2223], &_types[2260], NULLOT, &_types[2268] },
    { "nonBroadcastLine", "1.3.6.1.2.1.18.14", &_names[2268],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2255], &_types[2161], &_types[2269], &_types[2269] },
    { "phivNonBroadcastTable", "1.3.6.1.2.1.18.14.1", &_names[2269],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2256], NULLOT, &_types[2270], &_types[2270] },
    { "phivNonBroadcastEntry", "1.3.6.1.2.1.18.14.1.1", &_names[2270],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivNonBroadcastIndex", NULL, NULL,
      &_types[2257], NULLOT, &_types[2274], &_types[2271] },
    { "phivNonBroadcastIndex", "1.3.6.1.2.1.18.14.1.1.1", &_names[2271],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2258], &_types[2273], NULLOT, &_types[2272] },
    { "phivNonBroadcastController", "1.3.6.1.2.1.18.14.1.1.2", &_names[2272],
      (OS) 146, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2183], &_types[2271], NULLOT, &_types[2273] },
    { "phivNonBroadcastDuplex", "1.3.6.1.2.1.18.14.1.1.3", &_names[2273],
      (OS) 147, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2271], &_types[2275], NULLOT, &_types[2274] },
    { "phivNonBroadcastClock", "1.3.6.1.2.1.18.14.1.1.4", &_names[2274],
      (OS) 148, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2050], &_types[2272], NULLOT, &_types[2275] },
    { "phivNonBroadcastRetransmitTimer", "1.3.6.1.2.1.18.14.1.1.5", &_names[2275],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2266], NULLOT, NULLOT, &_types[2276] },
    { "area", "1.3.6.1.2.1.18.15", &_names[2276],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1962], NULLOT, &_types[2287], &_types[2277] },
    { "phivAreaTable", "1.3.6.1.2.1.18.15.1", &_names[2277],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2269], NULLOT, &_types[2278], &_types[2278] },
    { "phivAreaEntry", "1.3.6.1.2.1.18.15.1.1", &_names[2278],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "phivAreaNum", NULL, NULL,
      &_types[2270], NULLOT, &_types[2282], &_types[2279] },
    { "phivAreaNum", "1.3.6.1.2.1.18.15.1.1.1", &_names[2279],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 64,
      NULL, NULL, NULL,
      &_types[2274], &_types[2283], NULLOT, &_types[2280] },
    { "phivAreaState", "1.3.6.1.2.1.18.15.1.1.2", &_names[2280],
      (OS) 149, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2262], &_types[2284], NULLOT, &_types[2281] },
    { "phivAreaCost", "1.3.6.1.2.1.18.15.1.1.3", &_names[2281],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2254], &_types[2279], NULLOT, &_types[2282] },
    { "phivAreaHops", "1.3.6.1.2.1.18.15.1.1.4", &_names[2282],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2160], &_types[2281], NULLOT, &_types[2283] },
    { "phivAreaNextNode", "1.3.6.1.2.1.18.15.1.1.5", &_names[2283],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2122], &_types[2280], NULLOT, &_types[2284] },
    { "phivAreaCircuitIndex", "1.3.6.1.2.1.18.15.1.1.6", &_names[2284],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[2273], NULLOT, NULLOT, &_types[2285] },
    { "phivAreaMaxCost", "1.3.6.1.2.1.18.15.2", &_names[2285],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1022,
      NULL, NULL, NULL,
      &_types[2281], &_types[2277], NULLOT, &_types[2286] },
    { "phivAreaMaxHops", "1.3.6.1.2.1.18.15.3", &_names[2286],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 30,
      NULL, NULL, NULL,
      &_types[2282], &_types[2285], NULLOT, &_types[2287] },
    { "phivRouteMaxArea", "1.3.6.1.2.1.18.15.4", &_names[2287],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 63,
      NULL, NULL, NULL,
      &_types[2194], &_types[2286], NULLOT, &_types[2288] },
    { "char", "1.3.6.1.2.1.19", &_names[2288],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2221], &_types[2329], &_types[2290], &_types[2289] },
    { "charNumber", "1.3.6.1.2.1.19.1", &_names[2289],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2279], NULLOT, NULLOT, &_types[2290] },
    { "charPortTable", "1.3.6.1.2.1.19.2", &_names[2290],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2325], &_types[2310], &_types[2291], &_types[2291] },
    { "charPortEntry", "1.3.6.1.2.1.19.2.1", &_names[2291],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "charPortIndex", NULL, NULL,
      &_types[2278], NULLOT, &_types[2294], &_types[2292] },
    { "charPortIndex", "1.3.6.1.2.1.19.2.1.1", &_names[2292],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2326], &_types[2309], NULLOT, &_types[2293] },
    { "charPortName", "1.3.6.1.2.1.19.2.1.2", &_names[2293],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 32,
      NULL, NULL, NULL,
      &_types[2259], &_types[2295], NULLOT, &_types[2294] },
    { "charPortType", "1.3.6.1.2.1.19.2.1.3", &_names[2294],
      (OS) 150, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2291], &_types[2300], NULLOT, &_types[2295] },
    { "charPortHardware", "1.3.6.1.2.1.19.2.1.4", &_names[2295],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2202], NULLOT, NULLOT, &_types[2296] },
    { "charPortReset", "1.3.6.1.2.1.19.2.1.5", &_names[2296],
      (OS) 151, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2280], &_types[2297], NULLOT, &_types[2297] },
    { "charPortAdminStatus", "1.3.6.1.2.1.19.2.1.6", &_names[2297],
      (OS) 152, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2296], &_types[2298], NULLOT, &_types[2298] },
    { "charPortOperStatus", "1.3.6.1.2.1.19.2.1.7", &_names[2298],
      (OS) 153, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2297], &_types[2302], NULLOT, &_types[2299] },
    { "charPortLastChange", "1.3.6.1.2.1.19.2.1.8", &_names[2299],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2288], &_types[2304], NULLOT, &_types[2300] },
    { "charPortInFlowType", "1.3.6.1.2.1.19.2.1.9", &_names[2300],
      (OS) 154, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2294], &_types[2301], NULLOT, &_types[2301] },
    { "charPortOutFlowType", "1.3.6.1.2.1.19.2.1.10", &_names[2301],
      (OS) 155, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2300], &_types[2306], NULLOT, &_types[2302] },
    { "charPortInFlowState", "1.3.6.1.2.1.19.2.1.11", &_names[2302],
      (OS) 156, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2298], &_types[2303], NULLOT, &_types[2303] },
    { "charPortOutFlowState", "1.3.6.1.2.1.19.2.1.12", &_names[2303],
      (OS) 157, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2302], &_types[2292], NULLOT, &_types[2304] },
    { "charPortInCharacters", "1.3.6.1.2.1.19.2.1.13", &_names[2304],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2299], &_types[2305], NULLOT, &_types[2305] },
    { "charPortOutCharacters", "1.3.6.1.2.1.19.2.1.14", &_names[2305],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2304], &_types[2293], NULLOT, &_types[2306] },
    { "charPortAdminOrigin", "1.3.6.1.2.1.19.2.1.15", &_names[2306],
      (OS) 158, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2289], &_types[2308], NULLOT, &_types[2307] },
    { "charPortSessionMaximum", "1.3.6.1.2.1.19.2.1.16", &_names[2307],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2249], &_types[2296], NULLOT, &_types[2308] },
    { "charPortSessionNumber", "1.3.6.1.2.1.19.2.1.17", &_names[2308],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2306], &_types[2307], NULLOT, &_types[2309] },
    { "charPortSessionIndex", "1.3.6.1.2.1.19.2.1.18", &_names[2309],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2292], &_types[2299], NULLOT, &_types[2310] },
    { "charSessTable", "1.3.6.1.2.1.19.3", &_names[2310],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2290], &_types[2322], &_types[2311], &_types[2311] },
    { "charSessEntry", "1.3.6.1.2.1.19.3.1", &_names[2311],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "charSessPortIndex charSessIndex", NULL, NULL,
      &_types[2301], NULLOT, &_types[2317], &_types[2312] },
    { "charSessPortIndex", "1.3.6.1.2.1.19.3.1.1", &_names[2312],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2309], &_types[2313], NULLOT, &_types[2313] },
    { "charSessIndex", "1.3.6.1.2.1.19.3.1.2", &_names[2313],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2312], &_types[2318], NULLOT, &_types[2314] },
    { "charSessKill", "1.3.6.1.2.1.19.3.1.3", &_names[2314],
      (OS) 159, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2228], &_types[2320], NULLOT, &_types[2315] },
    { "charSessState", "1.3.6.1.2.1.19.3.1.4", &_names[2315],
      (OS) 160, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2303], &_types[2312], NULLOT, &_types[2316] },
    { "charSessProtocol", "1.3.6.1.2.1.19.3.1.5", &_names[2316],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2322], NULLOT, NULLOT, &_types[2317] },
    { "charSessOperOrigin", "1.3.6.1.2.1.19.3.1.6", &_names[2317],
      (OS) 161, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2308], &_types[2315], NULLOT, &_types[2318] },
    { "charSessInCharacters", "1.3.6.1.2.1.19.3.1.7", &_names[2318],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2305], &_types[2319], NULLOT, &_types[2319] },
    { "charSessOutCharacters", "1.3.6.1.2.1.19.3.1.8", &_names[2319],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2318], &_types[2321], NULLOT, &_types[2320] },
    { "charSessConnectionId", "1.3.6.1.2.1.19.3.1.9", &_names[2320],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2042], &_types[2316], NULLOT, &_types[2321] },
    { "charSessStartTime", "1.3.6.1.2.1.19.3.1.10", &_names[2321],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2275], &_types[2314], NULLOT, &_types[2322] },
    { "wellKnownProtocols", "1.3.6.1.2.1.19.4", &_names[2322],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2265], &_types[2289], &_types[2323], &_types[2323] },
    { "protocolOther", "1.3.6.1.2.1.19.4.1", &_names[2323],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2283], &_types[2326], NULLOT, &_types[2324] },
    { "protocolTelnet", "1.3.6.1.2.1.19.4.2", &_names[2324],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2090], &_types[2325], NULLOT, &_types[2325] },
    { "protocolRlogin", "1.3.6.1.2.1.19.4.3", &_names[2325],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2277], &_types[2328], NULLOT, &_types[2326] },
    { "protocolLat", "1.3.6.1.2.1.19.4.4", &_names[2326],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2284], &_types[2324], NULLOT, &_types[2327] },
    { "protocolX29", "1.3.6.1.2.1.19.4.5", &_names[2327],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3037], NULLOT, NULLOT, &_types[2328] },
    { "protocolVtp", "1.3.6.1.2.1.19.4.6", &_names[2328],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1995], &_types[2327], NULLOT, &_types[2329] },
    { "snmpDot3RptrMgt", "1.3.6.1.2.1.22", &_names[2329],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2293], &_types[2572], &_types[2330], &_types[2330] },
    { "rptrBasicPackage", "1.3.6.1.2.1.22.1", &_names[2330],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2328], &_types[2355], &_types[2331], &_types[2331] },
    { "rptrRptrInfo", "1.3.6.1.2.1.22.1.1", &_names[2331],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2251], &_types[2338], &_types[2333], &_types[2332] },
    { "rptrGroupCapacity", "1.3.6.1.2.1.22.1.1.1", &_names[2332],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2383], &_types[2334], NULLOT, &_types[2333] },
    { "rptrOperStatus", "1.3.6.1.2.1.22.1.1.2", &_names[2333],
      (OS) 162, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2315], &_types[2335], NULLOT, &_types[2334] },
    { "rptrHealthText", "1.3.6.1.2.1.22.1.1.3", &_names[2334],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2285], &_types[2336], NULLOT, &_types[2335] },
    { "rptrReset", "1.3.6.1.2.1.22.1.1.4", &_names[2335],
      (OS) 163, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2333], &_types[2337], NULLOT, &_types[2336] },
    { "rptrNonDisruptTest", "1.3.6.1.2.1.22.1.1.5", &_names[2336],
      (OS) 164, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2272], NULLOT, NULLOT, &_types[2337] },
    { "rptrTotalPartitionedPorts", "1.3.6.1.2.1.22.1.1.6", &_names[2337],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2264], &_types[2332], NULLOT, &_types[2338] },
    { "rptrGroupInfo", "1.3.6.1.2.1.22.1.2", &_names[2338],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2331], &_types[2347], &_types[2339], &_types[2339] },
    { "rptrGroupTable", "1.3.6.1.2.1.22.1.2.1", &_names[2339],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2310], NULLOT, &_types[2340], &_types[2340] },
    { "rptrGroupEntry", "1.3.6.1.2.1.22.1.2.1.1", &_names[2340],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rptrGroupIndex", NULL, NULL,
      &_types[2311], NULLOT, &_types[2343], &_types[2341] },
    { "rptrGroupIndex", "1.3.6.1.2.1.22.1.2.1.1.1", &_names[2341],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2313], &_types[2345], NULLOT, &_types[2342] },
    { "rptrGroupDescr", "1.3.6.1.2.1.22.1.2.1.1.2", &_names[2342],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2229], NULLOT, NULLOT, &_types[2343] },
    { "rptrGroupObjectID", "1.3.6.1.2.1.22.1.2.1.1.3", &_names[2343],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2307], &_types[2344], NULLOT, &_types[2344] },
    { "rptrGroupOperStatus", "1.3.6.1.2.1.22.1.2.1.1.4", &_names[2344],
      (OS) 165, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2335], &_types[2341], NULLOT, &_types[2345] },
    { "rptrGroupLastOperStatusChange", "1.3.6.1.2.1.22.1.2.1.1.5", &_names[2345],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2319], &_types[2346], NULLOT, &_types[2346] },
    { "rptrGroupPortCapacity", "1.3.6.1.2.1.22.1.2.1.1.6", &_names[2346],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2332], &_types[2342], NULLOT, &_types[2347] },
    { "rptrPortInfo", "1.3.6.1.2.1.22.1.3", &_names[2347],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2338], NULLOT, &_types[2348], &_types[2348] },
    { "rptrPortTable", "1.3.6.1.2.1.22.1.3.1", &_names[2348],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2339], NULLOT, &_types[2349], &_types[2349] },
    { "rptrPortEntry", "1.3.6.1.2.1.22.1.3.1.1", &_names[2349],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rptrPortGroupIndex rptrPortIndex", NULL, NULL,
      &_types[2340], NULLOT, &_types[2352], &_types[2350] },
    { "rptrPortGroupIndex", "1.3.6.1.2.1.22.1.3.1.1.1", &_names[2350],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2341], &_types[2351], NULLOT, &_types[2351] },
    { "rptrPortIndex", "1.3.6.1.2.1.22.1.3.1.1.2", &_names[2351],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2350], NULLOT, NULLOT, &_types[2352] },
    { "rptrPortAdminStatus", "1.3.6.1.2.1.22.1.3.1.1.3", &_names[2352],
      (OS) 166, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2344], &_types[2353], NULLOT, &_types[2353] },
    { "rptrPortAutoPartitionState", "1.3.6.1.2.1.22.1.3.1.1.4", &_names[2353],
      (OS) 167, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2352], &_types[2354], NULLOT, &_types[2354] },
    { "rptrPortOperStatus", "1.3.6.1.2.1.22.1.3.1.1.5", &_names[2354],
      (OS) 168, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2353], &_types[2350], NULLOT, &_types[2355] },
    { "rptrMonitorPackage", "1.3.6.1.2.1.22.2", &_names[2355],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2330], &_types[2383], &_types[2356], &_types[2356] },
    { "rptrMonitorRptrInfo", "1.3.6.1.2.1.22.2.1", &_names[2356],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2347], &_types[2358], &_types[2357], &_types[2357] },
    { "rptrMonitorTransmitCollisions", "1.3.6.1.2.1.22.2.1.1", &_names[2357],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2354], NULLOT, NULLOT, &_types[2358] },
    { "rptrMonitorGroupInfo", "1.3.6.1.2.1.22.2.2", &_names[2358],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2356], &_types[2365], &_types[2359], &_types[2359] },
    { "rptrMonitorGroupTable", "1.3.6.1.2.1.22.2.2.1", &_names[2359],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2348], NULLOT, &_types[2360], &_types[2360] },
    { "rptrMonitorGroupEntry", "1.3.6.1.2.1.22.2.2.1.1", &_names[2360],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rptrMonitorGroupIndex", NULL, NULL,
      &_types[2349], NULLOT, &_types[2364], &_types[2361] },
    { "rptrMonitorGroupIndex", "1.3.6.1.2.1.22.2.2.1.1.1", &_names[2361],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2351], &_types[2362], NULLOT, &_types[2362] },
    { "rptrMonitorGroupTotalFrames", "1.3.6.1.2.1.22.2.2.1.1.2", &_names[2362],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2359], NULLOT, NULLOT, &_types[2363] },
    { "rptrMonitorGroupTotalOctets", "1.3.6.1.2.1.22.2.2.1.1.3", &_names[2363],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2357], &_types[2361], NULLOT, &_types[2364] },
    { "rptrMonitorGroupTotalErrors", "1.3.6.1.2.1.22.2.2.1.1.4", &_names[2364],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2267], &_types[2363], NULLOT, &_types[2365] },
    { "rptrMonitorPortInfo", "1.3.6.1.2.1.22.2.3", &_names[2365],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2358], NULLOT, &_types[2366], &_types[2366] },
    { "rptrMonitorPortTable", "1.3.6.1.2.1.22.2.3.1", &_names[2366],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2362], NULLOT, &_types[2367], &_types[2367] },
    { "rptrMonitorPortEntry", "1.3.6.1.2.1.22.2.3.1.1", &_names[2367],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rptrMonitorPortGroupIndex rptrMonitorPortIndex", NULL, NULL,
      &_types[2360], NULLOT, &_types[2374], &_types[2368] },
    { "rptrMonitorPortGroupIndex", "1.3.6.1.2.1.22.2.3.1.1.1", &_names[2368],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2361], &_types[2369], NULLOT, &_types[2369] },
    { "rptrMonitorPortIndex", "1.3.6.1.2.1.22.2.3.1.1.2", &_names[2369],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2368], &_types[2380], NULLOT, &_types[2370] },
    { "rptrMonitorPortReadableFrames", "1.3.6.1.2.1.22.2.3.1.1.3", &_names[2370],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2366], &_types[2375], NULLOT, &_types[2371] },
    { "rptrMonitorPortReadableOctets", "1.3.6.1.2.1.22.2.3.1.1.4", &_names[2371],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2363], &_types[2377], NULLOT, &_types[2372] },
    { "rptrMonitorPortFCSErrors", "1.3.6.1.2.1.22.2.3.1.1.5", &_names[2372],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2364], &_types[2373], NULLOT, &_types[2373] },
    { "rptrMonitorPortAlignmentErrors", "1.3.6.1.2.1.22.2.3.1.1.6", &_names[2373],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2372], &_types[2382], NULLOT, &_types[2374] },
    { "rptrMonitorPortFrameTooLongs", "1.3.6.1.2.1.22.2.3.1.1.7", &_names[2374],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2367], &_types[2376], NULLOT, &_types[2375] },
    { "rptrMonitorPortShortEvents", "1.3.6.1.2.1.22.2.3.1.1.8", &_names[2375],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2287], &_types[2378], NULLOT, &_types[2376] },
    { "rptrMonitorPortRunts", "1.3.6.1.2.1.22.2.3.1.1.9", &_names[2376],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2374], &_types[2372], NULLOT, &_types[2377] },
    { "rptrMonitorPortCollisions", "1.3.6.1.2.1.22.2.3.1.1.10", &_names[2377],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2371], &_types[2368], NULLOT, &_types[2378] },
    { "rptrMonitorPortLateEvents", "1.3.6.1.2.1.22.2.3.1.1.11", &_names[2378],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2375], &_types[2379], NULLOT, &_types[2379] },
    { "rptrMonitorPortVeryLongEvents", "1.3.6.1.2.1.22.2.3.1.1.12", &_names[2379],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2378], NULLOT, NULLOT, &_types[2380] },
    { "rptrMonitorPortDataRateMismatches", "1.3.6.1.2.1.22.2.3.1.1.13", &_names[2380],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2115], &_types[2370], NULLOT, &_types[2381] },
    { "rptrMonitorPortAutoPartitions", "1.3.6.1.2.1.22.2.3.1.1.14", &_names[2381],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2386], &_types[2371], NULLOT, &_types[2382] },
    { "rptrMonitorPortTotalErrors", "1.3.6.1.2.1.22.2.3.1.1.15", &_names[2382],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2373], &_types[2381], NULLOT, &_types[2383] },
    { "rptrAddrTrackPackage", "1.3.6.1.2.1.22.3", &_names[2383],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2355], NULLOT, &_types[2384], &_types[2384] },
    { "rptrAddrTrackRptrInfo", "1.3.6.1.2.1.22.3.1", &_names[2384],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2365], &_types[2385], NULLOT, &_types[2385] },
    { "rptrAddrTrackGroupInfo", "1.3.6.1.2.1.22.3.2", &_names[2385],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2384], &_types[2386], NULLOT, &_types[2386] },
    { "rptrAddrTrackPortInfo", "1.3.6.1.2.1.22.3.3", &_names[2386],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2385], NULLOT, &_types[2387], &_types[2387] },
    { "rptrAddrTrackTable", "1.3.6.1.2.1.22.3.3.1", &_names[2387],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2370], NULLOT, &_types[2388], &_types[2388] },
    { "rptrAddrTrackEntry", "1.3.6.1.2.1.22.3.3.1.1", &_names[2388],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rptrAddrTrackGroupIndex rptrAddrTrackPortIndex", NULL, NULL,
      &_types[2376], NULLOT, &_types[2391], &_types[2389] },
    { "rptrAddrTrackGroupIndex", "1.3.6.1.2.1.22.3.3.1.1.1", &_names[2389],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2369], &_types[2390], NULLOT, &_types[2390] },
    { "rptrAddrTrackPortIndex", "1.3.6.1.2.1.22.3.3.1.1.2", &_names[2390],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2389], &_types[2392], NULLOT, &_types[2391] },
    { "rptrAddrTrackLastSourceAddress", "1.3.6.1.2.1.22.3.3.1.1.3", &_names[2391],
      (OS) 2, 1, (u_long) 0, 4,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 6, 6,
      NULL, NULL, NULL,
      &_types[2381], &_types[2393], NULLOT, &_types[2392] },
    { "rptrAddrTrackSourceAddrChanges", "1.3.6.1.2.1.22.3.3.1.1.4", &_names[2392],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2345], NULLOT, NULLOT, &_types[2393] },
    { "rptrAddrTrackNewLastSrcAddress", "1.3.6.1.2.1.22.3.3.1.1.5", &_names[2393],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 0,
      NULL, NULL, NULL,
      &_types[2391], &_types[2389], NULLOT, &_types[2394] },
    { "rip2", "1.3.6.1.2.1.23", &_names[2394],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2295], &_types[1566], &_types[2398], &_types[2395] },
    { "rip2GlobalGroup", "1.3.6.1.2.1.23.1", &_names[2395],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2343], NULLOT, &_types[2397], &_types[2396] },
    { "rip2GlobalRouteChanges", "1.3.6.1.2.1.23.1.1", &_names[2396],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2392], NULLOT, NULLOT, &_types[2397] },
    { "rip2GlobalQueries", "1.3.6.1.2.1.23.1.2", &_names[2397],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2393], &_types[2396], NULLOT, &_types[2398] },
    { "rip2IfStatTable", "1.3.6.1.2.1.23.2", &_names[2398],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2387], &_types[2405], &_types[2399], &_types[2399] },
    { "rip2IfStatEntry", "1.3.6.1.2.1.23.2.1", &_names[2399],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rip2IfStatAddress", NULL, NULL,
      &_types[2388], NULLOT, &_types[2400], &_types[2400] },
    { "rip2IfStatAddress", "1.3.6.1.2.1.23.2.1.1", &_names[2400],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2397], &_types[2404], NULLOT, &_types[2401] },
    { "rip2IfStatRcvBadPackets", "1.3.6.1.2.1.23.2.1.2", &_names[2401],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2346], &_types[2403], NULLOT, &_types[2402] },
    { "rip2IfStatRcvBadRoutes", "1.3.6.1.2.1.23.2.1.3", &_names[2402],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2321], &_types[2401], NULLOT, &_types[2403] },
    { "rip2IfStatSentUpdates", "1.3.6.1.2.1.23.2.1.4", &_names[2403],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1553], NULLOT, NULLOT, &_types[2404] },
    { "rip2IfStatStatus", "1.3.6.1.2.1.23.2.1.5", &_names[2404],
      (OS) 169, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2377], &_types[2402], NULLOT, &_types[2405] },
    { "rip2IfConfTable", "1.3.6.1.2.1.23.3", &_names[2405],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2398], &_types[2415], &_types[2406], &_types[2406] },
    { "rip2IfConfEntry", "1.3.6.1.2.1.23.3.1", &_names[2406],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rip2IfConfAddress", NULL, NULL,
      &_types[2399], NULLOT, &_types[2409], &_types[2407] },
    { "rip2IfConfAddress", "1.3.6.1.2.1.23.3.1.1", &_names[2407],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2400], &_types[2414], NULLOT, &_types[2408] },
    { "rip2IfConfDomain", "1.3.6.1.2.1.23.3.1.2", &_names[2408],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2336], &_types[2407], NULLOT, &_types[2409] },
    { "rip2IfConfAuthType", "1.3.6.1.2.1.23.3.1.3", &_names[2409],
      (OS) 170, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2406], &_types[2408], NULLOT, &_types[2410] },
    { "rip2IfConfAuthKey", "1.3.6.1.2.1.23.3.1.4", &_names[2410],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 16,
      NULL, NULL, NULL,
      &_types[2390], &_types[2411], NULLOT, &_types[2411] },
    { "rip2IfConfSend", "1.3.6.1.2.1.23.3.1.5", &_names[2411],
      (OS) 171, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2396], &_types[2413], NULLOT, &_types[2412] },
    { "rip2IfConfReceive", "1.3.6.1.2.1.23.3.1.6", &_names[2412],
      (OS) 172, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2222], NULLOT, NULLOT, &_types[2413] },
    { "rip2IfConfDefaultMetric", "1.3.6.1.2.1.23.3.1.7", &_names[2413],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 15,
      NULL, NULL, NULL,
      &_types[2411], &_types[2412], NULLOT, &_types[2414] },
    { "rip2IfConfStatus", "1.3.6.1.2.1.23.3.1.8", &_names[2414],
      (OS) 173, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2404], &_types[2410], NULLOT, &_types[2415] },
    { "rip2PeerTable", "1.3.6.1.2.1.23.4", &_names[2415],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2405], &_types[2395], &_types[2416], &_types[2416] },
    { "rip2PeerEntry", "1.3.6.1.2.1.23.4.1", &_names[2416],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rip2PeerAddress rip2PeerDomain", NULL, NULL,
      &_types[2409], NULLOT, &_types[2420], &_types[2417] },
    { "rip2PeerAddress", "1.3.6.1.2.1.23.4.1.1", &_names[2417],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2407], &_types[2422], NULLOT, &_types[2418] },
    { "rip2PeerDomain", "1.3.6.1.2.1.23.4.1.2", &_names[2418],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 2, 2,
      NULL, NULL, NULL,
      &_types[2408], &_types[2417], NULLOT, &_types[2419] },
    { "rip2PeerLastUpdate", "1.3.6.1.2.1.23.4.1.3", &_names[2419],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2403], NULLOT, NULLOT, &_types[2420] },
    { "rip2PeerVersion", "1.3.6.1.2.1.23.4.1.4", &_names[2420],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[2323], &_types[2418], NULLOT, &_types[2421] },
    { "rip2PeerRcvBadPackets", "1.3.6.1.2.1.23.4.1.5", &_names[2421],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2401], &_types[2419], NULLOT, &_types[2422] },
    { "rip2PeerRcvBadRoutes", "1.3.6.1.2.1.23.4.1.6", &_names[2422],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2402], &_types[2421], NULLOT, &_types[2423] },
    { "ident", "1.3.6.1.2.1.24", &_names[2423],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2055], NULLOT, &_types[2424], &_types[2424] },
    { "identInfo", "1.3.6.1.2.1.24.1", &_names[2424],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2417], NULLOT, &_types[2425], &_types[2425] },
    { "identTable", "1.3.6.1.2.1.24.1.1", &_names[2425],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2415], NULLOT, &_types[2426], &_types[2426] },
    { "identEntry", "1.3.6.1.2.1.24.1.1.1", &_names[2426],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "tcpConnLocalAddress tcpConnLocalPort tcpConnRemAddress tcpConnRemPort", NULL, NULL,
      &_types[2416], NULLOT, &_types[2427], &_types[2427] },
    { "identStatus", "1.3.6.1.2.1.24.1.1.1.1", &_names[2427],
      (OS) 174, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2414], &_types[2429], NULLOT, &_types[2428] },
    { "identOpSys", "1.3.6.1.2.1.24.1.1.1.2", &_names[2428],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2316], NULLOT, NULLOT, &_types[2429] },
    { "identCharset", "1.3.6.1.2.1.24.1.1.1.3", &_names[2429],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2413], &_types[2431], NULLOT, &_types[2430] },
    { "identUserid", "1.3.6.1.2.1.24.1.1.1.4", &_names[2430],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2198], &_types[2428], NULLOT, &_types[2431] },
    { "identMisc", "1.3.6.1.2.1.24.1.1.1.5", &_names[2431],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2380], &_types[2430], NULLOT, &_types[2432] },
    { "host", "1.3.6.1.2.1.25", &_names[2432],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2152], &_types[1538], &_types[2546], &_types[2433] },
    { "hrSystem", "1.3.6.1.2.1.25.1", &_names[2433],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2428], NULLOT, &_types[2439], &_types[2434] },
    { "hrSystemUptime", "1.3.6.1.2.1.25.1.1", &_names[2434],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2529], &_types[2435], NULLOT, &_types[2435] },
    { "hrSystemDate", "1.3.6.1.2.1.25.1.2", &_names[2435],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[2431], &_types[2438], NULLOT, &_types[2436] },
    { "hrSystemInitialLoadDevice", "1.3.6.1.2.1.25.1.3", &_names[2436],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2461], NULLOT, NULLOT, &_types[2437] },
    { "hrSystemInitialLoadParameters", "1.3.6.1.2.1.25.1.4", &_names[2437],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2542], &_types[2434], NULLOT, &_types[2438] },
    { "hrSystemNumUsers", "1.3.6.1.2.1.25.1.5", &_names[2438],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2430], &_types[2436], NULLOT, &_types[2439] },
    { "hrSystemProcesses", "1.3.6.1.2.1.25.1.6", &_names[2439],
      (OS) 11, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2465], &_types[2440], NULLOT, &_types[2440] },
    { "hrSystemMaxProcesses", "1.3.6.1.2.1.25.1.7", &_names[2440],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2439], &_types[2437], NULLOT, &_types[2441] },
    { "hrStorage", "1.3.6.1.2.1.25.2", &_names[2441],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2170], &_types[2562], &_types[2442], &_types[2442] },
    { "hrStorageTypes", "1.3.6.1.2.1.25.2.1", &_names[2442],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2546], &_types[2451], &_types[2443], &_types[2443] },
    { "hrStorageOther", "1.3.6.1.2.1.25.2.1.1", &_names[2443],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2420], &_types[2444], NULLOT, &_types[2444] },
    { "hrStorageRam", "1.3.6.1.2.1.25.2.1.2", &_names[2444],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2230], &_types[2445], NULLOT, &_types[2445] },
    { "hrStorageVirtualMemory", "1.3.6.1.2.1.25.2.1.3", &_names[2445],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2425], &_types[2446], NULLOT, &_types[2446] },
    { "hrStorageFixedDisk", "1.3.6.1.2.1.25.2.1.4", &_names[2446],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2562], &_types[2447], NULLOT, &_types[2447] },
    { "hrStorageRemovableDisk", "1.3.6.1.2.1.25.2.1.5", &_names[2447],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2446], &_types[2448], NULLOT, &_types[2448] },
    { "hrStorageFloppyDisk", "1.3.6.1.2.1.25.2.1.6", &_names[2448],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2447], &_types[2449], NULLOT, &_types[2449] },
    { "hrStorageCompactDisc", "1.3.6.1.2.1.25.2.1.7", &_names[2449],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2448], &_types[2450], NULLOT, &_types[2450] },
    { "hrStorageRamDisk", "1.3.6.1.2.1.25.2.1.8", &_names[2450],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2449], NULLOT, NULLOT, &_types[2451] },
    { "hrMemorySize", "1.3.6.1.2.1.25.2.2", &_names[2451],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2471], &_types[2452], NULLOT, &_types[2452] },
    { "hrStorageTable", "1.3.6.1.2.1.25.2.3", &_names[2452],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2480], NULLOT, &_types[2453], &_types[2453] },
    { "hrStorageEntry", "1.3.6.1.2.1.25.2.3.1", &_names[2453],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrStorageIndex", NULL, NULL,
      &_types[2524], NULLOT, &_types[2455], &_types[2454] },
    { "hrStorageIndex", "1.3.6.1.2.1.25.2.3.1.1", &_names[2454],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2472], &_types[2457], NULLOT, &_types[2455] },
    { "hrStorageType", "1.3.6.1.2.1.25.2.3.1.2", &_names[2455],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2453], &_types[2458], NULLOT, &_types[2456] },
    { "hrStorageDescr", "1.3.6.1.2.1.25.2.3.1.3", &_names[2456],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2342], NULLOT, NULLOT, &_types[2457] },
    { "hrStorageAllocationUnits", "1.3.6.1.2.1.25.2.3.1.4", &_names[2457],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2470], &_types[2460], NULLOT, &_types[2458] },
    { "hrStorageSize", "1.3.6.1.2.1.25.2.3.1.5", &_names[2458],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2451], &_types[2454], NULLOT, &_types[2459] },
    { "hrStorageUsed", "1.3.6.1.2.1.25.2.3.1.6", &_names[2459],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2438], &_types[2456], NULLOT, &_types[2460] },
    { "hrStorageAllocationFailures", "1.3.6.1.2.1.25.2.3.1.7", &_names[2460],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2314], &_types[2459], NULLOT, &_types[2461] },
    { "hrDevice", "1.3.6.1.2.1.25.3", &_names[2461],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2263], &_types[2441], &_types[2462], &_types[2462] },
    { "hrDeviceTypes", "1.3.6.1.2.1.25.3.1", &_names[2462],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2442], &_types[2524], &_types[2467], &_types[2463] },
    { "hrDeviceOther", "1.3.6.1.2.1.25.3.1.1", &_names[2463],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2443], &_types[2477], NULLOT, &_types[2464] },
    { "hrDeviceUnknown", "1.3.6.1.2.1.25.3.1.2", &_names[2464],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2421], &_types[2469], NULLOT, &_types[2465] },
    { "hrDeviceProcessor", "1.3.6.1.2.1.25.3.1.3", &_names[2465],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2433], NULLOT, NULLOT, &_types[2466] },
    { "hrDeviceNetwork", "1.3.6.1.2.1.25.3.1.4", &_names[2466],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2557], &_types[2479], NULLOT, &_types[2467] },
    { "hrDevicePrinter", "1.3.6.1.2.1.25.3.1.5", &_names[2467],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2334], &_types[2478], NULLOT, &_types[2468] },
    { "hrDeviceDiskStorage", "1.3.6.1.2.1.25.3.1.6", &_names[2468],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2450], &_types[2465], NULLOT, &_types[2469] },
    { "hrDeviceVideo", "1.3.6.1.2.1.25.3.1.10", &_names[2469],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2086], &_types[2470], NULLOT, &_types[2470] },
    { "hrDeviceAudio", "1.3.6.1.2.1.25.3.1.11", &_names[2470],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2412], &_types[2475], NULLOT, &_types[2471] },
    { "hrDeviceCoprocessor", "1.3.6.1.2.1.25.3.1.12", &_names[2471],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2395], &_types[2463], NULLOT, &_types[2472] },
    { "hrDeviceKeyboard", "1.3.6.1.2.1.25.3.1.13", &_names[2472],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2410], &_types[2466], NULLOT, &_types[2473] },
    { "hrDeviceModem", "1.3.6.1.2.1.25.3.1.14", &_names[2473],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2418], &_types[2472], NULLOT, &_types[2474] },
    { "hrDeviceParallelPort", "1.3.6.1.2.1.25.3.1.15", &_names[2474],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2337], &_types[2476], NULLOT, &_types[2475] },
    { "hrDevicePointing", "1.3.6.1.2.1.25.3.1.16", &_names[2475],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2423], &_types[2468], NULLOT, &_types[2476] },
    { "hrDeviceSerialPort", "1.3.6.1.2.1.25.3.1.17", &_names[2476],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2474], &_types[2464], NULLOT, &_types[2477] },
    { "hrDeviceTape", "1.3.6.1.2.1.25.3.1.18", &_names[2477],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2463], &_types[2473], NULLOT, &_types[2478] },
    { "hrDeviceClock", "1.3.6.1.2.1.25.3.1.19", &_names[2478],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2317], &_types[2471], NULLOT, &_types[2479] },
    { "hrDeviceVolatileMemory", "1.3.6.1.2.1.25.3.1.20", &_names[2479],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2445], &_types[2480], NULLOT, &_types[2480] },
    { "hrDeviceNonVolatileMemory", "1.3.6.1.2.1.25.3.1.21", &_names[2480],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2479], &_types[2474], NULLOT, &_types[2481] },
    { "hrDeviceTable", "1.3.6.1.2.1.25.3.2", &_names[2481],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2452], &_types[2489], &_types[2482], &_types[2482] },
    { "hrDeviceEntry", "1.3.6.1.2.1.25.3.2.1", &_names[2482],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrDeviceIndex", NULL, NULL,
      &_types[2455], NULLOT, &_types[2484], &_types[2483] },
    { "hrDeviceIndex", "1.3.6.1.2.1.25.3.2.1.1", &_names[2483],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2454], &_types[2485], NULLOT, &_types[2484] },
    { "hrDeviceType", "1.3.6.1.2.1.25.3.2.1.2", &_names[2484],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2482], &_types[2488], NULLOT, &_types[2485] },
    { "hrDeviceDescr", "1.3.6.1.2.1.25.3.2.1.3", &_names[2485],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 64,
      NULL, NULL, NULL,
      &_types[2456], NULLOT, NULLOT, &_types[2486] },
    { "hrDeviceID", "1.3.6.1.2.1.25.3.2.1.4", &_names[2486],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2458], &_types[2487], NULLOT, &_types[2487] },
    { "hrDeviceStatus", "1.3.6.1.2.1.25.3.2.1.5", &_names[2487],
      (OS) 175, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2427], &_types[2483], NULLOT, &_types[2488] },
    { "hrDeviceErrors", "1.3.6.1.2.1.25.3.2.1.6", &_names[2488],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2382], &_types[2486], NULLOT, &_types[2489] },
    { "hrProcessorTable", "1.3.6.1.2.1.25.3.3", &_names[2489],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2481], &_types[2493], &_types[2490], &_types[2490] },
    { "hrProcessorEntry", "1.3.6.1.2.1.25.3.3.1", &_names[2490],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrDeviceIndex", NULL, NULL,
      &_types[2484], NULLOT, &_types[2491], &_types[2491] },
    { "hrProcessorFrwID", "1.3.6.1.2.1.25.3.3.1.1", &_names[2491],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2486], &_types[2492], NULLOT, &_types[2492] },
    { "hrProcessorLoad", "1.3.6.1.2.1.25.3.3.1.2", &_names[2492],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 100,
      NULL, NULL, NULL,
      &_types[2444], NULLOT, NULLOT, &_types[2493] },
    { "hrNetworkTable", "1.3.6.1.2.1.25.3.4", &_names[2493],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2489], &_types[2496], &_types[2494], &_types[2494] },
    { "hrNetworkEntry", "1.3.6.1.2.1.25.3.4.1", &_names[2494],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrDeviceIndex", NULL, NULL,
      &_types[2490], NULLOT, &_types[2495], &_types[2495] },
    { "hrNetworkIfIndex", "1.3.6.1.2.1.25.3.4.1.1", &_names[2495],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2483], NULLOT, NULLOT, &_types[2496] },
    { "hrPrinterTable", "1.3.6.1.2.1.25.3.5", &_names[2496],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2493], &_types[2500], &_types[2497], &_types[2497] },
    { "hrPrinterEntry", "1.3.6.1.2.1.25.3.5.1", &_names[2497],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrDeviceIndex", NULL, NULL,
      &_types[2494], NULLOT, &_types[2498], &_types[2498] },
    { "hrPrinterStatus", "1.3.6.1.2.1.25.3.5.1.1", &_names[2498],
      (OS) 176, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2487], &_types[2499], NULLOT, &_types[2499] },
    { "hrPrinterDetectedErrorState", "1.3.6.1.2.1.25.3.5.1.2", &_names[2499],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2498], NULLOT, NULLOT, &_types[2500] },
    { "hrDiskStorageTable", "1.3.6.1.2.1.25.3.6", &_names[2500],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2496], &_types[2506], &_types[2501], &_types[2501] },
    { "hrDiskStorageEntry", "1.3.6.1.2.1.25.3.6.1", &_names[2501],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrDeviceIndex", NULL, NULL,
      &_types[2497], NULLOT, &_types[2502], &_types[2502] },
    { "hrDiskStorageAccess", "1.3.6.1.2.1.25.3.6.1.1", &_names[2502],
      (OS) 177, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2437], &_types[2504], NULLOT, &_types[2503] },
    { "hrDiskStorageMedia", "1.3.6.1.2.1.25.3.6.1.2", &_names[2503],
      (OS) 178, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1411], NULLOT, NULLOT, &_types[2504] },
    { "hrDiskStorageRemoveble", "1.3.6.1.2.1.25.3.6.1.3", &_names[2504],
      (OS) 179, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2329], &_types[2505], NULLOT, &_types[2505] },
    { "hrDiskStorageCapacity", "1.3.6.1.2.1.25.3.6.1.4", &_names[2505],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2526], &_types[2503], NULLOT, &_types[2506] },
    { "hrPartitionTable", "1.3.6.1.2.1.25.3.7", &_names[2506],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2500], &_types[2513], &_types[2507], &_types[2507] },
    { "hrPartitionEntry", "1.3.6.1.2.1.25.3.7.1", &_names[2507],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrDeviceIndex hrPartitionIndex", NULL, NULL,
      &_types[2501], NULLOT, &_types[2510], &_types[2508] },
    { "hrPartitionIndex", "1.3.6.1.2.1.25.3.7.1.1", &_names[2508],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2495], &_types[2512], NULLOT, &_types[2509] },
    { "hrPartitionLabel", "1.3.6.1.2.1.25.3.7.1.2", &_names[2509],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2537], NULLOT, NULLOT, &_types[2510] },
    { "hrPartitionID", "1.3.6.1.2.1.25.3.7.1.3", &_names[2510],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2491], &_types[2511], NULLOT, &_types[2511] },
    { "hrPartitionSize", "1.3.6.1.2.1.25.3.7.1.4", &_names[2511],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2510], &_types[2508], NULLOT, &_types[2512] },
    { "hrPartitionFSIndex", "1.3.6.1.2.1.25.3.7.1.5", &_names[2512],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2508], &_types[2509], NULLOT, &_types[2513] },
    { "hrFSTable", "1.3.6.1.2.1.25.3.8", &_names[2513],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2506], NULLOT, &_types[2514], &_types[2514] },
    { "hrFSEntry", "1.3.6.1.2.1.25.3.8.1", &_names[2514],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrFSIndex", NULL, NULL,
      &_types[2507], NULLOT, &_types[2518], &_types[2515] },
    { "hrFSIndex", "1.3.6.1.2.1.25.3.8.1.1", &_names[2515],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2512], &_types[2521], NULLOT, &_types[2516] },
    { "hrFSMountPoint", "1.3.6.1.2.1.25.3.8.1.2", &_names[2516],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2475], &_types[2517], NULLOT, &_types[2517] },
    { "hrFSRemoteMountPoint", "1.3.6.1.2.1.25.3.8.1.3", &_names[2517],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2516], NULLOT, NULLOT, &_types[2518] },
    { "hrFSType", "1.3.6.1.2.1.25.3.8.1.4", &_names[2518],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2514], &_types[2520], NULLOT, &_types[2519] },
    { "hrFSAccess", "1.3.6.1.2.1.25.3.8.1.5", &_names[2519],
      (OS) 180, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2502], &_types[2515], NULLOT, &_types[2520] },
    { "hrFSBootable", "1.3.6.1.2.1.25.3.8.1.6", &_names[2520],
      (OS) 181, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2473], &_types[2519], NULLOT, &_types[2521] },
    { "hrFSStorageIndex", "1.3.6.1.2.1.25.3.8.1.7", &_names[2521],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2515], &_types[2522], NULLOT, &_types[2522] },
    { "hrFSLastFullBackupDate", "1.3.6.1.2.1.25.3.8.1.8", &_names[2522],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[2435], &_types[2523], NULLOT, &_types[2523] },
    { "hrFSLastPartialBackupDate", "1.3.6.1.2.1.25.3.8.1.9", &_names[2523],
      (OS) 2, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[2522], &_types[2516], NULLOT, &_types[2524] },
    { "hrFSTypes", "1.3.6.1.2.1.25.3.9", &_names[2524],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2462], &_types[2481], &_types[2525], &_types[2525] },
    { "hrFSOther", "1.3.6.1.2.1.25.3.9.1", &_names[2525],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2477], &_types[2534], NULLOT, &_types[2526] },
    { "hrFSUnknown", "1.3.6.1.2.1.25.3.9.2", &_names[2526],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2464], &_types[2537], NULLOT, &_types[2527] },
    { "hrFSBerkeleyFFS", "1.3.6.1.2.1.25.3.9.3", &_names[2527],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1534], &_types[2528], NULLOT, &_types[2528] },
    { "hrFSSys5FS", "1.3.6.1.2.1.25.3.9.4", &_names[2528],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2527], &_types[2530], NULLOT, &_types[2529] },
    { "hrFSFat", "1.3.6.1.2.1.25.3.9.5", &_names[2529],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2394], &_types[2526], NULLOT, &_types[2530] },
    { "hrFSHPFS", "1.3.6.1.2.1.25.3.9.6", &_names[2530],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2528], &_types[2531], NULLOT, &_types[2531] },
    { "hrFSHFS", "1.3.6.1.2.1.25.3.9.7", &_names[2531],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2530], &_types[2532], NULLOT, &_types[2532] },
    { "hrFSMFS", "1.3.6.1.2.1.25.3.9.8", &_names[2532],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2531], &_types[2533], NULLOT, &_types[2533] },
    { "hrFSNTFS", "1.3.6.1.2.1.25.3.9.9", &_names[2533],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2532], &_types[2538], NULLOT, &_types[2534] },
    { "hrFSVNode", "1.3.6.1.2.1.25.3.9.10", &_names[2534],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2525], &_types[2542], NULLOT, &_types[2535] },
    { "hrFSJournaled", "1.3.6.1.2.1.25.3.9.11", &_names[2535],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2149], NULLOT, NULLOT, &_types[2536] },
    { "hrFSiso9660", "1.3.6.1.2.1.25.3.9.12", &_names[2536],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2466], &_types[2539], NULLOT, &_types[2537] },
    { "hrFSRockRidge", "1.3.6.1.2.1.25.3.9.13", &_names[2537],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[101], &_types[2527], NULLOT, &_types[2538] },
    { "hrFSNFS", "1.3.6.1.2.1.25.3.9.14", &_names[2538],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2533], &_types[2540], NULLOT, &_types[2539] },
    { "hrFSNetware", "1.3.6.1.2.1.25.3.9.15", &_names[2539],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2536], &_types[2529], NULLOT, &_types[2540] },
    { "hrFSAFS", "1.3.6.1.2.1.25.3.9.16", &_names[2540],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2538], &_types[2541], NULLOT, &_types[2541] },
    { "hrFSDFS", "1.3.6.1.2.1.25.3.9.17", &_names[2541],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2540], &_types[2543], NULLOT, &_types[2542] },
    { "hrFSAppleshare", "1.3.6.1.2.1.25.3.9.18", &_names[2542],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2424], &_types[2536], NULLOT, &_types[2543] },
    { "hrFSRFS", "1.3.6.1.2.1.25.3.9.19", &_names[2543],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2541], &_types[2544], NULLOT, &_types[2544] },
    { "hrFSDGCFS", "1.3.6.1.2.1.25.3.9.20", &_names[2544],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2543], &_types[2545], NULLOT, &_types[2545] },
    { "hrFSBFS", "1.3.6.1.2.1.25.3.9.21", &_names[2545],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2544], &_types[2535], NULLOT, &_types[2546] },
    { "hrSWRun", "1.3.6.1.2.1.25.4", &_names[2546],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2426], &_types[2557], &_types[2547], &_types[2547] },
    { "hrSWOSIndex", "1.3.6.1.2.1.25.4.1", &_names[2547],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2521], &_types[2548], NULLOT, &_types[2548] },
    { "hrSWRunTable", "1.3.6.1.2.1.25.4.2", &_names[2548],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2513], NULLOT, &_types[2549], &_types[2549] },
    { "hrSWRunEntry", "1.3.6.1.2.1.25.4.2.1", &_names[2549],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrSWRunIndex", NULL, NULL,
      &_types[2518], NULLOT, &_types[2555], &_types[2550] },
    { "hrSWRunIndex", "1.3.6.1.2.1.25.4.2.1.1", &_names[2550],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2547], &_types[2551], NULLOT, &_types[2551] },
    { "hrSWRunName", "1.3.6.1.2.1.25.4.2.1.2", &_names[2551],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2504], NULLOT, NULLOT, &_types[2552] },
    { "hrSWRunID", "1.3.6.1.2.1.25.4.2.1.3", &_names[2552],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2511], &_types[2553], NULLOT, &_types[2553] },
    { "hrSWRunPath", "1.3.6.1.2.1.25.4.2.1.4", &_names[2553],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2534], &_types[2554], NULLOT, &_types[2554] },
    { "hrSWRunParameters", "1.3.6.1.2.1.25.4.2.1.5", &_names[2554],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2519], &_types[2556], NULLOT, &_types[2555] },
    { "hrSWRunType", "1.3.6.1.2.1.25.4.2.1.6", &_names[2555],
      (OS) 182, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2549], &_types[2552], NULLOT, &_types[2556] },
    { "hrSWRunStatus", "1.3.6.1.2.1.25.4.2.1.7", &_names[2556],
      (OS) 183, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2499], &_types[2550], NULLOT, &_types[2557] },
    { "hrSWRunPerf", "1.3.6.1.2.1.25.5", &_names[2557],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2169], &_types[2461], &_types[2558], &_types[2558] },
    { "hrSWRunPerfTable", "1.3.6.1.2.1.25.5.1", &_names[2558],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2548], NULLOT, &_types[2559], &_types[2559] },
    { "hrSWRunPerfEntry", "1.3.6.1.2.1.25.5.1.1", &_names[2559],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrSWRunIndex", NULL, NULL,
      &_types[2555], NULLOT, &_types[2561], &_types[2560] },
    { "hrSWRunPerfCPU", "1.3.6.1.2.1.25.5.1.1.1", &_names[2560],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2436], NULLOT, NULLOT, &_types[2561] },
    { "hrSWRunPerfMem", "1.3.6.1.2.1.25.5.1.1.2", &_names[2561],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2558], &_types[2560], NULLOT, &_types[2562] },
    { "hrSWInstalled", "1.3.6.1.2.1.25.6", &_names[2562],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2441], &_types[2433], &_types[2563], &_types[2563] },
    { "hrSWInstalledLastChange", "1.3.6.1.2.1.25.6.1", &_names[2563],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2429], &_types[2564], NULLOT, &_types[2564] },
    { "hrSWInstalledLastUpdateTime", "1.3.6.1.2.1.25.6.2", &_names[2564],
      (OS) 14, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2422], &_types[2565], NULLOT, &_types[2565] },
    { "hrSWInstalledTable", "1.3.6.1.2.1.25.6.3", &_names[2565],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2561], NULLOT, &_types[2566], &_types[2566] },
    { "hrSWInstalledEntry", "1.3.6.1.2.1.25.6.3.1", &_names[2566],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "hrSWInstalledIndex", NULL, NULL,
      &_types[2559], NULLOT, &_types[2570], &_types[2567] },
    { "hrSWInstalledIndex", "1.3.6.1.2.1.25.6.3.1.1", &_names[2567],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2550], &_types[2568], NULLOT, &_types[2568] },
    { "hrSWInstalledName", "1.3.6.1.2.1.25.6.3.1.2", &_names[2568],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2551], &_types[2571], NULLOT, &_types[2569] },
    { "hrSWInstalledID", "1.3.6.1.2.1.25.6.3.1.3", &_names[2569],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2552], &_types[2567], NULLOT, &_types[2570] },
    { "hrSWInstalledType", "1.3.6.1.2.1.25.6.3.1.4", &_names[2570],
      (OS) 184, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2566], &_types[2569], NULLOT, &_types[2571] },
    { "hrSWInstalledDate", "1.3.6.1.2.1.25.6.3.1.5", &_names[2571],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 8, 8,
      NULL, NULL, NULL,
      &_types[2523], NULLOT, NULLOT, &_types[2572] },
    { "snmpDot3MauMgt", "1.3.6.1.2.1.26", &_names[2572],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2568], &_types[2648], &_types[2604], &_types[2573] },
    { "dot3RpMauBasicGroup", "1.3.6.1.2.1.26.1", &_names[2573],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2569], &_types[2585], &_types[2574], &_types[2574] },
    { "rpMauTable", "1.3.6.1.2.1.26.1.1", &_names[2574],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2565], NULLOT, &_types[2575], &_types[2575] },
    { "rpMauEntry", "1.3.6.1.2.1.26.1.1.1", &_names[2575],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "rpMauGroupIndex rpMauPortIndex rpMauIndex", NULL, NULL,
      &_types[2604], NULLOT, &_types[2579], &_types[2576] },
    { "rpMauGroupIndex", "1.3.6.1.2.1.26.1.1.1.1", &_names[2576],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2613], &_types[2577], NULLOT, &_types[2577] },
    { "rpMauPortIndex", "1.3.6.1.2.1.26.1.1.1.2", &_names[2577],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 1024,
      NULL, NULL, NULL,
      &_types[2576], &_types[2578], NULLOT, &_types[2578] },
    { "rpMauIndex", "1.3.6.1.2.1.26.1.1.1.3", &_names[2578],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 9,
      NULL, NULL, NULL,
      &_types[2577], &_types[2582], NULLOT, &_types[2579] },
    { "rpMauType", "1.3.6.1.2.1.26.1.1.1.4", &_names[2579],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2575], &_types[2584], NULLOT, &_types[2580] },
    { "rpMauStatus", "1.3.6.1.2.1.26.1.1.1.5", &_names[2580],
      (OS) 185, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2607], &_types[2583], NULLOT, &_types[2581] },
    { "rpMauMediaAvailable", "1.3.6.1.2.1.26.1.1.1.6", &_names[2581],
      (OS) 186, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2503], NULLOT, NULLOT, &_types[2582] },
    { "rpMauMediaAvailableStateExits", "1.3.6.1.2.1.26.1.1.1.7", &_names[2582],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1848], &_types[2581], NULLOT, &_types[2583] },
    { "rpMauJabberState", "1.3.6.1.2.1.26.1.1.1.8", &_names[2583],
      (OS) 187, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2580], &_types[2576], NULLOT, &_types[2584] },
    { "rpMauJabberingStateEnters", "1.3.6.1.2.1.26.1.1.1.9", &_names[2584],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2579], &_types[2580], NULLOT, &_types[2585] },
    { "dot3IfMauBasicGroup", "1.3.6.1.2.1.26.2", &_names[2585],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2573], &_types[2596], &_types[2586], &_types[2586] },
    { "ifMauTable", "1.3.6.1.2.1.26.2.1", &_names[2586],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2574], NULLOT, &_types[2587], &_types[2587] },
    { "ifMauEntry", "1.3.6.1.2.1.26.2.1.1", &_names[2587],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "ifMauIfIndex ifMauIndex", NULL, NULL,
      &_types[2584], NULLOT, &_types[2590], &_types[2588] },
    { "ifMauIfIndex", "1.3.6.1.2.1.26.2.1.1.1", &_names[2588],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2578], &_types[2589], NULLOT, &_types[2589] },
    { "ifMauIndex", "1.3.6.1.2.1.26.2.1.1.2", &_names[2589],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 9,
      NULL, NULL, NULL,
      &_types[2588], &_types[2593], NULLOT, &_types[2590] },
    { "ifMauType", "1.3.6.1.2.1.26.2.1.1.3", &_names[2590],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2587], &_types[2595], NULLOT, &_types[2591] },
    { "ifMauStatus", "1.3.6.1.2.1.26.2.1.1.4", &_names[2591],
      (OS) 188, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2583], &_types[2594], NULLOT, &_types[2592] },
    { "ifMauMediaAvailable", "1.3.6.1.2.1.26.2.1.1.5", &_names[2592],
      (OS) 189, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2581], NULLOT, NULLOT, &_types[2593] },
    { "ifMauMediaAvailableStateExits", "1.3.6.1.2.1.26.2.1.1.6", &_names[2593],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2582], &_types[2592], NULLOT, &_types[2594] },
    { "ifMauJabberState", "1.3.6.1.2.1.26.2.1.1.7", &_names[2594],
      (OS) 190, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2591], &_types[2588], NULLOT, &_types[2595] },
    { "ifMauJabberingStateEnters", "1.3.6.1.2.1.26.2.1.1.8", &_names[2595],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2590], &_types[2591], NULLOT, &_types[2596] },
    { "dot3BroadMauBasicGroup", "1.3.6.1.2.1.26.3", &_names[2596],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2585], NULLOT, &_types[2597], &_types[2597] },
    { "broadMauBasicTable", "1.3.6.1.2.1.26.3.1", &_names[2597],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2586], NULLOT, &_types[2598], &_types[2598] },
    { "broadMauBasicEntry", "1.3.6.1.2.1.26.3.1.1", &_names[2598],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "broadMauIfIndex broadMauIndex", NULL, NULL,
      &_types[2595], NULLOT, &_types[2601], &_types[2599] },
    { "broadMauIfIndex", "1.3.6.1.2.1.26.3.1.1.1", &_names[2599],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2589], &_types[2600], NULLOT, &_types[2600] },
    { "broadMauIndex", "1.3.6.1.2.1.26.3.1.1.2", &_names[2600],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 9,
      NULL, NULL, NULL,
      &_types[2599], &_types[2602], NULLOT, &_types[2601] },
    { "broadMauXmtRcvSplitType", "1.3.6.1.2.1.26.3.1.1.3", &_names[2601],
      (OS) 191, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2598], &_types[2599], NULLOT, &_types[2602] },
    { "broadMauXmtCarrierFreq", "1.3.6.1.2.1.26.3.1.1.4", &_names[2602],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2434], &_types[2603], NULLOT, &_types[2603] },
    { "broadMauTranslationFreq", "1.3.6.1.2.1.26.3.1.1.5", &_names[2603],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2602], NULLOT, NULLOT, &_types[2604] },
    { "dot3MauType", "1.3.6.1.2.1.26.4", &_names[2604],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2570], &_types[2573], &_types[2605], &_types[2605] },
    { "dot3MauTypeAUI", "1.3.6.1.2.1.26.4.1", &_names[2605],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2286], &_types[2611], NULLOT, &_types[2606] },
    { "dot3MauType10Base5", "1.3.6.1.2.1.26.4.2", &_names[2606],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2379], &_types[2608], NULLOT, &_types[2607] },
    { "dot3MauTypeFoirl", "1.3.6.1.2.1.26.4.3", &_names[2607],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2556], &_types[2613], NULLOT, &_types[2608] },
    { "dot3MauType10Base2", "1.3.6.1.2.1.26.4.4", &_names[2608],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2606], &_types[2609], NULLOT, &_types[2609] },
    { "dot3MauType10BaseT", "1.3.6.1.2.1.26.4.5", &_names[2609],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2610], NULLOT, &_types[2610] },
    { "dot3MauType10BaseFP", "1.3.6.1.2.1.26.4.6", &_names[2610],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2535], &_types[2612], NULLOT, &_types[2611] },
    { "dot3MauType10BaseFB", "1.3.6.1.2.1.26.4.7", &_names[2611],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2520], &_types[2607], NULLOT, &_types[2612] },
    { "dot3MauType10BaseFL", "1.3.6.1.2.1.26.4.8", &_names[2612],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2432], NULLOT, NULLOT, &_types[2613] },
    { "dot3MauType10Broad36", "1.3.6.1.2.1.26.4.9", &_names[2613],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2567], &_types[2606], NULLOT, &_types[2614] },
    { "application", "1.3.6.1.2.1.27", &_names[2614],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2554], &_types[2288], &_types[2615], &_types[2615] },
    { "applTable", "1.3.6.1.2.1.27.1", &_names[2615],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2597], &_types[2632], &_types[2616], &_types[2616] },
    { "applEntry", "1.3.6.1.2.1.27.1.1", &_names[2616],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex", NULL, NULL,
      &_types[2601], NULLOT, &_types[2620], &_types[2617] },
    { "applIndex", "1.3.6.1.2.1.27.1.1.1", &_names[2617],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2600], &_types[2623], NULLOT, &_types[2618] },
    { "applName", "1.3.6.1.2.1.27.1.1.2", &_names[2618],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2572], &_types[2619], NULLOT, &_types[2619] },
    { "applDirectoryName", "1.3.6.1.2.1.27.1.1.3", &_names[2619],
      (OS) 192, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2618], &_types[2621], NULLOT, &_types[2620] },
    { "applVersion", "1.3.6.1.2.1.27.1.1.4", &_names[2620],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2553], &_types[2624], NULLOT, &_types[2621] },
    { "applUptime", "1.3.6.1.2.1.27.1.1.5", &_names[2621],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2603], &_types[2628], NULLOT, &_types[2622] },
    { "applOperStatus", "1.3.6.1.2.1.27.1.1.6", &_names[2622],
      (OS) 193, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2594], &_types[2617], NULLOT, &_types[2623] },
    { "applLastChange", "1.3.6.1.2.1.27.1.1.7", &_names[2623],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2563], &_types[2618], NULLOT, &_types[2624] },
    { "applInboundAssociations", "1.3.6.1.2.1.27.1.1.8", &_names[2624],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2643], &_types[2625], NULLOT, &_types[2625] },
    { "applOutboundAssociations", "1.3.6.1.2.1.27.1.1.9", &_names[2625],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2624], &_types[2626], NULLOT, &_types[2626] },
    { "applAccumulatedInboundAssociations", "1.3.6.1.2.1.27.1.1.10", &_names[2626],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2625], &_types[2627], NULLOT, &_types[2627] },
    { "applAccumulatedOutboundAssociations", "1.3.6.1.2.1.27.1.1.11", &_names[2627],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2626], &_types[2630], NULLOT, &_types[2628] },
    { "applLastInboundActivity", "1.3.6.1.2.1.27.1.1.12", &_names[2628],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2485], &_types[2629], NULLOT, &_types[2629] },
    { "applLastOutboundActivity", "1.3.6.1.2.1.27.1.1.13", &_names[2629],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2628], NULLOT, NULLOT, &_types[2630] },
    { "applRejectedInboundAssociations", "1.3.6.1.2.1.27.1.1.14", &_names[2630],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2627], &_types[2631], NULLOT, &_types[2631] },
    { "applFailedOutboundAssociations", "1.3.6.1.2.1.27.1.1.15", &_names[2631],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2630], &_types[2622], NULLOT, &_types[2632] },
    { "assocTable", "1.3.6.1.2.1.27.2", &_names[2632],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2615], &_types[2646], &_types[2633], &_types[2633] },
    { "assocEntry", "1.3.6.1.2.1.27.2.1", &_names[2633],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex assocIndex", NULL, NULL,
      &_types[2616], NULLOT, &_types[2637], &_types[2634] },
    { "assocIndex", "1.3.6.1.2.1.27.2.1.1", &_names[2634],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2617], &_types[2636], NULLOT, &_types[2635] },
    { "assocRemoteApplication", "1.3.6.1.2.1.27.2.1.2", &_names[2635],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2631], &_types[2638], NULLOT, &_types[2636] },
    { "assocApplicationProtocol", "1.3.6.1.2.1.27.2.1.3", &_names[2636],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2440], NULLOT, NULLOT, &_types[2637] },
    { "assocApplicationType", "1.3.6.1.2.1.27.2.1.4", &_names[2637],
      (OS) 194, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2633], &_types[2635], NULLOT, &_types[2638] },
    { "assocDuration", "1.3.6.1.2.1.27.2.1.5", &_names[2638],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2635], &_types[2634], NULLOT, &_types[2639] },
    { "applConformance", "1.3.6.1.2.1.27.3", &_names[2639],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2611], NULLOT, &_types[2643], &_types[2640] },
    { "applGroups", "1.3.6.1.2.1.27.3.1", &_names[2640],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2596], NULLOT, &_types[2641], &_types[2641] },
    { "applGroup", "1.3.6.1.2.1.27.3.1.1", &_names[2641],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2647], &_types[2642], NULLOT, &_types[2642] },
    { "assocGroup", "1.3.6.1.2.1.27.3.1.2", &_names[2642],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2641], NULLOT, NULLOT, &_types[2643] },
    { "applCompliances", "1.3.6.1.2.1.27.3.2", &_names[2643],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2614], &_types[2640], &_types[2644], &_types[2644] },
    { "applCompliance", "1.3.6.1.2.1.27.3.2.1", &_names[2644],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2638], &_types[2645], NULLOT, &_types[2645] },
    { "assocCompliance", "1.3.6.1.2.1.27.3.2.2", &_names[2645],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2644], NULLOT, NULLOT, &_types[2646] },
    { "applTCPProtoID", "1.3.6.1.2.1.27.4", &_names[2646],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2640], &_types[2647], NULLOT, &_types[2647] },
    { "applUDPProtoID", "1.3.6.1.2.1.27.5", &_names[2647],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2646], &_types[2639], NULLOT, &_types[2648] },
    { "mta", "1.3.6.1.2.1.28", &_names[2648],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2619], &_types[1961], &_types[2649], &_types[2649] },
    { "mtaTable", "1.3.6.1.2.1.28.1", &_names[2649],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2632], &_types[2660], &_types[2650], &_types[2650] },
    { "mtaEntry", "1.3.6.1.2.1.28.1.1", &_names[2650],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex", NULL, NULL,
      &_types[2637], NULLOT, &_types[2651], &_types[2651] },
    { "mtaReceivedMessages", "1.3.6.1.2.1.28.1.1.1", &_names[2651],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2324], &_types[2652], NULLOT, &_types[2652] },
    { "mtaStoredMessages", "1.3.6.1.2.1.28.1.1.2", &_names[2652],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2651], &_types[2653], NULLOT, &_types[2653] },
    { "mtaTransmittedMessages", "1.3.6.1.2.1.28.1.1.3", &_names[2653],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2652], &_types[2654], NULLOT, &_types[2654] },
    { "mtaReceivedVolume", "1.3.6.1.2.1.28.1.1.4", &_names[2654],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2476], &_types[2655], NULLOT, &_types[2655] },
    { "mtaStoredVolume", "1.3.6.1.2.1.28.1.1.5", &_names[2655],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2654], &_types[2656], NULLOT, &_types[2656] },
    { "mtaTransmittedVolume", "1.3.6.1.2.1.28.1.1.6", &_names[2656],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2655], &_types[2657], NULLOT, &_types[2657] },
    { "mtaReceivedRecipients", "1.3.6.1.2.1.28.1.1.7", &_names[2657],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2457], &_types[2658], NULLOT, &_types[2658] },
    { "mtaStoredRecipients", "1.3.6.1.2.1.28.1.1.8", &_names[2658],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2657], &_types[2659], NULLOT, &_types[2659] },
    { "mtaTransmittedRecipients", "1.3.6.1.2.1.28.1.1.9", &_names[2659],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2658], NULLOT, NULLOT, &_types[2660] },
    { "mtaGroupTable", "1.3.6.1.2.1.28.2", &_names[2660],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2649], &_types[2687], &_types[2661], &_types[2661] },
    { "mtaGroupEntry", "1.3.6.1.2.1.28.2.1", &_names[2661],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex mtaGroupIndex", NULL, NULL,
      &_types[2650], NULLOT, &_types[2674], &_types[2662] },
    { "mtaGroupIndex", "1.3.6.1.2.1.28.2.1.1", &_names[2662],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2634], &_types[2663], NULLOT, &_types[2663] },
    { "mtaGroupReceivedMessages", "1.3.6.1.2.1.28.2.1.2", &_names[2663],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2653], &_types[2664], NULLOT, &_types[2664] },
    { "mtaGroupRejectedMessages", "1.3.6.1.2.1.28.2.1.3", &_names[2664],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2663], &_types[2665], NULLOT, &_types[2665] },
    { "mtaGroupStoredMessages", "1.3.6.1.2.1.28.2.1.4", &_names[2665],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2664], &_types[2666], NULLOT, &_types[2666] },
    { "mtaGroupTransmittedMessages", "1.3.6.1.2.1.28.2.1.5", &_names[2666],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2665], &_types[2686], NULLOT, &_types[2667] },
    { "mtaGroupReceivedVolume", "1.3.6.1.2.1.28.2.1.6", &_names[2667],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2656], &_types[2668], NULLOT, &_types[2668] },
    { "mtaGroupStoredVolume", "1.3.6.1.2.1.28.2.1.7", &_names[2668],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2667], &_types[2669], NULLOT, &_types[2669] },
    { "mtaGroupTransmittedVolume", "1.3.6.1.2.1.28.2.1.8", &_names[2669],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2668], &_types[2670], NULLOT, &_types[2670] },
    { "mtaGroupReceivedRecipients", "1.3.6.1.2.1.28.2.1.9", &_names[2670],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2659], &_types[2671], NULLOT, &_types[2671] },
    { "mtaGroupStoredRecipients", "1.3.6.1.2.1.28.2.1.10", &_names[2671],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2670], &_types[2672], NULLOT, &_types[2672] },
    { "mtaGroupTransmittedRecipients", "1.3.6.1.2.1.28.2.1.11", &_names[2672],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2671], &_types[2682], NULLOT, &_types[2673] },
    { "mtaGroupOldestMessageStored", "1.3.6.1.2.1.28.2.1.12", &_names[2673],
      (OS) 24, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2468], &_types[2685], NULLOT, &_types[2674] },
    { "mtaGroupInboundAssociations", "1.3.6.1.2.1.28.2.1.13", &_names[2674],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2694], &_types[2675], NULLOT, &_types[2675] },
    { "mtaGroupOutboundAssociations", "1.3.6.1.2.1.28.2.1.14", &_names[2675],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2674], &_types[2676], NULLOT, &_types[2676] },
    { "mtaGroupAccumulatedInboundAssociations", "1.3.6.1.2.1.28.2.1.15", &_names[2676],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2675], &_types[2677], NULLOT, &_types[2677] },
    { "mtaGroupAccumulatedOutboundAssociations", "1.3.6.1.2.1.28.2.1.16", &_names[2677],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2676], &_types[2680], NULLOT, &_types[2678] },
    { "mtaGroupLastInboundActivity", "1.3.6.1.2.1.28.2.1.17", &_names[2678],
      (OS) 24, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2629], &_types[2679], NULLOT, &_types[2679] },
    { "mtaGroupLastOutboundActivity", "1.3.6.1.2.1.28.2.1.18", &_names[2679],
      (OS) 24, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2678], &_types[2673], NULLOT, &_types[2680] },
    { "mtaGroupRejectedInboundAssociations", "1.3.6.1.2.1.28.2.1.19", &_names[2680],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2677], &_types[2681], NULLOT, &_types[2681] },
    { "mtaGroupFailedOutboundAssociations", "1.3.6.1.2.1.28.2.1.20", &_names[2681],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2680], &_types[2684], NULLOT, &_types[2682] },
    { "mtaGroupInboundRejectionReason", "1.3.6.1.2.1.28.2.1.21", &_names[2682],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2460], &_types[2683], NULLOT, &_types[2683] },
    { "mtaGroupOutboundConnectFailureReason", "1.3.6.1.2.1.28.2.1.22", &_names[2683],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2682], &_types[2678], NULLOT, &_types[2684] },
    { "mtaGroupScheduledRetry", "1.3.6.1.2.1.28.2.1.23", &_names[2684],
      (OS) 24, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2681], &_types[2662], NULLOT, &_types[2685] },
    { "mtaGroupMailProtocol", "1.3.6.1.2.1.28.2.1.24", &_names[2685],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2636], NULLOT, NULLOT, &_types[2686] },
    { "mtaGroupName", "1.3.6.1.2.1.28.2.1.25", &_names[2686],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2648], &_types[2667], NULLOT, &_types[2687] },
    { "mtaGroupAssociationTable", "1.3.6.1.2.1.28.3", &_names[2687],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2660], &_types[2690], &_types[2688], &_types[2688] },
    { "mtaGroupAssociationEntry", "1.3.6.1.2.1.28.3.1", &_names[2688],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex mtaGroupIndex mtaGroupAssociationIndex", NULL, NULL,
      &_types[2661], NULLOT, &_types[2689], &_types[2689] },
    { "mtaGroupAssociationIndex", "1.3.6.1.2.1.28.3.1.1", &_names[2689],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2662], NULLOT, NULLOT, &_types[2690] },
    { "mtaConformance", "1.3.6.1.2.1.28.4", &_names[2690],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2639], NULLOT, &_types[2694], &_types[2691] },
    { "mtaGroups", "1.3.6.1.2.1.28.4.1", &_names[2691],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2642], NULLOT, &_types[2692], &_types[2692] },
    { "mtaGroup", "1.3.6.1.2.1.28.4.1.1", &_names[2692],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2691], &_types[2693], NULLOT, &_types[2693] },
    { "mtaAssocGroup", "1.3.6.1.2.1.28.4.1.2", &_names[2693],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2692], NULLOT, NULLOT, &_types[2694] },
    { "mtaCompliances", "1.3.6.1.2.1.28.4.2", &_names[2694],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2645], &_types[2691], &_types[2695], &_types[2695] },
    { "mtaCompliance", "1.3.6.1.2.1.28.4.2.1", &_names[2695],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2684], &_types[2696], NULLOT, &_types[2696] },
    { "mtaAssocCompliance", "1.3.6.1.2.1.28.4.2.2", &_names[2696],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2695], NULLOT, NULLOT, &_types[2697] },
    { "dsaMIB", "1.3.6.1.2.1.29", &_names[2697],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2690], &_types[141], &_types[2737], &_types[2698] },
    { "dsaOpsTable", "1.3.6.1.2.1.29.1", &_names[2698],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2687], &_types[2720], &_types[2699], &_types[2699] },
    { "dsaOpsEntry", "1.3.6.1.2.1.29.1.1", &_names[2699],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex", NULL, NULL,
      &_types[2688], NULLOT, &_types[2700], &_types[2700] },
    { "dsaAnonymousBinds", "1.3.6.1.2.1.29.1.1.1", &_names[2700],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2467], &_types[2701], NULLOT, &_types[2701] },
    { "dsaUnauthBinds", "1.3.6.1.2.1.29.1.1.2", &_names[2701],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2700], &_types[2702], NULLOT, &_types[2702] },
    { "dsaSimpleAuthBinds", "1.3.6.1.2.1.29.1.1.3", &_names[2702],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2701], &_types[2703], NULLOT, &_types[2703] },
    { "dsaStrongAuthBinds", "1.3.6.1.2.1.29.1.1.4", &_names[2703],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2702], &_types[2704], NULLOT, &_types[2704] },
    { "dsaBindSecurityErrors", "1.3.6.1.2.1.29.1.1.5", &_names[2704],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2488], &_types[2718], NULLOT, &_types[2705] },
    { "dsaInOps", "1.3.6.1.2.1.29.1.1.6", &_names[2705],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2679], &_types[2706], NULLOT, &_types[2706] },
    { "dsaReadOps", "1.3.6.1.2.1.29.1.1.7", &_names[2706],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2705], &_types[2707], NULLOT, &_types[2707] },
    { "dsaCompareOps", "1.3.6.1.2.1.29.1.1.8", &_names[2707],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2706], &_types[2708], NULLOT, &_types[2708] },
    { "dsaAddEntryOps", "1.3.6.1.2.1.29.1.1.9", &_names[2708],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2707], &_types[2709], NULLOT, &_types[2709] },
    { "dsaRemoveEntryOps", "1.3.6.1.2.1.29.1.1.10", &_names[2709],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2708], &_types[2710], NULLOT, &_types[2710] },
    { "dsaModifyEntryOps", "1.3.6.1.2.1.29.1.1.11", &_names[2710],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2709], &_types[2711], NULLOT, &_types[2711] },
    { "dsaModifyRDNOps", "1.3.6.1.2.1.29.1.1.12", &_names[2711],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2710], &_types[2712], NULLOT, &_types[2712] },
    { "dsaListOps", "1.3.6.1.2.1.29.1.1.13", &_names[2712],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2711], &_types[2713], NULLOT, &_types[2713] },
    { "dsaSearchOps", "1.3.6.1.2.1.29.1.1.14", &_names[2713],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2712], &_types[2714], NULLOT, &_types[2714] },
    { "dsaOneLevelSearchOps", "1.3.6.1.2.1.29.1.1.15", &_names[2714],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2713], &_types[2715], NULLOT, &_types[2715] },
    { "dsaWholeTreeSearchOps", "1.3.6.1.2.1.29.1.1.16", &_names[2715],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2714], NULLOT, NULLOT, &_types[2716] },
    { "dsaReferrals", "1.3.6.1.2.1.29.1.1.17", &_names[2716],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2669], &_types[2705], NULLOT, &_types[2717] },
    { "dsaChainings", "1.3.6.1.2.1.29.1.1.18", &_names[2717],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2623], &_types[2716], NULLOT, &_types[2718] },
    { "dsaSecurityErrors", "1.3.6.1.2.1.29.1.1.19", &_names[2718],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2704], &_types[2719], NULLOT, &_types[2719] },
    { "dsaErrors", "1.3.6.1.2.1.29.1.1.20", &_names[2719],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2718], &_types[2717], NULLOT, &_types[2720] },
    { "dsaEntriesTable", "1.3.6.1.2.1.29.2", &_names[2720],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2698], &_types[2727], &_types[2721], &_types[2721] },
    { "dsaEntriesEntry", "1.3.6.1.2.1.29.2.1", &_names[2721],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex", NULL, NULL,
      &_types[2699], NULLOT, &_types[2722], &_types[2722] },
    { "dsaMasterEntries", "1.3.6.1.2.1.29.2.1.1", &_names[2722],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2721], &_types[2723], NULLOT, &_types[2723] },
    { "dsaCopyEntries", "1.3.6.1.2.1.29.2.1.2", &_names[2723],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2722], &_types[2724], NULLOT, &_types[2724] },
    { "dsaCacheEntries", "1.3.6.1.2.1.29.2.1.3", &_names[2724],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2723], &_types[2725], NULLOT, &_types[2725] },
    { "dsaCacheHits", "1.3.6.1.2.1.29.2.1.4", &_names[2725],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2545], &_types[2726], NULLOT, &_types[2726] },
    { "dsaSlaveHits", "1.3.6.1.2.1.29.2.1.5", &_names[2726],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2725], NULLOT, NULLOT, &_types[2727] },
    { "dsaIntTable", "1.3.6.1.2.1.29.3", &_names[2727],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2720], NULLOT, &_types[2728], &_types[2728] },
    { "dsaIntEntry", "1.3.6.1.2.1.29.3.1", &_names[2728],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "applIndex dsaIntIndex", NULL, NULL,
      &_types[2724], NULLOT, &_types[2732], &_types[2729] },
    { "dsaIntIndex", "1.3.6.1.2.1.29.3.1.1", &_names[2729],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2147483647,
      NULL, NULL, NULL,
      &_types[2689], &_types[2730], NULLOT, &_types[2730] },
    { "dsaName", "1.3.6.1.2.1.29.3.1.2", &_names[2730],
      (OS) 192, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2686], &_types[2731], NULLOT, &_types[2731] },
    { "dsaTimeOfCreation", "1.3.6.1.2.1.29.3.1.3", &_names[2731],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2593], &_types[2735], NULLOT, &_types[2732] },
    { "dsaTimeOfLastAttempt", "1.3.6.1.2.1.29.3.1.4", &_names[2732],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2742], &_types[2733], NULLOT, &_types[2733] },
    { "dsaTimeOfLastSuccess", "1.3.6.1.2.1.29.3.1.5", &_names[2733],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2732], &_types[2734], NULLOT, &_types[2734] },
    { "dsaFailuresSinceLastSuccess", "1.3.6.1.2.1.29.3.1.6", &_names[2734],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2733], &_types[2736], NULLOT, &_types[2735] },
    { "dsaFailures", "1.3.6.1.2.1.29.3.1.7", &_names[2735],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2683], NULLOT, NULLOT, &_types[2736] },
    { "dsaSuccesses", "1.3.6.1.2.1.29.3.1.8", &_names[2736],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2734], &_types[2729], NULLOT, &_types[2737] },
    { "dsaConformance", "1.3.6.1.2.1.29.4", &_names[2737],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2697], &_types[2698], &_types[2742], &_types[2738] },
    { "dsaGroups", "1.3.6.1.2.1.29.4.1", &_names[2738],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2693], NULLOT, &_types[2739], &_types[2739] },
    { "dsaOpsGroup", "1.3.6.1.2.1.29.4.1.1", &_names[2739],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2738], &_types[2740], NULLOT, &_types[2740] },
    { "dsaEntryGroup", "1.3.6.1.2.1.29.4.1.2", &_names[2740],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2739], &_types[2741], NULLOT, &_types[2741] },
    { "dsaIntGroup", "1.3.6.1.2.1.29.4.1.3", &_names[2741],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2740], NULLOT, NULLOT, &_types[2742] },
    { "dsaCompliances", "1.3.6.1.2.1.29.4.2", &_names[2742],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2696], &_types[2738], &_types[2743], &_types[2743] },
    { "dsaOpsCompliance", "1.3.6.1.2.1.29.4.2.1", &_names[2743],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2736], &_types[2744], NULLOT, &_types[2744] },
    { "dsaEntryCompliance", "1.3.6.1.2.1.29.4.2.2", &_names[2744],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2743], &_types[2745], NULLOT, &_types[2745] },
    { "dsaIntCompliance", "1.3.6.1.2.1.29.4.2.3", &_names[2745],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2744], NULLOT, NULLOT, &_types[2746] },
    { "experimental", "1.3.6.1.3", &_names[2746],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[4], &_types[2747], &_types[2747] },
    { "clns", "1.3.6.1.3.1", &_names[2747],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1213], NULLOT, &_types[2748], &_types[2748] },
    { "clnp", "1.3.6.1.3.1.1", &_names[2748],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2747], &_types[2807], &_types[2752], &_types[2749] },
    { "clnpForwarding", "1.3.6.1.3.1.1.1", &_names[2749],
      (OS) 353, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1112], NULLOT, NULLOT, &_types[2750] },
    { "clnpDefaultLifeTime", "1.3.6.1.3.1.1.2", &_names[2750],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1266], &_types[2761], NULLOT, &_types[2751] },
    { "clnpInReceives", "1.3.6.1.3.1.1.3", &_names[2751],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1268], &_types[2765], NULLOT, &_types[2752] },
    { "clnpInHdrErrors", "1.3.6.1.3.1.1.4", &_names[2752],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2807], &_types[2753], NULLOT, &_types[2753] },
    { "clnpInAddrErrors", "1.3.6.1.3.1.1.5", &_names[2753],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2752], &_types[2759], NULLOT, &_types[2754] },
    { "clnpForwPDUs", "1.3.6.1.3.1.1.6", &_names[2754],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2804], NULLOT, &_types[2755] },
    { "clnpInUnknownNLPs", "1.3.6.1.3.1.1.7", &_names[2755],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2756], NULLOT, &_types[2756] },
    { "clnpInUnknownULPs", "1.3.6.1.3.1.1.8", &_names[2756],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2755], &_types[2764], NULLOT, &_types[2757] },
    { "clnpInDiscards", "1.3.6.1.3.1.1.9", &_names[2757],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1107], &_types[2760], NULLOT, &_types[2758] },
    { "clnpInDelivers", "1.3.6.1.3.1.1.10", &_names[2758],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1284], &_types[2749], NULLOT, &_types[2759] },
    { "clnpOutRequests", "1.3.6.1.3.1.1.11", &_names[2759],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1178], &_types[2763], NULLOT, &_types[2760] },
    { "clnpOutDiscards", "1.3.6.1.3.1.1.12", &_names[2760],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2757], &_types[2806], NULLOT, &_types[2761] },
    { "clnpOutNoRoutes", "1.3.6.1.3.1.1.13", &_names[2761],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2750], &_types[2762], NULLOT, &_types[2762] },
    { "clnpReasmTimeout", "1.3.6.1.3.1.1.14", &_names[2762],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2761], &_types[2768], NULLOT, &_types[2763] },
    { "clnpReasmReqds", "1.3.6.1.3.1.1.15", &_names[2763],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2759], &_types[2750], NULLOT, &_types[2764] },
    { "clnpReasmOKs", "1.3.6.1.3.1.1.16", &_names[2764],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[63], &_types[2766], NULLOT, &_types[2765] },
    { "clnpReasmFails", "1.3.6.1.3.1.1.17", &_names[2765],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1260], &_types[2767], NULLOT, &_types[2766] },
    { "clnpSegOKs", "1.3.6.1.3.1.1.18", &_names[2766],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2764], &_types[2754], NULLOT, &_types[2767] },
    { "clnpSegFails", "1.3.6.1.3.1.1.19", &_names[2767],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2765], &_types[2755], NULLOT, &_types[2768] },
    { "clnpSegCreates", "1.3.6.1.3.1.1.20", &_names[2768],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[737], &_types[2769], NULLOT, &_types[2769] },
    { "clnpAddrTable", "1.3.6.1.3.1.1.21", &_names[2769],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1281], &_types[2774], &_types[2770], &_types[2770] },
    { "clnpAddrEntry", "1.3.6.1.3.1.1.21.1", &_names[2770],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "clnpAdEntAddr", NULL, NULL,
      &_types[2758], NULLOT, &_types[2773], &_types[2771] },
    { "clnpAdEntAddr", "1.3.6.1.3.1.1.21.1.1", &_names[2771],
      (OS) 15, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1278], &_types[2772], NULLOT, &_types[2772] },
    { "clnpAdEntIfIndex", "1.3.6.1.3.1.1.21.1.2", &_names[2772],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1283], NULLOT, NULLOT, &_types[2773] },
    { "clnpAdEntReasmMaxSize", "1.3.6.1.3.1.1.21.1.3", &_names[2773],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[1162], &_types[2771], NULLOT, &_types[2774] },
    { "clnpRoutingTable", "1.3.6.1.3.1.1.22", &_names[2774],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2769], &_types[2788], &_types[2775], &_types[2775] },
    { "clnpRouteEntry", "1.3.6.1.3.1.1.22.1", &_names[2775],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "clnpRouteDest", NULL, NULL,
      &_types[2770], NULLOT, &_types[2783], &_types[2776] },
    { "clnpRouteDest", "1.3.6.1.3.1.1.22.1.1", &_names[2776],
      (OS) 15, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1280], &_types[2784], NULLOT, &_types[2777] },
    { "clnpRouteIfIndex", "1.3.6.1.3.1.1.22.1.2", &_names[2777],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2772], &_types[2785], NULLOT, &_types[2778] },
    { "clnpRouteMetric1", "1.3.6.1.3.1.1.22.1.3", &_names[2778],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1247], &_types[2779], NULLOT, &_types[2779] },
    { "clnpRouteMetric2", "1.3.6.1.3.1.1.22.1.4", &_names[2779],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2778], &_types[2780], NULLOT, &_types[2780] },
    { "clnpRouteMetric3", "1.3.6.1.3.1.1.22.1.5", &_names[2780],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2779], &_types[2781], NULLOT, &_types[2781] },
    { "clnpRouteMetric4", "1.3.6.1.3.1.1.22.1.6", &_names[2781],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2780], &_types[2786], NULLOT, &_types[2782] },
    { "clnpRouteNextHop", "1.3.6.1.3.1.1.22.1.7", &_names[2782],
      (OS) 15, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2749], &_types[2787], NULLOT, &_types[2783] },
    { "clnpRouteType", "1.3.6.1.3.1.1.22.1.8", &_names[2783],
      (OS) 354, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2775], &_types[2782], NULLOT, &_types[2784] },
    { "clnpRouteProto", "1.3.6.1.3.1.1.22.1.9", &_names[2784],
      (OS) 355, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1201], NULLOT, NULLOT, &_types[2785] },
    { "clnpRouteAge", "1.3.6.1.3.1.1.22.1.10", &_names[2785],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2777], &_types[2778], NULLOT, &_types[2786] },
    { "clnpRouteMetric5", "1.3.6.1.3.1.1.22.1.11", &_names[2786],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2781], &_types[2776], NULLOT, &_types[2787] },
    { "clnpRouteInfo", "1.3.6.1.3.1.1.22.1.12", &_names[2787],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2771], &_types[2777], NULLOT, &_types[2788] },
    { "clnpNetToMediaTable", "1.3.6.1.3.1.1.23", &_names[2788],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2774], &_types[2796], &_types[2789], &_types[2789] },
    { "clnpNetToMediaEntry", "1.3.6.1.3.1.1.23.1", &_names[2789],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "clnpNetToMediaIfIndex clnpNetToMediaNetAddress", NULL, NULL,
      &_types[2783], NULLOT, &_types[2793], &_types[2790] },
    { "clnpNetToMediaIfIndex", "1.3.6.1.3.1.1.23.1.1", &_names[2790],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2785], &_types[2794], NULLOT, &_types[2791] },
    { "clnpNetToMediaPhysAddress", "1.3.6.1.3.1.1.23.1.2", &_names[2791],
      (OS) 16, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2787], &_types[2792], NULLOT, &_types[2792] },
    { "clnpNetToMediaNetAddress", "1.3.6.1.3.1.1.23.1.3", &_names[2792],
      (OS) 15, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2791], &_types[2790], NULLOT, &_types[2793] },
    { "clnpNetToMediaType", "1.3.6.1.3.1.1.23.1.4", &_names[2793],
      (OS) 356, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2789], &_types[2791], NULLOT, &_types[2794] },
    { "clnpNetToMediaAge", "1.3.6.1.3.1.1.23.1.5", &_names[2794],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2790], &_types[2795], NULLOT, &_types[2795] },
    { "clnpNetToMediaHoldTime", "1.3.6.1.3.1.1.23.1.6", &_names[2795],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2762], NULLOT, NULLOT, &_types[2796] },
    { "clnpMediaToNetTable", "1.3.6.1.3.1.1.24", &_names[2796],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2788], &_types[2751], &_types[2797], &_types[2797] },
    { "clnpMediaToNetEntry", "1.3.6.1.3.1.1.24.1", &_names[2797],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "clnpMediaToNetIfIndex clnpMediaToNetPhysAddress", NULL, NULL,
      &_types[2793], NULLOT, &_types[2801], &_types[2798] },
    { "clnpMediaToNetIfIndex", "1.3.6.1.3.1.1.24.1.1", &_names[2798],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2794], &_types[2802], NULLOT, &_types[2799] },
    { "clnpMediaToNetAddress", "1.3.6.1.3.1.1.24.1.2", &_names[2799],
      (OS) 15, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2792], &_types[2800], NULLOT, &_types[2800] },
    { "clnpMediaToNetPhysAddress", "1.3.6.1.3.1.1.24.1.3", &_names[2800],
      (OS) 16, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2799], &_types[2798], NULLOT, &_types[2801] },
    { "clnpMediaToNetType", "1.3.6.1.3.1.1.24.1.4", &_names[2801],
      (OS) 357, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2797], &_types[2799], NULLOT, &_types[2802] },
    { "clnpMediaToNetAge", "1.3.6.1.3.1.1.24.1.5", &_names[2802],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2798], &_types[2803], NULLOT, &_types[2803] },
    { "clnpMediaToNetHoldTime", "1.3.6.1.3.1.1.24.1.6", &_names[2803],
      (OS) 0, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2795], NULLOT, NULLOT, &_types[2804] },
    { "clnpInOpts", "1.3.6.1.3.1.1.25", &_names[2804],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1133], &_types[2805], NULLOT, &_types[2805] },
    { "clnpOutOpts", "1.3.6.1.3.1.1.26", &_names[2805],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2804], &_types[2757], NULLOT, &_types[2806] },
    { "clnpRoutingDiscards", "1.3.6.1.3.1.1.27", &_names[2806],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2760], &_types[2758], NULLOT, &_types[2807] },
    { "error", "1.3.6.1.3.1.2", &_names[2807],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2748], &_types[2854], &_types[2808], &_types[2808] },
    { "clnpInErrors", "1.3.6.1.3.1.2.1", &_names[2808],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2753], &_types[2809], NULLOT, &_types[2809] },
    { "clnpOutErrors", "1.3.6.1.3.1.2.2", &_names[2809],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2808], &_types[2818], NULLOT, &_types[2810] },
    { "clnpInErrUnspecs", "1.3.6.1.3.1.2.3", &_names[2810],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1245], &_types[2820], NULLOT, &_types[2811] },
    { "clnpInErrProcs", "1.3.6.1.3.1.2.4", &_names[2811],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2784], &_types[2833], NULLOT, &_types[2812] },
    { "clnpInErrCksums", "1.3.6.1.3.1.2.5", &_names[2812],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2801], &_types[2834], NULLOT, &_types[2813] },
    { "clnpInErrCongests", "1.3.6.1.3.1.2.6", &_names[2813],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1253], &_types[2835], NULLOT, &_types[2814] },
    { "clnpInErrHdrs", "1.3.6.1.3.1.2.7", &_names[2814],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2768], &_types[2836], NULLOT, &_types[2815] },
    { "clnpInErrSegs", "1.3.6.1.3.1.2.8", &_names[2815],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2796], &_types[2837], NULLOT, &_types[2816] },
    { "clnpInErrIncomps", "1.3.6.1.3.1.2.9", &_names[2816],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2763], &_types[2838], NULLOT, &_types[2817] },
    { "clnpInErrDups", "1.3.6.1.3.1.2.10", &_names[2817],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2802], &_types[2839], NULLOT, &_types[2818] },
    { "clnpInErrUnreachDsts", "1.3.6.1.3.1.2.11", &_names[2818],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2809], &_types[2819], NULLOT, &_types[2819] },
    { "clnpInErrUnknownDsts", "1.3.6.1.3.1.2.12", &_names[2819],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2818], &_types[2840], NULLOT, &_types[2820] },
    { "clnpInErrSRUnspecs", "1.3.6.1.3.1.2.13", &_names[2820],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2810], &_types[2832], NULLOT, &_types[2821] },
    { "clnpInErrSRSyntaxes", "1.3.6.1.3.1.2.14", &_names[2821],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[705], &_types[2843], NULLOT, &_types[2822] },
    { "clnpInErrSRUnkAddrs", "1.3.6.1.3.1.2.15", &_names[2822],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2800], &_types[2844], NULLOT, &_types[2823] },
    { "clnpInErrSRBadPaths", "1.3.6.1.3.1.2.16", &_names[2823],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[956], &_types[2827], NULLOT, &_types[2824] },
    { "clnpInErrHops", "1.3.6.1.3.1.2.17", &_names[2824],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2782], &_types[2846], NULLOT, &_types[2825] },
    { "clnpInErrHopReassms", "1.3.6.1.3.1.2.18", &_names[2825],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2767], &_types[2847], NULLOT, &_types[2826] },
    { "clnpInErrUnsOptions", "1.3.6.1.3.1.2.19", &_names[2826],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2805], &_types[2848], NULLOT, &_types[2827] },
    { "clnpInErrUnsVersions", "1.3.6.1.3.1.2.20", &_names[2827],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2823], &_types[2845], NULLOT, &_types[2828] },
    { "clnpInErrUnsSecurities", "1.3.6.1.3.1.2.21", &_names[2828],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1275], &_types[2850], NULLOT, &_types[2829] },
    { "clnpInErrUnsSRs", "1.3.6.1.3.1.2.22", &_names[2829],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2855], &_types[2830], NULLOT, &_types[2830] },
    { "clnpInErrUnsRRs", "1.3.6.1.3.1.2.23", &_names[2830],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2829], &_types[2851], NULLOT, &_types[2831] },
    { "clnpInErrInterferences", "1.3.6.1.3.1.2.24", &_names[2831],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1158], &_types[2853], NULLOT, &_types[2832] },
    { "clnpOutErrUnspecs", "1.3.6.1.3.1.2.25", &_names[2832],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2820], &_types[2842], NULLOT, &_types[2833] },
    { "clnpOutErrProcs", "1.3.6.1.3.1.2.26", &_names[2833],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2811], &_types[2812], NULLOT, &_types[2834] },
    { "clnpOutErrCksums", "1.3.6.1.3.1.2.27", &_names[2834],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2812], &_types[2824], NULLOT, &_types[2835] },
    { "clnpOutErrCongests", "1.3.6.1.3.1.2.28", &_names[2835],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2813], &_types[2822], NULLOT, &_types[2836] },
    { "clnpOutErrHdrs", "1.3.6.1.3.1.2.29", &_names[2836],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2814], &_types[2815], NULLOT, &_types[2837] },
    { "clnpOutErrSegs", "1.3.6.1.3.1.2.30", &_names[2837],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2815], &_types[2828], NULLOT, &_types[2838] },
    { "clnpOutErrIncomps", "1.3.6.1.3.1.2.31", &_names[2838],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2816], &_types[2810], NULLOT, &_types[2839] },
    { "clnpOutErrDups", "1.3.6.1.3.1.2.32", &_names[2839],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2817], &_types[2816], NULLOT, &_types[2840] },
    { "clnpOutErrUnreachDsts", "1.3.6.1.3.1.2.33", &_names[2840],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2819], &_types[2841], NULLOT, &_types[2841] },
    { "clnpOutErrUnknownDsts", "1.3.6.1.3.1.2.34", &_names[2841],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2840], &_types[2823], NULLOT, &_types[2842] },
    { "clnpOutErrSRUnspecs", "1.3.6.1.3.1.2.35", &_names[2842],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2832], &_types[2814], NULLOT, &_types[2843] },
    { "clnpOutErrSRSyntaxes", "1.3.6.1.3.1.2.36", &_names[2843],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2821], NULLOT, NULLOT, &_types[2844] },
    { "clnpOutErrSRUnkAddrs", "1.3.6.1.3.1.2.37", &_names[2844],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2822], &_types[2817], NULLOT, &_types[2845] },
    { "clnpOutErrSRBadPaths", "1.3.6.1.3.1.2.38", &_names[2845],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2827], &_types[2849], NULLOT, &_types[2846] },
    { "clnpOutErrHops", "1.3.6.1.3.1.2.39", &_names[2846],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2824], &_types[2821], NULLOT, &_types[2847] },
    { "clnpOutErrHopReassms", "1.3.6.1.3.1.2.40", &_names[2847],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2825], &_types[2829], NULLOT, &_types[2848] },
    { "clnpOutErrUnsOptions", "1.3.6.1.3.1.2.41", &_names[2848],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2826], &_types[2831], NULLOT, &_types[2849] },
    { "clnpOutErrUnsVersions", "1.3.6.1.3.1.2.42", &_names[2849],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2845], &_types[2813], NULLOT, &_types[2850] },
    { "clnpOutErrUnsSecurities", "1.3.6.1.3.1.2.43", &_names[2850],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2828], &_types[2825], NULLOT, &_types[2851] },
    { "clnpOutErrUnsSRs", "1.3.6.1.3.1.2.44", &_names[2851],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2830], &_types[2852], NULLOT, &_types[2852] },
    { "clnpOutErrUnsRRs", "1.3.6.1.3.1.2.45", &_names[2852],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2851], &_types[2826], NULLOT, &_types[2853] },
    { "clnpOutErrInterferences", "1.3.6.1.3.1.2.46", &_names[2853],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2831], &_types[2811], NULLOT, &_types[2854] },
    { "echo", "1.3.6.1.3.1.3", &_names[2854],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1014], &_types[2855], NULLOT, &_types[2855] },
    { "es-is", "1.3.6.1.3.1.4", &_names[2855],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[938], NULLOT, &_types[2857], &_types[2856] },
    { "esisESHins", "1.3.6.1.3.1.4.1", &_names[2856],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2833], &_types[2858], NULLOT, &_types[2857] },
    { "esisESHouts", "1.3.6.1.3.1.4.2", &_names[2857],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2806], &_types[2859], NULLOT, &_types[2858] },
    { "esisISHins", "1.3.6.1.3.1.4.3", &_names[2858],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2856], &_types[2861], NULLOT, &_types[2859] },
    { "esisISHouts", "1.3.6.1.3.1.4.4", &_names[2859],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2857], &_types[2856], NULLOT, &_types[2860] },
    { "esisRDUins", "1.3.6.1.3.1.4.5", &_names[2860],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2842], NULLOT, NULLOT, &_types[2861] },
    { "esisRDUouts", "1.3.6.1.3.1.4.6", &_names[2861],
      (OS) 8, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1166], &_types[2860], NULLOT, &_types[2862] },
    { "private", "1.3.6.1.4", &_names[2862],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2746], &_types[2863], &_types[2863] },
    { "enterprises", "1.3.6.1.4.1", &_names[2863],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[2864], &_types[2864] },
    { "unix", "1.3.6.1.4.1.4", &_names[2864],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2751], NULLOT, &_types[2897], &_types[2865] },
    { "agents", "1.3.6.1.4.1.4.1", &_names[2865],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2839], &_types[2900], &_types[2869], &_types[2866] },
    { "fourBSDisode", "1.3.6.1.4.1.4.1.2", &_names[2866],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2859], NULLOT, &_types[2867], &_types[2867] },
    { "fourBSDisodeAgent", "1.3.6.1.4.1.4.1.2.9.6", &_names[2867],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2938], NULLOT, NULLOT, &_types[2868] },
    { "agentAction", "1.3.6.1.4.1.4.1.3", &_names[2868],
      (OS) 358, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2776], &_types[2866], NULLOT, &_types[2869] },
    { "iSODEContextTable", "1.3.6.1.4.1.4.1.4", &_names[2869],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2837], &_types[2872], &_types[2870], &_types[2870] },
    { "iSODEContextEntry", "1.3.6.1.4.1.4.1.4.1", &_names[2870],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "contextEntry", NULL,
      &_types[2834], NULLOT, &_types[2871], &_types[2871] },
    { "iSODEContextName", "1.3.6.1.4.1.4.1.4.1.1", &_names[2871],
      (OS) 3, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 255,
      NULL, NULL, NULL,
      &_types[2860], NULLOT, NULLOT, &_types[2872] },
    { "iSODEPartyTestTable", "1.3.6.1.4.1.4.1.5", &_names[2872],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2869], &_types[2875], &_types[2873], &_types[2873] },
    { "iSODEPartyTestEntry", "1.3.6.1.4.1.4.1.5.1", &_names[2873],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "partyEntry", NULL,
      &_types[2870], NULLOT, &_types[2874], &_types[2874] },
    { "iSODEPartyTestMode", "1.3.6.1.4.1.4.1.5.1.1", &_names[2874],
      (OS) 359, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2835], NULLOT, NULLOT, &_types[2875] },
    { "iSODETestTable", "1.3.6.1.4.1.4.1.6", &_names[2875],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2872], &_types[2868], &_types[2876], &_types[2876] },
    { "iSODETestEntry", "1.3.6.1.4.1.4.1.6.1", &_names[2876],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "iSODETestIndex", NULL, NULL,
      &_types[2873], NULLOT, &_types[2877], &_types[2877] },
    { "iSODETestIndex", "1.3.6.1.4.1.4.1.6.1.1", &_names[2877],
      (OS) 2, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2865], &_types[2879], NULLOT, &_types[2878] },
    { "iSODETestInteger", "1.3.6.1.4.1.4.1.6.1.2", &_names[2878],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 1,
      NULL, NULL, NULL,
      &_types[2853], NULLOT, NULLOT, &_types[2879] },
    { "iSODETestString", "1.3.6.1.4.1.4.1.6.1.3", &_names[2879],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 2,
      NULL, NULL, NULL,
      &_types[472], &_types[2878], NULLOT, &_types[2880] },
    { "mbuf", "1.3.6.1.4.1.4.2", &_names[2880],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1272], &_types[2865], &_types[2881], &_types[2881] },
    { "mbufs", "1.3.6.1.4.1.4.2.1", &_names[2881],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2880], &_types[2885], NULLOT, &_types[2882] },
    { "mbufClusters", "1.3.6.1.4.1.4.2.2", &_names[2882],
      (OS) 9, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1273], &_types[2883], NULLOT, &_types[2883] },
    { "mbufFreeClusters", "1.3.6.1.4.1.4.2.3", &_names[2883],
      (OS) 9, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2882], &_types[2894], NULLOT, &_types[2884] },
    { "mbufDrops", "1.3.6.1.4.1.4.2.4", &_names[2884],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2844], NULLOT, NULLOT, &_types[2885] },
    { "mbufWaits", "1.3.6.1.4.1.4.2.5", &_names[2885],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2877], &_types[2887], NULLOT, &_types[2886] },
    { "mbufDrains", "1.3.6.1.4.1.4.2.6", &_names[2886],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1248], &_types[2893], NULLOT, &_types[2887] },
    { "mbufFrees", "1.3.6.1.4.1.4.2.7", &_names[2887],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1210], &_types[2888], NULLOT, &_types[2888] },
    { "mbufTable", "1.3.6.1.4.1.4.2.8", &_names[2888],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2875], &_types[2886], &_types[2889], &_types[2889] },
    { "mbufEntry", "1.3.6.1.4.1.4.2.8.1", &_names[2889],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "mbufType", NULL, NULL,
      &_types[2876], NULLOT, &_types[2890], &_types[2890] },
    { "mbufType", "1.3.6.1.4.1.4.2.8.1.1", &_names[2890],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2889], &_types[2891], NULLOT, &_types[2891] },
    { "mbufAllocates", "1.3.6.1.4.1.4.2.8.1.2", &_names[2891],
      (OS) 9, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2884], &_types[2892], NULLOT, &_types[2892] },
    { "mbufNewAllocates", "1.3.6.1.4.1.4.2.8.1.3", &_names[2892],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2891], NULLOT, NULLOT, &_types[2893] },
    { "mbufSpaces", "1.3.6.1.4.1.4.2.9", &_names[2893],
      (OS) 9, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[445], &_types[2896], NULLOT, &_types[2894] },
    { "mbufNewClusters", "1.3.6.1.4.1.4.2.10", &_names[2894],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2883], &_types[2895], NULLOT, &_types[2895] },
    { "mbufNewFreeClusters", "1.3.6.1.4.1.4.2.11", &_names[2895],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2894], &_types[2884], NULLOT, &_types[2896] },
    { "mbufNewSpaces", "1.3.6.1.4.1.4.2.12", &_names[2896],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2893], &_types[2882], NULLOT, &_types[2897] },
    { "peers", "1.3.6.1.4.1.4.3", &_names[2897],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2864], &_types[2944], &_types[2898], &_types[2898] },
    { "fourBSDunixd", "1.3.6.1.4.1.4.3.1", &_names[2898],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[941], NULLOT, &_types[2899], &_types[2899] },
    { "fourBSDunixdPeer", "1.3.6.1.4.1.4.3.1.4", &_names[2899],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2955], NULLOT, NULLOT, &_types[2900] },
    { "netstat", "1.3.6.1.4.1.4.5", &_names[2900],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2898], NULLOT, &_types[2901], &_types[2901] },
    { "unixNetstat", "1.3.6.1.4.1.4.5.1", &_names[2901],
      (OS) 360, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2900], &_types[2902], NULLOT, &_types[2902] },
    { "unixTcpConnTable", "1.3.6.1.4.1.4.5.2", &_names[2902],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2888], &_types[2906], &_types[2903], &_types[2903] },
    { "unixTcpConnEntry", "1.3.6.1.4.1.4.5.2.1", &_names[2903],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "tcpConnEntry", NULL,
      &_types[2890], NULLOT, &_types[2904], &_types[2904] },
    { "unixTcpConnSendQ", "1.3.6.1.4.1.4.5.2.1.1", &_names[2904],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2879], &_types[2905], NULLOT, &_types[2905] },
    { "unixTcpConnRecvQ", "1.3.6.1.4.1.4.5.2.1.2", &_names[2905],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2904], NULLOT, NULLOT, &_types[2906] },
    { "unixUdpTable", "1.3.6.1.4.1.4.5.3", &_names[2906],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2902], &_types[2912], &_types[2907], &_types[2907] },
    { "unixUdpEntry", "1.3.6.1.4.1.4.5.3.1", &_names[2907],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "udpEntry", NULL,
      &_types[2903], NULLOT, &_types[2908], &_types[2908] },
    { "unixUdpRemAddress", "1.3.6.1.4.1.4.5.3.1.1", &_names[2908],
      (OS) 6, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2892], &_types[2909], NULLOT, &_types[2909] },
    { "unixUdpRemPort", "1.3.6.1.4.1.4.5.3.1.2", &_names[2909],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[2886], &_types[2910], NULLOT, &_types[2910] },
    { "unixUdpSendQ", "1.3.6.1.4.1.4.5.3.1.3", &_names[2910],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2905], &_types[2911], NULLOT, &_types[2911] },
    { "unixUdpRecvQ", "1.3.6.1.4.1.4.5.3.1.4", &_names[2911],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2910], NULLOT, NULLOT, &_types[2912] },
    { "unixIpRoutingTable", "1.3.6.1.4.1.4.5.4", &_names[2912],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2906], &_types[2922], &_types[2913], &_types[2913] },
    { "unixIpRouteEntry", "1.3.6.1.4.1.4.5.4.1", &_names[2913],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "ipRouteEntry", NULL,
      &_types[2907], NULLOT, &_types[2915], &_types[2914] },
    { "unixIpRouteFlags", "1.3.6.1.4.1.4.5.4.1.1", &_names[2914],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65536,
      NULL, NULL, NULL,
      &_types[2861], &_types[2916], NULLOT, &_types[2915] },
    { "unixIpRouteRefCnt", "1.3.6.1.4.1.4.5.4.1.2", &_names[2915],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2846], &_types[2914], NULLOT, &_types[2916] },
    { "unixIpRouteUses", "1.3.6.1.4.1.4.5.4.1.3", &_names[2916],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2944], NULLOT, NULLOT, &_types[2917] },
    { "unixRouteBadRedirects", "1.3.6.1.4.1.4.5.5", &_names[2917],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2850], &_types[2918], NULLOT, &_types[2918] },
    { "unixRouteCreatedByRedirects", "1.3.6.1.4.1.4.5.6", &_names[2918],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2917], &_types[2919], NULLOT, &_types[2919] },
    { "unixRouteModifiedByRedirects", "1.3.6.1.4.1.4.5.7", &_names[2919],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2918], &_types[2920], NULLOT, &_types[2920] },
    { "unixRouteLookupFails", "1.3.6.1.4.1.4.5.8", &_names[2920],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2847], &_types[2921], NULLOT, &_types[2921] },
    { "unixRouteWildcardUses", "1.3.6.1.4.1.4.5.9", &_names[2921],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2916], NULLOT, NULLOT, &_types[2922] },
    { "unixClnpRoutingTable", "1.3.6.1.4.1.4.5.10", &_names[2922],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2912], &_types[2917], &_types[2923], &_types[2923] },
    { "unixClnpRouteEntry", "1.3.6.1.4.1.4.5.10.1", &_names[2923],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "clnpRouteEntry", NULL,
      &_types[2913], NULLOT, &_types[2925], &_types[2924] },
    { "unixClnpRouteFlags", "1.3.6.1.4.1.4.5.10.1.1", &_names[2924],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65536,
      NULL, NULL, NULL,
      &_types[2914], &_types[2926], NULLOT, &_types[2925] },
    { "unixClnpRouteRefCnt", "1.3.6.1.4.1.4.5.10.1.2", &_names[2925],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2915], &_types[2924], NULLOT, &_types[2926] },
    { "unixClnpRouteUses", "1.3.6.1.4.1.4.5.10.1.3", &_names[2926],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2921], NULLOT, NULLOT, &_types[2927] },
    { "print", "1.3.6.1.4.1.4.6", &_names[2927],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[351], &_types[2880], &_types[2928], &_types[2928] },
    { "printQTable", "1.3.6.1.4.1.4.6.1", &_names[2928],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2922], &_types[2936], &_types[2929], &_types[2929] },
    { "printQEntry", "1.3.6.1.4.1.4.6.1.1", &_names[2929],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "*printQName", NULL, NULL,
      &_types[2923], NULLOT, &_types[2934], &_types[2930] },
    { "printQName", "1.3.6.1.4.1.4.6.1.1.1", &_names[2930],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2871], &_types[2933], NULLOT, &_types[2931] },
    { "printQStatus", "1.3.6.1.4.1.4.6.1.1.2", &_names[2931],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2881], &_types[2930], NULLOT, &_types[2932] },
    { "printQDisplay", "1.3.6.1.4.1.4.6.1.1.3", &_names[2932],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2866], NULLOT, NULLOT, &_types[2933] },
    { "printQAction", "1.3.6.1.4.1.4.6.1.1.5", &_names[2933],
      (OS) 361, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2868], &_types[2932], NULLOT, &_types[2934] },
    { "printQEntries", "1.3.6.1.4.1.4.6.1.1.6", &_names[2934],
      (OS) 9, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2929], &_types[2935], NULLOT, &_types[2935] },
    { "printQNewEntries", "1.3.6.1.4.1.4.6.1.1.7", &_names[2935],
      (OS) 12, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2934], &_types[2931], NULLOT, &_types[2936] },
    { "printJTable", "1.3.6.1.4.1.4.6.2", &_names[2936],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2928], NULLOT, &_types[2937], &_types[2937] },
    { "printJEntry", "1.3.6.1.4.1.4.6.2.1", &_names[2937],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "*printQName printJRank", NULL, NULL,
      &_types[2935], NULLOT, &_types[2940], &_types[2938] },
    { "printJRank", "1.3.6.1.4.1.4.6.2.1.1", &_names[2938],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2885], &_types[2939], NULLOT, &_types[2939] },
    { "printJName", "1.3.6.1.4.1.4.6.2.1.2", &_names[2939],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2930], &_types[2941], NULLOT, &_types[2940] },
    { "printJOwner", "1.3.6.1.4.1.4.6.2.1.3", &_names[2940],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1235], &_types[2942], NULLOT, &_types[2941] },
    { "printJDescription", "1.3.6.1.4.1.4.6.2.1.4", &_names[2941],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2933], &_types[2943], NULLOT, &_types[2942] },
    { "printJSize", "1.3.6.1.4.1.4.6.2.1.5", &_names[2942],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2773], &_types[2938], NULLOT, &_types[2943] },
    { "printJAction", "1.3.6.1.4.1.4.6.2.1.6", &_names[2943],
      (OS) 362, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2941], NULLOT, NULLOT, &_types[2944] },
    { "users", "1.3.6.1.4.1.4.7", &_names[2944],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2459], &_types[2970], &_types[2966], &_types[2945] },
    { "userTable", "1.3.6.1.4.1.4.7.1", &_names[2945],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2936], &_types[2957], &_types[2946], &_types[2946] },
    { "userEntry", "1.3.6.1.4.1.4.7.1.1", &_names[2946],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "*userName", NULL, NULL,
      &_types[2937], NULLOT, &_types[2951], &_types[2947] },
    { "userName", "1.3.6.1.4.1.4.7.1.1.1", &_names[2947],
      (OS) 3, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2939], &_types[2953], NULLOT, &_types[2948] },
    { "userPasswd", "1.3.6.1.4.1.4.7.1.1.2", &_names[2948],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2874], &_types[2952], NULLOT, &_types[2949] },
    { "userID", "1.3.6.1.4.1.4.7.1.1.3", &_names[2949],
      (OS) 1, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2942], &_types[2950], NULLOT, &_types[2950] },
    { "userGroup", "1.3.6.1.4.1.4.7.1.1.4", &_names[2950],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2949], &_types[2948], NULLOT, &_types[2951] },
    { "userQuota", "1.3.6.1.4.1.4.7.1.1.5", &_names[2951],
      (OS) 1, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2946], &_types[2954], NULLOT, &_types[2952] },
    { "userComment", "1.3.6.1.4.1.4.7.1.1.6", &_names[2952],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2908], &_types[2956], NULLOT, &_types[2953] },
    { "userFullName", "1.3.6.1.4.1.4.7.1.1.7", &_names[2953],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2947], &_types[2955], NULLOT, &_types[2954] },
    { "userHome", "1.3.6.1.4.1.4.7.1.1.8", &_names[2954],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2940], &_types[2949], NULLOT, &_types[2955] },
    { "userShell", "1.3.6.1.4.1.4.7.1.1.9", &_names[2955],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2897], NULLOT, NULLOT, &_types[2956] },
    { "userStatus", "1.3.6.1.4.1.4.7.1.1.10", &_names[2956],
      (OS) 363, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2931], &_types[2947], NULLOT, &_types[2957] },
    { "groupTable", "1.3.6.1.4.1.4.7.2", &_names[2957],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2945], &_types[2963], &_types[2958], &_types[2958] },
    { "groupEntry", "1.3.6.1.4.1.4.7.2.1", &_names[2958],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "*groupName", NULL, NULL,
      &_types[2951], NULLOT, &_types[2961], &_types[2959] },
    { "groupName", "1.3.6.1.4.1.4.7.2.1.1", &_names[2959],
      (OS) 3, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2953], NULLOT, NULLOT, &_types[2960] },
    { "groupPasswd", "1.3.6.1.4.1.4.7.2.1.2", &_names[2960],
      (OS) 3, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2948], &_types[2962], NULLOT, &_types[2961] },
    { "groupID", "1.3.6.1.4.1.4.7.2.1.3", &_names[2961],
      (OS) 1, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2950], &_types[2960], NULLOT, &_types[2962] },
    { "groupStatus", "1.3.6.1.4.1.4.7.2.1.4", &_names[2962],
      (OS) 364, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2956], &_types[2959], NULLOT, &_types[2963] },
    { "grUserTable", "1.3.6.1.4.1.4.7.3", &_names[2963],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2957], &_types[2967], &_types[2964], &_types[2964] },
    { "grUserEntry", "1.3.6.1.4.1.4.7.3.1", &_names[2964],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "groupName grUserZero *userName", NULL, NULL,
      &_types[2958], NULLOT, &_types[2965], &_types[2965] },
    { "grUserStatus", "1.3.6.1.4.1.4.7.3.1.1", &_names[2965],
      (OS) 365, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2962], NULLOT, NULLOT, &_types[2966] },
    { "grUserZero", "1.3.6.1.4.1.4.7.4", &_names[2966],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 0,
      NULL, NULL, NULL,
      &_types[2927], &_types[2945], NULLOT, &_types[2967] },
    { "grNewUserTable", "1.3.6.1.4.1.4.7.5", &_names[2967],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2963], NULLOT, &_types[2968], &_types[2968] },
    { "grNewUserEntry", "1.3.6.1.4.1.4.7.5.1", &_names[2968],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "groupName *userName", NULL, NULL,
      &_types[2964], NULLOT, &_types[2969], &_types[2969] },
    { "grNewUserStatus", "1.3.6.1.4.1.4.7.5.1.1", &_names[2969],
      (OS) 366, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2965], NULLOT, NULLOT, &_types[2970] },
    { "unixFs", "1.3.6.1.4.1.4.8", &_names[2970],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2927], &_types[2971], &_types[2971] },
    { "fsTable", "1.3.6.1.4.1.4.8.1", &_names[2971],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2967], NULLOT, &_types[2972], &_types[2972] },
    { "fsTableEntry", "1.3.6.1.4.1.4.8.1.1", &_names[2972],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "fsIdentifier", NULL, NULL,
      &_types[2968], NULLOT, &_types[2976], &_types[2973] },
    { "fsIdentifier", "1.3.6.1.4.1.4.8.1.1.1", &_names[2973],
      (OS) 1, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2854], &_types[2975], NULLOT, &_types[2974] },
    { "fsName", "1.3.6.1.4.1.4.8.1.1.2", &_names[2974],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2959], &_types[2980], NULLOT, &_types[2975] },
    { "fsMountPoint", "1.3.6.1.4.1.4.8.1.1.3", &_names[2975],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2973], &_types[2977], NULLOT, &_types[2976] },
    { "fsMountType", "1.3.6.1.4.1.4.8.1.1.4", &_names[2976],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2972], &_types[2979], NULLOT, &_types[2977] },
    { "fsMountOptions", "1.3.6.1.4.1.4.8.1.1.5", &_names[2977],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2848], NULLOT, NULLOT, &_types[2978] },
    { "fsBlockSize", "1.3.6.1.4.1.4.8.1.1.6", &_names[2978],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2961], &_types[2974], NULLOT, &_types[2979] },
    { "fsBlockCount", "1.3.6.1.4.1.4.8.1.1.7", &_names[2979],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2925], &_types[2982], NULLOT, &_types[2980] },
    { "fsBlocksFree", "1.3.6.1.4.1.4.8.1.1.8", &_names[2980],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2887], &_types[2981], NULLOT, &_types[2981] },
    { "fsBlocksAvailable", "1.3.6.1.4.1.4.8.1.1.9", &_names[2981],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[684], &_types[2983], NULLOT, &_types[2982] },
    { "fsInodeCount", "1.3.6.1.4.1.4.8.1.1.10", &_names[2982],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2979], &_types[2978], NULLOT, &_types[2983] },
    { "fsInodesAvailable", "1.3.6.1.4.1.4.8.1.1.11", &_names[2983],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[2981], &_types[2973], NULLOT, &_types[2984] },
    { "security", "1.3.6.1.5", &_names[2984],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2985], NULLOT, &_types[2985] },
    { "snmpV2", "1.3.6.1.6", &_names[2985],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[2992], &_types[2986] },
    { "snmpDomains", "1.3.6.1.6.1", &_names[2986],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[2996], &_types[2987], &_types[2987] },
    { "snmpUDPDomain", "1.3.6.1.6.1.1", &_names[2987],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2996], &_types[2988], NULLOT, &_types[2988] },
    { "snmpCLNSDomain", "1.3.6.1.6.1.2", &_names[2988],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2987], &_types[2989], NULLOT, &_types[2989] },
    { "snmpCONSDomain", "1.3.6.1.6.1.3", &_names[2989],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2988], &_types[2990], NULLOT, &_types[2990] },
    { "snmpDDPDomain", "1.3.6.1.6.1.4", &_names[2990],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2989], &_types[2991], NULLOT, &_types[2991] },
    { "snmpIPXDomain", "1.3.6.1.6.1.5", &_names[2991],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2990], NULLOT, NULLOT, &_types[2992] },
    { "snmpProxys", "1.3.6.1.6.2", &_names[2992],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3], &_types[2986], &_types[2993], &_types[2993] },
    { "rfc1157Proxy", "1.3.6.1.6.2.1", &_names[2993],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2992], NULLOT, &_types[2994], &_types[2994] },
    { "rfc1157Domain", "1.3.6.1.6.2.1.1", &_names[2994],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2991], &_types[2995], NULLOT, &_types[2995] },
    { "rfc1157noAuth", "1.3.6.1.6.2.1.2", &_names[2995],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[2996] },
    { "snmpModules", "1.3.6.1.6.3", &_names[2996],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2986], NULLOT, &_types[2997], &_types[2997] },
    { "snmpMIB", "1.3.6.1.6.3.1", &_names[2997],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2994], &_types[3093], &_types[3038], &_types[2998] },
    { "snmpMIBObjects", "1.3.6.1.6.3.1.1", &_names[2998],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[3022], &_types[2999] },
    { "snmpStats", "1.3.6.1.6.3.1.1.1", &_names[2999],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2995], NULLOT, &_types[3006], &_types[3000] },
    { "snmpStatsPackets", "1.3.6.1.6.3.1.1.1.1", &_names[3000],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3001], NULLOT, &_types[3001] },
    { "snmpStats30Something", "1.3.6.1.6.3.1.1.1.2", &_names[3001],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2984], &_types[3007], NULLOT, &_types[3002] },
    { "snmpStatsEncodingErrors", "1.3.6.1.6.3.1.1.1.3", &_names[3002],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[1], &_types[3010], NULLOT, &_types[3003] },
    { "snmpStatsUnknownDstParties", "1.3.6.1.6.3.1.1.1.4", &_names[3003],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3039], &_types[3005], NULLOT, &_types[3004] },
    { "snmpStatsDstPartyMismatches", "1.3.6.1.6.3.1.1.1.5", &_names[3004],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2998], &_types[3000], NULLOT, &_types[3005] },
    { "snmpStatsUnknownSrcParties", "1.3.6.1.6.3.1.1.1.6", &_names[3005],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3003], &_types[3008], NULLOT, &_types[3006] },
    { "snmpStatsBadAuths", "1.3.6.1.6.3.1.1.1.7", &_names[3006],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2999], &_types[3004], NULLOT, &_types[3007] },
    { "snmpStatsNotInLifetimes", "1.3.6.1.6.3.1.1.1.8", &_names[3007],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[0], &_types[3002], NULLOT, &_types[3008] },
    { "snmpStatsWrongDigestValues", "1.3.6.1.6.3.1.1.1.9", &_names[3008],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3005], &_types[3011], NULLOT, &_types[3009] },
    { "snmpStatsUnknownContexts", "1.3.6.1.6.3.1.1.1.10", &_names[3009],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3038], &_types[3003], NULLOT, &_types[3010] },
    { "snmpStatsBadOperations", "1.3.6.1.6.3.1.1.1.11", &_names[3010],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3041], &_types[3009], NULLOT, &_types[3011] },
    { "snmpStatsSilentDrops", "1.3.6.1.6.3.1.1.1.12", &_names[3011],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3008], NULLOT, NULLOT, &_types[3012] },
    { "snmpV1", "1.3.6.1.6.3.1.1.2", &_names[3012],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3015], &_types[3013], &_types[3013] },
    { "snmpV1BadCommunityNames", "1.3.6.1.6.3.1.1.2.1", &_names[3013],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3014], NULLOT, &_types[3014] },
    { "snmpV1BadCommunityUses", "1.3.6.1.6.3.1.1.2.2", &_names[3014],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[3015] },
    { "snmpOR", "1.3.6.1.6.3.1.1.3", &_names[3015],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3036], &_types[3016], &_types[3016] },
    { "snmpORLastChange", "1.3.6.1.6.3.1.1.3.1", &_names[3016],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3017], NULLOT, &_types[3017] },
    { "snmpORTable", "1.3.6.1.6.3.1.1.3.2", &_names[3017],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[3018], &_types[3018] },
    { "snmpOREntry", "1.3.6.1.6.3.1.1.3.2.1", &_names[3018],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpORIndex", NULL, NULL,
      &_types[2863], NULLOT, &_types[3020], &_types[3019] },
    { "snmpORIndex", "1.3.6.1.6.3.1.1.3.2.1.1", &_names[3019],
      (OS) 1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3021], NULLOT, &_types[3020] },
    { "snmpORID", "1.3.6.1.6.3.1.1.3.2.1.2", &_names[3020],
      (OS) 4, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3010], &_types[3019], NULLOT, &_types[3021] },
    { "snmpORDescr", "1.3.6.1.6.3.1.1.3.2.1.3", &_names[3021],
      (OS) 3, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3015], NULLOT, NULLOT, &_types[3022] },
    { "snmpTrap", "1.3.6.1.6.3.1.1.4", &_names[3022],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3029], &_types[3028], &_types[3023] },
    { "snmpTrapOID", "1.3.6.1.6.3.1.1.4.1", &_names[3023],
      (OS) 4, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3020], &_types[3024], NULLOT, &_types[3024] },
    { "snmpTrapTable", "1.3.6.1.6.3.1.1.4.2", &_names[3024],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3017], NULLOT, &_types[3025], &_types[3025] },
    { "snmpTrapEntry", "1.3.6.1.6.3.1.1.4.2.1", &_names[3025],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, "partyEntry", NULL,
      &_types[3018], NULLOT, &_types[3026], &_types[3026] },
    { "snmpTrapNumbers", "1.3.6.1.6.3.1.1.4.2.1.1", &_names[3026],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[3027] },
    { "snmpTrapEnterprise", "1.3.6.1.6.3.1.1.4.3", &_names[3027],
      (OS) 4, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3025], &_types[3023], NULLOT, &_types[3028] },
    { "snmpV2EnableAuthenTraps", "1.3.6.1.6.3.1.1.4.4", &_names[3028],
      (OS) 18, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3029], &_types[3027], NULLOT, &_types[3029] },
    { "snmpTraps", "1.3.6.1.6.3.1.1.5", &_names[3029],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3022], &_types[3012], &_types[3033], &_types[3030] },
    { "coldStart", "1.3.6.1.6.3.1.1.5.1", &_names[3030],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3006], &_types[3031], NULLOT, &_types[3031] },
    { "warmStart", "1.3.6.1.6.3.1.1.5.2", &_names[3031],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3030], &_types[3034], NULLOT, &_types[3032] },
    { "linkDown", "1.3.6.1.6.3.1.1.5.3", &_names[3032],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3030], NULLOT, &_types[3033] },
    { "linkUp", "1.3.6.1.6.3.1.1.5.4", &_names[3033],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3012], &_types[3035], NULLOT, &_types[3034] },
    { "authenticationFailure", "1.3.6.1.6.3.1.1.5.5", &_names[3034],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[3035] },
    { "egpNeighborLoss", "1.3.6.1.6.3.1.1.5.6", &_names[3035],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3032], NULLOT, &_types[3036] },
    { "snmpSet", "1.3.6.1.6.3.1.1.6", &_names[3036],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2997], &_types[2999], &_types[3037], &_types[3037] },
    { "snmpSetSerialNo", "1.3.6.1.6.3.1.1.6.1", &_names[3037],
      (OS) 19, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, NULLOT, &_types[3038] },
    { "snmpMIBConformance", "1.3.6.1.6.3.1.2", &_names[3038],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3036], &_types[2998], &_types[3039], &_types[3039] },
    { "snmpMIBCompliances", "1.3.6.1.6.3.1.2.1", &_names[3039],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3041], &_types[3040], &_types[3040] },
    { "snmpMIBCompliance", "1.3.6.1.6.3.1.2.1.1", &_names[3040],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3011], NULLOT, NULLOT, &_types[3041] },
    { "snmpMIBGroups", "1.3.6.1.6.3.1.2.2", &_names[3041],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3167], NULLOT, &_types[3042], &_types[3042] },
    { "snmpStatsGroup", "1.3.6.1.6.3.1.2.2.1", &_names[3042],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3023], &_types[3043], NULLOT, &_types[3043] },
    { "snmpV1Group", "1.3.6.1.6.3.1.2.2.2", &_names[3043],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3042], &_types[3044], NULLOT, &_types[3044] },
    { "snmpORGroup", "1.3.6.1.6.3.1.2.2.3", &_names[3044],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3043], &_types[3045], NULLOT, &_types[3045] },
    { "snmpTrapGroup", "1.3.6.1.6.3.1.2.2.4", &_names[3045],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3044], &_types[3046], NULLOT, &_types[3046] },
    { "snmpSetGroup", "1.3.6.1.6.3.1.2.2.5", &_names[3046],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3045], NULLOT, NULLOT, &_types[3047] },
    { "snmpM2M", "1.3.6.1.6.3.2", &_names[3047],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3121], NULLOT, &_types[3087], &_types[3048] },
    { "snmpM2MObjects", "1.3.6.1.6.3.2.1", &_names[3048],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3106], NULLOT, &_types[3049], &_types[3049] },
    { "snmpAlarm", "1.3.6.1.6.3.2.1.1", &_names[3049],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3069], &_types[3051], &_types[3050] },
    { "snmpAlarmNextIndex", "1.3.6.1.6.3.2.1.1.1", &_names[3050],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[3155], NULLOT, NULLOT, &_types[3051] },
    { "snmpAlarmTable", "1.3.6.1.6.3.2.1.1.2", &_names[3051],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3151], &_types[3065], &_types[3052], &_types[3052] },
    { "snmpAlarmEntry", "1.3.6.1.6.3.2.1.1.2.1", &_names[3052],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "contextIdentity snmpAlarmIndex", NULL, NULL,
      &_types[3157], NULLOT, &_types[3056], &_types[3053] },
    { "snmpAlarmIndex", "1.3.6.1.6.3.2.1.1.2.1.1", &_names[3053],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3050], &_types[3061], NULLOT, &_types[3054] },
    { "snmpAlarmVariable", "1.3.6.1.6.3.2.1.1.2.1.2", &_names[3054],
      (OS) 21, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3147], &_types[3057], NULLOT, &_types[3055] },
    { "snmpAlarmInterval", "1.3.6.1.6.3.2.1.1.2.1.3", &_names[3055],
      (OS) 1, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2], NULLOT, NULLOT, &_types[3056] },
    { "snmpAlarmSampleType", "1.3.6.1.6.3.2.1.1.2.1.4", &_names[3056],
      (OS) 36, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3052], &_types[3054], NULLOT, &_types[3057] },
    { "snmpAlarmValue", "1.3.6.1.6.3.2.1.1.2.1.5", &_names[3057],
      (OS) 1, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3088], &_types[3064], NULLOT, &_types[3058] },
    { "snmpAlarmStartupAlarm", "1.3.6.1.6.3.2.1.1.2.1.6", &_names[3058],
      (OS) 37, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3049], &_types[3055], NULLOT, &_types[3059] },
    { "snmpAlarmRisingThreshold", "1.3.6.1.6.3.2.1.1.2.1.7", &_names[3059],
      (OS) 1, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3060], NULLOT, &_types[3060] },
    { "snmpAlarmFallingThreshold", "1.3.6.1.6.3.2.1.1.2.1.8", &_names[3060],
      (OS) 1, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3059], &_types[3058], NULLOT, &_types[3061] },
    { "snmpAlarmRisingEventIndex", "1.3.6.1.6.3.2.1.1.2.1.9", &_names[3061],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[3053], &_types[3062], NULLOT, &_types[3062] },
    { "snmpAlarmFallingEventIndex", "1.3.6.1.6.3.2.1.1.2.1.10", &_names[3062],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[3061], &_types[3063], NULLOT, &_types[3063] },
    { "snmpAlarmUnavailableEventIndex", "1.3.6.1.6.3.2.1.1.2.1.11", &_names[3063],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[3062], &_types[3059], NULLOT, &_types[3064] },
    { "snmpAlarmStatus", "1.3.6.1.6.3.2.1.1.2.1.12", &_names[3064],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3158], &_types[3053], NULLOT, &_types[3065] },
    { "snmpAlarmNotifications", "1.3.6.1.6.3.2.1.1.3", &_names[3065],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3050], &_types[3066], &_types[3066] },
    { "snmpRisingAlarm", "1.3.6.1.6.3.2.1.1.3.1", &_names[3066],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3058], &_types[3067], NULLOT, &_types[3067] },
    { "snmpFallingAlarm", "1.3.6.1.6.3.2.1.1.3.2", &_names[3067],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3066], &_types[3068], NULLOT, &_types[3068] },
    { "snmpObjectUnavailableAlarm", "1.3.6.1.6.3.2.1.1.3.3", &_names[3068],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3067], NULLOT, NULLOT, &_types[3069] },
    { "snmpEvent", "1.3.6.1.6.3.2.1.2", &_names[3069],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[3079], &_types[3070] },
    { "snmpEventNextIndex", "1.3.6.1.6.3.2.1.2.1", &_names[3070],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[3063], &_types[3071], NULLOT, &_types[3071] },
    { "snmpEventTable", "1.3.6.1.6.3.2.1.2.2", &_names[3071],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3051], &_types[3081], &_types[3072], &_types[3072] },
    { "snmpEventEntry", "1.3.6.1.6.3.2.1.2.2.1", &_names[3072],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpEventIndex", NULL, NULL,
      &_types[3056], NULLOT, &_types[3074], &_types[3073] },
    { "snmpEventIndex", "1.3.6.1.6.3.2.1.2.2.1.1", &_names[3073],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3070], &_types[3077], NULLOT, &_types[3074] },
    { "snmpEventID", "1.3.6.1.6.3.2.1.2.2.1.2", &_names[3074],
      (OS) 4, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3090], &_types[3078], NULLOT, &_types[3075] },
    { "snmpEventDescription", "1.3.6.1.6.3.2.1.2.2.1.3", &_names[3075],
      (OS) 3, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 127,
      NULL, NULL, NULL,
      &_types[3021], NULLOT, NULLOT, &_types[3076] },
    { "snmpEventEvents", "1.3.6.1.6.3.2.1.2.2.1.4", &_names[3076],
      (OS) 9, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3069], &_types[3075], NULLOT, &_types[3077] },
    { "snmpEventLastTimeSent", "1.3.6.1.6.3.2.1.2.2.1.5", &_names[3077],
      (OS) 23, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3016], &_types[3076], NULLOT, &_types[3078] },
    { "snmpEventStatus", "1.3.6.1.6.3.2.1.2.2.1.6", &_names[3078],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3064], &_types[3073], NULLOT, &_types[3079] },
    { "snmpEventNotifyMinInterval", "1.3.6.1.6.3.2.1.2.3", &_names[3079],
      (OS) 1, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3055], &_types[3080], NULLOT, &_types[3080] },
    { "snmpEventNotifyMaxRetransmissions", "1.3.6.1.6.3.2.1.2.4", &_names[3080],
      (OS) 1, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3057], &_types[3070], NULLOT, &_types[3081] },
    { "snmpEventNotifyTable", "1.3.6.1.6.3.2.1.2.5", &_names[3081],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3071], NULLOT, &_types[3082], &_types[3082] },
    { "snmpEventNotifyEntry", "1.3.6.1.6.3.2.1.2.5.1", &_names[3082],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "snmpEventIndex contextIdentity", NULL, NULL,
      &_types[3072], NULLOT, &_types[3086], &_types[3083] },
    { "snmpEventNotifyIntervalRequested", "1.3.6.1.6.3.2.1.2.5.1.1", &_names[3083],
      (OS) 1, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3060], &_types[3084], NULLOT, &_types[3084] },
    { "snmpEventNotifyRetransmissionsRequested", "1.3.6.1.6.3.2.1.2.5.1.2", &_names[3084],
      (OS) 1, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3083], &_types[3085], NULLOT, &_types[3085] },
    { "snmpEventNotifyLifetime", "1.3.6.1.6.3.2.1.2.5.1.3", &_names[3085],
      (OS) 1, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3120], NULLOT, NULLOT, &_types[3086] },
    { "snmpEventNotifyStatus", "1.3.6.1.6.3.2.1.2.5.1.4", &_names[3086],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3078], &_types[3083], NULLOT, &_types[3087] },
    { "snmpM2MConformance", "1.3.6.1.6.3.2.2", &_names[3087],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3138], &_types[3048], &_types[3088], &_types[3088] },
    { "snmpM2MCompliances", "1.3.6.1.6.3.2.2.1", &_names[3088],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3164], &_types[3090], &_types[3089], &_types[3089] },
    { "snmpM2MCompliance", "1.3.6.1.6.3.2.2.1.1", &_names[3089],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3080], NULLOT, NULLOT, &_types[3090] },
    { "snmpM2MGroups", "1.3.6.1.6.3.2.2.2", &_names[3090],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3166], NULLOT, &_types[3091], &_types[3091] },
    { "snmpAlarmGroup", "1.3.6.1.6.3.2.2.2.1", &_names[3091],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3074], &_types[3092], NULLOT, &_types[3092] },
    { "snmpEventGroup", "1.3.6.1.6.3.2.2.2.2", &_names[3092],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3091], NULLOT, NULLOT, &_types[3093] },
    { "partyMIB", "1.3.6.1.6.3.3", &_names[3093],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3009], &_types[3047], &_types[3159], &_types[3094] },
    { "partyAdmin", "1.3.6.1.6.3.3.1", &_names[3094],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[3100], &_types[3095] },
    { "partyProtocols", "1.3.6.1.6.3.3.1.1", &_names[3095],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2993], NULLOT, &_types[3098], &_types[3096] },
    { "noAuth", "1.3.6.1.6.3.3.1.1.1", &_names[3096],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3031], NULLOT, NULLOT, &_types[3097] },
    { "noPriv", "1.3.6.1.6.3.3.1.1.2", &_names[3097],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2862], &_types[3096], NULLOT, &_types[3098] },
    { "desPrivProtocol", "1.3.6.1.6.3.3.1.1.3", &_names[3098],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3095], &_types[3099], NULLOT, &_types[3099] },
    { "v2md5AuthProtocol", "1.3.6.1.6.3.3.1.1.4", &_names[3099],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3098], &_types[3097], NULLOT, &_types[3100] },
    { "temporalDomains", "1.3.6.1.6.3.3.1.2", &_names[3100],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3093], &_types[3104], &_types[3101], &_types[3101] },
    { "currentTime", "1.3.6.1.6.3.3.1.2.1", &_names[3101],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3102], NULLOT, &_types[3102] },
    { "restartTime", "1.3.6.1.6.3.3.1.2.2", &_names[3102],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3101], &_types[3103], NULLOT, &_types[3103] },
    { "cacheTime", "1.3.6.1.6.3.3.1.2.3", &_names[3103],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3102], NULLOT, NULLOT, &_types[3104] },
    { "initialPartyId", "1.3.6.1.6.3.3.1.3", &_names[3104],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3033], &_types[3105], NULLOT, &_types[3105] },
    { "initialContextId", "1.3.6.1.6.3.3.1.4", &_names[3105],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3104], &_types[3095], NULLOT, &_types[3106] },
    { "partyMIBObjects", "1.3.6.1.6.3.3.2", &_names[3106],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3004], &_types[3094], &_types[3150], &_types[3107] },
    { "snmpParties", "1.3.6.1.6.3.3.2.1", &_names[3107],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3040], &_types[3141], &_types[3108], &_types[3108] },
    { "partyTable", "1.3.6.1.6.3.3.2.1.1", &_names[3108],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3024], NULLOT, &_types[3109], &_types[3109] },
    { "partyEntry", "1.3.6.1.6.3.3.2.1.1.1", &_names[3109],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "*partyIdentity", NULL, NULL,
      &_types[3027], NULLOT, &_types[3125], &_types[3110] },
    { "partyIdentity", "1.3.6.1.6.3.3.2.1.1.1.1", &_names[3110],
      (OS) 30, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3120], NULLOT, &_types[3111] },
    { "partyIndex", "1.3.6.1.6.3.3.2.1.1.1.2", &_names[3111],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3019], &_types[3119], NULLOT, &_types[3112] },
    { "partyTDomain", "1.3.6.1.6.3.3.2.1.1.1.3", &_names[3112],
      (OS) 4, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3159], &_types[3113], NULLOT, &_types[3113] },
    { "partyTAddress", "1.3.6.1.6.3.3.2.1.1.1.4", &_names[3113],
      (OS) 31, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3160], &_types[3115], NULLOT, &_types[3114] },
    { "partyMaxMessageSize", "1.3.6.1.6.3.3.2.1.1.1.5", &_names[3114],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 484, 65507,
      NULL, NULL, NULL,
      &_types[3165], &_types[3124], NULLOT, &_types[3115] },
    { "partyLocal", "1.3.6.1.6.3.3.2.1.1.1.6", &_names[3115],
      (OS) 18, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3096], &_types[3126], NULLOT, &_types[3116] },
    { "partyAuthProtocol", "1.3.6.1.6.3.3.2.1.1.1.7", &_names[3116],
      (OS) 4, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3099], &_types[3121], NULLOT, &_types[3117] },
    { "partyAuthClock", "1.3.6.1.6.3.3.2.1.1.1.8", &_names[3117],
      (OS) 32, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3026], &_types[3114], NULLOT, &_types[3118] },
    { "partyAuthPrivate", "1.3.6.1.6.3.3.2.1.1.1.9", &_names[3118],
      (OS) 2, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3097], &_types[3122], NULLOT, &_types[3119] },
    { "partyAuthPublic", "1.3.6.1.6.3.3.2.1.1.1.10", &_names[3119],
      (OS) 2, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2746], &_types[3123], NULLOT, &_types[3120] },
    { "partyAuthLifetime", "1.3.6.1.6.3.3.2.1.1.1.11", &_names[3120],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 2147483647,
      NULL, NULL, NULL,
      &_types[3007], &_types[3116], NULLOT, &_types[3121] },
    { "partyPrivProtocol", "1.3.6.1.6.3.3.2.1.1.1.12", &_names[3121],
      (OS) 4, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3116], NULLOT, NULLOT, &_types[3122] },
    { "partyPrivPrivate", "1.3.6.1.6.3.3.2.1.1.1.13", &_names[3122],
      (OS) 2, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3118], &_types[3117], NULLOT, &_types[3123] },
    { "partyPrivPublic", "1.3.6.1.6.3.3.2.1.1.1.14", &_names[3123],
      (OS) 2, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3119], &_types[3110], NULLOT, &_types[3124] },
    { "partyCloneFrom", "1.3.6.1.6.3.3.2.1.1.1.15", &_names[3124],
      (OS) 30, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, &_types[3112], NULLOT, &_types[3125] },
    { "partyStorageType", "1.3.6.1.6.3.3.2.1.1.1.16", &_names[3125],
      (OS) 34, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3109], &_types[3118], NULLOT, &_types[3126] },
    { "partyStatus", "1.3.6.1.6.3.3.2.1.1.1.17", &_names[3126],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3115], &_types[3111], NULLOT, &_types[3127] },
    { "snmpContexts", "1.3.6.1.6.3.3.2.2", &_names[3127],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3100], &_types[3107], &_types[3128], &_types[3128] },
    { "contextTable", "1.3.6.1.6.3.3.2.2.1", &_names[3128],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3108], NULLOT, &_types[3129], &_types[3129] },
    { "contextEntry", "1.3.6.1.6.3.3.2.2.1.1", &_names[3129],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "*contextIdentity", NULL, NULL,
      &_types[3125], NULLOT, &_types[3134], &_types[3130] },
    { "contextIdentity", "1.3.6.1.6.3.3.2.2.1.1.1", &_names[3130],
      (OS) 33, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3110], NULLOT, NULLOT, &_types[3131] },
    { "contextIndex", "1.3.6.1.6.3.3.2.2.1.1.2", &_names[3131],
      (OS) 0, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3111], &_types[3133], NULLOT, &_types[3132] },
    { "contextLocal", "1.3.6.1.6.3.3.2.2.1.1.3", &_names[3132],
      (OS) 18, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3126], &_types[3140], NULLOT, &_types[3133] },
    { "contextViewIndex", "1.3.6.1.6.3.3.2.2.1.1.4", &_names[3133],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 65535,
      NULL, NULL, NULL,
      &_types[3131], &_types[3135], NULLOT, &_types[3134] },
    { "contextLocalEntity", "1.3.6.1.6.3.3.2.2.1.1.5", &_names[3134],
      (OS) 2, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3129], &_types[3139], NULLOT, &_types[3135] },
    { "contextLocalTime", "1.3.6.1.6.3.3.2.2.1.1.6", &_names[3135],
      (OS) 4, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3103], &_types[3130], NULLOT, &_types[3136] },
    { "contextProxyDstParty", "1.3.6.1.6.3.3.2.2.1.1.7", &_names[3136],
      (OS) 30, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3113], &_types[3137], NULLOT, &_types[3137] },
    { "contextProxySrcParty", "1.3.6.1.6.3.3.2.2.1.1.8", &_names[3137],
      (OS) 30, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3136], &_types[3132], NULLOT, &_types[3138] },
    { "contextProxyContext", "1.3.6.1.6.3.3.2.2.1.1.9", &_names[3138],
      (OS) 4, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3112], &_types[3136], NULLOT, &_types[3139] },
    { "contextStorageType", "1.3.6.1.6.3.3.2.2.1.1.10", &_names[3139],
      (OS) 34, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3134], &_types[3138], NULLOT, &_types[3140] },
    { "contextStatus", "1.3.6.1.6.3.3.2.2.1.1.11", &_names[3140],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3132], &_types[3131], NULLOT, &_types[3141] },
    { "snmpAccess", "1.3.6.1.6.3.3.2.3", &_names[3141],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3107], NULLOT, &_types[3142], &_types[3142] },
    { "aclTable", "1.3.6.1.6.3.3.2.3.1", &_names[3142],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3128], NULLOT, &_types[3143], &_types[3143] },
    { "aclEntry", "1.3.6.1.6.3.3.2.3.1.1", &_names[3143],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "aclTarget aclSubject aclResources", NULL, NULL,
      &_types[3139], NULLOT, &_types[3148], &_types[3144] },
    { "aclTarget", "1.3.6.1.6.3.3.2.3.1.1.1", &_names[3144],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3002], &_types[3145], NULLOT, &_types[3145] },
    { "aclSubject", "1.3.6.1.6.3.3.2.3.1.1.2", &_names[3145],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3140], &_types[3146], NULLOT, &_types[3146] },
    { "aclResources", "1.3.6.1.6.3.3.2.3.1.1.3", &_names[3146],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3145], &_types[3149], NULLOT, &_types[3147] },
    { "aclPrivileges", "1.3.6.1.6.3.3.2.3.1.1.4", &_names[3147],
      (OS) 0, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 255,
      NULL, NULL, NULL,
      &_types[3122], &_types[3144], NULLOT, &_types[3148] },
    { "aclStorageType", "1.3.6.1.6.3.3.2.3.1.1.5", &_names[3148],
      (OS) 34, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3143], &_types[3147], NULLOT, &_types[3149] },
    { "aclStatus", "1.3.6.1.6.3.3.2.3.1.1.6", &_names[3149],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3146], NULLOT, NULLOT, &_types[3150] },
    { "snmpViews", "1.3.6.1.6.3.3.2.4", &_names[3150],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3000], &_types[3127], &_types[3151], &_types[3151] },
    { "viewTable", "1.3.6.1.6.3.3.2.4.1", &_names[3151],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3142], NULLOT, &_types[3152], &_types[3152] },
    { "viewEntry", "1.3.6.1.6.3.3.2.4.1.1", &_names[3152],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "viewIndex *viewSubtree", NULL, NULL,
      &_types[3148], NULLOT, &_types[3156], &_types[3153] },
    { "viewIndex", "1.3.6.1.6.3.3.2.4.1.1.1", &_names[3153],
      (OS) 0, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 1, 65535,
      NULL, NULL, NULL,
      &_types[3133], &_types[3155], NULLOT, &_types[3154] },
    { "viewSubtree", "1.3.6.1.6.3.3.2.4.1.1.2", &_names[3154],
      (OS) 4, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3149], &_types[3158], NULLOT, &_types[3155] },
    { "viewMask", "1.3.6.1.6.3.3.2.4.1.1.3", &_names[3155],
      (OS) 2, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      1, 0, 16,
      NULL, NULL, NULL,
      &_types[3153], NULLOT, NULLOT, &_types[3156] },
    { "viewType", "1.3.6.1.6.3.3.2.4.1.1.4", &_names[3156],
      (OS) 35, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3152], &_types[3157], NULLOT, &_types[3157] },
    { "viewStorageType", "1.3.6.1.6.3.3.2.4.1.1.5", &_names[3157],
      (OS) 34, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3156], &_types[3154], NULLOT, &_types[3158] },
    { "viewStatus", "1.3.6.1.6.3.3.2.4.1.1.6", &_names[3158],
      (OS) 22, 7, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3154], &_types[3153], NULLOT, &_types[3159] },
    { "partyMIBConformance", "1.3.6.1.6.3.3.3", &_names[3159],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3127], &_types[3106], &_types[3160], &_types[3160] },
    { "partyMIBCompliances", "1.3.6.1.6.3.3.3.1", &_names[3160],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3141], &_types[3165], &_types[3161], &_types[3161] },
    { "unSecurableCompliance", "1.3.6.1.6.3.3.3.1.1", &_names[3161],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3137], &_types[3162], NULLOT, &_types[3162] },
    { "partyNoPrivacyCompliance", "1.3.6.1.6.3.3.3.1.2", &_names[3162],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3161], &_types[3163], NULLOT, &_types[3163] },
    { "partyPrivacyCompliance", "1.3.6.1.6.3.3.3.1.3", &_names[3163],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3162], &_types[3164], NULLOT, &_types[3164] },
    { "fullPrivacyCompliance", "1.3.6.1.6.3.3.3.1.4", &_names[3164],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3163], NULLOT, NULLOT, &_types[3165] },
    { "partyMIBGroups", "1.3.6.1.6.3.3.3.2", &_names[3165],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3046], NULLOT, &_types[3166], &_types[3166] },
    { "partyMIBGroup", "1.3.6.1.6.3.3.3.2.1", &_names[3166],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3114], NULLOT, NULLOT, &_types[3167] },
    { "joint-iso-ccitt", "2", &_names[3167],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      NULLOT, NULLOT, &_types[3168], &_types[3168] },
    { "mhs", "2.6", &_names[3168],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2803], NULLOT, &_types[3169], &_types[3169] },
    { "group", "2.6.6", &_names[3169],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2978], NULLOT, &_types[3170], &_types[3170] },
    { "mtr", "2.6.6.200", &_names[3170],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2976], NULLOT, &_types[3171], &_types[3171] },
    { "demoGroup", "2.6.6.200.5", &_names[3171],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[3169], NULLOT, &_types[3172], &_types[3172] },
    { "demo", "2.6.6.200.5.1", &_names[3172],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2895], NULLOT, &_types[3173], &_types[3173] },
    { "mtrBigNumber", "2.6.6.200.5.1.1", &_names[3173],
      (OS) 10, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2954], &_types[3179], NULLOT, &_types[3174] },
    { "mtrNsapAddress", "2.6.6.200.5.1.2", &_names[3174],
      (OS) 15, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2952], &_types[3176], NULLOT, &_types[3175] },
    { "mtrBitString", "2.6.6.200.5.1.3", &_names[3175],
      (OS) 367, 3, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2911], NULLOT, NULLOT, &_types[3176] },
    { "mtrTable", "2.6.6.200.5.1.4", &_names[3176],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2971], &_types[3175], &_types[3177], &_types[3177] },
    { "mtrEntry", "2.6.6.200.5.1.4.1", &_names[3177],
      (OS) -1, 0, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      "mtrColumn", NULL, NULL,
      &_types[3170], NULLOT, &_types[3178], &_types[3178] },
    { "mtrColumn", "2.6.6.200.5.1.4.1.2", &_names[3178],
      (OS) 1, 1, (u_long) 0, 2,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2969], NULLOT, NULLOT, &_types[3179] },
    { "mtrDemoMIB", "2.6.6.200.5.1.999", &_names[3179],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      0, 0, 0,
      NULL, NULL, NULL,
      &_types[2960], &_types[3174], NULLOT, NULLOT },
    NULL
};

OT	anchor = _types;
OT	chain = &_types[3179];

static OT _Tbuckets[128] = {
    &_types[1131],
    &_types[2000],
    &_types[2754],
    &_types[1088],
    &_types[2022],
    &_types[1279],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[40],
    &_types[1104],
    &_types[527],
    &_types[1161],
    NULLOT,
    NULLOT,
    &_types[2970],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[2766],
    &_types[968],
    &_types[897],
    &_types[1169],
    NULLOT,
    &_types[2756],
    &_types[802],
    &_types[2852],
    &_types[462],
    NULLOT,
    &_types[803],
    NULLOT,
    &_types[1004],
    NULLOT,
    &_types[393],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[1187],
    &_types[499],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[1341],
    NULLOT,
    &_types[513],
    &_types[2896],
    &_types[727],
    &_types[618],
    &_types[2926],
    &_types[1196],
    &_types[1249],
    &_types[2975],
    &_types[2166],
    &_types[2983],
    &_types[723],
    &_types[2920],
    &_types[1846],
    &_types[2899],
    &_types[2919],
    &_types[945],
    &_types[2909],
    &_types[1160],
    &_types[3176],
    &_types[2836],
    &_types[1183],
    &_types[3168],
    &_types[2980],
    &_types[2974],
    &_types[2924],
    &_types[2786],
    &_types[2901],
    &_types[2838],
    &_types[2867],
    &_types[3178],
    &_types[3174],
    &_types[3179],
    &_types[2849],
    &_types[3171],
    &_types[2841],
    &_types[3173],
    &_types[2966],
    &_types[2843],
    &_types[2982],
    &_types[349],
    &_types[3177],
    &_types[3172],
    &_types[2858],
    &_types[2932],
    &_types[2878],
    &_types[1119],
    &_types[3175],
    &_types[2943],
    &_types[2977],
    &_types[715],
    &_types[925],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
};

extern	int	once_only_Tbuckets;
extern	OT	Tbuckets[];

loadobjects (file)
char   *file;
{
    int	    i;
    register struct _syntax *sy;
    register OT	    ot;
    static int once_only = 0;

    if (file) {
	once_only = 1;
	return readobjects (file);
    }

    if (once_only) {
	(void) sprintf (PY_pepy, "loadobjects called more than once!");
	return NOTOK;
    }
    once_only = 1;

    bcopy ((char *) _Tbuckets, (char *) Tbuckets, sizeof _Tbuckets);
    once_only_Tbuckets = 1;

    readsyntax ();
    for (sy = _syntaxes; sy -> name; sy++) {
	if (sy -> textual
	        && add_textual (sy -> name, sy -> textual,
				sy -> display ? sy -> display : "") == NOTOK) {
	    (void) sprintf (PY_pepy, "lost \"%s\" textual convention",
			    sy -> name);
	    return NOTOK;
	}

	if ((sy -> value = text2syn (sy -> name)) == NULLOS) {
	    (void) sprintf (PY_pepy, "lost \"%s\" syntax", sy -> name);
	    return NOTOK;
	}
	sy -> value -> os_enum = sy -> es;
    }

    for (ot = _types; ot -> ot_text; ot++)
	ot -> ot_syntax = (i = (int) ot -> ot_syntax) < 0
	    			? NULLOS : _syntaxes[i].value;

    return OK;
}
